unit Eftfut;
{
CopyFile(FromFilePath,ToFilePath)
          Copies a file from one Drive:\DirectoryPath\FileName.Ext to another
          and returns a boolean to express the result of the operation.
	  The FromFilePath,ToFilePath parameters can be of type String.
	  i.e.:
            if CopyFile('E:\TMP\Notes.TXT','F:\SAVE\Notes.TXT')
		then ProcText;
          Will copy the 'Notes.TXT' file to the specified directory
          and execute the ProcText procedure.

MoveFile(FromFilePath,ToFilePath)
          Moves a file from one Drive:\DirectoryPath\FileName.Ext to another
          (Deleting the Original if the Copy operation was succuessful)
          and returns a boolean to express the result of the operation.
	  The FromFilePath,ToFilePath parameters can be of type String.
	  i.e.:
            if MoveFile('E:\TMP\Notes.TXT','F:\SAVE\Notes.TXT')
		then ProcText;
          Will copy the 'Notes.TXT' file to the specified directory
          and execute the ProcText procedure and delete the file from the
	  original location.

GridClear(GridName)
	  Clears the a TStringGrid specified by GridName of all Cell
 	  values and Object values.
	  i.e.:
	    GridClear(PatientList);

LastPiecePos(Value,Delimiter)
	Returns an integer value of the number of occurances of a delimiter + 1
	i.e. if Value = '^This^is^just^for^testing^' then
           LastPiecePos(Value,'^') = 7
        This is the M equivalent of $L(Value,"^")

PiecePos(Text,Value,Delimiter)
	Returns an integer value of the delimiter position of the first occurance
        of string in a string (Value in Text)
	i.e. if Text = '^This^is^just^for^testing^' then
	  PiecePos(Text,'testing','^') = 6
	This is the M equivalent of $L($P(Value,'testing'),"^")
AddSec(ChngeTime,Sec)
	Returns a time or date/time depending on the value of the ChngeTime
	parameter. and adds the number of seconds specified by the Sec parameter.
	This fumction handles additions which cross the noonand midnight boundaries.
Pause(Seconds)
	This parameter will return when the number of seconds specified have
	expired on the system clock.   }
interface
  uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs,{ TabNotBk, }StdCtrls, Grids, Trpcb,{ Menus, }ExtCtrls,
  {XWBut1,} MFunStr,{, EchoAbt, Buttons, Winsock, wsockc, Spin,} filectrl;

    {}
 //   function CopyFile(const FromFile,ToFile: TFileName):boolean;
 //   function MoveFile(const FromFile,ToFile: TFileName):boolean;
    procedure GridClear(Grid: TStringGrid);
    Function LastPiecePos(SubStr:String;Delim: String): integer;
    function AddSec(ChngeTime:TDateTime; ASec: word):TDateTime;
    function PiecePos(Text,Value,Delimiter: string):integer;
    procedure pause(ASec: integer);
    function ExecuteFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;

implementation
uses ShellAPI;
const
  EFOpenError = 'Cannot open file %s';

{function CopyFile(const FromFile,ToFile: TFileName): boolean;
var
  source,dest: integer; {handles}
 { CopyResult: string;
  CopyBuffer: Pointer;
  TimeStamp, BytesCopied: Longint;
const
  ChunkSize: Longint = 8192;

begin
  GetMem(CopyBuffer, ChunkSize);
  result := false;
  try
    CopyResult := '1^Successful File Copy^';
    TimeStamp := FileAge(FromFile);
    Source := FileOpen(FromFile, fmShareExclusive);
    if Source < 0 then CopyResult := '0^Source File Unavailable^' + IntToStr(Source);
    if Source >= 0 then
      try
        {Dest := FileCreate(ToFile);}
  {      Dest := FileOpen(ToFile, fmShareExclusive);
        if Dest <> -5 then
          begin
            FileClose(Dest);
           if DirectoryExists(ExtractFilePath(ToFile)) = True then
              begin
               Dest := FileCreate(ToFile);
               if Dest < 0 then
                 begin
                  CopyResult :='0^Destination File Create Error^' + IntToStr(Dest);
                  raise  EFCreateError.Create(Format(EFOpenError, [ToFile]));
                 end    {We Absolutely thought we had it trapped, but...}
   {            else
                 try
                   repeat
                     BytesCopied := FileRead(Source, CopyBuffer^, ChunkSize);
                     if BytesCopied > 0 then
                       FileWrite(Dest, CopyBuffer^, BytesCopied);
                   until BytesCopied < ChunkSize;
                 finally
                   FileClose(Dest);
                  {SetFileTimeStamp(Dest, TimeStamp); }
    {             end; {All Systems GO - Copy File}
     {         end {DirectoryFilePathExists}
     {      else
              CopyResult := '0^Destination FilePath Invalid^' + ToFile;
          end {access to Destination file not denied}
      {  else
          CopyResult := '0^Destination File in Use^' + IntToStr(Dest) ;
      finally
        FileClose(dest);
      end;{try}
  {finally
    FileClose(source);
    FreeMem(CopyBuffer, ChunkSize); {Free the Buffer}
   { if piece(CopyResult,'^',1) = '1' then
      result := true;
  end;{try}
{end;{proc}

{function MoveFile(const FromFile,ToFile: TFileName): boolean;
var
  source,dest: integer; {handles}
//  FromFileString: string;{32 coding change}
{begin
  try
  Result := false;
  if DirectoryExists(ExtractFilePath(FromFile)) and
     DirectoryExists(ExtractFilePath(ToFile)) and
      CopyFile(FromFile,ToFile) {and
 //       DeleteFile(FromFile) }//then
//         Result := true;
{  except
  on EInOutError  do
    MessageDlg('EFault MoveFile', mtConfirmation, mbYesNoCancel, 0);
  end;
end; }
procedure GridClear(Grid: TStringGrid);
var
 i,j: integer;
 null: string;
begin
  null := '';
  for i := 0 to Grid.ColCount - 1 do
   for j := 0 to Grid.RowCount - 1 do
     begin
      Grid.Cells[i,j] := null;
      Grid.Objects[i,j] := nil;
     end;
  Grid.RowCount := 20;
end;

Function LastPiecePos(SubStr:String;Delim: String): integer;
Var
Count: integer;
begin
count := 0;
while pos(Delim,SubStr) <> 0 do
 begin
   inc(count);{count := count + pos(Delim,SubStr);}
   SubStr := Copy(SubStr,pos(Delim,SubStr)+1,9999);
 end;
 if count > 0 then inc(count);
 LastPiecePos := count;
end;


function AddSec(ChngeTime:TDateTime; ASec: word):TDateTime;
var
  hour,min,sec,msec: word;
  NewTime: TDateTime;
const
  HalfDaySec : word = 43200;
  HourSec : word = 3600;
  MinSec: word = 60;

begin
  NewTime := ChngeTime;
  hour := ASec div HourSec;
  Min := (ASec mod HourSec) div MinSec;
  sec := ((ASec mod HourSec) mod MinSec);
  msec := 0;
  AddSec := NewTime + EncodeTime(hour,min,sec,msec);
end;

function PiecePos(Text,Value,Delimiter: string):integer;
var
  count: integer;
  posit:byte;
  temp: string;
begin
  count := 0 ;
  posit := pos(Value,Text);
  if posit <> 0 then
    begin
      if posit = 1 then {test for first and only OR first and delimited}
        if (length(Value)=length(Text)) or (pos(delimiter,text) =
          (posit+length(Value))) then inc(count);
      if (posit > 1) and (pos(Delimiter,Text) <> 0) then
        {test for last or middle, delimited piece}
         if ((posit + length(value) = length(Text) + 1) and (copy(text,posit-length
                (Delimiter),length(Delimiter)) = Delimiter))
           or
            ((copy(text,posit-length(Delimiter),length(Delimiter)) = Delimiter) and
                (copy(text,posit+length(value),length(Delimiter)) = Delimiter)) then
           begin  {Value exists,therefore a minumum of two,
                now lets count the delimiters}
             inc(count);
             temp := copy(Text,1,pos(Value,Text)-1);
             posit := pos(Delimiter,temp);
             while posit <> 0 do
              begin
               temp := Copy(temp,posit+length(Delimiter),length(Temp));
               inc(count);
               posit := pos(Delimiter,temp);
              end;
           end;
    end;
  result := count;
end;

procedure pause(ASec: integer);
var
EndPause: TDateTime;
begin
  EndPause := Now;
  EndPause := AddSec(EndPause,ASec);
  While EndPause > Now do
    {Application.ProcessMessages};
end;

function ExecuteFile(const FileName, Params, DefaultDir: string;
  ShowCmd: Integer): THandle;
var
  zFileName, zParams, zDir: array[0..79] of Char;
begin
  Result := ShellExecute(Application.MainForm.Handle, nil,
    StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
    StrPCopy(zDir, DefaultDir), ShowCmd);
end;
end.
