unit MagPerResults;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, Printers;

type
  TfrmPurgeResults = class(TForm)
    mnuMain: TMainMenu;
    mnuFile1: TMenuItem;
    mnuExit: TMenuItem;
    SaveDialog1: TSaveDialog;
    PrintDialog1: TPrintDialog;
    memResults: TMemo;
    procedure mnuPrint1Click(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPurgeResults: TfrmPurgeResults;

implementation

{$R *.DFM}
uses magpurge1;

procedure TfrmPurgeResults.mnuPrint1Click(Sender: TObject);
var
  PageNum: string;
  i,Ctr,x,PHeight,LineSpace: integer;
begin

{  with PrintDialog1 do begin
    Options := [poPrintToFile];
    PrintToFile := True;
    if Execute then begin
      if PrintToFile then begin
        SaveDialog1.Title := 'Print to File: ';
        //
        if SaveDialog1.Execute then chart1.SaveToMetafile(SaveDialog1.FileName);
        end // if PrintToFile
      else Chart1.Print;
      end; //if Execute
    end; //with PrintDialog1
}
  with PrintDialog1 do begin
    Options := [poPrintToFile];
    PrintToFile := True;
    Printer.Orientation := poPortrait;
    Printer.Title := 'Purge Summary Report';
    if Execute then begin
      if PrintToFile then begin
        SaveDialog1.DefaultExt := 'txt';
        SaveDialog1.Filter := 'Text files (*.txt)|*.txt|All files (*.*)|*.*';
        if SaveDialog1.Execute then memResults.Lines.SaveToFile(SaveDialog1.FileName);
        end // if PrintToFile
      else begin
        Printer.BeginDoc;
          PHeight := Printer.PageHeight;
          LineSpace := PHeight DIV 60;
          Ctr := 1;
          x := 1;
          PageNum := IntToStr(Printer.PageNumber);
          for i := 0 to memResults.Lines.Count - 1 do begin
            Printer.Canvas.TextOut(0,x,memResults.Lines[i]); //     lbResults.Items[i]);
            x := x + LineSpace;
            ctr := ctr + 1;
            If ctr > 59 then begin
              Printer.NewPage;
              x := 0;
              Ctr := 0;
              PageNum := IntToStr(Printer.PageNumber);
              end; // ctr > 59
            end; // for i
        Printer.EndDoc;
        end; // else print
      end; //if Execute
    end; //with PrintDialog1
end;

procedure TfrmPurgeResults.mnuExitClick(Sender: TObject);
begin
  frmPurgeResults.Close;
end;

procedure TfrmPurgeResults.FormCreate(Sender: TObject);
begin
  {$ifdef Win32}
          SetForegroundWindow(frmPurgeResults.Handle);
  {$else}
          BringWindowToTop(frmPurgeResults.Handle);
  {$endif}

//  frmMagPurge.SendToBack;
//  frmPurgeResults.BringToFront;

end;

procedure TfrmPurgeResults.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  frmPurgeResults.ModalResult := mrCancel;
  Action := caFree;

end;

procedure TfrmPurgeResults.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if (Key = 27) then frmPurgeResults.Close;
end;

end.
