unit PurgeShareSelect1;
    {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: BP Purge
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls, Buttons, ComCtrls,Fmcntrls, Fmcmpnts,
  Diaccess,RpcConf1,DiTypLib,Fmlookup,rpcSLogin,Trpcb,
  MFunstr, ImgList;

type
  TfrmPurgeShareSelect = class(TForm)
    tvNetworkShares: TTreeView;
    fmlNetLoc: TFMLister;
    ImageList1: TImageList;
    Panel1: TPanel;
    bbtnCancel: TBitBtn;
    bbtnOK: TBitBtn;
    btnApply: TBitBtn;
    bbtnHelp: TBitBtn;
    procedure FormCreate(Sender: TObject);
    function GetLabels(FMDC:TObject): TStringList;
    function GetLabel(FMFile,FMField:string): String;
    procedure TreeViewUpdate(Clear,IEN: Boolean;Lister,Sublister:TFMLister;tv:TTreeView;Hint: string);
    procedure tvNetworkSharesChange(Sender: TObject; Node: TTreeNode);
    procedure btnApplyClick(Sender: TObject);
    procedure bbtnCancelClick(Sender: TObject);
    procedure bbtnOKClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure bbtnHelpClick(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPurgeShareSelect: TfrmPurgeShareSelect;

implementation

{$R *.dfm}
uses magWebHelp,magpurge1;

procedure TfrmPurgeShareSelect.FormCreate(Sender: TObject);
begin
//  fmlNetLoc.Screen :='I $P($G(^MAG(2005.2,Y,0)),U,10)='+IntToStr(Place)+
//   ',$P($G(^MAG(2005.2,Y,0)),U,6,7)="1^MAG",$P(^(0),U,9)'+#39+'="1",$P($G(^(1)),U,6)'+#39+'="1"';
//  TreeViewUpdate(true,true,fmlNetLoc,nil,tvNetworkShares,'');
end;

function TfrmPurgeShareSelect.GetLabels(FMDC:TObject): TStringList;
      var i:integer;
    begin
      Result := TStringList.Create;
      if FMDC.ClassType = TFMLister then with FMDC as TFMLister do
      for i := 0 to FieldNumbers.Count-1 do
        result.Add(GetLabel(FileNumber,FieldNumbers[i]));
      if FMDC.ClassType = TFMGets then with FMDC as TFMGets do
        for i := 0 to FieldNumbers.Count-1 do
          result.Add(GetLabel(FileNumber,FieldNumbers[i]));
    end;//GetLabels(FMDC:TObject):

function TfrmPurgeShareSelect.GetLabel(FMFile,FMField:string): String;
      var ResultList :TStringList;
          Complete: boolean;
    begin
      repeat
        Complete := true;
        ResultList := TStringList.create;
        frmMagPurge.RPCBroker1.Param[0].VALUE := FMFile;
        frmMagPurge.RPCBroker1.Param[0].PTYPE := LITERAL;
        frmMagPurge.RPCBroker1.Param[1].VALUE := FMField;
        frmMagPurge.RPCBroker1.Param[1].PTYPE := LITERAL;
        frmMagPurge.RPCBroker1.Param[2].VALUE := '';
        frmMagPurge.RPCBroker1.Param[2].PTYPE := LITERAL;
        frmMagPurge.RPCBroker1.Param[3].VALUE := 'LABEL';
        frmMagPurge.RPCBroker1.Param[3].PTYPE := LITERAL;
        frmMagPurge.RPCBroker1.RemoteProcedure := 'MAG FLD ATT';
        try
          frmMagPurge.RPCBroker1.LSTCALL(ResultList);
        except
          on E:Exception do begin
            frmMagPurge.LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^RPC Exception: MAG FLD ATT^',magpurge1.PurgeErrorLogSize);
            frmMagPurge.OnException(E);
            Complete := false;
            end; // on E:Exception
        end // try...Except;
      until Complete;
      Result := ResultList[0] ;
    end; // function GetLabel

procedure TfrmPurgeShareSelect.TreeViewUpdate(Clear,IEN: Boolean;Lister,Sublister:TFMLister;tv:TTreeView;Hint:string);
function GetNode(ien: integer;tv:TTreeView;Lister:TFMLister):TTreenode;
  var i : integer;
      temp,RGTMP: string;
      Gets: TFMGets;
begin
  RGTMP := '';
  result := nil;
  Gets:= TFMGets.Create(self);
  Gets.RPCBroker := Lister.RPCBroker;
  Gets.FileNumber := Lister.FileNumber;
  Gets.IENS := Lister.Results[ien];
  Gets.FieldNumbers.Add('.01');
  Gets.FieldNumbers.Add('1');
  Gets.FieldNumbers.Add('31');
  Gets.GetData;
  temp := Gets.GetField('.01').FMDBExternal+' - '+Gets.GetField('1').FMDBExternal; //+' - '+Gets.GetField('31').FMDBExternal;
  RGTMP := Gets.GetField('31').FMDBExternal;
  if RGTMP <> '' then temp := temp + ' - '+RGTMP;
  Gets.Free;
  if lister.ErrorList.Count > 0 then Lister.DisplayErrors;
  for i := 0 to tv.items.count - 1 do
    if tv.items[i].text = temp then result := tv.items[i];
  if not assigned(result) then begin
    tv.Items.add(nil,temp);
    result := tv.Items[tv.Items.count-1];
    end;
end;
var
  i,j,k,l: integer;
  Labels: TStringList;
  RootNodes,subnodes: TTreeNode;
begin
  if clear then begin
    tv.Items.Clear;
    tv.ShowButtons := true;
    tv.ShowLines := true;
    tv.ShowRoot := true;
    end; // if clear
  Lister.GetList(nil);
  for i := 0 to Lister.Results.Count - 1 do begin   //Create ListItems
    Rootnodes := GetNode(i,tv,Lister);
    RootNodes.ImageIndex := 0;
    if assigned(Sublister) then begin
      Sublister.IENS := ','+Lister.Results[i]+Lister.IENS;
      Sublister.GetList(nil);
      for k := 0 to Sublister.Results.Count - 1 do begin
        subnodes := tv.Items.AddChild(RootNodes,Sublister.GetRecord(Sublister.Results[k]).GetField('.01').FMDBExternal);
        if Hint <> '' then subnodes.Text := subnodes.Text+' - '+Hint;
        end;
      end;
    end; //for i
  for i := 0 to tv.Items.Count -1 do tv.Items[i].Expand(true);
  tv.ReadOnly := true;
end;



procedure TfrmPurgeShareSelect.tvNetworkSharesChange(Sender: TObject;
  Node: TTreeNode);
begin
  if tvNetworkShares.SelectionCount > 0 then btnApply.Enabled := true
  else btnApply.Enabled := false;
end;

procedure TfrmPurgeShareSelect.btnApplyClick(Sender: TObject);
var i: integer;
begin
  if not Assigned(magpurge1.SelectShareList) then
    magpurge1.SelectShareList := TStringList.create
  else magpurge1.SelectShareList.Clear;
  for i := 0 to tvNetworkShares.Items.Count -1 do
    if tvNetworkShares.Items[i].Selected then
      magpurge1.SelectShareList.Add(tvNetworkShares.Items[i].Text);
  btnApply.Enabled := false;
end;

procedure TfrmPurgeShareSelect.bbtnCancelClick(Sender: TObject);
begin
  if Assigned(magpurge1.SelectShareList) then
    magpurge1.SelectShareList.Clear;
  frmPurgeShareSelect.ModalResult := mrCancel;
end;

procedure TfrmPurgeShareSelect.bbtnOKClick(Sender: TObject);

var i: integer;
begin
  if not Assigned(magpurge1.SelectShareList) then
    magpurge1.SelectShareList := TStringList.create
  else magpurge1.SelectShareList.Clear;
  for i := 0 to tvNetworkShares.Items.Count -1 do
    if tvNetworkShares.Items[i].Selected then
      magpurge1.SelectShareList.Add(tvNetworkShares.Items[i].Text);
  if  magpurge1.SelectShareList.Count > 0 then
    magpurge1.Shares := 'SEL';
  btnApply.Enabled := false;
  frmPurgeShareSelect.ModalResult := mrCancel;
end;

procedure TfrmPurgeShareSelect.FormActivate(Sender: TObject);
begin
  fmlNetLoc.Screen :='I $P($G(^MAG(2005.2,Y,0)),U,10)='+IntToStr(Place)+
   ',$P($G(^MAG(2005.2,Y,0)),U,6,7)="1^MAG",$P(^(0),U,9)'+char(39)+'="1",$P($G(^(1)),U,6)'+
   char(39)+'="1",$L($P($G(^(0)),U,2))>3';
  TreeViewUpdate(true,true,fmlNetLoc,nil,tvNetworkShares,'');
  btnApply.Enabled := false;
end;

procedure TfrmPurgeShareSelect.bbtnHelpClick(Sender: TObject);
begin
  Application.CreateForm(TfrmMagBPHelp,frmMagBPHelp);
  frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
 'help\Imaging_System_Background_Processor_User_Manual.htm#_Toc254594905');

end;

procedure TfrmPurgeShareSelect.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if (Key = 27) then frmPurgeShareSelect.ModalResult := mrCancel;
end;

end.
