unit UnitDM;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: BP Database interface module
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Diaccess, Fmcmpnts, Trpcb, Fmlookup,DiTypLib,RpcConf1,MFunStr,hash,Eftfut;
  
type
  TdmMain = class(TDataModule)
    fmgImageUsers: TFMGets;
    fmgNetLoc: TFMGets;
    fmlNetLoc: TFMLister;
    FMValidatorNetLoc: TFMValidator;
    fmgBPWS: TFMGets;
    fmlBPWS: TFMLister;
    fmgSiteParam: TFMGets;
    fmgQueuePointer: TFMGets;
    fmlQueueRecord: TFMLister;
    fmlQueuePointer: TFMLister;
    fmlUserPreferences: TFMLister;
    fmlFileTypes: TFMLister;
    fmlMember: TFMLister;
    fmlJukebox: TFMLister;
    fmgRemoteMembers: TFMGets;
    fmgVaUser: TFMGets;
    fmlRemoteMember: TFMLister;
    fmfQueueRecord: TFMFinder;
    fmlMultiNamespace: TFMLister;
    fmlAssociatedInstitutions: TFMLister;
    fmlVistaRadGroup: TFMLister;
    fmlAssocVistaRadGroup: TFMLister;
    RPCBroker1: TRPCBroker;
    fmlMailMessages: TFMLister;
    fmgMailMessages: TFMGets;
    fmlMailMessageMembers: TFMLister;
    fmgMailMessageMembers: TFMGets;
    fmlMailGroups: TFMLister;
    fmgMailGroups: TFMGets;
    fmlMailGroupMembers: TFMLister;
    fmgXWBGroupMembers: TFMGets;
    fmlXWBGroupMembers: TFMLister;
    fmlXWBMemberGroups: TFMLister;
    fmgXWBMemberGroups: TFMGets;
    fmlXWBRemoteMembers: TFMLister;
    fmgXWBRemoteMembers: TFMGets;
    fmlNewPerson: TFMLister;
    fmlGCC: TFMLister;
    fmf2006_1: TFMFiler;
    fmf3_8: TFMFiler;
    fmf3_81: TFMFiler;
    fmf2006_166: TFMFiler;
    fmf2006_1662: TFMFiler;
    fmf3_811: TFMFiler;
    fmf3_812: TFMFiler;
    fmlPACSWriteLocation: TFMLister;
    fmgNLGROUP: TFMGets;
    fmlNLDGM: TFMLister;
    fmgNLJUKEBOX: TFMGets;
    fmgNLROUTER: TFMGets;
    fmgNLURL: TFMGets;
    fmgNLEKG: TFMGets;
    fmgNLRAID: TFMGets;
    fmgNLGCC: TFMGets;
    fmgNLDIAGRAM: TFMGets;
    fmlNLRAID: TFMLister;
    fmlNLJukebox: TFMLister;
    fmlNLURL: TFMLister;
    fmlNLRouters: TFMLister;
    fmlNLEKG: TFMLister;
    fmlNLGCC: TFMLister;
    fmlRGMembers: TFMLister;
    fmlRAIDGroups: TFMLister;
    procedure DataModuleCreate(Sender: TObject);
    function security2(Broker: TRPCBroker):boolean;
    function VistaValidate(IENS,FNum,FldNum,FldValue: string;silent:boolean):boolean;
    function GetFieldValue(FNum,FldNum,IENS,Flag:string;silent:boolean): string;
    procedure HandleBrokerError(Sender: TRPCBroker);
    function GetVariable(GetLogic:string):string;
    function FMUpdate(FNum,FldNum,IENS,Value:string):boolean;
    function GetSilentCodes(Vserver, Vport: string; var SilentAccess: string; var SilentVerify: string): boolean;
    function TestSilentLog(VServer, VPort,SilentAccess, SilentVerify: string):boolean;
    function AutoLogin(Broker: TRPCBroker;SilentAccess,SilentVerify,VServer,VPort:string; Pause: Integer): boolean;

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  dmMain: TdmMain;

implementation

uses Magbtm1;

{$R *.DFM}

procedure TdmMain.DataModuleCreate(Sender: TObject);
var    VServer, VPort,SilentAccess, SilentVerify: string;
begin
  if not RPCBroker1.Connected then
    if not TestSilentLog(VServer, VPort,SilentAccess, SilentVerify) then
    if not security2(RPCBroker1) then application.Terminate;
  end;
//**********
function TdmMain.TestSilentLog(VServer, VPort,SilentAccess, SilentVerify: string):boolean;
begin
 if VServer ='' then VServer :='127.0.00.01';
  if VPort = '' then VPort :='9800';
  if not RPCBroker1.Connected then
  if GetSilentCodes(VServer, VPort, SilentAccess, SilentVerify) then begin
//    MAGBTMF1.AutoLoggin(dmMain.RPCBroker1,SilentAccess,SilentVerify,VServer,VPort, 5)
    RPCBroker1.AccessVerifyCodes := SilentAccess + ';' + SilentVerify;
    RPCBroker1.server := VServer;
    RPCBroker1.listenerPort := strtoint(VPort);
    try
      RPCBroker1.connected := true;
      Result := RPCBroker1.connected;
      finally
      if Result then showmessage('Silent Loggin Successful!')
      else showmessage('Silent Loggin NOT Successful!');
    end;
    end;  // if GetSilentCodes
  end;


//**********
function TdmMain.security2(Broker: TRPCBroker):boolean;
  var
    VServer, VPort: string;
  begin
    with dmMain do begin
      result := false;
      if GetServerInfo(VServer, VPort) = mrcancel then begin
        halt;
        exit;
        end;
      Broker.Server := VServer;
      Broker.listenerPort := strtoint(VPort);
      Broker.OnRPCBFailure := handlebrokererror;
      application.processmessages;
      try
        Broker.Connected := true;
        if broker.Connected then
          if not Broker.createcontext('MAG WINDOWS') then begin
             ShowMessage('CC:createcontext("MAG WINDOWS") not be established!');
             halt;
             exit;
             end
          else result := true
        else begin
            showmessage('Broker Connection to server could not be established!');
            halt;
            exit;
            end;
      except
        on E:Exception do
          if Assigned(dmMain.RPCBroker1) then begin
            dmMain.RPCBroker1.free;
            dmMain.RPCBroker1 := nil;
            end;
          end; //try...except
    end; {with dmMain}
 end;
function TdmMain.VistaValidate(IENS,FNum,FldNum,FldValue: string;silent:boolean):boolean;
var
  i:integer;
  ErrorText: string;
  rlist : TStringlist;
begin
  VistaValidate := true ;
  rlist := TStringList.Create;
  RPCBroker1.RemoteProcedure :='DDR VALIDATOR';
  RPCBroker1.Param.Clear;
  with RPCBroker1.Param[0] do begin
    Value  := '.DDR';
    Ptype  := list;
    Mult['"FILE"']  := FNum;
    Mult['"IENS"']  := IENS;
    Mult['"FIELD"'] := FldNum;
    Mult['"VALUE"'] := FldValue;
    end; // with RPCBroker1.Param[0]
  try try
    RPCBroker1.LSTCALL(rlist);
  except
    on E:Exception do begin
      if Assigned(dmMain.RPCBroker1) then begin
        dmMain.RPCBroker1.free;
        dmMain.RPCBroker1 := nil;
        end;
      dmMain.RPCBroker1 := TRPCBroker.Create(nil);
      if not dmMain.RPCBroker1.Connected then begin
         if not dmMain.AutoLogin(dmMain.RPCBroker1,Magbtm1.SilentAccess,Magbtm1.SilentVerify,VServer,VPort, 5) then begin
           repeat
             MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^Login Message^Silent Login attempt failed!',280,MAGBTMF1.sgLatestTasks);
             MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^Login Message^Pausing 5 minutes and will then retry',280,MAGBTMF1.sgLatestTasks);
             pause(300);
             if Assigned(dmMain.RPCBroker1) then begin
               dmMain.RPCBroker1.free;
               dmMain.RPCBroker1 := nil;
               end;
             dmMain.RPCBroker1 := TRPCBroker.Create(nil);
           until dmMain.AutoLogin(dmMain.RPCBroker1,Magbtm1.SilentAccess,Magbtm1.SilentVerify,VServer,VPort, 5);
              end;
            end
          else begin
            MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^Error Message^Non-Connection related Broker error',280,MAGBTMF1.sgLatestTasks);
            MAGBTMF1.ErrorLog('BPError.Log',E.ClassName,'',E.Message,'');
            end; // else
          end; // on E:Exception
          end; //try...except
  finally
    if RPCBroker1.Results.Count > 1 then begin
      ErrorText := '';
      for i := 0 to RList.Count-1 do begin
        if pos('BEGIN_diERRORS',rlist[i]) <> 0 then begin
          VistaValidate := false;
          if not silent then
            if (i+6) <= (rlist.Count -1) then showmessage(rlist[i+6]);
          end;
        end;
      end;
    RPCBroker1.Param.Clear;
  end; //Try
  end;
function TdmMain.GetFieldValue(FNum,FldNum,IENS,Flag:string;silent:boolean): string;
    var RList: tstringlist;
            i : integer;
  begin
    RPCBroker1.RemoteProcedure := 'DDR GETS ENTRY DATA';
      RList := TStringList.Create;
      RPCBroker1.Param.Clear;
      with RPCBroker1.Param[0] do begin
        Value  := '.DDR';
        Ptype  := list;
        Mult['"FILE"']  := FNum;
        Mult['"IENS"']  := IENS;
        Mult['"FIELDS"'] := FldNum;
        Mult['"FLAGS"'] := Flag;
        end; // with RPCBroker1.Param[0]
    try try
    RPCBroker1.LSTCALL(rlist);
  except
    on E:Exception do begin
      if Assigned(dmMain.RPCBroker1) then begin
        dmMain.RPCBroker1.free;
        dmMain.RPCBroker1 := nil;
        end;
      dmMain.RPCBroker1 := TRPCBroker.Create(nil);
      if not dmMain.RPCBroker1.Connected then begin
         if not dmMain.AutoLogin(dmMain.RPCBroker1,Magbtm1.SilentAccess,Magbtm1.SilentVerify,VServer,VPort, 5) then begin
           repeat
             MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^Login Message^Silent Login attempt failed!',280,MAGBTMF1.sgLatestTasks);
             MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^Login Message^Pausing 5 minutes and will then retry',280,MAGBTMF1.sgLatestTasks);
             pause(300);
             if Assigned(dmMain.RPCBroker1) then begin
               dmMain.RPCBroker1.free;
               dmMain.RPCBroker1 := nil;
               end;
             dmMain.RPCBroker1 := TRPCBroker.Create(nil);
           until dmMain.AutoLogin(dmMain.RPCBroker1,Magbtm1.SilentAccess,Magbtm1.SilentVerify,VServer,VPort, 5);
              end;
            end
          else begin
            MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^Error Message^Non-Connection related Broker error',280,MAGBTMF1.sgLatestTasks);
            MAGBTMF1.ErrorLog('BPError.Log',E.ClassName,'',E.Message,'');
            end; // else
          end; // on E:Exception
          end; //try...except
      finally
       if RList[0]='[Data]' then begin
         if flag = 'I' then result := piece(RList[1],U,4)
       else result := piece(RList[1],U,5);
       end
     else Result := '';
     //end;
     if Result = '' then
         for i := 0 to Rlist.Count -1 do begin
            if pos('BEGIN_diERRORS',rlist[i]) <> 0 then
              if not silent then
                if (i+6) <= (rlist.Count -1) then showmessage(rlist[i+6]);
             end;
     RList.Free;
     RPCBroker1.Param.Clear;
     end; // try...finally
   end;

 procedure TdmMain.HandleBrokerError(Sender: TRPCBroker);
var
  ErrorText: String;
  Path: String;
  StrLoc: TStringList;
  NowVal: TDateTime;
begin
  NowVal := Now;
  ErrorText := TRPCBroker(Sender).RPCBError;
  StrLoc := TStringList.Create;
  try
    Path := ExtractFilePath(Application.ExeName);
    Path := Path + 'Error.Log';
    if FileExists(Path) then
      StrLoc.LoadFromFile(Path);
    StrLoc.Add(FormatDateTime('mm/dd/yyyy hh:mm:ss  ',NowVal) + ErrorText);
    StrLoc.SaveToFile(Path);
  finally
    StrLoc.Free;
  end;
end;
function TdmMain.GetVariable(GetLogic:string):string;
  var
  data: string;
begin
  result := '';
   with RPCBroker1 do begin
    RemoteProcedure := 'XWB GET VARIABLE VALUE';
    Param[0].Value := GetLogic;
    Param[0].PType := reference;
    try
      Call;
    finally
      if RPCBroker1.Results.Count > 0 then Data := RPCBroker1.Results[0]
      else Data :='0';
      result := Data;
    end; //try
    end; // with RPCBroker1
end;// function
function TdmMain.FMUpdate(FNum,FldNum,IENS,Value:string):boolean;
var Data: string;
begin
  result := true;
  with RPCBroker1 do begin
    RemoteProcedure := 'DDR FILER';
    Param[0].Value := 'UPDATE';
    Param[0].PType := literal;
    Param[1].Value := '"'+FNum+'^'+FldNum+'^'+IENS+'^'+Value+'"' ;
    Param[1].PType := literal;
    try
      Call;
    finally
      if RPCBroker1.Results.Count > 0 then Data := RPCBroker1.Results[0]
      else Data :='0';
      if Data = '0' then result := false;
    end;
    end;
end;
function TdmMain.GetSilentCodes(Vserver, Vport: string; var SilentAccess: string; var SilentVerify: string): boolean;

var t: tstrings;
    I,place: INTEGER;
begin
  result := false;
  if not fileexists('c:\MySAVC.avc') then exit;
  t := Tstringlist.create;
  try
    t.LoadFromFile('c:\MySAVC.avc');
    for I := 0 to t.count - 1 do
      begin
        if (pos(Vserver + ',' + Vport, t[i]) > 0) then
          begin
            silentaccess := piece(t[i], '^', 2);
            silentverify := piece(t[i], '^', 3);
            result := true;
          end;
      end;
  finally
    t.free;
  end;
end;
function TdmMain.AutoLogin(Broker: TRPCBroker;SilentAccess,SilentVerify,VServer,VPort:string; Pause: Integer): boolean;
begin
  result := false;
  with Broker do begin
    if pos('hidden',SilentAccess) <> 0 then
      AccessVerifyCodes := hash.Decrypt(SilentAccess) + ';' + hash.Decrypt(SilentVerify)
    else AccessVerifyCodes := SilentAccess + ';' + SilentVerify;
    server := VServer;
    listenerPort := strtoint(VPort);
    try
      connected := true;
    finally
      MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^Login Message^Silent Login attempt',280,MAGBTMF1.sgLatestTasks);
      if not connected then begin
        MAGBTMF1.ErrorLog('BPError.Log','Login Message','','Broker Reconnection failed','');
        application.Terminate;
        end // if not connected
      else begin
        MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^Login Message^Broker Reconnection Successful',280,MAGBTMF1.sgLatestTasks);
        result := true;
        end;
    end; //try...finally
    end; // With Broker
end;

end.
