unit frmRemoteImages;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  StdCtrls, trpcb, cmagvutils,
  cmagutils,
  Dialogs, maggut1, cMagSecurity, umagclasses, fmagfullres, uMagDefinitions;//, fmagimagelist;


type
  TfrmRIV = class(TForm)
    GroupBox1: TGroupBox;
    Label1: TLabel;
    edtServer: TEdit;
    Label2: TLabel;
    edtPort: TEdit;
    btnConnect: TButton;
    lisImages: TListBox;
    btnRetrieveImages: TButton;
    Memo1: TMemo;
    grpRemoteSites: TGroupBox;
    Label3: TLabel;
    btnGetImages: TButton;
    lisVisitedSites: TListBox;

    procedure btnConnectClick(Sender: TObject);
    procedure btnRetrieveImagesClick(Sender: TObject);
    procedure lisImagesClick(Sender: TObject);
    procedure lisImagesDblClick(Sender: TObject);
    procedure btnGetImagesClick(Sender: TObject);
  private
    { Private declarations }
    RemoteDUZ : String;
    RemoteMAGWINDOWS : String;
    UserSSN : String;
    LocalDUZ : String;
    UserName : String;
    RPCBrokerRemote1 : Trpcbroker;
    LocalBroker : TRPCBroker;
    LocalPatientDFN : String;
    SecurityBroker : TMag4Security;
    FVutils: TMagVutils;
    FUtils: TMagUtils;
    RemoteServer : String;
    RemotePort : integer;

    function getSSN(aDUZ: String) : String;
    function getImageInfo(ImageIEN : String) : String;
    procedure ConvertImageListToObjectList(aList : TStrings; FObjlist: TList);
    procedure getServerPort(SiteName : String; var Server : String; var Port : integer);
  public
    procedure RetrieveImages(CurrentBroker : TRPCBroker; PatientDFN : String; var RemoteImageList :TStrings; var RemoteSiteName : String);




    procedure Initialize(CurrentBroker : TRPCBroker; PatientDFN : String; SecurBroker : TMag4Security);
    { Public declarations }
  published
    ImageList: TStrings;
  end;

var
  frmRIV: TfrmRIV;


implementation

uses dmSingle;

//uses dmSingle;//, fmagImageList;

{$R *.dfm}

procedure TfrmRIV.getServerPort(SiteName : String; var Server : String; var Port : integer);
begin

  if SiteName = 'WASHINGTON, DC' then
  begin
    Server := '<servername>';
    Port := 9300;
  end;

end;

procedure TfrmRIV.Initialize(CurrentBroker : TRPCBroker; PatientDFN : String; SecurBroker : TMag4Security);
begin
  LocalBroker := CurrentBroker;
  SecurityBroker := SecurBroker;
  LocalDUZ := LocalBroker.User.DUZ;
  UserName := LocalBroker.User.Name;
  LocalPatientDFN := PatientDFN;

end;

procedure TfrmRIV.RetrieveImages(CurrentBroker : TRPCBroker; PatientDFN : String; var RemoteImageList :TStrings; var RemoteSiteName : String);
var
  i : integer;
begin
  LocalBroker := CurrentBroker;
  LocalDUZ := LocalBroker.User.DUZ;
  UserName := LocalBroker.User.Name;
  UserSSN := getSSN(LocalDUZ);
  LocalPatientDFN := PatientDFN;

  LocalBroker.RemoteProcedure := 'VAFCTFU GET TREATING LIST';
  LocalBroker.Param[0].Value := LocalPatientDFN;
  LocalBroker.Param[0].PType := Literal;
  LocalBroker.Call;
  for i := 0 to localbroker.Results.Count -1 do
  begin
    lisVisitedSites.Items.Add(magpiece(LocalBroker.Results.Strings[i], '^',2));

  end;

//  lisVisitedSites.Items := magpiece(LocalBroker.Results, '^',2);

  ShowModal;
  if (modalresult = mrOK) and (lisvisitedsites.ItemIndex <> -1 ) then
  begin
    getServerPort(lisVisitedSites.Items[lisvisitedsites.itemindex], RemoteServer, RemotePort);
  // do something here to convert the select site to get the serverIP and Port of the remote sites.
  RemoteSiteName := lisvisitedsites.items[lisVisitedSites.itemindex];


  RPCBrokerRemote1 := dmod.RemoteBroker.GetBroker;
  if RPCBrokerRemote1 = nil then
  begin
    RPCBrokerRemote1 := TRPCBroker.Create(self);
  end;
//  RPCBrokerRemote1 := TRPCBroker.Create(self);

  RPCBrokerRemote1.ClearParameters := true;
  RPCBrokerRemote1.ClearResults := true;
  RPCBrokerRemote1.KernelLogIn := false;
  RPCBrokerRemote1.LogIn.Mode := lmNTToken;
  RPCBrokerRemote1.Server := RemoteServer;// edtserver.Text;
  RPCBrokerRemote1.ListenerPort := RemotePort;//strtoint(edtport.Text);
  RPCBrokerRemote1.RemoteProcedure := 'XUS SIGNON SETUP';
  RPCBrokerRemote1.Param[0].Value := '-31^DVBA_^' + UserSSN + '^' + UserName + '^COLUMBIA, MO^543^' + LocalDUZ + '^No Phone';
  RPCBrokerRemote1.Param[0].PType := literal;
  RPCBrokerRemote1.Call;

  Try
    If not RPCBrokerRemote1.CreateContext('DVBA CAPRI GUI') then
    Showmessage('could not create DVBA CAPRI GUI context');
  except
    on E: Exception do Showmessage(E.Message);
  end;
            // get the remote users DUZ

  RPCBrokerRemote1.RemoteProcedure := 'XWB GET VARIABLE VALUE';
  RPCBrokerRemote1.Param[0].Value := '$O(^VA(200,"SSN",' + UserSSN + ',""))';
  RPCBrokerRemote1.Param[0].PType := reference;
  RPCBrokerRemote1.Call;
  RemoteDUZ := RPCBrokerRemote1.Results[0];

                                           {
                     //execute RPC
      // get the MAG WINDOWS context IEN
                                            }

  RPCBrokerRemote1.RemoteProcedure := 'XWB GET VARIABLE VALUE';
  RPCBrokerRemote1.Param[0].Value := '$O(^DIC(19,"B","MAG WINDOWS",""))';
  RPCBrokerRemote1.Param[0].PType := reference;
  RPCBrokerRemote1.Call;
  RemoteMAGWINDOWS := RPCBrokerRemote1.Results[0];

  // Assign MAG WINDOWS to remote server
  RPCBrokerRemote1.RemoteProcedure := 'DDR FILER';
  RPCBrokerRemote1.Param[0].Value := 'EDIT';
  RPCBrokerRemote1.Param[0].PType := Literal;
  RPCBrokerRemote1.Param[1].Mult['1'] := '200.03^.01^1,' + RemoteDUZ + '^' + RemoteMAGWINDOWS;
  RPCBrokerRemote1.Param[1].PType := List;
  RPCBrokerRemote1.Call;
//  lisImages.Items := RPCBrokerRemote1.Results;

RPCBrokerRemote1.RemoteProcedure := 'MAG4 PAT GET IMAGES';

with RPCBrokerRemote1 do
begin
      param[0].Value := LocalPatientDFN;
      param[0].PType := literal;
      param[1].value := '';//pkg;
      param[1].ptype := literal;
      param[2].value := 'CLIN,CLIN/ADMIN,ADMIN/CLIN';//cls;
      param[2].ptype := literal;
      param[3].value := '';//types;
      param[3].ptype := literal;
      param[4].value := '';//event;
      param[4].ptype := literal;
      param[5].value := '';//spec;
      param[5].ptype := literal;
      Param[6].Value := '';//FrDt;
      Param[6].ptype := literal;
      Param[7].Value := '';//ToDt;
      Param[7].ptype := literal;
      Param[8].Value := '';//origin;
      Param[8].PType := literal;

end;

  RPCBrokerRemote1.lstCall(RemoteImageList);

  RemoteImageList.Delete(0);
  end
  else
  begin
    RemoteImageList.Add('-1^USER DID NOT SELECT REMOTE SITE');
  end;

end;

function TfrmRIV.getSSN(aDUZ: String) : String;
var
res : String;
begin
  LocalBroker.RemoteProcedure := 'XWB GET VARIABLE VALUE';
  LocalBroker.Param[0].value := '^VA(200,' + aDUZ + ',1)';
  LocalBroker.Param[0].PType := reference;
  res := LocalBroker.strCall;
  result := magpiece(res, '^', 9);
end;

procedure TfrmRIV.btnConnectClick(Sender: TObject);
var
  Shares : TStrings;
  i : integer;
begin
  UserSSN := getSSN(LocalDUZ);
  RPCBrokerRemote1 := TRPCBroker.Create(self);
  RPCBrokerRemote1.ClearParameters := true;
  RPCBrokerRemote1.ClearResults := true;
  RPCBrokerRemote1.KernelLogIn := false;
  RPCBrokerRemote1.LogIn.Mode := lmNTToken;
  RPCBrokerRemote1.Server := edtserver.Text;
  RPCBrokerRemote1.ListenerPort := strtoint(edtport.Text);
  RPCBrokerRemote1.RemoteProcedure := 'XUS SIGNON SETUP';
  RPCBrokerRemote1.Param[0].Value := '-31^DVBA_^' + UserSSN + '^' + UserName + '^COLUMBIA, MO^543^' + LocalDUZ + '^No Phone';
//  RPCBrokerRemote1.Param[0].Value := '-31^DVBA_^' + edtssn.text + '^' + edtname.text + '^COLUMBIA, MO^543^' + edtlocalduz.Text + '^No Phone';
  RPCBrokerRemote1.Param[0].PType := literal;
  RPCBrokerRemote1.Call;

  Try
    If not RPCBrokerRemote1.CreateContext('DVBA CAPRI GUI') then
    Showmessage('could not create DVBA CAPRI GUI context');
  except
    on E: Exception do Showmessage(E.Message);
  end;
            // get the remote users DUZ

  RPCBrokerRemote1.RemoteProcedure := 'XWB GET VARIABLE VALUE';
//  RPCBrokerRemote1.Param[0].Value := '$O(^VA(200,"SSN",<xxxxxxxxx>,""))';
  RPCBrokerRemote1.Param[0].Value := '$O(^VA(200,"SSN",' + UserSSN + ',""))';
  RPCBrokerRemote1.Param[0].PType := reference;
  RPCBrokerRemote1.Call;
  RemoteDUZ := RPCBrokerRemote1.Results[0];

                                           {
                     //execute RPC
      // get the MAG WINDOWS context IEN
                                            }

  RPCBrokerRemote1.RemoteProcedure := 'XWB GET VARIABLE VALUE';
  RPCBrokerRemote1.Param[0].Value := '$O(^DIC(19,"B","MAG WINDOWS",""))';
  RPCBrokerRemote1.Param[0].PType := reference;
  RPCBrokerRemote1.Call;
  RemoteMAGWINDOWS := RPCBrokerRemote1.Results[0];
//  edtContextIEN.text := RemoteMAGWINDOWSIEN;

               {
  RPCBrokerRemote1.RemoteProcedure := 'XWB GET VARIABLE VALUE';
  RPCBrokerRemote1.Param[0].Value := '$O(^VA(200,' + edtStrRtrn1.text + ',203,"B",' + edtContextIEN.text + ',0)';
  RPCBrokerRemote1.Param[0].PType := reference;
  RPCBrokerRemote1.Call;
  self.caption := RPCBrokerRemote1.Results[0];  //for single value use Results[0]
              }

              // Assign MAG WINDOWS to remote server
  RPCBrokerRemote1.RemoteProcedure := 'DDR FILER';
  RPCBrokerRemote1.Param[0].Value := 'EDIT';
  RPCBrokerRemote1.Param[0].PType := Literal;
  RPCBrokerRemote1.Param[1].Mult['1'] := '200.03^.01^1,' + RemoteDUZ + '^' + RemoteMAGWINDOWS;
  RPCBrokerRemote1.Param[1].PType := List;
  RPCBrokerRemote1.Call;
  lisImages.Items := RPCBrokerRemote1.Results;


  //DELETE CAPRI CONTEXT
                               {
  RPCBrokerRemote1.RemoteProcedure := 'DDR FILER';
  RPCBrokerRemote1.Param[0].Value := 'EDIT';
  RPCBrokerRemote1.Param[0].PType := Literal;
  RPCBrokerRemote1.Param[1].Mult['1'] := '200.03^.01^1,' + RemoteDUZ + '^@';
  RPCBrokerRemote1.Param[1].PType := List;

  lstData.items := RPCBrokerRemote1.Results;
  }
{
  btnLoadRemoteImages.Enabled := true;
  btnLoginRemote.Enabled := false;
  edtRemoteServerIP.Enabled := false;
  edtRemoteServerPort.Enabled := false;
  }

  RPCBrokerRemote1.remoteprocedure := 'MAG GET NETLOC';
  RPCBrokerRemote1.PARAM[0].VALUE := 'ALL';
  RPCBrokerRemote1.PARAM[0].PTYPE := Literal;

  RPCBrokerRemote1.Call();

  Shares := rpcBrokerRemote1.results;

  for i := 0 to Shares.Count -1 do
  begin
//    SecurityBroker.ShareList.Add(Shares[i]);
  end;

end;

procedure TfrmRIV.btnRetrieveImagesClick(Sender: TObject);
var

  i : integer;
  objlist : Tlist;
begin

ImageList := tstringlist.Create;//  tstrings.Create;
RPCBrokerRemote1.RemoteProcedure := 'MAG4 PAT GET IMAGES';

with RPCBrokerRemote1 do
begin
      param[0].Value := LocalPatientDFN;
      param[0].PType := literal;
      param[1].value := '';//pkg;
      param[1].ptype := literal;
      param[2].value := 'CLIN,CLIN/ADMIN,ADMIN/CLIN';//cls;
      param[2].ptype := literal;
      param[3].value := '';//types;
      param[3].ptype := literal;
      param[4].value := '';//event;
      param[4].ptype := literal;
      param[5].value := '';//spec;
      param[5].ptype := literal;
      Param[6].Value := '';//FrDt;
      Param[6].ptype := literal;
      Param[7].Value := '';//ToDt;
      Param[7].ptype := literal;
      Param[8].Value := '';//origin;
      Param[8].PType := literal;

end;
try
  RPCBrokerRemote1.lstCall(ImageList);
  memo1.text := ImageList.Text;
  lisImages.Clear();
  ImageList.Delete(0);
  for i := 0 to ImageList.Count - 1 do
  begin
     lisimages.Items.Add(ImageList[i]);
  end;










  {
  ConvertImageListToObjectList(flist, objlist);
  frmimagelist.MagListView1.LoadListFromMagImageList(flist,objlist);
  }

except
    on E: EXCEPTION do
      begin
        showmessage('Error getting images: ' + e.Message);
//        Flist.insert(0, '0^ERROR Accessing Patient Image list.');
//        Fstat := false;
//        rpcmsg := 'ERROR Accessing Patient Image list: ' + e.Message;
//        Flist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;
end;

procedure TfrmRIV.lisImagesClick(Sender: TObject);
begin
self.Caption := magpiece(lisimages.Items[lisimages.ItemIndex],'^',15);

end;

function TfrmRIV.getImageInfo(ImageIEN : String) : String;
var
rList : TStrings;
rstat : boolean;
rmsg : String;
begin
rList := TStringList.Create;
    rstat := false;
  with RPCBrokerRemote1 do
    begin
      param[0].Value := ImageIEN;
      param[0].PType := literal;
      Param[1].Value := magBoolToStrInt(false);
      Param[1].PType := literal;
      RPCBrokerRemote1.remoteprocedure := 'MAGG IMAGE INFO';
    end;
  try
    RPCBrokerRemote1.lstCall(rlist);
    if (magpiece(rlist[0], '^', 1) = '0') or (rlist.count = 0) then
      begin
        rstat := false;
        if rlist.count > 0 then rmsg := magpiece(rlist[0], '^', 2)
        else rmsg := 'ERROR in VistA operation canceled.';
        exit;
      end;
    rstat := true;
    result := rlist[0];
    rlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        rlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        rlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;
end;

procedure TfrmRIV.lisImagesDblClick(Sender: TObject);
var magien : string;
rstat : boolean;
rmsg : string;
rlist : Tstrings;
Iobj : TimageData;
objlist : Tlist;
NewFullRes : TfrmFullRes;
begin
objlist := Tlist.create;
rlist := Tstringlist.Create;
try
magien := '';
magien := magpiece(self.caption, '|', 1);
// if  inputquery('Open Image ID #','Enter Image ID# ',magien) then
//   begin
     if magien <> '' then
//     dmod.MagDBMVista1.RPMaggImageInfo(rstat,rmsg,rlist,magien);
//     if not rstat then exit;
      rmsg := getImageInfo(magien);
     Iobj := dmod.MagVUtils1.StringToIMageObj(rmsg);
     // ? compare patients, if Diff Patient than MagPat1, then open in diff window.
//     if Iobj.DFN = LocalPatientDFN then
//       begin
        NewFullRes := TfrmFullRes.Create(nil);
        NewFullRes.Caption := 'Opening Image(s) by ID #';
//        NewFullRes.color := clPurple;
        NewFullRes.Mag4Viewer1.Align := alnone;
        NewFullRes.Mag4Viewer1.SetBounds(NewFullRes.Mag4Viewer1.left+10,NewFullRes.Mag4Viewer1.top+10,NewFullRes.Mag4Viewer1.width-20,NewFullRes.mag4Viewer1.height-20);
        NewFullRes.Mag4Viewer1.Anchors := [akleft,aktop,akright,akbottom];
//        NewFullRes.Color := clblue;
        NewFullRes.Show;
        application.processmessages;
        objlist.Add(Iobj);
        NewFullRes.Mag4Viewer1.ImagesToMagView(objlist);
        {
       end
     else
       begin

       end;
       }
//   end;

finally
rlist.free;
objlist.Free;
end;

end;

procedure TfrmRIV.ConvertImageListToObjectList(aList : TStrings; FObjlist: TList);
var i: integer;
  IObj: TImageData;
begin
FObjlist := TList.Create();
  for i := 1 to aList.count - 1 do
    begin
      try
        Iobj := FVutils.StringToIMageObj('xx^' + Futils.magPiece(aList[i], '|', 2));

        FObjlist.Add(Iobj);
        // Need to rething the GroupIEN, maybe the pointer to cMagImagelist
        //   in the Iobj  ? ?
        {
        If (FgroupIEN <> '') then Iobj.GroupIEN := Strtoint(FGroupIEN);
        Iobj.GroupIndex := (FObjlist.count - 1);
        FBaselist[i] := Futils.magPiece(FbaseList[i], '|', 1) + '|' + inttostr(FObjlist.count - 1);
        }
      except
      //
      end;
    end;
end;

procedure TfrmRIV.btnGetImagesClick(Sender: TObject);
begin
modalresult := mrok;
end;

end.
