unit magWebHelp;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, OleCtrls, SHDocVw,ACTIVEX, ComCtrls, ToolWin, Buttons,
  ActnList, ImgList;

type
  TfrmMagBPHelp = class(TForm)
    MainMenu1: TMainMenu;
    mnuHelpSearch: TMenuItem;
    WB: TWebBrowser;
    mnuBack: TMenuItem;
    mnuForward: TMenuItem;
    mnuFile: TMenuItem;
    mnuPrint: TMenuItem;
    mnuExit: TMenuItem;
    procedure WBPrintWithDialog(Sender: TObject);
    procedure WBPrintPreview(Sender: TObject);
    procedure WBPrintPageSetup(Sender: TObject);
    procedure mnuPrintAllClick(Sender: TObject);
    procedure mnuBackClick(Sender: TObject);
    procedure mnuForwardClick(Sender: TObject);
    procedure mnuHomeClick(Sender: TObject);
    procedure mnuHelpSearchClick(Sender: TObject);
    procedure OpenFindDialog(WB: TWebBrowser);
    procedure WBSaveAs(Sender: TObject) ;
    procedure WebBrowser_OnCommandStateChange(Sender: TObject;Command: Integer;Enable: WordBool);
    procedure CloseApp(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMagBPHelp: TfrmMagBPHelp;

implementation

{$R *.dfm}
procedure TfrmMagBPHelp.mnuPrintAllClick(Sender: TObject);
// print directly without printer dialog
//procedure TfrmMagBPHelp.WBPrintNoDialog(WB: TWebBrowser) ;
var
   vIn, vOut: OleVariant;
begin
   WB.ControlInterface.ExecWB(OLECMDID_PRINT, OLECMDEXECOPT_DONTPROMPTUSER, vIn, vOut) ;
end;

//call the printer dialog
procedure TfrmMagBPHelp.WBPrintWithDialog(Sender: TObject) ;
var
   vIn, vOut: OleVariant;
begin
   WB.ControlInterface.ExecWB(OLECMDID_PRINT, OLECMDEXECOPT_PROMPTUSER, vIn, vOut) ;
end;

// Print Preview
procedure TfrmMagBPHelp.WBPrintPreview(Sender: TObject);
var
   vIn, vOut: OleVariant;
begin
   WB.ControlInterface.ExecWB(OLECMDID_PRINTPREVIEW, OLECMDEXECOPT_DONTPROMPTUSER, vIn, vOut) ;
end;

//Call page setup dialog
procedure TfrmMagBPHelp.WBPrintPageSetup(Sender: TObject) ;
var
   vIn, vOut: OleVariant;
begin
   WB.ControlInterface.ExecWB(OLECMDID_PAGESETUP, OLECMDEXECOPT_PROMPTUSER, vIn, vOut) ;
end;

procedure TfrmMagBPHelp.WBSaveAs(Sender: TObject) ;
var
   vIn, vOut: OleVariant;
begin
   WB.ControlInterface.ExecWB(OLECMDID_SAVEAS, OLECMDEXECOPT_PROMPTUSER, vIn, vOut) ;
end;
procedure TfrmMagBPHelp.mnuBackClick(Sender: TObject);
begin
  wb.GoBack;
end;

procedure TfrmMagBPHelp.mnuForwardClick(Sender: TObject);
begin
  WB.GoForward;
end;

procedure TfrmMagBPHelp.mnuHomeClick(Sender: TObject);
begin
  WB.GoHome;
end;
procedure TfrmMagBPHelp.WebBrowser_OnCommandStateChange(
  Sender: TObject;
  Command: Integer;
  Enable: WordBool);
begin
  case Command of
  CSC_NAVIGATEBACK: mnuBack.Enabled := Enable;
  CSC_NAVIGATEFORWARD: mnuForward.Enabled := Enable;
  end;
end;
procedure TfrmMagBPHelp.mnuHelpSearchClick(Sender: TObject);
begin
  OpenFindDialog(WB);
end;
procedure TfrmMagBPHelp.OpenFindDialog(WB: TWebBrowser);
const
  CGID_WebBrowser: TGUID = '{ED016940-BD5B-11cf-BA4E-00C04FD70816}';
  HTMLID_FIND = 1;
var
  CmdTarget : IOleCommandTarget;
  vaIn, vaOut: OleVariant;
  PtrGUID: PGUID;
begin
  New(PtrGUID);
  PtrGUID^ := CGID_WebBrowser;
  if WB.Document <> nil then
    try
      WB.Document.QueryInterface(IOleCommandTarget, CmdTarget);
      if CmdTarget <> nil then
        try
          CmdTarget.Exec(PtrGUID, HTMLID_FIND, 0, vaIn, vaOut);
        finally
          CmdTarget._Release;
        end;
    except
    end;
  Dispose(PtrGUID);
end;
procedure TfrmMagBPHelp.CloseApp(Sender: TObject);
begin
  frmMagBPHelp.Free;
end;

{
OLECMDID_OPEN OLECMDID_NEW OLECMDID_SAVE
OLECMDID_SAVEAS OLECMDID_SAVECOPYAS OLECMDID_PRINT
OLECMDID_PRINTPREVIEW OLECMDID_PAGESETUP OLECMDID_SPELL
OLECMDID_PROPERTIES OLECMDID_CUT OLECMDID_COPY
OLECMDID_PASTE OLECMDID_PASTESPECIAL OLECMDID_UNDO
OLECMDID_REDO OLECMDID_SELECTALL OLECMDID_CLEARSELECTION
OLECMDID_ZOOM OLECMDID_GETZOOMRANGE OLECMDID_UPDATECOMMANDS

OLECMDID_REFRESH OLECMDID_STOP OLECMDID_HIDETOOLBARS
OLECMDID_SETPROGRESSMAX OLECMDID_SETPROGRESSPOS
OLECMDID_SETPROGRESSTEXT

OLECMDID_SETTITLE OLECMDID_SETDOWNLOADSTATE OLECMDID_STOPDOWNLOAD

OLECMDID_FIND OLECMDID_ONTOOLBARACTIVATED OLECMDID_DELETE

OLECMDID_HTTPEQUIV OLECMDID_ENABLE_INTERACTION OLECMDID_HTTPEQUIV_DONE

OLECMDID_ONUNLOAD OLECMDID_PROPERTYBAG2 OLECMDID_PREREFRESH

}
{
OnCommandStateChange
Indicates whether certain command functionality is available.

procedure YourForm.WebBrowser_OnCommandStateChange(
    Sender: TObject;
    Command: Integer;
    Enable: WordBool);
Arguments:-

Command is one of:

type TCommandStateChangeConstants =(
    CSC_UPDATECOMMANDS = $FFFFFFFF,
    CSC_NAVIGATEFORWARD = $000000001,
    CSC_NAVIGATEBACK = $00000002);
CSC_UPDATECOMMANDS
The state of one of the toolbar buttons may have changed. Check status of each toolbar button relevant to your application and whether the toolbar is visible.
CSC_NAVIGATEFORWARD
Indicates whether there is "forward" history.
CSC_NAVIGATEBACK
Indicates whether there is "backwards" history.
Note: It seems fairly common to use OnCommandStateChange to control directly whether the "Back" and "Forward" buttons should be available:

procedure YourForm.WebBrowser_OnCommandStateChange(
  Sender: TObject;
  Command: Integer;
  Enable: WordBool);
begin
  case Command of
  CSC_NAVIGATEBACK: BackBtn.Enabled := Enable;
  CSC_NAVIGATEFORWARD: ForwardBtn.Enabled := Enable;
  end;
end;

}
end.
