unit magpurge1;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: BP Purge
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,Trpcb,
  MFunstr,StdCtrls,FileCtrl, OleCtrls, TeeProcs, TeEngine, Chart,ExtCtrls,magbut,
  splVista,eftfut, Menus, isp3, Buttons,Series,hash, CheckLst,DateUtils,Fmcmpnts,StrUtils,
  Diaccess,DiTypLib,Fmlookup,RpcConf1,frmVistAAbout,rpcSLogin,telabout;
type
  TMagSitePurgeParam = RECORD
    FilePrefix: string;
    abs_KeepDays: integer;
    full_KeepDays: integer;
    big_KeepDays: integer;
    photo_ID: integer;
    minimum: integer;
    ExpressPurge: boolean;
    Rate: integer;
    PurgeBy: string;
  end;
  TMagFileServer = RECORD
   Path : String[100];
   Size : TLargeInteger;
   Space      : TLargeInteger;
   Used : TLargeInteger;
  end;
  TMagPurgeCount = RECORD
    abs: integer;
    full: integer;
    big: integer;
    photoID: integer;
    text: integer;
    foreign: integer;
  end;
  TfrmMagPurge = class(TForm)
    splButton: TSplitter;
    pnlGraphs: TPanel;
    pnlProcGroup: TPanel;
    gbActivities: TGroupBox;
    gbShares: TGroupBox;
    lbServers: TListBox;
    gbPurgeFiles: TGroupBox;
    lbPaths: TListBox;
    RPCBroker1: TRPCBroker;
    MainMenu1: TMainMenu;
    mnuHelp: TMenuItem;
    mnuAbout: TMenuItem;
    Content1: TMenuItem;
    File1: TMenuItem;
    Exit1: TMenuItem;
    OpenLog1: TMenuItem;
    fmlNetLoc: TFMLister;
    RPCBrokerTest: TRPCBroker;
    mnuEdit1: TMenuItem;
    muuSelectShares: TMenuItem;
    gpPurgeParameters: TGroupBox;
    lbPurgeParameters: TListBox;
    mnuPrintResults: TMenuItem;
    PrintDialog1: TPrintDialog;
    chrtOriginalServers: TChart;
    Series1: TBarSeries;
    chrtCachePurge: TChart;
    Series2: TBarSeries;
    stStartDate: TStaticText;
    stStartDateData: TStaticText;
    stStartTime: TStaticText;
    stStartTimeData: TStaticText;
    stRunTime: TStaticText;
    stRunTimeData: TStaticText;
    stTotalFiles: TStaticText;
    stTotalFilesData: TStaticText;
    stPurgeCount: TStaticText;
    stPurgeCountData: TStaticText;
    stJBQueues: TStaticText;
    stJBQueuesData: TStaticText;
    stPurgeCriteria: TStaticText;
    stPurgeCriteriaData: TStaticText;
    stIENCount: TStaticText;
    stIENCountData: TStaticText;
    sbtnStart: TBitBtn;
    sbtnStop: TBitBtn;
    function Purge(FilePath: string): boolean; //Purge(FilePath: string; Hash: Boolean): boolean;
    function Getlist(var ServerList:TStringList;Shares: string): Boolean;
    function PurgeParam:boolean;
    procedure FormCreate(Sender: TObject);
    function DeleteCriteria(var Criteria: string;var IEN: string;var filetype:integer;
       FPath: string; FileRec: TSearchRec; PurgeBy: string): boolean;
    procedure LogFile(filepath,DataItem:string;var FileSize: integer);
    function JBQueue(RecNo: string):string;
    procedure sbtnStartClick(Sender: TObject);
    procedure CacheUpdate(filepath,fname,ien: string);
    procedure init;
    function AltLastFile(FilePath:string):boolean;
    function FileDate(FileRec: TSearchRec):TDate;
    procedure mWait(AMsec:Word);
    procedure GraphicUpdate(CacheCount,PurgeCount:TMagPurgeCount);
    procedure TBUpdate;
    procedure logproc(LogFile:string);
    procedure Summary;
    procedure Elog(Limit:integer);
    function MagUpdate(FileName,ext,ien, device: string): Boolean;
    procedure InitVariables;
    function ImageDel(IEN:string):boolean;
    function FileSizeZero(Path:string): boolean;
    procedure SetPiece(SubString: string;var TargetString:string ;delimiter:string;piece1:integer);
    procedure sbtnStopClick(Sender: TObject);
    function GetPlace(var SiteCode: string):integer;
    procedure AltFileType(var AltFileTypeList:TStringList);
    procedure ErrorLog(Proced,ErrorType,MessageS,EM,Action: String;var FileSize: Integer);
    procedure mnuAboutClick(Sender: TObject);
    procedure InitLogFile(filepath,StringHeader:string;ArchiveOnly: Boolean);
    procedure ExecNewProcess(ProgramName : String; Wait: Boolean);
    procedure Content1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure OpenLog1Click(Sender: TObject);
    function MPieceSub(SuperString,Delimiter:string;LowerRange,UpperRange:integer):String;
    function VerifyVersion(Sender: TObject;  AppVersion: string; var kids:string): boolean;
    function AssignLogPath(WSIEN:string):string;
    function GetVariable(GetLogic:string):string;
    function GetValue(Filenumber,FieldNumber,IEN:string):string;
    function LogSize(BPWS:string):Integer;
    procedure OnException(E:exception);
    function AutoLogin(Broker: TRPCBroker;SilentAccess,SilentVerify,VServer,VPort,Division:string; Pause: Integer;Sender:TObject): boolean;
    procedure FMComponentInit(Sender: TObject);
    function FMUpdate(FNum,FldNum,IENS,Value:string):boolean;
    function GetFieldValue(FNum,FldNum,IENS,Flag:string;silent:boolean): string;
    procedure muuSelectSharesClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    function FileInUse(FileName: string): Boolean;
    function DateToFMInternal(ExDate:string):string;
    procedure mnuPrintResultsClick(Sender: TObject);
    function DiskFree32(var FileServer: TMagFileServer): Boolean;
    function NumericSegment(Segment: string):integer;
    function ImageFile(FileName:string;var IEN:string):boolean;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormPaint(Sender: TObject);
    function IsStrANumber(const S: string): Boolean;
    procedure DelCnt(fileType: integer);

  //  function CheckCmdLine(brkrRPCB: TRPCBroker): boolean;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  E:Exception;
  frmMagPurge: TfrmMagPurge;
  SitePurgeParam: TMagSitePurgeParam;
  PurgeCount: TMagPurgeCount;
  CacheCount: TMagPurgeCount;
  CurrentShare: string[100];
  LogOn: boolean;
  kids,AppVer,DistDate,OSVer,WSID,JOBID, SiteCode, CompName, Server, Port, LogFilePath: string;
  FileCount,FolderCount, DeleteCount, JBQCount, place,IENCount,filetype: integer;
  StartTime: TDateTime;
  StartDate: TDateTime;
  Login: TVistaLogin;
  PurgeLogSize,PurgeErrorLogSize,LogSizeV: integer;
  ErrorLogDate,LogDate: TDATETime;
  AltFileTypeList: TStringList;
  StopButton,SummaryExec,ErrorLogInit,RunOnce: boolean;
  ExpressPurgeLimitReached: boolean;
  Criteria,Shares,LastIEN: string;
  SilentAccess,SilentVerify,VServer,VPort,Division,AUTO,SCHED,RequestedDate: string;
  SelectShareList,Groups: TStringList;
  WSIEN,PurgeType: string ;

const
  AbsType  = '^.abs^';
  TimeLimit = 90;
  rStringHeader = 'Date/Time^Event_Type^Message';
  ErrorStringHeader = 'Date/Time^Event_Type^Message^Path';

  //  logMAX = 5000;

implementation

  uses  MagPerResults,MagWebHelp,MagShowLog,PurgeShareSelect1;

{$R *.DFM}

function TfrmMagPurge.Purge(FilePath: string): boolean;  //Purge(FilePath: string; Hash: Boolean): boolean;
function DirCheck(SearchRec: TSearchRec):boolean;
begin
  result := false;
  if (SearchRec.FindData.dwFileAttributes mod 32) div 16 = 1 then
    result := true;
end;
var
  FileRec:TSearchRec;
  index,i,code: integer;
  EvalCriteria,IEN: string;
begin  //Purge
 result := true;
 if FindFirst(FilePath,(faDirectory),FileRec) <> 0 then
    LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^Findfirst failed^'+ FilePath+' '+ FileRec.Name+'^',PurgeLogSize)
  else
    repeat
      if Length(ExtractFilePath(FileRec.name)) > 0 then
        Windows.MessageBox(frmMagPurge.Handle,PChar(FileRec.name),'',MB_SYSTEMMODAL);
      if DirCheck(FileRec) then begin
       inc(FolderCount);
        if ((FileRec.name<>'.') and (FileRec.name<>'..')) then {not self/parent}{and Hash}
            Purge(ExtractFilePath(FilePath)+FileRec.Name+'\*.*');
        end
      else begin // process as image file;
        inc(FileCount);
        lbPaths.Update;
        if FileCount mod 1000 = 0 then GraphicUpdate(CacheCount,PurgeCount);
        // purge txt when last of image filename
        if AltFileTypeList.Find(piece(LowerCase(ExtractFileExt(FileRec.Name)),'.',2),index) and
          (ImageFile(FileRec.Name,IEN)) then begin
          inc(CacheCount.text);
          if AltLastFile(ExtractFilePath(FilePath)+FileRec.Name) then begin
            DeleteFile(ExtractFilePath(FilePath)+FileRec.Name);
            inc(PurgeCount.text);
            inc(DeleteCount);
            if lbPaths.Items.Count > 50 then lbPaths.clear;
            lbPaths.Items.Add(format('%s - %s',[piece(ExtractFilePath(FilePath),
              ExtractFileDrive(FilePath),2)+FileRec.Name,
              DateTimeToStr(FileDate(FileRec))]));
            lbPaths.Update;
            LogFile('log\Purge\Purge.Log',DateTimeToStr(Now)+'^AltLastFile'+ '^'+
              ExtractFilePath(FilePath)+FileRec.Name+' '+
              DateTimeToStr(FileDate(FileRec)),PurgeLogSize);
            end; //If AltLastFile
            continue;
          end; //If LowerCaseExt
      if DeleteCriteria(Criteria,IEN,filetype,FilePath,FileRec,SitePurgeParam.PurgeBy) then begin
        LastIEN := IEN;
        IENCount := 0;  // reset IENCuunt for ExpressPurge
       if DeleteFile(ExtractFilePath(FilePath)+FileRec.Name) then begin
          DelCnt(filetype);
          if (pos('3',piece(criteria,'^',1)) = 0) then
             MagUpdate(FileRec.Name,piece(ExtractFileExt(FileRec.Name),'.',2),piece(Criteria,'^',6),'NET');
          if lbPaths.Items.Count > 50 then lbPaths.clear;
          lbPaths.Items.Add(format('%s - %s',[piece(ExtractFilePath(FilePath),
            ExtractFileDrive(FilePath),2)+ FileRec.Name,DateTimeToStr(FileDate(FileRec))]));
          lbPaths.Update;
          EvalCriteria := StringReplace(MPieceSub(Criteria,'^',1,3),'^','~',[rfReplaceAll]);
          LogFile('log\Purge\Purge.Log',DateTimeToStr(Now)+'^Purge Criteria: '+EvalCriteria+'^'
            +ExtractFilePath(FilePath)+FileRec.Name+' '+ DateTimeToStr(FileDate(FileRec)),PurgeLogSize);
          end   //IF DeleteFile
        else LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^File Delete failure: '
          +ExtractFilePath(FilePath)+FileRec.Name+'^'+SysErrorMessage(GetLastError)+'^',PurgeErrorLogSize);
      end // IF Delete Criteria
      else begin
        if IEN <> LastIEN then begin
          INC(IENCount);
          LastIEN := IEN
          end; // if IEN <> LastIEN ...
        if ((piece(criteria,'^',3) <> 'NMA') and (pos('7',piece(criteria,'^',3)) = 0)) then begin
          val(piece(Criteria,'^',1),i,code);
          if ((code <> 0) or (i < 0)) then begin
            EvalCriteria := StringReplace(MPieceSub(Criteria,'^',1,3),'^','~',[rfReplaceAll]);
            LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^Purge Criteria: '+EvalCriteria+'^NOT PURGED'+ExtractFilePath(FilePath)+FileRec.Name+' '
              +DateTimeToStr(FileDate(FileRec))+'^^',PurgeErrorLogSize);
            end; // if ((code <> 0) or ...
          end; // if piece(criteria,'^',3) <> 'NMA' ...
        end; // else (not) Delete Criteria
     end; //else image file
    Application.ProcessMessages;
    mWait(5);
  if (FileCount mod 10 = 0) or (FolderCount > 10) then TBUpdate;
  if ((IENCount > SitePurgeParam.Rate) and SitePurgeParam.ExpressPurge) then begin
    ExpressPurgeLimitReached := true;
    break;
   end;
  until (StopButton) or (FindNext(FileRec) <> 0);
  FindClose(FileRec);
end;// Purge
procedure TfrmMagPurge.DelCnt(fileType: integer);
begin
  inc(DeleteCount);
  case fileType of
    0: inc(PurgeCount.foreign);
    1: inc(PurgeCount.abs);
    2: inc(PurgeCount.full);
    3: inc(PurgeCount.big) ;
    4: inc(PurgeCount.photoID);
  end;
end; // DelCnt

function TfrmMagPurge.DeleteCriteria(var Criteria: string;var IEN:string;var filetype:integer;
             FPath: string; FileRec: TSearchRec; PurgeBy: string): boolean;
function TimeDifference(days: integer): boolean;  //if #days + DateLastAccessed
  var                                             //<today then true
    SystemTime: TSystemTime;
    FileTA: TDate;
  begin
    result:= false;
    if PurgeBy = 'DATE CREATED' then FileTimeToSystemTime(FileRec.finddata.ftCreationTime,SystemTime);
    if PurgeBy = 'DATE ACCESSED' then FileTimeToSystemTime(FileRec.finddata.ftLastAccessTime,SystemTime);
    if PurgeBy = 'DATE MODIFIED' then FileTimeToSystemTime(FileRec.finddata.ftLastWriteTime,SystemTime);
    with SystemTime do
      FileTA:= EncodeDate(wyear,wmonth,wday);
    if FileTA + days <= date then result := true;
  end;
function Age(ReturnStr: string; FileType:integer): boolean;
begin
  case FileType of
   1: result := TimeDifference(SitePurgeParam.abs_KeepDays);
   2: result := TimeDifference(SitePurgeParam.FULL_KeepDays);
   3: result := TimeDifference(SitePurgeParam.big_KeepDays);
   4: result := TimeDifference(SitePurgeParam.photo_ID);
   else result := false;
  end;  // case
end; //age
var
  ReturnStr,Extension, EvalCriteria: string;
  Action: integer;
  Complete: boolean;
begin  // DeleteCriteria
  result := false;
  ImageFile(FileRec.Name,IEN);
  Extension := LowerCase(ExtractFileExt(FileRec.Name));
  repeat
    Complete:= true;
    RPCBroker1.Param[0].VALUE := ExtractFilePath(FPath);
    RPCBroker1.Param[0].PTYPE := LITERAL;
    RPCBroker1.Param[1].VALUE := FileRec.Name;
    RPCBroker1.Param[1].PTYPE := LITERAL;
    RPCBroker1.Param[2].VALUE := piece(Extension,'.',2);
    RPCBroker1.Param[2].PTYPE := LITERAL;
    RPCBroker1.Param[3].VALUE := CurrentShare;
    RPCBroker1.Param[3].PTYPE := LITERAL;
    RPCBroker1.RemoteProcedure := 'MAGQBP FREF';
    try
      RPCBroker1.Call;       //call
    except
      on E:Exception do begin
        LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^RPC Error: MAGQBP FREF^'+ E.ClassName+' '+E.Message+'^',PurgeErrorLogSize);
        OnException(E);
        Complete := false;
        end; // on E:Exception
    end // try...Except;
  until Complete;
  ReturnStr := RPCBroker1.Results[0];
  Criteria := ReturnStr;
  IEN := piece(ReturnStr,'^',6);
  filetype := StrToInt(piece(ReturnStr,'^',2));
  Action := StrToInt(piece(ReturnStr,'^',1));
  if  (Action <> 0)and(Action <> 3) then
    if not TimeDifference(SitePurgeParam.minimum) then begin
      criteria := '-1^^NMA';
      case fileType of
        0: inc(CacheCount.foreign);
        1: inc(CacheCount.abs);
        2: inc(CacheCount.full);
        3: inc(CacheCount.big);
        4: inc(CacheCount.photoID);
        end;  // case
      exit;
      end;
  case filetype of
    0: inc(CacheCount.foreign);
    1 : inc(CacheCount.abs);
    2 : inc(CacheCount.full);
    3 : inc(CacheCount.big);
    4 : inc(CacheCount.photoID)
    else inc(CacheCount.full);
    end; //case
  case Action of
   -1,-3 : result := false ;
   -2 : begin result := false; inc(JBQCount); end;
   0 : begin result := true; end;
   1 : begin
     if (not FileExists(piece(ReturnStr,'^',5))) or (FileSizeZero(piece(ReturnStr,'^',5))) then begin
       //MagUpdate(FileRec.Name,piece(ExtractFileExt(FPath),'.',2),piece(ReturnStr,'^',6),'JB');
       ReturnStr := ReturnStr + '^'+ JBQueue(piece(ReturnStr,'^',6));
       EvalCriteria := StringReplace(MPieceSub(Criteria,'^',1,3),'^','~',[rfReplaceAll]);
       LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^NOT Purged criteria: '+EvalCriteria+'^NOT PURGED-JUKEBOX QUEUED '+ExtractFilePath(FPath)+FileRec.Name+' '
          +DateTimeToStr(FileDate(FileRec))+'^^',PurgeErrorLogSize);
       end
     else result := Age(ReturnStr,filetype);
     end; //case of 1
   3 :begin   (* unlike other cases...commit file references update here
        data base has references otherwise --- file age criteria ignored -> update RAID reference PRN  *)
        if FileExists(piece(ReturnStr,'^',4)) and (not FileSizeZero(piece(ReturnStr,'^',4))) then
          result := true // File exists at alternate site leave file references as is
        else CacheUpdate(ExtractFilePath(FPath),FileRec.Name,piece(ReturnStr,'^',6));
      end; //case of 3
   5 :
     begin
       if FileExists(piece(ReturnStr,'^',4)) and (not FileSizeZero(piece(ReturnStr,'^',4))) then begin
         result := true;  // good copy at alternate site (pointed to site)
         end;
       if not FileExists(piece(ReturnStr,'^',5)) or FileSizeZero(piece(ReturnStr,'^',5)) then begin
         MagUpdate(FileRec.Name,piece(ExtractFileExt(FPath),'.',2),piece(ReturnStr,'^',6),'JB');
         SetPiece('-2',ReturnStr,'^',1);
         ReturnStr := ReturnStr + '^'+ JBQueue(piece(ReturnStr,'^',6));
         result := false;
         end;
     end; // case of 5
  end; // Case of Action
end; //TMagPurge.DeleteCriteria
function TfrmMagPurge.ImageFile(FileName:string;var IEN:string):boolean;
var
  prefix,FName: string;
  i,cnt,code,pcount: integer;
begin
  Result:= false;
  IEN := '';
  Fname := piece(Filename,ExtractFileExt(Filename),1);
  prefix := SitePurgeParam.FilePrefix;
  pcount := LastPiecePos(prefix,',');
  if pcount = 0 then inc(pcount) ;
  for cnt := 1 to pcount do begin
    if (pos(piece(prefix,',',cnt),FileName)=1) then begin
      val(piece(Fname,piece(prefix,',',cnt),2),i,code);
      if code = 0 then IEN := IntToStr(i);
      end;
      end;
  if IEN <> '' then result :=true;
end;

procedure TfrmMagPurge.CacheUpdate(filepath,fname,ien: string);
var Complete : boolean;
begin
  repeat
    Complete:= true;
    RPCBroker1.Param[0].VALUE := filepath;
    RPCBroker1.Param[0].PTYPE := LITERAL;
    RPCBroker1.Param[1].VALUE := fname;
    RPCBroker1.Param[1].PTYPE := LITERAL;
    RPCBroker1.Param[2].VALUE := piece(ExtractFileExt(fname),'.',2);
    RPCBroker1.Param[2].PTYPE := LITERAL;
    RPCBroker1.Param[3].VALUE := ien;
    RPCBroker1.Param[3].PTYPE := LITERAL;
    RPCBroker1.RemoteProcedure := 'MAGQ CUPDTE';
    try
      RPCBroker1.Call;       //call
    except
      on E:Exception do begin
        LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^RPC Error in Cache Update: MAGQ CUPDTE^^'+E.Message,PurgeErrorLogSize);
        OnException(E);
        Complete := false;
        end; // on E:Exception
      end // try...Except;
    until Complete;
end; // CacheUpdate

function TfrmMagPurge.FileSizeZero(Path:string): boolean;
var
  SearchRec: TSearchRec;
begin
  FindFirst(Path,faAnyFile,SearchRec);  //get original Last Access Time Stamp
  Result := not (SearchRec.Size>0) ;
  FindClose(SearchRec);
end;

function TfrmMagPurge.Getlist(var ServerList:TStringList; Shares:string): Boolean;
  var
    clbSelectServers: TCheckListBox;
    i: integer;
    temp: string;
    Complete: boolean;
begin
  if pos('SEL',Shares) <> 0 then begin
      Serverlist := TStringList.Create();
      for i := 0 to SelectShareList.Count -1 do ServerList.Add(Piece(SelectShareList[i],' - ',2));
    end
  else begin
    repeat
      Complete:= true;
      RPCBroker1.Param[0].VALUE := Shares;
      RPCBroker1.Param[0].PTYPE := LITERAL ;
      RPCBroker1.RemoteProcedure := 'MAGQBP ALL SHARES';
      try
        RPCBroker1.LSTCALL(ServerList);
      except
        on E:Exception do begin
          LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^EBroker Error in GetList'+'^'+E.Message+'^',PurgeErrorLogSize);
          OnException(E);
          Complete := false;
          end; // on E:Exception
      end // try...Except;
    until Complete;
    end;  // else Shares
      //clbSelectServers := TCheckListBox.Create;
  if ServerList.count > 0 then result := true
  else result:= false;
end; //Getlist

function TfrmMagPurge.MagUpdate(FileName,ext,ien,device: string): Boolean;
  var Complete: boolean;
  begin
    Repeat
      Complete:= true;
      RPCBroker1.Param[0].VALUE := FileName;
      RPCBroker1.Param[0].PTYPE := LITERAL;
      RPCBroker1.Param[1].VALUE := ext;
      RPCBroker1.Param[1].PTYPE := LITERAL;
      RPCBroker1.Param[2].VALUE := ien;
      RPCBroker1.Param[2].PTYPE := LITERAL;
      RPCBroker1.Param[3].VALUE := device;
      RPCBroker1.Param[3].PTYPE := LITERAL;
      RPCBroker1.RemoteProcedure := 'MAGQBP UPDATE';
      try
        RPCBroker1.Call;       //call
      except
        on E:Exception do begin
          LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^EBroker Error in PurgeUpdate^'+E.Message+'^',PurgeErrorLogSize);
          OnException(E);
          Complete := false;
          end; // on E:Exception
        end // try...Except;
    until Complete;
    if piece(RPCBroker1.Results[0],'^',1) = '1' then result := true
    else result := false;
end;

function TfrmMagPurge.PurgeParam:boolean;
var temp: string;
   Complete: boolean;
 begin
   repeat
     Complete := true;
     RPCBroker1.RemoteProcedure := 'MAGQBP PARM';
     try
       RPCBroker1.Call;       //call
      except
        on E:Exception do begin
          LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^EBroker Error in GetQueue^'+E.Message+'^',PurgeErrorLogSize);
          OnException(E);
          Complete := false;
          end; // on E:Exception
        end // try...Except;
   until Complete;
   if StrToInt(piece(RPCBroker1.Results[0],'^',1)) = 1 then begin
     result := true;
     SitePurgeParam.abs_KeepDays := StrToInt(piece(RPCBroker1.Results[0],'^',2));
     SitePurgeParam.full_KeepDays := StrToInt(piece(RPCBroker1.Results[0],'^',3));
     SitePurgeParam.big_KeepDays := StrToInt(piece(RPCBroker1.Results[0],'^',4));
     SitePurgeParam.FilePrefix := piece(RPCBroker1.Results[0],'^',5);
     if piece(RPCBroker1.Results[0],'^',6)= 'ON' then SitePurgeParam.ExpressPurge := true
     else SitePurgeParam.ExpressPurge := false;
     SitePurgeParam.Rate := StrToInt(GetFieldValue('2006.1','60.3',IntToStr(place)+',','E',true)) ;
     // The following code is for the convenience of the tester.  The Data Dictionary
     // does not allow a value below 10,000
     if SitePurgeParam.Rate < 1000 then SitePurgeParam.Rate := 500;
     SitePurgeParam.PurgeBy := piece(RPCBroker1.Results[0],'^',7);
     SitePurgeParam.photo_ID := StrToInt(piece(RPCBroker1.Results[0],'^',8));
     SitePurgeParam.minimum := StrToInt(piece(RPCBroker1.Results[0],'^',9));
     gbPurgeFiles.Caption := 'Purged Files   -   ' + SitePurgeParam.PurgeBy;
     //result := VerifyParam(SitePurgeParam);
     end
   else result := false;
end;
procedure TfrmMagPurge.LogFile(filepath,DataItem:string;var FileSize:integer);
var
  logfile: textfile;
  fPath: string;
begin
  if FileSize + Length(DataItem) > LogSizeV then begin
    LogProc(filepath);
    FileSize := 0;
    end;
  FileSize := FileSize + Length(DataItem);
  fpath := ExtractFilePath(Application.ExeName)+ filepath;
  if not DirectoryExists(ExtractFilePath(fpath))
    then ForceDirectories(ExtractFilePath(fpath));
  if not FileExists(fpath) then FileClose(FileCreate(filepath));
  AssignFile(logfile,fpath);
  Append(logfile);
  Writeln(logfile,DataItem);
  Flush(logfile);
  CloseFile(logfile);
end;// LogFile

procedure TfrmMagPurge.FormCreate(Sender: TObject);
function FileLastWriteDate(FileRec: TSearchRec):TDate;
var
  SystemTime: TSystemTime;
begin
 FileTimeToSystemTime(FileRec.FindData.ftLastWriteTime,
   SystemTime);
 with SystemTime do
   FileLastWriteDate:= EncodeDate(wyear,wmonth,wday);
end;

var
FileRec: TSearchRec;
begin
   if not CheckCmdLine(RPCBroker1) then
     if GetServerInfo(Server, Port)<> mrCancel then begin
       RPCBroker1.Server := Server;
       RPCBroker1.ListenerPort := StrToInt(Port);
       Caption := 'Vista Imaging BP Purge - Started by normal sign-on';
      end
     else halt;
      try
        RPCBroker1.Connected := true;
        if RPCBroker1.Connected then
          if not RPCBroker1.createcontext('MAG WINDOWS') then begin
             Windows.MessageBox(frmMagPurge.Handle,PChar('CC:createcontext("MAG WINDOWS") not be established!'),'',MB_SYSTEMMODAL);
             halt;
             exit;
             end ;
      except
        on E:Exception do begin
           if Assigned(RPCBroker1) then begin
             RPCBroker1.free;
             RPCBroker1 := nil;
             end;
           Windows.MessageBox(frmMagPurge.Handle,PChar('Broker Connection to server could not be established!'),'',MB_SYSTEMMODAL);
           halt;
           exit;
           end;
          end; //try...except
  Application.BringToFront;
  Application.ProcessMessages;
  if FindFirst(Application.ExeName,(faAnyFile),FileRec) = 0 then
    DistDate :=  DateToFMInternal(DateTimeToStr(FileLastWriteDate(FileRec)))
  else DistDate := '';
  FindClose(FileRec);
  AppVer := GetAppVer(Application.ExeName);
  OSVer := GetOSVersion(self);
  CompName := GetCompName(self);
  if not VerifyVersion(self,AppVer,kids) then begin
    if length(kids)= 0 then kids := 'an appropriate version'  ;
    Windows.MessageBox(frmMagPurge.Handle,PChar('The Background Processor client software is version ' + GetAppVer(Application.ExeName)+
        ' .  VistA Imaging Host software does not have '+kids+' installed.  Please update to compatible'+
        ' client and host software.  Shutting down the Background Processor...'),'',MB_SYSTEMMODAL);
    application.Terminate;
    end;
  Application.HelpFile :=ExtractFilePath(Application.ExeName)+'help\mag_bpuserman.htm';
  Application.ShowHint := True;
  application.HintPause :=1000;
  application.HintHidePause := 8000;
  Application.HintColor := clAqua;
  logon:= true;
  init;
  //frmMagPurge.Update;
//  SummaryExec := false;
  place := GetPlace(SiteCode);
  WSIEN:=GetVariable('$S($D(^MAG(2006.8,"C","'+IntToStr(Place)+'","'+CompName+'"))'+
  ':$O(^MAG(2006.8,"C","'+IntToStr(Place)+'","'+CompName+'","0")),1:0)');
  LogFilePath := AssignLogPath(WSIEN);
  LogSizeV := LogSize(CompName);
  Caption := ' '+SiteCode+' VistA Imaging BP Purge by: '+SitePurgeParam.PurgeBy;
  RunOnce := false;
  VServer := RPCBroker1.Server;
  VPort := IntToStr(RPCBroker1.ListenerPort);
  SilentAccess:= GetVariable('$S($D(^MAG(2006.1,"'+IntToStr(place)+'","GW"))'+
    ':$P($G(^MAG(2006.1,"'+IntToStr(place)+'","GW")),U,1),1:0)');
  SilentVerify:= GetVariable('$S($D(^MAG(2006.1,"'+IntToStr(place)+'","GW"))'+
    ':$P($G(^MAG(2006.1,"'+IntToStr(place)+'","GW")),U,2),1:0)');
  SilentAccess := hash.Decrypt(SilentAccess);
  SilentVerify := hash.Decrypt(SilentVerify);
  Division := rpcbroker1.LogIn.Division;
  RPCBrokerTest := TRPCBroker.Create(nil);
  sbtnStop.enabled := false;
  sbtnStart.enabled := true;

end;  //FormCreate
procedure TfrmMagPurge.FormActivate(Sender: TObject);
begin
  {$ifdef Win32}
          SetForegroundWindow(frmMagPurge.Handle);
  {$else}
          BringWindowToTop(frmMagPurge.Handle);
  {$endif}
 if frmMagPurge.Visible then begin
   if sbtnStart.Enabled then sbtnStart.setfocus
   else if sbtnStop.Enabled then sbtnStop.SetFocus;
   end;
 if not RunOnce then
 if (pos('AutoPurge',ParamStr(1)) <> 0) or (pos('SchedPurge',ParamStr(1)) <> 0) then begin
    if pos('AutoPurge',ParamStr(1)) <> 0 then PurgeType := 'Automatic'
    else PurgeType := 'Scheduled';
    Application.BringToFront;
    Application.ProcessMessages;
    RunOnce := true;
    Shares := ParamStr(2);
    AUTO := '1';
    if pos('SchedPurge',ParamStr(1)) <> 0 then SCHED :='1'
    else SCHED := '';
    sbtnStartClick(self);
    Application.ProcessMessages;
    end
 else begin
   PurgeType := 'Manual';
   if shares <> 'SEL' then Shares := 'ALL';
   AUTO := '';
   end;
end;

procedure TfrmMagPurge.init;
var
  ProcList: TStringList;
  Complete: boolean;
begin
  Repeat
    Complete := true;
    ProcList := TStringList.Create;
    RPCBroker1.Param[0].VALUE := CompName+U+AppVer+U+OSVer; //tcp1.LocalHostName;
    RPCBroker1.Param[0].PTYPE := LITERAL ;
    RPCBroker1.Param[1].VALUE := 'Purge';
    RPCBroker1.Param[1].PTYPE := LITERAL ;
    RPCBroker1.RemoteProcedure := 'MAGQ ABP';
    try
      RPCBroker1.LSTCALL(ProcList);
    except
      on E:Exception do begin
        LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^EBroker Error in GetQueue^'+E.Message+'^',PurgeErrorLogSize);
        OnException(E);
        Complete := false;
        ProcList.free;
        end; // on E:Exception
      end // try...Except;
   until Complete;
   WSID := piece(ProcList[0],'^',4)+' - '+piece(ProcList[0],'^',5);
   JOBID := piece(ProcList[0],'^',3);
   ProcList.Free;
   PurgeLogSize := 0;
   PurgeErrorLogSize := 0;
end;
function TfrmMagPurge.ImageDel(IEN:string):boolean;
var
  Value : TStringList;
  Complete: boolean;
begin
  Result := false;
  repeat
    Complete := true;
    Value := TStringList.Create;
    RPCBroker1.Param[0].VALUE :=IEN;
    RPCBroker1.Param[0].PTYPE := LITERAL ;
    RPCBroker1.Param[1].VALUE := '0';
    RPCBroker1.Param[1].PTYPE := LITERAL ;
    RPCBroker1.RemoteProcedure := 'MAGQ DIK';
    try
      RPCBroker1.LSTCALL(Value);
    except
      on E:Exception do begin
        LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^RPC Broker Error in ImageDel^'+E.Message+'^',PurgeErrorLogSize);
        OnException(E);
        Complete := false;
        Value.Free;
        end; // on E:Exception
      end // try...Except;
   until Complete;
  Value.free;
  Result := true;
end; // ImageDel
function TfrmMagPurge.JBQueue(RecNo: string):string;
  var Complete: boolean;
begin
  inc(JBQCount);
  repeat
    Complete := true;
    RPCBroker1.Param[0].VALUE := RecNo;
    RPCBroker1.Param[0].PTYPE := LITERAL;
    RPCBroker1.RemoteProcedure := 'MAGQ JBQUE';
    try
      RPCBroker1.Call;
    except
      on E:Exception do begin
        LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^RPC Broker Error in JBQueue^'+E.Message+'^',PurgeErrorLogSize);
        OnException(E);
        Complete := false;
        end; // on E:Exception
      end // try...Except;
   until Complete;
   JBQueue := RPCBroker1.Results[0];
end; //JBQueue
procedure TfrmMagPurge.sbtnStartClick(Sender: TObject);
var
  ServerIndex,AltIndex: integer;
  ServerList: TStringlist;
  Share: TMagFileServer ;
  Hash: Boolean;
  shareIEN: string;
  responce : integer;
  NewDate,Frequency: string;
  Save_Cursor:TCursor;

begin   // btnPurgeClick
  sbtnStart.Enabled := false;
  sbtnStop.Enabled := true;
  sbtnStop.SetFocus;
  StopButton := false;
  FMUpdate('2006.8','51',WSIEN,AppVer);
  FMUpdate('2006.8','52',WSIEN,DistDate);
  FMUpdate('2006.8','53',WSIEN,OSVer);
  FMUpdate('2006.8','55',WSIEN,DateToFMInternal(DateToStr(Now)));
  InitLogFile('log\purge\Purge.Log',rStringHeader,true);
  InitLogFile('log\purge\PurgeError.Log',ErrorStringHeader,true);
  ErrorLogInit := true;
  InitVariables;
  GraphicUpdate(CacheCount,PurgeCount);
  Application.CreateForm(TfrmPurgeResults,frmPurgeResults);
  frmPurgeResults.Visible := false;
  frmPurgeResults.memResults.Clear;
 // mnuPurgeResults.Enabled := false;
  AltFileType(AltFileTypeList);
  for AltIndex := 0 to AltFileTypeList.Count -1 do begin
    AltFileTypeList[AltIndex] := lowercase(AltFileTypeList[AltIndex]);
    end;
  AltFileTypeList.Sort;
  ServerList := TStringList.Create;
  lbServers.Clear;
  lbServers.Update;
  StartTime := Now ;//Time;
  StartDate := Today;
  if pos('1',SCHED) <> 0 then RequestedDate := ParamStr(3)
  else RequestedDate := DateToFMInternal(DateToStr(StartDate));
  frmMagPurge.Update;
  if PurgeParam and GetList(ServerList,Shares) then begin
    lbPurgeParameters.Clear;
    with SitePurgeParam do begin
      lbPurgeParameters.Items.Add('Site File Prefix: '+ FilePrefix);
      lbPurgeParameters.Items.Add('Abstract keep days: ' + IntToStr(abs_KeepDays));
      lbPurgeParameters.Items.Add('Full keep days: ' + IntToStr(full_KeepDays));
      lbPurgeParameters.Items.Add('Big keep days: ' + IntToStr(big_KeepDays));
      lbPurgeParameters.Items.Add('Photo ID keep days: ' + IntToStr(photo_ID));
      lbPurgeParameters.Items.Add('Minimum keep days: ' + IntToStr(minimum));
      lbPurgeParameters.Items.Add('Purge Criteria: ' + PurgeBy);
      if ExpressPurge then begin
        lbPurgeParameters.Items.Add('Express Purge: ON');
        lbPurgeParameters.Items.Add('Express Purge Rate: '+IntToStr(Rate));
        end // if ExpressPurge
      else lbPurgeParameters.Items.Add('ExpressPurge: OFF');
      end; //with SitePurgeParam
    if not FMUpdate('2006.1','61.1',IntToStr(Place),RequestedDate) then
      LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^Start Date failure^^',PurgeLogSize);
    for ServerIndex := 0 to ServerList.Count-1 do
      if lbServers.Items.IndexOf(ServerList[ServerIndex])= -1 then
      lbServers.items.Add(ServerList[ServerIndex]);
      ServerList.Clear;
    if pos('1',AUTO) = 0 then
      if ((pos('SEL',Shares) <> 0) or (pos('ALL',Shares) <> 0)) then
        if MessageDlg('Do you wish to purge these RAID shares with these parameters?',
          mtConfirmation,[mbOK ,mbNo,mbCancel],0) <> mrOk then begin
            Windows.MessageBox(frmMagPurge.Handle,PChar('Use Edit|Select Shares menu to edit Share list.'),'',MB_SYSTEMMODAL);
            sbtnStart.Enabled := true;
            sbtnStart.SetFocus;
            sbtnStop.Enabled := false;
            lbPurgeParameters.Clear;
            lbServers.Clear;
            exit;
            end;  // MessageDlg
    stStartTimeData.Caption := TimeToStr(StartTime);
    stStartDateData.Caption := DateToStr(StartDate);
    if pos('SEL',Shares) <> 0 then Shares := 'ALL';  // revert to 'ALL' if a manual select share was invoked
   // Share loop
    for ServerIndex := 0 to lbServers.Items.Count - 1 do begin
      lbServers.ItemIndex := ServerIndex;
      ExpressPurgeLimitReached := false;
      lbServers.Update;
      lbpaths.clear;
      lbpaths.update;
      IENCount := 0;
      LastIEN :='';
      CurrentShare := lbServers.Items[ServerIndex]; //piece(ServerList[ServerIndex],'^',1);
     // Hash := (piece(ServerList[ServerIndex],'^',2) = 'Y');
      LogFile('log\Purge\Purge.Log',DateTimeToStr(Now)+'^Begin Purging Share^'+CurrentShare+'^',PurgeLogSize);
      if RightStr(CurrentShare,1) <> '\' then CurrentShare := CurrentShare+'\';
      Purge(CurrentShare+'*.*');    //Purge(CurrentShare+'\*.*',Hash);
      if SitePurgeParam.ExpressPurge and ExpressPurgeLimitReached then
       LogFile('log\Purge\Purge.Log',DateTimeToStr(Now)+'^Express Purge'+ '^'+
        'Express Purge Rate limit reached: '+IntToStr(SitePurgeParam.Rate)+', on share: '+CurrentShare ,PurgeLogSize);
      lbServers.items.strings[ServerIndex] :=
        format('%s - %s',[lbServers.items.strings[ServerIndex],' Purged']);
      LogFile('log\Purge\Purge.Log',DateTimeToStr(Now)+'^Share purge completed^'+CurrentShare,PurgeLogSize);
      //ServerSizeUpdate
        Share.Path := CurrentShare;
        if Diskfree32(Share) then begin
          shareIEN := GetVariable('$S($D(^MAG(2005.2,"G","'+IntToStr(Place)+'","'+CurrentShare+'"))'+
                           ':$O(^MAG(2005.2,"G","'+IntToStr(Place)+'","'+CurrentShare+'","0")),1:0)');
          FMUpdate('2005.2','4',shareIEN,FloatToStr(Share.Space));
          FMUpdate('2005.2','2',shareIEN,FloatToStr(Share.Size));
        end; // DiskFree
      lbServers.Update;
      GraphicUpdate(CacheCount,PurgeCount);
        //init;
      if StopButton then break;
      end; // - Share Loop - for ServerIndex := 0 to lbServers.Items.Count - 1
      end; // if PurgeParam and GetList
  ServerList.Free;
//  if not SummaryExec then Summary;
  TBUpdate;
  Elog(250);
  Summary;
  if pos('1',SCHED) <> 0 then begin//Schedule Next Purge
    Frequency := GetFieldValue('2006.1','61.2',IntToStr(place)+',','E',true);
    if not IsStrANumber(Frequency) then begin
      LogFile('log\Purge\Purge.Log',DateTimeToStr(Now)+'^Scheduled Purge^The Purge Frequency is null.The next purge is NOT scheduled' ,PurgeLogSize);
      NewDate := '';
      end
    else NewDate := GetVariable('$S(1:$$FMADD^XLFDT('+RequestedDate+','+Frequency+',"",""))');
    FMUpdate('2006.1','61.3',IntToStr(Place),NewDate);
    end;
  //log last BP Purge Workstation
  FMUpdate('2006.1','60.4',IntToStr(Place),WSIEN);
  FMUpdate('2006.1','61.1',IntToStr(Place),DateToFMInternal(DateToStr(StartDate)));
  InitLogFile('log\purge\Purge.Log',rStringHeader,true);
  InitLogFile('log\purge\PurgeError.Log',ErrorStringHeader,true);
  if (pos('1',SCHED) <> 0) or (pos('1',AUTO) <> 0) then
    Exit1Click(self);
  sbtnStart.Enabled := true;
  sbtnStart.SetFocus;
  sbtnStop.Enabled := false;
  StopButton := true;

end;  // btnPurgeClick
procedure TfrmMagPurge.Summary;
var
  ResultSummary: TStringList;
  i: integer;
begin
  ResultSummary := TStringList.Create;
  ResultSummary.Add('['+PurgeType+' Purge Run Summary]');
  ResultSummary.Add('  Start Date: '+DateToStr(StartTime));
  ResultSummary.Add('  Start Time: '+TimeToStr(StartTime));
  ResultSummary.Add('  Run Time: '+ stRunTimeData.Caption);
  ResultSummary.Add('  JB Queues: '+ stJBQueuesData.Caption);
  with SitePurgeParam do begin
    ResultSummary.Add('[Purge Site Parameters]');
    ResultSummary.Add('  Site File Prefix: '+FilePrefix);
    ResultSummary.Add('  Abstract keep days: ' + IntToStr(abs_KeepDays));
    ResultSummary.Add('  Full keep days: ' + IntToStr(full_KeepDays));
    ResultSummary.Add('  Big keep days: ' + IntToStr(big_KeepDays));
    ResultSummary.Add('  Photo ID keep days: ' + IntToStr(photo_ID));
    ResultSummary.Add('  Purge Criteria: ' + SitePurgeParam.PurgeBy);
    if SitePurgeParam.ExpressPurge then begin
      ResultSummary.Add('  Express Purge: ON');
      ResultSummary.Add('  Express Purge Term: '+IntToStr(SitePurgeParam.Rate));
      end
    else ResultSummary.Add('  ExpressPurge: OFF');
    end; //with SitePurgeParam
  ResultSummary.Add('[RAID Share Count]');
  ResultSummary.Add('  Total Share Files: '+ IntToStr(FileCount));
  with CacheCount do begin
    ResultSummary.Add('  Total Abstracts: '+ IntToStr(abs));
    ResultSummary.Add('  Total Full: '+IntToStr(full));
    ResultSummary.Add('  Total Big: '+IntToStr(big));
    ResultSummary.Add('  Total Text: '+IntToStr(text));
    ResultSummary.Add('  Photo ID: '+IntToStr(CacheCount.photoID));
    ResultSummary.Add('  Foreign: '+IntToStr(CacheCount.foreign));
    end; // with CacheCount
  ResultSummary.Add('[Purge File Count]');
  ResultSummary.Add('  Total Share Files Deleted: ' + IntToStr(DeleteCount));
  with PurgeCount do begin
    ResultSummary.Add('  Purged Abstracts: '+IntToStr(abs));
    ResultSummary.Add('  Purged Full: '+IntToStr(full));
    ResultSummary.Add('  Purged Big: '+IntToStr(big));
    ResultSummary.Add('  Purged Text: '+IntToStr(text));
    ResultSummary.Add('  Purged Photo ID: '+IntToStr(photoID));
    ResultSummary.Add('  Purged Foreign: '+IntToStr(Foreign));
    end; // with PurgeCount
  if Assigned(Groups) then begin
    ResultSummary.Add('[VistA RAID Groups Purged]');
    for i := 0 to Groups.Count - 1 do ResultSummary.Add(Groups[i]);
    end;
  ResultSummary.Add('[VistA RAID Shares Purged]');
  for i := 0 to lbServers.items.Count - 1 do
    ResultSummary.Add(lbServers.items.strings[i]);
  for i := 0 to ResultSummary.count - 1 do begin
    Logfile('log\Purge\Purge.Log',DateTimeToStr(Now)+'^Result summary^'+ResultSummary[i],PurgeLogSize);
    frmPurgeResults.memResults.Lines.Add(ResultSummary[i]);
    end;
  ResultSummary.Free;
  if pos('1',AUTO) = 0 then
    frmPurgeResults.ShowModal;
  frmPurgeResults.Free;
  frmMagPurge.BringToFront;
//  frmPurgeResults.Visible := true;
//  SummaryExec := true;
 // mnuPurgeResults.Enabled := true;
end; //procedure Summary
procedure TfrmMagPurge.Elog(Limit:integer);
var
  ProcList: TStringList;
  I: integer;
  Complete: boolean;

begin
  repeat
    Complete:= true;
    ProcList := TStringList.Create;
    RPCBroker1.Param[0].VALUE :=IntToStr(Limit);
    RPCBroker1.Param[0].PTYPE := LITERAL ;
    RPCBroker1.RemoteProcedure := 'MAGQ ELOGR';
    try
      RPCBroker1.LSTCALL(ProcList);
    except
      on E:Exception do begin
        LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^RPC Broker Error in Elog^'+E.Message+'^',PurgeErrorLogSize);
        OnException(E);
        Complete := false;
        ProcList.Free;
        end; // on E:Exception
    end; // try...Except;
   if ProcList.Count > 0 then
    for i := 1 to ProcList.Count - 1 do
      LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^'+ProcList.Strings[i],PurgeErrorLogSize);
   if pos('MORE',Proclist[0]) <> 0 then Complete := false;
   ProcList.free;
   until Complete;
end;

function TfrmMagPurge.AltLastFile(FilePath:string): boolean;
var
  SearchRec: TSearchRec;
  WildCard: string;
begin
  Wildcard:=piece(LowerCase(FilePath),LowerCase(ExtractFileExt(FilePath)),1)+'.*';
  case FindFirst(WildCard, faAnyFile, SearchRec) of
   0 : if (LowerCase(ExtractFileExt(SearchRec.Name)) <> LowerCase(ExtractFileExt(FilePath))) or
           (FindNext(SearchRec) = 0) then result := false
       else result := true;
  else result := true;
  end;
  FindClose(SearchRec);
end;
function TfrmMagPurge.FileDate(FileRec: TSearchRec):TDate;
var
  SystemTime: TSystemTime;
begin
 if SitePurgeParam.PurgeBy = 'DATE CREATED' then FileTimeToSystemTime(FileRec.finddata.ftCreationTime,SystemTime);
 if SitePurgeParam.PurgeBy = 'DATE ACCESSED' then FileTimeToSystemTime(FileRec.finddata.ftLastAccessTime,SystemTime);
 if SitePurgeParam.PurgeBy = 'DATE MODIFIED' then FileTimeToSystemTime(FileRec.finddata.ftLastWriteTime,SystemTime);
 with SystemTime do FileDate:= EncodeDate(wyear,wmonth,wday);
end;
procedure TfrmMagPurge.mWait(Amsec:Word);//Millisec Wait
function AddMilSec(ChngeTime:TDateTime; AmSec: word):TDateTime;
var
  hour,min,sec,msec,Asec: word;
  NewTime: TDateTime;
const
  HalfDaySec : word = 43200;
  HourSec : word = 3600;
  MinSec: word = 60;
begin
  NewTime := ChngeTime;
  Asec := AmSec div 1000;
  hour := ASec div HourSec;
  Min := (ASec mod HourSec) div MinSec;
  sec := ((ASec mod HourSec) mod MinSec);
  msec := AmSec mod 1000;
  AddMilSec := NewTime + EncodeTime(hour,min,sec,msec);
end;
var
EndPause: TDateTime;
begin
  EndPause := Now;
  EndPause := AddMilSec(EndPause,AmSec);
  While EndPause > Now do
    {Application.ProcessMessages};
end;
procedure TfrmMagPurge.ErrorLog(Proced,ErrorType,MessageS,EM,Action: String; var FileSize: integer);
var
  logfile: Textfile;
  input: string;
  const u = '^';
begin
  //ErrorValue := GetLastError;
  If not ErrorLogInit then begin
    InitLogFile('log\purge\PurgeError.Log',ErrorStringHeader,true);
    ErrorLogInit := true;
    end;
  input := DateTimeToStr(Now)+u+Proced+u+ErrorType+u+MessageS+u+EM;
  if Length(Action) > 0 then begin
    input := input+u+Action;
    end;
  if FileSize + Length(input) > LogSizeV then begin
    LogProc('log\BackProc\PurgeError.log');
    FileSize := 0;
    end;
  FileSize := FileSize + Length(input);
  AssignFile(logfile,LogFilePath+'log\BackProc\PurgeError.log');
  Append(logfile);
  Writeln(logfile,input);
  Flush(logfile);
  CloseFile(logfile);
end; //  ErrorLog

procedure TfrmMagPurge.TBUpdate;
var
  hours,min,sec,remain,SecsB: Int64;
begin
  SecsB := SecondsBetween(StartTime,Now);
  hours := SecsB div 3600;
  remain := SecsB mod 3600;
  min := remain div 60;
  sec := remain mod 60;
 stRunTimeData.Caption :=IntToStr(hours)+':'+IntToStr(Min)+':'+IntToStr(sec);
 stTotalFilesData.Caption := IntToStr(FileCount);
 stPurgeCountData.Caption := IntToStr(DeleteCount);
 stJBQueuesData.Caption := IntToStr(JBQCount);
 stPurgeCriteriaData.Caption := SitePurgeParam.PurgeBy;
 stIENCountData.Caption := IntToStr(IENCount);
 frmMagPurge.Update;
 FolderCount := 0;
 application.ProcessMessages;
end;
procedure TfrmMagPurge.GraphicUpdate(CacheCount,PurgeCount:TMagPurgeCount);
   begin
     with chrtOriginalServers do begin
       Series1.Clear;
       Series1.Add( CacheCount.abs,'Abstract', clTeeColor );
       Series1.Add( CacheCount.full,'Full Image', clTeeColor );
       Series1.Add( CacheCount.big,'Big', clTeeColor );
       Series1.Add( CacheCount.text,'Text', clTeeColor );
       Series1.Add( CacheCount.photoID,'Photo ID', clTeeColor );
       Series1.Add( CacheCount.foreign ,'Foreign', clTeeColor );
       update;
       end;
     with chrtCachePurge do begin
       Series2.Clear;
       Series2.Add( PurgeCount.abs,'Abstract', clTeeColor );
       Series2.Add( PurgeCount.full,'Full Image', clTeeColor );
       Series2.Add( PurgeCount.big,'Big', clTeeColor );
       Series2.Add( PurgeCount.text,'Text', clTeeColor );
       Series2.Add( PurgeCount.photoID,'Photo ID', clTeeColor );
       Series2.Add( PurgeCount.foreign,'Foreign', clTeeColor );
       update;
       end;
   end;
procedure TfrmMagPurge.InitVariables;
  begin
    with PurgeCount do begin
      abs:=0;
      full:= 0;
      big:=0;
      text:=0;
      photoId := 0;
      foreign := 0;
      end;
    with CacheCount do begin
      abs:=0;
      full:= 0;
      big:=0;
      text:=0;
      photoId := 0;
      foreign := 0;
      end;
    FileCount := 0;
    FolderCount := 0;
    DeleteCount := 0;
    JBQCount :=0;
    IENCount := 0;
    LastIEN :='';
    stStartDateData.Caption := '         ';
    stStartTimeData.Caption := '       ';
    stRunTimeData.Caption := '       ';
    stTotalFilesData.Caption := '       ';
    stPurgeCountData.Caption := '       ';
    stJBQueuesData.Caption := '        ';
    stPurgeCriteriaData.Caption := '            ';
    stIENCountData.Caption := '         ';
    Application.ProcessMessages;
  end;
procedure TfrmMagPurge.SetPiece(SubString: string;var TargetString:string;delimiter:string;piece1:integer);
var
  index: integer;
  temp,temp1: string;
begin
  temp := TargetString;
  TargetString :='';
  temp1 := piece(temp,delimiter,piece1);
  for index := 1 to piece1 -1 do TargetString := TargetString + piece(Temp,delimiter,index)+ delimiter;
  TargetString := TargetString + Substring + copy(temp,(length(TargetString)+length(Temp1))+1,9999);
end;
procedure TfrmMagPurge.logproc(LogFile: string);
begin
  if pos('PurgeError.Log',LogFile) <> 0 then InitLogFile(LogFile,ErrorStringHeader,false)
  else InitLogFile(LogFile,rStringHeader,false);
end;


procedure TfrmMagPurge.sbtnStopClick(Sender: TObject);
begin
  sbtnStart.Enabled := true;
  sbtnStart.SetFocus;
  sbtnStop.Enabled := false;
  StopButton := true;
  frmMagPurge.LogFile('log\Purge\Purge.Log',DateTimeToStr(Now)+'^Stop Button Clicked^',PurgeLogSize);
end;

function TfrmMagPurge.GetPlace(var SiteCode: string):integer;
var i: integer;
  FMGetsPN : TFMGets;
  Lister : TFMLister;
  Complete: boolean;
begin
  repeat
    Complete := true;
    Lister := TFMLister.Create(application);
    Lister.RPCBroker := RPCBroker1;
    Lister.FileNumber := '2006.1';
    Lister.ListerFlags := [lfInternal];
    Lister.FMIndex := '#';
    Lister.FieldNumbers.Clear;
    Lister.FieldNumbers.Add('.01');
    Lister.Screen :='I $D(^MAG(2006.1,"B",+$G(DUZ(2)),Y))';
    try
      Lister.GetList(nil);
    except
      on E:Exception do begin
        LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^EBroker Error in GetPlace'+'^'+E.Message+'^',PurgeErrorLogSize);
        OnException(E);
        Complete := false;
        Lister.Free;
        end; // on E:Exception
      end // try...Except;
    until Complete;
  with Lister do begin
     if results.count = 1 then begin
       GetPlace := StrToInt(Results[0]);
       place := StrToInt(Results[0]);
       end
    else GetPlace := 0;
    end;
  repeat
    Complete:= true;
    FMGetsPN := TFMGets.Create(self);
    FMGetsPN.FileNumber := '2006.1';
    FMGetsPN.FieldNumbers.Clear;
    FMGetsPN.FieldNumbers.Add('.02') ;
    FMGetsPN.RPCBroker := RPCBroker1;
    FMGetsPN.IENS := IntToStr(Place)+',';
    try
      FMGetsPN.GetData;
    except
      on E:Exception do begin
        LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^EBroker Error in GetPlace'+'^'+E.Message+'^',PurgeErrorLogSize);
        OnException(E);
        Complete := false;
        FMGetsPN.Free;
        end; // on E:Exception
      end // try...Except;
    until Complete;
  SiteCode := FMGetsPN.GetField('.02').FMDBExternal;
  FMGetsPN.Free;
end;

procedure TfrmMagPurge.AltFileType(var AltFileTypeList:TStringList);
var Complete: boolean;
begin
  repeat
    Complete := true;
    AltFileTypeList := TStringList.Create;
    RPCBroker1.RemoteProcedure := 'MAGQ FTYPE';
    try
      RPCBroker1.LSTCALL(AltFileTypeList);
    except
      on E:Exception do begin
        LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^EBroker Error in AltFileType'+'^'+E.Message+'^',PurgeErrorLogSize);
        OnException(E);
        Complete := false;
        AltFileTypeList.Free;
        end; // on E:Exception
      end // try...Except;
    until Complete;
end;
function TfrmMagPurge.NumericSegment(Segment: string):integer;
    var
     code: integer;
    begin
     Val(Segment,Result,Code);
     if (code <> 0) then result := 0;
    end;


procedure TfrmMagPurge.mnuAboutClick(Sender: TObject);
var about : TTelaboutf  ;
begin
  about := TTelaboutf.create(self);
  about.showmodal;
  about.free;

end;
procedure TfrmMagPurge.InitLogFile(filepath, Stringheader:string;ArchiveOnly: Boolean);
  procedure NewCreationDate(Path: string);
    var
      NewfileTime : TFileTime;
      TempFileHandle: Integer;
      CurrentSystemTime: TSystemTime;
    begin
      GetLocalTime(CurrentSystemTime);
      if SystemTimeToFileTime(CurrentSystemTime,NewfileTime) then begin
        TempFileHandle := FileOpen(path,fmOpenWrite);
        if not SetFileTime(TempFileHandle,@NewFileTime,nil,nil) then
          if not FileInUse(ExtractFilePath(Application.ExeName)+'log\Purge\PurgeError.Log') then
            if GetLastError > 0 then
              LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+U+'NewCreationDate^SetFileTime Failed '+
                Path+' '+ IntToStr(GetLastError)+ ': '+ SysErrorMessage(GetLastError)+'^',PurgeErrorLogSize);
        FileClose(TempFileHandle);
        end;
   end; // procedure NewCreationDate
  function CreationDate(FileRec: TSearchRec):TDate;
  var
    SystemTime: TSystemTime;
  begin
    FileTimeToSystemTime(FileRec.finddata.ftCreationTime,
     SystemTime);
    with SystemTime do
      CreationDate:= EncodeDate(wyear,wmonth,wday);
  end;
   function DateStringF(Value:Tdate):string;
     var
       DayStr,MonthStr: string;
       Year,Month,Day:word;
     begin
       DecodeDate(value,Year,Month,Day);
       DayStr := RightStr(StringOfChar('0',2) + IntToStr(Day),2);
       MonthStr := RightStr(StringOfChar('0',2) + IntToStr(Month),2);
       result := IntToStr(Year)+ '_'+MonthStr + '_' + DayStr ;
     end;

  function ArchName(DriveDir,FName,FExt: string; OldRec:TSearchRec):string;
    var
      DateString,SeqNumber,TempRec: string;
      FileList: TStringList;
      cnt,i: integer;
      rec: TSearchRec;
    begin
      DateString := DateStringF(ToDay);
      TempRec:='';
      SeqNumber :='';
      if FindFirst(DriveDir+FName+DateString+'*',(faDirectory),Rec) = 0 then begin
        TempRec:= Rec.Name;
        while FindNext(Rec) = 0 do TempRec := Rec.Name;
        FindClose(Rec);
        end; // if FindFirst
      SeqNumber := piece(piece(TempRec,FName+DateString,2),'.',1);
      cnt := NumericSegment(piece(SeqNumber,'_',2));
      inc(cnt);
      SeqNumber := '_'+RightStr(StringOfChar('0',4) + IntToStr(cnt),4);
      Result := DriveDir+FName+DateString+SeqNumber+FExt;
      end;
  function FSize(filepath:string): longint;
    var ftext: textfile;
    begin AssignFile(ftext, filepath);
      Reset(ftext);
      try
        FSize := system.FileSize(ftext);
      finally
        CloseFile(ftext);
      end;// try..finally
    end; // function FSize
  procedure ArchiveFile(ArchPath,WSDriveDir,Filepath,FName,FExt: string;AlwaysNew: boolean);
    var
      FileRec:TSearchRec;
      ExeProcessInfo: TProcessInformation;
      NewName,EMessage,params: string;
      LastError: integer;
    begin
      if FindFirst(WSDriveDir+FName+'*',(faDirectory),FileRec) = 0 then begin //Archive
        if ((CreationDate(FileRec) <> Date) or AlwaysNew) then begin
          NewName := ArchName(ArchPath,FName,FExt,FileRec);
          FindClose(FileRec);
          if not RenameFile(WSDriveDir+ FName+FExt,NewName) then begin
            EMessage :=DateTimeToStr(Now)+U+'InitLogFile ^Problem renaming log file: '+WSDriveDir+ filepath+' -> '+NewName;
            LogFile('log\Purge\PurgeError.Log',EMessage+'^',PurgeErrorLogSize);
            LastError:= GetLastError;
            EMessage :=DateTimeToStr(Now)+U+'Last Error'+U+IntToStr(LastError)+': '+SysErrorMessage(LastError);
            LogFile('log\Purge\PurgeError.Log',EMessage+'^',PurgeErrorLogSize);
            end  // if not RenameFile
          else begin  // Successful rename - Archive step
            params := char(34)+newname+char(34)+ ' '+ char(34)+ExtractFilePath(Archpath)+piece(ExtractFileName(newname),'.',1)+'.html'+ char(34)+' '+ StringHeader + ' '+'../../linked.css' + ' '+'^';
            ExecNewProcess('MagHTMLArchive.exe '+params,true);
            application.ProcessMessages;
            DeleteFile(newname);
            application.ProcessMessages;
            end; // else ...Archive
          end; // if ((CreationDate(FileRec) <> Date)
        end //if FindFirst
      else FindClose(FileRec);
    end; //procedure ArchiveFile
  function CheckFilepath(var filepath,ArchPath:string):Boolean;
   // Initializes directory for the designated Share path for archival Log files (html)
   // Inititalizes the Archival path and the log path if one does not exist.
   // defaults to local workstation especially when the network destination filas
   var logfile: textfile;
      EMessage : string;
   begin // CheckFilepath
     result := true;
     Archpath := LogFilePath+filepath;
     //Update local creation date
     if not fileExists(ExtractFilePath(Application.ExeName)+filepath) then begin
        AssignFile(logfile,ExtractFilePath(Application.ExeName)+filepath);
        Rewrite(logfile);
        CloseFile(logfile);
        EMessage :=DateTimeToStr(Now)+U+'InitLogFile ^A new logfile is created: '+ExtractFilePath(Application.ExeName)+filepath;
        frmMagPurge.LogFile('log\Purge\Purge.Log',EMessage,PurgeLogSize);
        end;
     //test remote read/write access
     try
      if not DirectoryExists(ExtractFilePath(LogFilePath+filepath))
        then if not SysUtils.ForceDirectories(ExtractFilePath(LogFilepath+Filepath)) then begin
           EMessage :=DateTimeToStr(Now)+U+'CheckFilePath^GetLastError: '+IntToStr(GetLastError)+' '+
             SysErrorMessage(GetLastError)+' '+ExtractFilePath(LogFilepath+filepath);
           frmMagPurge.LogFile('log\Purge\PurgeError.Log',EMessage+'^',PurgeLogSize);
           end;
      if fileExists(LogFilepath+filepath) then begin
        {$I-}
        AssignFile(logfile,LogFilepath+filepath);
        FileMode := 2;  {Set file access to Read/Write }
        Reset(logfile);
        CloseFile(logfile);
       {$I+} // if one exists then leave it alone this is only a test
       CheckFilepath := (IOResult = 0) and (LogFilepath+filepath <> '');
        end  // if fileExists(
      else begin
        AssignFile(logfile,LogFilePath+filepath);
        Rewrite(logfile);
        CloseFile(logfile);
        DeleteFile(LogFilePath+filepath); // post test cleanup
        end; // if not fileExists(
     except
       Archpath := ExtractFilePath(Application.ExeName)+filepath;
       EMessage :=DateTimeToStr(Now)+U+'CheckFilePath^Log File Archival reset to: '+Archpath+
         ' instead of: '+ExtractFilePath(LogFilepath+filepath);
       frmMagPurge.LogFile('log\Purge\PurgeError.Log',EMessage+'^',PurgeLogSize);
       result := false;
       end; // try...except
     if fileinuse(ExtractFilePath(Application.ExeName)+filepath) then begin
       EMessage :=DateTimeToStr(Now)+U+'CheckFilePath^File in use: '+ExtractFilePath(LogFilepath+filepath);
       frmMagPurge.LogFile('log\Purge\PurgeError.Log',EMessage+'^',PurgeLogSize);
       end // if fileinuse(
     else
        begin
        application.ProcessMessages;
        NewCreationDate(ExtractFilePath(Application.ExeName)+filepath);
        end;
   end; // CheckFilepath
 var
   FName,FExt,emessage,ArchPath,WSFilePath: string;
   LastError: integer;
   logfile: textfile;
  begin  //procedure TfrmMagPurge.InitLogFile
    // log files on local machine and archive on designated remote
    // "ArchPath" is the archival (html) designated path
    // "WS" is the local log path
    WSFilePath := ExtractFilePath(Application.ExeName)+ filepath;
    FExt := ExtractFileExt(WSFilePath);
    FName := piece(ExtractFileName(WSFilePath),ExtractFileExt(WSFilePath),1);
    if not DirectoryExists(ExtractFilePath(WSFilePath))
      then ForceDirectories(ExtractFilePath(WSFilePath));
    Checkfilepath(filepath,ArchPath);
    //DriveDir := ExtractFilePath(ArchPath); // local if network out
    //Archive Process
    if FileExists(WSFilePath) then if FSize(WSFilePath) <> 0 then
      ArchiveFile(ExtractFilePath(ArchPath),ExtractFilePath(WSFilePath),Filepath,FName,FExt,true);
    if not ArchiveOnly then if not fileExists(ExtractFilePath(Application.ExeName)+ filepath) then begin
      AssignFile(logfile,ExtractFilePath(Application.ExeName)+ filepath);
      Rewrite(logfile);
      CloseFile(logfile);
      NewCreationDate(ExtractFilePath(Application.ExeName)+ filepath);
      end; // if not fileExists(
  end; //procedure TfrmMagPurge.InitLogFile
procedure TfrmMagPurge.ExecNewProcess(ProgramName : String; Wait: Boolean);
   var
  StartInfo : TStartupInfo;
  ProcInfo : TProcessInformation;
  CreateOK : Boolean;
  Emessage: string;
begin
    { fill with known state }
  FillChar(StartInfo,SizeOf(TStartupInfo),#0);
  FillChar(ProcInfo,SizeOf(TProcessInformation),#0);
  StartInfo.cb := SizeOf(TStartupInfo);
  CreateOK := CreateProcess(nil, PChar(ProgramName), nil, nil,False,
              CREATE_NEW_PROCESS_GROUP+NORMAL_PRIORITY_CLASS,
              nil, nil, StartInfo, ProcInfo);
    { check to see if successful }
  if CreateOK then
    begin
        //may or may not be needed. Usually wait for child processes
      if Wait then
        WaitForSingleObject(ProcInfo.hProcess, INFINITE);
    end
  else
    begin
      EMessage :=DateTimeToStr(Now)+U+'Create Process failed'+ProgramName;
      LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+U+'ExecNewProcess'+U+EMessage+'^',PurgeErrorLogSize);
      ErrorLog('ExecNewProcess','Create Process failed',ProgramName,'','',PurgeErrorLogSize);
     end;
  CloseHandle(ProcInfo.hProcess);
  CloseHandle(ProcInfo.hThread);
end;


procedure TfrmMagPurge.Content1Click(Sender: TObject);
begin
  Application.CreateForm(TfrmMagBPHelp,frmMagBPHelp);
  frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+'help\MAG_BP_User_Manual.htm#_Toc315345043');
  frmMagBPHelp.Caption := 'BP Purge Help';
end;

procedure TfrmMagPurge.Exit1Click(Sender: TObject);
begin
  PostMessage(self.handle, WM_CLOSE, 0, 0);
  frmMagPurge.Close;
  Application.ProcessMessages;
end;
function TfrmMagPurge.VerifyVersion(Sender: TObject;  AppVersion: string; var kids:string): boolean;
var
  VERS,Data: string;
  Complete: boolean;
  begin
    result := false;
    Data := '';
    VERS := piece(AppVersion,'.',1) + '.' + piece(AppVersion,'.',2)+ 'P'+ piece(AppVersion,'.',3);
    repeat
      Complete:= true;
      RPCBroker1.RemoteProcedure := 'MAGQ VOK';
      RPCBroker1.Param[0].Value := VERS;
      RPCBroker1.Param[0].PType := LITERAL;
      try
        RPCBroker1.Call;
      except
        on E:Exception do begin
          LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^EBroker Error in Verify Version'+'^'+E.Message+'^',PurgeErrorLogSize);
          OnException(E);
          Complete := false;
          end; // on E:Exception
        end // try...Except;
    until Complete;
    Data := RPCBroker1.Results[0];
    if pos('1^',data) <> 0 then result := true
    else result := false;
    kids := piece(Data,'^',2)
  end;


procedure TfrmMagPurge.OpenLog1Click(Sender: TObject);
begin
  ShowLog.OpenLogFile(logFilePath+'log\',Self);
end;
function TfrmMagPurge.MPieceSub(SuperString,Delimiter:string;LowerRange,UpperRange:integer):String;
var i: integer;
begin
  result := '';
  for i := LowerRange to UpperRange do begin
    if i <> LowerRange then result := result+Delimiter;
    result := result+piece(SuperString,Delimiter,i);
    end;
end;
function TfrmMagPurge.AssignLogPath(WSIEN:string):string;
// Look at the Win32 API GetFileSecurity() function.
// also GetNamedSecurityInfo to check for network write permissions before returnning the network result.
// Log and return local default
//http://groups.google.com/group/borland.public.delphi.language.delphi.win32/browse_thread/thread/40ecfe40371d89bd
begin
  if StrToInt(WSIEN) > 0 then begin
    result := GetValue('2006.8','49',WSIEN);
    if (pos('-1',piece(result,'^',1)) <> 0) or (Length(Result) < 2) then
      result := ExtractFilePath(Application.ExeName);
    if (GetDriveType(pchar(result)) = DRIVE_REMOTE) then result := result + CompName+'\'
    else if RightStr(result,1) <> '\' then result := result +'\';
    end;
end;

function TfrmMagPurge.LogSize(BPWS:string):integer;
var
  WSIEN,temp: string ;
begin
  WSIEN:=GetVariable('$S($D(^MAG(2006.8,"C","'+IntToStr(Place)+'","'+BPWS+'"))'+
  ':$O(^MAG(2006.8,"C","'+IntToStr(Place)+'","'+BPWS+'","0")),1:0)');
  if StrToInt(WSIEN) > 0 then begin
    temp := GetValue('2006.8','54',WSIEN);
    if temp = '' then temp := '0';
    if pos('-1',temp) <> 0 then temp := '0';
    if not (StrToInt(temp) > 0) then temp := '1';
    result := StrToInt(temp)*1000000;
    end
  else result:=1000000;

end;
function TfrmMagPurge.GetVariable(GetLogic:string):string;
  var
    data: string;
    Complete: boolean;
begin
  repeat
    Complete:= true;
    result := '';
    RPCBroker1.RemoteProcedure := 'XWB GET VARIABLE VALUE';
    RPCBroker1.Param[0].Value := GetLogic;
    RPCBroker1.Param[0].PType := reference;
    try
      RPCBroker1.Call;
    except
      on E:Exception do begin
        LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^RPC Broker Error in GetVariable^'+E.Message+'^',PurgeErrorLogSize);
        OnException(E);
        Complete := false;
        end; // on E:Exception
      end // try...Except;
   until Complete;
   if RPCBroker1.Results.Count > 0 then Data := RPCBroker1.Results[0]
   else Data :='0';
   result := Data;
end;// function
function TfrmMagPurge.GetValue(Filenumber,FieldNumber,IEN:string):string;
var
  FMGetsPN: TFMGets;
  Complete: boolean;
begin
  repeat
    Complete := true;
    FMGetsPN := TFMGets.Create(self);
    FMGetsPN.FileNumber := Filenumber;
    FMGetsPN.FieldNumbers.Clear;
    FMGetsPN.FieldNumbers.Add(FieldNumber) ;
    FMGetsPN.RPCBroker := RPCBroker1;
    FMGetsPN.IENS := IEN+',';
    try
      FMGetsPN.GetData;
    except
      on E:Exception do begin
        LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^RPC Broker Error in GetValue^'+E.Message+'^',PurgeErrorLogSize);
        OnException(E);
        Complete := false;
        FMGetsPN.Free;
        end; // on E:Exception
      end // try...Except;
   until Complete;
  Result := FMGetsPN.GetField(FieldNumber).FMDBExternal;
  FMGetsPN.Free;
end;

function TfrmMagPurge.AutoLogin(Broker: TRPCBroker;SilentAccess,SilentVerify,VServer,VPort,Division:string; Pause: Integer;Sender:TObject): boolean;
begin
  result := false;
  with Broker do begin
    AccessVerifyCodes := SilentAccess + ';' + SilentVerify;
    server := VServer;
    listenerPort := strtoint(VPort);
    LogIn.Division := Division;
    try try
      connected := true;
      Broker.CreateContext('MAG WINDOWS');
     except
       on E:Exception do
          LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^Login Message^'+E.Message+U,PurgeLogSize);
       end; //try...exception
    finally
      LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^Login Message^Silent Login attempt^',PurgeLogSize);
      if not connected then begin
        LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^Login Message^Broker Reconnection failed^',PurgeLogSize);
        application.Terminate;
        end // if not connected
      else begin
        LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^Login Message^Login Message^Broker Reconnection Successful^',PurgeLogSize);
        FMComponentInit(sender);
        FMComponentInit(self);
        result := true;
        end;
    end; //try...finally
    end; // With Broker
end;
procedure TfrmMagPurge.OnException(E:exception);
begin
   LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^Error on RPCBrokercall^'+E.Message+'^',PurgeLogSize);
   if Assigned(RPCBroker1) then begin
     RPCBroker1.free;
     RPCBroker1 := nil;
     end;
   RPCBroker1 := TRPCBroker.Create(nil);
   if not RPCBroker1.Connected then begin
     if not AutoLogin(RPCBroker1,SilentAccess,SilentVerify,VServer,VPort,Division, 5, SELF) then
       repeat
         LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^Login Message^Silent Login attempt failed!^',PurgeLogSize);
         LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^Login Message^Pausing 3 minutes and will then retry^',PurgeLogSize);
         eftfut.pause(180);
         if Assigned(RPCBroker1) then begin
           RPCBroker1.free;
           RPCBroker1 := nil;
           end;
         RPCBroker1 := TRPCBroker.Create(nil);
       until AutoLogin(RPCBroker1,SilentAccess,SilentVerify,VServer,VPort,Division, 5, SELF);
       end // if not dmMain.RPCBroker1.Connected
     else begin
       LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^Error Message^Non-Connection related Broker error^',PurgeLogSize);
       end; // else
end;
procedure TfrmMagPurge.FMComponentInit(Sender: TObject);
var i: integer;
begin
  for i := 0 to (Sender as TComponent).ComponentCount - 1 do begin
    if (pos('TFM',(Sender as TComponent).Components[i].ClassName)= 1) then begin
      if ((Sender as TComponent).Components[i] is TFMLister) then
        ((Sender as TComponent).Components[i] as TFMLister).RPCBroker := RPCBroker1;
      if ((Sender as TComponent).Components[i] is TFMGets) then
        ((Sender as TComponent).Components[i] as TFMGets).RPCBroker := RPCBroker1;
      if ((Sender as TComponent).Components[i] is TFMValidator) then
        ((Sender as TComponent).Components[i] as TFMValidator).RPCBroker := RPCBroker1;
      if ((Sender as TComponent).Components[i] is TFMFiler) then
        ((Sender as TComponent).Components[i] as TFMFiler).RPCBroker := RPCBroker1;
      if ((Sender as TComponent).Components[i] is TFMFindOne) then
        ((Sender as TComponent).Components[i] as TFMFindOne).RPCBroker := RPCBroker1;
      if ((Sender as TComponent).Components[i] is TFMFinder) then
        ((Sender as TComponent).Components[i] as TFMFinder).RPCBroker := RPCBroker1;
      if ((Sender as TComponent).Components[i] is TFMHelp) then
        ((Sender as TComponent).Components[i] as TFMHelp).RPCBroker := RPCBroker1;
      end;
    end;

end;

function TfrmMagPurge.FMUpdate(FNum,FldNum,IENS,Value:string):boolean;
var
  filer: TFMFiler;
  Complete: boolean;
begin
  result := true;
  repeat
    Complete:= true;
    filer := TFMFiler.Create(self);
    filer.RPCBroker := RPCBroker1;
    Filer.AddFDA(FNum,IENS+',',FldNum,Value);
    try
      filer.Update;
    except
      on E:Exception do begin
        LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^RPC Broker Error in FMUpdate^'+E.Message+'^',PurgeErrorLogSize);
        OnException(E);
        Complete := false;
        filer.Free;
        end; // on E:Exception
      end // try...Except;
   until Complete;
   if filer.ErrorList.Count < 0 then begin
     filer.DisplayErrors;
     Result := false;
     end;
   filer.Free;
end;
function TfrmMagPurge.GetFieldValue(FNum,FldNum,IENS,Flag:string;silent:boolean): string;
    var RList: tstringlist;
            i : integer;
         Complete: boolean;
  begin
    repeat
      Complete := true;
      RPCBroker1.RemoteProcedure := 'DDR GETS ENTRY DATA';
      RList := TStringList.Create;
      RPCBroker1.Param.Clear;
      with RPCBroker1.Param[0] do begin
        Value  := '.DDR';
        Ptype  := list;
        Mult['"FILE"']  := FNum;
        Mult['"IENS"']  := IENS;
        Mult['"FIELDS"'] := FldNum;
        Mult['"FLAGS"'] := Flag;
        end; // with RPCBroker1.Param[0]
      try
        RPCBroker1.LSTCALL(rlist);
      except
        on E:Exception do begin
          LogFile('log\Purge\PurgeError.Log',DateTimeToStr(Now)+'^RPC Broker Error in GetFieldValue^'+E.Message+'^',PurgeErrorLogSize);
          OnException(E);
          Complete := false;
          Rlist.Free;
          end; // on E:Exception
        end // try...Except;
    until Complete;
    if RList[0]='[Data]' then begin
      if flag = 'I' then result := piece(RList[1],U,4)
      else result := piece(RList[1],U,5);
      end
    else Result := '';
   //end;
   if Result = '' then
       for i := 0 to Rlist.Count -1 do begin
          if pos('BEGIN_diERRORS',rlist[i]) <> 0 then
            if not silent then
              if (i+6) <= (rlist.Count -1) then
                Windows.MessageBox(frmMagPurge.Handle,PChar(rlist[i+6]),'',MB_SYSTEMMODAL);
           end;
   RList.Free;
   RPCBroker1.Param.Clear;
   end;

function TfrmMagPurge.FileInUse(FileName: string): Boolean;
     var hFileRes: HFILE;
     begin
       Result := False;
       if not FileExists(FileName) then exit;
      hFileRes := CreateFile(PChar(FileName),GENERIC_READ or GENERIC_WRITE,0,
                               nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
      Result := (hFileRes = INVALID_HANDLE_VALUE);
      if not Result then CloseHandle(hFileRes);
     end; //  function FileInUse

function TfrmMagPurge.DateToFMInternal(ExDate:string):string;
begin
  result := IntToStr(YearOf(StrToDate(ExDate))-1700)+
        RightStr('0'+IntToStr(MonthOf(StrToDate(ExDate))),2)+
        RightStr('0'+IntToStr(DayOf(StrToDate(Exdate))),2);
end;

procedure TfrmMagPurge.muuSelectSharesClick(Sender: TObject);
begin
  frmPurgeShareSelect.ShowModal;
end;

function TfrmMagPurge.DiskFree32(var FileServer: TMagFileServer): Boolean;
function spcopy(input:string): LPSTR;
var size:integer;
begin
  size:=length(input);
  result:=stralloc(size+1);
  strpcopy(result,input);
end;//DiskFree.spcopy

var
  GetDiskfreeSpaceEx: Function(lpDirectoryName: string;
                    var lpFreeBytesAvailableToCaller,
                      lpTotalNumberOfBytes,
                      lpTotalNumberOfFreeBytes: Int64): Bool; STDCALL;
  ServerPath:string;
  hlib: THandle;
   FreeBAU,TotNumBytes,TotNumFree: Int64;
begin
  hlib := GetModuleHandle('kernel32');
  if hlib <> 0 then
    begin
      GetDiskFreeSpaceEx := GetProcAddress(hlib, 'GetDiskFreeSpaceExA');
      ServerPath := FileServer.Path;
      result := GetDiskFreeSpaceEx(ServerPath,FreeBAU,TotNumBytes,TotNumFree);
      with FileServer do begin
        size := TotNumBytes div 1000000000;
        space := TotNumFree div 1000000000;
        used :=  (TotNumBytes - TotNumFree) div 1000000000;
        end;
    end
  else result:= false;
  if not FreeLibrary(hlib) then
    Windows.MessageBox(frmMagPurge.Handle,PChar('not FreeLibrary:'+IntToStr(GetLastError)),'',MB_SYSTEMMODAL);
end;

procedure TfrmMagPurge.mnuPrintResultsClick(Sender: TObject);
begin
  with PrintDialog1 do begin
   if Execute then begin
     chrtOriginalServers.Print;
     chrtCachePurge.Print;
     end; //if Execute
    end; //with PrintDialog1
end;

procedure TfrmMagPurge.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Exit1Click(Sender);
end;

procedure TfrmMagPurge.FormPaint(Sender: TObject);
begin
(*
    stStartDateData.caption := '';
    stRunTimeData.caption := '';
    stTotalFilesData.caption := '';
    stPurgeCountData.caption := '';
    stJBQueuesData.caption := '';
    stIENCountData.caption := '';
    stPurgeCriteriaData.caption := '';
    *)
end;
function TfrmMagPurge.IsStrANumber(const S: string): Boolean;
  var
    P: PChar;
  begin
    P      := PChar(S);
    Result := False;
    if P^ = #0 then Exit;
    while P^ <> #0 do
    begin
      if not (P^ in ['0'..'9']) then Exit;
      Inc(P);
    end;
    Result := True;
  end; // IsStrANumber


end.

