unit FmagDateTimeDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls, Grids, Calendar, Buttons, ExtCtrls,
  maggut1, DateUtils, types,MFunStr;

type
  TfrmDateTimeDialog = class(TForm)
    trckbarHour: TTrackBar;
    trckbarMin: TTrackBar;
    lbTime: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    lstHour: TListBox;
    Panel1: TPanel;
    cal: TMonthCalendar;
    Image2: TImage;
    Image1: TImage;
    edtTime: TEdit;
    lbDate: TLabel;
    btnOK: TBitBtn;
    btncancel: TBitBtn;
    Label3: TLabel;
    lstMin: TListBox;
    lbampm: TLabel;
    lbampm2: TLabel;
    procedure trckbarHourChange(Sender: TObject);
    procedure trckbarMinChange(Sender: TObject);
    procedure Image2Click(Sender: TObject);
    procedure calClick(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure lstHourClick(Sender: TObject);
    procedure lstMinClick(Sender: TObject);
    procedure edtTimeChange(Sender: TObject);
  private
    FignHour,
    FignMin,
    FMinMove : boolean;
    FHrMove : boolean;
    procedure SetDate(vdate: string);
    procedure SetTime(vTime: string);{ Private declarations }
  public
    function execute(var vDateTime: string; var dDateTime : Tdatetime): boolean;overload;
    function execute(pt : Tpoint; var vDateTime: string; var dDateTime : Tdatetime): boolean;overload;

    { Public declarations }
  end;

var
  frmDateTimeDialog: TfrmDateTimeDialog;

implementation

{$R *.DFM}

function TfrmDateTimeDialog.execute(var vDateTime: string; var dDateTime : Tdatetime): boolean;
VAR vpt : Tpoint;
begin
vpt.X := 0;
vpt.Y := 0;
result := execute(vpt,vDateTime,dDateTime);
end;



function TfrmDateTimeDialog.execute(pt : Tpoint; var vDateTime: string; var dDateTime : Tdatetime): boolean;
var rdttm : TdateTime;
begin
application.CreateForm(TfrmDateTimeDialog,frmDateTimeDialog);
if pt.X > 0 then
   begin
   with frmDateTimeDialog do
   begin
   Left := pt.X + 5;
   if Left > screen.Width then Left := screen.Width - Width;
   top := pt.Y - ( height div 2) ;
   if top < 0 then top := 5;
   end;
   end;
with frmDateTimeDialog do
  begin
    if vDateTime = ''
       then
         begin
         rDttm := now;
         SetDate(formatdatetime('mm/dd/yyyy',rdttm));
         settime(formatdatetime('hh:mm',rdttm));
         end
         else
         begin
         SetDate(magpiece(vDateTime,'@',1));
         SetTime(magpiece(vDateTime,'@',2));
         end;
    showmodal;
    if lbtime.caption = '00:00'
       then vDateTime := lbDate.caption
       else vDateTime := lbDate.caption+'@'+lbTime.caption;
       dDateTime := strtodatetime(lbDate.caption + ' '+ lbTime.caption);
     result := modalresult = mrok;
  end;
end;

procedure TfrmDateTimeDialog.trckbarHourChange(Sender: TObject);
var s1,s2 : string;
hr : integer;
begin
 if FignHour then begin FignHour := false; exit; end;
   if not fminmove then    FhrMove := true
   else exit;
   trckbarMin.Position := trckbarHour.position mod 12;
   lstMin.ItemIndex := trckBarMin.Position;
    hr := trckbarHour.position div 12;
    lstHour.ItemIndex := hr;
    s1 := inttostr(trckbarHour.position div 12);
    s2 := inttostr(trckbarMin.position * 5);

    if length(s1) = 1 then s1 := '0' + s1;
    if length(s2) = 1 then s2 := '0' + s2;

   lbTime.caption := s1 + ':' + s2;
   Fhrmove := false;
   lbTime.update;
   edtTime.Text := lbTime.caption;
end;

procedure TfrmDateTimeDialog.trckbarMinChange(Sender: TObject);
var s1,s2 : string;
i1,hr : integer;
begin
 if FignMin then begin FignMin := false; exit; end;
    if not fhrmove then fminmove := true
    else exit;
    i1 := (trckbarHour.position div 12) * 12 ;
    hr := i1 div 12;
    lstHour.ItemIndex := hr;
    lstHour.Update;
    s1 := inttostr(i1 div 12);
    lstMin.ItemIndex := trckbarMin.Position;
   trckbarHour.Position := trckbarMin.position + i1;

    s2 := inttostr(trckbarMin.position * 5);


    if length(s1) = 1 then s1 := '0' + s1;
    if length(s2) = 1 then s2 := '0' + s2;
   lbTime.caption := s1 + ':' + s2;
   fminmove := false;
   lbTime.update;
   edtTime.Text := lbTime.caption;
end;

procedure TfrmDateTimeDialog.Image2Click(Sender: TObject);
begin
cal.Date := now;
SetDate(formatdatetime('mm/dd/yyyy',now));
SetTime(formatDateTime('hh:mm',now));
end;

procedure TfrmDateTimeDialog.calClick(Sender: TObject);
// works okay, not needed here
//var dtcmp : TValueRelationship;
begin

//dtcmp := CompareDate(now,cal.date);

SetDate(formatDatetime('mm/dd/yyyy',cal.Date));
//SetTime('00:00');
end;

procedure TfrmDateTimeDialog.Image1Click(Sender: TObject);
begin
//cal.Date := now;
//SetDate(formatdatetime('mm/dd/yyyy',now));
SetTime('23:59') ; //formatDateTime('hh:mm',now);
end;

procedure TfrmDateTimeDialog.SetDate(vdate: string);
begin
  lbDate.caption := vdate;
  if Vdate <> '' then   cal.date := strtodate(vdate);
end;

procedure TfrmDateTimeDialog.SetTime(vTime: string);
var hr,min : string;
//hrii : string;
minii : integer;
begin
if vtime = '' then vTime := '00:00';
  lbTime.caption := vtime;
  edtTime.Text := vTime;
  hr := magpiece(vtime,':',1);
  if pos('0',hr)=1 then hr := copy(hr,2,99);
  if lstHour.Items.IndexOf(hr) = -1 then hr := '0';

  //hrii :=
  lstHour.ItemIndex := lstHour.Items.IndexOf(hr);
  FignHour := true;
  trckbarHour.Position := lstHour.itemindex * 12;


  min := magpiece(vtime,':',2);
  if pos('0',min)=1 then min := copy(min,2,99);
  minii := strtoint(min) div 5 ;

  if minii <> trckbarMin.Position then
    begin
    lstMin.ItemIndex := minii;
     FignMin := true;
     trckbarMin.Position := minii;
    end;
 // if lstMin.Items.IndexOf(min) > -1 then
  //  begin
     ////hrii :=
  //   lstMin.ItemIndex := lstMin.Items.IndexOf(min);
  //   end;

end;

procedure TfrmDateTimeDialog.lstHourClick(Sender: TObject);
var hri : integer;
//    hrs : string;
begin
  hri := lstHour.ItemIndex;
  trckbarHour.Position := hri*12;
  trckBarMin.Position := trckBarMin.Min;

end;

procedure TfrmDateTimeDialog.lstMinClick(Sender: TObject);
var mini : integer;
begin
mini := lstMin.ItemIndex;
trckbarMin.Position := mini;


end;

procedure TfrmDateTimeDialog.edtTimeChange(Sender: TObject);
var ap,hrs : string;
     hri : integer;
begin
hrs := magpiece(edttime.text,':',1);
try
hri := strtoint(hrs);
except
hri := 0;
end;

if hri > 12 then
  begin
    ap := ' pm';
    hri := hri mod 12;
  end
  else
   ap := ' am';


lbampm.caption := '( '+inttostr(hri)+':'+piece(edttime.Text,':',2)+ ap + ' )';
lbampm2.caption := lbampm.Caption;

end;

end.
