unit MAGJHRPT;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: BP Queue Processor JBTOHD Report
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls,Printers;

type
  TfrmMagJHRPT1 = class(TForm)
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    mnuNew1: TMenuItem;
    mnuOpen1: TMenuItem;
    mnuSave1: TMenuItem;
    ListBox1: TListBox;
    mnuExit1: TMenuItem;
    Help1: TMenuItem;
    procedure mnuNew1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure mnuSave1Click(Sender: TObject);
    procedure mnuOpen1Click(Sender: TObject);
    procedure mnuExit1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Help1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMagJHRPT1: TfrmMagJHRPT1;
  report: TStringList;
implementation

{$R *.DFM}
 uses Magbtm1, UnitDM, magWebHelp;
procedure TfrmMagJHRPT1.mnuNew1Click(Sender: TObject);
var
 // report: TStringList;
  i: integer;
begin
   dmMain.RPCBroker1.RemoteProcedure := 'MAGQ JH RPT';
   dmMain.RPCBroker1.LSTCALL(Report);
   ListBox1.Items.Clear;
   for i := 0 to report.Count - 1 do ListBox1.Items.add(report.strings[i]);
   ListBox1.Update;
end;

procedure TfrmMagJHRPT1.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ListBox1.Items.Clear;
  report.Clear;
  MAGBTMF1.mnuJHRPT.checked := false;
  frmMagJHRPT1.ModalResult := mrCancel;
  Action := caFree;
end;

procedure TfrmMagJHRPT1.mnuSave1Click(Sender: TObject);
begin
 SaveDialog1.Title :='Save info for JBTOHD queue back log';
 SaveDialog1.Filter := 'Text files (*.txt)|*.TXT';
 SaveDialog1.Options := [ofOverwritePrompt]	;
 SaveDialog1.InitialDir := MAGBTM1.LogFilePath;
 if SaveDialog1.Execute then Report.SaveToFile(SaveDialog1.FileName);


end;


procedure TfrmMagJHRPT1.mnuOpen1Click(Sender: TObject);
var
 i: integer;
begin
 OpenDialog1.Title :='JBTOHD queue back log';
 OpenDialog1.Filter := 'Text files (*.txt)|*.TXT';
 OpenDialog1.Options := [ofReadOnly, ofFileMustExist]	;
 OpenDialog1.InitialDir := MAGBTM1.LogFilePath;
 if OpenDialog1.Execute then begin
   //SetWindowPos(OpenDialog1.handle,HWND_TOPMOST, 0,0,0,0, SWP_NOSIZE or SWP_NOMOVE);
   Report.LoadFromFile(OpenDialog1.FileName);
   ListBox1.Items.Clear;
   for i := 0 to report.Count - 1 do ListBox1.Items.add(report.strings[i]);
   ListBox1.Update;
   end;
end;

procedure TfrmMagJHRPT1.mnuExit1Click(Sender: TObject);
begin
  frmMagJHRPT1.Close;
end;

procedure TfrmMagJHRPT1.FormCreate(Sender: TObject);
begin
  report := TStringList.Create;
  mnuNew1Click(SELF);
  Caption := Format('%s - %s - %s', ['JBTOHD Report' ,TimeToStr(Now),'Currently Active Jukebox to Harddisk Queues']);

end;

procedure TfrmMagJHRPT1.Help1Click(Sender: TObject);
begin
  Application.CreateForm(TfrmMagBPHelp,frmMagBPHelp);
  frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
 'help\MAG_BP_User_Manual.htm#_Toc315345017');
end;

procedure TfrmMagJHRPT1.FormActivate(Sender: TObject);
begin
  {$ifdef Win32}
          SetForegroundWindow(frmMagJHRPT1.Handle);
  {$else}
          BringWindowToTop(frmMagJHRPT1.Handle);
  {$endif}
end;

end.
