unit MAGNetLoc2;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: Main BP Queue Processor
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls,Fmcmpnts,Diaccess,DiTypLib,Fmlookup, Trpcb, StdCtrls,
  ExtCtrls, ImgList, ShellCtrls, Buttons,MFunStr, Menus;

type
  TfrmNetworkLoc = class(TForm)
    pagecontrol1: TPageControl;
    tsRAID: TTabSheet;
    tsJUKEBOX: TTabSheet;
    tsRouters: TTabSheet;
    tsGCC: TTabSheet;
    tsEKG: TTabSheet;
    tsURL: TTabSheet;
    tsDiagrams: TTabSheet;
    ImageList1: TImageList;
    tvRAIDGroups: TTreeView;
    Panel1: TPanel;
    rgListViewStyle: TRadioGroup;
    Splitter1: TSplitter;
    FMLookUp1: TFMLookUp;
    FMFindOne1: TFMFindOne;
    FMFiler1: TFMFiler;
    bbtnOK: TBitBtn;
    bbtnCancel: TBitBtn;
    btnApply: TBitBtn;
    bbtnHelp: TBitBtn;
    PopupMenu1: TPopupMenu;
    mnuProperties1: TMenuItem;
    btnNew: TButton;
    bbtnAddGroup: TButton;
    lbEdit: TListBox;
    gbRAID: TGroupBox;
    lvRAID: TListView;
    gbJukeBox: TGroupBox;
    lvJUKEBOX: TListView;
    gbRouters: TGroupBox;
    lvRouters: TListView;
    gbGCC: TGroupBox;
    lvGCC: TListView;
    gbURLs: TGroupBox;
    lvURLS: TListView;
    gbDiagrams: TGroupBox;
    lvDiagrams: TListView;
    gbEKG: TGroupBox;
    lvEKG: TListView;
    function GetPlace(var SiteCode,SiteName: string):integer;
    procedure FormActivate(Sender: TObject);
    procedure ListViewUpdate(Clear,IEN: Boolean;Lister:TFMLister;lv:TListView;CAP:string);
    function GetLabels(FMDC:TObject): TStringList;
    procedure lvColumnClick(Sender: TObject;Column: TListColumn);
    procedure lvCompare(Sender: TObject; Item1,
      Item2: TListItem; Data: Integer; var Compare: Integer);
    function lvSearch(SearchList:TListView;SearchString: string;
      ColumnIndex:integer):integer;
    procedure rgListViewStyleClick(Sender: TObject);
    procedure TreeViewUpdate(Clear,IEN: Boolean;Lister,Sublister:TFMLister;tv:TTreeView);
    procedure FormDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean) ;
    procedure TreeView2DragDrop(Sender, Source: TObject; X, Y: Integer) ;
    procedure ListView2DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure lvMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lvRAIDEndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure tvMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure bbtnOKClick(Sender: TObject);
    procedure bbtnCancelClick(Sender: TObject);
    procedure btnApplyClick(Sender: TObject);
    procedure bbtnHelpClick(Sender: TObject);
    procedure NetLocUpdate(Place:integer;Caller:TObject);
    function FindOne(FileNum,FMIndex,IENS,Value:string):string;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ProcList(EdtList: TStrings;Filer: TFMFiler);
    procedure mnuProperties1Click(Sender: TObject);
    function Execute(Sender:TObject):boolean;
    procedure btnNewClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure lvSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure tvSelectItem(Sender: TObject;
      Item: TListItem; Selected: Boolean);
    procedure lvRAIDDragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure mnuDelete1Click(Sender: TObject);
    procedure pagecontrol1Change(Sender: TObject);
    procedure bbtnAddGroupClick(Sender: TObject);
    procedure ScanNetwork(TV: TTreeView; LV: TListView);
    function GetImageIndex(ShareName:string):integer;
    procedure tvRAIDGroupsMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure lvRAIDSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    function ConfirmNetLocDelete(Sender: TObject; NetName: string): boolean;
//    procedure CreateParams(var Params: TCreateParams);override;

//**********************

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmNetworkLoc: TfrmNetworkLoc;
  place,intSaveRPCTimeLimit,ColumnToSort,i: integer;
  SiteName,SiteCode,order,ParentFileNumber,SubfileNumber,ParentSubFieldNumber: string;
  lastHintNode: TTreeNode;
  LVStyle: TViewStyle;

const TimeLimit = 90;
       u = '^';
implementation

uses UnitDM,MagWebHelp,MagNetLoc,Magbtm1,ConfirmNetDel;
{$R *.dfm}

function TfrmNetworkLoc.Execute(Sender: TObject):boolean;
begin
//  application.CreateForm(TfrmNetworkLoc, frmNetworkLoc);
//  result:= frmNetworkLoc.ShowModal = mrOK;
end;
procedure TfrmNetworkLoc.FormActivate(Sender: TObject);
var i : integer;

begin
  {$ifdef Win32}
          SetForegroundWindow(frmNetworkLoc.Handle);
  {$else}
          BringWindowToTop(frmNetworkLoc.Handle);
  {$endif}
 LVStyle := vsReport;
  place := GetPlace(SiteCode,SiteName);
  if place < 1 then begin
    Windows.MessageBox(frmNetworkLoc.Handle,'The Site parameter context could not be determined.  The application will terminate.','',MB_SYSTEMMODAL) ;
    application.Terminate;
    end;
  Caption := ' '+SiteName+' '+ 'Network Location Manager';
  order := 'd';
   for I := 0 to frmNetworkLoc.ComponentCount - 1 do begin
     if (frmNetworkLoc.Components[I] is TListView) then
       with frmNetworkLoc.Components[I] as TListView do begin
         OnColumnClick := lvColumnClick;
         OnCompare := lvCompare;
         RowSelect := true;
         MultiSelect := true;
         end;
     end;
  NetLocUpdate(place,nil);
lvRouters.Items.BeginUpdate;
for i := 0 to lvRouters.Columns.Count -1 do begin
  lvRouters.Columns[i].AutoSize := true;   {AutoSize Columns}
  lvRouters.Columns[i].width := columnheaderwidth;  {Set ColumnWidth}
  end;
lvRouters.Items.EndUpdate;


end;
procedure TfrmNetworkLoc.NetLocUpdate(Place:integer;Caller:TObject);
  begin
  // RAID Groups
  dmMain.fmlRAIDGroups.Screen :='I $P($G(^MAG(2005.2,Y,0)),U,10)='+IntToStr(Place)+',$P($G(^MAG(2005.2,Y,0)),U,7)="GRP"';
  TreeViewUpdate(true,true,dmMain.fmlRAIDGroups,dmMain.fmlRGMembers,tvRAIDGroups);
  // RAID
  dmMain.fmlNLRAID.Screen :='I $P($G(^MAG(2005.2,Y,0)),U,10)='+IntToStr(Place)+',$P($G(^MAG(2005.2,Y,0)),U,7)="MAG"';
  dmMain.fmlNLRAID.Screen := dmMain.fmlNLRAID.Screen+',$P($G(^MAG(2005.2,Y,0)),U,9)'+chr(39)+'="1"';
  dmMain.fmlNLRAID.Screen := dmMain.fmlNLRAID.Screen+','+chr(39)+'$P($G(^MAG(2005.2,Y,1)),U,8)';
  ListViewUpdate(true,true,dmMain.fmlNLRAID,lvRAID,'.01');
  // JUKEBOX
  dmMain.fmlNLJukebox.Screen :='I $P($G(^MAG(2005.2,Y,0)),U,10)='+IntToStr(Place)+',$P($G(^MAG(2005.2,Y,0)),U,7)["WORM"';
  ListViewUpdate(true,true,dmMain.fmlNLJukebox,lvJUKEBOX,'.01');
  // Routers
  dmMain.fmlNLRouters.Screen :='I $P($G(^MAG(2005.2,Y,0)),U,10)='+IntToStr(Place)+',(($P($G(^MAG(2005.2,Y,0)),U,9)="1")&';
  dmMain.fmlNLRouters.Screen := dmMain.fmlNLRouters.Screen +'($P($G(^MAG(2005.2,Y,0)),U,7)["MAG"))';
  dmMain.fmlNLRouters.Screen := dmMain.fmlNLRouters.Screen +'!($P($G(^MAG(2005.2,Y,0)),U,7)["RTR")';
  ListViewUpdate(true,true,dmMain.fmlNLRouters,lvROUTERS,'.01');
  // Generic Carbon Copy GCC - Export
  dmMain.fmlNLGCC.Screen :='I $P($G(^MAG(2005.2,Y,0)),U,10)='+IntToStr(Place)+',$P($G(^MAG(2005.2,Y,0)),U,7)="GCC"';
  ListViewUpdate(true,true,dmMain.fmlNLGCC,lvGCC,'.01');
  // EKG - MUSE
  dmMain.fmlNLEKG.Screen :='I $P($G(^MAG(2005.2,Y,0)),U,10)='+IntToStr(Place)+',$P($G(^MAG(2005.2,Y,0)),U,7)="EKG"';
  ListViewUpdate(true,true,dmMain.fmlNLEKG,lvEKG,'.01');
  // URLs
  dmMain.fmlNLURL.Screen :='I $P($G(^MAG(2005.2,Y,0)),U,10)='+IntToStr(Place)+',$P($G(^MAG(2005.2,Y,0)),U,7)="URL"';
  ListViewUpdate(true,true,dmMain.fmlNLURL,lvURLs,'.01');
  // Diagrams
  dmMain.fmlNLDGM.Screen :='I $P($G(^MAG(2005.2,Y,0)),U,10)='+IntToStr(Place)+',$P($G(^MAG(2005.2,Y,0)),U,7)="DGM"';
  ListViewUpdate(true,true,dmMain.fmlNLDGM,lvDiagrams,'.01');
end;
procedure TfrmNetworkLoc.ListViewUpdate(Clear,IEN: Boolean;Lister:TFMLister;lv:TListView;CAP: string);
var
  i,j,k: integer;
  Labels: TStringList;
  NewColumn: TListColumn;
  ListItem: TListItem;
begin
  lv.Items.BeginUpdate;
  if clear then begin
    lv.Items.Clear;
    lv.Columns.Clear;
    if lv.Parent.ClassName = 'TGroupBox' then (lv.Parent as TGroupBox).Caption := '';
//    lv.SmallImages := ImageList1;
//    lv.LargeImages := ImageList1;
    Labels := GetLabels(Lister);
    if Labels.Count > 0 then begin{Create Column Labels}
      if CAP <> '' then begin
        NewColumn := lv.Columns.Add;
        NewColumn.Caption := Labels[Lister.FieldNumbers.IndexOf(CAP)];
        if magbtmf1.mnu508mode.Checked then
          if lv.Parent.ClassName = 'TGroupBox' then
            (lv.Parent as TGroupBox).Caption := (lv.Parent as TGroupBox).Caption +
              NewColumn.Caption;
        end;
      if IEN then begin
        NewColumn := lv.Columns.Add;
        NewColumn.Caption := 'IEN';
        if magbtmf1.mnu508mode.Checked then
          if lv.Parent.ClassName = 'TGroupBox' then
            (lv.Parent as TGroupBox).Caption := (lv.Parent as TGroupBox).Caption +
            ' ' + NewColumn.Caption;
        end;
      for k := 0 to Labels.Count-1 do begin
        if k = Lister.FieldNumbers.IndexOf(CAP) then continue;
        NewColumn := lv.Columns.Add;
        NewColumn.Caption := Labels[k];
        if magbtmf1.mnu508mode.Checked then
          if lv.Parent.ClassName = 'TGroupBox' then
            (lv.Parent as TGroupBox).Caption := (lv.Parent as TGroupBox).Caption +
              ' '+ Labels[k];
        end;
      end; // if Labels.count
    end; // if clear
  with Lister do begin
    GetList(nil);
    lv.ViewStyle := LVStyle;
    lv.GridLines := true;
    for i := 0 to Results.Count -1 do begin   {Create ListItems}
      ListItem := lv.Items.Add;
      ListItem.ImageIndex := 0;
//      ListItem.SubItems.AddObject(Lister.IENS,Lister);
      if IEN then ListItem.SubItems.Add(Lister.Results[i]);
      for j := 0 to FieldNumbers.Count -1 do
        if j = Lister.FieldNumbers.IndexOf(CAP) then
          ListItem.Caption := GetRecord(Results[i]).GetField(FieldNumbers.Strings[j]).FMDBExternal
        else ListItem.SubItems.Add(GetRecord(Results[i]).GetField(FieldNumbers.Strings[j]).FMDBExternal);
      end; //for i
      for i := 0 to lv.Columns.Count -1 do begin
        lv.Columns[i].AutoSize := true;   {AutoSize Columns}
        lv.Columns[i].width := columnheaderwidth;  {Set ColumnWidth}
        end;
    end; // with Lister
    lv.ReadOnly := true;
    //if lv.Items.Count < 1 then lv.Enabled := false
    //else lv.Enabled := true;
    lv.PopupMenu := PopupMenu1 ;
    lv.Items.EndUpdate;
    if lv.Items.Count > 0 then lv.Items[0].Selected := true;
end; //ListViewUpdate
procedure TfrmNetWorkLoc.TreeViewUpdate(Clear,IEN: Boolean;Lister,Sublister:TFMLister;tv:TTreeView);
var
  i,k: integer;
  share,shareIEN: string;
  RootNodes,subnodes: TTreeNode;
begin
  if clear then begin
    tv.Items.Clear;
    tv.ShowButtons := true;
    tv.ShowLines := true;
    tv.ShowRoot := true;
    end; // if clear
    Lister.GetList(nil);
    for i := 0 to Lister.Results.Count -1 do begin   {Create ListItems}
      RootNodes := tv.Items.add(nil,Lister.GetRecord(Lister.Results[i]).GetField('.01').FMDBExternal);
      RootNodes.ImageIndex := 2;
      Sublister.IENS := ','+Lister.Results[i]+',';
      Sublister.GetList(nil);
      for k := 0 to Sublister.Results.Count - 1 do begin
        share := Sublister.GetRecord(Sublister.Results[k]).GetField('.01').FMDBExternal;
        subnodes := tv.Items.AddChild(RootNodes,share);
        subnodes.ImageIndex := GetImageIndex(share);
      end; // for k
      end; // for i
    for i := 0 to tv.Items.Count -1 do tv.Items[i].Expand(true);
    tv.ReadOnly := true;
    if tv.Items.Count > 0 then tv.Items[0].MakeVisible;
end;
function TfrmNetworkLoc.GetImageIndex(ShareName:string):integer;
var shareIEN: string;
begin
  shareIEN := dmMain.FindC('2005.2','','QXK',IntToStr(magbtm1.place)+'^'+trim(shareName),'D','');
  if ((dmMain.GetFieldValue('2005.2','5',shareIEN+',','I',true) = '1') and
    (dmMain.GetFieldValue('2005.2','5.5',shareIEN+',','I',true) <> '1')) then
     GetImageIndex := 0
  else GetImageIndex := 0;
end;
function TfrmNetworkLoc.GetLabels(FMDC:TObject): TStringList;
  function GetLabel(FMFile,FMField:string): String;
    var
      ResultList :TStringList;
  begin
    ResultList := TStringList.create;
    with dmMain.RPCBroker1 do begin
     Param[0].VALUE := FMFile;
     Param[0].PTYPE := LITERAL;
     Param[1].VALUE := FMField;
     Param[1].PTYPE := LITERAL;
     Param[2].VALUE := '';
     Param[2].PTYPE := LITERAL;
     Param[3].VALUE := 'LABEL';
     Param[3].PTYPE := LITERAL;
     RemoteProcedure := 'MAG FLD ATT';
     intSaveRPCTimeLimit := RPCTimeLimit;  {save off current time limit}
     RPCTimeLimit := TimeLimit;   {can take up to a minute to complete}
      try
        LSTCALL(ResultList);
        RPCTimeLimit := intSaveRPCTimeLimit;
      except
        On E: EBrokerError do begin
          RPCTimeLimit := intSaveRPCTimeLimit;
          Result := 'Broker Error: '+ E.ClassName+' '+
            E.Mnemonic+' '+E.Message+' '+E.Action;
          Exit;
          end;
      end;  //try
    end; //with RPCBroker1
    Result := ResultList[0] ;
  end;
  var i:integer;
begin
 Result := TStringList.Create;
 if FMDC.ClassType = TFMLister then with FMDC as TFMLister do
   for i := 0 to FieldNumbers.Count-1 do
     result.Add(GetLabel(FileNumber,FieldNumbers[i]));
 if FMDC.ClassType = TFMGets then with FMDC as TFMGets do
   for i := 0 to FieldNumbers.Count-1 do
     result.Add(GetLabel(FileNumber,FieldNumbers[i]));
end;//GetLabels(FMDC:TObject):
procedure TfrmNetworkLoc.lvColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  ColumnToSort := Column.Index;
  (Sender as TCustomListView).AlphaSort;
  if order = 'a' then order := 'd'
  else order := 'a';
end;

procedure TfrmNetworkLoc.lvCompare(Sender: TObject; Item1,
  Item2: TListItem; Data: Integer; var Compare: Integer);
function CompAll(Input1,Input2:string):integer;
var
  I1,I2,C1,C2: Integer;
begin
    Val(Input1,I1,C1);
    Val(Input2,I2,C2);
  if ((c1 = 0) and (c2 = 0)) then begin
    if I1 > I2 then result := I1 - I2;
    if I1 < I2 then result := -(I2 - I1);
    if I1 = I2 then result := 0;
    end
  else result := CompareText(Input1,Input2);
  if order = 'd' then result := -result;
end;
var IX: integer;
begin
  if ColumnToSort = 0 then
    Compare := CompAll(Item1.Caption,Item2.Caption)
  else begin
   ix := ColumnToSort - 1;
   Compare := CompAll(Item1.SubItems[ix],Item2.SubItems[ix]);
  end;
end;
function TfrmNetworkLoc.lvSearch(SearchList:TListView;SearchString: string;ColumnIndex:integer):integer;
var i: integer;
  FoundItem : TListItem;
begin
  result := -1;
 if ColumnIndex = 0 then begin
   FoundItem := SearchList.FindCaption(0,SearchString,false,true,false);
   if FoundItem <> nil then Result := FoundItem.index
   else Result := -1;
   end
 else begin
   for i := 0 to SearchList.Items.Count - 1 do
     if pos(SearchString,SearchList.Items[i].SubItems[ColumnIndex-1]) <> 0 then begin
       result := i;
       exit;
       end;
     end;
end;

function TfrmNetworkLoc.GetPlace(var SiteCode,SiteName: string):integer;
var
  FMGetsPN : TFMGets;
  Lister: TFMLister;
begin
  Lister := TFMLister.Create(application);
  Lister.RPCBroker := dmMain.RPCBroker1;
  Lister.FileNumber := '2006.1';
  Lister.ListerFlags := [lfInternal];
  Lister.FMIndex := '#';
  Lister.FieldNumbers.Clear;
  Lister.FieldNumbers.Add('.01');
  Lister.Screen :='I $D(^MAG(2006.1,"B",+$G(DUZ(2)),Y))';
  Lister.GetList(nil);
  with Lister do begin
     if results.count = 1 then begin
       GetPlace := StrToInt(Results[0]);
       place := StrToInt(Results[0]);
       end
    else GetPlace := 0;
    end;
  FMGetsPN := TFMGets.Create(self);
  FMGetsPN.FileNumber := '2006.1';
  FMGetsPN.FieldNumbers.Clear;
  FMGetsPN.FieldNumbers.Add('.01') ;
  FMGetsPN.FieldNumbers.Add('.02') ;
  FMGetsPN.RPCBroker := dmMain.RPCBroker1;
  FMGetsPN.IENS := IntToStr(Place)+',';
  FMGetsPN.GetData;
  SiteName := FMGetsPN.GetField('.01').FMDBExternal;
  SiteCode := FMGetsPN.GetField('.02').FMDBExternal;
  FMGetsPN.Free;
end; //GetPlace
procedure TfrmNetworkLoc.rgListViewStyleClick(Sender: TObject);
var i:integer;
begin
  // Change the view style based on the radio button selection
  LVStyle := TViewStyle(rgListViewStyle.ItemIndex + 2);
  for i := 0 to frmNetworkLoc.ComponentCount - 1 do
     if (frmNetworkLoc.Components[I] is TListView) then
       with frmNetworkLoc.Components[I] as TListView do
        ViewStyle := LVStyle;
end;
procedure TfrmNetworkLoc.tvMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
   var
      HT: THitTests;
      hoverNode :TTreeNode;
      tree : TTreeView;
begin
try
  (Sender as TTreeView).Selected := (Sender as TTreeView).GetNodeAt(X,Y);
  if (Sender as TTreeView).Selected = nil then exit;
  //*********** Fixes problem with the RightClickSelect property of TreeView
  HT := (Sender as TTreeView).GetHitTestInfoAt(X, Y);
  if (HT <= [htOnItem, htOnIcon, htOnLabel, htOnStateIcon])
     and (button=mbRight) then begin
     // Code to enable Popupmenu to edit properties
     if sender.ClassType = TTreeView then begin
       if ((sender as TTreeView).SelectionCount > 0) and (not btnApply.Enabled) then
         PopupMenu1.Items[0].Enabled := true
       else PopupMenu1.Items[0].Enabled := false;
       end;
     end;
  if Button = mbLeft then{ drag only if left button pressed }
    if DragDetect((Sender as TTreeView).Handle, POINT(X, Y)) then begin
      //  Don't Drag Group NODES - ELSE only allow the moving of the Group NODE members
      //  Code that in the DRAGDROP event
      if (sender as TTreeView).Selected.Level <> 0 then
         (sender as TTreeView).BeginDrag(false);
      end;
finally
end;

end;

procedure TfrmNetworkLoc.lvMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
try
  if Button = mbLeft then{ drag only if left button pressed }
    begin
      if DragDetect((Sender as TListview).Handle, POINT(X, Y)) then
      (sender as TListView).BeginDrag(True);
    end;
finally
//  Windows.MessageBox(frmNetworkLoc.Handle,pchar('lvMouseDown'),'',MB_SYSTEMMODAL) ;
  end;
end;
procedure TfrmNetworkLoc.TreeView2DragDrop(Sender, Source: TObject; X, Y: Integer) ;
var
   AnItem: TTreeNode;
   HT: THitTests;
   CurrentItem, NextItem: TListItem;
   ToDeleteNode, DropNode, CurrentNode, NextNode: TTreeNode;
   i : integer;
   DropText,SourceText: string;
begin
  try
   HT := (Sender as TTreeView).GetHitTestInfoAt(X, Y) ;
   AnItem := (Sender as TTreeView).GetNodeAt(X, Y) ;
   if AnItem = nil then exit;
   if htNowhere in HT then Exit;// 'NoWhere'
   if Source.ClassType = TListView then begin
     CurrentItem := TListView(Source).Selected;
     while assigned(CurrentItem) do begin
       NextItem := TListView(Source).GetNextItem(CurrentItem, sdAll, [isSelected]);
       if AnItem.Level = 0 then begin
         for i := 0 to AnItem.Count -1 do
           if AnItem.Item[i].Text = CurrentItem.Caption then begin
             Windows.MessageBox(frmNetworkLoc.Handle,PChar('The value: '+CurrentItem.Caption+' is already a member of '+AnItem.Text+'!'),' ',MB_SYSTEMMODAL) ;
             exit;
             end;  //item is already a member check
            btnApply.Enabled := true;
            AnItem := TTreeView(sender).Items.AddChild(AnItem,CurrentItem.Caption);
            AnItem.ImageIndex := GetImageIndex(AnItem.Text);
            CurrentItem.Free;
         end  // AnItem.Level = 0
       else begin // AnItem.Level <> 0
         for i := 0 to AnItem.Parent.Count - 1 do
           if AnItem.Parent.Item[i].Text = CurrentItem.Caption then begin
             Windows.MessageBox(frmNetworkLoc.Handle,PChar('The value: '+CurrentItem.Caption+' is already a member of '+AnItem.Parent.Item[i].Text+ '!'),'' ,MB_SYSTEMMODAL) ;
             exit;
             end;  //item is already a member check
           btnApply.Enabled := true;
           AnItem := TTreeView(sender).Items.Add(AnItem,CurrentItem.Caption);
           AnItem.ImageIndex := GetImageIndex(AnItem.Text);
           CurrentItem.Free;
           end; // AnItem.Level <> 0
       CurrentItem := NextItem;
       end;  //while assigned(CurrentItem)
     end;  //Source.ClassType = TListView
   if Source.ClassType = TTreeView then begin
     DropNode := TTreeView(Sender).GetNodeAt(X, Y);
     CurrentNode := TTreeView(Source).Selected;
     if CurrentNode.Level <> 0 then begin
       if DropNode.Level = 0 then begin
         NextNode := TTreeView(Source).Items.AddChild(DropNode, CurrentNode.Text);
         NextNode.ImageIndex := GetImageIndex(NextNode.Text);
         end  // DropNode.Level = 0
       else begin  //  DropNode.Level <> 0
         NextNode := TTreeView(Source).Items.Insert(DropNode, CurrentNode.Text);
         NextNode.ImageIndex := GetImageIndex(NextNode.Text);
         end; //  DropNode.Level <> 0
       ToDeleteNode := CurrentNode;
       if Assigned(ToDeleteNode) then begin
         ToDeleteNode.Delete;
         ToDeleteNode := nil;
         end; // if Assigned(ToDeleteNode)
       end; //  if CurrentNode.Level <> 0
     btnApply.Enabled := true;
     end; //if Source.ClassType = TTreeView
  finally
    TTreeView(Sender).FullExpand;
  end;
end; // TreeView2DragDrop

procedure TfrmNetworkLoc.ListView2DragDrop(Sender, Source: TObject; X, Y: Integer);
var
  DragItem, DropItem, CurrentItem, NextItem: TListItem;
  IEN,Parent,ParentSub,temp: string;

begin
  if Sender.ClassType = Source.ClassType then begin
    DropItem := TListView(Sender).GetItemAt(x,y);
    CurrentItem := TListView(Source).Selected;
    while assigned(CurrentItem) do begin
      NextItem := TListView(Source).GetNextItem(CurrentItem, sdAll, [isSelected]);
      //if a specfic insertion point is not defined then add item
      if not Assigned(DropItem) then DragItem := (Sender as TListView).Items.Add
      else DragItem :=(Sender as TListView).Items.Insert(DropItem.Index);
      DragItem.Assign(CurrentItem);
      DragItem.Caption := CurrentItem.Caption;
      CurrentItem.Free;
      CurrentItem := NextItem;
      end; // while assigned(CurrentItem)
    end; // Sender.ClassType = Source.ClassType
  if Source.ClassType = TTreeView then begin
    DropItem := TListView(Sender).GetItemAt(x,y);
    if  lvSearch(TListView(Sender),TTreeView(Source).Selected.Text,0) = -1 then begin
      if Assigned(DropItem) then DragItem := TListView(Sender).Items.Insert(DropItem.Index)
      else DragItem := TListView(Sender).Items.Insert(0);
      DragItem.Caption := TTreeView(Source).Selected.Text;
      end;
    TTreeView(Source).Items.Delete(TTreeView(Source).Selected);
    btnApply.Enabled := true;
    TTreeView(Source).FullExpand;
    end; // Source.ClassType = TTreeView
end; // ListView2DragDrop

procedure TfrmNetworkLoc.lvRAIDEndDrag(Sender, Target: TObject; X,
  Y: Integer);
 { var AnItem: TListItem;}
begin
  if target <> nil then begin
    if Target.ClassType = TTreeView then (Target as TTreeView).Update;
    if Target.ClassType = TListView then (Target as TListView).Update;
    end;
end;


procedure TfrmNetworkLoc.bbtnOKClick(Sender: TObject);
begin
  //if FMFiler1.AnythingToFile then FMFiler1.Update;
  if btnApply.Enabled then btnApplyClick(self);
  if lbEdit.Items.Count <> 0 then ProcList(lbEdit.Items,FMFiler1);
  frmNetworkLoc.Close;
end;

procedure TfrmNetworkLoc.bbtnCancelClick(Sender: TObject);
begin
  lbEdit.Items.Clear;
  frmNetworkLoc.Close;
end;

procedure TfrmNetworkLoc.btnApplyClick(Sender: TObject);
begin
   ScanNetwork(tvRAIDGroups,lvRAID);
   if lbEdit.Items.Count <> 0 then ProcList(lbEdit.items,FMFiler1);
   btnApply.Enabled := false;
   NetLocUpdate(Place,nil);
end;

procedure TfrmNetworkLoc.ScanNetwork(TV: TTreeView; LV: TListView);
procedure GroupList(IEN:string;HostList: TStringList);
var
    i: integer;
  NetLoc: TFMLister;
begin
  NetLoc := TFMLister.Create(nil);
  NetLoc.RPCBroker := dmMain.RPCBroker1;
  NetLoc.FileNumber := '2005.22';
  NetLoc.IENS :=','+Ien+',';
  NetLoc.FieldNumbers.Add('.01');
  NetLoc.GetList(nil); //NodeGroupList);
  for i := 0 to NetLoc.Results.Count -1 do begin
    HostList.Add(NetLoc.GetRecord(NetLoc.Results[i]).GetField('.01').FMDBExternal);
    end;
  NetLoc.Free;
end;
var
  CurrentGroupNode,CurrentShareNode: TTreenode;
  NodeGroupList,HostGroupList: TStringList;
  GroupIEN,ShareIEN,SubFileIEN: string;
  CurrentListItem: TListItem;
  i: integer;
  NetLoc: TFMLister;
begin //this procedure creates an Edit list - to be processed by the ProcList procedure
  lbEdit.Items.Clear;
   //traverse the RAID group, add all non-members, remove excess members
  HostGroupList := TStringList.Create;
  CurrentGroupNode := TV.Items.GetFirstNode;
  while CurrentGroupNode <> nil do begin
    HostGroupList.Clear;
    GroupIEN := dmMain.FindC('2005.2','','QXK',IntToStr(magbtm1.place)+'^'+trim(CurrentGroupNode.Text),'D','');
    GroupList(GroupIEN,HostGroupList);
    for i := 0 to CurrentGroupNode.count - 1 do begin
      CurrentShareNode := CurrentGroupNode.Item[i];
      if HostGroupList.IndexOf(trim(CurrentShareNode.Text)) <> -1 then begin
        HostGroupList.Delete(HostGroupList.IndexOf(trim(CurrentShareNode.Text)));
        end //  Host Group multiple is already current
      else begin
        //add host group member and Group pointer
        ShareIEN := dmMain.FindC('2005.2','','QXK',IntToStr(magbtm1.place)+'^'+trim(CurrentShareNode.Text),'D','');
        lbEdit.Items.Add('2005.2^'+ShareIEN+',^31^'+GroupIEN);
        lbEdit.Items.Add('2005.22^+1,'+GroupIEN+',^.01^'+ShareIEN);
        end; // Update Host Group Multiple (#2005.22)
      end; // CurrentGroupNode traversal
    //  Remove remaining Host Group members and remove Group pointer from Netloc RAID share
      for i := 0 to HostGroupList.Count - 1 do begin
        ShareIEN := dmMain.FindC('2005.2','','QXK',IntToStr(magbtm1.place)+'^'+trim(HostGroupList[i]),'D','');
        SubFileIEN := FindOne('2005.22','',','+GroupIEN+',',trim(HostGroupList[i]));
        lbEdit.Items.Add('2005.22^'+SubFileIEN+','+GroupIEN+','+'^'+'.01^@');
        if (dmMain.GetFieldValue('2005.2','31',ShareIEN+',','I',true) = GroupIEN) then
          lbEdit.Items.Add('2005.2^'+ShareIEN+',^31^@');
        end; // processing of remaining HostGroupList
      if lbEdit.Items.Count > 0 then ProcList(lbEdit.items,FMFiler1);
    CurrentGroupNode := CurrentGroupNode.getNextSibling;
    end; // while CurrentGroupNode <> nil
  HostGroupList.Free;
  //loop though the Listview and delete the Group Pointer (#31) for all members
  for i := 0 to LV.Items.Count - 1 do begin
    CurrentListItem := LV.Items[i];
    ShareIEN := dmMain.FindC('2005.2','','QXK',IntToStr(magbtm1.place)+'^'+trim(CurrentListItem.Caption),'D','');
    lbEdit.items.Add('2005.2^'+ShareIEN+'^31^@');
    end;
  if lbEdit.Items.Count > 0 then ProcList(lbEdit.items,FMFiler1);
end; // ScanNetwork
procedure TfrmNetworkLoc.ProcList(EdtList: TStrings;Filer: TFMFiler);
var i,j : integer;
begin
 if not Magbtm1.LogOn then begin
   Magbtm1.BPErrorLogSize := 0;
   magbtmf1.InitLogFile('log\BackProc\BackProc.LOG','BackProc_Log',true,Magbtm1.BackProcLogSize);
   Magbtm1.LogOn := true;
   end;
 for i := 0 to EdtList.Count - 1 do begin
   Magbtmf1.InvStrGrid(True,DateTimeToStr(Now)+'^NetLocationManager^FM Filer Update: '+StringReplace(EdtList[i],'^',' ',[rfReplaceAll]),280,Magbtmf1.sgLatestTasks);
   Filer.AddFDA(piece(EdtList[i],'^',1),piece(EdtList[i],'^',2),piece(EdtList[i],'^',3),piece(EdtList[i],'^',4));
   if not Filer.Update then Filer.DisplayErrors;
   if filer.AnythingToFile then
     Windows.MessageBox(frmNetworkLoc.Handle,PChar('Filer list not cleared! '),' ',MB_SYSTEMMODAL) ;
     //Filer.Clear;
   end;
 EdtList.Clear;
end;

procedure TfrmNetworkLoc.FormDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean) ;
begin
  if Source.ClassType = TListView then Accept := (Source is TListView);
  if Source.ClassType = TTreeView then Accept := (Source is TTreeView);
end;

function TfrmNetworkLoc.FindOne(FileNum,FMIndex,IENS,Value:string):string;
begin
    FMFindOne1.IENS :=IENS;
    FMFindOne1.FileNumber := FileNum;
    FMFindOne1.FMIndex := FMIndex;
    FMFindOne1.RPCBroker := dmMain.RPCBroker1;
    FMFindOne1.Value := Value;
    FMFindOne1.FinderFlags := [fnfOnlyExact] ;
    Result := FMFindOne1.GetIEN;
    if FMFindOne1.ErrorList.Count > 0 then begin
     FMFindOne1.DisplayErrors;
     Result := '-1';
     end;
end;

procedure TfrmNetworkLoc.bbtnHelpClick(Sender: TObject);
begin
  Application.CreateForm(TfrmMagBPHelp,frmMagBPHelp);
  Case pagecontrol1.ActivePageIndex of
    0: begin  // RAID
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help/MAG_BP_User_Manual.htm#_Toc315344972');
       end; //case 0 // RAID
    1: begin // Jukebox
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help/MAG_BP_User_Manual.htm#_Toc315344973');
         end; // Case 1 JukeBox
    2: begin // Routers
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help/MAG_BP_User_Manual.htm#_Toc315344974');
         end; // Case 2 Routers
    3: begin    // GCC
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help/MAG_BP_User_Manual.htm#_Toc315344975');
         end;  // case ActivePageIndex of 3 GCC
    4: begin   // EKG
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help\MAG_BP_User_Manual.htm#_Toc315344976');
         end; //Case 4 EKG
     5: begin   // URLs
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help\MAG_BP_User_Manual.htm#_Toc315344977');
        end; //Case 5 URLs
     6: begin   // Diagrams
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help\MAG_BP_User_Manual.htm#_Toc315344978');
        end; // Case 6 Diagrams
  end; //case
end;

procedure TfrmNetworkLoc.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  Magbtmf1.mnuNetLocMan.Checked := false;
  frmNetworkLoc.ModalResult := mrCancel;
  Action := caFree;
end;
procedure TfrmNetworkLoc.mnuProperties1Click(Sender: TObject);
var SIEN : string;
begin
  if Sender.ClassName = 'TMenuItem' then
    with ((Sender as TMenuItem).GetParentComponent) as TPopUpMenu do begin
      if PopUpComponent.ClassName = 'TTreeView' then
        with PopUpComponent as TTreeView do begin
          if TTreeView(PopUpComponent).Selected.Text <> '' then
            SIEN := dmMain.FindC('2005.2','','QXK',IntToStr(magbtm1.place)+'^'+TTreeView(PopUpComponent).Selected.Text,'D','');
          if pos('-1',SIEN) <> 0 then
            Windows.MessageBox(frmNetworkLoc.Handle,PChar('The lookup for '+TTreeView(PopUpComponent).Selected.Text+ ' Failed!'),' ',MB_SYSTEMMODAL)
          else begin
            Application.CreateForm(TfrmMagNet,frmMagNet);
            MagNetLoc.AddRecord := false;
            MagNetLoc.ien := SIEN;
            frmMagNet.ShowModal;
            frmMagNet.Free;
            end;
          end; // with PopUpComponent as TTreeView
      if PopUpComponent.ClassName = 'TListView' then
        with PopUpComponent as TListView do begin
          if TListView(PopUpComponent).Selected.Caption  <> '' then
            SIEN := dmMain.FindC('2005.2','','QXK',IntToStr(magbtm1.place)+'^'+TListView(PopUpComponent).Selected.Caption,'D','');
          if pos('-1',SIEN) <> 0 then
            Windows.MessageBox(frmNetworkLoc.Handle,PChar('The lookup for '+TListView(PopUpComponent).Selected.Caption+ ' Failed!'),' ',MB_SYSTEMMODAL)
          else begin
            Application.CreateForm(TfrmMagNet,frmMagNet);
            MagNetLoc.AddRecord := false;
            MagNetLoc.ien := SIEN;
            frmMagNet.ShowModal;
            frmMagNet.Free;
            end;
          end;  //with PopUpComponent as TTreeView
      end;
  NetLocUpdate(place,nil);
//  mnuProperties1.Enabled := false;
end;

procedure TfrmNetworkLoc.btnNewClick(Sender: TObject);
begin
  Application.CreateForm(TfrmMagNet,frmMagNet);
  MagNetLoc.AddRecord := true;
  Case pagecontrol1.ActivePageIndex of
    0: frmMagNet.fmrgStorageType.ItemIndex := 0; // RAID
    1: frmMagNet.fmrgStorageType.ItemIndex := 1; // Jukebox
    2: frmMagNet.fmrgStorageType.ItemIndex := 6; // Routers
    3: frmMagNet.fmrgStorageType.ItemIndex := 3; // GCC
    4: frmMagNet.fmrgStorageType.ItemIndex := 2; // EKG
    5: frmMagNet.fmrgStorageType.ItemIndex := 5; // URLs
    6: frmMagNet.fmrgStorageType.ItemIndex := 4;  // Diagrams
  end; //case
  frmMagNet.ShowModal;
  frmMagNet.Free;
  NetLocUpdate(place,nil);
end;

procedure TfrmNetworkLoc.FormCreate(Sender: TObject);
begin
  application.ShowHint:=true;
  application.HintPause := 100;
  application.HintHidePause := 8000;
  dmMain.FMComponentInit(self);
end;

procedure TfrmNetworkLoc.PopupMenu1Popup(Sender: TObject);
var
  i: integer;
  AnItem: TTreeNode;
begin
  if (Sender as TPopUpMenu).PopupComponent.ClassName = 'TTreeView' then begin
    if tvRAIDGroups.Selected = nil then begin
      for i := 0 to popupMenu1.Items.Count - 1 do
        popupMenu1.Items[i].Enabled := false;
      exit;
      end;
 // Code to enable Popupmenu to edit properties
    if (tvRAIDGroups.SelectionCount > 0)  and (not btnApply.Enabled)  then begin
      AnItem := tvRAIDGroups.Selected;
      case AnItem.Level of
        0: begin
             popupMenu1.Items[popupMenu1.Items.IndexOf(mnuProperties1)].Enabled := false;
        (* Disabling Network Location delete per CR 679 - 02/03/2011 RMP - the submenu
          mnuDelete1 was removed from the popupMenu1
             popupMenu1.Items[popupMenu1.Items.IndexOf(mnuDelete1)].Enabled := true;*)
             end;
        1: begin
             for i := 0 to popupMenu1.Items.Count - 1 do
               popupMenu1.Items[i].Enabled := true;
             end;
         end; // Case
      end // if ((tvMailMessages.SelectionCount > 0
    else for i := 0 to popupMenu1.Items.Count - 1 do
            popupMenu1.Items[i].Enabled := false;
    end; // if TreeView
end;

procedure TfrmNetworkLoc.tvSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  if sender.ClassType = TListView then begin
    if (sender as TListView).SelCount > 0 then
      PopupMenu1.Items[0].Enabled := true
    else PopupMenu1.Items[0].Enabled := false;
    end;
end;


procedure TfrmNetworkLoc.lvSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
var i: integer;
begin
  if sender.ClassType = TListView then begin
    if ((sender as TListView).SelCount > 0) and (not btnApply.Enabled) then begin
      for i:= 0 to PopupMenu1.Items.Count - 1 do
        PopupMenu1.Items[i].Enabled := true;
      end
    else begin
      for i:= 0 to PopupMenu1.Items.Count - 1 do
        PopupMenu1.Items[i].Enabled := false;
      end;
    end;
end;

procedure TfrmNetworkLoc.lvRAIDDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
 Accept := Sender = tvRaidGroups;
end;

procedure TfrmNetworkLoc.mnuDelete1Click(Sender: TObject);
function DELLocation(IEN:string):string;
begin
  with dmMain.RPCBroker1 do begin
    Param[0].VALUE := IEN;
    Param[0].PTYPE := LITERAL;
    RemoteProcedure := 'MAGQ DEL NLOC';
    try
      CALL;
      RPCTimeLimit := intSaveRPCTimeLimit;
    except
      On E: EBrokerError do begin
        magbtmf1.OnException(E);
        Exit;
        end;
      end;  //try
   result := Results[0];
   if not Magbtm1.LogOn then begin
     Magbtm1.BPErrorLogSize := 0;
     magbtmf1.InitLogFile('log\BackProc\BackProc.LOG','BackProc_Log',true,Magbtm1.BackProcLogSize);
     Magbtm1.LogOn := true;
     end;
   if StrToInt(piece(result,'^',1)) < 1 then begin
     Windows.MessageBox(frmNetworkLoc.Handle,PChar('The delete failed because: '+piece(result,'^',2)),' ',MB_SYSTEMMODAL) ;
     Magbtmf1.InvStrGrid(True,DateTimeToStr(Now)+'^NetLocationManager^Share deletion failed: '+piece(result,'^',2),280,Magbtmf1.sgLatestTasks);
     end
   else
     Magbtmf1.InvStrGrid(True,DateTimeToStr(Now)+'^NetLocationManager^Share deletion: '+piece(IEN,'^',1)+' ien:'+piece(IEN,'^',2),280,Magbtmf1.sgLatestTasks);
    end; //with RPCBroker1
  NetLocUpdate(place,nil);
end; //DELLocation(IEN:string);

var SIEN: string;
    SHARENAME: string;
begin
  if Sender.ClassName = 'TMenuItem' then
    with ((Sender as TMenuItem).GetParentComponent) as TPopUpMenu do begin
      if PopUpComponent.ClassName = 'TTreeView' then
        with PopUpComponent as TTreeView do begin
          if TTreeView(PopUpComponent).Selected.Text <> '' then
            SIEN := dmMain.FindC('2005.2','','QXK',IntToStr(magbtm1.place)+'^'+TTreeView(PopUpComponent).Selected.Text,'D','');
          if pos('-1',SIEN) <> 0 then
            Windows.MessageBox(frmNetworkLoc.Handle,PChar('The lookup for '+TTreeView(PopUpComponent).Selected.Text+ ' Failed!'),' ',MB_SYSTEMMODAL)
          else begin
            SHARENAME := TTreeView(PopUpComponent).Selected.Text ;
            if ConfirmNetLocDelete(Self,SHARENAME) then DELLocation(SHARENAME+'^'+SIEN);
            end;
          end; // with PopUpComponent as TTreeView
      if PopUpComponent.ClassName = 'TListView' then
        with PopUpComponent as TListView do begin
          if TListView(PopUpComponent).Selected.Caption  <> '' then
            SIEN := dmMain.FindC('2005.2','','QXK',IntToStr(magbtm1.place)+'^'+TListView(PopUpComponent).Selected.Caption,'D','');
          if pos('-1',SIEN) <> 0 then
            Windows.MessageBox(frmNetworkLoc.Handle,PChar('The lookup for '+TListView(PopUpComponent).Selected.Caption+ ' Failed!'),'',MB_SYSTEMMODAL)
          else begin
            SHARENAME := TListView(PopUpComponent).Selected.Caption ;
            if ConfirmNetLocDelete(Self,SHARENAME) then DELLocation(SHARENAME+'^'+SIEN);
            end;
          end;  //with PopUpComponent as TTreeView
      end;
end;
function TfrmNetworkLoc.ConfirmNetLocDelete(Sender: TObject; NetName: string):boolean;
begin
  Application.CreateForm(TfrmConfirmNetDelete,frmConfirmNetDelete);
    try
      frmConfirmNetDelete.StaticText1.Caption :=
        pchar('This action will remove the '+NetName+' from the Network Location File !!! '+ #13#10+#13#10+
         'If there are Imaging references to this entry they would be disabled.  This could result in any number of '+
         'system errors.  Know that it is possible to rename this entry, take it off-line, or set it as read only instead of deleting it. '+
          #13#10+#13#10+
         'If there is any doubt please log a National Help Desk Ticket for assistance with this operation.');
      frmConfirmNetDelete.StaticText1.Font.Size := 10;
      frmConfirmNetDelete.ShowModal;
    finally
     result := ((frmConfirmNetDelete.ModalResult = mrok) and
        (ConfirmNetDel.Confirm));
      frmConfirmNetDelete.Free;
    end; // try...finally
end;





procedure TfrmNetworkLoc.pagecontrol1Change(Sender: TObject);
begin
  if (Sender as TPageControl).ActivePage.Caption = 'RAID' then bbtnAddGroup.Enabled := true
  else bbtnAddGroup.Enabled := false;
end;

procedure TfrmNetworkLoc.bbtnAddGroupClick(Sender: TObject);
begin
  with dmMain.RPCBroker1 do begin
    Param[0].VALUE := '1';
    Param[0].PTYPE := LITERAL;
    RemoteProcedure := 'MAGQ ADD RAID GROUP';
    try
      strCall;
    except
      On E: EBrokerError do begin
        magbtmf1.OnException(E);
        Exit;
        end;
      end;  //try
    end; //with RPCBroker1
  NetLocUpdate(place,nil);
end;

procedure TfrmNetworkLoc.tvRAIDGroupsMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
function NodeHint(tn: TTreeNode): string;
  var
   temp,RAIDien,Space,Share,Status,Read: string;
begin
  // Physical Reference, Space, Status, Read-Only (1, 4, 5, 5.5)
  case tn.Level of
    0: result := 'RAID Group';
    1: begin
        RAIDien := dmMain.FindC('2005.2','','QXK',IntToStr(magbtm1.place)+'^'+trim(tn.Text),'D','');
        Share := '  Share: '+ dmMain.GetFieldValue('2005.2','1',RAIDien+',','E',true);
        Space := ' Free Space: '+ dmMain.GetFieldValue('2005.2','4',RAIDien+',','E',true);
        Status := '  Status: '+dmMain.GetFieldValue('2005.2','5',RAIDien+',','E',true);
        Read := dmMain.GetFieldValue('2005.2','5.5',RAIDien+',','E',true);
        if pos('YES',uppercase(Read)) = 0 then Read := 'No';
        temp := 'IEN: '+ RAIDien;
        result := temp+Share+Space+Status+' Read-Only: '+ Read;
       end; // 1:
  end; // case tn.Level of
end; // NodeHint
var
  tree: TTreeView;
  hoverNode: TTreeNode;
  hitTest : THitTests;
  temp: string;
begin
  if (Sender is TTreeView) then tree := TTreeView(Sender)
  else Exit;
  hitTest := tree.GetHitTestInfoAt(X, Y) ;
  hoverNode := tree.GetNodeAt(X,Y);
  if (lastHintNode <> hoverNode) then begin
    Application.CancelHint;
    if (hitTest <= [htOnItem, htOnIcon, htOnLabel, htOnStateIcon]) then begin
      lastHintNode := hoverNode;
      tree.Hint := NodeHint(hoverNode);
      end; // if (hitTest <=
    end;  // if (lastHintNode <> hoverNode)
end;

procedure TfrmNetworkLoc.lvRAIDSelectItem(Sender: TObject; Item: TListItem;
  Selected: Boolean);
  var i : integer;
begin
  if sender.ClassType = TListView then begin
    if ((sender as TListView).SelCount > 0) and (not btnApply.Enabled) then
      for i := 0 to popupMenu1.Items.Count - 1 do popupMenu1.Items[i].Enabled := true
    else
      for i := 0 to popupMenu1.Items.Count - 1 do popupMenu1.Items[i].Enabled := false;
    end;
end;

end.
