unit MagGraphShare;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: Main BP Queue Processor
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)
//  Generalize the calling code from the MAGBTM1 routine so that the raid and jukebox lists use the same code efficiently
//  Make sure the Jukebox shares are updating the Network location file with the size space available etc
//  Be sure and add a print function

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls,ExtCtrls,MFunStr, Trpcb, TeEngine, Series,
  TeeProcs, Chart, TeeShape, Menus, ComCtrls, ToolWin;

type
  TfrmMagGraph = class(TForm)
    MainMenu1: TMainMenu;
    mnuEdit: TMenuItem;
    mnuExit: TMenuItem;
    Chart1: TChart;
    Series1: TPieSeries;
    Series2: TBarSeries;
    Series3: THorizBarSeries;
    SaveDialog1: TSaveDialog;
    s1: TMenuItem;
    procedure GraphDisplay(ServerList: TStringList;
      index:integer;TheChart: TChart);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure tbRefreshClick(Sender: TObject);
    procedure tbExitClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure s1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
     tmpX,tmpY:Longint;
  end;
Const
  BarStyleMax = 7;
var
  frmMagGraph: TfrmMagGraph;
  BarStyleActive,SeriesActive: integer;
{  cwl: string;}
implementation

uses Magbtm1{,UnitDM};
{$R *.DFM}
procedure TfrmMagGraph.GraphDisplay
(ServerList: TStringList;index:integer;
      TheChart: TChart);
var
 i,j: integer;
 size,space,temp: string;
const gig = 1000000000;
//ColorPalette : Array[1..MaxDefaultColors] of TColor = (clRed, clGreen, clYellow,
//clBlue, clWhite, clGray, clFuchsia, clTeal, clNavy, clMaroon, clLime, clOlive, clPurple, clSilver, clAqua, clBlack);

begin
  SeriesActive := 0;
  with TheChart do begin
     for i := 0 to SeriesCount-1 do SeriesList[i].Clear;
     for i := 0 to ServerList.Count - 1 do begin
        TEMP := piece(ServerList.Strings[i],'^',1)+piece(ServerList.Strings[i],'^',2);
       space := piece(ServerList.Strings[i],'^',2);
       for j := 0 to SeriesCount - 1 do SeriesList[j].Add(StrToFloat(space),temp,ColorPalette[i+1]); //  clTeeColor);
//       for j := 0 to SeriesCount - 1 do SeriesList[j].Add(StrToInt64(size) div gig,temp
//         ,ColorPalette[StrToInt(piece(ServerList.Strings[i],'^',6))]); //  clTeeColor);
       end;
     for i := 0 to SeriesCount - 1 do begin
        if SeriesList[i].ClassName = 'TPieSeries' then (seriesList[i] as TPieSeries).ExplodedSlice[0] := 30;
        if i <> SeriesActive then SeriesList[i].Active := false
        else SeriesList[i].Active := true;
        end;
     Visible := true;
     frmMagGraph.BringToFront;
     end;
 end;

procedure TfrmMagGraph.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  MAGBTMF1.mnuServerSize.checked := false;
end;

procedure TfrmMagGraph.FormResize(Sender: TObject);
begin
{  with grphCauchePurge2 do begin
    case frmMagPurge2.WindowState of
      wsNormal : begin
                   FontUse := 0;
                   FontSize := 200;
                   FontUse := 2;
                   FontSize := 50;
                   FontUse := 3;
                   FontSize := 50;
                 end;
      wsMinimized : begin
                      FontUse := 4;
                      FontSize := 50;
                   end;
      wsMaximized : begin
                      FontUse := 4;
                      FontSize := 400;
                   end;
    end; //case frmMagPurge2.WindowState
    DrawMode :=2;
  end; // with grphCauchePurge2}
end;

procedure TfrmMagGraph.FormCreate(Sender: TObject);
begin
//  MAGBTMF1.ServerSize('Group');
//  MAGBTMF1.ResetCurrentServer('0');
 // Application.HelpFile :=ExtractFilePath(Application.ExeName)+'help\BackProc.HLP';
end;

procedure TfrmMagGraph.Timer1Timer(Sender: TObject);
var j: integer;
begin
//  frmMagGraph.Caption := Format('%s - %s - %s',
//    [Magbtm1.SiteCode +  ' Vista Storage: ',TimeToStr(Now),'CWL: '+ cwl]);
    for j := 0 to frmMagGraph.ComponentCount -1 do
     if frmMagGraph.Components[j] is TChart then begin
       if (frmMagGraph.Components[j] as TChart).SeriesList[SeriesActive].ClassName <> 'TPieSeries' then exit;
    with (frmMagGraph.Components[j] as TChart) do begin
      if tmpX>0 then begin
        if (SeriesList[SeriesActive] as TPieSeries).XRadius+tmpX>ChartWidth div 3 then
         tmpX := -tmpX;
        end
      else if (SeriesList[SeriesActive] as TPieSeries).XRadius+tmpX<30 then tmpX:=-tmpX;
      (SeriesList[SeriesActive] as TPieSeries).CustomXRadius:=(SeriesList[SeriesActive] as TPieSeries).XRadius+tmpX;
      if tmpY>0 then begin
        if (SeriesList[SeriesActive] as TPieSeries).YRadius+tmpY>ChartHeight div 3 then
         tmpY:=-tmpY;
      end
      else if (SeriesList[SeriesActive] as TPieSeries).YRadius+tmpY<30 then tmpY:=-tmpY;
       (SeriesList[SeriesActive] as TPieSeries).CustomYRadius:=(SeriesList[SeriesActive] as TPieSeries).YRadius+tmpY;
      end;
      end;
end;
procedure TfrmMagGraph.tbRefreshClick(Sender: TObject);
begin
// MAGBTMF1.ServerSize('Group');
// MAGBTMF1.ResetCurrentServer('0');
end;


procedure TfrmMagGraph.tbExitClick(Sender: TObject);
begin
 close;
end;



procedure TfrmMagGraph.FormActivate(Sender: TObject);
begin
  {$ifdef Win32}
          SetForegroundWindow(frmMagGraph.Handle);
  {$else}
          BringWindowToTop(frmMagGraph.Handle);
  {$endif}

end;

procedure TfrmMagGraph.s1Click(Sender: TObject);
begin
  frmMagGraph.SendToBack;
  SaveDialog1.DefaultExt := GraphicExtension(TBitmap);
  SaveDialog1.Filter := GraphicFilter(TBitmap);
  SaveDialog1.Title := 'Save Graph to File: ';
  if SaveDialog1.Execute then chart1.SaveToMetafile(SaveDialog1.FileName);
  frmMagGraph.BringToFront;
  frmMagGraph.Repaint;
end;

end.
