unit MagHTMLArchiveUnit;

interface

uses

  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls,magbut,MFunStr;


type
  TMagHTMLArchiveForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure CreateHTML(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MagHTMLArchiveForm: TMagHTMLArchiveForm;
  SourceFile,TargetFile,ColHdr,DocType,Title,StyleCSS,Delimiter:string;
  ColCnt: integer;

implementation

{$R *.xfm}

procedure TMagHTMLArchiveForm.FormCreate(Sender: TObject);
var
  i: Integer;
begin
SourceFile := ParamStr(1);
TargetFile := ParamStr(2);
ColHdr := ParamStr(3);
StyleCSS := ParamStr(4);
Delimiter := ParamStr(5);
if length(Delimiter)= 0 then Delimiter :='^';
//DocType := ParamStr(4);
DocType :='<!doctype html public "-..w3c//dtd html 4.01 Transitional//en"  " http://www.w3.org/TR/html4/loose.dtd">';
//Title := ParamStr(5);
Title := piece(ExtractFileName(TargetFile),'.',1);
//Title := 'BP Queue Log';
Label1.Caption:=SourceFile;
Label2.Caption:=TargetFile;
Label3.Caption:=ColHdr;
Label4.Caption:=StyleCSS;
//Label5.Caption:=Title;
  for i := 1 to ParamCount do
  begin
    if LowerCase(ParamStr(i)) = 'beep' then
      Beep
    else if LowerCase(ParamStr(i)) = 'exit' then
      Application.Terminate;
  end;
CreateHTML(self);
Application.Terminate;

end;
procedure TMagHTMLArchiveForm.CreateHTML(Sender: TObject);
procedure InitializeHTML(var TFile:TextFile;TargetFile,DocHeader,Title,Style:string);
var i: integer;
  begin
    AssignFile(TFile,TargetFile);
    Rewrite(TFile);
    Writeln(TFile,DocType);
    Writeln(TFile,'<html><head><title>'+Title+'</title>');
    if Length(Style) > 0 then
      Writeln(TFile,'<link rel="stylesheet" type="text/css" href="'+
        Style+'" />');
    Writeln(TFile,'</head><body>');
    Writeln(TFile,'<FONT FACE="arial" SIZE="1">');
    Writeln(TFile,'<table border="1" cellpadding="2" cellspacing="1" width="80%">');
    if Length(ColHdr) <> 0 then begin
      ColCnt:= LastPiecePos(ColHdr,Delimiter);
      Writeln(TFile,'<tr>');
      for i := 1 to ColCnt do
        Writeln(TFile,'<th>'+piece(ColHdr,Delimiter,i)+'</th>');
      Writeln(TFile,'<tr>');
      end;
    end;// InitializeHTML
var
 Sfile,TFile: TextFile;
 Text :String;
 i: integer;
begin
  InitializeHTML(TFile,TargetFile,DocType,Title,StyleCSS);
  if fileExists(SourceFile) then begin
    AssignFile(Sfile,SourceFile);
    Reset(Sfile);
    while not EOF(Sfile) do begin
      Readln(Sfile,text);
      Writeln(TFile,'<tr>');
      for i := 1 to ColCnt do begin
        if length(piece(text,Delimiter,i)) <> 0 then Writeln(TFile,'<td>'+piece(text,Delimiter,i)+'</tr>')
        else Writeln(TFile,'<td>&nbsp;</tr>')
        end;
      Writeln(TFile,'<tr>');
      end;
    closefile(SFile);
    end;
  {Finally}
  Writeln(TFile,'</table>');
  Writeln(TFile,'</body></html>');
  Flush(TFile);
  CloseFile(TFile);
end;

procedure TMagHTMLArchiveForm.Button1Click(Sender: TObject);
begin
    CreateHTML(self);
    Application.Terminate;
end;

end.
