unit MagMessage;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: Main BP Queue Processor
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Fmcntrls,Diaccess,RpcConf1,Trpcb,DiTypLib,
  Fmcmpnts;

type
  TfrmErrorMessageEdit = class(TForm)
    gbMessaging: TGroupBox;
    fmeInterval: TFMEdit;
    fmeDTLMess: TFMEdit;
    bbtnOKEM: TBitBtn;
    bbtnCancelEM: TBitBtn;
    btnApplyEM: TBitBtn;
    bbtnHelpEM: TBitBtn;
    MessageUpdateFiler: TFMFiler;
    FMGets1: TFMGets;
    stDTLastMessage: TStaticText;
    stInterval: TStaticText;
    procedure btnApplyEMClick(Sender: TObject);
    procedure bbtnOKEMClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure fmeDTLMessExit(Sender: TObject);
    procedure bbtnHelpEMClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmErrorMessageEdit: TfrmErrorMessageEdit;

implementation

uses  MAGBTM1,MagSiteParameters, UnitDM , magWebHelp;

 {$R *.dfm}

procedure TfrmErrorMessageEdit.btnApplyEMClick(Sender: TObject);
begin
   with MessageUpdateFiler do begin
     if AnythingToFile then begin
       Update;
       if ErrorList.Count > 0 then DisplayErrors;
       btnApplyEM.Enabled := false;
       end;
     end;
end;

procedure TfrmErrorMessageEdit.bbtnOKEMClick(Sender: TObject);
begin
  with MessageUpdateFiler do
    if AnythingToFile then begin
      Update;
      if ErrorList.Count > 0 then DisplayErrors;
      end;
    frmErrorMessageEdit.Close;
end;

procedure TfrmErrorMessageEdit.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ModalResult := mrOK ;
end;

procedure TfrmErrorMessageEdit.fmeDTLMessExit(Sender: TObject);
begin
  with Sender as TFMEdit do begin
    if FMModified then
    if (Sender as TFMEdit).Validate then begin
       MessageUpdateFiler.AddChgdControl(Sender as TFMEdit);
       btnApplyEM.Enabled := true;
      end;
    end;

end;

procedure TfrmErrorMessageEdit.bbtnHelpEMClick(Sender: TObject);
begin
  Application.CreateForm(TfrmMagBPHelp,frmMagBPHelp);
  frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
 'help\MAG_BP_User_Manual.htm#_Toc278963037');

end;

end.
