unit MagNetLoc;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: BP Network Location editor
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

interface

uses
  Windows,Variants, Fmcmpnts, Fmlookup, Diaccess, StdCtrls, Buttons,
  Controls, Fmcntrls, ExtCtrls, Classes, Messages, SysUtils, Graphics, Forms, Dialogs,
  OleCtrls, Trpcb,MFunStr,FileCtrl, eftfut, TeeProcs, TeEngine,
  Chart, Series,fmagDirectoryDialog,StrUtils,hash;

type
  TMagFileServer = RECORD
     Path   : String[100];
     Size   : TLargeInteger;
     Space  : TLargeInteger;
     Used   : TLargeInteger;
     end;

  TfrmMagNet = class(TForm)
    FMHelp1: TFMHelp;
   // FMFiler1: TFMFiler;
    FMValidator1: TFMValidator;
    FMLookUp1: TFMLookUp;
    pnl1: TPanel;
    gbCacheIDs: TGroupBox;
    fmeName: TFMEdit;
    fmcbOnline: TFMCheckBox;
    fmcbHash: TFMCheckBox;
    fmcbRouter: TFMCheckBox;
    bbtnOK: TBitBtn;
    bbtnCancel: TBitBtn;
    fmrgStorageType: TFMRadioGroup;
    gbNetworkShareCredentials: TGroupBox;
    fmeUName: TFMEdit;
    gbMuse: TGroupBox;
    fmeMuseSN: TFMEdit;
    fmcbMuseV: TFMComboBoxLookUp;
    FMLister2: TFMLister;
    fmePassword: TFMEdit;
    fmgNetLoc: TFMGets;
    fmcbConnection: TFMCheckBox;
    gbRouting: TGroupBox;
    fmeConn: TFMEdit;
    fmeTrans: TFMEdit;
    fmcbRPAbstract: TFMCheckBox;
    fmcbBIG: TFMCheckBox;
    fmcbFull: TFMCheckBox;
    fmcbText: TFMCheckBox;
    fmcbDICOM: TFMCheckBox;
    fmeRetention: TFMEdit;
    fmeSubdirectory: TFMEdit;
    bbtnApply: TBitBtn;
    FMGets1: TFMGets;
    gbNetworkShare: TGroupBox;
    BitBtnShareDialog: TBitBtn;
    fmeNetworkPath: TFMEdit;
    fmcbReadOnly: TFMCheckBox;
    BitBtn1: TBitBtn;
    BitBtnProperties: TBitBtn;
    gbStorageType2: TGroupBox;
    fmlblStorageType: TFMLabel;
    fmeSite: TFMEdit;
    STStorageType: TStaticText;
    STHashed: TStaticText;
    stName: TStaticText;
    stUserName: TStaticText;
    stPassword: TStaticText;
    stSiteNum: TStaticText;
    stVersNum: TStaticText;
    stMaxNumRetryonConnect: TStaticText;
    stMxNumTran: TStaticText;
    stRetentionPeriod: TStaticText;
    stSite: TStaticText;
    stSubdirectory: TStaticText;
    stAST1: TStaticText;
    stAST2: TStaticText;
    stAST3: TStaticText;
    procedure UpdateEditList(FMFile,FMField,IENs,Value:string;EditList: TStringList);
    function PartialSearch(Search: string;SearchList: TStringList): integer;
    procedure ProcList(EditList: TStringList;ChangedCtrlsList:Tlist);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure fmeNameExit(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure bbtnOKClick(Sender: TObject);
    procedure bbtnCancelClick(Sender: TObject);
    procedure fmeUNameClick(Sender: TObject);
    procedure fmcbMuseVChange(Sender: TObject);
    procedure bbtnHelpClick(Sender: TObject);
    procedure EnableFMC(IEN: string;CompOn: boolean;Sender: TObject);
    procedure GroupBoxUpdate(Sender: TObject;Enable:boolean);
    procedure bbtnApplyClick(Sender: TObject);
    procedure bbtnDirectoryDialogClick(Sender: TObject);
    procedure fmeNetworkPathExit(Sender: TObject);
    procedure BitBtnPropertiesClick(Sender: TObject);
    procedure fmeNetworkPathKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure fmrgStorageTypeExit(Sender: TObject);
    function DiskFree32(var FileServer: TMagFileServer): Boolean;
    procedure F1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    function BrowseDialog(const Title: string; const Flag: integer): string;
    procedure FreeList(List: TList);
    procedure GraphShare(NetPath: string);
    procedure MagNetShow(iens: string);
    procedure MagNetNew;
    procedure fmeNameKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure fmeUNameKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure fmeSiteExit(Sender: TObject);
    procedure fmeSiteKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure fmcbOnlineClick(Sender: TObject);
    procedure GCCfmePasswordKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure BitBtn1Click(Sender: TObject);
    procedure fmeNameMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure fmeHiddenChange(Sender: TObject);
    procedure fmePasswordKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure gbNetworkShareExit(Sender: TObject);
    procedure BitBtnShareDialogExit(Sender: TObject);
    procedure fmcbRouterClick(Sender: TObject);
    function RouterAttribute(Sender: TObject; var StorageType: string): boolean;
    function CheckKey :boolean;

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMagNet: TfrmMagNet;
  AddRecord: boolean;
  ien: string;
  NLEditlist: TStringlist;
  NLChangedCtrlsList : TList;
  RouterB: boolean;
  OnMagNetShow: boolean;
implementation
uses Magbtm1, UnitDM,ShellAPI, ShlObj{,MagGraphShare}, MagGraphShare,
  MagSiteParameters,MAGNetLoc2, magWebHelp;
{$R *.DFM}

procedure TfrmMagNet.UpdateEditList(FMFile,FMField,IENs,Value:string;EditList: TStringList);
var SearchListIndex:integer;
begin
 SearchListIndex := PartialSearch(FMFile+'^'+FMField+'^'+IENS+'^',Editlist);
 if SearchListIndex <> -1 then Editlist[SearchListIndex] := FMFile+'^'+FMField+'^'+IENS+'^'+Value
 else Editlist.Add(FMFile+'^'+FMField+'^'+IENS+'^'+Value);
end;

function TfrmMagNet.PartialSearch(Search: string;SearchList: TStringList): integer;
  var i: integer;
begin
  result:= -1;
  for i := 0 to Searchlist.Count - 1 do
   if pos(Search,SearchList[i]) <> 0 then result := i;
end;

procedure TfrmMagNet.ProcList(EditList: TStringList;ChangedCtrlsList:Tlist);
var i: integer;
begin
 if (EditList.Count < 1) and (ChangedCtrlsList.Count < 1) then begin
    Windows.MessageBox(frmMagNet.Handle,PChar('Nothing to file!'),' ',MB_SYSTEMMODAL);
    exit;
    end;
  if not dmMain.FDAUpdate('',EditList,ChangedCtrlsList,ien) then
     Windows.MessageBox(frmMagNet.Handle,PChar('Changes not applied!'),' ',MB_SYSTEMMODAL)
  else begin
     frmMagNet.bbtnApply.Enabled := false;
     AddRecord := false;
     Editlist.Clear;
     FreeList(ChangedCtrlsList);
     end;
end;  // ProcList


procedure TfrmMagNet.FormActivate(Sender: TObject);
begin
 if not frmMagNet.Visible then exit;
  {$ifdef Win32}
          SetForegroundWindow(frmMagNet.Handle);
  {$else}
          BringWindowToTop(frmMagNet.Handle);
  {$endif}
  OnMagNetShow := false;
  if AddRecord then begin
     ien := '+1,';
    if fmrgStorageType.ItemIndex <> -1 then
      UpdateEditList(fmrgStorageType.FMFile,fmrgStorageType.FMField,'+1,',fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex],NLEditList);
    MagNetNew;
    if fmrgStorageType.Items[fmrgStorageType.ItemIndex] = 'EKG' then begin
      GroupBoxUpdate(gbNetworkshareCredentials,true);
      GroupBoxUpdate(gbMuse,true);
      EnableFMC(ien,true,fmeUName);
      EnableFMC(ien,true,fmePassword);
      EnableFMC(ien,true,fmeMuseSN);
      EnableFMC(ien,true,fmcbMuseV);
      end;  // EKG
    end
  else begin
    MagNetShow(ien);
    end;
end;
procedure TfrmMagNet.FormCreate(Sender: TObject);
begin
  frmMagNet.Caption := format( '%s - %s',[' '+SiteName+' ',' Network Location Properties ']);
  dmMain.FMComponentInit(self);
  application.ShowHint:=true;
  application.HintPause :=1000;
  application.HintHidePause := 8000;
  frmMagNet.bbtnApply.Enabled := false;
  NLChangedCtrlsList := TList.create;
  NLEditlist := TStringList.Create;
  // Button1.Hint := 'First line'  + #13 + 'Second line' + #13 + 'Third line';
 // ...add more lines as desired...

end;
procedure TfrmMagNet.fmeNameExit(Sender: TObject);
var valid : string;
begin
  with Sender as TFMEdit do begin
    if AddRecord then IENS := '+1,'
    else IENS := ien;
    if not FMModified then exit;
    if length(text) < 1 then begin
      Windows.MessageBox(frmMagNet.Handle,PChar('The Share name is required! '),'',MB_SYSTEMMODAL);
      (Sender as TFMEdit).Text := (Sender as TFMEdit).FMDBExternal; {reset value to previous}
      frmMagNet.bbtnApply.Enabled := false;
      setfocus;
      exit;
      end;
    if (Sender as TFMEdit).FMDBInternal <> (Sender as TFMEdit).Text then begin
        valid :=dmMain.GetVariable('$S($D(^MAG(2005.2,"D","'+IntToStr(magbtm1.place)+'","'+
        (Sender as TFMEdit).text+'")):-1,1:1)');
        if valid <> '1' then begin
          Windows.MessageBox(frmMagNet.Handle,PChar('This Network Location name is already assigned!'),'',MB_SYSTEMMODAL);
          Text := FMDBExternal; {reset value to previous}
          frmMagNet.bbtnApply.Enabled := false;
          SetFocus;
          end
        else begin
          valid :=  dmMain.MagFieldValidate(FMFile,IENS,FMField,'',text);
          if pos('-1',piece(Valid,'^',1)) <> 0 then begin
            Windows.MessageBox(frmMagNet.Handle,PChar('invalid fmeNameExit: '+piece(Valid,'^',2)),'',MB_SYSTEMMODAL);
            frmSiteParameters.SiteParametersDisplayHelp(Sender);
            frmMagNet.bbtnApply.Enabled := false;
            Text := FMDBExternal;
            SetFocus;
            end // if pos('-1',piece(Valid,'^',1)) <> 0
          else begin // validate the key
            UpdateEditList((Sender as TFMEdit).FMFile,(Sender as TFMEdit).FMField,(Sender as TFMEdit).IENS,(Sender as TFMEdit).Text,NLEditList);
            frmMagNet.bbtnApply.Enabled := false;
            if length(fmeNetworkpath.text) > 0 then
              if CheckKey then frmMagNet.bbtnApply.Enabled := true;
            end;
          end; // else Valid
      end; //FMDBInternal <> Text
    end; // with Sender as TFMEdit
end; // fmeUNameClick
procedure TfrmMagNet.bbtnOKClick(Sender: TObject);
var
       I: Integer;
    Temp: TComponent;
   Check: Boolean;
  NewIEN, valid: string;
  Server:  TMagFileServer;
begin
  application.ProcessMessages;
  if (not frmMagNet.bbtnApply.Enabled) then begin
     PostMessage(self.handle, WM_CLOSE, 0, 0);
     frmMagNet.Close;
     application.ProcessMessages;
     exit;
     end;
  if fmrgStorageType.ItemIndex < 0 then begin
    Windows.MessageBox(frmMagNet.Handle,'You must check a Storage Type.','',MB_SYSTEMMODAL) ;
    frmMagNet.bbtnApply.Enabled := false;
    exit;
    end;
  if fmrgStorageType.Items.Count = 0 then begin //StorageType #6
    Windows.MessageBox(frmMagNet.Handle,'You must check a Storage Type.','',MB_SYSTEMMODAL) ;
    frmMagNet.bbtnApply.Enabled := false;
    exit;
    end;
  if Length(fmeName.text) < 3 then begin  // NETWORK LOCATION #.01
    Windows.MessageBox(frmMagNet.Handle,'You must enter a 3 Character or longer Share Name.','',MB_SYSTEMMODAL) ;
    frmMagNet.bbtnApply.Enabled := false;
    exit;
    end;
  if AddRecord then begin
    //if not a RAID Group then the networkpath is required
    if pos(fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex],'GRP') <> 0 then begin
        Windows.MessageBox(frmMagNet.Handle,'Use the "Add Group" button on the Network locations window to add a group','',MB_SYSTEMMODAL) ;
        exit;
        end; //if AddRecord
     valid :=  dmMain.MagFieldValidate(fmeNetworkpath.FMFile,fmeNetworkpath.IENS,fmeNetworkpath.FMField,'',fmeNetworkpath.text) ;
     if pos('-1',piece(Valid,'^',1)) <> 0 then begin
       Windows.MessageBox(frmMagNet.Handle,PChar('Invalid network path: '+piece(Valid,'^',2)),'',MB_SYSTEMMODAL);
       frmSiteParameters.SiteParametersDisplayHelp(fmeNetworkpath);
       fmeNetworkpath.Text := fmeNetworkpath.FMCtrlExternal;
       fmeNetworkpath.SetFocus;
       frmMagNet.bbtnApply.Enabled := false;
       exit;
       end; // if pos('-1',piece(Valid,'^',1)) <> 0
      if (NLEditList.Count > 0) or (NLChangedCtrlsList.Count > 0) then begin
        UpdateEditList('2005.2','.04','+1,',IntToStr(magbtm1.place),NLEditList);
        UpdateEditList('2005.2','5','+1,',fmcbOnline.FMValueChecked,NLEditList);
        end; // if AnythingToFile
    //note the p39 SRS states that the GCC USERNAME and PASSWORD are no longer required
    if (pos(fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex],'MAG') <> 0) then begin
        Server.Path := fmeNetworkpath.text;
        if DiskFree32(Server) then begin
          UpdateEditList('2005.2','4','+1,',IntToStr(Server.Space),NLEditList);
          UpdateEditList('2005.2','2','+1,',IntToStr(Server.Size),NLEditList);
          end;// if magbtmf1.DiskFree32(Server)
        UpdateEditList('2005.2','7','+1,','Y',NLEditList);
        UpdateEditList('2005.2','5.5','+1,',fmcbReadOnly.FMValueUnchecked,NLEditList);
        end;// if 'MAG'
    if (pos(fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex],'WORM-OTG') <> 0) then begin
        Server.Path := fmeNetworkpath.text;
        if DiskFree32(Server) then begin
          UpdateEditList('2005.2','4','+1,',IntToStr(Server.Space),NLEditList);
          UpdateEditList('2005.2','2','+1,',IntToStr(Server.Size),NLEditList);
          end;// if magbtmf1.DiskFree32(Server)
        UpdateEditList('2005.2','7','+1,','Y',NLEditList);
        UpdateEditList('2005.2','5.5','+1,',fmcbReadOnly.FMValueUnchecked,NLEditList);
        end;// 'WORM-OTG'
    if (pos(fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex],'RTR') <> 0) then begin
        UpdateEditList('2005.2','7','+1,','Y',NLEditList);
        end;// 'RTR'
    end; // if AddRecord
    if (pos(fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex],'EKG') <> 0) then
      if not AddRecord then begin
        if Length(fmeUName.FMCtrlExternal)= 0 then begin
          Windows.MessageBox(frmMagNet.Handle,PChar('Share credentials in the form of a user name is required.'),'',MB_SYSTEMMODAL) ;
          fmeUName.SetFocus;
          frmMagNet.bbtnApply.Enabled := false;
          exit;
          end;  // if Length(fmeUName.FMCtrlExternal)= 0
        if Length(fmePassword.FMCtrlExternal)= 0 then begin
          Windows.MessageBox(frmMagNet.Handle,PChar('Share credentials in the form of a password is required.'),'',MB_SYSTEMMODAL) ;
          fmePassword.SetFocus;
          frmMagNet.bbtnApply.Enabled := false;
          exit;
          end; // if Length(fmePassword.FMCtrlExternal)= 0
        if Length(fmeMuseSN.FMCtrlExternal)= 0 then begin
          Windows.MessageBox(frmMagNet.Handle,PChar('The Muse Site number is required for this share.'),'',MB_SYSTEMMODAL) ;
          fmeMuseSN.SetFocus;
          frmMagNet.bbtnApply.Enabled := false;
          exit;
          end; // if Length(fmeMuseSN.FMCtrlExternal)= 0
        if Length(fmcbMuseV.FMCtrlExternal) < 2  then begin
          Windows.MessageBox(frmMagNet.Handle,PChar('The Muse version number is required for this share.'),'',MB_SYSTEMMODAL) ;
          fmcbMuseV.SetFocus;
          frmMagNet.bbtnApply.Enabled := false;
          exit;
          end; // if Length(fmcbMuseV.FMCtrlExternal) < 2
        end; // if pos(fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex],'EKG')
    if (NLEditList.Count > 0) or (NLChangedCtrlsList.Count > 0) then begin
        ProcList(NLEditList,NLChangedCtrlsList);
        if (NLEditList.Count > 0) or (NLChangedCtrlsList.Count > 0) then begin
           Windows.MessageBox(frmMagNet.Handle,PChar('Changes were not applied!'),'',MB_SYSTEMMODAL) ;          end; // else key valid
      end; // else Record.update
    frmMagNet.bbtnApply.Enabled := false;
    if (Sender as TBitBtn).Name = 'bbtnApply' then MagNetShow(ien)
    else frmMagNet.ModalResult := mrCancel;
  end;  //bbtnOKClick

procedure TfrmMagNet.bbtnCancelClick(Sender: TObject);
begin
  PostMessage(self.handle, WM_CLOSE, 0, 0);
  frmMagNet.Close;
  application.ProcessMessages;
end;

procedure TfrmMagNet.fmcbMuseVChange(Sender: TObject);
var valid: string;
begin
 with sender as TFMComboBox do begin
   if AddRecord then IENS := '+1,'
   else IENS := ien;
   if FMModified then begin
     valid :=  dmMain.MagFieldValidate((sender as TFMComboBox).FMFile,(sender as TFMComboBox).IENS,(sender as TFMComboBox).FMField,'',(sender as TFMComboBox).text) ;
     if pos('-1',piece(Valid,'^',1)) <> 0 then begin
       Windows.MessageBox(frmMagNet.Handle,PChar('Invalid fmcbMuseVChange: '+piece(Valid,'^',2)),'',MB_SYSTEMMODAL);
       frmSiteParameters.SiteParametersDisplayHelp(Sender);
       (sender as TFMComboBox).Text := (sender as TFMComboBox).FMCtrlExternal;
       end
     else begin
       FMCtrlInternal := piece(Valid,'^',2);
       FMCtrlExternal := piece(Valid,'^',3);
       UpdateEditList((sender as TFMComboBox).FMFile,(sender as TFMComboBox).FMField,(sender as TFMComboBox).IENS,(sender as TFMComboBox).GetSelectedRecord.IEN,NLEditList);
       end;
     end; // if Modified
   end; // with sender
   frmMagNet.bbtnApply.Enabled := CheckKey;
end; // fmcbMuseVChange
(*
procedure TfrmMagNet.fmrgStorageTypeClick(Sender: TObject);
begin
  with Sender as TFMRadioGroup do begin
    if AddRecord then IENS := '+1,'
    else begin
      IENS := ien;
      exit;
      end;
    if fmrgStorageType.FMCtrlInternal = 'GRP' then begin
      Windows.MessageBox(frmMagNet.Handle,'A new group must be added using the Network Location Manager','',MB_SYSTEMMODAL) ;
      exit;
      end;
    if IENS <> '' then begin
      if (fmrgStorageType.FMCtrlInternal = 'MAG') or (fmrgStorageType.FMCtrlInternal = 'WORM-OTG') then begin
        fmcbHash.Checked := true;
        EnableFMC(IENS,false,fmcbHash);
        UpdateEditList(fmcbHash.FMFile,fmcbHash.IENS,fmcbHash.FMField,fmcbHash.FMCtrlInternal,NLEditList);
        UpdateEditList(FMFile,IENS,FMField,FMCtrlInternal,NLEditList);
        frmMagNet.bbtnApply.Enabled := true
        end;
      if Validate then begin
        if ((FMInternalCodes.Count > 0) and
        AddRecord) then magnetshow(IENS);
        FMFiler1.AddFDA(FMFile,IENS,FMField,FMCtrlInternal);
        if ValidateNewLoc(self,FMField) then
          frmMagNet.bbtnApply.Enabled := true
        else begin
          frmSiteParameters.SiteParametersDisplayHelp(Sender);
          frmMagNet.bbtnApply.Enabled := false;
          end; // else ValidateNewLoc
        end // if validate
      else begin
        frmSiteParameters.SiteParametersDisplayHelp(Sender);
        frmMagNet.bbtnApply.Enabled := false;
        FMFiler1.AddFDA(FMFile,IENS,FMField,FMCtrlInternal);
        end;  // else Validate
      end; // if IENS <> ''
    end; //with Sender
end; //StorageTypeClick
*)
procedure TfrmMagNet.fmeUNameClick(Sender: TObject);
var valid : string;

begin
  with Sender as TFMEdit do begin
    if AddRecord then IENS := '+1,'
    else IENS := ien;
    if (Sender as TFMEdit).FMModified then begin
      valid :=  dmMain.MagFieldValidate(FMFile,IENS,FMField,'',text);
      if pos('-1',piece(Valid,'^',1)) <> 0 then begin
        Windows.MessageBox(frmMagNet.Handle,PChar('Invalid Input: '+piece(Valid,'^',2)),'',MB_SYSTEMMODAL);
        frmSiteParameters.SiteParametersDisplayHelp(Sender);
        Text := FMDBExternal;
        end
      else begin
        FMCtrlInternal := piece(Valid,'^',2);
        FMCtrlExternal := piece(Valid,'^',3);
        if Not OnMagNetShow then begin
          UpdateEditList((Sender as TFMEdit).FMFile,(Sender as TFMEdit).FMField,(Sender as TFMEdit).IENS,(Sender as TFMEdit).FMCtrlInternal,NLEditList);
          // Validate Key
          if length(fmeNetworkpath.text) > 0 then
            if CheckKey then frmMagNet.bbtnApply.Enabled := true
            else frmMagNet.bbtnApply.Enabled := false;
           end; //if Not OnMagNetShow
        end; // else Valid
      end; //FMDBInternal <> Text
    end; // with Sender as TFMEdit
end; // fmeUNameClick
procedure TfrmMagNet.bbtnHelpClick(Sender: TObject);
begin
application.HelpContext(12);
end;
procedure TfrmMagNet.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  FreeList(NLChangedCtrlsList);
  FreeAndNil(NLChangedCtrlsList);
  NLEditList.free;
  frmMagNet.ModalResult := mrCancel;
  Action := caFree;
end;
procedure TfrmMagNet.EnableFMC(IEN: string;CompOn: boolean;Sender: TObject);
  begin
    if pos('TFMCheckBox',Sender.ClassName) <> 0 then begin
      with sender as TFMCheckbox do begin
       (sender as TFMCheckbox).iens:= ien;
       (sender as TFMCheckbox).visible := CompOn;
       (sender as TFMCheckbox).enabled := CompOn;
       (sender as TFMCheckbox).TabStop := CompOn;
       end; // with sender as TFMCheckbox
      exit;
      end; // if pos('TFMCheckBox'
    if pos('TFMComboBoxLookUp',Sender.ClassName) <> 0 then begin
      with sender as TFMComboBoxLookup do begin
        iens:= ien;
        if CompOn then
          if FMDBInternal <> FMCtrlInternal then
            UpdateEditList(FMFile,FMField,IENS,FMCtrlInternal,NLEditList);
        visible := CompOn;
        enabled := CompOn;
        TabStop := CompOn;
        end; // with sender as TFMComboBoxLookup
      exit;
      end; // if pos('TFMComboBoxLookUp'
    if pos('TFMEdit',Sender.ClassName) <> 0  then begin
      with sender as TFMEdit do begin
        if CompOn then
          if FMDBInternal <> FMCtrlInternal then
            UpdateEditList(FMFile,FMField,IENS,FMCtrlInternal,NLEditList);
        visible := CompOn;
        enabled := CompOn;
        TabStop := CompOn;
        iens:= ien;
        end; //with sender as TFMEdit
     exit;
     end; //  if pos('TFMEdit',
    if pos('TFMRadioGroup',Sender.ClassName) <> 0 then begin
      with sender as TFMRadioGroup do begin
        if CompOn then
          if FMDBInternal <> FMCtrlInternal then
            UpdateEditList(FMFile,FMField,IENS,FMCtrlInternal,NLEditList);
        visible := CompOn;
        enabled := CompOn;
        TabStop := CompOn;
        iens:= ien;
        end; // with sender as TFMRadioGroup
      exit;
      end; // if pos('TFMRadioGroup',
  end; // EnableFMC

procedure TfrmMagNet.GroupBoxUpdate(Sender: TObject;Enable:boolean);
var i: integer;
   rec: string;
begin
  if AddRecord then rec := '+1,'
  else rec :=  fmgNetLoc.IENS;
  with Sender as TGroupBox do begin
    for i := 0 to ControlCount-1 do begin
      if Controls[i] is TFMCheckBox then
        with Controls[i] as TFMCheckBox do begin
          Enabled := Enable;
          IENS := rec;
          if Enable then visible := true//color := clWindow
          else visible := false;//color := clLtGray;
          end;
      if Controls[i] is TFMEdit then
        with Controls[i] as TFMEdit do begin
          Enabled := Enable;
          IENS := rec;
          if Enable then visible := true//color := clWindow
          else visible := false;//color := clLtGray;
          end;
      if Controls[i] is TLabel then
        with Controls[i] as TLabel do begin
         enabled:= Enable;
         if Enable then visible := true//Font.color := clWindowText
         else visible := false;//Font.color := clLtGray;
         end;
     if Controls[i] is TFMComboBoxLookup then
        with Controls[i] as TFMComboBoxLookup do begin
         enabled:= Enable;
         IENS := rec;
         if Enable then visible := true//color := clWindow
         else visible := false;//color := clLtGray;
         end;
      end;
      (Sender as TGroupBox).Visible := enable;
    end;  // Sender as TGroupBox
end;
procedure TfrmMagNet.bbtnApplyClick(Sender: TObject);
begin
  bbtnOKClick(bbtnApply);
end;

procedure TfrmMagNet.bbtnDirectoryDialogClick(Sender: TObject);
var
    valid,sTitle, sFolder: string;
    iFlag : integer;
begin // bbtnDirectoryDialogClick
 //http://delphi.about.com/od/windowsshellapi/l/aa122803a.htm
  Application.NormalizeTopMosts;
  SetWindowPos(frmMagNet.Handle, HWND_NOTOPMOST, 0,0,0,0,
    SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
  sTitle := 'Network Location';
  iFlag :=  BIF_RETURNONLYFSDIRS;
  with fmeNetworkPath do begin
    fmeNetworkPath.Text := BrowseDialog(sTitle, iFlag);
    if pos(':',fmeNetworkPath.Text) <> 0 then fmeNetworkPath.Text := ExpandUNCFileName(fmeNetworkPath.Text);
    if fmeNetworkPath.FMDBExternal <> fmeNetworkPath.Text then fmeNetworkPathExit(fmeNetworkPath);
    end;// with fmeNetworkPath
  Application.NormalizeTopMosts;
  SetWindowPos(frmMagNet.Handle, HWND_TOPMOST, 0,0,0,0,
    SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
end; // bbtnDirectoryDialogClick
{BrowseInfo structure
Two of the main elements of BrowseInfo are the lpszTitle and ulFlags fields. The dialog box displays the contents of lpszTitle in a static text control above the treeview. The ulFlags element sets the value which determines what the dialog displays and allows the user to select.
We can specify zero or more of the flags in order to make the dialog box much more useful than just browsing for folders. Some of the flags that can be specified to enhance the Browse For Folders dialog box are:

Value Meaning
BIF_BROWSEFORCOMPUTER Only returns computers.
  If the user selects anything other than a computer, the OK button is grayed.
BIF_BROWSEFORPRINTER Only returns printers.
  If the user selects anything other than a printer, the OK button is grayed.
BIF_RETURNONLYFSDIRS Only returns file system directories.
  If the user selects folders that aren't part of the file system, the OK button is grayed.
BIF_BROWSEINCLUDEFILES The browse dialog will display files as well as folders
BIF_DONTGOBELOWDOMAIN	Does not include network folders below the domain level
   in the tree view control.  For example, to browse for both folders and files
   the ulFlags should be set to BIF_BROWSEINCLUDEFILES.
 }
function TfrmMagNet.BrowseDialog(const Title: string; const Flag: integer): string;
var
  lpItemID : PItemIDList;
  BrowseInfo : TBrowseInfo;
  DisplayName : array[0..MAX_PATH] of char;
  TempPath : array[0..MAX_PATH] of char;
begin
  Result:='';
  FillChar(BrowseInfo, sizeof(TBrowseInfo), #0);
  with BrowseInfo do begin
    hwndOwner := Application.Handle;
    pszDisplayName := @DisplayName;
    lpszTitle := PChar(Title);
    ulFlags := Flag;
    end;  //with BrowseInfo
  lpItemID := SHBrowseForFolder(BrowseInfo);
  if lpItemId <> nil then begin
    SHGetPathFromIDList(lpItemID, TempPath);
    Result := TempPath;
    GlobalFreePtr(lpItemID);
    end;  //if lpItemId <> nil
end; // BrowseDialog

procedure TfrmMagNet.fmeNetworkPathExit(Sender: TObject);
var Screen,valid,ExistingIEN: string;

begin
//  if bbtnCancel.Focused then exit;
//  if BitBtnShareDialog.Focused then exit;
  with Sender as TFMEdit do begin
    if pos(':',(Sender as TFMEdit).Text) <> 0 then begin
      (Sender as TFMEdit).Text := ExpandUNCFileName((Sender as TFMEdit).Text);
      end;  //if pos(':',Text) <> 0
    if AddRecord then IENS := '+1,';
    if ((Sender as TFMEdit).Text= '') then begin
      Windows.MessageBox(frmMagNet.Handle,PChar('The Network Share is required! '),'',MB_SYSTEMMODAL);
      (Sender as TFMEdit).Text := (Sender as TFMEdit).FMDBExternal; {reset value to previous}
      frmMagNet.bbtnApply.Enabled := false;
      exit;
      end;
    if RightStr((Sender as TFMEdit).Text,1) <> '\' then (Sender as TFMEdit).Text := (Sender as TFMEdit).Text +'\';
    if (Sender as TFMEdit).FMDBEXternal <> (Sender as TFMEdit).Text then begin
        valid :=dmMain.GetVariable('$S($D(^MAG(2005.2,"G","'+IntToStr(magbtm1.place)+'","'+text+'")):-1,1:1)');
        if valid <> '1' then begin
          Windows.MessageBox(frmMagNet.Handle,PChar('This network share is already assigned!'),'',MB_SYSTEMMODAL);
          (Sender as TFMEdit).Text := (Sender as TFMEdit).FMDBInternal; {reset value to previous}
          frmMagNet.bbtnApply.Enabled := false;
          Setfocus;
          end
        else begin
          valid :=  dmMain.MagFieldValidate(FMFile,IENS,FMField,'',text);
          if pos('-1',piece(Valid,'^',1)) <> 0 then begin
            Windows.MessageBox(frmMagNet.Handle,PChar('Invalid fmeNetworkPath: '+piece(Valid,'^',2)),'',MB_SYSTEMMODAL);
            frmSiteParameters.SiteParametersDisplayHelp(Sender);
            (Sender as TFMEdit).Text := (Sender as TFMEdit).FMDBExternal;
            frmMagNet.bbtnApply.Enabled := false;
            Setfocus;
            end
          else begin
            (Sender as TFMEdit).FMCtrlInternal := piece(Valid,'^',2);
            (Sender as TFMEdit).FMCtrlExternal := piece(Valid,'^',3);
            bitbtnProperties.Enabled := true;
            bitbtnProperties.TabStop := true;
            UpdateEditList((Sender as TFMEdit).FMFile,(Sender as TFMEdit).FMField,(Sender as TFMEdit).IENS,(Sender as TFMEdit).Text,NLEditList);
            // Validate Key
            if length(fmeNetworkpath.text) > 0 then
              if CheckKey then frmMagNet.bbtnApply.Enabled := true
              else frmMagNet.bbtnApply.Enabled := false;
              end;  // else valid
        end; // valid - non-duplicate
      end; // if FMDBInternal <> Text
    end; //with Sender as TFMEdit
end;

procedure TfrmMagNet.BitBtnPropertiesClick(Sender: TObject);
begin
  GraphShare(fmeNetworkPath.FMCtrlExternal);
end;
procedure TfrmMagNet.fmeNetworkPathKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  SystemParametersInfo(SPI_SETBEEP, 1, nil, SPIF_SENDWININICHANGE);
   If Key = VK_Return Then Begin
    If HiWord(GetKeyState(VK_SHIFT)) <> 0 then
     SelectNext(Sender as TWinControl,False,True)
    else
     SelectNext(Sender as TWinControl,True,True) ;
     Key := VK_TAB
   end;
  SystemParametersInfo(SPI_SETBEEP, 0, nil, SPIF_SENDWININICHANGE);
end;
procedure TfrmMagNet.fmrgStorageTypeExit(Sender: TObject);
var valid: string;
    SearchListIndex: integer;
begin
  with Sender as TFMRadioGroup do begin
    if AddRecord then IENS := '+1,'
    else IENS := ien;
    UpdateEditList(FMFile,FMField,IENS,FMInternalCodes[fmrgStorageType.ItemIndex],NLEditList);
    if fmrgStorageType.Items[fmrgStorageType.ItemIndex] = 'GRP' then begin
      Windows.MessageBox(frmMagNet.Handle,PChar('A new group must be added using the Network Location Manager'),'',MB_SYSTEMMODAL) ;
      exit;
      end;
    if fmrgStorageType.ItemIndex < 0 then begin
      Windows.MessageBox(frmMagNet.Handle,PChar('Storage type is a required field!'),'',MB_SYSTEMMODAL) ;
      exit;
      end;
    if length(fmeNetworkpath.text) <> 0 then begin
      valid :=  dmMain.MagFieldValidate(fmeNetworkpath.FMFile,fmeNetworkpath.IENS,fmeNetworkpath.FMField,'',fmeNetworkpath.text) ;
      if (pos('-1',piece(Valid,'^',1)) = 0)then begin
        valid :=  dmMain.MagFieldValidate(fmeName.FMFile,fmeName.IENS,fmeName.FMField,'',fmeName.text) ;
        if (pos('-1',piece(Valid,'^',1)) = 0)then begin
          if CheckKey then frmMagNet.bbtnApply.Enabled := true
          else frmMagNet.bbtnApply.Enabled := false;
          end; // if (pos('-1',
        end; // if (pos('-1',
      end; // if length(
    if AddRecord then
     if (fmrgStorageType.Items[fmrgStorageType.ItemIndex] = 'EKG') then begin
       GroupBoxUpdate(gbNetworkshareCredentials,true);
       GroupBoxUpdate(gbMuse,true);
       EnableFMC(IENS,true,fmeUName);
       EnableFMC(IENS,true,fmePassword);
       EnableFMC(IENS,true,fmeMuseSN);
       EnableFMC(IENS,true,fmcbMuseV);
       end
     else begin //clear inappropriate attributes and remove associated values from the editlist
       GroupBoxUpdate(gbMuse,false);
       SearchListIndex := PartialSearch(FMFile+'^'+fmeMuseSN.FMField+'^'+IENS+'^',NLEditlist);
       if SearchListIndex <> -1 then NLEditlist.Delete(SearchListIndex);
       SearchListIndex := PartialSearch(FMFile+'^'+fmcbMuseV.FMField+'^'+IENS+'^',NLEditlist);
       if SearchListIndex <> -1 then NLEditlist.Delete(SearchListIndex);
       if (fmrgStorageType.Items[fmrgStorageType.ItemIndex] <> 'GCC') and
        (fmrgStorageType.Items[fmrgStorageType.ItemIndex] <> 'RTR') then begin
           GroupBoxUpdate(gbNetworkshareCredentials,false);
           SearchListIndex := PartialSearch(FMFile+'^'+fmeUName.FMField+'^'+IENS+'^',NLEditlist);
           if SearchListIndex <> -1 then NLEditlist.Delete(SearchListIndex);
           SearchListIndex := PartialSearch(FMFile+'^'+fmePassword.FMField+'^'+IENS+'^',NLEditlist);
           if SearchListIndex <> -1 then NLEditlist.Delete(SearchListIndex);
           end; // neither GCC RTR or EKG
       end; // Clear invalid attributes from the editlist
    end;// with Sender as TFMRadioGroup
end;

function TfrmMagNet.DiskFree32(var FileServer: TMagFileServer): Boolean;
function spcopy(input:string): LPSTR;
var size:integer;
begin
  size:=length(input);
  result:=stralloc(size+1);
  strpcopy(result,input);
end;//DiskFree.spcopy

var
  GetDiskfreeSpaceEx: Function(lpDirectoryName: string;
                    var lpFreeBytesAvailableToCaller,
                      lpTotalNumberOfBytes,
                      lpTotalNumberOfFreeBytes: Int64): Bool; STDCALL;
//                    lpTotalNumberOfFreeBytes: TLargeInteger): Bool; STDCALL;
  ServerPath:string;
  Error : string;
  hlib: THandle;
 // FreeBAU,TotNumBytes,TotNumFree: TLargeInteger;
   FreeBAU,TotNumBytes,TotNumFree: Int64;
const megabyte = 1000000;
begin
  hlib := GetModuleHandle('kernel32');
  if hlib <> 0 then
    begin
      GetDiskFreeSpaceEx := GetProcAddress(hlib, 'GetDiskFreeSpaceExA');
      ServerPath := FileServer.Path;
      result := GetDiskFreeSpaceEx(ServerPath,FreeBAU,TotNumBytes,TotNumFree);
      with FileServer do begin
        size := TotNumBytes div megabyte;
        space := TotNumFree div megabyte;
        used :=  (TotNumBytes - TotNumFree) div megabyte;
        end;
    end
  else result:= false;
//  GetDiskFreeSpaceEx := nil;
  if not FreeLibrary(hlib) then begin
    Error := IntToStr(GetLastError);
    Windows.MessageBox(frmMagNet.Handle,'not FreeLibrary','',MB_SYSTEMMODAL) ;
    end;
end;


procedure TfrmMagNet.F1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin  if key = VK_F1 then
     frmSiteParameters.F1KeyDown(Sender,Key,Shift);
end;
procedure TfrmMagNet.FreeList(List: TList);
var
  index: integer;
  cnt: integer;
begin
  for index := List.Count - 1 downto 0 do
  begin
    dispose(List.Items[index]);
    List.Delete(index);
  end;
end;


procedure TfrmMagNet.GraphShare(NetPath: string);
var
   Server: TMagFileServer;
   SizeStr,FreeStr,UsedStr: string;
   ServerList: TStringList;
begin
  Server.Path := NetPath; //+'\';
  ServerList := TStringList.Create;
  if Diskfree32(Server) then begin
    FreeStr := FloatToStrF((Server.Space / 1000),ffGeneral,4,4);
    SizeStr := FloatToStrF((Server.Size / 1000),ffGeneral,4,4);
    UsedStr := FloatToStrF((Server.Used / 1000),ffGeneral,4,4);
    ServerList.Add('Space Used: ^'+UsedStr);
    ServerList.Add('Free Space: ^'+FreeStr);
    Application.CreateForm(TfrmMagGraph,frmMagGraph);
    frmMagGraph.Caption := Format('%s - %s',[' VistA Imaging Storage: '+NetPath,TimeToStr(Now)]);
    with frmMagGraph.Chart1 do begin
      Title.Text.Add('Share: '+NetPath);
      Title.Text.Add('Space in Megabytes');
      Title.Text.Add('Capacity: '+FloatToStrF((Server.Size / 1000),ffGeneral,4,4));
      Title.Color := clWhite;
      Frame.Visible := True ;
      Frame.Color := clBlue ;
      Frame.Width := 1 ;
      Frame.Style := psDot ;
      frmMagGraph.Chart1.Title.Repaint;
      end; //with frmMagGraph.Chart1
    frmMagGraph.GraphDisplay(ServerList,1,frmMagGraph.Chart1);
    frmMagGraph.ShowModal;
    frmMagGraph.Free;
    end //if MAGBTMF1.Diskfree32(Server);
    else
      Windows.MessageBox(frmMagNet.Handle,'This share is not currently available on the network!','',MB_SYSTEMMODAL) ;
end;

procedure TfrmMagNet.MagNetShow(IENS: string);
//display or redisplay Network location record
var
  i: integer;
  StorageType: string;
begin
  OnMagNetShow := true;
  ien := iens;
  bbtnOK.Enabled := true;
  fmgNetLoc.IENS := iens;
  fmcbMuseV.IENS := iens;
  fmcbMuseV.GetList;
  EnableFMC(iens,true,fmlblStorageType);
  fmlblStorageType.Visible := true;
  EnableFMC(iens,false,fmrgStorageType);
  GroupBoxUpdate(gbStorageType2,true);
  fmgNetLoc.GetAndFill;
  STStorageType.Caption := fmlblStorageType.Caption;
  fmlblStorageType.Visible := false;
  RouterB := RouterAttribute(fmcbRouter,StorageType);
  if fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex] = 'GCC' then begin  // GCC
     EnableFMC(IENS,true,fmeName);
     GroupBoxUpdate(gbNetworkshare,true);
     GroupBoxUpdate(gbNetworkshareCredentials,true);
     EnableFMC(IENS,true,fmeUName);
     EnableFMC(IENS,true,fmePassword);
     GroupBoxUpdate(gbRouting,false);
     EnableFMC(IENS,true,fmcbOnline);
     EnableFMC(IENS,false,fmcbReadonly);
     EnableFMC(IENS,false,fmcbRouter);
     EnableFMC(IENS,true,fmcbHash);
     EnableFMC(IENS,false,fmcbConnection);
     GroupBoxUpdate(gbMuse,false);
    end;
  if fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex] = 'GRP' then begin   // Group
     EnableFMC(IENS,true,fmeName);
     GroupBoxUpdate(gbNetworkshare,false);
     GroupBoxUpdate(gbNetworkshareCredentials,false);
     GroupBoxUpdate(gbRouting,false);
     EnableFMC(IENS,true,fmcbOnline);
     EnableFMC(IENS,true,fmcbReadonly);
     EnableFMC(IENS,false,fmcbRouter);
     EnableFMC(IENS,false,fmcbHash);
     EnableFMC(IENS,false,fmcbConnection);
     GroupBoxUpdate(gbMuse,false);
    end;
  if fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex] = 'EKG' then begin  // EKG
     EnableFMC(IENS,true,fmeName);
     GroupBoxUpdate(gbNetworkshare,true);
     GroupBoxUpdate(gbNetworkshareCredentials,true);
     EnableFMC(IENS,true,fmeUName);
     EnableFMC(IENS,true,fmePassword);
     GroupBoxUpdate(gbRouting,false);
     EnableFMC(IENS,true,fmcbOnline);
     EnableFMC(IENS,false,fmcbReadonly);
     EnableFMC(IENS,false,fmcbRouter);
     EnableFMC(IENS,false,fmcbHash);
     EnableFMC(IENS,false,fmcbConnection);
     GroupBoxUpdate(gbMuse,true);
     fmcbMuseV.GetList;
     end;
  if fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex] = 'URL' then begin // URL
     EnableFMC(IENS,true,fmeName);
     GroupBoxUpdate(gbNetworkshare,true);
     GroupBoxUpdate(gbNetworkshareCredentials,false);
     GroupBoxUpdate(gbRouting,false);
     EnableFMC(IENS,true,fmcbOnline);
     EnableFMC(IENS,false,fmcbReadonly);
     EnableFMC(IENS,false,fmcbRouter);
     EnableFMC(IENS,false,fmcbHash);
     EnableFMC(IENS,false,fmcbConnection);
     GroupBoxUpdate(gbMuse,false);
     end;
  if (fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex] = 'MAG') and
    (not routerB) then begin // RAID
//      (fmcbRouter.FMCtrlInternal=fmcbRouter.FMValueUnchecked) then begin // RAID
     EnableFMC(IENS,true,fmeName);
     GroupBoxUpdate(gbNetworkshare,true);
     GroupBoxUpdate(gbNetworkshareCredentials,false);
     GroupBoxUpdate(gbRouting,false);
     EnableFMC(IENS,true,fmcbOnline);
     EnableFMC(IENS,true,fmcbReadonly);
     EnableFMC(IENS,false,fmcbRouter);
     fmcbHash.Checked := true;
     EnableFMC(IENS,false,fmcbHash);
     STHashed.Visible := true;
     STHashed.Top := fmcbHash.Top;
     STHashed.Left := fmcbhash.Left;
     if fmcbHash.Checked then STHashed.Caption := 'Hashed'
     else STHashed.Caption := 'Unhashed';
     EnableFMC(IENS,false,fmcbConnection);
     GroupBoxUpdate(gbMuse,false);
     end;
  if pos('WORM',fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex]) <> 0  then begin  // Jukebox
     EnableFMC(IENS,true,fmeName);
     GroupBoxUpdate(gbNetworkshare,true);
     GroupBoxUpdate(gbNetworkshareCredentials,false);
     GroupBoxUpdate(gbRouting,false);
     EnableFMC(IENS,true,fmcbOnline);
     EnableFMC(IENS,true,fmcbReadonly);
     EnableFMC(IENS,false,fmcbRouter);
     fmcbHash.Checked := true;
     EnableFMC(IENS,false,fmcbHash);
     STHashed.Visible := true;
     STHashed.Top := fmcbHash.Top;
     STHashed.Left := fmcbhash.Left;
     if fmcbHash.Checked then STHashed.Caption := 'Hashed'
     else STHashed.Caption := 'Unhashed';
     EnableFMC(IENS,false,fmcbConnection);
     GroupBoxUpdate(gbMuse,false);
     end;
  if (fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex] = 'RTR') or
  ((fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex] = 'MAG') and (RouterB))
      then begin                                              // Router
     EnableFMC(IENS,true,fmeName);
     GroupBoxUpdate(gbNetworkshare,true);
     GroupBoxUpdate(gbNetworkshareCredentials,true);
     EnableFMC(IENS,true,fmeUName);
     EnableFMC(IENS,true,fmePassword);
     GroupBoxUpdate(gbRouting,true);
     EnableFMC(IENS,true,fmcbOnline);
     EnableFMC(IENS,true,fmcbReadonly);
     if fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex] = 'RTR' then
       EnableFMC(IENS,false,fmcbRouter)
     else EnableFMC(IENS,true,fmcbRouter);
     EnableFMC(IENS,false,fmcbHash);
     STHashed.Visible := true;
     STHashed.Top := fmcbHash.Top;
     STHashed.Left := fmcbhash.Left;
     if fmcbHash.Checked then STHashed.Caption := 'Hashed'
     else STHashed.Caption := 'Unhashed';
     stSite.Visible := true;
     EnableFMC(IENS,true,fmeSite);
     EnableFMC(IENS,false,fmcbConnection);
     GroupBoxUpdate(gbMuse,false);
    end;
  if fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex] = 'DGM' then begin    // Diagram
     EnableFMC(IENS,true,fmeName);
     GroupBoxUpdate(gbNetworkshare,true);
     GroupBoxUpdate(gbNetworkshareCredentials,false);
     GroupBoxUpdate(gbRouting,false);
     EnableFMC(IENS,true,fmcbOnline);
     EnableFMC(IENS,false,fmcbReadonly);
     EnableFMC(IENS,false,fmcbRouter);
     EnableFMC(IENS,false,fmcbHash);
     EnableFMC(IENS,false,fmcbConnection);
     GroupBoxUpdate(gbMuse,false);
    end;
  Application.ProcessMessages;
  frmMagNet.bbtnApply.Enabled := false;
  OnMagNetShow := false;
end;

procedure TfrmMagNet.MagNetNew;
var
   i : integer;
   classN,iens : ShortString;
begin
  AddRecord := true;
  iens := '+1,';
  ien:= IENS;
  STHashed.Visible := false;
  EnableFMC(iens,true,fmeNetworkPath);
  EnableFMC(iens,false,fmlblStorageType);
  GroupBoxUpdate(gbStorageType2,false);
  fmlblStorageType.Visible := false;
  EnableFMC(iens,false,fmeSite);
  stSite.Visible := false;
  EnableFMC(iens,true,fmeName);
  EnableFMC(iens,false,fmcbOnline);
  EnableFMC(iens,true,fmrgStorageType);
  EnableFMC(iens,false,fmcbOnline);
  EnableFMC(iens,false,fmcbRouter);
  EnableFMC(iens,false,fmcbReadOnly);
  EnableFMC(iens,false,fmcbHash);
  EnableFMC(iens,false,fmeMuseSN);
  EnableFMC(iens,false,fmcbMuseV);
  EnableFMC(iens,false,fmeUName);
  EnableFMC(iens,false,fmePassword);
  EnableFMC(iens,false,fmcbConnection);
  GroupBoxUpdate(gbNetWorkShare,true);
  GroupBoxUpdate(gbRouting,false);
  GroupBoxUpdate(gbNetworkShareCredentials,false);
  GroupBoxUpdate(gbMuse,false);
  frmMagNet.ActiveControl := fmeName;
  fmeName.SetFocus;
  bitbtnProperties.Enabled := false;
  bitbtnProperties.TabStop := false;
  fmrgStorageType.Items.Delete(fmrgStorageType.Items.IndexOf('RAID GROUP'));
end;

procedure TfrmMagNet.fmeNameKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  SystemParametersInfo(SPI_SETBEEP, 1, nil, SPIF_SENDWININICHANGE);
   If Key = VK_Return Then Begin
    If HiWord(GetKeyState(VK_SHIFT)) <> 0 then
     SelectNext(Sender as TWinControl,False,True)
    else
     SelectNext(Sender as TWinControl,True,True) ;
     Key := VK_TAB
   end;
  SystemParametersInfo(SPI_SETBEEP, 0, nil, SPIF_SENDWININICHANGE);
end;

procedure TfrmMagNet.fmeUNameKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  SystemParametersInfo(SPI_SETBEEP, 1, nil, SPIF_SENDWININICHANGE);
   If Key = VK_Return Then Begin
    If HiWord(GetKeyState(VK_SHIFT)) <> 0 then
     SelectNext(Sender as TWinControl,False,True)
    else
     SelectNext(Sender as TWinControl,True,True) ;
     Key := VK_TAB
   end;
  SystemParametersInfo(SPI_SETBEEP, 0, nil, SPIF_SENDWININICHANGE);
end;

procedure TfrmMagNet.fmeSiteExit(Sender: TObject);
var valid : string;
begin
  with Sender as TFMEdit do begin
    if AddRecord then IENS := '+1,'
    else IENS := ien;
    if FMDBInternal <> Text then begin
      valid :=  dmMain.MagFieldValidate((Sender as TFMEdit).FMFile,(Sender as TFMEdit).IENS,(Sender as TFMEdit).FMField,'',(Sender as TFMEdit).text) ;
      if pos('-1',piece(Valid,'^',1)) <> 0 then begin
        Windows.MessageBox(frmMagNet.Handle,PChar('Invalid fmeSite: '+piece(Valid,'^',2)),'',MB_SYSTEMMODAL);
        frmSiteParameters.SiteParametersDisplayHelp(Sender);
        (Sender as TFMEdit).Text := (Sender as TFMEdit).FMDBExternal; {reset value to previous}
        end // if pos('-1',piece(Valid,'^',1)) <> 0
      else begin
        FMCtrlInternal := piece(Valid,'^',2);
        FMCtrlExternal := piece(Valid,'^',3);
        UpdateEditList((Sender as TFMEdit).FMFile,(Sender as TFMEdit).FMField,(Sender as TFMEdit).IENS,(Sender as TFMEdit).text,NLEditList);
        end; //else begin
      end; //FMDBInternal <> Text
    end; // with Sender as TFMEdit
  frmMagNet.bbtnApply.Enabled := CheckKey;
end; // fmeUNameClick

procedure TfrmMagNet.fmeSiteKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  SystemParametersInfo(SPI_SETBEEP, 1, nil, SPIF_SENDWININICHANGE);
   If Key = VK_Return Then Begin
    If HiWord(GetKeyState(VK_SHIFT)) <> 0 then
     SelectNext(Sender as TWinControl,False,True)
    else
     SelectNext(Sender as TWinControl,True,True) ;
     Key := VK_TAB
   end;
  SystemParametersInfo(SPI_SETBEEP, 0, nil, SPIF_SENDWININICHANGE);

end;

procedure TfrmMagNet.fmcbOnlineClick(Sender: TObject);
  var valid: string;
begin
  with sender as TFMCheckBox do begin
    if AddRecord then (sender as TFMCheckBox).IENS := '+1,'
    else (sender as TFMCheckBox).IENS := ien;
    if Not OnMagNetShow then begin
      if (sender as TFMCheckBox).Checked then (sender as TFMCheckBox).FMCtrlInternal := (sender as TFMCheckBox).FMValueChecked
      else (sender as TFMCheckBox).FMCtrlInternal := (sender as TFMCheckBox).FMValueUnchecked;
      UpdateEditList((sender as TFMCheckBox).FMFile,(sender as TFMCheckBox).FMField,(sender as TFMCheckBox).IENS,(sender as TFMCheckBox).FMCtrlInternal,NLEditList);
      // Validate Key
      if length(fmeNetworkpath.text) > 0 then
         if CheckKey then frmMagNet.bbtnApply.Enabled := true
         else frmMagNet.bbtnApply.Enabled := false;
      end;
    end; // with Sender...
end;

procedure TfrmMagNet.GCCfmePasswordKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  SystemParametersInfo(SPI_SETBEEP, 1, nil, SPIF_SENDWININICHANGE);
   If Key = VK_Return Then Begin
    If HiWord(GetKeyState(VK_SHIFT)) <> 0 then
     SelectNext(Sender as TWinControl,False,True)
    else
     SelectNext(Sender as TWinControl,True,True) ;
     Key := VK_TAB
   end;
  SystemParametersInfo(SPI_SETBEEP, 0, nil, SPIF_SENDWININICHANGE);
end;

procedure TfrmMagNet.BitBtn1Click(Sender: TObject);
begin
  Application.CreateForm(TfrmMagBPHelp,frmMagBPHelp);

  Case fmrgStorageType.ItemIndex of
    0: begin  // RAID
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help/MAG_BP_User_Manual.htm#_Toc315344972');
       end; //case 0 // RAID
     1: begin // Jukebox
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help/MAG_BP_User_Manual.htm#_Toc315344973');
         end; // Case 1 JukeBox
     2: begin   // EKG
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help\MAG_BP_User_Manual.htm#_Toc315344976');
         end; //Case 4 EKG
     3: begin    // GCC
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help/MAG_BP_User_Manual.htm#_Toc315344975');
         end;  // case ActivePageIndex of 3 GCC
     4: begin   // Diagrams
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help\MAG_BP_User_Manual.htm#_Toc315344978');
        end; // Case 6 Diagrams
     5: begin   // URLs
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help\MAG_BP_User_Manual.htm#_Toc315344977');
        end; //Case 5 URLs
     6: begin // Routers
         frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help/MAG_BP_User_Manual.htm#_Toc315344974');
        end; // Case 2 Routers

  end; //case






end;

procedure TfrmMagNet.fmeNameMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  fmeNameExit(Sender);
end;
procedure TfrmMagNet.fmeHiddenChange(Sender: TObject);
var valid: string;
begin
  with Sender as TFMEdit do begin
     if FMModified then begin
      if AddRecord then IENS := '+1,'
      else IENS := ien;
      valid :=  dmMain.MagFieldValidate(FMFile,IENS,FMField,'',text);
      if pos('-1',piece(Valid,'^',1)) <> 0 then begin
        Windows.MessageBox(frmMagNet.Handle,PChar('Invalid fmeHidden: '+piece(Valid,'^',2)),'',MB_SYSTEMMODAL);
        frmSiteParameters.SiteParametersDisplayHelp(Sender);
        Text := FMDBExternal; {reset value to previous}
        end
      else begin
        FMCtrlInternal := piece(Valid,'^',2);
        FMCtrlExternal := piece(Valid,'^',3);
        UpdateEditList((Sender as TFMEdit).FMFile,(Sender as TFMEdit).FMField,(Sender as TFMEdit).IENS,(Sender as TFMEdit).FMCtrlInternal,NLEditList);
        // Validate Key
            if length(fmeNetworkpath.text) > 0 then begin
               valid :=
                 dmMain.MagFieldValidate(fmeNetworkpath.FMFile,fmeNetworkpath.IENS,fmeNetworkpath.FMField,'',fmeNetworkpath.text) ;
               if (pos('-1',piece(Valid,'^',1)) = 0) and (fmrgStorageType.ItemIndex <> -1) then
                 if CheckKey then frmMagNet.bbtnApply.Enabled := true
                 else frmMagNet.bbtnApply.Enabled := false;
              end; //validate Networkpath
        end; // else Valid
      end; // FMModified
  end;  // with Sender as TFMEdit
end;

procedure TfrmMagNet.fmePasswordKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  SystemParametersInfo(SPI_SETBEEP, 1, nil, SPIF_SENDWININICHANGE);
  If Key = VK_Return Then Begin
   If HiWord(GetKeyState(VK_SHIFT)) <> 0 then
    SelectNext(Sender as TWinControl,False,True)
   else
    SelectNext(Sender as TWinControl,True,True) ;
    Key := VK_TAB
  end;
  SystemParametersInfo(SPI_SETBEEP, 0, nil, SPIF_SENDWININICHANGE);
end;

procedure TfrmMagNet.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
  var Control: TControl;
          hHandle    : THandle;
          sClassName : String;
  begin
   // debugging tAB KEY SEQUENCE ONLY
   // if key = VK_TAB then begin
   // To get the handle of the active control.
   // hHandle    := Screen.ActiveControl.Handle;
   // To get the class name of the active control.
   // sClassName := Screen.ActiveControl.ClassName;
   // Windows.MessageBox(frmMagNet.Handle,PChar(sClassName),'',MB_SYSTEMMODAL);
   // TO FORCE AN ERROR FOR EUREKALOG
   //  Control := nil;
   //  Control.Enabled := false; // force an exception;
   // end;
end;

procedure TfrmMagNet.gbNetworkShareExit(Sender: TObject);
begin
  fmeNetworkPathExit(fmeNetworkPath);
end;

procedure TfrmMagNet.BitBtnShareDialogExit(Sender: TObject);
begin
  fmeNetworkPathExit(fmeNetworkPath);
end;



function TfrmMagNet.RouterAttribute(Sender: TObject; var StorageType: string): boolean;
var
  routerS: string;
begin
  if AddRecord then (sender as TFMCheckBox).IENS := '+1,'
  else (sender as TFMCheckBox).IENS := MagNetLoc.ien;
  storageType := dmMain.GetVariable('$S($D(^MAG(2005.2,'+piece(MagNetLoc.ien,',',1)+',0)):$P(^MAG(2005.2,'+piece(MagNetLoc.ien,',',1)+',0),U,7),1:"")');
  if not AddRecord then
    routerS := dmMain.GetVariable('$S($D(^MAG(2005.2,'+piece(MagNetLoc.ien,',',1)+',0)):$P(^MAG(2005.2,'+piece(MagNetLoc.ien,',',1)+',0),U,9),1:"")')
  else routerS := '';
  Result := not ((length(routerS)<0) or (routerS = '0')); // null or 0 equates to no router attribute set
end; // RouterAttribute

procedure TfrmMagNet.fmcbRouterClick(Sender: TObject);
var
  routerS,storageType,valid: string;
  checkedL,RouterB: boolean;
begin  // fmcbRouterClick(
  with sender as TFMCheckBox do begin
    routerB := RouterAttribute(Sender,StorageType);
    if (pos('MAG',storageType) <> 0) then // if "MAG" Storage type without Router attribute set, disallow edit of Router attribute
      if (not routerB) and (sender as TFMCheckBox).Checked then
        (sender as TFMCheckBox).Checked := routerB;
    if (pos('MAG',storageType) <> 0) and (not routerB) then EnableFMC(IENS,false,fmcbRouter)
    else EnableFMC(IENS,true,fmcbRouter);
      if Not OnMagNetShow then begin
        if (sender as TFMCheckBox).Checked then (sender as TFMCheckBox).FMCtrlInternal := (sender as TFMCheckBox).FMValueChecked
        else (sender as TFMCheckBox).FMCtrlInternal := (sender as TFMCheckBox).FMValueUnchecked;
          UpdateEditList((sender as TFMCheckBox).FMFile,(sender as TFMCheckBox).FMField,(sender as TFMCheckBox).IENS,(sender as TFMCheckBox).FMCtrlInternal,NLEditList);
        // Validate Key
        if length(fmeNetworkpath.text) > 0 then
          if CheckKey then frmMagNet.bbtnApply.Enabled := true
          else frmMagNet.bbtnApply.Enabled := false;
        end; // Not OnMagNetShow
    end; // with Sender...
end;  // fmcbRouterClick(

function TfrmMagNet.CheckKey:boolean;
var
  KeyList:TStringList;
  CheckCtrls: TList;
  Valid: string;
begin
  result := false;
  KeyList := TStringList.Create;
  CheckCtrls := TList.Create;
  UpdateEditList(fmrgStorageType.FMFile,fmrgStorageType.FMField,fmrgStorageType.IENS,fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex],KeyList);
  UpdateEditList(fmeName.FMFile,fmeName.FMField,fmeName.IENS,fmeName.Text,KeyList);
  UpdateEditList(fmeNetworkpath.FMFile,fmeNetworkpath.FMField,fmeNetworkpath.IENS,fmeNetworkpath.Text,KeyList);
  valid := dmMain.MagKeyValidate('Q',Keylist,CheckCtrls);
  if pos('-1',piece(Valid,'^',1)) <> 0 then
     Windows.MessageBox(frmMagNet.Handle,PChar('Invalid record Key: '+piece(Valid,'^',2)),'',MB_SYSTEMMODAL)
  else result := true;
  KeyList.Free;
  CheckCtrls.Free;
  if result then
    if pos(fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex],'EKG') <> 0 then begin
    if AddRecord then
      result := (fmeUName.Text <>'') and
                (fmePassword.Text <>'') and
                (fmeMuseSN.Text <>'') and
                (fmcbMuseV.Text <>'')
    else
      result := (fmeUName.FMDBExternal <>'') and
                (fmePassword.FMDBExternal <>'') and
                (fmeMuseSN.FMDBExternal <>'') and
                (fmcbMuseV.FMDBExternal <>'') and
                (NLEditList.Count > 0);

      end; // if pos(fmrgStorageType.FMInternalCodes[fmrgStorageType.ItemIndex],'EKG')
end;

end.

