unit MagPurge2;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: Main BP Queue Processor
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)
//  Generalize the calling code from the MAGBTM1 routine so that the raid and jukebox lists use the same code efficiently
//  Make sure the Jukebox shares are updating the Network location file with the size space available etc
//  Be sure and add a print function
// background for printDialog issue: https://forums.codegear.com/thread.jspa?threadID=17410
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, OleCtrls,ExtCtrls,MFunStr, Trpcb, TeEngine, Series,
  TeeProcs, Chart, TeeShape, Menus, ComCtrls, ToolWin, printers;

type
  TfrmMagPurge2 = class(TForm)
    pcNetworkShares: TPageControl;
    tsRAIDShares: TTabSheet;
    tsJukeboxShare: TTabSheet;
    tsRAIDGroups: TTabSheet;
    chtRAIDShares: TChart;
    Series2: TBarSeries;
    chtJukeboxShares: TChart;
    BarSeries1: TBarSeries;
    chtRAIDGroups: TChart;
    Series5: TBarSeries;
    ToolBar1: TToolBar;
    tbRefresh: TToolButton;
    tbRefreshAll: TToolButton;
    tbExit: TToolButton;
    tbStyle: TToolButton;
    tbShapes: TToolButton;
    MainMenu1: TMainMenu;
    mnuEdit: TMenuItem;
    tbPrint: TToolButton;
    mnuRefresh: TMenuItem;
    mnuRefreshAll: TMenuItem;
    mnuStyle: TMenuItem;
    mnuShapes: TMenuItem;
    mnuPrint: TMenuItem;
    mnuExit: TMenuItem;
    Series3: TBarSeries;
    Series1: TBarSeries;
    Series4: TBarSeries;
    Series6: TBarSeries;
    PieSeries1: TBarSeries;
    procedure GraphDisplay(ServerList: TStringList;
      index:integer;TheChart: TChart);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure mnuPrint1Click(Sender: TObject);
    procedure tbRefreshClick(Sender: TObject);
    procedure tbRefreshAllClick(Sender: TObject);
    procedure tbExitClick(Sender: TObject);
    procedure tbStyleClick(Sender: TObject);
    procedure tbShapesClick(Sender: TObject);
    function GetIntValue(Value:string):Integer;
    procedure FormActivate(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
     tmpX,tmpY:Longint;
  end;
Const
  BarStyleMax = 7;
var
  frmMagPurge2: TfrmMagPurge2;
  BarStyleActive,SeriesActive: integer;
  cwl,crg: string;
  printDialog: TPrintDialog;
implementation

uses Magbtm1,UnitDM;
{$R *.DFM}
function TfrmMagPurge2.GetIntValue(Value:string):Integer;
  var  code: integer;
  begin
  Val(Value,Result,Code);
  if (code <> 0) then result := 0;
  end;
procedure TfrmMagPurge2.GraphDisplay
(ServerList: TStringList;index:integer;
      TheChart: TChart);

//ColorPalette : Array[1..MaxDefaultColors] of TColor = (clRed, clGreen, clYellow,
//clBlue, clWhite, clGray, clFuchsia, clTeal, clNavy, clMaroon, clLime, clOlive, clPurple, clSilver, clAqua, clBlack);

var
 i,j,k: integer;
 size,space,reserve,sreserve,temp: string;
// ffGeneral : TFormatSettings;
begin
//  GetLocaleFormatSettings(LOCALE_SYSTEM_DEFAULT, ffGeneral);
  crg := dmMain.GetFieldValue('2006.1','.031',IntToStr(magbtm1.place)+',','I',true); // Current RAID Group
  cwl := piece(ServerList.Strings[0],'^',2);
  if TheChart.Name = 'chtRAIDShares' then
  frmMagPurge2.Caption := Format('%s - %s - %s',
    [Magbtm1.SiteCode +  ' Vista Storage: ',TimeToStr(Now),'Current Write Location: '+ piece(ServerList.Strings[0],'^',5)]);
  reserve := IntToStr(GetIntValue(dmMain.GetFieldValue('2006.1','11',IntToStr(magbtm1.place)+',','I',true)));
  // note reserve is represented as a percentage and defaults to 5 if not greater than zero
  if StrToInt(reserve) <= 0 then reserve := '5';
  SeriesActive := 0;
  with TheChart do begin
     for i := 0 to SeriesCount - 1 do SeriesList[i].Clear;
     for i := 0 to ServerList.Count - 1 do begin
       k := GetIntValue(piece(ServerList.Strings[i],'^',index));
       size := FloatToStrF(k,ffGeneral,9,4);
       k := GetIntValue(piece(ServerList.Strings[i],'^',index + 1));
       space := FloatToStrF(k,ffGeneral,9,4);
       if StrToFloat(size) > 0  then sreserve := FloatToStrF(((StrToFloat(reserve)* StrToFloat(size)) / 100),ffGeneral,4,4)
       else sreserve := '0';
         TheChart.Series[0].AddY(StrToFloat(Size),piece(ServerList.Strings[i],'^',5),ColorPalette[i+1]);
         TheChart.Series[1].AddY(StrToFloat(Space),'FreeSpace ',ColorPalette[i+1]);
       if TheChart.Name <> 'chtJukeboxShares'  then
         TheChart.Series[2].AddY(StrToFloat(SReserve),'Reserve ',ColorPalette[i+1]);
       end;
     Visible := true;
     end; // with The Chart...
//     tbShapes.Visible := false;
  //   mnuShapes.Enabled := false;
 end;

procedure TfrmMagPurge2.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  MAGBTMF1.mnuServerSize.checked := false;
end;

procedure TfrmMagPurge2.FormResize(Sender: TObject);
begin
{  with grphCauchePurge2 do begin
    case frmMagPurge2.WindowState of
      wsNormal : begin
                   FontUse := 0;
                   FontSize := 200;
                   FontUse := 2;
                   FontSize := 50;
                   FontUse := 3;
                   FontSize := 50;
                 end;
      wsMinimized : begin
                      FontUse := 4;
                      FontSize := 50;
                   end;
      wsMaximized : begin
                      FontUse := 4;
                      FontSize := 400;
                   end;
    end; //case frmMagPurge2.WindowState
    DrawMode :=2;
  end; // with grphCauchePurge2}
end;

procedure TfrmMagPurge2.FormCreate(Sender: TObject);
begin
  pcNetworkShares.ActivePageIndex := 0;
  MAGBTMF1.ServerSize('Group');
  MAGBTMF1.ResetCurrentServer('0');

end;

procedure TfrmMagPurge2.Timer1Timer(Sender: TObject);
var j: integer;
begin
  frmMagPurge2.Caption := Format('%s - %s - %s',
    [Magbtm1.SiteCode +  ' Vista Storage: ',TimeToStr(Now),'Current Write Location: '+ cwl]);
    for j := 0 to frmMagPurge2.ComponentCount -1 do
     if frmMagPurge2.Components[j] is TChart then begin
       if (frmMagPurge2.Components[j] as TChart).SeriesList[SeriesActive].ClassName <> 'TPieSeries' then exit;
    with (frmMagPurge2.Components[j] as TChart) do begin
      if tmpX>0 then begin
        if (SeriesList[SeriesActive] as TPieSeries).XRadius+tmpX>ChartWidth div 3 then
         tmpX := -tmpX;
        end
      else if (SeriesList[SeriesActive] as TPieSeries).XRadius+tmpX<30 then tmpX:=-tmpX;
      (SeriesList[SeriesActive] as TPieSeries).CustomXRadius:=(SeriesList[SeriesActive] as TPieSeries).XRadius+tmpX;
      if tmpY>0 then begin
        if (SeriesList[SeriesActive] as TPieSeries).YRadius+tmpY>ChartHeight div 3 then
         tmpY:=-tmpY;
      end
      else if (SeriesList[SeriesActive] as TPieSeries).YRadius+tmpY<30 then tmpY:=-tmpY;
       (SeriesList[SeriesActive] as TPieSeries).CustomYRadius:=(SeriesList[SeriesActive] as TPieSeries).YRadius+tmpY;
      end;
      end;
end;


procedure TfrmMagPurge2.mnuPrint1Click(Sender: TObject);
begin
  with PrintDialog do begin
   if Execute then begin
     chtRAIDShares.Print;
     chtJukeboxShares.Print;
     chtRAIDGroups.Print;
     end; //if Execute
    end; //with PrintDialog1
end;

procedure TfrmMagPurge2.tbRefreshClick(Sender: TObject);
begin
 MAGBTMF1.ServerSize('Group');
 MAGBTMF1.ResetCurrentServer('0');
end;

procedure TfrmMagPurge2.tbRefreshAllClick(Sender: TObject);
begin
 MAGBTMF1.ServerSize('ALL');
 MAGBTMF1.ResetCurrentServer('0');
end;

procedure TfrmMagPurge2.tbExitClick(Sender: TObject);
begin
 close;
end;

procedure TfrmMagPurge2.tbStyleClick(Sender: TObject);
var i,j : integer;
begin
try
  inc(SeriesActive);
  if SeriesActive > chtRAIDShares.SeriesCount - 1 then SeriesActive := 0;
  for j := 0 to frmMagPurge2.ComponentCount -1 do
     if frmMagPurge2.Components[j] is TChart then
    for i := 0 to (frmMagPurge2.Components[j] as TChart).SeriesCount-1 do
      if i <> SeriesActive then (frmMagPurge2.Components[j] as TChart).SeriesList[i].Active := false
      else (frmMagPurge2.Components[j] as TChart).SeriesList[SeriesActive].Active := true;
  case SeriesActive of
    0: begin
         tbShapes.Visible := false;
         mnuShapes.Enabled := false;
         end;
    1: begin
         tbShapes.Visible := true;
         mnuShapes.Enabled := true;
         end;
    2: begin
         tbShapes.Visible := true;
         mnuShapes.Enabled := true;
         end;
    end; //case
  except
    Windows.MessageBox(frmMagPurge2.Handle,PChar('Except'),' ',MB_SYSTEMMODAL)
    end;
end;

procedure TfrmMagPurge2.tbShapesClick(Sender: TObject);
var j :integer;
begin
    inc(BarStyleActive);
    if BarStyleActive > (BarStyleMax - 1 ) then BarStyleActive := 0;
//    if Chart1.Series[t] is TLineSeries then
//		(Chart1.Series[t] as TLineSeries).LinePen.Width:=3;
  for j := 0 to frmMagPurge2.ComponentCount -1 do
     if frmMagPurge2.Components[j] is TChart then begin
       if (frmMagPurge2.Components[j] as TChart).SeriesList[SeriesActive] is TBarSeries then
         ((frmMagPurge2.Components[j] as TChart).SeriesList[SeriesActive] as TBarSeries).BarStyle := TBarStyle(BarStyleActive);
       if (frmMagPurge2.Components[j] as TChart).SeriesList[SeriesActive] is THorizBarSeries then
         ((frmMagPurge2.Components[j] as TChart).SeriesList[SeriesActive] as THorizBarSeries).BarStyle := TBarStyle(BarStyleActive);
       end;
end;

procedure TfrmMagPurge2.FormActivate(Sender: TObject);
begin

{
  if Printer.printerindex > 0 then begin
    printdialog := TPrintdialog.Create(frmMagPurge2);
      // Set up print dialog options
    printDialog.MinPage := 1;               // First allowed page number
    printDialog.MaxPage := 2;     // Highest allowed page number
    printDialog.ToPage  := 2;     // 1 to ToPage page range allowed
    printDialog.Options := [poPageNums];    // Allow page
    Printdialog.PrintToFile := true;
    mnuPrint.Enabled := true;
    end
  else MainMenu1.Items[MainMenu1.Items.IndexOf(mnuprint)].Enabled := false;
 }
end;

end.
