unit MagQueuePurgeByType;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: BP Queue Manager Utility
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Fmcntrls, Buttons, Diaccess, Fmcmpnts,RpcConf1,Trpcb,
  ComCtrls, ExtCtrls;

type
  TfrmQPurgeByType = class(TForm)
    FMFindOne1: TFMFindOne;
    fmlQueuePointer: TFMLister;
    fmgQueuePointer: TFMGets;
    PCPurgeByType: TPageControl;
    TSFailed: TTabSheet;
    TSActive: TTabSheet;
    cbActiveDelete: TCheckBox;
    cbActiveGCC: TCheckBox;
    cbActiveImport: TCheckBox;
    cbActiveJBTOHD: TCheckBox;
    cbActiveJukebox: TCheckBox;
    cbActivePrefet: TCheckBox;
    cbActiveEval: TCheckBox;
    fmlActivePrefetchCnt: TFMLabel;
    fmlActiveEvalCnt: TFMLabel;
    fmlActiveJukeboxCnt: TFMLabel;
    fmlActiveJBTOHDCnt: TFMLabel;
    fmlActiveImportCnt: TFMLabel;
    fmlActiveGccCnt: TFMLabel;
    fmlActiveDeleteCnt: TFMLabel;
    fmlActiveAbstractCnt: TFMLabel;
    cbActiveAbstract: TCheckBox;
    cbFailedAbstract: TCheckBox;
    fmlFailedAbstractcnt: TFMLabel;
    cbFailedDelete: TCheckBox;
    fmlFailedDeleteCnt: TFMLabel;
    cbFailedGCC: TCheckBox;
    fmlFailedGCCCnt: TFMLabel;
    cbFailedImport: TCheckBox;
    fmlFailedImportCnt: TFMLabel;
    cbFailedJBTOHD: TCheckBox;
    fmlFailedJBTOHDCnt: TFMLabel;
    cbFailedJukebox: TCheckBox;
    fmlFailedJukeboxCnt: TFMLabel;
    cbFailedPrefetch: TCheckBox;
    fmlFailedPrefetchCnt: TFMLabel;
    cbFailedEval: TCheckBox;
    fmlFailedEvalCnt: TFMLabel;
    btnFailedPurge: TButton;
    btnFailedRequeue: TButton;
    btnActivePurge: TButton;
    stFailedAction: TStaticText;
    stActiveAction: TStaticText;
    Panel1: TPanel;
    bbtnOKQueuePartition: TBitBtn;
    bbtnCancelQueuePartition: TBitBtn;
    btnApplyQueuePartition: TBitBtn;
    bbtnHelp: TBitBtn;
    procedure ProcessQueuePartitionForm(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure GetCountsQueuePartition(Active: boolean;CntLabel:TFMLabel; Queue: string);
    procedure bbtnCancelQueuePartitionClick(Sender: TObject);
    procedure bbtnOKQueuePartitionClick(Sender: TObject);
    procedure ProcessQueuePartition(Queue,Process,Start,Stop,Place: string);
    procedure btnApplyQueuePartitionClick(Sender: TObject);
    procedure btnCBClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormActivate(Sender: TObject);
    procedure btnActivePurgeClick(Sender: TObject);
    procedure bbtnHelpClick(Sender: TObject);
    procedure PCPurgeByTypeChange(Sender: TObject);
    procedure btnFailedRequeueClick(Sender: TObject);
    procedure btnFailedPurgeClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmQPurgeByType: TfrmQPurgeByType;
  PurgeB,ReQueueB: boolean;
implementation
uses Magbtm1, UnitDM, magWebHelp;
{$R *.dfm}

procedure TfrmQPurgeByType.FormCreate(Sender: TObject);
begin
  dmMain.FMComponentInit(self);
  PCPurgeByType.ActivePageIndex := 0;
  btnApplyQueuePartition.Enabled := false;
  frmQPurgeByType.Caption := format('%s - %s',[' '+Magbtm1.SiteName,'Queue Management by Type']);
  PCPurgeByTypeChange(PCPurgeByType);
end;
procedure  TfrmQPurgeByType.GetCountsQueuePartition(Active: boolean;CntLabel:TFMLabel; Queue: string);
var    rec : string;
  total,count: integer;
begin
    with frmQPurgeByType.fmlQueuePointer do begin
      frmQPurgeByType.fmgQueuePointer.IENS:='';
      Screen :='I (($P(^(0),U,1)="'+Queue+'")&'+
        '($P(^(0),U,4)="'+ IntToStr(magbtm1.place)+'"))';
      ListerFlags := [lfInternal];
      GetList(nil);
      if errorlist.Count > 0 then begin
        displayErrors;
        exit;
        end;
      if Results.Count < 1 then begin
        CntLabel.caption := '0';
        exit;
        end;
      rec := Results[0];
      end;
  if rec = '-1' then
    FMFindOne1.DisplayErrors
  else begin
  // RE-ENTRY HERE DOES NOT WORK
    if StrToInt(rec) > 0 then begin
      frmQPurgeByType.fmgQueuePointer.IENS:=rec+',';
      frmQPurgeByType.fmgQueuePointer.GetData;
      if Length(frmQPurgeByType.fmgQueuePointer.GetField('3').FMDBExternal) < 1 then
        total := 0
      else total := StrToInt(frmQPurgeByType.fmgQueuePointer.GetField('3').FMDBExternal);
      if Length(frmQPurgeByType.fmgQueuePointer.GetField('2').FMDBExternal) < 1 then
      Count := 0
      else Count := StrToInt(frmQPurgeByType.fmgQueuePointer.GetField('2').FMDBExternal);
      if not active then CntLabel.caption := IntToStr(Total-Count)
      else CntLabel.caption := IntToStr(Count) ;
      end
    else
      Windows.MessageBox(frmQPurgeByType.Handle,PChar('No records matched.'),' ',MB_SYSTEMMODAL) ;
    end;
end;

procedure TfrmQPurgeByType.bbtnCancelQueuePartitionClick(Sender: TObject);
begin
  frmQPurgeByType.Close;
end;

procedure TfrmQPurgeByType.bbtnOKQueuePartitionClick(Sender: TObject);
begin
  if btnApplyQueuePartition.Enabled then
     btnApplyQueuePartitionClick(Sender);
  frmQPurgeByType.Close;
end;

procedure TfrmQPurgeByType.ProcessQueuePartition(Queue,Process,Start,Stop,Place: string);
begin
  with dmMain.RPCBroker1 do begin
    Param[0].VALUE := Queue;
    Param[0].PTYPE := LITERAL;
    Param[1].VALUE := Process;
    Param[1].PTYPE := LITERAL;
    Param[2].VALUE := Start;
    Param[2].PTYPE := LITERAL;
    Param[3].VALUE := Stop;
    Param[3].PTYPE := LITERAL;
    Param[4].VALUE := Place;
    Param[4].PTYPE := LITERAL;
    RemoteProcedure := 'MAGQ QRNGE';
    try
      Call;       //call
    except
      On E: EBrokerError do begin
        Application.terminate;
        end;
      end; // try
    end;
end;
procedure TfrmQPurgeByType.ProcessQueuePartitionForm(Sender: TObject);
 var i: integer;
    cb : TCheckbox;
    cl: TColor;
    Process,Start,Stop,temp,QueuePointerIEN: string;
    ActivePartition: boolean;
begin
  Process :='';
  ActivePartition := PCPurgeByType.ActivePageIndex = 1;
  if (ReQueueB) then Process := 'REQ';
  if (PurgeB) then Process := 'DEL';
  if Length(Process) < 3 then begin
    Windows.MessageBox(frmQPurgeByType.Handle,PChar('You must select an Action !'),' ',MB_SYSTEMMODAL) ;
    exit;
    end;
  for i := 0 to PCPurgeByType.ActivePage.ControlCount -1 do begin
    if PCPurgeByType.ActivePage.Controls[i] is TCheckbox then begin
      cb:= TCheckbox(PCPurgeByType.ActivePage.Controls[i]);
      if cb.Checked = true then begin
        cl := cb.Color;
        cb.Color := clHotLight;
        application.ProcessMessages;
        QueuePointerIEN := dmMain.GetVariable('$S($D(^MAGQUEUE(2006.031,"C","'+IntToStr(magbtm1.Place)+'","'+UpperCase(cb.Caption)+'"))'+
                         ':$O(^MAGQUEUE(2006.031,"C","'+IntToStr(magbtm1.Place)+'","'+UpperCase(cb.Caption)+'","0")),1:0)');
        if not ActivePartition then begin
          Start := dmMain.GetVariable('$S($D(^MAGQUEUE(2006.03,"C","'+IntToStr(magbtm1.Place)+'","'+UpperCase(cb.Caption)+'"))'+
            ':$O(^MAGQUEUE(2006.03,"C","'+IntToStr(magbtm1.Place)+'","'+UpperCase(cb.Caption)+'","0")),1:0)');
          Stop := UpperCase(dmMain.GetFieldValue('2006.031','1',QueuePointerIEN+',','I',true));
          end
        else begin  //ActivePartition
        //Start + 1 of the value of the "1" field in 2006.031 for Queue and Place if Active
         Temp := UpperCase(dmMain.GetFieldValue('2006.031','1',QueuePointerIEN+',','I',true));
         Start := dmMain.GetVariable('$S($D(^MAGQUEUE(2006.03,"C","'+IntToStr(magbtm1.Place)+'","'+UpperCase(cb.Caption)+'"))'+
            ':$O(^MAGQUEUE(2006.03,"C","'+IntToStr(magbtm1.Place)+'","'+UpperCase(cb.Caption)+'","'+Temp+'")),1:0)');
        //Stop +$O(^MAGQUEUE(2006.03,"C",PLACE,QUEUE," ",-1)) if Active
        Stop := dmMain.GetVariable('$S($D(^MAGQUEUE(2006.03,"C","'+IntToStr(magbtm1.Place)+'","'+UpperCase(cb.Caption)+'"))'+
            ':$O(^MAGQUEUE(2006.03,"C","'+IntToStr(magbtm1.Place)+'","'+UpperCase(cb.Caption)+'"," "),-1),1:0)');
          end; //ActivePartition
        if (Start <> '0') and (Stop <> '0') then
          ProcessQueuePartition(UpperCase(cb.Caption),Process,Start,Stop,IntToStr(magbtm1.Place));
        cb.Color := cl;
        cb.Checked := false;
        end; //  if (Start <> '0') and (Stop <> '0')
      end;
   end;  // for i := 0 to PCPurgeByType.ActivePage.ControlCount
   ReQueueB := false;
   PurgeB := False;
   stActiveAction.Caption := 'Select an Action';
   stFailedAction.Caption := 'Select an Action';
end; // ProcessQueuePartitionForm
procedure TfrmQPurgeByType.btnCBClick(Sender: TObject);
var i: integer;
begin
  btnApplyQueuePartition.Enabled := false;
  Case PCPurgeByType.ActivePageIndex of
    0: begin  // TSFailed
         if ReQueueB or PurgeB then
           for i := 0 to TSFailed.ControlCount - 1 do
             if (TSFailed.Controls[i] is TCheckbox ) then
               if (TSFailed.Controls[i] as TCheckbox).enabled then
                 if  (TSFailed.Controls[i] as TCheckbox).Checked then
                    btnApplyQueuePartition.Enabled := true;
         end; // TSFailed
    1: begin // TSActive
         if PurgeB then
           for i := 0 to TSActive.ControlCount - 1 do
             if (TSActive.Controls[i] is TCheckbox ) then
               if (TSActive.Controls[i] as TCheckbox).enabled then
                 if  (TSActive.Controls[i] as TCheckbox).Checked then
                    btnApplyQueuePartition.Enabled := true;
       end; // TSFailed
    end; // Case PCPurgeByType
end;


procedure TfrmQPurgeByType.btnApplyQueuePartitionClick(Sender: TObject);
begin
  ProcessQueuePartitionForm(self);
  PCPurgeByTypeChange(PCPurgeByType);
end;


procedure TfrmQPurgeByType.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  frmQPurgeByType.ModalResult := mrCancel;
end;

procedure TfrmQPurgeByType.FormActivate(Sender: TObject);
begin
  {$ifdef Win32}
          SetForegroundWindow(frmQPurgeByType.Handle);
  {$else}
          BringWindowToTop(frmQPurgeByType.Handle);
  {$endif}
  application.ProcessMessages;
end;
procedure TfrmQPurgeByType.btnFailedRequeueClick(Sender: TObject);
var i: integer;
begin
  PurgeB:= false;
  ReQueueB := True;
  stFailedAction.Caption := 'Requeue is the action selected';
  btnApplyQueuePartition.Enabled := false;
  // enable Apply button if any Checkboxes are selected
  for i := 0 to TSFailed.ControlCount - 1 do
    if (TSFailed.Controls[i] is TCheckbox ) then
      if (TSFailed.Controls[i] as TCheckbox).enabled then
        if  (TSFailed.Controls[i] as TCheckbox).Checked then
          btnApplyQueuePartition.Enabled := true;
end;

procedure TfrmQPurgeByType.btnFailedPurgeClick(Sender: TObject);
var I: integer;
begin
  PurgeB:= true;
  ReQueueB := false;
  stFailedAction.Caption := 'Purge is the action selected';
  // enable Apply button if any Checkboxes are selected
  for i := 0 to TSFailed.ControlCount - 1 do
    if (TSFailed.Controls[i] is TCheckbox ) then
      if (TSFailed.Controls[i] as TCheckbox).enabled then
        if  (TSFailed.Controls[i] as TCheckbox).Checked then
          btnApplyQueuePartition.Enabled := true;
end;


procedure TfrmQPurgeByType.btnActivePurgeClick(Sender: TObject);
var i: integer;
begin
  PurgeB:= true;
  ReQueueB := False;
  stActiveAction.Caption := 'Purge is the action selected';
  btnApplyQueuePartition.Enabled := false;
  // enable Apply button if any Checkboxes are selected
  for i := 0 to TSActive.ControlCount - 1 do
    if (TSActive.Controls[i] is TCheckbox ) then
      if (TSActive.Controls[i] as TCheckbox).enabled then
        if (TSActive.Controls[i] as TCheckbox).Checked then
          btnApplyQueuePartition.Enabled := true;
end;
procedure TfrmQPurgeByType.bbtnHelpClick(Sender: TObject);
begin
  Application.CreateForm(TfrmMagBPHelp,frmMagBPHelp);
  frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
 'help/MAG_BP_User_Manual.htm#_Toc269903259');
end;


procedure TfrmQPurgeByType.PCPurgeByTypeChange(Sender: TObject);
var i: integer;
   Active: boolean;
begin
  PurgeB:= false;
  ReQueueB := false;
  btnApplyQueuePartition.Enabled := false;
  stActiveAction.Caption := 'Select an Action';
  stFailedAction.Caption := 'Select an Action';
Case (Sender as TPageControl).ActivePageIndex of
  0: begin  // TSFailed
       for i := 0 to TSActive.ControlCount - 1 do begin
         if (TSActive.Controls[i] is TCheckbox ) then begin
           (TSActive.Controls[i] as TCheckbox).Checked := false;
           (TSActive.Controls[i] as TCheckbox).enabled := false;
            end;
         if (TSActive.Controls[i] is TFMLabel) then (TSActive.Controls[i] as TFMLabel).Caption := '';
         end;
       btnFailedPurge.Enabled := true;
       btnFailedReQueue.Enabled := true;
       btnActivePurge.Enabled := false;
       active := false;
       for i := 0 to TSFailed.ControlCount -1 do
         if (TSFailed.Controls[i] is TCheckbox ) then (TSFailed.Controls[i] as TCheckbox).Checked := false;
       GetCountsQueuePartition(Active,fmlFailedAbstractcnt,'ABSTRACT');
       if (StrToInt(fmlFailedAbstractcnt.Caption) < 1) then cbFailedAbstract.enabled := false
       else cbFailedAbstract.enabled := true;
       GetCountsQueuePartition(Active,fmlFailedDeleteCnt,'DELETE');
       if (StrToInt(fmlFailedDeleteCnt.Caption) < 1) then cbFailedDelete.enabled := false
       else cbFailedDelete.enabled := true;
       GetCountsQueuePartition(Active,fmlFailedPrefetchCnt,'PREFET');
       if StrToInt(fmlFailedPrefetchCnt.Caption) < 1 then cbFailedPrefetch.enabled := false
       else cbFailedPrefetch.enabled := true;
       GetCountsQueuePartition(Active,fmlFailedGCCCnt,'GCC');
       if StrToInt(fmlFailedGCCCnt.Caption) < 1 then cbFailedGCC.enabled := false
       else cbFailedGCC.enabled := true;
       GetCountsQueuePartition(Active,fmlFailedImportCnt,'IMPORT');
       if (StrToInt(fmlFailedImportCnt.Caption) < 1) then cbFailedIMPORT.enabled := false
       else cbFailedIMPORT.enabled := true;
       GetCountsQueuePartition(Active,fmlFailedJukeboxCnt,'JUKEBOX');
       if (StrToInt(fmlFailedJukeboxCnt.Caption) < 1) then cbFailedJUKEBOX.enabled := false
       else cbFailedJUKEBOX.enabled := true;
       GetCountsQueuePartition(Active,fmlFailedJBTOHDCnt,'JBTOHD');
       if StrToInt(fmlFailedJBTOHDCnt.Caption) < 1 then cbFailedJBTOHD.enabled := false
       else cbFailedJBTOHD.enabled := true;
       GetCountsQueuePartition(Active,fmlFailedEvalCnt,'EVAL');
       if StrToInt(fmlFailedEvalCnt.Caption) < 1 then cbFailedEVAL.enabled := false
       else cbFailedEVAL.enabled := true;
       end; // Case Failed
  1: begin  // TSActive
       Active := true;
       btnFailedPurge.Enabled := false;
       btnFailedReQueue.Enabled := false;
       btnActivePurge.Enabled := true;
       for i := 0 to TSFailed.ControlCount - 1 do begin
         if (TSFailed.Controls[i] is TCheckbox ) then begin
           (TSFailed.Controls[i] as TCheckbox).Checked := false;
           (TSFailed.Controls[i] as TCheckbox).enabled := false;
            end;
         if (TSFailed.Controls[i] is TFMLabel) then (TSFailed.Controls[i] as TFMLabel).Caption :='';
         end;
       for i := 0 to TSActive.ControlCount -1 do
         if (TSActive.Controls[i] is TCheckbox ) then (TSActive.Controls[i] as TCheckbox).Checked := false;
       GetCountsQueuePartition(Active,fmlActiveAbstractcnt,'ABSTRACT');
       cbActiveAbstract.enabled := false;
       GetCountsQueuePartition(Active,fmlActiveDeleteCnt,'DELETE');
       cbActiveDelete.enabled := false;
       GetCountsQueuePartition(Active,fmlActivePrefetchCnt,'PREFET');
       if StrToInt(fmlActivePrefetchCnt.Caption) < 1 then cbActivePrefet.enabled := false
       else cbActivePrefet.enabled := true;
       GetCountsQueuePartition(Active,fmlActiveGCCCnt,'GCC');
       if StrToInt(fmlActiveGCCCnt.Caption) < 1 then cbActiveGCC.enabled := false
       else cbActiveGCC.enabled := true;
       GetCountsQueuePartition(Active,fmlActiveImportCnt,'IMPORT');
       cbActiveIMPORT.enabled := false;
       GetCountsQueuePartition(Active,fmlActiveJukeboxCnt,'JUKEBOX');
       cbActiveJUKEBOX.enabled := false;
       GetCountsQueuePartition(Active,fmlActiveJBTOHDCnt,'JBTOHD');
       if StrToInt(fmlActiveJBTOHDCnt.Caption) < 1 then cbActiveJBTOHD.enabled := false
       else cbActiveJBTOHD.enabled := true;
       GetCountsQueuePartition(Active,fmlActiveEvalCnt,'EVAL');
       if StrToInt(fmlActiveEvalCnt.Caption) < 1 then cbActiveEVAL.enabled := false
       else cbActiveEVAL.enabled := true;
       end;  // Case Active
  end; // Case (Sender as TPageControl).ActivePageIndex of
end;

end.
