unit MagRec;
interface
uses StdCtrls, SysUtils, Controls,
 WinTypes, WinProcs, Messages, Classes, Graphics,
  Forms, Dialogs, inifiles,Grids, Menus,ExtCtrls, maggut1;
type
{TMagImageTypes = (TCTGA,TCJPG,C256,XRAY,XJPG,BW,TIFUN,TIFG3,MV,AUD);
MAGINItypes = set of TMagImageTypes;}


 ptrImageData = ^ImageData;
   ImageData = record
        Mag0: String[10];
        AFile: String[130];
        FFile: String[130];
        ImgDes: String[70];
        ImgType: String[10];
        PtName: String[40];
        Date: String[20];
        Proc: String[30];
        DemoRpt : String[20];
        AbsLocation: String[1];
      end;

TMagImageType = RECORD
  TCTGA   : boolean;
  TCJPG   : boolean;
  C256   : boolean;
  X   : boolean;
  XJPG : boolean;
  BW   : boolean;
  TIFUN   : boolean;
  TIFG3   : boolean;
  MV   : boolean;
  AUD   : boolean;
end;




TMagUserPreferences = record
   showabswindow : boolean;  { make it visible on patient selection}
   showimagegrid : boolean;  { make it visible on patient selection}
   showRadListWin  : boolean; { run the call to get rad exam list}
   absViewJBox : boolean;
   ReverseOrder : boolean;
   {accessed : boolean;}
   getmain : boolean;
   getabs : boolean;
   getfull : boolean;
   getgroup : boolean;
   getdoc : boolean;
   getreport : boolean;
   getimagegrid : boolean;
   getRadListWin  : boolean;

   mainstyle : byte;   { 0 - MDIChild, 1 - MDIForm   2 - Normal 3 - StayOnTop}
   mainpos : trect;       { top,  left , width, height  }
   absstyle :  byte;    { 0 - MDIChild, 1 - MDIForm   2 - Normal 3 - StayOnTop}
   abspos : trect;        { top,  left , width, height  }
   absmax : byte;
   abswidth : integer;
   absheight : integer;
   grpstyle : byte;
   grppos : trect;
   grpabsmax : byte;
   grpabswidth : integer;
   grpabsheight : integer;
   imagegridstyle : byte;
   imagegridpos : trect;
   RadListWinstyle : byte;
   RadListWinpos : trect;
   reportstyle : byte;
   reportpos : trect;
   reportfont : tfont;
   docstyle : byte;
   docpos : trect;
   docfitwidth : byte;
   docfitheight : byte;
   docbandingmode : byte;
   fullstyle : byte; { 0 - MDIChild      1 = seperate window }
   fullpos : trect;

end;

TMagSystemSettings = record
  EKGSite : Boolean;
  FileSecurity : Boolean;
end;

TMagWrksSettings = record
  AllowSaveToDemo : boolean;
  WrksLocation: string;
  WrksCompName:string;
  LASTMAGUPDATE:string;
  LASTMUSEUPDATE:string;
  NTSecurity  : boolean;
  dual   : boolean;
  Rad2k  : boolean;
  ViewAbs : boolean;
  DOME   : boolean;
  LoginOnStartup : boolean;
  WSID : string;
  IniLogAction :  boolean;
  MuseDemoMode : Boolean;

end;


TMagSessionSettings = record
  ListenerPort : integer;
  ListenerServer :STRING;
  DemoMode : Boolean;
  AppPath : String;
   DemoDirectory : string;
   end;

TMagCaptureSettings = record
  MeteorChoice : Tstringlist;
  MeteorValues : Tstringlist;
  MeteorDefault: string;
  Lum100Choice : Tstringlist;
  Lum100Values : Tstringlist;
  Lum100Default: String;
  OkImageType : TMagImageType;
   {-----------------}
  { these are temporarily used as variables in MagCapu}
  {TempDir : string[100];
  TempFileName :String[20];
  TempFileExt : string[4];
  MAGDir : string[100];
  MAGFileName :String[20];
  MAGFileExt : string[4];
  CapDir  : String[100];
  CapFileName : string[20];
  CapFileExt : string[4];}
  CapWinPos : Trect;
  {MagImageFullPathAndName : string;}
  COLORSCAN256 : boolean;
{  Importdir : string[100];}{temporarily using a variable in MAgCapu}
  ImportIni: string ;
  ImageDescCreate : boolean;
  ImageDescAutoSelect : boolean;
  ImageDescCurAtEnd : boolean;

  IniImportType : String;
  IniImportDesc : String;

  MedNewProcOnSave : boolean;
  MedNewProcNow    : boolean;

  IniSaveAsSingle : Boolean;

  OKMed : boolean;
  OKLab : boolean;
  OKRad : boolean;
  OKSur : boolean;
  OKNone : boolean;
  OKDoc : boolean;
  SpecDefault : String;

  ABScreated: boolean;
  ABSSent:  boolean;
  SaveBIG: boolean;
  ABSForImage : boolean;
  
end; {MagCaptureSettings = record }

TMagSettings = record
 Session : TMagSessionSettings;
 Wrks    : TMagWrksSettings;
 System  : TMagSystemSettings;
 User    : TMagUserPreferences;
 Cap     : TMagCaptureSettings;
end;

Var Mset : TMagSettings;

procedure GetINISettings(var MSet : TMagSettings);
procedure InitMagSettings(var Mset : TMagSettings);
implementation


procedure InitMagSettings(var Mset : TMagSettings);
begin
with Mset.Cap do
  begin
  MeteorChoice := Tstringlist.create;
  MeteorValues := Tstringlist.create;
  Lum100Choice := Tstringlist.create;
  Lum100Values := Tstringlist.create;
  end;
end;


procedure GetINISettings(var MSet : TMagSettings);
var INI : Tinifile;
s : string;
begin
INI := Tinifile.create('MAG.INI');
with INI do
   begin
   with Mset.Wrks do
      begin
      AllowSaveToDemo := (UpperCase(ReadString('SYS_SiteParam','ALLOWSAVEAS1','FALSE'))='TRUE');
      {OpenDemo1.visible := ( allowsave or (UpperCase(ReadString('SYS_SiteParam','ALLOWOPEN','FALSE'))='TRUE'));}

      WrksLocation:=ReadString('SYS_SiteParam','Location','UNKLOC');
      WrksCompName:=Uppercase(ReadString('SYS_AUTOUPDATE','ComputerName','NoComputerName'));
      LASTMAGUPDATE:=Uppercase(ReadString('SYS_AUTOUPDATE','LASTUPDATE','0'));
      LASTMUSEUPDATE:=Uppercase(ReadString('SYS_AUTOUPDATE','LASTMUSEUPDATE','0'));
      NTSecurity  := (UpperCase(ReadString('FileSvr','NT','FALSE'))            ='TRUE' );
      dual   := (Uppercase(ReadString('RadiologyDisplay','DUAL','False')) ='TRUE' );
      Rad2k  := (Uppercase(ReadString('RadiologyDisplay','VIEW2K','False'))='TRUE');
      ViewAbs:= (Uppercase(ReadString('RadiologyDisplay','VIEWABS','FALSE'))='TRUE');
      DOME   := (Uppercase(ReadString('RadiologyDisplay','DOME','FALSE'))='TRUE');
      LoginOnStartup := (Uppercase(ReadString('LOGIN','LoginOnStartup','TRUE'))='TRUE');
      {Loginonstartup := true;} { CHANGED the default to 'TRUE' }
      WSID:=Uppercase(ReadString('SYS_SiteParam','ID','UNK'));
      WSID:=WSID + '_' + ReadString('SYS_SiteParam','Location','UNKLOC');
      IniLogAction:= ( Uppercase(ReadString('SYS_SiteParam','LOGACTION','FALSE'))='TRUE');
      MuseDemoMode := (Uppercase(Readstring('SYS_SiteParam','MUSEDEMOMODE','FALSE'))='TRUE');
      { these have to be in main }
       { mLocalMuse.Visible := Mwr.MuseDemoMode;
         mLocalMuse.Checked := Mwr.MuseDemoMode;}    {OK}
      end;
   with Mset.User do
      begin
      absViewJBox   := (UpperCase(ReadString('SYS_SiteParam','DISPJBABS','TRUE'))='TRUE');
      { IniViewJBox }
      ReverseOrder := true;
      {IniRevorder}
      {IniTeleLkp := (UpperCase(ReadString('SYS_SiteParam','LOOKUPONTELECONSULT','TRUE'))    ='TRUE' );}
      end;
   with Mset.Session do
      begin
      ListenerPort := ReadInteger('Locations','LOCALPORT',9200);
      ListenerServer := ReadString('Locations','LOCAL','DHCPSERVER');
      DemoMode := false;
      AppPath := copy(extractfilepath(application.exename),1,length(extractfilepath(application.exename))-1);
      end;
   with Mset.system do
      begin
      EKGSite :=  (Uppercase(Readstring('SYS_SiteParam','MUSE','FALSE'))='TRUE');
      {bEKG.visible}
      { these have to be in main form}
      {   bEKG.visible := Msy.EKGsite;
          mMUSEEKGlist.enabled := Msy.EKGsite; }    {ok}

      FileSecurity := true;
      If UpperCase(ReadString('FileSvr','Novell','IniError'))='TRUE' then FileSecurity := False;
      If UpperCase(ReadString('FileSvr','NT','FALSE'))='FALSE' then FileSecurity := False;
      end;
   with Mset.Cap do
      begin
      ReadSection('SYS_Meteor', MeteorChoice);
      ReadSection('SYS_FilmSize_Lumisys100', Lum100Choice);
      ReadSectionValues('SYS_Meteor', Meteorvalues);
      ReadSectionValues('SYS_FilmSize_Lumisys100', Lum100values);
      MeteorDefault := ReadString('InputType','Meteor settings','NONE');
      Lum100Default := ReadString('InputType','Lumisys100 FilmSize','NONE');

     { ----------}
       {temporarily these are out, declared in the MagCap window }
     { TempDir := 'C:\VISTA\IMAGING\TEMP';
      CapFileName :='scantemp';
      CapFileExt := '.TGA';}
            S := ReadString('SYS_CAPPOSITION','POSITION','NONE');
      if S <> 'NONE' then
      CapWinPos.left   := strtoint(magpiece(s,',',1));
      CapWinPos.top    := strtoint(magpiece(s,',',2));
      CapWinPos.right  := strtoint(magpiece(s,',',3));
      CapWinPos.bottom := strtoint(magpiece(s,',',4));
      COLORSCAN256 := Uppercase(ReadString('SCAN','ColorScan 256','FALSE'))='TRUE';
      ImportIni:='TGA';

      ImageDescCreate  := ReadString('Buttons/Fields','CreateDefaultImageDesc','TRUE')='TRUE';



      s := Readstring('Buttons/Fields','ImageDesc','Selected (Windows default)') ;
      if pos('NoSelect',s)> 0 then
          ImageDescAutoSelect := false;
      if s ='NoSelectCursorEnd' then
          ImageDescCurAtEnd  := true;

     If UpperCase(ReadString('Import Options','Type','IniError'))='COPY TO SERVER' then
         IniImportType := 'COPY';
         IniImportDesc := 'Copy To Server' ;
     If UpperCase(ReadString('Import Options','Type','IniError'))='CONVERT TO TGA' then
         IniImportType := 'TGA';
         IniImportDesc := 'Convert Image To TGA';
     If UpperCase(ReadString('Import Options','Type','IniError'))='CONVERT FILE FORMAT TO DEFAULT' THEN
         IniImportType :='';
         IniImportDesc := 'Convert Image to Selected Image Type' ;


     if readstring('Medicine Options','Create New/List Existing','Create New')='Create New' then
      MedNewProcOnSave := TRUE ;
      MedNewProcNow := UpperCase(readstring('Medicine Options','Create Procedure stub first','FALSE'))='TRUE';



     IniSaveAsSingle :=UpperCase(ReadString('SaveOptions','default','GROUP'))='SINGLE' ;

     with Mset.Cap.OkImageType do

          BEGIN
          TCTGA :=  UpperCase(ReadString('ImageType','True Color TGA','IniError'))='TRUE' ;
          TCJPG :=  UpperCase(ReadString('ImageType','True Color JPG','IniError'))='TRUE' ;
          C256  :=  UpperCase(ReadString('ImageType','256 Color','IniError'))='TRUE' ;
          X     :=  UpperCase(ReadString('ImageType','Xray','IniError'))='TRUE' ;
          XJPG  :=  UpperCase(ReadString('ImageType','Xray JPG','IniError'))='TRUE' ;
          BW    :=  UpperCase(ReadString('ImageType','Black and White','IniError'))='TRUE' ;
          TIFUN :=  UpperCase(ReadString('ImageType','Document TIF Uncompressed','IniError'))='TRUE' ;
          TIFG3 :=  UpperCase(ReadString('ImageType','Document TIF G3 FAX','IniError'))='TRUE' ;
          MV    :=  UpperCase(ReadString('ImageType','Motion Video','IniError'))='TRUE' ;
          AUD   :=  UpperCase(ReadString('ImageType','Audio','IniError'))='TRUE' ;
          END;



     OKMed  :=Uppercase(ReadString('Specialty','Medicine','IniError'))='TRUE';
     OKLab  := UpperCase(ReadString('Specialty','Laboratory','IniError'))='TRUE';
     OKRad  :=UpperCase(ReadString('Specialty','Radiology','IniError'))='TRUE';
     OKSur  :=UpperCase(ReadString('Specialty','Surgery','IniError'))='TRUE';
     OKNone := UpperCase(ReadString('Specialty','None','IniError'))='TRUE';
     OKDoc  := UpperCase(ReadString('Specialty','Document','IniError'))='TRUE';
     SpecDefault := UpperCase(ReadString('Specialty','Default','None'));

     ABScreated:= UpperCase(ReadString('SYS_SiteParam','ABScreated','FALSE'))='TRUE';
     ABSSent:= UpperCase(ReadString('SYS_SiteParam','ABSSentToRemote','FALSE'))='TRUE';
     SaveBIG:= UpperCase(ReadString('SYS_SiteParam','SaveBIG','FALSE'))='TRUE' ;
     ABSForImage := true; 
     end;  {with Mset.Cap do }




   end; {with INI do begin }
end; {GetINISettings}




end.



(*


 w-AllowSave := (UpperCase(ReadString('SYS_SiteParam','ALLOWSAVEAS1','FALSE'))='TRUE');
OpenDemo1.visible := ( allowsave or (UpperCase(ReadString('SYS_SiteParam','ALLOWOPEN','FALSE'))='TRUE'));

w-WrksLocation:=ReadString('SYS_SiteParam','Location','UNKLOC');
w-WrksCompName:=Uppercase(ReadString('SYS_AUTOUPDATE','ComputerName','NoComputerName'));
w-LASTMAGUPDATE:=Uppercase(ReadString('SYS_AUTOUPDATE','LASTUPDATE','0'));
w-LASTMUSEUPDATE:=Uppercase(ReadString('SYS_AUTOUPDATE','LASTMUSEUPDATE','0'));
u-IniViewJBox    := (UpperCase(ReadString('SYS_SiteParam','DISPJBABS','TRUE'))='TRUE');
u-IniRevorder := (UpperCase(ReadString('SYS_SiteParam','ORDER','TRUE'))    ='TRUE' );
IniTeleLkp := (UpperCase(ReadString('SYS_SiteParam','LOOKUPONTELECONSULT','TRUE'))    ='TRUE' );
w-NTsec  := (UpperCase(ReadString('FileSvr','NT','FALSE'))            ='TRUE' );
w-dual   := (Uppercase(ReadString('RadiologyDisplay','DUAL','False')) ='TRUE' );
w-Rad2k  := (Uppercase(ReadString('RadiologyDisplay','VIEW2K','False'))='TRUE');
w-ViewAbs:= (Uppercase(ReadString('RadiologyDisplay','VIEWABS','FALSE'))='TRUE');
w-DOME   := (Uppercase(ReadString('RadiologyDisplay','DOME','FALSE'))='TRUE');
w--LoginOnStartup := (Uppercase(ReadString('LOGIN','LoginOnStartup','TRUE'))='TRUE');
{loginonstartup := true;} { CHANGED the default to 'TRUE' }
w-WSID:=Uppercase(ReadString('SYS_SiteParam','ID','UNK'));
w-WSID:=WSID + '_' + ReadString('SYS_SiteParam','Location','UNKLOC');
se-ListenerPort:=ReadInteger('Locations','LOCALPORT',9200);
se-RemoteLPort:=ReadInteger('Locations','REMOTEPORT',9200);
w-IniLogAction := ( Uppercase(ReadString('SYS_SiteParam','LOGACTION','FALSE'))='TRUE');
sy-bEKG.visible :=  (Uppercase(Readstring('SYS_SiteParam','MUSE','FALSE'))='TRUE');
sy-mMUSEEKGlist.enabled := bEKG.visible;
w-mLocalMuse.Visible := (Uppercase(Readstring('SYS_SiteParam','MUSEDEMOMODE','FALSE'))='TRUE');
w-mLocalMuse.Checked := mLocalMuse.visible;
w-MuseDemoMode := mLocalMuse.visible;
sy-MagSecurity1.SecurityOn:=true;
If UpperCase(ReadString('FileSvr','Novell','IniError'))='TRUE' then MagSecurity1.SecurityOn:=False;
If UpperCase(ReadString('FileSvr','NT','FALSE'))='FALSE' then MagSecurity1.SecurityOn:=False;

end;  {WITH MAGINI DO BEGIN}
FINALLY
Magini.free;

 *)

 (* ==================================================== *)

 (*
 TempDir := 'C:\VISTA\IMAGING\TEMP';
CapFileName :='scantemp';
CapFileExt := '.TGA';
TRY

with Magini do
     begin
     S := ReadString('SYS_CAPPOSITION','POSITION','NONE');
     if S <> 'NONE' then
        setbounds(strtoint(magpiece(s,',',1)),strtoint(magpiece(s,',',2)),
           strtoint(magpiece(s,',',3)),strtoint(magpiece(s,',',4)));
{     ImageMain.RPCBroker1.ListenerPort:=ReadInteger('Locations','LOCALPORT',9200);
     Teleradi.RPCBRemote.ListenerPort:=ReadInteger('Locations','REMOTEPORT',9200);
     DHCP:=ReadString('Locations','Local','NONE');
     REMOTE:=ReadString('Locations','Remote','NONE'); }{mag321}
     {SCANBITS:=ReadInteger('SCAN','SCANBITS',0);}
     COLORSCAN256 := Uppercase(ReadString('SCAN','ColorScan 256','FALSE'))='TRUE';
     ImportIni:='TGA';
     IniUseImageDesc := ReadString('Buttons/Fields','CreateDefaultImageDesc','TRUE')='TRUE';


     s := Readstring('Buttons/Fields','ImageDesc','Selected (Windows default)') ;
       if pos('NoSelect',s)> 0 then Imagedes.autoselect := false;
       if s ='NoSelectCursorEnd' then  IniImageDescCurEnd := true;




     if NOT (ReadString('InputType','Meteor settings','NONE') = 'NONE') then
       magconfig.meteorchoice.itemindex :=
           magconfig.meteorchoice.items.indexof(ReadString('InputType','Meteor settings','NONE'));
           Magconfig.MeteorChoiceChange(self);
     if NOT (ReadString('InputType','Lumisys100 FilmSize','NONE') = 'NONE') then
       magconfig.lum100choice.itemindex :=
           magconfig.lum100choice.items.indexof(ReadString('InputType','Lumisys100 FilmSize','NONE'));
           MagConfig.Lum100choiceChange(self);

     WSID:=Uppercase(ReadString('SYS_SiteParam','ID','UNK'));
     WSID:=WSID + '_' + ReadString('SYS_SiteParam','Location','UNKLOC');
     WrksLocation:=ReadString('SYS_SiteParam','Location','UNKLOC');
     WrksCompName:=Uppercase(ReadString('SYS_AUTOUPDATE','ComputerName','NoComputerName'));
     LASTMAGUPDATE:=Uppercase(ReadString('SYS_AUTOUPDATE','LASTUPDATE','0'));

     If UpperCase(ReadString('Import Options','Type','IniError'))='COPY TO SERVER' then
        begin ImportIni:='COPY'; Magconfig.importmode.caption := 'COPY TO SERVER'; END;
     If UpperCase(ReadString('Import Options','Type','IniError'))='CONVERT TO TGA' then
         begin ImportIni:='TGA'; Magconfig.importmode.caption := 'CONVERT TO TGA'; END;
     If UpperCase(ReadString('Import Options','Type','IniError'))='CONVERT FILE FORMAT TO DEFAULT' THEN
        begin ImportIni:=''; Magconfig.importmode.caption := 'CONVERT TO IMAGETYPE'; END;


     if readstring('Medicine Options','Create New/List Existing','Create New')='Create New' then
        MAGGMCF.rbnewproc.checked := TRUE ELSE MAGGMCF.rblistproc.checked := true;
     MAGGMCF.cbMakeProcStub.checked :=
               UpperCase(readstring('Medicine Options','Create Procedure stub first','FALSE'))='TRUE';




     with MagConfig do
     begin
     OnLine.checked := true;
     NoTeleconsult.checked := true;
     ImageGroup.checked := true;



{     If UpperCase(REMOTE) <> 'NONE' then teleconsult.enabled := true;}

     NoImageGroup.checked:=UpperCase(ReadString('SaveOptions','default','GROUP'))='SINGLE' ;


     xray.enabled:= UpperCase(ReadString('ImageType','Xray','IniError'))='TRUE' ;
     xrayjpg.enabled:= UpperCase(ReadString('ImageType','Xray JPG','IniError'))='TRUE' ;
     Color.enabled:=UpperCase(ReadString('ImageType','True Color TGA','IniError'))='TRUE' ;
     Blackandwhite.enabled:=UpperCase(ReadString('ImageType','Black and White','IniError'))='TRUE' ;
     Document.enabled:=UpperCase(ReadString('ImageType','Document TIF Uncompressed','IniError'))='TRUE' ;
     {MotionVideo.enabled:=UpperCase(ReadString('ImageType','Motion Video','IniError'))='TRUE' ;
     Audio.enabled:=UpperCase(ReadString('ImageType','Audio','IniError'))='TRUE' ;}
     ColorScan.enabled:=UpperCase(ReadString('ImageType','256 Color','IniError'))='TRUE' ;
     truecolorJPG.enabled:=UpperCase(ReadString('ImageType','True Color JPG','IniError'))='TRUE' ;
     DocumentG3.enabled:=UpperCase(ReadString('ImageType','Document TIF G3 FAX','IniError'))='TRUE' ;
     { we're setting flags as to what ImageTypes are enabled in the INI file, so
       when we switch devices , and the new device enables it's possible ImageTypes, we
       won't enable an ImageType that has been disabled in the INI.  }
     WITH initype DO
          BEGIN
          TCTGA :=  Color.enabled ;
          TCJPG :=  truecolorJPG.enabled ;
          C256  :=  ColorScan.enabled ;
          X     :=  xray.enabled  ;
          XJPG  :=  xrayjpg.enabled;
          BW    :=  Blackandwhite.enabled ;
          TIFUN :=  Document.enabled ;
          TIFG3 :=  DocumentG3.enabled;
          MV    :=  FALSE;
          AUD   :=  FALSE;
          END;

     Lumisys75.Enabled:= UpperCase(ReadString('InputType','Lumisys75','FALSE'))='TRUE' ;
     Lumisys100.Enabled:= UpperCase(ReadString('InputType','Lumisys100','FALSE'))='TRUE' ;
     Lumisys150.Enabled:= UpperCase(ReadString('InputType','Lumisys150','FALSE'))='TRUE' ;
     Vidar.Enabled:= UpperCase(ReadString('InputType','Vidar','FALSE'))='TRUE' ;
     Vista.Enabled:=UpperCase(ReadString('InputType','Vista','FALSE'))='TRUE' ;
     Meteor.Enabled:=UpperCase(ReadString('InputType','Meteor','FALSE'))='TRUE' ;
     Twain.Enabled:=UpperCase(ReadString('InputType','TWAIN','FALSE'))='TRUE' ;
     Import.Enabled:=UpperCase(ReadString('InputType','Import','FALSE'))='TRUE';
     VistaInteractive.enabled:=UpperCase(ReadString('InputType','Vistainteractive','FALSE'))='TRUE' ;
     Scanecg.enabled := UpperCase(ReadString('InputType','SCANECG','FALSE'))='TRUE' ;
     Scanneddocument.enabled := UpperCase(ReadString('InputType','ScannedDocument','FALSE'))='TRUE' ;
     ScanJetXray.enabled := UpperCase(ReadString('InputType','ScanJetXray','FALSE'))='TRUE' ;


     defaultinputtype(ReadString('InputType','Default','NONE'));        {197}

     defaultImageType(ReadString('ImageType','Default','none'));

     Online.Checked:=True;

     {bLOOKUPdata.visible:=False; }  { this is the lookup to medicine procedure, lab specimens, rad report}
     Medicine.Enabled:=Uppercase(ReadString('Specialty','Medicine','IniError'))='TRUE';
     Laboratory.Enabled:=UpperCase(ReadString('Specialty','Laboratory','IniError'))='TRUE';
     Radiology.Enabled:=UpperCase(ReadString('Specialty','Radiology','IniError'))='TRUE';
     Surgery.Enabled:=UpperCase(ReadString('Specialty','Surgery','IniError'))='TRUE';
     NoSpecialty.Enabled:= UpperCase(ReadString('Specialty','None','IniError'))='TRUE';
     defaultspecialty(ReadString('Specialty','Default','None'));      {197}

     end; {with magconfig do }




   {  ImageMain.MagSecurity1.SecurityOn:=true;
     If UpperCase(ReadString('FileSvr','Novell','IniError'))='TRUE' then ImageMain.MagSecurity1.SecurityOn:=False;
     If UpperCase(ReadString('FileSvr','NT','FALSE'))='FALSE' then ImageMain.MagSecurity1.SecurityOn:=False; }
     { later gek.  this has to be done different}

     { Format:='.TGA';
     Gear1.SaveFormat:=3;
     Format:='.' + UpperCase(ReadString('SYS_SiteParam','Format','TGA'));
     If Format='.JPG' then Gear1.SaveFormat:=13;
     If Format='.TIF' then Gear1.SaveFormat:=0; } { gek 2/14/97  }
     {uncompressed - be consistent RED 2/10/97}
     {If UpperCase(ReadString('SYS_SiteParam','Format','IniError'))<>'TGA' then} {what happened here??? RED 2/10/97}

     ABScreated:= UpperCase(ReadString('SYS_SiteParam','ABScreated','FALSE'))='TRUE';
     ABSSent:= UpperCase(ReadString('SYS_SiteParam','ABSSentToRemote','FALSE'))='TRUE';
     SaveBIG:= UpperCase(ReadString('SYS_SiteParam','SaveBIG','FALSE'))='TRUE' ;
 {    LoginOnStartup := Uppercase(ReadString('LOGIN','LoginOnStartup','TRUE'))='TRUE';}{mag321}
     magconfig.loadhotbuttons(magini);
     end ; {with magini do begin }
     FINALLY
     Magini.free;
     END;
*)
