unit MagShowLog;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: BP Show log
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TShowLog = class(TForm)
    OpenDialog1: TOpenDialog;
    procedure OpenLogFile(defDirectory:string;Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ShowLog: TShowLog;

implementation

uses magWebHelp;

{$R *.DFM}

procedure TShowLog.OpenLogFile(defDirectory:string;Sender: TObject);
var
  OpenDialog: TOpenDialog;
begin
  OpenDialog := TOpenDialog.Create(Self);
  with OpenDialog do begin
   if defDirectory <> '' then InitialDir := defDirectory
   else InitialDir := ExtractFilePath(Application.ExeName)+'log\';
    //DefaultExt := '*.*';
    Filter := 'Log files (Any files (*.*)|*.*|*.log)|*.log|'+
              'HTML files (*.HTML|*.HTML|'+
              'Certed files (Certed*.log)|Certed*.log|'+
              'Scan files (Scan*.log)|Scan*.log|'+
              'ScanError files (ScanError*.log)|ScanError*.log|'+
              'Text files (*.txt)|*.txt|Any files (*.*)|*.*';
    FilterIndex := 0; { start the dialog showing all files }
    Options := [ofFileMustExist,ofPathMustExist,ofEnableSizing];
    if NOT Execute then exit
    else begin
      if pos('HTML',UpperCase(FileName)) <> 0 then begin
        Application.CreateForm(TfrmMagBPHelp,frmMagBPHelp);
        frmMagBPHelp.WB.Navigate(FileName);
        frmMagBPHelp.Caption := 'BP Log file : '+ FileName;
        end
      else WinExec(pchar('NOTEPAD.exe '+FileName),SW_SHOW);
      end;
    end; //with OpenDialog
end;
end.
