unit MagSiteParameters;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: BP Site Parameter Editor
   Note:   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Fmcntrls, Fmcmpnts, Diaccess,{MagSecurityUnit,MagBroker,} {maggut1,}{MagSec_C,} ComCtrls,
  Buttons,RpcConf1,Trpcb,DiTypLib, ExtCtrls, Spin, OleCtnrs,MFunstr, Qt,
  Menus, Fmlookup, TabNotBk, ImgList, IdBaseComponent, IdComponent,
  IdTCPConnection, IdTCPClient, IdTime,DateUtils,StrUtils,Hash;
Type
  TfrmSiteParameters = class(TForm)
    FMFilerMain: TFMFiler;
    FMValidatorMain: TFMValidator;
    FMFilerRemoteMailMembers: TFMFiler;
    FMValidatorRemoteMail: TFMValidator;
    FMLookUp1: TFMLookUp;
    PopupAssociatedInst: TPopupMenu;
    edtVistaRadGroup: TMenuItem;
    Delete: TMenuItem;
    PopRemoteMember: TPopupMenu;
    PopFileTypes: TPopupMenu;
    PopupMultiNameSpace: TPopupMenu;
    PopJukeboxShares: TPopupMenu;
    popJBAdd: TMenuItem;
    popjbDelete: TMenuItem;
    popRMAdd: TMenuItem;
    popRMDelete: TMenuItem;
    popFTAdd: TMenuItem;
    popFTDelete: TMenuItem;
    popMNSAdd: TMenuItem;
    popMNSDelete: TMenuItem;
    popVistaRadGroups: TPopupMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    popTVXWBMailGroup: TPopupMenu;
    mnuXWBProperties: TMenuItem;
    ImageList1: TImageList;
    popTVMailMessage: TPopupMenu;
    mnupuTreeViewProperties: TMenuItem;
    FMFilerMailMessage: TFMFiler;
    pnlProcessButtons: TPanel;
    bbtnHelp: TBitBtn;
    btnApply: TBitBtn;
    bbtnCancel: TBitBtn;
    bbtnOK: TBitBtn;
    FMFilerPurgeVerifier: TFMFiler;
    FMValidatorBPWS: TFMValidator;
    popBPWS: TPopupMenu;
    puDeleteBPWS: TMenuItem;
    popLVMailGroups: TPopupMenu;
    puMailGroupAdd: TMenuItem;
    puMailGroupEdit: TMenuItem;
    puMailGroupDelete2: TMenuItem;
    PoptvBPQueues: TPopupMenu;
    popPurgeQueue: TMenuItem;
    popRequeue: TMenuItem;
    popSetQueuePartition: TMenuItem;
    FMValidatorPurgeVerifier: TFMValidator;
    fmfMNSFiler: TFMFiler;
    fmfFileTypeFiler: TFMFiler;
    puLogFileDirectory: TPopupMenu;
    puNetLog: TMenuItem;
    mnuRemoteMailMember: TMenuItem;
    mnuDeleteMember: TMenuItem;
    ImageList2: TImageList;
    mnupuDeleteMailMessageMembers: TMenuItem;
    mnuAdd1: TMenuItem;
    FMHelp1: TFMHelp;
    FMHelp2: TFMHelp;
    popImportQueueProperties: TMenuItem;
    fmgSiteParam: TFMGets;
    FMGetsPurgeVerifier: TFMGets;
    pcSiteParameters: TPageControl;
    tsMain: TTabSheet;
    gbAdmin: TGroupBox;
    fmeFilePrefix: TFMEdit;
    fmcbNetworkLoc: TFMComboBox;
    fmeVRSiteCode: TFMEdit;
    fmcbGCC: TFMComboBox;
    fmlbAssociatedInstitutions: TFMListBox;
    fmcbImportQueueSecurity: TFMCheckBox;
    fmlbVistaRadGroup: TFMListBox;
    fmcbCurrentRAIDGroup: TFMComboBox;
    gbJukeboxF: TGroupBox;
    fmcbJBDefault: TFMComboBox;
    fmcbAWU: TFMCheckBox;
    fmlbMultiNS: TFMListBox;
    eMNS: TEdit;
    fmePSR: TFMEdit;
    fmlbFileTypes: TFMListBox;
    eFileExt: TEdit;
    gbImagingWSPar: TGroupBox;
    fmcbUCK: TFMCheckBox;
    fmeTOWD: TFMEdit;
    fmeTOWC: TFMEdit;
    fmeDMSN: TFMEdit;
    fmeTOVR: TFMEdit;
    gbPacs: TGroupBox;
    fmePFSDM: TFMEdit;
    fmeRDDM: TFMEdit;
    fmcbPACSInterfaceSwitch: TFMCheckBox;
    fmcbDICOMWL: TFMComboBox;
    gbNTProfiles: TGroupBox;
    fmeWindowsPassword: TFMEdit;
    fmeWindowsName: TFMEdit;
    fmeVistaAccess: TFMEdit;
    fmeVistaVerify: TFMEdit;
    gbTelereader: TGroupBox;
    fmeTeleReaderTimeout: TFMEdit;
    fmcbNetSiteService: TFMComboBox;
    tsMailMessages: TTabSheet;
    gbMailGroups: TGroupBox;
    lvMailGroups: TListView;
    gbSecurityKeysMembers: TGroupBox;
    lvSecurityKeys: TListView;
    gbMailUsers: TGroupBox;
    lvMailUsers: TListView;
    gbMailGroupsTV: TGroupBox;
    tvMailMessages: TTreeView;
    tsMailGroups: TTabSheet;
    Splitter2: TSplitter;
    Splitter3: TSplitter;
    pnlMailGroups2: TPanel;
    gbMailGroups2: TGroupBox;
    lvMailGroups2: TListView;
    gbUsers: TGroupBox;
    lvUsers: TListView;
    gbMailGroupTV: TGroupBox;
    tvMailGroups: TTreeView;
    tsPurgeParameters: TTabSheet;
    fmlLVBPWS: TFMLabel;
    GroupBox1: TGroupBox;
    gbPPAutoPurge: TGroupBox;
    fmlLastPurgeDate: TFMLabel;
    fmePPSPT: TFMEdit;
    fmcbPPSchedPurge: TFMCheckBox;
    fmePPSPF: TFMEdit;
    fmeSchedPurgeDate: TFMEdit;
    BitBtnSchedPurgeDate: TBitBtn;
    BitBtnSchedPurgeTime: TBitBtn;
    fmrgPPPurgeCriteria: TFMRadioGroup;
    gbRentention: TGroupBox;
    fmePPFullFiles: TFMEdit;
    fmePPBigFiles: TFMEdit;
    fmePPAbstractFiles: TFMEdit;
    fmePhotoIDs: TFMEdit;
    gbExpressPurge: TGroupBox;
    fmcbPPPOPPurge: TFMCheckBox;
    fmeExpressPurgeTerm: TFMEdit;
    gbAutoPurge: TGroupBox;
    fmlLastPURGEBPWS: TFMLabel;
    fmcbAutoPurge: TFMCheckBox;
    fmePurgeFactor: TFMEdit;
    gbVerifierSettings: TGroupBox;
    fmlLastVerifierDate: TFMLabel;
    fmcbSchedVerifier: TFMCheckBox;
    fmeSVTime: TFMEdit;
    fmeSVFreq: TFMEdit;
    fmeNextVerifierDate: TFMEdit;
    BitBtnNextVerifierDate: TBitBtn;
    BitBtnSchedVerifierTime: TBitBtn;
    fmcbBPVCheckText: TFMCheckBox;
    GroupBox2: TGroupBox;
    fmlLastRAIDAdvance: TFMLabel;
    fmeSchedRGAdvanceFreq: TFMEdit;
    fmeSchedRGAdvanceDate: TFMEdit;
    BitBtnSchedRGAdvanceDate: TBitBtn;
    fmeSchedRGAdvanceTime: TFMEdit;
    BitBtnSchedRGAdvanceTime: TBitBtn;
    fmcbSchedRGAdvance: TFMCheckBox;
    pnlHelp2: TPanel;
    tsBPServers: TTabSheet;
    tvBPServerTasks: TTreeView;
    btnAddBPWS: TButton;
    tsQueuePartition: TTabSheet;
    pnlQueueManager: TPanel;
    tvBPQueues: TTreeView;
    stCurrentNamespace: TStaticText;
    fmgQueuePointer: TFMGets;
    fmlQueuePointer: TFMLister;
    stGCC: TStaticText;
    stNWWriteLoc: TStaticText;
    stCurrentRAIDGroup: TStaticText;
    stVRSiteCode: TStaticText;
    stAssociatedInst: TStaticText;
    stVistaRadGrouping: TStaticText;
    stJBDefault: TStaticText;
    stMultiNS: TStaticText;
    stFileTypes: TStaticText;
    stPSR: TStaticText;
    stNetSiteService: TStaticText;
    stTeleReaderTimeout: TStaticText;
    stTOWD: TStaticText;
    stTOWC: TStaticText;
    stTOVR: TStaticText;
    stDefMSiteN: TStaticText;
    stDUP: TStaticText;
    stUSERNAME: TStaticText;
    stPassword: TStaticText;
    stVistAAccess: TStaticText;
    stVistAVerify: TStaticText;
    stPacsWL: TStaticText;
    stPFSDM: TStaticText;
    stRDDM: TStaticText;
    stFullFiles: TStaticText;
    stBigFiles: TStaticText;
    stAbstractFiles: TStaticText;
    stPhotoIDs: TStaticText;
    stLastPurgeBPServer: TStaticText;
    stPurgeFactor: TStaticText;
    stPurgeRate: TStaticText;
    stFrequency: TStaticText;
    stLastPurgeDate: TStaticText;
    stNextPurgeDate: TStaticText;
    stPurgeTime: TStaticText;
    stLastVerifyBPServer: TStaticText;
    stLastVerifierDate: TStaticText;
    stSVFrequency: TStaticText;
    stSVNextVerifierDate: TStaticText;
    stVerifierTime: TStaticText;
    stLastRAIDAdvance: TStaticText;
    stSchedRDAdvanceFreq: TStaticText;
    stSchedRGAdvanceDate: TStaticText;
    stSchedRGAdvanceTime: TStaticText;
    stBPWS: TStaticText;
    stFFileDate: TStaticText;
    stBFileDate: TStaticText;
    stAFileDate: TStaticText;
    stPIDEDates: TStaticText;
    bbtnLVMailUsers: TBitBtn;
    bbtnMGUsers: TBitBtn;
    fmcblkDefUserPref: TFMComboBoxLookUp;
    fmlDefUserPref: TFMLister;
    addmailusee: TMenuItem;
    stRETENTION_DAYS_HL7_DICOM: TStaticText;
    fmeHL7_MODALITY_WORKLIST: TFMEdit;
    procedure pcSiteParametersChange(Sender: TObject);
    procedure fmeFilePrefixChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure fmcbNetworkLocChange(Sender: TObject);
    procedure fmcbInterfaceSwitchClick(Sender: TObject);
    procedure sbAddFileTypeClick(Sender: TObject);
    procedure sbSaveClick(Sender: TObject);
    procedure sbDeleteFileTypeClick(Sender: TObject);
    procedure fmcbJukeboxeditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure bbtnCancelClick(Sender: TObject);
    procedure bbtnOKClick(Sender: TObject);
    procedure DeleteMember(var ListBox:TFMListBox; MainIEN:string);
    procedure sbaddMNSClick(Sender: TObject);
    procedure sbSaveMNSClick(Sender: TObject);
    procedure sbDeleteMNSClick(Sender: TObject);
    procedure bbtnHelpClick(Sender: TObject);
    procedure UpdateBoolean(sender:TObject);
    procedure btnApplyClick(Sender: TObject);
    procedure addClick(Sender: TObject);
    procedure addGroupClick(Sender: TObject);
    procedure DeleteClick(Sender: TObject);
    procedure DeleteGroupClick(Sender: TObject);
    procedure MainSiteUpdate(Place:integer;Caller:TObject);
    procedure EditVistaRadGroupClick(Sender: TObject);
    procedure PopupAssociatedInstPopup(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure MailMessageUpdate(Place:integer;Caller:TObject);
    procedure MailGroupUpdate(Place:integer;Caller:TObject);
    procedure TreeViewUpdate(Clear,IEN: Boolean;Lister,Sublister:TFMLister;tv:TTreeView;Hint: string);
    function GetLabel(FMFile,FMField:string): String;
    function GetLabels(FMDC:TObject): TStringList;
    procedure lvColumnClick(Sender: TObject;Column: TListColumn);
    procedure lvCompare(Sender: TObject; Item1,Item2: TListItem; Data: Integer; var Compare: Integer);
    function lvSearch(SearchList:TListView;SearchString: string;ColumnIndex:integer):integer;
    procedure LVGUpdate(Clear,IEN: boolean;fmg:TFMGets;lv:TListView);
    procedure ListViewUpdate(Clear,IEN: Boolean;Lister:TFMLister;lv:TListView;CAP: string);
    procedure mnupuTreeViewPropertiesClick(Sender: TObject);
    procedure TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer) ;
    procedure TreeViewBPWSDragDrop(Sender, Source: TObject; X, Y: Integer) ;
    procedure lvMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lvRAIDEndDrag(Sender, Target: TObject; X, Y: Integer);
    procedure tvMailMessageMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure lvRAIDDragOver(Sender, Source: TObject; X,
      Y: Integer; State: TDragState; var Accept: Boolean);
    procedure FormDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean) ;
    procedure lvSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure tvSelectItem(Sender: TObject;
      Item: TListItem; Selected: Boolean);
    procedure smnuIconsClick(Sender: TObject);
    procedure smnuSIconsClick(Sender: TObject);
    procedure smnuListClick(Sender: TObject);
    procedure smnuReportClick(Sender: TObject);
    procedure ProcList(EditList: TStringList;Filer: TFMFiler);
    procedure PageControlChange(PageControl: TPageControl;Hide: boolean);
//    procedure tvMailMessagesDblClick(Sender: TObject);
    procedure fmrgPPPurgeCriteriaClick(Sender: TObject);
    procedure puNBPWSClick(Sender: TObject);
    procedure puDeleteBPWSClick(Sender: TObject);
    procedure GetCountsQueuePartition(Active: boolean;CntLabel:TFMLabel; Queue: string);
    procedure Exit2Click(Sender: TObject);
    procedure mnuMainSiteParametersClick(Sender: TObject);
    procedure mnuMailGroupsClick(Sender: TObject);
    procedure mnuPurgeParamsClick(Sender: TObject);
    procedure mnuBPServersClick(Sender: TObject);
    procedure mnuQueuePartitionClick(Sender: TObject);
    procedure mnuMailMessagesClick(Sender: TObject);
    procedure GetCountsQueuePartitionTXT(Active: boolean;var CntTXT:String; Queue: string);
    procedure getQueues(QueueNode:TTreeNode;Active:boolean;Queue: string);
    procedure popPurgeQueueClick(Sender: TObject);
    procedure mnuXWBPropertiesClick(Sender: TObject);
    procedure PoptvBPQueuesPopup(Sender: TObject);
    procedure popSetQueuePartitionClick(Sender: TObject);
    procedure popRequeueClick(Sender: TObject);
    function Requeue(ien:string): string;
    procedure DeQueue(ien:string);
    procedure ReSetQueueCnt(Queue:string);
    procedure QueuePointerUPdate(Queue,ien:string);
    procedure popTVXWBMailGroupPopup(Sender: TObject);
    procedure tvMailGroupsMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure tvMailMessagesMouseMove(Sender: TObject; Shift: TShiftState;
      X, Y: Integer);
    procedure tvBPQueuesMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    function AddBPWSActivities(CurItem: string):TStringList;
    procedure tvBPServerTasksMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    procedure BPServerUpdate(Place:integer;Caller:TObject);
    procedure QueueManagerUpdate(Place:integer;Caller:TObject);
    procedure puNetLogClick(Sender: TObject);
    procedure popBPWSPopup(Sender: TObject);
    procedure btnAddBPWSClick(Sender: TObject);
    procedure mnuRemoteMailMemberClick(Sender: TObject);
    procedure mnuDeleteMemberClick(Sender: TObject);
    procedure tvMailGroupsMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure fmeDateChangeFuture(Sender: TObject);
    procedure BitBtnSchedPurgeDateClick(Sender: TObject);
    procedure BitBtnNextVerifierDateClick(Sender: TObject);
    procedure BitBtnSchedPurgeTimeClick(Sender: TObject);
    function  StripTime(datetime : string): string;
    procedure BitBtnSchedRGAdvanceDateClick(Sender: TObject);
    procedure BitBtnSchedRGAdvanceTimeClick(Sender: TObject);
    procedure mnuMailMessageDeleteClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure BitBtnSchedVerifierTimeClick(Sender: TObject);
    function DateToFMInternal(ExDate:string):string;
    procedure mnuDeleteMessageMemberClick(Sender: TObject);
    procedure tvBPQueuesMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure fmeVRSiteCodeKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure mnuNetworkLocatinManager1Click(Sender: TObject);
    procedure tvBPServerTasksMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure popTVMailMessagePopup(Sender: TObject);
    procedure RestoreEntry(UnDeleteList: TStringlist);
    procedure RemoveEntry(DeleteList: TStringList);
    procedure mnuApplyClick(Sender: TObject);
    procedure mnuApplyExitClick(Sender: TObject);
    function GetDDAttribute(FMFile,FMField,ATT:string): TStringList;
    procedure F1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure fmcbNetSiteServiceChange(Sender: TObject);
    procedure SiteParametersDisplayHelp(Sender: TObject);
    procedure popImportQueuePropertiesClick(Sender: TObject);
    procedure lvHelp(Sender: TObject; var Key: Word;
                Shift: TShiftState);
    procedure DisplayFieldHelp(HFile,HField:string);
    procedure UpdateEditList(FMFile,FMField,IENs,Value:string;EditList: TStringList);
    function PartialSearch(Search: string;SearchList: TStringList): integer;
    procedure eMNSKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure eMNSKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure eFileExtKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure eFileExtKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure fmeHiddenChange(Sender: TObject);
    procedure fmeVistaVerifyKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure gbMailUsersClick(Sender: TObject);
    procedure gbUsersClick(Sender: TObject);
    function IsStrANumber(const S: string): Boolean;
    procedure lvMailGroupsEnter(Sender: TObject);
    procedure lvSecurityKeysEnter(Sender: TObject);
    procedure bbtnLVMailUsersClick(Sender: TObject);
    procedure bbtnMGUsersClick(Sender: TObject);
    procedure lvMailGroups2Enter(Sender: TObject);
    procedure lvUsersEnter(Sender: TObject);
    procedure lvMailUsersEnter(Sender: TObject);
    procedure fmcblkDefUserPrefChange(Sender: TObject);
    procedure fmcblkDefUserPrefEnter(Sender: TObject);
    procedure fmeNextVerifierDateKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure fmcbAutoPurgeKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure fmcbNetworkLocKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure fmlbFileTypesKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);

  private
    { Private declarations }
  public
    { Public declarations }

  end;
type
   TEventHandlers = class // create a dummy class
//       procedure AddXWBMailGroup(Sender: TObject);
//     procedure AddOnKeyPress(Sender: TObject; var Key: Word;Shift: TShiftState);
   end;
var
  frmSiteParameters: TfrmSiteParameters;
  MailGroupIEN: string;
  AddList: TStringList;
  DeleteList: TStringList;
  intSaveRPCTimeLimit: integer;
  lbMagSystem: TListBox;
  AddCnt: integer;
  MailGroup: TFMEdit;
  EvHandler:TEventHandlers;
  Editlist: TStringlist;
  EditingActive: boolean;
  lastHintNode: TTreeNode;
  DateString: String;
  gbCnt: integer;
const
  TimeLimit = 360;
implementation

uses magbtm1, UnitDM, magWebHelp, magAssocInstVistaRadGroups1,
  fmagLookUpDialog,MagPurgeParam, fmagDirectoryDialog, MagNewBP,MAGMailGroups,
  MailGroupProperties,MagMessageProp,magRemoteMailMember,
  frmGenericCalendar1, FmagDateTimeDialog, FmagTimeDialog, frmBPProperties,bpHelp1,MagImportQueue1;

{$R *.DFM}
procedure TfrmSiteParameters.UpdateEditList(FMFile,FMField,IENs,Value:string;EditList: TStringList);
var SearchListIndex:integer;
begin
 SearchListIndex := PartialSearch(FMFile+'^'+FMField+'^'+IENS+'^',Editlist);
 if SearchListIndex <> -1 then Editlist[SearchListIndex] := FMFile+'^'+FMField+'^'+IENS+'^'+Value
 else Editlist.Add(FMFile+'^'+FMField+'^'+IENS+'^'+Value);
end;
function TfrmSiteParameters.PartialSearch(Search: string;SearchList: TStringList): integer;
  var i: integer;
begin
  result:= -1;
  for i := 0 to Searchlist.Count - 1 do
   if pos(Search,SearchList[i]) <> 0 then result := i;
end;


function  TfrmSiteParameters.StripTime(datetime : string): string;
begin
  {for now, we only take the 1st '@' piece, later we may need more checking.}
  result := piece(datetime,':',1)+piece(datetime,':',2);
  end;
procedure TfrmSiteParameters.fmeHiddenChange(Sender: TObject);
var valid: string;
begin
  with Sender as TFMEdit do begin
     if FMModified then begin
      valid :=  dmMain.MagFieldValidate(FMFile,IENS,FMField,'',text);
      if pos('-1',piece(Valid,'^',1)) <> 0 then begin
        Windows.MessageBox(frmSiteParameters.Handle,PChar(piece(Valid,'^',2)),'',MB_SYSTEMMODAL);
        SiteParametersDisplayHelp(Sender);
        Text := FMDBExternal; {reset value to previous}
        end
      else begin
        FMFiler.AddFDA(FMFile,IENS,FMField,hash.Encrypt((sender as TFMEdit).Text));
        btnApply.Enabled := true;
        PageControlChange(pcSiteParameters,true);
        end; // else Valid
      end; // FMModified
  end;  // with Sender as TFMEdit
end;
function TfrmSiteParameters.IsStrANumber(const S: string): Boolean;
  var
    P: PChar;
  begin
    P      := PChar(S);
    Result := False;
    if P^ = #0 then Exit;
    while P^ <> #0 do
    begin
      if not (P^ in ['0'..'9']) then Exit;
      Inc(P);
    end;
    Result := True;
  end; // IsStrANumber
procedure TfrmSiteParameters.fmeFilePrefixChange(Sender: TObject);
  function ConvertNull(value: string):string;   // and limit to 5
    begin
      if Length(Value) = 0 then Result := '0'
      else result:= Value;
      if Length(Value) > 5 then begin
        SiteParametersDisplayHelp(Sender);
        Result := (Sender as TFMEdit).FMDBExternal;
        end;
      if not IsStrANumber(Value) then begin
        SiteParametersDisplayHelp(Sender);
        Result := (Sender as TFMEdit).FMDBExternal;
        end;
    end; // function ConvertNull(value
var valid: string;
begin  // fmeFilePrefixChange
  with Sender as TFMEdit do begin
     if FMModified then begin
      //Display purge dates that the file attributes reference by these values as compared to today
      if (Sender as TFMEdit).Name = 'fmePPFullFiles' then begin
        (Sender as TFMEdit).text :=ConvertNull((Sender as TFMEdit).text);
        stFFileDate.caption := DateToStr(Today - StrToInt(ConvertNull((Sender as TFMEdit).text))) ;
        end;  //if name = 'fmePPFullFiles'
      if (Sender as TFMEdit).name = 'fmePPBigFiles' then begin
        (Sender as TFMEdit).text :=ConvertNull((Sender as TFMEdit).text);
        stBFileDate.caption := DateToStr(Today - StrToInt(ConvertNull((Sender as TFMEdit).text))) ;
        end;  // if name = 'fmePPBigFiles'
      if (Sender as TFMEdit).name = 'fmePPAbstractFiles' then begin
        (Sender as TFMEdit).text :=ConvertNull((Sender as TFMEdit).text);
        stAFileDate.caption := DateToStr(Today - StrToInt(ConvertNull((Sender as TFMEdit).text))) ;
        end; // if name = 'fmePPAbstractFiles'
      if (Sender as TFMEdit).name = 'fmePhotoIDs' then begin
        (Sender as TFMEdit).text :=ConvertNull((Sender as TFMEdit).text);
        stPIDEDates.caption := DateToStr(Today - StrToInt(ConvertNull((Sender as TFMEdit).text))) ;
        end; // if name = 'fmePhotoIDs'
      valid :=  dmMain.MagFieldValidate(FMFile,IENS,FMField,'',(Sender as TFMEdit).text);
      if pos('-1',piece(Valid,'^',1)) <> 0 then begin
        Windows.MessageBox(frmSiteParameters.Handle,PChar(piece(Valid,'^',2)),'',MB_SYSTEMMODAL);
        SiteParametersDisplayHelp(Sender);
        (Sender as TFMEdit).Text := (Sender as TFMEdit).FMDBExternal; {reset value to previous}
        end
      else begin
        FMFiler.AddFDA(FMFile,IENS,FMField,(sender as TFMEdit).Text);
        btnApply.Enabled := true;
        PageControlChange(pcSiteParameters,true);
        end; // else Valid
      end; // FMModified
  end;  // with Sender as TFMEdit
end; // fmeFilePrefixChange
procedure TfrmSiteParameters.DisplayFieldHelp(HFile,HField:string);
  var
     Description: TStringlist;
     i: integer;
  begin
    Application.CreateForm(TfrmHelp,frmHelp);
      with frmHelp do begin
        Caption := format('%s - %s',[frmHelp.Caption,GetLabel(HFile,HField)]) ;
        lbHelp.items := GetDDAttribute(HFile,HField,'HELP-PROMPT');
        Description := TStringList.Create;
        Description := GetDDAttribute(HFile,HField,'DESCRIPTION');
        if description.Count > 0 then lbHelp.items.Add(' ');
        for i := 0 to Description.Count - 1 do lbHelp.Items.Add(Description[i]);
        Description.Clear;
        Description := GetDDAttribute(HFile,HField,'TECHNICAL DESCRIPTION');
        if description.Count > 0 then lbHelp.items.Add(' ');
        for i := 0 to Description.Count - 1 do lbHelp.Items.Add(Description[i]);
        Description.Free;
        Application.ProcessMessages;
        Height := Height + (lbHelp.Items.count*lbHelp.Font.Size);
        try
          ShowModal;
        finally
          Free;
        end; // try..finally
        end; // with frmHelp
  end;



procedure TfrmSiteParameters.SiteParametersDisplayHelp(Sender: TObject);
  var
     Description: TStringlist;
     i: integer;
  begin
       Application.CreateForm(TfrmHelp,frmHelp);
       if sender.ClassName = 'TFMEdit' then begin
         with frmHelp do begin
           Caption := format('%s - %s',[frmHelp.Caption,GetLabel((Sender as TFMEdit).FMFile,(Sender as TFMEdit).FMField)]) ;
           lbHelp.items := GetDDAttribute((Sender as TFMEdit).FMFile,(Sender as TFMEdit).FMField,'HELP-PROMPT');
           Description := TStringList.Create;
           Description := GetDDAttribute((Sender as TFMEdit).FMFile,(Sender as TFMEdit).FMField,'DESCRIPTION');
           if description.Count > 0 then lbHelp.items.Add(' ');
           for i := 0 to Description.Count - 1 do
             lbHelp.Items.Add(Description[i]);
           Description.Clear;
           Description := GetDDAttribute((Sender as TFMEdit).FMFile,(Sender as TFMEdit).FMField,'TECHNICAL DESCRIPTION');
           if description.Count > 0 then lbHelp.items.Add(' ');
           for i := 0 to Description.Count - 1 do
             lbHelp.Items.Add(Description[i]);
           Description.Free;
           Application.ProcessMessages;
           Height := Height + (lbHelp.Items.count*lbHelp.Font.Size);
           try
             ShowModal;
           finally
             Free;
           end; // try..finally
           end; // with frmHelp
         end; // if sender.ClassName = 'TFMEdit'
       if sender.ClassName = 'TFMComboBox' then begin
         with frmHelp do begin
           Caption := format('%s - %s',[frmHelp.Caption,GetLabel((Sender as TFMComboBox).FMFile,(Sender as TFMComboBox).FMField)]) ;
           lbHelp.items := GetDDAttribute((Sender as TFMComboBox).FMFile,(Sender as TFMComboBox).FMField,'DESCRIPTION');
           Description := TStringList.Create;
           Description := GetDDAttribute((Sender as TFMComboBox).FMFile,(Sender as TFMComboBox).FMField,'TECHNICAL DESCRIPTION');
           if description.Count > 0 then lbHelp.items.Add(' ');
           for i := 0 to Description.Count - 1 do
             lbHelp.Items.Add(Description[i]);
           Description.Free;
           Application.ProcessMessages;
           Height := Height + (lbHelp.Items.count*lbHelp.Font.Size);
           try
             ShowModal;
           finally
             Free;
           end; // try..finally
           end; // with frmHelp
         end; // if sender.ClassName = 'TFMComboBox'
       if sender.ClassName = 'TFMComboBoxLookup' then begin
         with frmHelp do begin
           Caption := format('%s - %s',[frmHelp.Caption,GetLabel((Sender as TFMComboBoxLookup).FMFile,(Sender as TFMComboBoxLookup).FMField)]) ;
           lbHelp.items := GetDDAttribute((Sender as TFMComboBoxLookup).FMFile,(Sender as TFMComboBoxLookup).FMField,'DESCRIPTION');
           Description := TStringList.Create;
           Description := GetDDAttribute((Sender as TFMComboBoxLookup).FMFile,(Sender as TFMComboBoxLookup).FMField,'TECHNICAL DESCRIPTION');
           if description.Count > 0 then lbHelp.items.Add(' ');
           for i := 0 to Description.Count - 1 do
             lbHelp.Items.Add(Description[i]);
           Description.Free;
           Application.ProcessMessages;
           Height := Height + (lbHelp.Items.count*lbHelp.Font.Size);
           try
             ShowModal;
           finally
             Free;
           end; // try..finally
           end; // with frmHelp
         end; // if sender.ClassName = 'TFMComboBoxLookup'
       if sender.ClassName = 'TFMListBox' then begin
         with frmHelp do begin
           Caption := format('%s - %s',[frmHelp.Caption,GetLabel((Sender as TFMListBox).FMFile,(Sender as TFMListBox).FMField)]) ;
           lbHelp.items := GetDDAttribute((Sender as TFMListBox).FMFile,(Sender as TFMListBox).FMField,'DESCRIPTION');
           Description := TStringList.Create;
           Description := GetDDAttribute((Sender as TFMListBox).FMFile,(Sender as TFMListBox).FMField,'TECHNICAL DESCRIPTION');
           if description.Count > 0 then lbHelp.items.Add(' ');
           for i := 0 to Description.Count - 1 do
             lbHelp.Items.Add(Description[i]);
           Description.Free;
           Application.ProcessMessages;
           Height := Height + (lbHelp.Items.count*lbHelp.Font.Size);
           try
             ShowModal;
           finally
             Free;
           end; // try..finally
           end; // with frmHelp
         end; // if sender.ClassName = 'TFMListBox'
       if sender.ClassName = 'TFMCheckBox' then begin
         with frmHelp do begin
           Caption := format('%s - %s',[frmHelp.Caption,GetLabel((Sender as TFMCheckBox).FMFile,(Sender as TFMCheckBox).FMField)]) ;
           lbHelp.items := GetDDAttribute((Sender as TFMCheckBox).FMFile,(Sender as TFMCheckBox).FMField,'DESCRIPTION');
           Description := TStringList.Create;
           Description := GetDDAttribute((Sender as TFMCheckBox).FMFile,(Sender as TFMCheckBox).FMField,'TECHNICAL DESCRIPTION');
           if description.Count > 0 then lbHelp.items.Add(' ');
           for i := 0 to Description.Count - 1 do
             lbHelp.Items.Add(Description[i]);
           Description.free;
           Application.ProcessMessages;
           Height := Height + (lbHelp.Items.count*lbHelp.Font.Size);
           try
             ShowModal;
           finally
             Free;
           end; // try..finally
           end; // with frmHelp
         end; // if sender.ClassName = 'TFMCheckBox'
       if sender.ClassName = 'TFMLabel' then begin
         with frmHelp do begin
           Caption := format('%s - %s',[frmHelp.Caption,GetLabel((Sender as TFMLabel).FMFile,(Sender as TFMLabel).FMField)]) ;
           lbHelp.items := GetDDAttribute((Sender as TFMLabel).FMFile,(Sender as TFMLabel).FMField,'DESCRIPTION');
           Application.ProcessMessages;
           Height := Height + (lbHelp.Items.count*lbHelp.Font.Size);
           try
             ShowModal;
           finally
             Free;
           end; // try..finally
           end; // with frmHelp
         end; // if sender.ClassName = 'TFMLabel'
       if sender.ClassName = 'TFMRadioGroup' then begin
         with frmHelp do begin
           Caption := format('%s - %s',[frmHelp.Caption,GetLabel((Sender as TFMRadioGroup).FMFile,(Sender as TFMRadioGroup).FMField)]) ;
           lbHelp.items := GetDDAttribute((Sender as TFMRadioGroup).FMFile,(Sender as TFMRadioGroup).FMField,'DESCRIPTION');
           Application.ProcessMessages;
           Height := Height + (lbHelp.Items.count*lbHelp.Font.Size);
           try
             ShowModal;
           finally
             Free;
           end; // try..finally
           end; // with frmHelp
         end; // if sender.ClassName = 'TFMRadioGroup'
  end;  // procedure SiteParametersDisplayHelp

procedure TfrmSiteParameters.FormCreate(Sender: TObject);
begin
  application.ShowHint:=true;
  application.HintPause := 100;
  application.HintHidePause := 5000;
  if not assigned(Editlist) then Editlist := TStringList.Create;
  if not assigned(AddList) then AddList := TStringList.Create;
  if not assigned(DeleteList) then DeleteList := TStringList.Create;
  dmMain.FMComponentInit(self);
  AddCnt := 0;
  btnApply.Enabled := false;
  PageControlChange(pcSiteParameters,false);
end; // FormCreate

procedure TfrmSiteParameters.fmcbInterfaceSwitchClick(Sender: TObject);
begin
 with sender as TFMCheckBox do begin
   FMFiler.AddChgdControl(Sender);
   btnApply.Enabled := true;
   PageControlChange(pcSiteParameters,true);
   end; // with sender
end;


procedure TfrmSiteParameters.fmcbNetworkLocChange(Sender: TObject);
begin
 with sender as TFMComboBox do begin //need to test FMModified
   if FMModified then begin
      if UpperCase((sender as TFMComboBox).Name) = 'FMCBCURRENTRAIDGROUP' then begin
        fmcbDICOMWL.Enabled := false;
        fmcbNetworkLoc.Enabled := false;
        end; // if fmcbCurrentRAIDGroup
      if ((sender as TFMComboBox).GetSelectedRecord <> nil) then begin
        if (UpperCase((sender as TFMComboBox).Name) = 'FMCBNETWORKLOC') or
          (UpperCase((sender as TFMComboBox).Name) = 'FMCBDICOMWL') then begin
            FMFiler.AddFDA(FMFile,IENS,'.03',(sender as TFMComboBox).GetSelectedRecord.IEN);
            FMFiler.AddFDA(FMFile,IENS,'1.03',(sender as TFMComboBox).GetSelectedRecord.IEN);
            end;
        if (UpperCase((sender as TFMComboBox).Name) = 'FMCBJBDEFAULT') then
           FMFiler.AddFDA(FMFile,IENS,'2.01',(sender as TFMComboBox).GetSelectedRecord.IEN);
        if (UpperCase((sender as TFMComboBox).Name) = 'FMCBGCC') then
         FMFiler.AddFDA(FMFile,IENS,'.07',(sender as TFMComboBox).GetSelectedRecord.IEN);
        btnApply.Enabled := true;
        PageControlChange(pcSiteParameters,true);
        end
      else begin
         SiteParametersDisplayHelp(Sender);
        (sender as TFMComboBox).Text := (sender as TFMComboBox).FMCtrlExternal;
         end;
      end;
   end; // with sender
end;

procedure TfrmSiteParameters.sbAddFileTypeClick(Sender: TObject);
begin
  eFileExt.visible:= true;
  eFileExt.SetFocus;
end;

procedure TfrmSiteParameters.sbSaveClick(Sender: TObject);

 var valid : string;
begin
  eFileExt.visible:= false;
  if length(eFileExt.Text)<1 then exit;
  eFileExt.Text := UpperCase(eFileExt.Text);
  valid :=  dmMain.MagFieldValidate('2006.112','+1,'+fmgSiteParam.IENS,'.01','',eFileExt.text);
  if pos('-1',piece(Valid,'^',1)) <> 0 then begin
    Windows.MessageBox(frmSiteParameters.Handle,PChar(piece(Valid,'^',2)),'',MB_SYSTEMMODAL);
    DisplayFieldHelp('2006.112','.01');
    end
  else begin
    UpdateEditList('2006.112','+1,'+fmgSiteParam.IENS,'.01',eFileExt.Text,Editlist);
    fmlbFileTypes.Items.Add(eFileExt.Text);
    btnApply.Enabled := true;
    PageControlChange(pcSiteParameters,true);
    end;
  eFileExt.Text := '';
end;

procedure TfrmSiteParameters.sbDeleteFileTypeClick(Sender: TObject);
begin
  if btnApply.Enabled then begin
    Windows.MessageBox(frmSiteParameters.Handle,PChar('You need to apply changes prior to attempting to delete.'),'',MB_SYSTEMMODAL) ;
    exit;
    end;
  DeleteMember(fmlbFileTypes,IntToStr(magbtm1.place));
  if btnApply.Enabled then PageControlChange(pcSiteParameters,true);
end;

procedure TfrmSiteParameters.fmcbJukeboxeditKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (Key = 27) then
    if (ActiveControl is TFMComboBox) then begin
      SelectNext(ActiveControl,True,True);
      Key := 0;
      end;
end;

procedure TfrmSiteParameters.bbtnCancelClick(Sender: TObject);
begin
  RemoveEntry(AddList);
  RestoreEntry(DeleteList);
  AddList.Clear;
  DeleteList.Clear;
  if Not EditingActive then frmSiteParameters.Close;
  PageControlChange(pcSiteParameters,false);
end;
procedure TfrmSiteParameters.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  frmSiteParameters.ModalResult := mrCancel;
  Action := caFree;
end;
procedure TfrmSiteParameters.RemoveEntry(DeleteList: TStringList);
var
  FileNum,iens: string;
  cnt: integer;

begin
  for cnt:= 0 to DeleteList.Count - 1 do begin
    FMFilerMain.Clear;
    FileNum := piece(DeleteList[cnt],'^',1);
    iens := piece(DeleteList[cnt],'^',2);
    FMFilerMain.AddFDA(Filenum,iens,'.01','@');
    FMFilerMain.Update;
    end;
end;
procedure TfrmSiteParameters.RestoreEntry(UnDeleteList: TStringlist);
var
  cnt: integer;
  FileNum,iens,value: string;
begin
  for cnt:= 0 to UnDeleteList.Count - 1 do begin
    FMFilerMain.Clear;
    FileNum := piece(UnDeleteList[cnt],'^',1);
    iens := piece(UnDeleteList[cnt],'^',2);
    value := piece(UnDeleteList[cnt],'^',3);
    FMFilerMain.AddFDA(FileNum,iens,'.01',value);
    FMFilerMain.Update;
    end;
end;

procedure TfrmSiteParameters.bbtnOKClick(Sender: TObject);
var
 I: integer;
begin
  if EditList.Count <> 0 then ProcList(EditList,FMFilerMailMessage);
  for I := 0 to dmMain.ComponentCount - 1 do
    if (dmMain.Components[I] is TFMFiler) then
      with dmMain.Components[I] as TFMFiler do
        if AnythingToFile then begin
          Update;
          if ErrorList.Count > 0 then begin
            Windows.MessageBox(frmSiteParameters.Handle,PChar('Invalid Edit List data value!'),'',MB_SYSTEMMODAL);
            DisplayErrors;
            end;
          end;
    for i := 0 to frmSiteParameters.ComponentCount - 1 do
     if (frmSiteParameters.Components[i] is TFMFiler) then
      with frmSiteParameters.Components[i] as TFMFiler do
        if AnythingToFile then begin
          Update;
          if ErrorList.Count > 0 then begin
            Windows.MessageBox(frmSiteParameters.Handle,PChar('Invalid FMFiler data value!'),'',MB_SYSTEMMODAL);
            DisplayErrors;
            end;
          end;
  if Not EditingActive then ModalResult := mrOK ;//frmSiteParameters.Close;
 // EditingActive := false;
  PageControlChange(pcSiteParameters,false);
 // close;
end; // bbtnOKClick
procedure TfrmSiteParameters.DeleteMember(var ListBox:TFMListBox; MainIEN:string);
var
  IENS,FileNum: string;
begin
  if (ListBox.GetSelectedRecord <> nil) then begin //{delete
    IENS:= ListBox.GetSelectedRecord.IEN+','+MainIEN;
    FileNum := ListBox.FMLister.FileNumber;
    ListBox.FMFiler.AddFDA(FileNum,IENS,'.01','@');
    ListBox.Items.Delete(ListBox.ItemIndex);
    btnApply.Enabled := true;
    end
  else
    Windows.MessageBox(frmSiteParameters.Handle,PChar('You need to select an item to delete.'),'',MB_SYSTEMMODAL) ;
end;

procedure TfrmSiteParameters.sbaddMNSClick(Sender: TObject);
begin
  eMNS.visible:= true;
  eMNS.SetFocus;
end;

procedure TfrmSiteParameters.sbSaveMNSClick(Sender: TObject);
 var valid : string;
begin
  eMNS.visible:= false;
  if length(eMNS.Text)<1 then exit;
  eMNS.Text := UpperCase(eMNS.Text);
  valid :=  dmMain.MagFieldValidate('2006.11','+1,'+fmgSiteParam.IENS,'.01','',eMNS.text);
  if pos('-1',piece(Valid,'^',1)) <> 0 then begin
    Windows.MessageBox(frmSiteParameters.Handle,PChar(piece(Valid,'^',2)),'',MB_SYSTEMMODAL);
    DisplayFieldHelp('2006.11','.01');
    end
  else begin
    UpdateEditList('2006.11','+1,'+fmgSiteParam.IENS,'.01',eMNS.Text,Editlist);
    fmlbMultiNS.Items.Add(eMNS.Text);
    btnApply.Enabled := true;
    PageControlChange(pcSiteParameters,true);
    end;
   eMNS.Text := '';
end;

procedure TfrmSiteParameters.sbDeleteMNSClick(Sender: TObject);
begin
  if btnApply.Enabled then begin
    Windows.MessageBox(frmSiteParameters.Handle,PChar('You need to apply changes prior to attempting to delete.'),'',MB_SYSTEMMODAL) ;
    exit;
    end;
  DeleteMember(fmlbMultiNS,IntToStr(magbtm1.place)); //SiteParameterFile IEN= '1'
  if btnApply.Enabled then PageControlChange(pcSiteParameters,true);
end;

procedure TfrmSiteParameters.bbtnHelpClick(Sender: TObject);
begin
  Application.CreateForm(TfrmMagBPHelp,frmMagBPHelp);
  Case pcSiteParameters.ActivePageIndex of
    0: begin  //Site Parameters
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help\MAG_BP_User_Manual.htm#_Toc315344927');
       end; //case 0 //Site Parameters
 (*   1: begin // Mail Message Manager
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help\MAG_BP_User_Manual.htm#_Toc269903183');
         end; // Case 1 Mail Message Manager  *)

    1: begin // Mail Message Manager
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help\MAG_BP_User_Manual.htm#_Toc269903176');  //Toc269903176
         end; // Case 1 Mail Message Manager

(*    2: begin // Mail Group Manager
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help\MAG_BP_User_Manual.htm#_Toc287281812');
         end; // Case 2 Mail Group Manager*)

    2: begin // Mail Group Manager
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help\MAG_BP_User_Manual.htm#_Toc269903183');
         end; // Case 2 Mail Group Manager
    3: begin    //BP Purge/Verifier/RAID Group Advance Parameters
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help\MAG_BP_User_Manual.htm#_Toc269903191');
         end;  // case ActivePageIndex of 3
    4: begin   //BP Servers
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help\MAG_BP_User_Manual.htm#_Toc269903160');
         end; //Case 4
     5: begin   //Queue Partition
          frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
           'help\MAG_BP_User_Manual.htm#_Toc269903207');
        end; //Case 5
  end; //case
end;
procedure TfrmSiteParameters.UpdateBoolean(sender: TObject);
var Value : string;
begin
  with sender as TFMCheckBox do begin
      if (State = cbChecked) then value := FMValueChecked
      else value := FMValueUnChecked;
    if dmMain.VistaValidate(IENS,FMFile,FMField,value,true) then begin
        FMFiler.AddChgdControl(sender);
        btnApply.Enabled := true;
        PageControlChange(pcSiteParameters,true);
        end  // if Validate
      else begin
        SiteParametersDisplayHelp(Sender);
        Windows.MessageBox(frmSiteParameters.Handle,PChar('This Queue is currently assigned!'),' ',MB_SYSTEMMODAL) ;
        Checked := FMTag;
        end;
    end; // with sender
end;


procedure TfrmSiteParameters.btnApplyClick(Sender: TObject);
procedure Filer(Filer: TFMFiler);
  begin
    with Filer do begin
     if AnythingToFile then begin
       Update;
       if ErrorList.Count > 0 then begin
         Windows.MessageBox(frmSiteParameters.Handle,PChar('Invalid Filer data value!'),'',MB_SYSTEMMODAL) ;
         DisplayErrors;
         end;
       end; //if AnythingToFile
    end; // with Filer
  end; // Filer

var
 i: integer;
begin // btnApplyClick
  if EditList.Count <> 0 then ProcList(EditList,FMFilerMailMessage);
  for i := 0 to dmMain.ComponentCount - 1 do
     if (dmMain.Components[i] is TFMFiler) then
        filer(dmMain.Components[i] as TFMFiler);
  for i := 0 to frmSiteParameters.ComponentCount - 1 do
     if (frmSiteParameters.Components[i] is TFMFiler) then
        filer(frmSiteParameters.Components[i] as TFMFiler);
  MagAssocInstVistaRadGroup := nil;
  btnApply.Enabled := false;
  PageControlChange(pcSiteParameters,false);
  pcSiteParametersChange(pcSiteParameters);
end;

procedure TfrmSiteParameters.addClick(Sender: TObject);
var
  AddRecord : boolean;
  iens: string;
  RList: TStringList;
begin
  with dmMain do begin
    Lister :=TFMLister.Create(self);
    Lister.FileNumber := '40.8';
    Lister.FieldNumbers.Add('.01');
    Lister.FieldNumbers.Add('.07');
    Lister.DisplayFields.Add('.07');
    Lister.RPCBroker := dmMain.RPCBroker1;
    Lister.ListerFlags := [lfInternal] ;
    Lister.Screen :='I '+char(39)+'$D(^MAG(2006.1,"B",$P($G(^(0)),U,7)))';
    FMLookup1.FMLister := Lister;
    FMLookup1.AllowNew := false;
    Application.NormalizeTopMosts;
//    SetWindowPos(frmSiteParameters.Handle, HWND_NOTOPMOST, 0,0,0,0,
//      SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
    if FMLookup1.Execute(AddRecord) then begin
      inc(AddCnt);
      iens := '+'+IntToStr(AddCnt)+',';
        RPCBroker1.RemoteProcedure := 'DDR GETS ENTRY DATA';
      try try
        RList := TStringList.Create;
        with RPCBroker1.Param[0] do begin
          Value  := '.DDR';
          Ptype  := list;
          Mult['"FILE"']  := '40.8';
          Mult['"IENS"']  := FMLookup1.RecordNumber+',';
          Mult['"FIELDS"'] := '.01';
          Mult['"FLAGS"'] := 'E';
          end;
        RPCBroker1.LSTCALL(RList);
        if RList[0]='[Data]' then begin
          fmlbAssociatedInstitutions.Items.Add(piece(RList[1],U,5));
          RList.Clear;
          with RPCBroker1.Param[0] do begin
            Value  := '.DDR';
            Ptype  := list;
            Mult['"FILE"']  := '40.8';
            Mult['"IENS"']  := FMLookup1.RecordNumber+',';
            Mult['"FIELDS"'] := '.07';
            Mult['"FLAGS"'] := 'I';
            end;
          RPCBroker1.LSTCALL(RList);
          if RList[0]='[Data]' then begin
            FMFilerMain.AddFDA('2006.12',iens+
             frmSiteParameters.fmgSiteParam.IENS,'.01',piece(RList[1],U,4));
            end;
          end;
        btnApply.Enabled := true;
        PageControlChange(pcSiteParameters,true);
      except
        on E:Exception do MAGBTMF1.OnException(E);
      end; // on E:Exception
      finally
        RList.Free;
//        Application.NormalizeTopMosts;
//        SetWindowPos(frmSiteParameters.Handle, HWND_TOPMOST, 0,0,0,0,
//          SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
      end; // try...finally
      end;
      Lister.Free;
    end;
end;

procedure TfrmSiteParameters.DeleteClick(Sender: TObject);
begin
  if btnApply.Enabled then begin
    Windows.MessageBox(frmSiteParameters.Handle,PChar('You need to apply changes prior to attempting to delete.'),'',MB_SYSTEMMODAL) ;
    exit;
    end;
  DeleteMember(fmlbAssociatedInstitutions,IntToStr(magbtm1.place));
  if btnApply.Enabled then PageControlChange(pcSiteParameters,true);
end;
procedure TfrmSiteParameters.DeleteGroupClick(Sender: TObject);
begin
  if btnApply.Enabled then begin
    Windows.MessageBox(frmSiteParameters.Handle,PChar('You need to apply changes prior to attempting to delete.'),'',MB_SYSTEMMODAL) ;
    exit;
    end;
  DeleteMember(fmlbVistaRadGroup,IntToStr(magbtm1.place));
  if btnApply.Enabled then PageControlChange(pcSiteParameters,true);
end;

procedure TfrmSiteParameters.addGroupClick(Sender: TObject);
var
  AddRecord : boolean;
  iens: string;
  RList: TStringList;
begin
  with dmMain do begin
    Lister :=TFMLister.Create(self);
    Lister.FileNumber := '40.8';
    Lister.FieldNumbers.Add('.01');
    Lister.FieldNumbers.Add('.07');
    Lister.DisplayFields.Add('.07');
    Lister.RPCBroker := dmMain.RPCBroker1;
    Lister.ListerFlags := [lfInternal] ;
    Lister.Screen :='I '+char(39)+'$D(^MAG(2006.1,'+frmSiteParameters.fmgSiteParam.IENs+'201,"B",$P($G(^(0)),U,7)))';
    FMLookup1.FMLister := Lister;
    FMLookup1.AllowNew := false;
//    Application.NormalizeTopMosts;
//    SetWindowPos(frmSiteParameters.Handle, HWND_NOTOPMOST, 0,0,0,0,
//      SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
    if FMLookup1.Execute(AddRecord) then begin
      inc(AddCnt);
      iens := '+'+IntToStr(AddCnt)+',';
        RPCBroker1.RemoteProcedure := 'DDR GETS ENTRY DATA';
      try try
        RList := TStringList.Create;
        with RPCBroker1.Param[0] do begin
          Value  := '.DDR';
          Ptype  := list;
          Mult['"FILE"']  := '40.8';
          Mult['"IENS"']  := FMLookup1.RecordNumber+',';
          Mult['"FIELDS"'] := '.01';
          Mult['"FLAGS"'] := 'E';
          end;
        RPCBroker1.LSTCALL(RList);
        if RList[0]='[Data]' then begin
          fmlbVistaRadGroup.Items.Add(piece(RList[1],U,5));
          RList.Clear;
          with RPCBroker1.Param[0] do begin
            Value  := '.DDR';
            Ptype  := list;
            Mult['"FILE"']  := '40.8';
            Mult['"IENS"']  := FMLookup1.RecordNumber+',';
            Mult['"FIELDS"'] := '.07';
            Mult['"FLAGS"'] := 'I';
            end;
          RPCBroker1.LSTCALL(RList);
          if RList[0]='[Data]' then begin
            FMFilerMain.AddFDA('2006.1201',iens+
             frmSiteParameters.fmgSiteParam.IENs,'.01',piece(RList[1],U,4));
            end;
          end;
        btnApply.Enabled := true;
        PageControlChange(pcSiteParameters,true);
      except
        on E:Exception do MAGBTMF1.OnException(E);
      end; // on E:Exception
      finally
       RList.Free;
//       Application.NormalizeTopMosts;
//       SetWindowPos(frmSiteParameters.Handle, HWND_TOPMOST, 0,0,0,0,
//         SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
      end;
      end;
      Lister.Free;
    end;
   end;

procedure TfrmSiteParameters.EditVistaRadGroupClick(Sender: TObject);
begin
    Application.CreateForm(TMagAssocInstVistaRadGroup,MagAssocInstVistaRadGroup);
    try
      MagAssocInstVistaRadGroup.ShowModal;
    finally
      MagAssocInstVistaRadGroup.Free;
    end; // try...finally
end;

procedure TfrmSiteParameters.PopupAssociatedInstPopup(Sender: TObject);
begin
  if frmSiteParameters.fmlbAssociatedInstitutions.itemindex <> -1 then
    PopupAssociatedInst.Items[PopupAssociatedInst.Items.IndexOf(edtVistaRadGroup)].Enabled := true
  else PopupAssociatedInst.Items[PopupAssociatedInst.Items.IndexOf(edtVistaRadGroup)].Enabled := false;
end;


procedure TfrmSiteParameters.mnuXWBPropertiesClick(Sender: TObject);
var
  A,
  R,
  P : TPoint;
  TheSelectedNode : TTreeNode;
  f:TfrmMailGroupProperties ;
  temp,NodeText: string;
begin
  if tvMailGroups.Selected = nil then Exit;
  NodeText := tvMailGroups.Selected.Text;
  GetCursorPos(P);
  A := tvMailGroups.ScreenToClient(P);
  TheSelectedNode := tvMailGroups.GetNodeAt(A.x, A.y);
  if tvMailGroups.Selected.level <> 0 then
    NodeText := tvMailGroups.Selected.Parent.Text
  else NodeText := tvMailGroups.Selected.Text;
  GetCursorPos(R) ;
  P := ClientToScreen(Point(A.x,A.y));
  f := TfrmMailGroupProperties.Create(Self) ;
  try
    f.Top := frmSiteParameters.Top;    //R.y ;
    f.Left := frmSiteParameters.Left; //R.x ;
    temp := dmMain.Find1('3.8','','',NodeText,'B','',true);
    if pos('-1',temp) <> 0 then begin
      Windows.MessageBox(frmSiteParameters.Handle,PChar('Mail Group entry for: '+NodeText+' not found!'),' ',MB_SYSTEMMODAL) ;
      exit;
      end;
    f.FMGets.IENS := temp+',';
    f.FMGets.GetAndFill;
    if length(f.fmlRestrictions.FMCtrlInternal)<1 then
     f.fmlRestrictions.Caption := 'Unrestricted';
    f.Caption := 'Mail Group: ' + NodeText  ;
    dmMain.fmlXWBRemoteMembers.IENS := ','+temp+',';
    dmMain.fmlXWBGroupMembers.IENS := ','+temp+',';
    dmMain.fmlXWBMemberGroups.IENS := ','+temp+',';
    ListViewUpdate(true,false,dmMain.fmlXWBRemoteMembers,f.lvRemoteMailMembers,'.01');
    ListViewUpdate(true,false,dmMain.fmlXWBGroupMembers,f.lvXWBMailMembers,'.01');
    ListViewUpdate(true,false,dmMain.fmlXWBMemberGroups,f.lvXWBMailGroups,'.01');
    f.ShowModal ;
  finally
    f.Release ;
  end;
end;

procedure TfrmSiteParameters.Delete1Click(Sender: TObject);
var RNum: string;
begin
//fmlbXWBMailGroups.getSelectedRecord.IEN
  Application.NormalizeTopMosts;
  SetWindowPos(frmSiteParameters.Handle, HWND_NOTOPMOST, 0,0,0,0,
   SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
  if MessageDlg('Do you wish to delete this Mail Group?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then begin
    if Sender.ClassName = 'TMenuItem' then
      with ((Sender as TMenuItem).GetParentComponent) as TPopUpMenu do
      if PopUpComponent.ClassName = 'TFMListBox' then
        with PopUpComponent as TFMListBox do begin
          RNum := getSelectedRecord.IEN;
          if not DeleteRecord(dmMain.RPCBroker1,FMFile,RNum) then
          Windows.MessageBox(frmSiteParameters.Handle,PChar('Delete NOT Successful'),' ',MB_SYSTEMMODAL) ;
          end;
    end;
  Application.NormalizeTopMosts;
  SetWindowPos(frmSiteParameters.Handle, HWND_TOPMOST, 0,0,0,0,
   SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
end;

procedure TfrmSiteParameters.LVGUpdate(Clear, IEN: boolean;fmg:TFMGets;lv:TListView);
var
  i,k: integer;
  Labels: TStringList;
  NewColumn: TListColumn;
  ListItem: TListItem;
begin
with dmMain do begin
  if clear then begin
    lv.Items.Clear;
    lv.Columns.Clear;
    if lv.Parent.ClassName = 'TGroupBox' then (lv.Parent as TGroupBox).Caption :=
     piece((lv.Parent as TGroupBox).Caption,'-',1)+'-';
//    lv.SmallImages := frmSiteParameters.ImageList1;
//    lv.LargeImages := frmSiteParameters.ImageList1;
    Labels := GetLabels(fmg);
    if Labels.Count > 0 then begin //{Create Column Labels
  {    if CAP <> '' then begin
        NewColumn := lv.Columns.Add;
        NewColumn.Caption := Labels[Lister.FieldNumbers.IndexOf(CAP)];
        end;}
      if IEN then begin
        NewColumn := lv.Columns.Add;
        NewColumn.Caption := 'IEN';
        if magbtmf1.mnu508mode.Checked then
          if lv.Parent.ClassName = 'TGroupBox' then
            (lv.Parent as TGroupBox).Caption := (lv.Parent as TGroupBox).Caption +
            ' ' + NewColumn.Caption;
        end;
      for k := 0 to Labels.Count - 1 do begin
//        if k = Lister.FieldNumbers.IndexOf(CAP) then continue;
        NewColumn := lv.Columns.Add;
        NewColumn.Caption := Labels[k];
        if magbtmf1.mnu508mode.Checked then
          if lv.Parent.ClassName = 'TGroupBox' then
            (lv.Parent as TGroupBox).Caption := (lv.Parent as TGroupBox).Caption +
              ' '+ Labels[k];
        end;
      end; // if Labels.count
    end; // if clear
  lv.ViewStyle := vsReport;
  lv.GridLines := true;
  fmg.GetData;
  ListItem := lv.Items.Add;
  if IEN then ListItem.SubItems.Add(piece(fmg.IENS,',',1));
  for i := 0 to fmg.FieldNumbers.Count - 1 do begin
    if i = 0 then ListItem.Caption := fmg.GetField(fmg.FieldNumbers[i]).FMDBExternal//StringReplace(Labels.Strings[i],',',' ',[rfReplaceAll])
    else ListItem.SubItems.Add(fmg.GetField(fmg.FieldNumbers[i]).FMDBExternal);
    end;
  for i := 0 to lv.Columns.Count -1 do begin
    lv.Columns[i].AutoSize := true;   //*AutoSize Columns
    lv.Columns[i].width := columnheaderwidth; //*Set ColumnWidth
    end;
end; //with dmMain
end; //LVGUpdate
procedure TfrmSiteParameters.ListViewUpdate(Clear,IEN: Boolean;Lister:TFMLister;lv:TListView;CAP: string);
var
  i,j,k: integer;
  Labels: TStringList;
  NewColumn: TListColumn;
  ListItem: TListItem;
begin
  lv.Items.BeginUpdate;
  if clear then begin
    lv.Items.Clear;
    lv.Columns.Clear;
    if lv.Parent.ClassName = 'TGroupBox' then (lv.Parent as TGroupBox).Caption :=
     piece((lv.Parent as TGroupBox).Caption,'-',1)+'-';
//    lv.SmallImages := frmSiteParameters.ImageList1;
//    lv.LargeImages := frmSiteParameters.ImageList1;
    Labels := GetLabels(Lister);
    if Labels.Count > 0 then begin //{Create Column Labels
      if CAP <> '' then begin
        NewColumn := lv.Columns.Add;
        NewColumn.Caption := Labels[Lister.FieldNumbers.IndexOf(CAP)];
        if magbtmf1.mnu508mode.Checked then
          if lv.Parent.ClassName = 'TGroupBox' then
            (lv.Parent as TGroupBox).Caption := (lv.Parent as TGroupBox).Caption +
              NewColumn.Caption;
        end;
      if IEN then begin
        NewColumn := lv.Columns.Add;
        NewColumn.Caption := 'IEN';
        if magbtmf1.mnu508mode.Checked then
          if lv.Parent.ClassName = 'TGroupBox' then
            (lv.Parent as TGroupBox).Caption := (lv.Parent as TGroupBox).Caption +
            ' ' + NewColumn.Caption;
        end;
      for k := 0 to Labels.Count - 1 do begin
        if k = Lister.FieldNumbers.IndexOf(CAP) then continue;
        NewColumn := lv.Columns.Add;
        NewColumn.Caption := Labels[k];
        if magbtmf1.mnu508mode.Checked then
          if lv.Parent.ClassName = 'TGroupBox' then
            (lv.Parent as TGroupBox).Caption := (lv.Parent as TGroupBox).Caption +
              ' '+ Labels[k];
        end;
      end; // if Labels.count
    end; // if clear
  with Lister do begin
    GetList(nil);
    gbCnt := Lister.Results.Count;
    lv.ViewStyle := vsReport;
    lv.GridLines := true;
    // Initial process
    for i := 0 to Results.Count - 1 do begin  // Create ListItems
      ListItem := lv.Items.Add;
      ListItem.ImageIndex := 0;
      if IEN then ListItem.SubItems.Add(Lister.Results[i]);
      for j := 0 to FieldNumbers.Count - 1 do
        if j = Lister.FieldNumbers.IndexOf(CAP) then
          ListItem.Caption := GetRecord(Results[i]).GetField(FieldNumbers.Strings[j]).FMDBExternal
        else ListItem.SubItems.Add(GetRecord(Results[i]).GetField(FieldNumbers.Strings[j]).FMDBExternal);
      end; //for i
    repeat  //additional process if MORE
      if more then begin
        FromIEN := Lister.Results[Lister.Results.count - 1];
        Lister.Results.Clear;
        Lister.GetMore(nil);
        gbCnt := gbCnt+Lister.Results.Count;
        for i := 0 to Results.Count - 1 do begin  // Create ListItems
          ListItem := lv.Items.Add;
          ListItem.ImageIndex := 0;
          if IEN then ListItem.SubItems.Add(Lister.Results[i]);
          for j := 0 to FieldNumbers.Count - 1 do
            if j = Lister.FieldNumbers.IndexOf(CAP) then
              ListItem.Caption := GetRecord(Results[i]).GetField(FieldNumbers.Strings[j]).FMDBExternal
            else ListItem.SubItems.Add(GetRecord(Results[i]).GetField(FieldNumbers.Strings[j]).FMDBExternal);
          end; //for i
        end; // if more
    until not lister.More ;
    end; // with Lister
    for i := 0 to lv.Columns.Count - 1 do begin
      lv.Columns[i].AutoSize := true;   // AutoSize Columns
      lv.Columns[i].width := columnheaderwidth;  // Set ColumnWidth
      end;
    lv.Items.EndUpdate;
    if lv.Items.Count > 0 then lv.Items[0].Selected := true;
    lv.ReadOnly := true;
end; //ListViewUpdate
procedure TfrmSiteParameters.TreeViewUpdate(Clear,IEN: Boolean;Lister,Sublister:TFMLister;tv:TTreeView;Hint:string);
function GetNode(ien: integer;tv:TTreeView;Lister:TFMLister):TTreenode;
  var i : integer;
      temp: string;
      Gets: TFMGets;
begin
  result := nil;
  temp := Lister.GetRecord(Lister.Results[ien]).GetField('.01').FMDBExternal;
  if temp = '' then begin
    Gets:= TFMGets.Create(self);
    Gets.RPCBroker := Lister.RPCBroker;
    Gets.FileNumber := Lister.FileNumber;
    Gets.IENS := Lister.Results[ien];
    Gets.FieldNumbers.Add('.01');
    Gets.GetData;
    temp := Gets.GetField('.01').FMDBExternal;
    Gets.Free;
    end;
  if lister.ErrorList.Count > 0 then begin
    Windows.MessageBox(frmSiteParameters.Handle,PChar('Invalid Treeview data value!'),'',MB_SYSTEMMODAL);
    lister.DisplayErrors;
    end;
  for i := 0 to tv.items.count - 1 do
    if tv.items[i].text = temp then result := tv.items[i];
  if not assigned(result) then begin
    tv.Items.add(nil,temp);
    result := tv.Items[tv.Items.count - 1];
    end;
//    tv.Items.add(nil,Lister.GetRecord(Lister.Results[ien]).GetField('.01').FMDBExternal);
end;
var
  i,k: integer;
  RootNodes,subnodes: TTreeNode;
begin
  if clear then begin
    tv.Items.Clear;
    tv.ShowButtons := true;
    tv.ShowLines := true;
    tv.ShowRoot := true;
    end; // if clear
  Lister.GetList(nil);
  for i := 0 to Lister.Results.Count - 1 do begin   //Create ListItems
    Rootnodes := GetNode(i,tv,Lister);
    RootNodes.ImageIndex := 0;
    if assigned(Sublister) then begin
      Sublister.IENS := ','+Lister.Results[i]+Lister.IENS;
      Sublister.GetList(nil);
      for k := 0 to Sublister.Results.Count - 1 do begin
        subnodes := tv.Items.AddChild(RootNodes,Sublister.GetRecord(Sublister.Results[k]).GetField('.01').FMDBExternal);
        if Hint <> '' then subnodes.Text := subnodes.Text+' : '+Hint;
        end;
      end;
    end; //for i
  for i := 0 to tv.Items.Count - 1 do tv.Items[i].Expand(true);
  if tv.Items.Count > 0 then tv.Items[0].MakeVisible;
  tv.ReadOnly := true;
end;
function TfrmSiteParameters.GetDDAttribute(FMFile,FMField,ATT:string): TStringList;
var
  i: integer;
begin
  Result := TStringList.create;
  with dmMain.RPCBroker1 do begin
   Param[0].VALUE := FMFile;
   Param[0].PTYPE := LITERAL;
   Param[1].VALUE := FMField;
   Param[1].PTYPE := LITERAL;
   Param[2].VALUE := '""';
   Param[2].PTYPE := LITERAL;
   Param[3].VALUE := ATT;
   Param[3].PTYPE := LITERAL;
   RemoteProcedure := 'MAG FLD ATT';
   try
     LSTCALL(Result);
   except
     on E:Exception do magbtmf1.OnException(E);
    end; //try...except
    end; //with RPCBroker1
   for i:= Result.Count - 1 downto 0 do
     if pos(ATT,result[i]) <> 0 then result.delete(i);
  end;
function TfrmSiteParameters.GetLabel(FMFile,FMField:string): String;
var
  ResultList :TStringList;
begin
  ResultList := TStringList.create;
  with dmMain.RPCBroker1 do begin
   Param[0].VALUE := FMFile;
   Param[0].PTYPE := LITERAL;
   Param[1].VALUE := FMField;
   Param[1].PTYPE := LITERAL;
   Param[2].VALUE := '';
   Param[2].PTYPE := LITERAL;
   Param[3].VALUE := 'LABEL';
   Param[3].PTYPE := LITERAL;
   RemoteProcedure := 'MAG FLD ATT';
   try
     LSTCALL(ResultList);
   except
     on E:Exception do magbtmf1.OnException(E);
    end; //try...except
    end; //with RPCBroker1
    Result := ResultList[0] ;
  end;

function TfrmSiteParameters.GetLabels(FMDC:TObject): TStringList;
  var i:integer;
begin
 Result := TStringList.Create;
 if FMDC.ClassType = TFMLister then with FMDC as TFMLister do
   for i := 0 to FieldNumbers.Count - 1 do
     result.Add(GetLabel(FileNumber,FieldNumbers[i]));
 if FMDC.ClassType = TFMGets then with FMDC as TFMGets do
   for i := 0 to FieldNumbers.Count - 1 do
     result.Add(GetLabel(FileNumber,FieldNumbers[i]));
end;//GetLabels(FMDC:TObject):


procedure TfrmSiteParameters.lvColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  ColumnToSort := Column.Index;
  (Sender as TCustomListView).AlphaSort;
  if order = 'a' then order := 'd'
  else order := 'a';
end;
procedure TfrmSiteParameters.lvCompare(Sender: TObject; Item1,
  Item2: TListItem; Data: Integer; var Compare: Integer);
function CompAll(Input1,Input2:string):integer;
var
  I1,I2,C1,C2: Integer;
begin
    Val(Input1,I1,C1);
    Val(Input2,I2,C2);
  if ((c1 = 0) and (c2 = 0)) then begin
    if I1 > I2 then result := I1 - I2;
    if I1 < I2 then result := -(I2 - I1);
    if I1 = I2 then result := 0;
    end
  else result := CompareText(Input1,Input2);
  if order = 'd' then result := -result;
end;
var IX: integer;
begin
  if ColumnToSort = 0 then
    Compare := CompAll(Item1.Caption,Item2.Caption)
  else begin
   ix := ColumnToSort - 1;
   Compare := CompAll(Item1.SubItems[ix],Item2.SubItems[ix]);
  end;
end;
function TfrmSiteParameters.lvSearch(SearchList:TListView;SearchString: string;ColumnIndex:integer):integer;
var i: integer;
  FoundItem : TListItem;
begin
  result := -1;
 if ColumnIndex = 0 then begin
   FoundItem := SearchList.FindCaption(0,SearchString,false,true,false);
   if FoundItem <> nil then Result := FoundItem.index
   else Result := -1;
   end
 else begin
   for i := 0 to SearchList.Items.Count - 1 do
     if pos(SearchString,SearchList.Items[i].SubItems[ColumnIndex - 1]) <> 0 then begin
       result := i;
       exit;
       end;
     end;
end;



procedure TfrmSiteParameters.mnupuTreeViewPropertiesClick(Sender: TObject);
var
  AnItem: TTreeNode;
  ien,cap: string;
  i: integer;
begin
  if Sender.ClassName = 'TMenuItem' then
    with ((Sender as TMenuItem).GetParentComponent) as TPopUpMenu do begin
      if PopUpComponent.ClassName = 'TTreeView' then
        with PopUpComponent as TTreeView do
          if SelectionCount > 0 then begin
            AnItem := Selected;
            if AnItem.Level = 0 then begin
              ien := dmMain.Find1('2006.166',','+IntToStr(magbtm1.place)+',','',AnItem.Text,'B','',true);
              cap := AnItem.Text;
              end;
            if AnItem.Level = 1 then begin
              ien := dmMain.Find1('2006.166',','+IntToStr(magbtm1.place)+',','',AnItem.Parent.Text,'B','',true);
              cap := AnItem.Parent.Text;
              end;
            Application.CreateForm(TfrmMagMessageProp,frmMagMessageProp);
            MagMessageProp.frmIEN := ien+','+IntToStr(magbtm1.place)+',';
           for I := 0 to frmMagMessageProp.ComponentCount - 1 do
             if (frmMagMessageProp.Components[I] is TFMEdit) then
               with frmMagMessageProp.Components[I] as TFMEdit do begin
                 FMGets.IENS := ien+','+IntToStr(magbtm1.place)+',';
                 FMGets.GetAndFill;
                 end; // with frmMagMessageProp....
            frmMagMessageProp.Caption :=
            format('%s - %s',[ frmMagMessageProp.Caption+' ', cap]);
            try
              frmMagMessageProp.ShowModal;
            finally
              frmMagMessageProp.free;
            end; // try...finally
          end; // if SelectionCount > 0
      end; //with ((Sender as TMenuItem).GetParentComponent) as TPopUpMenu
end;
procedure TfrmSiteParameters.TreeView1DragDrop(Sender, Source: TObject; X, Y: Integer) ;
function AddSub(FileNum,SubFileNum,MainValue,SubValue,SVFileNum: string;var IENS:string):boolean;
var MIEN,SVStr:string  ;
begin
    Result := false;
    MIEN := dmMain.Find1(FileNum,IENS,'O',LeftStr(MainValue,30),'B','',true);
    if StrToInt(MIEN)> 0 then begin
      IENS := ','+MIEN +IENS;
      if pos('-1',dmMain.Find1(SubFileNum,IENS,'O',LeftStr(SubValue,30),'B','',true)) <> 0 then begin
        if pos('*FT',SVFileNum) <> 0 then SVStr := SubValue
        else SVStr := dmMain.Find1(SVFileNum,'','O',LeftStr(SubValue,30),'B','',true); // FindOne(SVFileNum,'B','',SubValue);
        if pos('-1',SVStr) <> 0 then
           Windows.MessageBox(frmSiteParameters.Handle,PChar(SubValue+' lookup failed!'),' ',MB_SYSTEMMODAL)
//        else EditList.Add(SubFileNum+'^'+'+1'+IENS+'^'+'.01'+'^'+SVStr+'^'+SubValue);
        else dmMain.FMUpdate(SubFileNum,'.01','+1'+IENS,SVStr );
        result:= true;
        end // if StrToInt(FindOne
      else Windows.MessageBox(frmSiteParameters.Handle,PChar('The entry: '+SubValue+ ' already exists in Group: '+ MAINValue),' ',MB_SYSTEMMODAL) ;
      end;
end; // function AddSub

procedure SetFileParams(var ParentFileNum,SubFileNum,SVFileNum,IENS,labels:String;Sender: TObject);
begin
if Sender.ClassType = TListView then begin
  if pos('lvMailGroups',(Sender as TListView).Name)<> 0 then begin
      IENS := ',' + IntToStr(magbtm1.place)+',';
      ParentFileNum := '2006.166';
      SubFileNum := '2006.1662';
      SVFileNum := '3.8';
      labels := 'GRP' ;
      end;
  if (Sender as TListView).Name = 'lvUsers' then begin
    IENS := ',';
    ParentFileNum := '3.8';
    SubFileNum := '3.81';
    SVFileNum := '200';
    labels := 'Mem' ;
    end;
  if (Sender as TListView).Name = 'lvMailUsers' then begin
    IENS := ',' + IntToStr(magbtm1.place)+',';
    ParentFileNum := '2006.166';
    SubFileNum := '2006.1664';
    SVFileNum := '200';
    labels := 'Mem' ;
    end;
  if (Sender as TListView).Name = 'lvRemoteMailMembers' then begin
    IENS := ',';
    ParentFileNum := '3.8';
    SubFileNum := '3.812';
    SVFileNum := '*FT';
    labels := 'Rem Mem' ;
    end;
  if (Sender as TListView).Name = 'lvSecurityKeys' then begin
    IENS := ',' + IntToStr(magbtm1.place)+',';
    ParentFileNum := '2006.166';
    SubFileNum := '2006.1665';
    SVFileNum := '19.1';
    labels := 'Keys';
    end;
if (Sender as TListView).Name = 'lvMailGroups2' then begin
    IENS := ',';
    ParentFileNum := '3.8';
    SubFileNum := '3.811';
    SVFileNum := '3.8';
    labels := 'GRP' ;
    end;
  end;  //if Sender.ClassType = TListView
if Sender.ClassType = TTreeView then begin
  if (Sender as TTreeView).Name = 'tvMailMessages' then begin
    IENS := ',' + IntToStr(magbtm1.place)+',';
    ParentFileNum := '2006.166';
    SubFileNum := '2006.1662';
    SVFileNum := '3.8';
    end; //  if (Sender as TTreeView).Name = 'tvMailMessages'
  end; // if Sender.ClassType = TTreeView then begin
end; // SetFileParams
var
   AnItem: TTreeNode;
   {AttachMode: TNodeAttachMode; }
   HT: THitTests;
   {DragItem, DropItem,} CurrentItem, NextItem: TListItem;
   {ToDeleteNode,} DropNode, CurrentNode, NextNode: TTreeNode;
   i : integer;
   DropText,IENS,ParentFileNum,SubFileNum,SVFileNum,labels : string;
begin
   HT := (Sender as TTreeView).GetHitTestInfoAt(X, Y) ;
   AnItem := (Sender as TTreeView).GetNodeAt(X, Y) ;
   if AnItem = nil then exit;
   if htNowhere in HT then Exit;
   if Source.ClassType = TListView then begin
     SetFileParams(ParentFileNum,SubFileNum,SVFileNum,IENS,labels,Source);
     CurrentItem := TListView(Source).Selected;
     while assigned(CurrentItem) do begin
       NextItem := TListView(Source).GetNextItem(CurrentItem, sdAll, [isSelected]);
       if AnItem.Level = 0 then begin
         for i := 0 to AnItem.Count - 1 do
           if AnItem.Item[i].Text = CurrentItem.Caption then begin
             Windows.MessageBox(frmSiteParameters.Handle,PChar('The entry: '+CurrentItem.Caption+' is already a member of '+AnItem.Text+ '!'),' ',MB_SYSTEMMODAL) ;
             exit;
             end;
         if AddSub(ParentFileNum,SubFileNum,AnItem.Text,CurrentItem.Caption,SVFileNum,IENS) then begin
           AnItem := TTreeView(sender).Items.AddChild(AnItem,CurrentItem.Caption + ' : '+labels);
           if not ((Sender as TTreeView).Name = 'tvMailMessages') and
             not ((Sender as TTreeView).Name = 'tvMailGroups') then
              PageControlChange(pcSiteParameters,true);
           end;
         end
       else begin
         for i := 0 to AnItem.Parent.Count - 1 do
           if AnItem.Parent.Item[i].Text = CurrentItem.Caption then begin
             Windows.MessageBox(frmSiteParameters.Handle,PChar('The entry: '+CurrentItem.Caption+' is already a member of '+AnItem.Parent.Text+ '!'),' ',MB_SYSTEMMODAL) ;
             exit;
             end;
         if AddSub(ParentFileNum,SubFileNum,AnItem.Parent.Text,CurrentItem.Caption,SVFileNum,IENS) then begin
           AnItem := TTreeView(sender).Items.Add(AnItem,CurrentItem.Caption+ ' : '+labels);
           if not ((Sender as TTreeView).Name = 'tvMailMessages') and
             not ((Sender as TTreeView).Name = 'tvMailGroups') then
           PageControlChange(pcSiteParameters,true);
           end;
         end;
       CurrentItem := NextItem;
       end;
  end; //if Source.ClassType = TListView
   if Source.ClassType = TTreeView then begin
     if (Sender as TTreeView).Name = 'tvMailMessages' then exit;  // temporarily stop allowing tv to tv
     if (Sender as TTreeView).Name = 'tvMailGroups' then exit;
     SetFileParams(ParentFileNum,SubFileNum,SVFileNum,IENS,labels,Source);
     DropNode := TTreeView(Sender).GetNodeAt(X, Y);
     CurrentNode := TTreeView(Source).Selected;
     if DropNode.Level <> 0 then DropText := DropNode.Parent.Text
     else DropText := Dropnode.Text;
     if CurrentNode.Level <> 0 then
       if AddSub(ParentFileNum,SubFileNum,DropText,CurrentNode.Text,SVFileNum,IENS) then begin
           if not ((Sender as TTreeView).Name = 'tvMailMessages') and
             not ((Sender as TTreeView).Name = 'tvMailGroups') then
        PageControlChange(pcSiteParameters,true);
        if DropNode.Level = 0 then begin
          NextNode := TTreeView(Source).Items.AddChild(DropNode, CurrentNode.Text);
          end
        else begin
          NextNode := TTreeView(Source).Items.Insert(DropNode, CurrentNode.Text);
          end;
        end;
     end; //if Source.ClassType = TTreeView
    TTreeView(Sender).FullExpand;
end;
procedure TfrmSiteParameters.TreeViewBPWSDragDrop(Sender, Source: TObject; X, Y: Integer) ;
function UpdateBPServer(DropTask,SourceWS,TargetWS:string):boolean;
//function to update BP Server Tasks
var SourceIEN,TargetIEN,FLDNum,BPWS:string  ;
begin
  Result := false;
  FldNum := dmMain.GetVariable('$S(1:$$FLDNUM^DILFD(2006.8,"'+DropTask+'"))');
  // exception code to handle dummy BP Server UAT 'Unassigned Tasks'
  if pos('Unassigned Tasks',SourceWS) <> 0 then BPWS := 'UAT'
  else BPWS := SourceWS;
  SourceIEN := dmMain.FindC('2006.8','','QXK',IntToStr(magbtm1.place)+'^'+BPWS,'D','');
  if pos('Unassigned Tasks',TargetWS) <> 0 then BPWS := 'UAT'
  else BPWS := TargetWS;
  TargetIEN := dmMain.FindC('2006.8','','QXK',IntToStr(magbtm1.place)+'^'+BPWS,'D','');
  if StrToInt(FldNum) > 0 then
    if SourceIEN <> '-1' then
      if TargetIEN <> '-1' then begin
        result:= true;
        EditList.Add('2006.8^'+SourceIEN+'^'+Fldnum+'^0^NO');
        EditList.Add('2006.8^'+TargetIEN+'^'+Fldnum+'^1^YES');
        end;
end; // function UpdateBPServer

var
   AnItem: TTreeNode;
   {AttachMode: TNodeAttachMode; }
   HT: THitTests;
   {DragItem, DropItem, CurrentItem, NextItem: TListItem;}
   {ToDeleteNode, }DropNode, CurrentNode, NextNode: TTreeNode;
   DropTask,SourceWS,TargetWS : string;
begin
  try
   HT := (Sender as TTreeView).GetHitTestInfoAt(X, Y) ;
   AnItem := (Sender as TTreeView).GetNodeAt(X, Y) ;
   if AnItem = nil then exit;
   if htNowhere in HT then Exit;
   if Source.ClassType = TTreeView then begin
     DropNode := TTreeView(Sender).GetNodeAt(X, Y);
     if DropNode = nil then exit;
     CurrentNode := TTreeView(Source).Selected;
     if DropNode.Level <> 0 then TargetWS := DropNode.Parent.Text
     else TargetWS := Dropnode.Text;
     SourceWS := CurrentNode.Parent.Text;
     DropTask := CurrentNode.Text;
     if UpdateBPServer(DropTask,SourceWS,TargetWS) then begin
       btnApply.Enabled := true;
       PageControlChange(pcSiteParameters,true);
       if DropNode.Level = 0 then
           NextNode := TTreeView(Source).Items.AddChild(DropNode, CurrentNode.Text)
       else
         NextNode := TTreeView(Source).Items.Insert(DropNode, CurrentNode.Text);
       CurrentNode.Delete;
      end; // if UpdateBPServer
     end; //if Source.ClassType = TTreeView
   finally
    TTreeView(Sender).FullExpand;
   end;
end;

procedure TfrmSiteParameters.lvRAIDEndDrag(Sender, Target: TObject; X,
  Y: Integer);
{  var AnItem: TListItem;  }
begin
  if target <> nil then begin
    if Target.ClassType = TTreeView then (Target as TTreeView).Update;
    if Target.ClassType = TListView then (Target as TListView).Update;
    end;
end;
procedure TfrmSiteParameters.lvRAIDDragOver(Sender, Source: TObject; X,
  Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept := Sender = tvMailMessages;
end;
procedure TfrmSiteParameters.FormDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean) ;
begin
   if Source.ClassType = TListView then Accept := (Source is TListView);
   if Source.ClassType = TTreeView then Accept := (Source is TTreeView);
end;

procedure TfrmSiteParameters.tvSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  if sender.ClassType = TListView then begin
  //  if (sender as TListView).SelCount > 0 then
  //    popTVMailMessage.Items[0].Enabled := true
  //  else popTVMailMessage.Items[0].Enabled := false;
    end;
end;


procedure TfrmSiteParameters.lvSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  if sender.ClassType = TListView then begin
    if (sender as TListView).SelCount > 0 then
      popTVMailMessage.Items[0].Enabled := true
    else popTVMailMessage.Items[0].Enabled := false;
    end;
end;

procedure TfrmSiteParameters.lvMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if Button = mbLeft then{ drag only if left button pressed }
    begin
      if DragDetect((Sender as TListview).Handle, POINT(X, Y)) then
      (sender as TListView).BeginDrag(True);
    end;
end;
procedure TfrmSiteParameters.tvMailMessageMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
      HT: THitTests;
      i: integer;
begin
  //*********** Fixes problem with the RightClickSelect property of TreeView
 (Sender as TTreeView).selected := (Sender as TTreeView).getNodeAt(X,Y);
  if (Sender as TTreeView).selected = nil then begin
    for i := 0 to popTVMailMessage.Items.count - 1 do
      popTVMailMessage.Items[i].Enabled := false;
    exit;
    end;
  HT := (Sender as TTreeView).GetHitTestInfoAt(X, Y);
  if Button = mbLeft then{ drag only if left button pressed }
    if DragDetect((Sender as TTreeView).Handle, POINT(X, Y)) then begin
      //  Don't Drag Group NODES - ELSE only allow the moving of the Group NODE members
      //  Code that in the DRAGDROP event
      if (sender as TTreeView).Selected.Level <> 0 then
         (sender as TTreeView).BeginDrag(false);
      end; //if DragDetect
end;

procedure TfrmSiteParameters.smnuIconsClick(Sender: TObject);
var i: integer;
begin
  for i := 0 to frmSiteParameters.ComponentCount - 1 do
     if (frmSiteParameters.Components[I] is TListView) then
       with frmSiteParameters.Components[I] as TListView do
        ViewStyle := TViewStyle(0);
end;

procedure TfrmSiteParameters.smnuSIconsClick(Sender: TObject);
var i: integer;
begin
  for i := 0 to frmSiteParameters.ComponentCount - 1 do
     if (frmSiteParameters.Components[I] is TListView) then
       with frmSiteParameters.Components[I] as TListView do
        ViewStyle := TViewStyle(1);
end;

procedure TfrmSiteParameters.smnuListClick(Sender: TObject);
var i: integer;
begin
  for i := 0 to frmSiteParameters.ComponentCount - 1 do
     if (frmSiteParameters.Components[I] is TListView) then
       with frmSiteParameters.Components[I] as TListView do
        ViewStyle := TViewStyle(2);
end;

procedure TfrmSiteParameters.smnuReportClick(Sender: TObject);
var i: integer;
begin
  for i := 0 to frmSiteParameters.ComponentCount - 1 do
     if (frmSiteParameters.Components[I] is TListView) then
       with frmSiteParameters.Components[I] as TListView do
        ViewStyle := TViewStyle(3);
end;

procedure TfrmSiteParameters.ProcList(EditList: TStringList;Filer: TFMFiler);
var i: integer;
begin
   for i := EditList.Count - 1 downto 0 do begin
    if pos('@',EditList[i]) <> 0 then continue;
    FMValidatorBPWS.SetUp(piece(EditList[i],'^',1),piece(EditList[i],'^',2),piece(EditList[i],'^',3),piece(EditList[i],'^',5));
    if not FMValidatorBPWS.Validate then begin
      DisplayFieldHelp(piece(EditList[i],'^',1),piece(EditList[i],'^',3));
      Windows.MessageBox(frmSiteParameters.Handle,PChar('The value: "'+piece(EditList[i],'^',4) + '" for "'+GetLabel(piece(EditList[i],'^',1),piece(EditList[i],'^',3))+'" did not process!' ),' ',MB_SYSTEMMODAL) ;
      EditList.Delete(i);
      end; // if not FMValidatorBPWS.Validate
    end;  // for i := 0 to EditList.Count - 1
   for i := 0 to EditList.Count - 1 do begin
     Filer.AddFDA(piece(EditList[i],'^',1),piece(EditList[i],'^',2),piece(EditList[i],'^',3),piece(EditList[i],'^',4));
     if not Filer.Update then
       Windows.MessageBox(frmSiteParameters.Handle,PChar('Updates did not apply!'),' ',MB_SYSTEMMODAL);
     if filer.AnythingToFile then
       Windows.MessageBox(frmSiteParameters.Handle,PChar('Updates did not apply!'),' ',MB_SYSTEMMODAL);
     end; // for i := 0 to EditList.Count
  EditList.Clear;
end;
procedure TfrmSiteParameters.PageControlChange(PageControl: TPageControl;Hide: boolean);
var i: integer;
begin
  for i := 0 to PageControl.PageCount - 1 do
    if PageControl.ActivePageIndex <> i then begin
      PageControl.Pages[i].TabVisible := not Hide;
      end;
  EditingActive := Hide;
  btnApply.Enabled := Hide;
end;
procedure TfrmSiteParameters.getQueues(QueueNode:TTreeNode;Active:boolean;Queue: string);
procedure GetFailedList(Queue:string;var StatusList:TStringList);
begin
  StatusList := TStringList.Create;
  with dmMain.RPCBroker1 do begin
    Param[0].VALUE := Queue;
    Param[0].PTYPE := LITERAL ;
    RemoteProcedure := 'MAGQB QSL';
    try
      LSTCALL(StatusList);
    except
       On E: EBrokerError do begin
         Windows.MessageBox(frmSiteParameters.Handle,PChar('The Queue File is corrupt!'),' ',MB_SYSTEMMODAL) ;
         Exit;
         end;
      end;  //try
    end;// with dmMain.RPCBroker1
end;
procedure QueueEntries(Active:boolean;Node:TTreeNode;Queue,Status:string);
var i,cnt: integer;
  QueueList: TStringList;
  Screen,ActivePart,QPtrIEN: String;
begin
  QueueList := TStringList.Create;
  cnt := 0;
  if queue = '' then Windows.MessageBox(frmSiteParameters.Handle,PChar('QueueEntries'),' ',MB_SYSTEMMODAL) ;
  QPtrIEN:=dmMain.GetVariable('$S($D(^MAGQUEUE(2006.031,"C","'+IntToStr(magbtm1.Place)+'","'+
  Queue+'"))'+':$O(^MAGQUEUE(2006.031,"C","'+IntToStr(magbtm1.Place)+'","'+Queue+'","0")),1:0)');
  If QPtrIEN <> '0' then ActivePart :=dmMain.GetFieldValue('2006.031','1',QPtrIEN+',','I',true)
  else ActivePart := '0';
  Screen := 'I $P(^(0),"^")="'+Queue+'",$P(^(0),U,12)='+IntToStr(magbtm1.place);
  if Active then Screen := Screen+',Y>"'+ActivePart+'"'
  else Screen := Screen+',$$TRIM^MAGQBUT4($P(^(0),"^",5))["'+Status+'",Y<"'+IntToStr(StrToInt(ActivePart)+1)+'"';
  dmMain.fmlQueueRecord.Screen := Screen;
  dmMain.fmlQueueRecord.GetList(QueueList);
  for i := 0 to QueueList.Count - 1 do begin
    if active then tvBPQueues.Items.add(Node,dmMain.fmlQueueRecord.Results[i]+' '+QueueList[i])
    else tvBPQueues.Items.AddChild(Node,dmMain.fmlQueueRecord.Results[i]+' '+QueueList[i]);
    inc(cnt);
    end;
  while dmMain.fmlQueueRecord.More do begin
     dmMain.fmlQueueRecord.FromIEN :=
       dmMain.fmlQueueRecord.Results[dmMain.fmlQueueRecord.Results.count - 1];
     dmMain.fmlQueueRecord.Results.Clear;
     QueueList.Clear;
     dmMain.fmlQueueRecord.GetMore(QueueList);
     for i := 0 to QueueList.Count - 1 do begin
       if active then
         tvBPQueues.Items.add(Node,dmMain.fmlQueueRecord.Results[i]+' '+QueueList[i])
       else
         tvBPQueues.Items.AddChild(Node,dmMain.fmlQueueRecord.Results[i]+' '+QueueList[i]);
       inc(cnt);
       end;
     end;
  if not active then Node.Text := Node.Text + ' : '+IntToStr(cnt);
//  Node.Parent.Text := Node.Parent.Text +' ('+IntToStr(Cnt)+')';
  QueueList.Free;
end;  //QueueEntries

var j: integer;
  tmpList: TStringList;
begin //getQueues
  if not Active then begin //Process 'Failed' Queues
    GetFailedList(Queue,tmpList);
    for j := 0 to tmpList.Count - 1 do begin
      tvBPQueues.Items.AddChild(QueueNode,TRIM(tmpList[j]));
      QueueEntries(Active,QueueNode.GetLastChild,Queue,TRIM(tmpList[j]));
      end;
    end
  else begin  //Process Active Queues
    tvBPQueues.Items.AddChild(QueueNode,'');  //Create a dummy first node to process all of threst at the same level
    QueueEntries(Active,QueueNode.GetLastChild,Queue,'');
    QueueNode.getFirstChild.Delete;   // Remove the dummy first node
    end;
end;
procedure TfrmSiteParameters.pcSiteParametersChange(Sender: TObject);
var
  i: integer;
{  RootNodes,subnodes,CurItem,AnItem: TTreeNode;   }

begin
  btnApply.Visible := true;
  bbtnCancel.Visible := true;
  Case (Sender as TPageControl).ActivePageIndex of
    0: begin  //Site Parameters
         for i := 0 to pnlProcessButtons.ControlCount - 1 do pnlProcessButtons.Controls[i].Visible := true;
         frmSiteParameters.Caption := format('%s - %s',[' '+Magbtm1.SiteName,'Imaging Site Parameters']);
         MainSiteUpdate(magbtm1.place,self);
       end; //case 0 //Site Parameters
    1: begin // Mail Message Manager
         frmSiteParameters.Caption := format('%s - %s',[' '+Magbtm1.SiteName,'Mail Message Manager']);
           // Imaging Mail Messages
         MailMessageUpdate(magbtm1.place,self);
         btnApply.Visible := false;
         bbtnCancel.Visible := false;
         end; // Case 1 Mail Message Manager
    2: begin // Mail Group Manager
         frmSiteParameters.Caption := format('%s - %s',[' '+Magbtm1.SiteName,'Mail Group Manager']);
          // Populate the Mail Group Edit
         MailGroupUpdate(magbtm1.place,self);
         btnApply.Visible := false;
         bbtnCancel.Visible := false;
         end; // Case 2 Mail Group Manager
    3: begin    //BP Purge/Verifier/RAID Group Advance Parameters
         for i := 0 to pnlProcessButtons.ControlCount - 1 do pnlProcessButtons.Controls[i].Visible := true;
         frmSiteParameters.Caption := format('%s - %s',[' '+Magbtm1.SiteName,'BP Purge / Verifier / RAID Group Advance Settings']);
         FMValidatorPurgeVerifier.IENS := IntToStr(magbtm1.place)+',';
         fmgetsPurgeVerifier.IENS := IntToStr(magbtm1.place)+',';
         fmgetsPurgeVerifier.GetAndFill;
             //Display purge dates that the file attributes reference by these values as compared to today
         if fmePPFullFiles.Text <> '' then stFFileDate.caption := DateToStr(Today - StrToInt(fmePPFullFiles.text)) ;
         if fmePPBigFiles.Text <> '' then stBFileDate.caption := DateToStr(Today - StrToInt(fmePPBigFiles.text)) ;
         if fmePPAbstractFiles.Text <> '' then stAFileDate.caption := DateToStr(Today - StrToInt(fmePPAbstractFiles.text)) ;
         if fmePhotoIDs.Text <> '' then stPIDEDates.Caption := DateToStr(Today - StrToInt(fmePhotoIDs.Text));
         PageControlChange(pcSiteParameters,false);
         end;  // case ActivePageIndex of 3
    4: begin   //BP Servers
         frmSiteParameters.Caption := format('%s * %s',[' '+Magbtm1.SiteName,'BP Server Parameters']);
         for i := 0 to pnlProcessButtons.ControlCount - 1 do pnlProcessButtons.Controls[i].Visible := true;
         //gbBPNetworkLogFiles.Visible := false;
         BPServerUpdate(magbtm1.place,self);
         end; //Case 4
    5: begin   //Queue Partition
          frmSiteParameters.Caption := format('%s - %s',[' '+Magbtm1.SiteName,'Queue Management by Type']);
          QueueManagerUpdate(magbtm1.place,self);
        end; //Case 5
  end; //case
end;
procedure TfrmSiteParameters.MainSiteUpdate(Place:integer;Caller:TObject);
var CurrentRAIDGroup: string;
begin
  with dmMain do begin
    frmSiteParameters.fmgSiteParam.IENS := IntToStr(magbtm1.place)+',';
    FMValidatorMain.IENS := IntToStr(magbtm1.place)+',';
    fmlFileTypes.IENS := ','+IntToStr(magbtm1.place)+',';
    fmlAssociatedInstitutions.IENS := ','+IntToStr(magbtm1.place)+',';
    fmlVistaRadGroup.IENS := ','+IntToStr(magbtm1.place)+',';
    fmlMultiNamespace.IENS := ','+IntToStr(magbtm1.place)+',';
    fmcbCurrentRAIDGroup.IENS := IntToStr(magbtm1.place)+',';

    // Must be RAID, must be Site, must not be Read-Only, must be a current Group member
    dmMain.fmlRAIDGroups.Screen := 'I $P(^(0),U,7)="GRP",$P(^(0),U,10)='+IntToStr(magbtm1.place)+
      ',$P($G(^MAG(2005.2,Y,1)),U,6)'+char(39)+'="1",$P($G(^MAG(2005.2,Y,7,0)),U,4)';
    fmcbCurrentRAIDGroup.GetList;
    CurrentRAIDGroup := dmMain.GetVariable('$S(1:$$CWG^MAGBAPI('+IntToStr(magbtm1.place)+'))');
  if StrToInt(CurrentRAIDGroup)> 0 then begin
    fmcbNetworkLoc.Enabled := true;
    fmcbDICOMWL.Enabled := true;
    dmMain.fmlNetLoc.Screen := 'I $P(^(0),U,6,7)="1^MAG",$P(^(0),U,10)='+IntToStr(magbtm1.place)+
      ',$P(^(0),U,9)'+char(39)+'="1",$P(^(0),U,2)["\\",$P($G(^MAG(2005.2,Y,1)),U,6)'+char(39)+'="1"'+
        ',$D(^MAG(2005.2,$$CWG^MAGBAPI('+IntToStr(magbtm1.place)+'),7,"B",Y))';
    fmcbNetworkLoc.GetList;
    fmcbDICOMWL.GetList;
    end
  else begin
    fmcbNetworkLoc.Enabled := false;
    fmcbDICOMWL.Enabled := false;
    end;
  dmMain.fmlGCC.Screen :='I $P(^(0),U,6,7)="1^GCC",$P(^(0),U,10)='+IntToStr(magbtm1.place)+
     ',$P($G(^MAG(2005.2,Y,1)),U,6)'+char(39)+'="1"';
     // Must be GCC, must be Site, must not be Read-Only,
  fmcbGCC.GetList;
  fmcbNetSiteService.Enabled := true;
  dmMain.fmlNetSiteService.Screen :='I $P(^(0),U,6,7)="1^URL",$P(^(0),U,10)='+IntToStr(magbtm1.place);
       // Must be URL type, must be Site
  fmcbNetSiteService.GetList;
  dmMain.fmlJukebox.Screen := 'I $P(^(0),U,6,7)["1^WORM",$P(^(0),U,10)='+IntToStr(magbtm1.place)+
    ',$P($G(^MAG(2005.2,Y,1)),U,6)'+char(39)+'="1"';
      // Must be JB type, must be Site, must not be Read-Only
  fmcbJBDefault.GetList;
  fmlbAssociatedInstitutions.GetList;
  fmlbVistaRadGroup.GetList;
  fmlbFileTypes.GetList;
  fmlbMultiNS.GetList;
  frmSiteParameters.fmgSiteParam.GetAndFill;
  fmcblkDefUserPref.Text := fmcblkDefUserPref.FMDBExternal ;
  end; // with dmMain
  PageControlChange(pcSiteParameters,false);
  if pos(fmcbGCC.IENS,',')= 0 then fmcbGCC.IENS := IntToStr(magbtm1.place)+',' ;
  if pos(fmcbNetworkLoc.IENS,',')= 0 then fmcbNetworkLoc.IENS := IntToStr(magbtm1.place)+',' ;
  if pos(fmcbDICOMWL.IENS,',')= 0 then fmcbDICOMWL.IENS := IntToStr(magbtm1.place)+',' ;
end; // MainSiteUpdate

procedure TfrmSiteParameters.MailMessageUpdate(Place:integer;Caller:TObject);
var tmp: string;
begin
  lvMailUsers.Visible := false;
  lvMailUsers.Clear;
  bbtnLVMailusers.Visible := true;
  // Imaging Mail Messages
  dmMain.fmgMailMessages.IENS := ','+IntToStr(magbtm1.place)+',';
  dmMain.fmlMailMessages.IENS := ','+IntToStr(Place);
  dmMain.fmlKernelMailGroups.Screen := 'I $E($P($G(^XMB(3.8,Y,0)),U,1),1,3)="MAG"';
  TreeViewUpdate(true,true,dmMain.fmlMailMessages,dmMain.fmlMailMessageMembers,tvMailMessages,'GRP');
  TreeViewUpdate(false,true,dmMain.fmlMailMessages,dmMain.fmlImagingMailMessageUsers,tvMailMessages,'Mem');
  TreeViewUpdate(false,true,dmMain.fmlMailMessages,dmMain.fmlMailMessageSecurityKeys,tvMailMessages,'Key');
  tvMailMessages.ToolTips := false;
  ListViewUpdate(true,FALSE,dmMain.fmlKernelMailGroups,lvMailGroups,'.01');
  //Mail Group members must have an ACCESS Code, have a mailbox, and be active
 // tmp := 'I $D(^XMB(3.7,+Y,0)),$$ACTIVE^XUSER(Y)'; // $L($P(^VA(200,Y,0),U,3)),
//  dmMain.fmlUsers.Screen := tmp;
//  dmMain.fmlUsers.Number := '250';
//  ListViewUpdate(true,FALSE,dmMain.fmlUsers,lvMailUsers,'.01');
  tmp := 'I $E($P(^DIC(19.1,Y,0),U,1),1,3)="MAG"';
  dmMain.fmlSecurityKeys.Screen := tmp;
  ListViewUpdate(true,FALSE,dmMain.fmlSecurityKeys,lvSecurityKeys,'.01');
  //tvMailMessages.Items[0].MakeVisible;
end;
procedure TfrmSiteParameters.MailGroupUpdate(Place:integer;Caller:TObject);
var tmp: string;
begin
  lvUsers.Visible := false;
  bbtnMGUsers.Visible := true;
    // Kernel Mail Groups
  dmMain.fmlKernelMailGroups.IENS := '';
  dmMain.fmlKernelMailGroups.PartList.Clear;
//  dmMain.fmlKernelMailGroups.PartList.Add('MAG');
  dmMain.fmlKernelMailGroups.Screen := 'I $E($P($G(^XMB(3.8,Y,0)),U,1),1,3)="MAG"';
  TreeViewUpdate(true,true,dmMain.fmlKernelMailGroups,dmMain.fmlKernelMailGroupMembers,tvMailGroups,'Mem');
  TreeViewUpdate(false,true,dmMain.fmlKernelMailGroups,dmMain.fmlKernelRemoteMember,tvMailGroups,'Rem Mem');
  TreeViewUpdate(false,true,dmMain.fmlKernelMailGroups,dmMain.fmlKernelMailMemberGroups,tvMailGroups,'GRP');
  tvMailGroups.ToolTips := false;
  //Mail Group members must have an ACCESS Code, have a mailbox, and be active
//  tmp := 'I $L($P(^VA(200,Y,0),U,3)),$D(^XMB(3.7,+Y,0)),$$ACTIVE^XUSER(Y)';
  tmp := 'I $D(^XMB(3.7,+Y,0)),$$ACTIVE^XUSER(Y)'; //$L($P(^VA(200,Y,0),U,3)),
  dmMain.fmlUsers.Screen := tmp;
  dmMain.fmlUsers.Number := '250';
//  ListViewUpdate(true,FALSE,dmMain.fmlUsers,lvUsers,'.01');
  ListViewUpdate(true,FALSE,dmMain.fmlKernelMailGroups,lvMailGroups2,'.01');
  //tvMailGroups.Items[0].MakeVisible;
end; // MailGroupUpdate
procedure TfrmSiteParameters.BPServerUpdate(Place:integer;Caller:TObject);
var i: integer;
   CurItem: TTreeNode;
   WSTasks : TStringList;
   Complete: boolean;
begin
   repeat
    Complete:= true;
    dmMain.RPCBroker1.Param[0].VALUE := IntToStr(Place);
    dmMain.RPCBroker1.Param[0].PTYPE := LITERAL;
    dmMain.RPCBroker1.RemoteProcedure := 'MAGQ BP UAT';
    try
      dmMain.RPCBroker1.Call;       //call
    except
      on E:Exception do begin
        magbtmf1.InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^MAGQ BP UAT',280,magbtmf1.sgLatestTasks);
        dmMain.OnException(E);
        Complete := false;
        end; // on E:Exception
    end; //try...except
  until Complete;
  FMValidatorBPWS.IENS := IntToStr(magbtm1.place)+',';
//  FMValidatorPurgeVerifier.IENS := IntToStr(magbtm1.place)+',';
  dmMain.fmlBPWS.Screen :='I $P(^(0),U,2)="'+IntToStr(magbtm1.place)+'"';
  TreeViewUpdate(true,true,dmMain.fmlBPWS,nil,tvBPServerTasks,'');
  CurItem := tvBPServerTasks.Items.GetFirstNode;
  while CurItem <> nil do begin
    WSTasks := AddBPWSActivities(CurItem.Text);
    if WSTasks.Count <> 0 then begin
      tvBPServerTasks.Items.AddChild(CurItem,WSTasks[0]);
      for i := 1 to WSTasks.Count - 1 do
      tvBPServerTasks.Items.AddChild(CurItem,WSTasks[i]);
      end;  // if WSTasks.Count <> 0
    if pos(CurItem.Text,'UAT') <> 0 then CurItem.Text := 'Unassigned Tasks';
    CurItem.Expand(false);
    CurItem := CurItem.getNextSibling;
    end;  //end primary node treeview while loop
    tvBPServerTasks.ToolTips := false;
    Update;
end;
procedure TfrmSiteParameters.QueueManagerUpdate(Place:integer;Caller:TObject);
var
   CurItem: TTreeNode;
   tmp: string;
begin
  // Treeview QueueManager begins here with primary nodes (only .01)
  btnApply.Visible := false;
  bbtnCancel.Visible := false;
  frmSiteParameters.fmlQueuePointer.Screen :='I $P(^(0),U,4)="'+IntToStr(magbtm1.place)+'"';
  TreeViewUpdate(true,true,frmSiteParameters.fmlQueuePointer,nil,tvBPQueues,'');
  CurItem := tvBPQueues.Items.GetFirstNode;
  while CurItem <> nil do begin
    if pos(uppercase(CurItem.Text),'EVAL') = 0 then begin
      GetCountsQueuePartitionTXT(false,tmp,CurItem.Text); //get failed Count
      tvBPQueues.Items.AddChild(CurItem,'Failed: '+tmp);  //tmp from prev
      if StrToInt(tmp)> 0 then //get failed Queues
        getQueues(CurItem.GetLastChild,False,CurItem.Text);
      end;
    GetCountsQueuePartitionTXT(true,tmp,CurItem.Text); //get active Count
    tvBPQueues.Items.AddChild(CurItem,'Active: '+tmp); //tmp from prev
    if StrToInt(tmp)> 0 then  //get Active Queues
      getQueues(CurItem.GetLastChild,True,CurItem.Text);
      CurItem.Expand(false);
      CurItem := CurItem.getNextSibling;
    end;  //end primary node treeview while loop
  tvBPQueues.ToolTips := false;
end; // QueueManagerUpdate(
function TfrmSiteParameters.AddBPWSActivities(CurItem: string):TStringList;
var BPWSIen,Screen,Value,BPWS: string;
   i:integer;
begin
  Result := TStringList.Create;
  Screen := 'I $P(^(0),U,2)="'+IntToStr(magbtm1.place)+'"';
  BPWS:= IntToStr(magbtm1.place);
  if pos('Unassigned Tasks',CurItem) <> 0 then BPWS:= BPWS+'^'+'UAT'
  else BPWS:= BPWS+'^'+CurItem;
  BPWSIen := dmMain.FindC('2006.8','','QXK',BPWS,'D','');
  If BPWSIen <> '-1' then begin
    for i := 3 to 20 do
      case i of 3,4,12..17,20 :begin
        Value :=dmMain.GetFieldValue('2006.8',IntToStr(i),BPWSIen+',','E',true);
        if pos(UpperCase(Value),'YES') <> 0 then Result.Add(GetLabel('2006.8',IntToStr(i)));
//          tvNode := BPWorkstation.Items.AddChild(NIL,IntToStr(i));
        end; // case of 3,...
        else;
        end; // case
      end; // if BPWSIen...
end; // AddBPWSActivities

procedure TfrmSiteParameters.fmrgPPPurgeCriteriaClick(Sender: TObject);
begin
 with sender as TFMRadioGroup do begin
     UpdateEditList(FMFile,IENS,FMField,fmrgPPPurgeCriteria.FMInternalCodes[fmrgPPPurgeCriteria.ItemIndex],Editlist);
     if FMModified then begin
       btnApply.Enabled := true;
       PageControlChange(pcSiteParameters,true);
       end
     else begin
      // SiteParametersDisplayHelp(Sender);
       end;
   end; // with sender
end;


procedure TfrmSiteParameters.puNBPWSClick(Sender: TObject);
var
  A,R,P : TPoint;
  f: TfrmMagNewBP ;
begin
  A := pcSiteParameters.ActivePage.ScreenToClient(P);
  GetCursorPos(R) ;
  P := ClientToScreen(Point(A.x,A.y));
  f := TfrmMagNewBP.Create(application) ;
  try
    f.AutoSize := true;
    f.ShowModal ;
  finally
    f.Release ;
    pcSiteParametersChange(pcSiteParameters);
  end; //try }
end;

procedure TfrmSiteParameters.puDeleteBPWSClick(Sender: TObject);
var
  Filer: TFMFiler;
  AnItem: TTreeNode;
  IEN: string;
begin
  with ((Sender as TMenuItem).GetParentComponent as TPopUPMenu) do
    with PopupComponent as TTreeView do
      if SelectionCount > 0 then begin
        AnItem := Selected;
        IEN := dmMain.FindC('2006.8','','QXK',IntToStr(magbtm1.place)+'^'+AnItem.Text,'D','');
        Filer := TFMFiler.Create(nil);
        filer.RPCBroker := dmMain.RPCBroker1;
        Filer.AddFDA('2006.8',IEN+',','.01','@');
        Filer.Update;
        Filer.Free;
        BPServerUpdate(magbtm1.place,nil);
        end  // if (Sender..
end;
procedure  TfrmSiteParameters.GetCountsQueuePartition(Active: boolean;CntLabel:TFMLabel; Queue: string);
var    rec : string;
  total,count: integer;
begin
with frmSiteParameters.fmlQueuePointer do begin
  frmSiteParameters.fmgQueuePointer.IENS:='';
  Screen :='I (($P(^(0),U,1)="'+Queue+'")&'+
    '($P(^(0),U,4)="'+ IntToStr(magbtm1.place)+'"))';
  ListerFlags := [lfInternal];
  GetList(nil);
  if errorlist.Count > 0 then begin
    Windows.MessageBox(frmSiteParameters.Handle,PChar('Invalid Get Counts data value!'),'',MB_SYSTEMMODAL);
    exit;
    end;
  if Results.Count < 1 then begin
    CntLabel.caption := '0';
    exit;
    end;
  rec := Results[0];
  end;
  if rec = '-1' then
    Windows.MessageBox(frmSiteParameters.Handle,PChar('Queue: '+Queue+' reference could not be found'),' ',MB_SYSTEMMODAL)
  else begin
    if StrToInt(rec) > 0 then begin
      frmSiteParameters.fmgQueuePointer.IENS:=rec+',';
      frmSiteParameters.fmgQueuePointer.GetData;
      if Length(frmSiteParameters.fmgQueuePointer.GetField('3').FMDBExternal) < 1 then
        total := 0
      else total := StrToInt(dmMain.fmgQueuePointer.GetField('3').FMDBExternal);
      if Length(frmSiteParameters.fmgQueuePointer.GetField('2').FMDBExternal) < 1 then
      Count := 0
      else Count := StrToInt(frmSiteParameters.fmgQueuePointer.GetField('2').FMDBExternal);
      if not active then CntLabel.caption := IntToStr(Total - Count)
      else CntLabel.caption := IntToStr(Count) ;
      end
    else
      Windows.MessageBox(frmSiteParameters.Handle,PChar('No records matched.'),' ',MB_SYSTEMMODAL) ;
    end;
end;
procedure  TfrmSiteParameters.GetCountsQueuePartitionTXT(Active: boolean;var CntTXT:String; Queue: string);
var    rec : string;
  total,count: integer;
begin
  ReSetQueueCnt(Queue);
  with frmSiteParameters.fmlQueuePointer do begin
    frmSiteParameters.fmgQueuePointer.IENS:='';
    Screen :='I (($P(^(0),U,1)="'+Queue+'")&'+
      '($P(^(0),U,4)="'+ IntToStr(magbtm1.place)+'"))';
    ListerFlags := [lfInternal];
    GetList(nil);
    if errorlist.Count > 0 then begin
      Windows.MessageBox(frmSiteParameters.Handle,PChar('Invalid Get Counts data value!'),'',MB_SYSTEMMODAL);
      exit;
      end;
    if Results.Count < 1 then begin
      CntTXT := '0';
      exit;
      end;
    rec := Results[0];
    end;
  if rec = '-1' then
    Windows.MessageBox(frmSiteParameters.Handle,PChar('The Queue: '+ Queue+' reference could not be found.'),' ',MB_SYSTEMMODAL)
  else begin
    if StrToInt(rec) > 0 then begin
      frmSiteParameters.fmgQueuePointer.IENS:=rec+',';
      frmSiteParameters.fmgQueuePointer.GetData;
      if Length(frmSiteParameters.fmgQueuePointer.GetField('3').FMDBExternal) < 1 then
        total := 0
      else total := StrToInt(frmSiteParameters.fmgQueuePointer.GetField('3').FMDBExternal);
      if Length(frmSiteParameters.fmgQueuePointer.GetField('2').FMDBExternal) < 1 then
      Count := 0
      else Count := StrToInt(frmSiteParameters.fmgQueuePointer.GetField('2').FMDBExternal);
      if not active then CntTXT := IntToStr(Total - Count)
      else CntTXT := IntToStr(Count) ;
      end
    else
      Windows.MessageBox(frmSiteParameters.Handle,PChar('No records matched.'),' ',MB_SYSTEMMODAL) ;
    end;
end;

procedure TfrmSiteParameters.Exit2Click(Sender: TObject);
begin
 frmSiteParameters.Close;
end;

procedure TfrmSiteParameters.mnuMainSiteParametersClick(Sender: TObject);
begin
  pcSiteParameters.ActivePageIndex := 0;
  pcSiteParametersChange(pcSiteParameters);
end;

procedure TfrmSiteParameters.mnuMailGroupsClick(Sender: TObject);
begin
  pcSiteParameters.ActivePageIndex := 2;
  pcSiteParametersChange(pcSiteParameters);

end;

procedure TfrmSiteParameters.mnuPurgeParamsClick(Sender: TObject);
begin
  pcSiteParameters.ActivePageIndex := 3;
  pcSiteParametersChange(pcSiteParameters);
end;

procedure TfrmSiteParameters.mnuBPServersClick(Sender: TObject);
begin
  pcSiteParameters.ActivePageIndex := 4;
  pcSiteParametersChange(pcSiteParameters);
end;

procedure TfrmSiteParameters.mnuQueuePartitionClick(Sender: TObject);
begin
  pcSiteParameters.ActivePageIndex := 5;
  pcSiteParametersChange(pcSiteParameters);
end;

procedure TfrmSiteParameters.mnuMailMessagesClick(Sender: TObject);
begin
  pcSiteParameters.ActivePageIndex := 1;
  pcSiteParametersChange(pcSiteParameters);
end;

procedure TfrmSiteParameters.popPurgeQueueClick(Sender: TObject);
procedure DelQueue(Node:TTreenode);
var temp : string;
begin
  temp := StringReplace(Node.Text,'  ',' ',[rfReplaceAll]);
  temp := StringReplace(temp,' ','^',[rfReplaceAll]);
  try
   if StrToInt(piece(temp,'^',1)) < 1 then exit;
  except
    //Windows.MessageBox(frmSiteParameters.Handle,PChar('Invalid Image IEN : '+temp),' ',MB_SYSTEMMODAL) ;
    exit;
    end;
  DeQueue(piece(temp,'^',1));
end;
var
   AnItem,ItemChild: TTreeNode;
   i: integer;
   temp,queue : string;
begin
  if Sender.ClassName = 'TMenuItem' then begin
    with ((Sender as TMenuItem).GetParentComponent) as TPopUpMenu do begin
      if PopUpComponent.ClassType = TTreeview then begin
          AnItem := (PopupComponent as TTreeView).Selected;
        try
        Application.NormalizeTopMosts;
        SetWindowPos(frmSiteParameters.Handle, HWND_NOTOPMOST, 0,0,0,0,
          SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
        case AnItem.Level of
         0: begin
            Windows.MessageBox(frmSiteParameters.Handle,PChar((PopupComponent as TTreeView).Name),' ',MB_SYSTEMMODAL) ;
            end;
         1: begin
              Queue := AnItem.Parent.Text;
              if MessageDlg('Do you wish to Purge all '+piece(AnItem.Text,':',1)+'('+trim(piece(AnItem.Text,':',2))+') '+AnItem.Parent.Text+' queues ?',
                  mtConfirmation, mbYesNoCancel,0) = mrYes then begin
                if pos('ACTIVE',uppercase(AnItem.Text)) <> 0 then begin
                  AnItem.Text := 'Active: 0';
                  while AnItem.HasChildren do begin
                    DelQueue(AnItem.getFirstChild);
                    AnItem.getFirstChild.Delete;
                    end; // while AnItem.HasChildren
              //    ReSetQueueCnt(Queue);
                 // Updating Active Count
                   end   // if pos('Active"
                else begin  // Failed
                  AnItem.Text := 'Failed: 0';
                  While AnItem.HasChildren do begin
                    ItemChild := AnItem.getFirstChild;
                    while ItemChild.HasChildren do begin
                      DelQueue(ItemChild.getFirstChild);
                      ItemChild.getFirstChild.Delete;
                      end; // while ItemChild.HasChildren
                    ItemChild.Delete;
                    end; // While AnItem.HasChildren
               //   ReSetQueueCnt(Queue);
                  end;  // else partition
               end; // if MessageDlg('
            end; // case level 1
         2: begin
             temp := StringReplace(AnItem.Parent.Text,'  ',' ',[rfReplaceAll]);
             if StrToInt(piece(temp,':',2)) < 1 then begin
               Windows.MessageBox(frmSiteParameters.Handle,PChar('Queue and Status could not be determined from: '+temp+' and '+AnItem.Parent.Text),' ',MB_SYSTEMMODAL) ;
               exit; //No Queues to process
               end;
               if (PopupComponent as TTreeView).SelectionCount < 1 then exit;
               if pos('FAILED',uppercase(AnItem.Parent.Text)) <> 0 then begin
                 // Status level - Purge Children then Status
                 if MessageDlg('Do you wish to Purge all ' + AnItem.Parent.Parent.Text+
                     ' queues, with a status of '+piece(AnItem.Text,':',1)+'('+trim(piece(AnItem.Text,':',2))+') ?',
                     mtConfirmation, mbYesNoCancel,0) <> mrYes then exit;
                 Queue := AnItem.Parent.Parent.Text;
                 AnItem.Parent.Text := (piece(AnItem.Parent.Text,':',1)+': ' + IntToStr(StrToInt(trim(piece(AnItem.Parent.Text,':',2))) - AnItem.Count)); //should always be zero
                 while AnItem.HasChildren do begin
                   DelQueue(AnItem.getFirstChild);
                   AnItem.getFirstChild.Delete;
                   end; // while AnItem.HasChildren
                 // Need to recount Failed and update Failed Node before removing Status Node
                 AnItem.Delete; // Purge Status
             //    ReSetQueueCnt(Queue);
                 end //if pos('FAILED',
               else begin // not pos('FAILED'
                 if MessageDlg('Do you wish to Purge all selected ('+IntToStr((PopupComponent as TTreeView).SelectionCount)+ ') '+
                   piece(AnItem.parent.text,':',1)+ ' '+AnItem.Parent.Parent.Text+' queues ?',mtConfirmation, mbYesNoCancel,0) <> mrYes then exit;
                  Queue := AnItem.Parent.Parent.Text;
                 AnItem.Parent.Text := (piece(AnItem.Parent.Text,':',1)+': '+ IntToStr(StrToInt(trim(piece(AnItem.Parent.Text,':',2))) - (PopupComponent as TTreeView).SelectionCount));
                 for i := (PopupComponent as TTreeView).SelectionCount - 1 downto 0 do begin
                   ItemChild := (PopupComponent as TTreeView).Selections[i];
                   DelQueue(ItemChild);
                   ItemChild.Delete;
                   end; // for
                // ReSetQueueCnt(Queue);
                 end;  // else
           end; // case level 2
         3: begin // level 3
             if MessageDlg('Do you wish to Purge all selected ('+IntToStr((PopupComponent as TTreeView).SelectionCount)+ ') ' +
               piece(AnItem.Parent.parent.text,':',1)+ ' '+AnItem.Parent.Parent.Parent.Text+' queues, with a status of '+piece(AnItem.Parent.Text,':',1)+' ?',
               mtConfirmation, mbYesNoCancel,0) = mrYes then begin
                 Queue := AnItem.Parent.Parent.Parent.Text ;
                 AnItem.Parent.Text := (piece(AnItem.Parent.Text,':',1)+': '+ IntToStr(StrToInt(trim(piece(AnItem.Parent.Text,':',2)))-(PopupComponent as TTreeView).SelectionCount));
                 AnItem.Parent.Parent.Text := (piece(AnItem.Parent.Parent.Text,':',1)+': '+ IntToStr(StrToInt(trim(piece(AnItem.Parent.Parent.Text,':',2))) - (PopupComponent as TTreeView).SelectionCount));
                 for i := (PopupComponent as TTreeView).selectioncount - 1 downto 0 do begin
                   ItemChild := (PopupComponent as TTreeView).Selections[i];
                   DelQueue(ItemChild);
                   ItemChild.Delete
                   end; // for
               //  ReSetQueueCnt(Queue);
                 end;  // if MessageDlg('
            end; // case level 3
         else Windows.MessageBox(frmSiteParameters.Handle,PChar('Unexpected Tree Level: '+IntToStr(AnItem.level)),' ',MB_SYSTEMMODAL) ;
         AnItem.Free;
         end; //case AnItem.Level of
//         pcSiteParametersChange(pcSiteParameters);
         finally
           Application.NormalizeTopMosts;
           SetWindowPos(frmSiteParameters.Handle, HWND_TOPMOST, 0,0,0,0,
             SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
         end; // try...finally
         end;  // if PopUpComponent.ClassType = TTreeview
      end;  // with ((Sender as TMenuItem).GetParentComponent) as TPopUpMenu
   end;  // if Sender.ClassName = 'TMenuItem'
end;  // popPurgeQueueClick

procedure TfrmSiteParameters.PoptvBPQueuesPopup(Sender: TObject);
var
   AnItem: TTreeNode;
   i: integer;
   temp : string;
begin
//Note there should be no failed 'EVAL' node
  if (Sender as TPopUpMenu).PopupComponent.ClassName = 'TTreeView' then begin
    with (Sender as TPopUpMenu).PopupComponent as TTreeView do begin
      if ((Sender as TPopUpMenu).PopupComponent as TTreeView).Selected = nil then begin
        Windows.MessageBox(frmSiteParameters.Handle,PChar('No selection !'),' ',MB_SYSTEMMODAL) ;
        exit;
        end;
         AnItem := ((Sender as TPopUpMenu).PopupComponent as TTreeView).Selected;
         case AnItem.level of
         0: for i := 0 to (Sender as TPopUpMenu).Items.Count - 1 do
             (Sender as TPopUpMenu).Items[i].Enabled := false;
         1: begin
             temp := StringReplace(AnItem.Text,'  ',' ',[rfReplaceAll]);
             if StrToInt(piece(temp,':',2)) < 1 then begin
             for i := 0 to (Sender as TPopUpMenu).Items.Count - 1 do
               (Sender as TPopUpMenu).Items[i].Enabled := false;
               exit; //No Queues to process
               end;
             if TVBPQueues.SelectionCount > 1 then begin
               Windows.MessageBox(frmSiteParameters.Handle,PChar('Only one selection allowed at this level!'),' ',MB_SYSTEMMODAL) ;
               tvBPQueues.Selections[0].Selected := false;
               exit;
               end;
              if pos('FAILED',uppercase(AnItem.Text)) <> 0 then begin
                 (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popSetQueuePartition)].Enabled := false;
                 (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popRequeue)].Enabled := true;
                 (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popPurgeQueue)].Enabled := true;
                 (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popImportQueueProperties)].Enabled := false;
                 if pos('EVAL',uppercase(AnItem.Parent.Text)) <> 0 then
                   (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popRequeue)].Enabled := false;
              end
              else if pos('ACTIVE',uppercase(AnItem.Text)) <> 0 then begin
                 (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popImportQueueProperties)].Enabled := false;
                 (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popSetQueuePartition)].Enabled := false;
                 (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popRequeue)].Enabled := false;
                 (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popPurgeQueue)].Enabled := true;
              end;
            end;
         2: begin
              if pos('FAILED',uppercase(AnItem.Parent.Text)) <> 0 then begin
                 (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popSetQueuePartition)].Enabled := false;
                 (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popRequeue)].Enabled := true;
                 (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popPurgeQueue)].Enabled := true;
                 if pos('IMPORT',uppercase(AnItem.Parent.Parent.Text)) <> 0 then
                   (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popImportQueueProperties)].Enabled := false;
                 if pos('EVAL',uppercase(AnItem.Parent.Parent.Text)) <> 0 then
                   (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popRequeue)].Enabled := false;
                 end // if pos('Failed'...
              else if pos('Active',AnItem.Parent.Text) <> 0 then begin
                if ((Sender as TPopUpMenu).PopupComponent as TTreeView).SelectionCount > 1 then
                  (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popSetQueuePartition)].Enabled := false
                else (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popSetQueuePartition)].Enabled := true;
                  (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popRequeue)].Enabled := false;
                (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popPurgeQueue)].Enabled := true;
                if pos('IMPORT',uppercase(AnItem.Parent.Parent.Text)) <> 0 then
                   (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popImportQueueProperties)].Enabled := True
                else
                   (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popImportQueueProperties)].Enabled := false;
                if pos('EVAL',uppercase(AnItem.Parent.Parent.Text)) <> 0 then begin
                  (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popRequeue)].Enabled := false;
                  (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popSetQueuePartition)].Enabled := false ;
                  end; // if pos('EVAL'...
               end; // else if pos('Active'...
            end; // Case level 2
         3: begin
               if pos('FAILED',uppercase(AnItem.Parent.Parent.Text)) <> 0 then begin
                 (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popSetQueuePartition)].Enabled := false;
                 (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popRequeue)].Enabled := true;
                 (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popPurgeQueue)].Enabled := true;
                 if pos('IMPORT',uppercase(AnItem.Parent.Parent.Parent.Text)) <> 0 then
                   (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popImportQueueProperties)].Enabled := True
                 else
                   (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(popImportQueueProperties)].Enabled := false;
              end;
            end;
          else for i := 0 to (Sender as TPopUpMenu).Items.Count - 1 do
             (Sender as TPopUpMenu).Items[i].Enabled := false;
          end; // case
      end;
    end;

// Case AnItem.level.level of

end;

procedure TfrmSiteParameters.popSetQueuePartitionClick(Sender: TObject);
var
  AnItem: TTreeNode;
  QIEN,Queue,temp: string;
begin
  AnItem := tvBPQueues.Selections[0];
  temp := StringReplace(AnItem.Text,'  ',' ',[rfReplaceAll]);
  temp := StringReplace(temp,' ','^',[rfReplaceAll]);
  QIEN := piece(temp,'^',1);
  Queue := piece(temp,'^',2);
  QueuePointerUPdate(Queue,QIEN);
  ReSetQueueCnt(Queue);
  pcSiteParametersChange(pcSiteParameters);
end;

procedure TfrmSiteParameters.popRequeueClick(Sender: TObject);
procedure QueueUpdate(TV: TTreeView;Partition,Queue,Value:string);
//to be used for updating the Active Queue Parition when requeuing
var
   CurItem,Part: TTreeNode;
   tmp: string;
   i : integer;
begin
  //dmMain.fmlQueueRecord.GetRecord(Value+',');
  with dmMain.fmgQueueRecord do begin
    IENS := Value+',';
    GetData;
  if ErrorList.Count > 0 then begin
    Windows.MessageBox(frmSiteParameters.Handle,PChar('Invalid data value!'),'',MB_SYSTEMMODAL);
     exit;
     end;
  for i := 0 to FieldNumbers.Count - 1 do
    tmp := tmp + GetField(FieldNumbers[i]).FMDBExternal+'  ';
    end; // with dmMain.fmgQueueRecord
  trim(tmp);
  CurItem := TV.Items.GetFirstNode;
  while (pos(uppercase(Queue),uppercase(CurItem.Text)) = 0) and (CurItem <> nil) do
    CurItem := CurItem.getNextSibling;
  if pos(uppercase(Queue),uppercase(CurItem.Text)) <> 0 then begin
    Part := CurItem.getFirstChild;
    while (pos(uppercase(Partition),uppercase(Part.Text)) = 0) and (Part <> nil) do
      Part := Part.getNextSibling;
    if part = nil then begin
      Windows.MessageBox(frmSiteParameters.Handle,PChar('The '+Partition+ ' subnode of the '+Queue+' queue partition could not be found!'),' ',MB_SYSTEMMODAL) ;
      exit;
      end;
    if pos(uppercase(Partition),uppercase(Part.Text)) <> 0 then
      TV.Items.AddChild(Part,value+' '+tmp);
    part.Text := (piece(part.Text,':',1)+ ': '+IntToStr(StrToInt(trim(piece(part.Text,':',2)))+1));
  end;
end; // QueueUpdate


procedure RQueue(Queue:string;Node:TTreenode);
var temp : string;
begin
  temp := StringReplace(Node.Text,'  ',' ',[rfReplaceAll]);
  temp := StringReplace(temp,' ','^',[rfReplaceAll]);
  try
   if StrToInt(piece(temp,'^',1)) < 1 then exit;
  except
    exit;
    end;
  QueueUpdate(tvBPQueues,'Active',Queue,Requeue(piece(temp,'^',1)));
end;

var
  AnItem,CurrentItem,ChildItem,ItemChild: TTreeNode;
  i : integer;
  temp,queue: string;
begin
  if Sender.ClassName = 'TMenuItem' then begin
    with ((Sender as TMenuItem).GetParentComponent) as TPopUpMenu do begin
      if PopUpComponent.ClassType = TTreeview then begin
          AnItem := (PopupComponent as TTreeView).Selected;
        try
          Application.NormalizeTopMosts;
          SetWindowPos(frmSiteParameters.Handle, HWND_NOTOPMOST, 0,0,0,0,
            SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
        case AnItem.Level of
          1: begin
               queue := AnItem.Parent.Text;
               if MessageDlg('Do you wish to re-queue all '+piece(AnItem.Text,':',1) +
                 '('+trim(piece(AnItem.Text,':',2))+') '+AnItem.Parent.Text+' queues ?',
                 mtConfirmation, mbYesNoCancel,0) = mrYes then begin
                 While AnItem.HasChildren do begin
                   ItemChild := AnItem.getFirstChild;
                   while ItemChild.HasChildren do begin
                     RQueue(Queue,ItemChild.getFirstChild);
                     ItemChild.getFirstChild.Delete;
                     end; // while ItemChild.HasChildren
                   ItemChild.Delete;
                   end; // While AnItem.HasChildren
                   AnItem.Text := 'Failed: 0';
                   end; // if MessageDlg('
                 ReSetQueueCnt(Queue);
             end; // case of 1
          2: begin
               temp := StringReplace(AnItem.Parent.Text,'  ',' ',[rfReplaceAll]);
               if StrToInt(piece(temp,':',2)) < 1 then begin
                 Windows.MessageBox(frmSiteParameters.Handle,PChar('Queue and Status could not be determined from: '+temp+' and '+AnItem.Parent.Text),' ',MB_SYSTEMMODAL) ;
                 exit; //No Queues to process
                 end;
                 if (PopupComponent as TTreeView).SelectionCount < 1 then exit;
                 Queue := AnItem.Parent.Parent.Text;
                 if pos('FAILED',uppercase(AnItem.Parent.Text)) <> 0 then begin
                   // Status level - Purge Children then Status
                   if MessageDlg('Do you wish to Re-Queue all ' + AnItem.Parent.Parent.Text+
                      ' queues, with a status of '+piece(AnItem.Text,':',1)+'('+trim(piece(AnItem.Text,':',2))+') ?',
                      mtConfirmation, mbYesNoCancel,0) <> mrYes then exit;
                   AnItem.Parent.Text := ('Failed: ' + IntToStr(StrToInt(trim(piece(AnItem.Parent.Text,':',2))) - AnItem.Count));
                   while AnItem.HasChildren do begin
                     RQueue(Queue,AnItem.getFirstChild);
                     AnItem.getFirstChild.Delete;
                     end; // while AnItem.HasChildren
                 // Need to recount Failed and update Failed Node before removing Status Node
                   AnItem.Delete; // Purge Status
                   ReSetQueueCnt(Queue);
                   end //if pos('FAILED',
                 else begin // not pos('FAILED'
                   if MessageDlg('Do you wish to Re-queue all selected ('+IntToStr((PopupComponent as TTreeView).SelectionCount)+ ') '+
                     piece(AnItem.parent.text,':',1)+ ' '+AnItem.Parent.Parent.Text+' queues ?',mtConfirmation, mbYesNoCancel,0) <> mrYes then exit;
                   AnItem.Parent.Text := ('Active: '+ IntToStr(StrToInt(trim(piece(AnItem.Parent.Text,':',2))) - (PopupComponent as TTreeView).SelectionCount));
                   for i := (PopupComponent as TTreeView).SelectionCount - 1 downto 0 do begin
                     ItemChild := (PopupComponent as TTreeView).Selections[i];
                     RQueue(Queue,ItemChild);
                     ItemChild.Delete;
                     end; // for
                   ReSetQueueCnt(Queue);
                   end;  // else
               end; //case of 2
          3: begin
               if MessageDlg('Do you wish to Re-Queue all selected ('+IntToStr((PopupComponent as TTreeView).SelectionCount)+ ') ' +
                 piece(AnItem.Parent.parent.text,':',1)+ ' '+AnItem.Parent.Parent.Parent.Text+' queues, with a status of '+piece(AnItem.Parent.Text,':',1)+' ?',
                 mtConfirmation, mbYesNoCancel,0) = mrYes then begin
                   Queue := AnItem.Parent.Parent.Parent.Text ;
                   AnItem.Parent.Text := (piece(AnItem.Parent.Text,':',1)+': '+ IntToStr(StrToInt(trim(piece(AnItem.Parent.Text,':',2)))-(PopupComponent as TTreeView).SelectionCount));
                   AnItem.Parent.Parent.Text := ('Failed: '+ IntToStr(StrToInt(trim(piece(AnItem.Parent.Parent.Text,':',2))) - (PopupComponent as TTreeView).SelectionCount));
                   for i := (PopupComponent as TTreeView).selectioncount - 1 downto 0 do begin
                       ItemChild := (PopupComponent as TTreeView).Selections[i];
                     RQueue(Queue,ItemChild);
                     ItemChild.Delete
                     end; // for
                   ReSetQueueCnt(Queue);
                   end;  // if MessageDlg('
              end; // case level 3
           else Windows.MessageBox(frmSiteParameters.Handle,PChar('Unexpected Tree Level: '+IntToStr(AnItem.level)),' ',MB_SYSTEMMODAL) ;
           AnItem.Free;
           end; //case AnItem.Level of
//    pcSiteParametersChange(pcSiteParameters);
         finally
           Application.NormalizeTopMosts;
           SetWindowPos(frmSiteParameters.Handle, HWND_TOPMOST, 0,0,0,0,
             SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
         end; // try...finally
         end;  // if PopUpComponent.ClassType = TTreeview
      end;  // with ((Sender as TMenuItem).GetParentComponent) as TPopUpMenu
     end;  // if Sender.ClassName = 'TMenuItem'

end; //procedure popRequeueClick
function TfrmSiteParameters.Requeue(ien:string):string;
begin
  with dmMain.RPCBroker1 do begin
    Param[0].VALUE := ien;
    Param[0].PTYPE := LITERAL;
    RemoteProcedure := 'MAGQ REQ';
    try
      Call;
    except
      on E:Exception do  MAGBTMF1.OnException(E);
    end; //try...except
    ReQueue := Results[0];
    end; //  with dmMain.RPCBroker1
end;
procedure TfrmSiteParameters.ReSetQueueCnt(Queue:string);
begin
  with dmMain.RPCBroker1 do begin
    Param[0].VALUE := IntToStr(magbtm1.place);
    Param[0].PTYPE := LITERAL;
    Param[1].VALUE := Queue;
    Param[1].PTYPE := LITERAL;
    RemoteProcedure := 'MAGQ QCNT';
    try
      Call;
    except
      on E:Exception do  MAGBTMF1.OnException(E);
    end; //try...except
    end; //  with dmMain.RPCBroker1
end;

procedure TfrmSiteParameters.DeQueue(ien:string);
begin
  with dmMain.RPCBroker1 do begin
    Param[0].VALUE := ien;
    Param[0].PTYPE := LITERAL;
    RemoteProcedure := 'MAGQB QUEDEL';
    try
      Call;
    except
      on E:Exception do  MAGBTMF1.OnException(E);
    end; //try...except
    end; //  with dmMain.RPCBroker1
end;

procedure TfrmSiteParameters.QueuePointerUPdate(Queue,ien:string);
var i: string;
  filer: TFMFiler;
begin
if queue <> '' then begin
  i := dmMain.GetVariable('$S($D(^MAGQUEUE(2006.031,"C","'+IntToStr(magbtm1.Place)+'","'+
  Queue+'"))'+':$O(^MAGQUEUE(2006.031,"C","'+IntToStr(magbtm1.Place)+'","'+Queue+'","0")),1:0)');
  filer := TFMFiler.Create(self);
  filer.RPCBroker := dmMain.RPCBroker1;
  Filer.AddFDA('2006.031',i+',','1',ien);
  filer.Update;
  filer.Free;
  end;
end;
procedure TfrmSiteParameters.tvMailGroupsMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
function NodeHint(tn: TTreeNode): string;
begin
  result := '';
  case tn.Level of
    0: result := 'Mail Group';
    1: begin
        if pos('MEM',UpperCase(tn.Text)) <> 0 then result := 'Mail User';
        if pos('GRP',UpperCase(tn.Text)) <> 0 then result := 'Mail Group';
        if pos('REM MEM',UpperCase(tn.Text)) <> 0 then result := 'Remote Mail User';
        if result = '' then result := 'Mail Group Member';
       end; // 1:
  end; // case tn.Level
end; // node hint

var
  tree: TTreeView;
  hoverNode: TTreeNode;
  hitTest : THitTests;
begin

  if (Sender is TTreeView) then tree := TTreeView(Sender)
  else Exit;
  hoverNode := tree.GetNodeAt(X, Y) ;
  if hoverNode = nil then exit;
  hitTest := tree.GetHitTestInfoAt(X, Y) ;
  if (lastHintNode <> hoverNode) then
  begin
    Application.CancelHint;
    if (hitTest <= [htOnItem, htOnIcon, htOnLabel, htOnStateIcon]) then
    begin
      lastHintNode := hoverNode;
      tree.Hint := NodeHint(hoverNode) ;
    end;
  end;

end;

procedure TfrmSiteParameters.tvMailMessagesMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
function NodeHint(tn: TTreeNode): string;
begin
  case tn.Level of
    0: result := 'Mail Message';
    1: begin
        if pos('MEM',UpperCase(tn.Text)) <> 0 then result := 'Mail User';
        if pos('GRP',UpperCase(tn.Text)) <> 0 then result := 'Vista Imaging Mail Group';
        if pos('KEY',UpperCase(tn.Text)) <> 0 then result := 'Security Keys';
       end; // 1:
  end; // case tn.Level of
end; // NodeHint
var
  tree: TTreeView;
  hoverNode: TTreeNode;
  hitTest : THitTests;
begin
  if (Sender is TTreeView) then tree := TTreeView(Sender)
  else Exit;
  hitTest := tree.GetHitTestInfoAt(X, Y) ;
  hoverNode := tree.GetNodeAt(X,Y);
  if (lastHintNode <> hoverNode) then begin
    Application.CancelHint;
    if (hitTest <= [htOnItem, htOnIcon, htOnLabel, htOnStateIcon]) then begin
      lastHintNode := hoverNode;
      tree.Hint := NodeHint(hoverNode);
      end; // if (hitTest <=
    end;  // if (lastHintNode <> hoverNode)
end;

procedure TfrmSiteParameters.tvBPQueuesMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);

function NodeHint(tn: TTreeNode): string;
begin
  case tn.Level of
    0: result := format('%s', ['Background Processor Queue']);
    1: if pos('ACTIVE',UpperCase(tn.Text)) <> 0 then
         result := format('%s- %s - %s', ['Active ',tn.Parent.Text,' BP Queues'])
       else if pos('FAILED',UpperCase(tn.Text)) <> 0 then
         result := format('%s - %s - %s', ['Inactive ',tn.Parent.Text,' BP Queues']);
    2: if pos('ACTIVE',UpperCase(tn.Parent.Text)) <> 0 then
         result := format('%s', ['Queue IEN / Queue / Site / Queuer  / Date Time of Queue / Status / Image IEN / Re-Queue Count'])
       else if pos('FAILED',UpperCase(tn.Text)) <> 0 then
         result := format('%s', ['Failed Queue status']);
    3: result := format('%s', ['Queue IEN / Queue / Site / Queuer  / Date Time of Queue / Status / Image IEN / Type / Re-Queue Count']);
  end; // case tn.Level of
end; // NodeHint
var
  tree: TTreeView;
  hoverNode: TTreeNode;
  hitTest : THitTests;
begin
  if (Sender is TTreeView) then
    tree := TTreeView(Sender)
  else Exit;
  hoverNode := tree.GetNodeAt(X, Y) ;
  hitTest := tree.GetHitTestInfoAt(X, Y) ;
  if (lastHintNode <> hoverNode) then
  begin
    Application.CancelHint;
    if (hitTest <= [htOnItem, htOnIcon, htOnLabel, htOnStateIcon]) then
    begin
      lastHintNode := hoverNode;
      tree.Hint := NodeHint(hoverNode) ;
    end;
  end;
end;

procedure TfrmSiteParameters.tvBPServerTasksMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
function NodeHint(tn: TTreeNode): string;
 var BPSien,CName: string;
begin
  case tn.Level of
    0: begin
         BPSien := dmMain.FindC('2006.8','','QXK',IntToStr(magbtm1.place)+'^'+trim(tn.Text),'D','');
         CName := dmMain.GetFieldValue('2006.8','50',BPSien+',','E',true);
         result := 'BP Server Name: '+CName;
         end;
    1: result := 'BP Tasks';
    else ;
  end; // case tn.Level of
end; // NodeHint
var
  tree: TTreeView;
  hoverNode: TTreeNode;
  hitTest : THitTests;
begin
  if (Sender is TTreeView) then tree := TTreeView(Sender)
  else Exit;
  hoverNode := tree.GetNodeAt(X, Y) ;
  hitTest := tree.GetHitTestInfoAt(X, Y) ;
  if (lastHintNode <> hoverNode) then
  begin
//    Application.CancelHint;
//    GBBPNetworkLogFiles.Visible := false;
    if (hitTest <= [htOnItem, htOnIcon, htOnLabel, htOnStateIcon]) then begin
      lastHintNode := hoverNode;
      tree.Hint := NodeHint(hoverNode) ;
      if hoverNode.Level <> 0 then
        if pos(UpperCase('Unassigned Tasks'),Uppercase(hoverNode.Parent.Text)) <> 0 then exit
      else
       if pos(UpperCase('Unassigned Tasks'),Uppercase(hoverNode.Text)) <> 0 then exit
      end;
    end;
end;


procedure TfrmSiteParameters.puNetLogClick(Sender: TObject);
var
  AnItem: TTreeNode;
  IEN: string;
begin
  with ((Sender as TMenuItem).GetParentComponent as TPopUPMenu) do
    with PopupComponent as TTreeView do
      if SelectionCount > 0 then begin
        AnItem := Selected;
        if AnItem.Level = 1 then
          IEN := dmMain.FindC('2006.8','','QXK',IntToStr(magbtm1.place)+'^'+AnItem.Parent.Text,'D','')
        else
          IEN := dmMain.FindC('2006.8','','QXK',IntToStr(magbtm1.place)+'^'+AnItem.Text,'D','');
         end;
      Application.CreateForm(TfrmBPProperties,frmBPProperties1);
      frmBPProperties.IENS := IEN+',';
      if AnItem.Level = 1 then frmBPProperties.Workstation := AnItem.Parent.Text
      else frmBPProperties.Workstation := AnItem.Text;
      frmBPProperties1.FMGets1.IENS := IEN+',';
      frmBPProperties1.FMGets1.GetAndFill;
      frmBPProperties1.Caption := format('%s * %s',[ ' '+
         frmBPProperties1.Caption+' ',frmBPProperties1.FMGets1.GetField('.01').FMDBExternal+' * '+
         frmBPProperties1.FMGets1.GetField('50').FMDBExternal]);
      try
        frmBPProperties1.ShowModal;
      finally
        frmBPProperties1.Free;
      end; // try...finally
end;

procedure TfrmSiteParameters.popBPWSPopup(Sender: TObject);
var
       i: integer;
  AnItem: TTreeNode;
begin
  if (Sender as TPopUpMenu).PopupComponent.ClassName = 'TTreeView' then begin
    with (Sender as TPopUpMenu).PopupComponent as TTreeView do
      if ((Sender as TPopUpMenu).PopupComponent as TTreeView).SelectionCount > 0 then begin
         AnItem := ((Sender as TPopUpMenu).PopupComponent as TTreeView).Selected;
         case AnItem.level of
           0: begin
               if AnItem.HasChildren or btnApply.Enabled then
                 (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(puDeleteBPWS)].Enabled := false
               else (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(puDeleteBPWS)].Enabled := true;
               if pos('Unassigned Tasks',AnItem.Text) <> 0 then
                 for i := 0 to (Sender as TPopUpMenu).Items.Count - 1 do (Sender as TPopUpMenu).Items[i].Enabled := false
                else (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(puNetLog)].Enabled := true;
               end; // Case level 0
           1: begin
               (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(puDeleteBPWS)].Enabled := false ;
               if pos('Unassigned Tasks',AnItem.Parent.Text) <> 0 then
                 for i := 0 to (Sender as TPopUpMenu).Items.Count - 1 do (Sender as TPopUpMenu).Items[i].Enabled := false
               else (Sender as TPopUpMenu).Items[(Sender as TPopUpMenu).Items.IndexOf(puNetLog)].Enabled := true;
               end; // Case level 1
           end; //case AnItem.level of
      end  // if ((Sender as TPopUpMenu).PopupComponent as TTreeView).SelectionCount > 0
    else ;//for i := 0 to (Sender as TPopUpMenu).Items.Count do (Sender as TPopUpMenu).Items[i].Enabled := false;
    end; // if (Sender as TPopUpMenu).PopupComponent.ClassName = 'TTreeView'
end;

procedure TfrmSiteParameters.btnAddBPWSClick(Sender: TObject);

begin
    try
      Application.CreateForm(TfrmMagNewBP,frmMagNewBP);
      frmMagNewBP.ShowModal;
    finally
      frmMagNewBP.Free;
      pcSiteParametersChange(pcSiteParameters);
      Application.ProcessMessages;
    end; //try...finally
end;

procedure TfrmSiteParameters.mnuRemoteMailMemberClick(Sender: TObject);

var
  AnItem: TTreeNode;
  ien,cap: string;
begin
  if Sender.ClassName = 'TMenuItem' then
    with ((Sender as TMenuItem).GetParentComponent) as TPopUpMenu do begin
      if PopUpComponent.ClassName = 'TTreeView' then
        with PopUpComponent as TTreeView do
          if SelectionCount > 0 then begin
            AnItem := Selected;
            if AnItem.Level = 0 then begin
              ien := dmMain.Find1('3.8','','',AnItem.Text,'B','',true);
              cap := AnItem.Text;
              end;
            if AnItem.Level = 1 then begin
              ien := dmMain.Find1('3.8','','',AnItem.Parent.Text,'B','',true);
              cap := AnItem.Parent.Text;
              end;
            Application.CreateForm(TfrmRemoteMailMember,frmRemoteMailMember);
            frmRemoteMailMember.Caption :=
            format('%s - %s',[ 'Adding Remote Member ', cap]);
            magRemoteMailMember.frmIEN := ','+ien+',';
            frmRemoteMailMember.fmeRemoteMailMember.IENS := ','+ien+',';
            try
              frmRemoteMailMember.ShowModal;
            finally
              frmRemoteMailMember.Free;
              end;  // try...finally
            dmMain.fmlKernelMailGroups.IENS := '';
            dmMain.fmlKernelMailGroups.Screen := 'I $E($P($G(^XMB(3.8,Y,0)),U,1),1,3)="MAG"';
            TreeViewUpdate(true,true,dmMain.fmlKernelMailGroups,dmMain.fmlKernelMailGroupMembers,tvMailGroups,'Mem');
            TreeViewUpdate(false,true,dmMain.fmlKernelMailGroups,dmMain.fmlKernelRemoteMember,tvMailGroups,'Rem Mem');
            TreeViewUpdate(false,true,dmMain.fmlKernelMailGroups,dmMain.fmlKernelMailMemberGroups,tvMailGroups,'GRP');
            tvMailGroups.ToolTips := false;
          end; // if SelectionCount > 0
      end; //with ((Sender as TMenuItem).GetParentComponent) as TPopUpMenu
end;

procedure TfrmSiteParameters.mnuDeleteMemberClick(Sender: TObject);
var
  AnItem: TTreeNode;
  ienM,ienS,subfile,node: string;
begin
  if Sender.ClassName = 'TMenuItem' then
    with ((Sender as TMenuItem).GetParentComponent) as TPopUpMenu do
      if PopUpComponent.ClassName = 'TTreeView' then
        with PopUpComponent as TTreeView do
          if SelectionCount > 0 then begin
            AnItem := Selected;
            if pos('Mem',piece(AnItem.Text,' : ',2)) <> 0 then
               if pos('Rem Mem',piece(AnItem.Text,' : ',2)) <> 0 then begin
                 subfile := '3.812';
                 node := '6';
                 end
               else begin
                 subfile := '3.81';
                 node := '1';
                 end;
            if pos('GRP',piece(AnItem.Text,' : ',2)) <> 0 then begin
              subfile := '3.811';
              node := '5';
              end;
            if AnItem.Level = 1 then begin
              ienM := dmMain.Find1('3.8','','',LeftStr(AnItem.parent.Text,30),'B','',true);
              ienS := dmMain.Find1(subfile,','+ienM+',','',LeftStr(piece(AnItem.Text,' : ',1),30),'B','',true);
              if pos('-1',ienS) <> 0 then begin    //CHECK THIS CODE - NODE IS EQUAL TO ZERO!!!
                ienS := dmMain.GetVariable('$S($D(^XMB(3.8,'+ienM+','+node+',"B","'+piece(AnItem.Text,' : ',1)+'"))'+
                  ':$O(^XMB(3.8,'+ienM+','+node+',"B","'+piece(AnItem.Text,' : ',1)+'","")),1:0)');
                end; //i f pos('-1'...
              if StrToInt(ienS)> 0 then begin
                dmMain.FMUpdate(subfile,'.01',ienS+','+ienM+',','@' );
                //EditList.Add(SubFile+'^'+ienS+','+ienM+'^'+'.01'+'^@^@');
                AnItem.Delete;
                end;
              end;  // if AnItem.Level = 1
            end; // if SelectionCount > 0
//   MailGroupUpdate(magbtm1.place,nil);
end; //mnuDeleteMemberClick
procedure TfrmSiteParameters.mnuDeleteMessageMemberClick(Sender: TObject);
var
  AnItem: TTreeNode;
  ienM,ienS,subfile: string;
begin
  if Sender.ClassName = 'TMenuItem' then
    with ((Sender as TMenuItem).GetParentComponent) as TPopUpMenu do
      if PopUpComponent.ClassName = 'TTreeView' then
        with PopUpComponent as TTreeView do
          if SelectionCount > 0 then begin
            AnItem := Selected;
            if AnItem.Level = 1 then begin
              ienM := dmMain.Find1('2006.166',(',' + IntToStr(magbtm1.place)+','),'',LeftStr(AnItem.parent.Text,30),'B','',true);
              if pos('MEM',piece(uppercase(AnItem.Text),' : ',2)) <> 0 then Subfile := '2006.1664';
              if pos('GRP',piece(uppercase(AnItem.Text),' : ',2)) <> 0 then Subfile := '2006.1662';
              if pos('KEY',piece(uppercase(AnItem.Text),' : ',2)) <> 0 then Subfile := '2006.1665';
              ienS := dmMain.Find1(SubFile,(','+ienM+','+ IntToStr(magbtm1.place)+','),'',LeftStr(piece(AnItem.Text,' : ',1),30),'B','',true);
              if pos('-1',ienS) <> 0 then exit;
                dmMain.FMUpdate(subfile,'.01',ienS+','+ienM+','+ IntToStr(magbtm1.place),'@' );
              //EditList.Add(SubFile+'^'+ienS+','+ienM+','+ IntToStr(magbtm1.place)+'^'+'.01'+'^@^@');
              AnItem.Delete;
              end;  // if AnItem.Level = 1
            end; // if SelectionCount > 0
end;

procedure TfrmSiteParameters.tvMailGroupsMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
      HT: THitTests;
      i: integer;
begin
  //*********** Fixes problem with the RightClickSelect property of TreeView
 (Sender as TTreeView).selected := (Sender as TTreeView).getNodeAt(X,Y);
  if (Sender as TTreeView).selected = nil then begin
    for i := 0 to popTVXWBMailGroup.Items.Count - 1 do
      popTVXWBMailGroup.Items[i].Enabled := false;
    exit;
    end;
  HT := (Sender as TTreeView).GetHitTestInfoAt(X, Y);
  if Button = mbLeft then{ drag only if left button pressed }
    if DragDetect((Sender as TTreeView).Handle, POINT(X, Y)) then begin
      //  Don't Drag Group NODES - ELSE only allow the moving of the Group NODE members
      //  Code that in the DRAGDROP event
      if (sender as TTreeView).Selected.Level <> 0 then
         (sender as TTreeView).BeginDrag(false);
      end; //if DragDetect
end;

procedure TfrmSiteParameters.fmeDateChangeFuture(Sender: TObject);
begin
  with Sender as TFMEdit do begin
    if (Sender as TFMEdit).FMDBExternal <> (Sender as TFMEdit).Text then begin// must Validate if OnExit Processing is not set
      if Validate and (StrToDate(Text)>(Today - 1)) then begin
        FMFiler.AddFDA(FMFile,IENS,FMField,DateToFMInternal(text));
        btnApply.Enabled := true;
        PageControlChange(pcSiteParameters,true);
        end // if Validate
      else begin
        SiteParametersDisplayHelp(Sender);
        Text := FMDBExternal; {reset value to previous}
        end;  // else
      end; // if FMDBInternal <> Text ..if change
    end;  // with Sender as TFMEdit
end;

procedure TfrmSiteParameters.BitBtnSchedPurgeDateClick(Sender: TObject);
begin
   Application.CreateForm(TfrmGenericCalendar,frmGenericCalendar);
   DateString := '';
   frmGenericCalendar.Caption := 'Next Purge Date';
   try
     frmGenericCalendar.ShowModal;
   finally
     frmGenericCalendar.Free;
   end; // try...finally
   if length(DateString) > 4 then begin
     fmeSchedPurgeDate.Text := DateString;
     fmeDateChangeFuture(fmeSchedPurgeDate);
     end;
   DateString := '';
end;


procedure TfrmSiteParameters.BitBtnNextVerifierDateClick(Sender: TObject);

begin
   Application.CreateForm(TfrmGenericCalendar,frmGenericCalendar);
   DateString := '';
   frmGenericCalendar.Caption := 'Next Verifier Date';
   frmGenericCalendar.ShowModal;
   frmGenericCalendar.Free;
   if length(DateString) > 4 then begin
     fmeNextVerifierDate.Text := DateString;
     fmeDateChangeFuture(fmeNextVerifierDate);
     end;
   DateString := '';
end;

procedure TfrmSiteParameters.BitBtnSchedPurgeTimeClick(Sender: TObject);
var dttm : String;
  dDttm : TDateTime;
  pt : Tpoint;
begin
  Application.CreateForm(TfrmTimeDialog,frmTimeDialog);
  dttm := '';
  pt.X := (sender as TBitbtn).Left + (sender as TBitbtn).Width;
  pt.Y := ((sender as TBitbtn).top + (sender as TBitbtn).height) - frmTimeDialog.Height;
  pt := (Sender as TBitBtn).ClientToScreen(pt) ;  //<<<<<  Sending a point on the screen, I open my  DateTIme Picker close to where the mouse currently is.
  if frmTimeDialog.execute(pt,dttm,dDtTm) then begin
//    if  compareDateTime(now,ddttm) = -1  then begin
//      Windows.MessageBox(frmTimeDialog.Handle,PChar('A Future Date/Time is not allowed.'),' ',MB_SYSTEMMODAL);
//      exit;
//      end;
    fmePPSPT.Text :=  StripTime(dttm);
    fmeFilePrefixChange(fmePPSPT);
    end;
  fmePPSPT.SetFocus;
  frmTimeDialog.Free;
end;

procedure TfrmSiteParameters.BitBtnSchedRGAdvanceDateClick(Sender: TObject);
begin
   Application.CreateForm(TfrmGenericCalendar,frmGenericCalendar);
   DateString := '';
   frmGenericCalendar.Caption := 'Scheduled RG Advance Date';
   frmGenericCalendar.ShowModal;
   frmGenericCalendar.Free;
   if length(DateString) > 4 then begin
     fmeSchedRGAdvanceDate.Text := DateString;
     fmeDateChangeFuture(fmeSchedRGAdvanceDate);
     end;
   DateString := '';

end;

procedure TfrmSiteParameters.BitBtnSchedRGAdvanceTimeClick(Sender: TObject);
var dttm : String;
  dDttm : TDateTime;
  pt : Tpoint;
begin
  Application.CreateForm(TfrmTimeDialog,frmTimeDialog);
  dttm := '';
  pt.X := (sender as TBitbtn).Left + (sender as TBitbtn).Width;
  pt.Y := ((sender as TBitbtn).top + (sender as TBitbtn).height) - frmTimeDialog.Height;
  pt := (Sender as TBitBtn).ClientToScreen(pt) ;  //<<<<<  Sending a point on the screen, I open my  DateTIme Picker close to where the mouse currently is.
  if frmTimeDialog.execute(pt,dttm,dDtTm) then begin
 //   if  compareDateTime(now,ddttm) = -1  then begin
 //   Windows.MessageBox(frmTimeDialog.Handle,PChar('A Future Date/Time is not allowed.'),' ',MB_SYSTEMMODAL) ;
 //     exit;
 //     end;
    fmeSchedRGAdvanceTime.Text :=  StripTime(dttm);
    fmeFilePrefixChange(fmeSchedRGAdvanceTime);
    end;
  fmeSchedRGAdvanceTime.SetFocus;
  frmTimeDialog.Free;
end;


procedure TfrmSiteParameters.mnuMailMessageDeleteClick(Sender: TObject);
var
  AnItem: TTreeNode;
  ienM,ienS,ienMess,ienE,subfile,node,internal: string;
begin
  if Sender.ClassName = 'TMenuItem' then
    with ((Sender as TMenuItem).GetParentComponent) as TPopUpMenu do
      if PopUpComponent.ClassName = 'TTreeView' then
        with PopUpComponent as TTreeView do
          if SelectionCount > 0 then begin
            AnItem := Selected;
            if pos('Mem',piece(AnItem.Text,' : ',2)) <> 0 then begin
              subfile := '2006.1664';
              node := '3';
              internal := dmMain.Find1('200','','O',LeftStr(piece(AnItem.Text,' - ',1),30),'B','',true);
              end;
            if pos('GRP',piece(AnItem.Text,' : ',2)) <> 0 then begin
              subfile := '2006.1662';
              node := '1';
              internal := dmMain.Find1('3.8','','O',LeftStr(piece(AnItem.Text,' : ',1),30),'B','',true);
              end;
            if pos('Key',piece(AnItem.Text,' : ',2)) <> 0 then begin
              subfile := '2006.1665';
              node := '4';
              internal := dmMain.Find1('19.1','','',LeftStr(piece(AnItem.Text,' : ',1),30),'B','',true);
              end;
            if AnItem.Level = 1 then begin
              ienM := ','+IntToStr(magbtm1.Place)+',';
              ienMess := dmMain.Find1('2006.166',ienM,'O',LeftStr(AnItem.parent.Text,30),'B','',true);
              ienS := dmMain.Find1(subfile,','+ienMess+ienM,'O',LeftStr(piece(AnItem.Text,' : ',1),30),'B','',true);
              if pos('-1',ienS) <> 0 then begin
                ienS := dmMain.GetVariable('$S($D(^MAG(2006.1,'+IntToStr(magbtm1.Place)+',6,'+ienMess+','+node+',"B","'+internal+'"))'+
                  ':$O(^MAG(2006.1,'+IntToStr(magbtm1.Place)+',6,'+ienMess+','+node+',"B","'+internal+'","")),1:0)');
                end; //i f pos('-1'...
              if StrToInt(ienS)> 0 then begin
                ienE :=ienS+','+ienMess+ienM;
                //dmMain.FMUpdate(subfile,'.01',ienS+','+ienM+',','@' );
                EditList.Add(SubFile+'^'+ienE+'^'+'.01'+'^@^@');
                AnItem.Delete;
                btnApply.Enabled := true;
                end
                else Windows.MessageBox(frmSiteParameters.Handle,PChar('Lookup failed: '+ienS+','+ienMess+ienM),' ',MB_SYSTEMMODAL) ;
              end;  // if AnItem.Level = 1
            end; // if SelectionCount > 0
//          MailMessageUpdate(magbtm1.place,self);
end;

procedure TfrmSiteParameters.FormActivate(Sender: TObject);
var i : integer;
begin
  {$ifdef Win32}
          SetForegroundWindow(frmSiteParameters.Handle);
  {$else}
          BringWindowToTop(frmSiteParameters.Handle);
  {$endif}
  order := 'd';
  for i := 0 to frmSiteParameters.ComponentCount - 1 do begin
    if (frmSiteParameters.Components[i] is TListView) then
      with frmSiteParameters.Components[I] as TListView do begin
        OnColumnClick := lvColumnClick;
        OnCompare := lvCompare;
        RowSelect := true;
        end;
     end;
end;

procedure TfrmSiteParameters.BitBtnSchedVerifierTimeClick(Sender: TObject);
var dttm : String;
  dDttm : TDateTime;
  pt : Tpoint;
begin
  Application.CreateForm(TfrmTimeDialog,frmTimeDialog);
  dttm := '';
  pt.X := (sender as TBitbtn).Left + (sender as TBitbtn).Width;
  pt.Y := ((sender as TBitbtn).top + (sender as TBitbtn).height) - frmTimeDialog.Height;
  pt := (Sender as TBitBtn).ClientToScreen(pt) ;  //<<<<<  Sending a point on the screen, I open my  DateTIme Picker close to where the mouse currently is.
  if frmTimeDialog.execute(pt,dttm,dDtTm) then begin
//    if  compareDateTime(now,ddttm) = -1  then begin
//      Windows.MessageBox(frmTimeDialog.Handle,PChar('A Future Date/Time is not allowed.'),' ',MB_SYSTEMMODAL) ;
//      exit;
//      end;
    fmeSVTime.Text :=  StripTime(dttm);
    fmeFilePrefixChange(fmeSVTime);
    end;
  fmeSVTime.SetFocus;
  frmTimeDialog.Free;
end;
function TfrmSiteParameters.DateToFMInternal(ExDate:string):string;
begin
  result := IntToStr(YearOf(StrToDate(ExDate)) - 1700)+
        RightStr('0'+IntToStr(MonthOf(StrToDate(ExDate))),2)+
        RightStr('0'+IntToStr(DayOf(StrToDate(Exdate))),2);
end;

procedure TfrmSiteParameters.tvBPQueuesMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
   var
      HT: THitTests;
      i: integer;
begin
  //*********** Fixes problem with the RightClickSelect property of TreeView
  (Sender as TTreeView).selected := (Sender as TTreeView).getNodeAt(X,Y);
  if (Sender as TTreeView).selected = nil then begin
   for i := 0 to PoptvBPQueues.Items.Count - 1 do
    PoptvBPQueues.Items[i].Enabled := false;
    exit;
    end;
  HT := (Sender as TTreeView).GetHitTestInfoAt(X, Y);
  if (HT - [htOnItem] <> HT) and (button=mbRight) then
     (Sender as TTreeView).selected := (Sender as TTreeView).getNodeAt(X,Y);
end;


procedure TfrmSiteParameters.fmeVRSiteCodeKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  SystemParametersInfo(SPI_SETBEEP, 1, nil, SPIF_SENDWININICHANGE);
  If Key = VK_Return Then Begin
    If HiWord(GetKeyState(VK_SHIFT)) <> 0 then
      SelectNext(Sender as TWinControl,False,True)
    else
      SelectNext(Sender as TWinControl,True,True) ;
      Key := VK_TAB
    end;
 SystemParametersInfo(SPI_SETBEEP, 0, nil, SPIF_SENDWININICHANGE);
end;

procedure TfrmSiteParameters.mnuNetworkLocatinManager1Click(Sender: TObject);
begin
  pcSiteParameters.ActivePageIndex := 6;
  pcSiteParametersChange(pcSiteParameters);

end;

procedure TfrmSiteParameters.tvBPServerTasksMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
   var
      HT: THitTests;
      i : integer;
begin
  //*********** Fixes problem with the RightClickSelect property of TreeView
 (Sender as TTreeView).selected := (Sender as TTreeView).getNodeAt(X,Y);
  if (Sender as TTreeView).selected = nil then begin
    for i := 0 to popBPWS.Items.Count-1 do
      popBPWS.Items[i].Enabled := false;
    exit;
    end;
  HT := (Sender as TTreeView).GetHitTestInfoAt(X, Y);
  if (HT - [htOnItem] <> HT) and (button=mbRight) then begin
     end; // if (HT - [htOnItem]
  if Button = mbLeft then{ drag only if left button pressed }
    if DragDetect((Sender as TTreeView).Handle, POINT(X, Y)) then begin
      //  Don't Drag Group NODES - ELSE only allow the moving of the Group NODE members
      //  Code that in the DRAGDROP event
      if (sender as TTreeView).Selected.Level <> 0 then
         (sender as TTreeView).BeginDrag(false);
      end; //if DragDetect
end;

procedure TfrmSiteParameters.popTVMailMessagePopup(Sender: TObject);
var
   AnItem: TTreeNode;
   i : integer;
begin
  if (Sender as TPopUpMenu).PopupComponent.ClassName = 'TTreeView' then begin
    if tvMailMessages.Selected = nil then begin
      for i := 0 to popTVMailMessage.Items.Count - 1 do
        popTVMailMessage.Items[i].Enabled := false;
      exit;
      end;
 // Code to enable Popupmenu to edit properties
    if (tvMailMessages.SelectionCount > 0) then begin
      AnItem := tvMailMessages.Selected;
      case AnItem.Level of
        0: begin
             popTVMailMessage.Items[popTVMailMessage.Items.IndexOf(mnupuDeleteMailMessageMembers)].Enabled := false;
             popTVMailMessage.Items[popTVMailMessage.Items.IndexOf(mnupuTreeViewProperties)].Enabled := true;
             end;
        1: begin
             popTVMailMessage.Items[popTVMailMessage.Items.IndexOf(mnupuDeleteMailMessageMembers)].Enabled := true;
             popTVMailMessage.Items[popTVMailMessage.Items.IndexOf(mnupuTreeViewProperties)].Enabled := true;
             end;
         end; // Case
      end // if ((tvMailMessages.SelectionCount > 0
    else for i := 0 to popTVMailMessage.Items.Count - 1 do
            popTVMailMessage.Items[i].Enabled := false;
    end; // if TreeView
end;
procedure TfrmSiteParameters.popTVXWBMailGroupPopup(Sender: TObject);
var
   AnItem: TTreeNode;
   i: integer;
begin
  if (Sender as TPopUpMenu).PopupComponent.ClassName = 'TTreeView' then begin
    if tvMailGroups.Selected = nil then begin
      for i := 0 to popTVXWBMailGroup.Items.Count - 1 do
        popTVXWBMailGroup.Items[i].Enabled := false;
    exit;
    end;
 // Code to enable Popupmenu to edit properties
    if (tvMailGroups.SelectionCount > 0) then begin
      AnItem := tvMailGroups.Selected;
      case AnItem.Level of
        0: begin
          popTVXWBMailGroup.Items[popTVXWBMailGroup.Items.IndexOf(mnuRemoteMailMember)].Enabled := true;
          popTVXWBMailGroup.Items[popTVXWBMailGroup.Items.IndexOf(mnuXWBProperties)].Enabled := true;
          popTVXWBMailGroup.Items[popTVXWBMailGroup.Items.IndexOf(mnuDeleteMember)].Enabled := false;
          end;
       1: begin
          popTVXWBMailGroup.Items[popTVXWBMailGroup.Items.IndexOf(mnuRemoteMailMember)].Enabled := true;
          popTVXWBMailGroup.Items[popTVXWBMailGroup.Items.IndexOf(mnuXWBProperties)].Enabled := true;
          if btnApply.Enabled then popTVXWBMailGroup.Items[popTVXWBMailGroup.Items.IndexOf(mnuDeleteMember)].Enabled := false
          else popTVXWBMailGroup.Items[popTVXWBMailGroup.Items.IndexOf(mnuDeleteMember)].Enabled := true;
          end;
       end; // case
     end // if ((tvMailGroups.SelectionCount > 0) and (not btnApply.Enabled))
  else
      for i := 0 to popTVXWBMailGroup.Items.Count - 1 do
        popTVXWBMailGroup.Items[i].Enabled := false;
end;
end; //popTVXWBMailGroupPopup(


procedure TfrmSiteParameters.mnuApplyClick(Sender: TObject);
begin
  btnApplyClick(nil);
end;

procedure TfrmSiteParameters.mnuApplyExitClick(Sender: TObject);
begin
  bbtnOKClick(nil);
end;

procedure TfrmSiteParameters.F1KeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
  var
     Description: TStringlist;
     i: integer;
 begin
    if key = VK_F1 then begin
       Application.CreateForm(TfrmHelp,frmHelp);
       Application.NormalizeTopMosts;
       SetWindowPos(frmHelp.Handle, HWND_TOPMOST, 0,0,0,0,
         SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
       if sender.ClassName = 'TFMEdit' then begin
         with frmHelp do begin
           Caption := format('%s - %s',[frmHelp.Caption,GetLabel((Sender as TFMEdit).FMFile,(Sender as TFMEdit).FMField)]) ;
           lbHelp.items := GetDDAttribute((Sender as TFMEdit).FMFile,(Sender as TFMEdit).FMField,'HELP-PROMPT');
           Description := TStringList.Create;
           Description := GetDDAttribute((Sender as TFMEdit).FMFile,(Sender as TFMEdit).FMField,'DESCRIPTION');
           if description.Count > 0 then lbHelp.items.Add(' ');
           for i := 0 to Description.Count - 1 do
             lbHelp.Items.Add(Description[i]);
           Description.Clear;
           Description := GetDDAttribute((Sender as TFMEdit).FMFile,(Sender as TFMEdit).FMField,'TECHNICAL DESCRIPTION');
           if Description.count > 0 then lbHelp.items.Add(' ');
           for i := 0 to Description.Count - 1 do
             lbHelp.Items.Add(Description[i]);
           Description.Free;
           Application.ProcessMessages;
           Height := Height + (lbHelp.Items.count*lbHelp.Font.Size);
           ShowModal;
           Free;
           end; // with frmHelp
         end; // if sender.ClassName = 'TFMEdit'
       if sender.ClassName = 'TFMComboBox' then begin
         with frmHelp do begin
           Caption := format('%s - %s',[frmHelp.Caption,GetLabel((Sender as TFMComboBox).FMFile,(Sender as TFMComboBox).FMField)]) ;
           lbHelp.items := GetDDAttribute((Sender as TFMComboBox).FMFile,(Sender as TFMComboBox).FMField,'DESCRIPTION');
           Description := TStringList.Create;
           Description := GetDDAttribute((Sender as TFMComboBox).FMFile,(Sender as TFMComboBox).FMField,'TECHNICAL DESCRIPTION');
           if Description.count > 0 then lbHelp.items.Add(' ');
           for i := 0 to Description.Count - 1 do
             lbHelp.Items.Add(Description[i]);
           Description.Free;
           Application.ProcessMessages;
           Height := Height + (lbHelp.Items.count*lbHelp.Font.Size);
           ShowModal;
           Free;
           end; // with frmHelp
         end; // if sender.ClassName = 'TFMComboBox'
       if sender.ClassName = 'TFMComboBoxLookUp' then begin
         with frmHelp do begin
           Caption := format('%s - %s',[frmHelp.Caption,GetLabel((Sender as TFMComboBoxLookUp).FMFile,(Sender as TFMComboBoxLookUp).FMField)]) ;
           lbHelp.items := GetDDAttribute((Sender as TFMComboBoxLookUp).FMFile,(Sender as TFMComboBoxLookUp).FMField,'DESCRIPTION');
           Description := TStringList.Create;
           Description := GetDDAttribute((Sender as TFMComboBoxLookUp).FMFile,(Sender as TFMComboBoxLookUp).FMField,'TECHNICAL DESCRIPTION');
           if Description.count > 0 then lbHelp.items.Add(' ');
           for i := 0 to Description.Count - 1 do
             lbHelp.Items.Add(Description[i]);
           Description.Free;
           Application.ProcessMessages;
           Height := Height + (lbHelp.Items.count*lbHelp.Font.Size);
           ShowModal;
           Free;
           end; // with frmHelp
         end; // if sender.ClassName = 'TFMComboBoxLookUp'
       if sender.ClassName = 'TFMListBox' then begin
         with frmHelp do begin
           Caption := format('%s - %s',[frmHelp.Caption,GetLabel((Sender as TFMListBox).FMFile,(Sender as TFMListBox).FMField)]) ;
           lbHelp.items := GetDDAttribute((Sender as TFMListBox).FMFile,(Sender as TFMListBox).FMField,'DESCRIPTION');
           Description := TStringList.Create;
           Description := GetDDAttribute((Sender as TFMListBox).FMFile,(Sender as TFMListBox).FMField,'TECHNICAL DESCRIPTION');
           if Description.count > 0 then lbHelp.items.Add(' ');
           for i := 0 to Description.Count - 1 do
             lbHelp.Items.Add(Description[i]);
           description.Clear;
           Application.ProcessMessages;
           Height := Height + (lbHelp.Items.count*lbHelp.Font.Size);
           ShowModal;
           Free;
           end; // with frmHelp
         end; // if sender.ClassName = 'TFMListBox'
       if sender.ClassName = 'TFMCheckBox' then begin
         with frmHelp do begin
           Caption := format('%s - %s',[frmHelp.Caption,GetLabel((Sender as TFMCheckBox).FMFile,(Sender as TFMCheckBox).FMField)]) ;
           lbHelp.items := GetDDAttribute((Sender as TFMCheckBox).FMFile,(Sender as TFMCheckBox).FMField,'DESCRIPTION');
           Description := TStringList.Create;
           Description := GetDDAttribute((Sender as TFMCheckBox).FMFile,(Sender as TFMCheckBox).FMField,'TECHNICAL DESCRIPTION');
           if Description.count > 0 then lbHelp.items.Add(' ');
           for i := 0 to Description.Count - 1 do
             lbHelp.Items.Add(Description[i]);
           Description.Free;
           Application.ProcessMessages;
           Height := Height + (lbHelp.Items.count*lbHelp.Font.Size);
           ShowModal;
           Free;
           end; // with frmHelp
         end; // if sender.ClassName = 'TFMCheckBox'
       if sender.ClassName = 'TFMLabel' then begin
         with frmHelp do begin
           Caption := format('%s - %s',[frmHelp.Caption,GetLabel((Sender as TFMLabel).FMFile,(Sender as TFMLabel).FMField)]) ;
           lbHelp.items := GetDDAttribute((Sender as TFMLabel).FMFile,(Sender as TFMLabel).FMField,'DESCRIPTION');
           Application.ProcessMessages;
           Height := Height + (lbHelp.Items.count*lbHelp.Font.Size);
           ShowModal;
           Free;
           end; // with frmHelp
         end; // if sender.ClassName = 'TFMLabel'
       if sender.ClassName = 'TFMRadioGroup' then begin
         with frmHelp do begin
           Caption := format('%s - %s',[frmHelp.Caption,GetLabel((Sender as TFMRadioGroup).FMFile,(Sender as TFMRadioGroup).FMField)]) ;
           lbHelp.items := GetDDAttribute((Sender as TFMRadioGroup).FMFile,(Sender as TFMRadioGroup).FMField,'DESCRIPTION');
           Application.ProcessMessages;
           Height := Height + (lbHelp.Items.count*lbHelp.Font.Size);
           ShowModal;
           Free;
           end; // with frmHelp
         end; // if sender.ClassName = 'TFMRadioGroup'
       if sender.ClassName = 'TFMMemo' then begin
         with frmHelp do begin
           Caption := format('%s - %s',[frmHelp.Caption,GetLabel((Sender as TFMMemo).FMFile,(Sender as TFMMemo).FMField)]) ;
           lbHelp.items := GetDDAttribute((Sender as TFMMemo).FMFile,(Sender as TFMMemo).FMField,'HELP-PROMPT');
           Description := TStringList.Create;
           Description := GetDDAttribute((Sender as TFMMemo).FMFile,(Sender as TFMMemo).FMField,'DESCRIPTION');
           if description.Count > 0 then lbHelp.items.Add(' ');
           for i := 0 to Description.Count - 1 do
             lbHelp.Items.Add(Description[i]);
           Description.Clear;
           Description := GetDDAttribute((Sender as TFMMemo).FMFile,(Sender as TFMMemo).FMField,'TECHNICAL DESCRIPTION');
           if Description.count > 0 then lbHelp.items.Add(' ');
           for i := 0 to Description.Count - 1 do
             lbHelp.Items.Add(Description[i]);
           Description.Free;
           Application.ProcessMessages;
           Height := Height + (lbHelp.Items.count*lbHelp.Font.Size);
           ShowModal;
           Free;
           end; // with frmHelp
         end; // if sender.ClassName = 'TFMMemo'

      end; // if key = VK_F1
  end;  // procedure F1KeyDown

procedure TfrmSiteParameters.fmcbNetSiteServiceChange(Sender: TObject);
begin
 with sender as TFMComboBox do begin //need to test FMModified
   if FMModified then begin
       if ((sender as TFMComboBox).GetSelectedRecord <> nil) then begin
        FMFiler.AddFDA(FMFile,IntToStr(magbtm1.place)+',','55',(sender as TFMComboBox).GetSelectedRecord.IEN);
        end
      else begin
        (sender as TFMComboBox).Text := (sender as TFMComboBox).FMCtrlExternal;
         end;
      btnApply.Enabled := true;
      end;
   end; // with sender

end;


procedure TfrmSiteParameters.popImportQueuePropertiesClick(
  Sender: TObject);
var
  AnItem: TTreeNode;
  temp,QIEN,IQ : string;
   key: word;
   Shift: TShiftState;
  begin
    if Sender.ClassName = 'TMenuItem' then
      with ((Sender as TMenuItem).GetParentComponent) as TPopUpMenu do
        if PopUpComponent.ClassName = 'TTreeView' then
          with PopUpComponent as TTreeView do
            if SelectionCount > 0 then begin
              AnItem := Selected;
              if ((AnItem.Level = 2) and (AnItem.Parent.Parent.Text = 'IMPORT')) or
                 ((AnItem.Level = 3) and (AnItem.Parent.Parent.Parent.Text = 'IMPORT')) then begin
                temp := StringReplace(AnItem.Text,'  ',' ',[rfReplaceAll]);
                temp := StringReplace(temp,' ','^',[rfReplaceAll]);
                try
                 if StrToInt(trim(piece(temp,'^',1))) < 1 then exit;
                 QIEN := trim(piece(temp,'^',1));
                except
                  exit;
                end; // try..except
                IQ := DMmAIN.GetFieldValue('2006.03','10',QIEN+',','I',true);
                Application.CreateForm(TfrmMagImportQueue, frmMagImportQueue);
                frmMagImportQueue.edImportQueueLookup.Text := IQ;
                key := VK_RETURN;
                frmMagImportQueue.edTrackingIDKeyDown(frmMagImportQueue.edImportQueueLookup,key,shift);
                frmMagImportQueue.ShowModal;
                frmMagImportQueue.Free;
                end;  // if level 2 or 3 IMPORT
              end; //  SelectionCount > 0
  end; //popImportQueuePropertiesClick

  procedure TfrmSiteParameters.lvHelp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
    procedure Update(FNumber,FldNum: string);
      var Description: TStringList;
                    i: integer;
      begin
        Application.CreateForm(TfrmHelp,frmHelp);
        with frmHelp do begin
         Caption := format('%s - %s',[frmHelp.Caption,GetLabel(FNumber,FldNum)]) ;
         lbHelp.items := GetDDAttribute(FNumber,FldNum,'HELP-PROMPT');
         Description := TStringList.Create;
         Description := GetDDAttribute(FNumber,FldNum,'DESCRIPTION');
         if description.Count > 0 then lbHelp.items.Add(' ');
         for i := 0 to Description.Count - 1 do
           lbHelp.Items.Add(Description[i]);
         Description.Clear;
         Description := GetDDAttribute(FNumber,FldNum,'TECHNICAL DESCRIPTION');
         if description.Count > 0 then lbHelp.items.Add(' ');
         for i := 0 to Description.Count - 1 do
             lbHelp.Items.Add(Description[i]);
         Description.Free;
         Application.ProcessMessages;
         Height := Height + (lbHelp.Items.count*lbHelp.Font.Size);
         ShowModal;
         Free;
         end; // with frmHelp
      end; // Update
   begin // lvHelp
     if pos((Sender as TListView).Name,'lvXWBMailMembers') <> 0 then Update('3.81','.01');
     if pos((Sender as TListView).Name,'lvXWBMailGroups') <> 0 then Update('3.811','.01');
     if pos((Sender as TListView).Name,'lvRemoteMailMembers') <> 0 then Update('3.812','.01');
   end;

procedure TfrmSiteParameters.eMNSKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  SystemParametersInfo(SPI_SETBEEP, 1, nil, SPIF_SENDWININICHANGE);
  If Key = VK_Return Then Begin
    If HiWord(GetKeyState(VK_SHIFT)) <> 0 then
      SelectNext(Sender as TWinControl,False,True)
    else
      SelectNext(Sender as TWinControl,True,True) ;
      Key := VK_TAB
    end;
//  if key = VK_Return then sbSaveMNSClick(Sender);
  SystemParametersInfo(SPI_SETBEEP, 0, nil, SPIF_SENDWININICHANGE);
end;

procedure TfrmSiteParameters.eMNSKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if key = VK_F1 then DisplayFieldHelp('2006.11','.01');
end;

procedure TfrmSiteParameters.eFileExtKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
if key = VK_F1 then DisplayFieldHelp('2006.112','.01');
end;

procedure TfrmSiteParameters.eFileExtKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  SystemParametersInfo(SPI_SETBEEP, 1, nil, SPIF_SENDWININICHANGE);
  If Key = VK_Return Then Begin
    If HiWord(GetKeyState(VK_SHIFT)) <> 0 then
      SelectNext(Sender as TWinControl,False,True)
    else
      SelectNext(Sender as TWinControl,True,True) ;
      Key := VK_TAB
    end;
//  if key = VK_Return then sbSaveClick(Sender);
  SystemParametersInfo(SPI_SETBEEP, 0, nil, SPIF_SENDWININICHANGE);
end;

procedure TfrmSiteParameters.fmeVistaVerifyKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  SystemParametersInfo(SPI_SETBEEP, 1, nil, SPIF_SENDWININICHANGE);
   If Key = VK_Return Then Begin
    If HiWord(GetKeyState(VK_SHIFT)) <> 0 then
      SelectNext(Sender as TWinControl,False,True)
    else
      SelectNext(Sender as TWinControl,True,True) ;
      Key := VK_TAB
    end;
  //  if key = VK_Return then fmeHiddenChange(Sender);
  SystemParametersInfo(SPI_SETBEEP, 0, nil, SPIF_SENDWININICHANGE);
end;

procedure TfrmSiteParameters.gbMailUsersClick(Sender: TObject);
var tmp: string;
begin
  if lvMailUsers.Visible then exit;
  tmp := 'I $D(^XMB(3.7,+Y,0)),$$ACTIVE^XUSER(Y)';
  dmMain.fmlUsers.Screen := tmp;
  dmMain.fmlUsers.Number := '250';
  ListViewUpdate(true,FALSE,dmMain.fmlUsers,lvMailUsers,'.01');
  lvMailUsers.Visible := true;
end;

procedure TfrmSiteParameters.gbUsersClick(Sender: TObject);
//var tmp: string;
begin
//  if lvUsers.Visible then exit;
//  tmp := 'I $D(^XMB(3.7,+Y,0)),$$ACTIVE^XUSER(Y)'; //$L($P(^VA(200,Y,0),U,3)),
//  dmMain.fmlUsers.Screen := tmp;
//  dmMain.fmlUsers.Number := '250';
//  ListViewUpdate(true,FALSE,dmMain.fmlUsers,lvUsers,'.01');
//  lvUsers.Visible := true;
end;

procedure TfrmSiteParameters.lvMailGroupsEnter(Sender: TObject);
begin
  if lvMailGroups.SelCount = 0 then
  lvMailGroups.Items[0].Selected := true;
end;

procedure TfrmSiteParameters.lvSecurityKeysEnter(Sender: TObject);
begin
  if lvSecurityKeys.SelCount = 0 then
    lvSecurityKeys.Items[0].Selected := true;

end;

procedure TfrmSiteParameters.bbtnLVMailUsersClick(Sender: TObject);
var tmp: string;
  i,cnt : integer;
  Start: TDateTime;
begin
   Start := Now;
   if lvMailUsers.Visible then exit;
(*LVGUpdate(Clear, IEN: boolean;fmg:TFMGets;lv:TListView)*)
  lvMailUsers.Items.BeginUpdate;
//  tmp := 'I $$ACTIVE^XUSER(Y)';
  tmp := 'I $D(^VA(200,"AUSER",$P(^VA(200,Y,0),U),Y))';
  dmMain.fmlMailBasket.Screen := tmp;
  dmMain.fmlMailBasket.Number := '250';
  lvMailUsers.Visible := true;
  dmMain.fmgVaUser.FieldNumbers.Clear;
  dmMain.fmgVaUser.FieldNumbers.Add('.01');
//  dmMain.fmgVaUser.FieldNumbers.Add('8');
//  dmMain.fmgVaUser.FieldNumbers.Add('29');
  with dmMain.fmlMailBasket do begin
    dmMain.fmlMailBasket.GetList(nil);
    cnt := dmMain.fmlMailBasket.Results.Count;
    lvMailUsers.ViewStyle := vsReport;
    lvMailUsers.GridLines := true;
    // Initial process
    dmMain.fmgVaUser.IENS := dmMain.fmlMailBasket.Results[0];
    LVGUpdate(true,false,dmMain.fmgVaUser,lvMailUsers);
    for i := 1 to dmMain.fmlMailBasket.Results.Count - 1 do begin  // Create ListItems
      dmMain.fmgVaUser.IENS := dmMain.fmlMailBasket.Results[i];
      LVGUpdate(false,false,dmMain.fmgVaUser,lvMailUsers);
      end; //for i
    repeat  //additional process if MORE
      if more then begin
        FromIEN := dmMain.fmlMailBasket.Results[dmMain.fmlMailBasket.Results.count - 1];
        dmMain.fmlMailBasket.Results.Clear;
        dmMain.fmlMailBasket.GetMore(nil);
        cnt := cnt + dmMain.fmlMailBasket.Results.Count;
        for i := 0 to dmMain.fmlMailBasket.Results.Count - 1 do begin  // Create ListItems
          dmMain.fmgVaUser.IENS := dmMain.fmlMailBasket.Results[i];
          LVGUpdate(false,false,dmMain.fmgVaUser,lvMailUsers);
          end; //for i
        end; // if more
    until not dmMain.fmlMailBasket.More ;
    end; // with Lister
    for i := 0 to lvMailUsers.Columns.Count - 1 do begin
      lvMailUsers.Columns[i].AutoSize := true;   // AutoSize Columns
      lvMailUsers.Columns[i].width := columnheaderwidth;  // Set ColumnWidth
      end;
    lvMailUsers.Items.EndUpdate;
    if lvMailUsers.SelCount = 0 then lvMailUsers.Items[0].Selected := true;
    lvMailUsers.Update;
    bbtnLVMailusers.Visible := false;
    lvMailUsers.ReadOnly := true;
//    gbMailUsers.Caption := gbMailUsers.Caption + IntToStr(cnt);
//    gbMailUsers.Caption := gbMailUsers.Caption + ' - ' +IntToStr(SecondsBetween(Start,now));
  (*  if lvMailUsers.Visible then exit;
  tmp := 'I $D(^XMB(3.7,+Y,0)),$$ACTIVE^XUSER(Y)';
  dmMain.fmlUsers.Screen := tmp;
  dmMain.fmlUsers.Number := '250';
  lvMailUsers.Visible := true;
  ListViewUpdate(true,FALSE,dmMain.fmlUsers,lvMailUsers,'.01');
  lvMailUsers.SetFocus;
  if lvMailUsers.SelCount = 0 then lvMailUsers.Items[0].Selected := true;
  lvMailUsers.Update;
  bbtnLVMailusers.Visible := false;
  *)
end;

procedure TfrmSiteParameters.bbtnMGUsersClick(Sender: TObject);
var tmp: string;
  i,cnt : integer;
  Start: TDateTime;
begin
   Start := Now;
   if lvUsers.Visible then exit;
(*LVGUpdate(Clear, IEN: boolean;fmg:TFMGets;lv:TListView)*)
  lvUsers.Items.BeginUpdate;
//  tmp := 'I $$ACTIVE^XUSER(Y)';
  tmp := 'I $D(^VA(200,"AUSER",$P(^VA(200,Y,0),U),Y))';
  dmMain.fmlMailBasket.Screen := tmp;
  dmMain.fmlMailBasket.Number := '250';
  lvUsers.Visible := true;
  dmMain.fmgVaUser.FieldNumbers.Clear;
  dmMain.fmgVaUser.FieldNumbers.Add('.01');
//  dmMain.fmgVaUser.FieldNumbers.Add('8');
//  dmMain.fmgVaUser.FieldNumbers.Add('29');
  with dmMain.fmlMailBasket do begin
    dmMain.fmlMailBasket.GetList(nil);
    cnt := dmMain.fmlMailBasket.Results.Count;
    lvUsers.ViewStyle := vsReport;
    lvUsers.GridLines := true;
    // Initial process
    dmMain.fmgVaUser.IENS := dmMain.fmlMailBasket.Results[0];
    LVGUpdate(true,false,dmMain.fmgVaUser,lvUsers);
    for i := 1 to dmMain.fmlMailBasket.Results.Count - 1 do begin  // Create ListItems
      dmMain.fmgVaUser.IENS := dmMain.fmlMailBasket.Results[i];
      LVGUpdate(false,false,dmMain.fmgVaUser,lvUsers);
      end; //for i
    repeat  //additional process if MORE
      if more then begin
        FromIEN := dmMain.fmlMailBasket.Results[dmMain.fmlMailBasket.Results.count - 1];
        dmMain.fmlMailBasket.Results.Clear;
        dmMain.fmlMailBasket.GetMore(nil);
        cnt := cnt + dmMain.fmlMailBasket.Results.Count;
        for i := 0 to dmMain.fmlMailBasket.Results.Count - 1 do begin  // Create ListItems
          dmMain.fmgVaUser.IENS := dmMain.fmlMailBasket.Results[i];
          LVGUpdate(false,false,dmMain.fmgVaUser,lvUsers);
          end; //for i
        end; // if more
    until not dmMain.fmlMailBasket.More ;
    end; // with Lister
    for i := 0 to lvUsers.Columns.Count - 1 do begin
      lvUsers.Columns[i].AutoSize := true;   // AutoSize Columns
      lvUsers.Columns[i].width := columnheaderwidth;  // Set ColumnWidth
      end;
    lvMailUsers.Items.EndUpdate;
    if lvUsers.SelCount = 0 then lvUsers.Items[0].Selected := true;
    lvUsers.Update;
    bbtnMGUsers.Visible := false;
    lvUsers.ReadOnly := true;
//    gbUsers.Caption := gbMailUsers.Caption + IntToStr(cnt);
//    gbUsers.Caption := gbMailUsers.Caption + ' - ' +IntToStr(SecondsBetween(Start,now));
(*var tmp:string;
  Start: TDateTime;
begin
Start := Now;
  if lvUsers.Visible then exit;
  gbcnt := 0;
 // tmp := 'I $D(^XMB(3.7,+Y,0))';//,$$ACTIVE^XUSER(Y)';
//  dmMain.fmlUsers.Screen := tmp;
  dmMain.fmlUsers.Number := '250';
//  dmMain.fmlUsers.FMIndex := '"B"';

  dmMain.fmlUsers.FMIndex := '"AUSER"';
  lvUsers.Visible := true;
  lvUsers.Clear;
  ListViewUpdate(true,FALSE,dmMain.fmlUsers,lvUsers,'.01');
  lvUsers.SetFocus;
  if lvUsers.SelCount = 0 then lvUsers.Items[0].Selected := true;
  lvUsers.Update;

  gbUsers.Caption := gbUsers.Caption + IntToStr(gbcnt);
  gbUsers.Caption := gbUsers.Caption + ' - ' +IntToStr(SecondsBetween(Start,now));

  bbtnMGUsers.Visible := false;
  *)
end;

procedure TfrmSiteParameters.lvMailGroups2Enter(Sender: TObject);
begin
  if lvMailGroups2.SelCount = 0 then
  lvMailGroups2.Items[0].Selected := true;
end;

procedure TfrmSiteParameters.lvUsersEnter(Sender: TObject);
begin
  if lvUsers.SelCount = 0 then
  lvUsers.Items[0].Selected := true;
end;

procedure TfrmSiteParameters.lvMailUsersEnter(Sender: TObject);
begin
  if lvMailUsers.SelCount = 0 then
    lvMailUsers.Items[0].Selected := true;

end;

procedure TfrmSiteParameters.fmcblkDefUserPrefChange(Sender: TObject);
begin
 with sender as TFMComboBoxLookUp do begin //need to test FMModified
   if FMModified then begin
       if ((sender as TFMComboBoxLookUp).GetSelectedRecord <> nil) then begin
        FMFiler.AddFDA(FMFile,IntToStr(magbtm1.place)+',',FMField,(sender as TFMComboBoxLookup).GetSelectedRecord.IEN);
        btnApply.Enabled := true;
        PageControlChange(pcSiteParameters,true);
        end
      else begin
        (sender as TFMComboBoxLookUp).Text := (sender as TFMComboBoxLookUp).FMCtrlExternal;
         end;
      end;
   end; // with sender
end;

procedure TfrmSiteParameters.fmcblkDefUserPrefEnter(Sender: TObject);
begin
  fmcblkDefUserPref.Text :='?';
end;

procedure TfrmSiteParameters.fmeNextVerifierDateKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  SystemParametersInfo(SPI_SETBEEP, 1, nil, SPIF_SENDWININICHANGE);
  If Key = VK_Return Then Begin
    If HiWord(GetKeyState(VK_SHIFT)) <> 0 then
      SelectNext(Sender as TWinControl,False,True)
    else
      SelectNext(Sender as TWinControl,True,True) ;
      Key := VK_TAB
    end;
  //  if key = VK_Return then fmeDateChangeFuture(Sender);
  SystemParametersInfo(SPI_SETBEEP, 0, nil, SPIF_SENDWININICHANGE);
end;

(*if GetasyncKeyState(VK_Return) <>0  then
  Windows.MessageBox(frmSiteParameters.Handle,PChar('Return Key is Down!'),' ',MB_SYSTEMMODAL)
else
 Windows.MessageBox(frmSiteParameters.Handle,PChar('Return Key is UP!'),' ',MB_SYSTEMMODAL) ;


*)
procedure TfrmSiteParameters.fmcbAutoPurgeKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  SystemParametersInfo(SPI_SETBEEP, 1, nil, SPIF_SENDWININICHANGE);
  If Key = VK_Return Then Begin
    If HiWord(GetKeyState(VK_SHIFT)) <> 0 then
      SelectNext(Sender as TWinControl,False,True)
    else
      SelectNext(Sender as TWinControl,True,True) ;
      Key := VK_TAB
    end;
  SystemParametersInfo(SPI_SETBEEP, 0, nil, SPIF_SENDWININICHANGE);

end;

procedure TfrmSiteParameters.fmcbNetworkLocKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  SystemParametersInfo(SPI_SETBEEP, 1, nil, SPIF_SENDWININICHANGE);
  If Key = VK_Return Then Begin
    If HiWord(GetKeyState(VK_SHIFT)) <> 0 then
      SelectNext(Sender as TWinControl,False,True)
    else
      SelectNext(Sender as TWinControl,True,True) ;
      Key := VK_TAB
    end;
  SystemParametersInfo(SPI_SETBEEP, 0, nil, SPIF_SENDWININICHANGE);
end;

procedure TfrmSiteParameters.fmlbFileTypesKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  SystemParametersInfo(SPI_SETBEEP, 1, nil, SPIF_SENDWININICHANGE);
  If Key = VK_Return Then Begin
    If HiWord(GetKeyState(VK_SHIFT)) <> 0 then
      SelectNext(Sender as TWinControl,False,True)
    else
      SelectNext(Sender as TWinControl,True,True) ;
      Key := VK_TAB
    end;
  SystemParametersInfo(SPI_SETBEEP, 0, nil, SPIF_SENDWININICHANGE);

end;

end.
