program Magbtm;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: Main BP Queue Processor
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

uses
  Forms,
  magbtm1 in 'magbtm1.pas' {MAGBTMF1},
  MagPurge2 in 'MagPurge2.pas' {frmMagPurge2},
  MAGJHRPT in 'MAGJHRPT.pas' {frmMagJHRPT1},
  MagViewLog in 'MagViewLog.pas' {frmMagViewLog},
  MagNewBP in 'MagNewBP.pas' {frmMagNewBP},
  MagNetLoc in 'MagNetLoc.pas' {frmMagNet},
  MagSiteParameters in 'MagSiteParameters.pas' {frmSiteParameters},
  telabout in 'telabout.pas' {TELABOUTF},
  UnitDM in 'UnitDM.pas' {dmMain: TDataModule},
  MagShowLog in 'MagShowLog.pas' {ShowLog},
  magWebHelp in 'magWebHelp.pas' {frmMagBPHelp},
  MagQueuePurgeByType in 'MagQueuePurgeByType.pas' {frmQPurgeByType},
  magAssocInstVistaRadGroups1 in 'magAssocInstVistaRadGroups1.pas' {MagAssocInstVistaRadGroup},
  fmagLookUpDialog in 'fmagLookupDialog.pas' {frmLookupDialog},
  MAGNetLoc2 in 'MAGNetLoc2.pas' {frmNetworkLoc},
  Hash in '..\..\..\..\Program Files\Vista\BDK32\Source\Hash.pas',
  MagMessage in 'MagMessage.pas' {frmErrorMessageEdit},
  MailGroupProperties in 'MailGroupProperties.pas' {frmMailGroupProperties},
  MagMessageProp in 'MagMessageProp.pas' {frmMagMessageProp},
  magRemoteMailMember in 'magRemoteMailMember.pas' {frmRemoteMailMember},
  frmGenericCalendar1 in 'frmGenericCalendar1.pas' {frmGenericCalendar},
  FmagTimeDialog in 'FmagTimeDialog.pas' {frmTimeDialog},
  frmBPProperties in 'frmBPProperties.pas' {frmBPProperties},
  MagGraphShare in 'MagGraphShare.pas' {frmMagGraph},
  BPHelp1 in 'BPHelp1.pas' {frmHelp},
  MagImportQueue1 in 'MagImportQueue1.pas' {frmMagImportQueue},
  ConfirmNetDel in 'ConfirmNetDel.pas' {frmConfirmNetDelete};

{ShareMem,delphimm}

{$R *.RES}

begin
  Application.Title := 'Vista Imaging Background Processor';
  Application.CreateForm(TdmMain, dmMain);
  Application.CreateForm(TMAGBTMF1, MAGBTMF1);
  Application.CreateForm(TfrmLookupDialog, frmLookupDialog);
  Application.CreateForm(TfrmErrorMessageEdit, frmErrorMessageEdit);
  Application.CreateForm(TfrmRemoteMailMember, frmRemoteMailMember);
  Application.CreateForm(TfrmTimeDialog, frmTimeDialog);
  Application.CreateForm(TfrmGenericCalendar, frmGenericCalendar);
  Application.CreateForm(TfrmConfirmNetDelete, frmConfirmNetDelete);
  Application.Run;
end.
