unit MailGroupProperties;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: Main BP Queue Processor
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Diaccess, Fmcmpnts, Fmcntrls, ExtCtrls,
  ComCtrls;

type
  TfrmMailGroupProperties = class(TForm)
    bbtnOKEM: TBitBtn;
    bbtnCancelEM: TBitBtn;
    btnApplyEM: TBitBtn;
    bbtnHelpEM: TBitBtn;
    fmlOrganizer: TFMLabel;
    lvRemoteMailMembers: TListView;
    fmmMailDescription: TFMMemo;
    lvXWBMailMembers: TListView;
    lvXWBMailGroups: TListView;
    FMValidator1: TFMValidator;
    FMHelp1: TFMHelp;
    fmgMailGroups: TFMGets;
    FMGets2: TFMGets;
    FMFiler1: TFMFiler;
    FMGets: TFMGets;
    stDescription: TStaticText;
    stOrganizer: TStaticText;
    fmlType: TFMLabel;
    stType: TStaticText;
    stRestrictions: TStaticText;
    fmlRestrictions: TFMLabel;
    procedure btnApplyEMClick(Sender: TObject);
    procedure bbtnOKEMClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure fmmMailDescriptionChange(Sender: TObject);
    procedure F1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure bbtnHelpEMClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMailGroupProperties: TfrmMailGroupProperties;

implementation

uses  MAGBTM1,MagSiteParameters, UnitDM , magWebHelp;
{$R *.dfm}

procedure TfrmMailGroupProperties.btnApplyEMClick(Sender: TObject);
begin
  with fmfiler1 do begin
    if AnythingToFile then begin
      Update;
      if ErrorList.Count > 0 then DisplayErrors;
      end;
    end;
  btnApplyEM.Enabled := false;
end;

procedure TfrmMailGroupProperties.bbtnOKEMClick(Sender: TObject);
begin
  with fmfiler1 do begin
    if AnythingToFile then begin
      Update;
      if ErrorList.Count > 0 then DisplayErrors;
      end;
    end;
  ModalResult := mrOK ;
end;

procedure TfrmMailGroupProperties.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  ModalResult := mrOK ;
end;

procedure TfrmMailGroupProperties.fmmMailDescriptionChange(
  Sender: TObject);
begin
 with sender as TFMMemo do begin
   if FMModified then begin
       FMFiler.AddChgdControl(Sender);
       btnApplyEM.Enabled := true;
       end //if modified
     else begin
       frmSiteParameters.SiteParametersDisplayHelp(Sender);
       // no current restor method     Checked := FMTag;
       end; // else
   end; // with sender
end;

procedure TfrmMailGroupProperties.F1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if key = VK_F1 then
    if Sender.ClassName = 'TListView' then frmSiteParameters.lvHelp(Sender,Key,Shift)
    else frmSiteParameters.F1KeyDown(Sender,Key,Shift);
end;

procedure TfrmMailGroupProperties.bbtnHelpEMClick(Sender: TObject);
begin
  Application.CreateForm(TfrmMagBPHelp,frmMagBPHelp);
  frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
 'help\MAG_BP_User_Manual.htm#_Toc269903190');
end;

procedure TfrmMailGroupProperties.FormCreate(Sender: TObject);
begin
  btnApplyEM.Enabled := false;
end;

end.
