unit UnitDM;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: BP Database interface module
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Diaccess, {cMagSecurity, cMagDBBroker, cMagDBMVista, cMagImport,}
  Fmcmpnts, Trpcb,
  Fmlookup,DiTypLib,RpcConf1,MFunStr,hash,Fmcntrls,Eftfut,DateUtils,StrUtils
   {/p121 gek imaging OCX }
 , variants
 , MagImportXControl1_TLB
  ;
const
  U = '^';
type
  TdmMain = class(TDataModule)
    fmgImageUsers: TFMGets;
    fmgNetLoc: TFMGets;
    fmlNetLoc: TFMLister;
    FMValidatorNetLoc: TFMValidator;
    fmgBPWS: TFMGets;
    fmlBPWS: TFMLister;
    fmgSiteParam: TFMGets;
    fmgQueuePointer: TFMGets;
    fmlQueueRecord: TFMLister;
    fmlQueuePointer: TFMLister;
    fmlUserPreferences: TFMLister;
    fmlFileTypes: TFMLister;
    fmlKernelMailMemberGroups: TFMLister;
    fmlJukebox: TFMLister;
    fmgRemoteMembers: TFMGets;
    fmgVaUser: TFMGets;
    fmlKernelRemoteMember: TFMLister;
    fmfQueueRecord: TFMFinder;
    fmlMultiNamespace: TFMLister;
    fmlAssociatedInstitutions: TFMLister;
    fmlVistaRadGroup: TFMLister;
    fmlAssocVistaRadGroup: TFMLister;
    RPCBroker1: TRPCBroker;
    fmlMailMessages: TFMLister;
    fmgMailMessages: TFMGets;
    fmlMailMessageMembers: TFMLister;
    fmgMailMessageMembers: TFMGets;
    fmlKernelMailGroups: TFMLister;
    fmgMailGroups: TFMGets;
    fmlKernelMailGroupMembers: TFMLister;
    fmgXWBGroupMembers: TFMGets;
    fmlXWBGroupMembers: TFMLister;
    fmlXWBMemberGroups: TFMLister;
    fmgXWBMemberGroups: TFMGets;
    fmlXWBRemoteMembers: TFMLister;
    fmgXWBRemoteMembers: TFMGets;
    fmlGCC: TFMLister;
    fmf2006_1: TFMFiler;
    fmf3_8: TFMFiler;
    fmf3_81: TFMFiler;
    fmf2006_166: TFMFiler;
    fmf2006_1662: TFMFiler;
    fmf3_811: TFMFiler;
    fmf3_812: TFMFiler;
    fmlPACSWriteLocation: TFMLister;
    fmgNLGROUP: TFMGets;
    fmlNLDGM: TFMLister;
    fmgNLJUKEBOX: TFMGets;
    fmgNLROUTER: TFMGets;
    fmgNLURL: TFMGets;
    fmgNLEKG: TFMGets;
    fmgNLRAID: TFMGets;
    fmgNLGCC: TFMGets;
    fmgNLDIAGRAM: TFMGets;
    fmlNLRAID: TFMLister;
    fmlNLJukebox: TFMLister;
    fmlNLURL: TFMLister;
    fmlNLRouters: TFMLister;
    fmlNLEKG: TFMLister;
    fmlNLGCC: TFMLister;
    fmlRGMembers: TFMLister;
    fmlRAIDGroups: TFMLister;
    fmlUsers: TFMLister;
    fmlImagingMailMessageUsers: TFMLister;
    fmf2006_8: TFMFiler;
    fmlSecurityKeys: TFMLister;
    fmlMailMessageSecurityKeys: TFMLister;
    FMGetsPurgeVerifier: TFMGets;
    fmlMailBasket: TFMLister;
    fmgQueueRecord: TFMGets;
    fmlNetSiteService: TFMLister;
    fmlAcquisitionSession: TFMLister;
    fmgAcquisitionSession: TFMGets;
    fmlImportQueue: TFMLister;
    fmlSessionFileErrors: TFMLister;
    procedure FMComponentInit(Sender: TObject);
    procedure DataModuleCreate(Sender: TObject);
    function security2(Broker: TRPCBroker):boolean;
    function VistaValidate(IENS,FNum,FldNum,FldValue: string;silent:boolean):boolean;
    function GetFieldValue(FNum,FldNum,IENS,Flag:string;silent:boolean): string;
    procedure HandleBrokerError(Sender: TRPCBroker);
    function GetVariable(GetLogic:string):string;
    function FMUpdate(FNum,FldNum,IENS,Value:string):boolean;
    function GetSilentCodes(Vserver, Vport: string; var SilentAccess: string; var SilentVerify: string): boolean;
    function TestSilentLog(VServer, VPort,SilentAccess, SilentVerify: string):boolean;
    function AutoLogin(Broker: TRPCBroker;SilentAccess,SilentVerify,VServer,VPort,MessageType,Division:string; Pause: Integer;Sender:TObject): boolean;
    function Find1(FNum,IENS,Flag,FndValue,XREF,Screen:string;silent:boolean): string;
    function FMUpdate1(FNum,FldNum,IENS,Value:string):boolean;
    function FindC(FNum,IENS,Flag,FndValue,XREF,Screen:string): string;
    function AddFMEntry(FNum,FldNum,IENS,Value,Flag:string):string;
    procedure OnException(e:Exception);
    function MagFieldValidate(FNum,IENS,FldNum,Flags,FldValue: string):string;
    function MagKeyValidate(Flags:string; FDA:  TStringlist; ChangedCtrlsList: TList):string;
    function FDAUpdate(Flags:string;FDA:TStringList;ChangedCtrlsList:TList;var ien:string):boolean;
    procedure TFMEditUpdate(fld: TFMEdit; RPCBroker: TRPCBroker; subcnt: Integer);
    procedure TFMCheckBoxUpdate(fld: TFMCheckBox; RPCBroker: TRPCBroker; subcnt: Integer);
    procedure TFMComboBoxUpdate(fld: TFMComboBox; RPCBroker: TRPCBroker; subcnt: Integer);
    procedure TFMLabelUpdate(fld: TFMLabel; RPCBroker: TRPCBroker; subcnt: Integer);
    procedure TFMListBoxUpdate(fld: TFMListBox; RPCBroker: TRPCBroker; subcnt: Integer);
    procedure TFMMemoUpdate(fld: TFMMemo; RPCBroker: TRPCBroker; subcnt: Integer);
    procedure TFMRadioButtonUpdate(fld: TFMRadioButton; RPCBroker: TRPCBroker; subcnt: Integer);
    procedure TFMRadioGroupUpdate(fld: TFMRadioGroup; RPCBroker: TRPCBroker; subcnt: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
   procedure OCXVistaInit;

  end;

var
  dmMain: TdmMain;
  {/p121 gek: Import API Active X control}
  MagImportX1 : TMagImportX;

implementation

uses Magbtm1;

{$R *.DFM}

{/p121     OCXVistaInit
     This procedure will initialize the Import OCX to the same server, port as the BP.
     Single Sign on is needed, so the User insn't prompted again.  }
{/p121 gek}
procedure TdmMain.OCXVistaInit;
var
  ok: wordbool;
  xmsg: widestring;
  vserver, vport, vdivision, vaccess, vverify, rstat: widestring;
begin
     if not assigned(MagImportX1) then
     begin
     MagImportX1 := TMagImportX.Create(Self);
     MagImportX1.Visible := false;
     end  ;
//vserver : use BP server
//vport :   use BP Port
{DONE -c121 : Maybe need other parameters. Division ? }

{ DONE -c121 : Tokan or AccessVerify.  Do same as BP AccessVerify }
{ TODO -c121 : Make a procedure out of this.  Called from two places. }
if (silentaccess = '') or (silentverify = '') then
  begin
  SilentAccess:= dmMain.GetVariable('$S($D(^MAG(2006.1,"'+IntToStr(magbtm1.place)+'","GW"))'+
    ':$P($G(^MAG(2006.1,"'+IntToStr(magbtm1.place)+'","GW")),U,1),1:0)');
  SilentVerify:= dmMain.GetVariable('$S($D(^MAG(2006.1,"'+IntToStr(magbtm1.place)+'","GW"))'+
    ':$P($G(^MAG(2006.1,"'+IntToStr(magbtm1.place)+'","GW")),U,2),1:0)');
  SilentAccess := hash.Decrypt(SilentAccess);
  SilentVerify := hash.Decrypt(SilentVerify);
  end;


  VServer := dmMain.RPCBroker1.Server;
  VPort := IntToStr(dmMain.RPCBroker1.ListenerPort);
  vDivision := piece(dmMain.RPCBroker1.User.Division,'^',1);
  vAccess := silentaccess; 
  vVerify := silentVerify; 

  MagImportX1.VistAInit(ok, xmsg, vserver, vport, vaccess, vverify, vdivision);
//  winmsg('VistA Init : ' + MagbooltostrLC(ok));
end;



procedure TdmMain.FMComponentInit(Sender: TObject);
var i: integer;
begin
// showmessage('Sender: '+Sender.ClassName);
  for i := 0 to (Sender as TComponent).ComponentCount - 1 do begin
    if (pos('TFM',(Sender as TComponent).Components[i].ClassName)= 1) then begin
      if ((Sender as TComponent).Components[i] is TFMLister) then
        ((Sender as TComponent).Components[i] as TFMLister).RPCBroker := dmMain.RPCBroker1;
      if ((Sender as TComponent).Components[i] is TFMGets) then
        ((Sender as TComponent).Components[i] as TFMGets).RPCBroker := dmMain.RPCBroker1;
      if ((Sender as TComponent).Components[i] is TFMValidator) then
        ((Sender as TComponent).Components[i] as TFMValidator).RPCBroker := dmMain.RPCBroker1;
      if ((Sender as TComponent).Components[i] is TFMFiler) then
        ((Sender as TComponent).Components[i] as TFMFiler).RPCBroker := dmMain.RPCBroker1;
      if ((Sender as TComponent).Components[i] is TFMFindOne) then
        ((Sender as TComponent).Components[i] as TFMFindOne).RPCBroker := dmMain.RPCBroker1;
      if ((Sender as TComponent).Components[i] is TFMFinder) then
        ((Sender as TComponent).Components[i] as TFMFinder).RPCBroker := dmMain.RPCBroker1;
      if ((Sender as TComponent).Components[i] is TFMHelp) then
        ((Sender as TComponent).Components[i] as TFMHelp).RPCBroker := dmMain.RPCBroker1;
      end;
    end;
end;

procedure TdmMain.DataModuleCreate(Sender: TObject);
begin
  if not RPCBroker1.Connected then
    if not security2(RPCBroker1) then application.Terminate;
  end;

function TdmMain.TestSilentLog(VServer, VPort,SilentAccess, SilentVerify: string):boolean;
begin
 if VServer ='' then VServer :='127.0.00.01';
  if VPort = '' then VPort :='9800';
  if not RPCBroker1.Connected then
  if GetSilentCodes(VServer, VPort, SilentAccess, SilentVerify) then begin
    RPCBroker1.AccessVerifyCodes := SilentAccess + ';' + SilentVerify;
    RPCBroker1.server := VServer;
    RPCBroker1.listenerPort := strtoint(VPort);
    try
      RPCBroker1.connected := true;
      Result := RPCBroker1.connected;
      finally
      if Result then showmessage('Silent Loggin Successful!')
      else showmessage('Silent Loggin NOT Successful!');
    end;
    end;  // if GetSilentCodes
  end;


function TdmMain.security2(Broker: TRPCBroker):boolean;
  var
    VServer, VPort: string;
  begin
    with dmMain do begin
      result := false;
      if GetServerInfo(VServer, VPort) = mrcancel then begin
        halt;
        exit;
        end;
      Broker.Server := VServer;
      Broker.listenerPort := strtoint(VPort);
      Broker.OnRPCBFailure := handlebrokererror;
      application.processmessages;
      try
        Broker.Connected := true;
        if broker.Connected then
          if not Broker.createcontext('MAG WINDOWS') then begin
             MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^security2^createcontext("MAG WINDOWS") not be established!',280,MAGBTMF1.sgLatestTasks);
             halt;
             exit;
             end
          else result := true
        else begin
            MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^security2^Broker Connection to server could not be established!',280,MAGBTMF1.sgLatestTasks);
            halt;
            exit;
            end;
{/p121 }
     if not assigned(MagImportX1) then
     begin
     MagImportX1 := TMagImportX.Create(Self);
     MagImportX1.Visible := false;
     end;

    {121  Do we want OCX VistAInit Here ? 
          was at first, but silentaccess and verify wern't defined yet.}
    {leave out.  look into later.}
    { if broker.Connected then
     begin
        OCXVistaInit;
     end; }


      except
        on E:Exception do
          if Assigned(dmMain.RPCBroker1) then begin
            dmMain.RPCBroker1.free;
            dmMain.RPCBroker1 := nil;
            end;
          end; //try...except
    end; {with dmMain}
 end;
function TdmMain.VistaValidate(IENS,FNum,FldNum,FldValue: string;silent:boolean):boolean;
var
  i:integer;
  ErrorText: string;
  rlist : TStringlist;
  Complete: boolean;
begin
  repeat
    Complete := true;
    VistaValidate := true ;
    rlist := TStringList.Create;
    dmMain.RPCBroker1.RemoteProcedure :='DDR VALIDATOR';
    dmMain.RPCBroker1.Param.Clear;
    dmMain.RPCBroker1.Param[0].Value  := '.DDR';
    dmMain.RPCBroker1.Param[0].Ptype  := list;
    dmMain.RPCBroker1.Param[0].Mult['"FILE"']  := FNum;
    dmMain.RPCBroker1.Param[0].Mult['"IENS"']  := IENS;
    dmMain.RPCBroker1.Param[0].Mult['"FIELD"'] := FldNum;
    dmMain.RPCBroker1.Param[0].Mult['"VALUE"'] := FldValue;
    try
      RPCBroker1.LSTCALL(rlist);
    except
      on E:Exception do begin
        OnException(E);
        MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^DDR VALIDATOR',280,MAGBTMF1.sgLatestTasks);
        Complete := false;
        rlist.Free;
        end;
      end;// try...except
    until Complete;
    if dmMain.RPCBroker1.Results.Count > 1 then begin
      ErrorText := '';
      for i := 0 to RList.Count-1 do begin
        if pos('BEGIN_diERRORS',rlist[i]) <> 0 then begin
          VistaValidate := false;
          if not silent then
            if (i+6) <= (rlist.Count -1) then
              MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^DDR VALIDATOR - '+rlist[i+6],280,MAGBTMF1.sgLatestTasks);
          end;
        end;
      end;
    dmMain.RPCBroker1.Param.Clear;
  end;
function TdmMain.GetFieldValue(FNum,FldNum,IENS,Flag:string;silent:boolean): string;
    var RList: tstringlist;
            i : integer;
      Complete: boolean;
  begin
    repeat
      Complete := true;
      dmMain.RPCBroker1.RemoteProcedure := 'DDR GETS ENTRY DATA';
      RList := TStringList.Create;
      dmMain.RPCBroker1.Param.Clear;
      dmMain.RPCBroker1.Param[0].Value  := '.DDR';
      dmMain.RPCBroker1.Param[0].Ptype  := list;
      dmMain.RPCBroker1.Param[0].Mult['"FILE"']  := FNum;
      dmMain.RPCBroker1.Param[0].Mult['"IENS"']  := IENS;
      dmMain.RPCBroker1.Param[0].Mult['"FIELDS"'] := FldNum;
      dmMain.RPCBroker1.Param[0].Mult['"FLAGS"'] := Flag;
      try
        RPCBroker1.LSTCALL(rlist);
      except
      on E:Exception do begin
        OnException(E);
        MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^DDR GETS ENTRY DATA',280,MAGBTMF1.sgLatestTasks);
        Complete := false;
        rlist.Free;
        end;
      end;// try...except
    until Complete;
    if RList[0]='[Data]' then begin
      if flag = 'I' then result := piece(RList[1],U,4)
      else result := piece(RList[1],U,5);
      end
    else Result := '';
     //end;
    if Result = '' then
      for i := 0 to Rlist.Count -1 do begin
        if pos('BEGIN_diERRORS',rlist[i]) <> 0 then
          if not silent then
            if (i+6) <= (rlist.Count -1) then
              MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^DDR GETS ENTRY DATA - '+rlist[i+6],280,MAGBTMF1.sgLatestTasks);
        end;
     RList.Free;
     dmMain.RPCBroker1.Param.Clear;
   end;

procedure TdmMain.HandleBrokerError(Sender: TRPCBroker);
var
  ErrorText: String;
  Path: String;
  StrLoc: TStringList;
  NowVal: TDateTime;
begin
  NowVal := Now;
  ErrorText := TRPCBroker(Sender).RPCBError;
  StrLoc := TStringList.Create;
  try
    Path := ExtractFilePath(Application.ExeName);
    Path := Path + 'Error.Log';
    if FileExists(Path) then
      StrLoc.LoadFromFile(Path);
    StrLoc.Add(FormatDateTime('mm/dd/yyyy hh:mm:ss  ',NowVal) + ErrorText);
    StrLoc.SaveToFile(Path);
  finally
    StrLoc.Free;
  end;
end;
function TdmMain.GetVariable(GetLogic:string):string;
  var
  data: string;
  Complete: boolean;
begin
  repeat
    Complete:= true;
    result := '';
    dmMain.RPCBroker1.RemoteProcedure := 'XWB GET VARIABLE VALUE';
    dmMain.RPCBroker1.Param[0].Value := GetLogic;
    dmMain.RPCBroker1.Param[0].PType := reference;
    try
      dmMain.RPCBroker1.Call;
    except
      on E:Exception do begin
        MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^XWB GET VARIABLE VALUE: '+GetLogic,280,MAGBTMF1.sgLatestTasks);
        OnException(E);
        Complete := false;
        end;
      end;// try...except
    until Complete;
    if dmMain.RPCBroker1.Results.Count > 0 then Data := dmMain.RPCBroker1.Results[0]
    else Data :='0';
    result := Data;
end;// function
function TdmMain.FMUpdate(FNum,FldNum,IENS,Value:string):boolean;
var
  filer: TFMFiler;
begin
  result := true;
  filer := TFMFiler.Create(self);
  filer.RPCBroker := dmMain.RPCBroker1;
  Filer.AddFDA(FNum,IENS,FldNum,Value);
  filer.Update;
  if filer.ErrorList.Count > 0 then begin
    filer.DisplayErrors;
    Result := false;
    end;
  filer.Free;
end;
function TdmMain.FMUpdate1(FNum,FldNum,IENS,Value:string):boolean;

var
  filer: TFMFiler;
  Complete: boolean;
begin
  repeat
    Complete := true;
    result := true;
    filer := TFMFiler.Create(self);
    filer.RPCBroker := dmMain.RPCBroker1;
    Filer.AddFDA(FNum,IENS+',',FldNum,Value);
    try
      filer.Update;
    except
      on E:Exception do begin
        OnException(E);
        MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^FMUpdate1',280,MAGBTMF1.sgLatestTasks);
        Complete := false;
        end;
      end;// try...except
  until Complete;
  if filer.ErrorList.Count < 0 then begin
    filer.DisplayErrors;
    Result := false;
    end;
  filer.Free;
end;


function TdmMain.GetSilentCodes(Vserver, Vport: string; var SilentAccess: string; var SilentVerify: string): boolean;

var t: tstrings;
    I: INTEGER;
begin
  result := false;
  if not fileexists('c:\MySAVC.avc') then exit;
  t := Tstringlist.create;
  try
    t.LoadFromFile('c:\MySAVC.avc');
    for I := 0 to t.count - 1 do
      begin
        if (pos(Vserver + ',' + Vport, t[i]) > 0) then
          begin
            silentaccess := piece(t[i], '^', 2);
            silentverify := piece(t[i], '^', 3);
            result := true;
          end;
      end;
  finally
    t.free;
  end;
end;
function TdmMain.AutoLogin(Broker: TRPCBroker;SilentAccess,SilentVerify,VServer,VPort,MessageType,Division:string; Pause: Integer;Sender:TObject): boolean;
begin
  result := false;
  with Broker do begin
    AccessVerifyCodes := SilentAccess + ';' + SilentVerify;
    server := VServer;
    listenerPort := strtoint(VPort);
    Broker.LogIn.Division := Division;
    try try
      connected := true;
      Broker.CreateContext('MAG WINDOWS');
     except
       on E:Exception do begin
          MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^Login Message^'+StringReplace(E.Message,'||','..',[rfReplaceAll]),280,MAGBTMF1.sgLatestTasks);
          end;
       end; //try...exception
    finally
        MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^Login Message^'+MessageType+' Login attempt',280,MAGBTMF1.sgLatestTasks);
      if not broker.connected then begin
        MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^AutoLogin^Broker Reconnection failed',280,MAGBTMF1.sgLatestTasks);
        end // if not connected
      else begin
        MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^Login Message^Broker Reconnection Successful',280,MAGBTMF1.sgLatestTasks);
        FMComponentInit(sender);
        FMComponentInit(self);
        //  next reconnect the Import DBBroker

 // ***************   Start 121   *************
  {/p121  then next few lines were setting properties of Import API control.
         The OCX does not surface these properties.  In Testing other Apps with Import OCX.  the OCXVistaInit procedure
         seemed to do the trick.   We may need to add parameters to the OCXVistaInit procedure.
         namely
           > AccessVerifyCodes := SilentAccess + ';' + SilentVerify;
            server := VServer;
            listenerPort := strtoint(VPort);
           > Broker.LogIn.Division := Division;
         }

(* /p121 next lines are not used with Import OCX. }
        if pos('TMAGBTMF1',uppercase(Sender.ClassName)) <> 0 then begin
          if Assigned(Magbtm1.MagDBBroker1) then begin
            Magbtm1.MagDBBroker1.Free;
            Magbtm1.MagDBBroker1 := nil;
            end;
          Magbtm1.MagDBBroker1 := TMagDBmvista.create;
          MAGBTMF1.MagImport1.MagBroker := dmMain.RPCBroker1;
          MAGBTMF1.MagImport1.MagDBBroker := Magbtm1.MagDBBroker1;
          Magbtm1.MagDBBroker1.SetBroker(dmMain.RPCBroker1);
          end;
          *)
     { TODO -c121 :  instead of above, we call OCXVistaInit, do we need to send parameters.. 
             OCXVistAInit doesn't need parameters from here.}

 {/p121.  this is all we need here. For AutoLogin SilentAccess and Silent Verify. are set in 
         OCXVistaInit if needed., other paremetes for silent login are defined in magbtm}
 
    OCXVistaInit;












  // ********  end 121 changes **************

        result := true;
        end;
    end; //try...finally
    end; // With Broker
    application.ProcessMessages;
end;
{    "FILE" the file or subfile number to search
    "IENS" the IENS that identifies the subfile if FILE is a subfile number
    "FLAGS" possible values include:
         A  allow pure numeric input to always be tried as an IEN
         M  multiple index allowed
         O  only find an exact match if possible
         Q  quick lookup
         X  exact match only
         R  record the ien in ^DISV via RECALL^DILFD
    "VALUE" the lookup value
    "XREF" the indexes that would be searched for a match
    "SCREEN" screen to apply to the record found
}
function TdmMain.Find1(FNum,IENS,Flag,FndValue,XREF,Screen:string;silent:boolean): string;
    var
        RList: tstringlist;
        i : integer;
        float        : Extended;
        errorPos     : Integer;
        Complete: boolean;
  begin
    repeat
      Complete:= true;
      dmMain.RPCBroker1.RemoteProcedure := 'DDR FIND1';
      RList := TStringList.Create;
      dmMain.RPCBroker1.Param.Clear;
      dmMain.RPCBroker1.Param[0].Value  := '.DDR';
      dmMain.RPCBroker1.Param[0].Ptype  := list;
      dmMain.RPCBroker1.Param[0].Mult['"FILE"']  := FNum;
      dmMain.RPCBroker1.Param[0].Mult['"IENS"']  := IENS;
      dmMain.RPCBroker1.Param[0].Mult['"FLAGS"'] := Flag;
      dmMain.RPCBroker1.Param[0].Mult['"VALUE"'] := FndValue;
      dmMain.RPCBroker1.Param[0].Mult['"XREF"'] := XREF;
      dmMain.RPCBroker1.Param[0].Mult['"SCREEN"'] := Screen;
      try
      dmMain.RPCBroker1.LSTCALL(rlist);
    except
      on E:Exception do begin
        OnException(E);
        MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^DDR FIND1',280,MAGBTMF1.sgLatestTasks);
        Complete := false;
        rlist.Free;
        end;
      end;// try...except
   until Complete;
     Val(Rlist[0], float, errorPos);
     if errorPos = 0 then Result := Rlist[0]
     else begin
       Result := '-1' ;
       for i := 0 to Rlist.Count -1 do begin
         if not silent then
           MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^DDR FIND1 - ' +rlist[i],280,MAGBTMF1.sgLatestTasks);
         if pos('BEGIN_diERRORS',rlist[i]) <> 0 then
           if not silent then if (i+6) <= (rlist.Count -1) then
             MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^DDR FIND1 - ' +rlist[i+6],280,MAGBTMF1.sgLatestTasks);
         end;
       end;
     if StrToInt(result) = 0 then result := '-1';
     RList.Free;
     dmMain.RPCBroker1.Param.Clear;
   end; // Find1
function TdmMain.FindC(FNum,IENS,Flag,FndValue,XREF,Screen:string): string;
  var Complete: Boolean;
begin
  repeat
    Complete:= true;
    dmMain.RPCBroker1.RemoteProcedure:= 'MAGQ FINDC';
    dmMain.RPCBroker1.Param[0].VALUE := FNum ;
    dmMain.RPCBroker1.Param[0].PTYPE := LITERAL ;
    dmMain.RPCBroker1.Param[1].VALUE := IENS ;
    dmMain.RPCBroker1.Param[1].PTYPE := LITERAL ;
    dmMain.RPCBroker1.Param[2].VALUE := Flag ;
    dmMain.RPCBroker1.Param[2].PTYPE := LITERAL ;
    dmMain.RPCBroker1.Param[3].VALUE := FndValue ;
    dmMain.RPCBroker1.Param[3].PTYPE := LITERAL ;
    dmMain.RPCBroker1.Param[4].VALUE := XREF ;
    dmMain.RPCBroker1.Param[4].PTYPE := LITERAL ;
    dmMain.RPCBroker1.Param[5].VALUE := Screen ;
    dmMain.RPCBroker1.Param[5].PTYPE := LITERAL ;
    try
      dmMain.RPCBroker1.Call;
    except
      on E:Exception do begin
        OnException(E);
        MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^MAGQ FINDC',280,MAGBTMF1.sgLatestTasks);
        Complete := false;
        end;
      end;// try...except
    until Complete;
    if dmMain.RPCBroker1.Results.Count > 0 then result := dmMain.RPCBroker1.Results[0]
    else Result :='-1';
end;
function TdmMain.AddFMEntry(FNum,FldNum,IENS,Value,Flag:string):string;
var i: integer;
   error,Complete: boolean;
begin
  repeat
    Complete:= True;
    Error := false;
    dmMain.RPCBroker1.RemoteProcedure:= 'DDR FILER';
    dmMain.RPCBroker1.Param[0].VALUE := 'ADD' ;
    dmMain.RPCBroker1.Param[0].PTYPE := LITERAL ;
    dmMain.RPCBroker1.Param[1].Value  := '.DDR';
    dmMain.RPCBroker1.Param[1].Ptype  := list;
    dmMain.RPCBroker1.Param[1].Mult['"1"'] := FNum+'^'+FldNum+'^'+IENS+'^'+Value ;
    dmMain.RPCBroker1.Param[2].VALUE := Flag ;
    dmMain.RPCBroker1.Param[2].PTYPE := LITERAL ;
    dmMain.RPCBroker1.Param[3].VALUE := '' ; // DDRIENS - Inactive
    dmMain.RPCBroker1.Param[3].PTYPE := LITERAL ;
    try
      dmMain.RPCBroker1.Call;
    except
      on E:Exception do begin
        OnException(E);
        MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^DDR FILER',280,MAGBTMF1.sgLatestTasks);
        Complete := false;
        end;
      end;// try...except
      until complete;
      for i := 0 to dmMain.RPCBroker1.Results.Count-1 do begin
        if pos('[BEGIN_diERRORS]',dmMain.RPCBroker1.Results[i]) <> 0 then Error := True;
      //  if i = 5 then showmessage(dmMain.RPCBroker1.Results[i]);
        end;
      if not Error then result := piece(dmMain.RPCBroker1.Results[1],'^',2)
      else Result :='-1';
end; //AddFMEntry



procedure TdmMain.TFMEditUpdate(fld: TFMEdit; RPCBroker: TRPCBroker; subcnt: Integer);
  begin
    with RPCBroker.Param[1] do begin
      Mult[IntToStr(subcnt)] :=
              fld.FMFile
        + U + fld.FMField
        + U + fld.IENS
        + U + fld.FMCtrlInternal;
      end; // TFMEditUpdate
  end; // TFMEditUpdate
procedure TdmMain.TFMCheckBoxUpdate(fld: TFMCheckBox; RPCBroker: TRPCBroker; subcnt: Integer);
begin
  with RPCBroker.Param[1] do begin
    Mult[IntToStr(subcnt)] :=
            fld.FMFile
      + U + fld.FMField
      + U + fld.IENS
      + U + fld.FMCtrlInternal;
    end;
end; // TFMCheckBoxUpdate

procedure TdmMain.TFMComboBoxUpdate(fld: TFMComboBox; RPCBroker: TRPCBroker; subcnt: Integer);
begin
  with RPCBroker.Param[1] do begin
    Mult[IntToStr(subcnt)] :=
             fld.FMFile
       + U + fld.FMField
       + U + fld.IENS
       + U + fld.FMCtrlInternal;
    end;
end; // TFMComboBoxUpdate

procedure TdmMain.TFMLabelUpdate(fld: TFMLabel; RPCBroker: TRPCBroker; subcnt: Integer);
begin
  with RPCBroker.Param[1] do begin
    Mult[IntToStr(subcnt)] :=
             fld.FMFile
       + U + fld.FMField
       + U + fld.IENS
       + U + fld.FMCtrlInternal;
    end;
end; // TFMLabelUpdate

procedure TdmMain.TFMListBoxUpdate(fld: TFMListBox; RPCBroker: TRPCBroker; subcnt: Integer);
begin
  with RPCBroker.Param[1] do begin
    Mult[IntToStr(subcnt)] :=
             fld.FMFile
       + U + fld.FMField
       + U + fld.IENS
       + U + fld.FMCtrlInternal;
    end;
end; // TFMListBoxUpdate

procedure TdmMain.TFMMemoUpdate(fld: TFMMemo; RPCBroker: TRPCBroker; subcnt: Integer);
var
  i, last: integer;
begin
  i := 0;
  with RPCBroker.Param[1] do begin
    {place file, field & entry info in parent node}
    Mult[IntToStr(subcnt)] :=
            fld.FMFile
      + U + fld.FMField
      + U + fld.IENS
      + U + 'DDRROOT('+ IntToStr(subcnt) + ')';
      {add memo field data}
      if fld.Lines.Count > 0 then begin
        last := fld.Lines.Count-1;
        for i := 0 to last do begin
          Mult[IntToStr(subcnt) + ',' + IntToStr(i+1)] := fld.Lines[i];
          end; // for i := 0 to last
        end //  if fld.Lines.Count > 0
      else Mult[IntToStr(subcnt) + ',' + IntToStr(i+1)] := '';
    end; // with RPCBroker1.Param[1]
end; // TFMMemoUpdate

procedure TdmMain.TFMRadioButtonUpdate(fld: TFMRadioButton; RPCBroker: TRPCBroker; subcnt: Integer);
begin
  with RPCBroker.Param[1] do begin
    Mult[IntToStr(subcnt)] :=
            fld.FMFile
      + U + fld.FMField
      + U + fld.IENS
      + U + fld.FMCtrlInternal;
     end;
end;

procedure TdmMain.TFMRadioGroupUpdate(fld: TFMRadioGroup; RPCBroker: TRPCBroker; subcnt: Integer);
begin
  with RPCBroker.Param[1] do begin
    Mult[IntToStr(subcnt)] :=
            fld.FMFile
      + U + fld.FMField
      + U + fld.IENS
      + U + fld.FMCtrlInternal;
     end;
end;
function TdmMain.FDAUpdate(Flags:string;FDA:TStringList;ChangedCtrlsList:TList;var ien:string):boolean;
procedure SetMode(IENS:string;var FMode: String);
begin
  if FMode = 'AddEntry' then exit;
  if pos('?', IENS) > 0 then FMode := 'AddEntry'
  else if pos('+', IENS) > 0 then FMode := 'AddEntry'
  else FMode := 'EditEntry';
end;
var
  error,Complete: boolean;
  FMode         : string;
  i,index,subcnt: integer;
  fld           : TObject;
  iens          : string;
begin // FDAUpdate
  if  (FDA.Count < 1) and (ChangedCtrlsList.Count < 1) then begin
    Result := True;  {No error in filing, Update returns True}
    exit;
    end; // if  (FDA.Count < 1) and (ChangedCtrlsList.Count < 1)
  repeat
    Result := False;
    Complete:= True;
    Error := false;
    try
//      if BrokerOK(Self) then begin
        Screen.Cursor := crHourglass;
        dmMain.RPCBroker1.RemoteProcedure := 'DDR FILER';
        dmMain.RPCBroker1.RPCVersion := '1';
        {set up edited fields array}
        with dmMain.RPCBroker1.Param[1] do Ptype  := list;
      subcnt  := 0;
      for index := 0 to (ChangedCtrlsList.Count - 1) do begin
        fld := ChangedCtrlsList[index];
        if fld <> nil then begin
          inc(subcnt);
          if fld is TFMEdit then
            TFMEditUpdate(TFMEdit(fld),dmMain.RPCBroker1, subcnt)
          else if fld is TFMCheckBox then
            TFMCheckBoxUpdate(TFMCheckBox(fld),dmMain.RPCBroker1, subcnt)
          else if (fld is TFMComboBox) or (fld is TFMComboBoxLookUp) then
            TFMComboBoxUpdate(TFMComboBox(fld),dmMain.RPCBroker1, subcnt)
          else if fld is TFMLabel then
            TFMLabelUpdate(TFMLabel(fld),dmMain.RPCBroker1, subcnt)
          else if fld is TFMListBox then
            TFMListBoxUpdate(TFMListBox(fld),dmMain.RPCBroker1, subcnt)
          else if fld is TFMMemo then
            TFMMemoUpdate(TFMMemo(fld),dmMain.RPCBroker1, subcnt)
          else if fld is TFMRadioButton then
            TFMRadioButtonUpdate(TFMRadioButton(fld),dmMain.RPCBroker1, subcnt)
          else if fld is TFMRadioGroup then
            TFMRadioGroupUpdate(TFMRadioGroup(fld),dmMain.RPCBroker1, subcnt)
          else
            dec(subcnt);
          end; // // if fld <> nil
        iens := Piece(dmMain.RPCBroker1.Param[1].Mult[IntToStr(subcnt)], U, 3);
        SetMode(IENS,FMode);
        end; // for index := 0 to (ChangedCtrlsList.Count - 1)
      {Add any required/key values to fda array scheme}
      for index := 0 to FDA.Count - 1 do begin
          inc(subcnt);
         dmMain.RPCBroker1.Param[1].Mult[IntToStr(subcnt)] :=
            piece(FDA[index],U,1)
            + U + piece(FDA[index],U,2)
            + U + piece(FDA[index],U,3)
            + U + piece(FDA[index],U,4);
          end; // for index := 0 to FDA.Count
        iens := Piece(dmMain.RPCBroker1.Param[1].Mult[IntToStr(subcnt)], U, 3);
        SetMode(IENS,FMode);
      {set up edit-mode parameter}
      with dmMain.RPCBroker1.Param[0] do begin
        if FMode = 'AddEntry'  then Value := 'ADD'
        else if FMode = 'EditEntry' then Value := 'EDIT';
        Ptype  := literal;
        end;  // with RPCBroker1.Param[0]
      {send loc'K' flag}
      with dmMain.RPCBroker1.Param[2] do begin
        Ptype := literal;
        if (FMode = 'EditEntry') then
          Value := Flags + 'K';
        end; // with RPCBroker1.Param[2]
     dmMain.RPCBroker1.Call;
    Screen.Cursor := crDefault;
    except
      on E:Exception do begin
        OnException(E);
        MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^DDR FILER',280,MAGBTMF1.sgLatestTasks);
        Complete := false;
        end; // on E:Exception
      end; // try...except
  until complete;
  for i := 0 to dmMain.RPCBroker1.Results.Count-1 do
    if pos('[BEGIN_diERRORS]',dmMain.RPCBroker1.Results[i]) <> 0 then Error := True;
  if Error then result := false
  else begin
    Result := true;
    if FMode = 'AddEntry' then ien := piece(dmMain.RPCBroker1.Results[1],'^',2)
    else ien := iens;
    end;
end; //FDAUpdate


procedure TdmMain.OnException(e:Exception);
begin
   if Assigned(dmMain.RPCBroker1) then begin
     dmMain.RPCBroker1.free;
     dmMain.RPCBroker1 := nil;
     end;
   dmMain.RPCBroker1 := TRPCBroker.Create(nil);
   if not dmMain.RPCBroker1.Connected then begin
     eftfut.pause(6);
     if not dmMain.AutoLogin(dmMain.RPCBroker1,Magbtm1.SilentAccess,Magbtm1.SilentVerify,Magbtm1.VServer,Magbtm1.VPort,'',Magbtm1.Division, 5, SELF) then
       repeat
         MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^Login Message^Silent Login attempt failed!',280,MAGBTMF1.sgLatestTasks);
         MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^Login Message^Pausing 3 minutes and will then retry',280,MAGBTMF1.sgLatestTasks);
         pause(180);
         if Assigned(dmMain.RPCBroker1) then begin
           dmMain.RPCBroker1.free;
           dmMain.RPCBroker1 := nil;
           end;
         dmMain.RPCBroker1 := TRPCBroker.Create(nil);
       until dmMain.AutoLogin(dmMain.RPCBroker1,Magbtm1.SilentAccess,Magbtm1.SilentVerify,Magbtm1.VServer,Magbtm1.VPort,'',Magbtm1.Division, 5, SELF);
       end // if not dmMain.RPCBroker1.Connected
     else begin
       MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^Error Message^Non-Connection related Broker error',280,MAGBTMF1.sgLatestTasks);
       MAGBTMF1.ErrorLog('Broker Relogin','Exception Handle',E.ClassName+' '+StringReplace(E.Message,'^','..',[rfReplaceAll]));
       end; // else
end;
function TdmMain.MagFieldValidate(FNum,IENS,FldNum,Flags,FldValue:  string):string;
var
  Complete,Error: boolean;
  i: integer;
begin
  repeat
    error := false;
    Complete := true;
    dmMain.RPCBroker1.RemoteProcedure :='MAG FIELD VALIDATE';
    dmMain.RPCBroker1.Param.Clear;
    dmMain.RPCBroker1.Param[0].Value  := FNum;
    dmMain.RPCBroker1.Param[0].Ptype  := literal;
    dmMain.RPCBroker1.Param[1].Value  := IENS;
    dmMain.RPCBroker1.Param[1].Ptype  := literal;
    dmMain.RPCBroker1.Param[2].Value  := FldNum;
    dmMain.RPCBroker1.Param[2].Ptype  := literal;
    dmMain.RPCBroker1.Param[3].Value  := Flags;
    dmMain.RPCBroker1.Param[3].Ptype  := literal;
    dmMain.RPCBroker1.Param[4].Value  := FldValue;
    dmMain.RPCBroker1.Param[4].Ptype  := literal;
    try
      dmMain.RPCBroker1.Call;
    except
      on E:Exception do begin
        OnException(E);
        MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^MAG FIELD VALIDATE',280,MAGBTMF1.sgLatestTasks);
        Complete := false;
        end;  // on E:
    end; // try...except
    until Complete;
    if dmMain.RPCBroker1.Results.Count > 1 then
      for i := 0 to dmMain.RPCBroker1.Results.Count-1 do
        if pos('BEGIN_diERRORS',dmMain.RPCBroker1.Results[i]) <> 0 then Error := true;
    if not Error then result := dmMain.RPCBroker1.Results[0]
    else Result :='-1^RPC Error: MAG Field Validate';
      dmMain.RPCBroker1.Param.Clear;
  end;
function TdmMain.MagKeyValidate(Flags:string; FDA:  TStringlist;ChangedCtrlsList: TList):string;
var
  cnt,i, index, subcnt:integer;
  Complete,Error: boolean;
  fld           : TObject;
begin
  repeat
    error := false;
    Complete := true;
    try
    dmMain.RPCBroker1.RemoteProcedure :='MAG KEY VALIDATE';
    dmMain.RPCBroker1.Param.Clear;
    dmMain.RPCBroker1.Param[0].Value  := Flags;
    dmMain.RPCBroker1.Param[0].Ptype  := literal;
    dmMain.RPCBroker1.Param[1].Ptype  := list;
    subcnt  := 0;
    for index := 0 to (ChangedCtrlsList.Count - 1) do begin
      fld := ChangedCtrlsList[index];
      if fld <> nil then begin
        inc(subcnt);
        if fld is TFMEdit then
          TFMEditUpdate(TFMEdit(fld),dmMain.RPCBroker1, subcnt)
        else if fld is TFMCheckBox then
          TFMCheckBoxUpdate(TFMCheckBox(fld),dmMain.RPCBroker1, subcnt)
        else if (fld is TFMComboBox) or (fld is TFMComboBoxLookUp) then
          TFMComboBoxUpdate(TFMComboBox(fld),dmMain.RPCBroker1, subcnt)
        else if fld is TFMLabel then
          TFMLabelUpdate(TFMLabel(fld),dmMain.RPCBroker1, subcnt)
        else if fld is TFMListBox then
          TFMListBoxUpdate(TFMListBox(fld),dmMain.RPCBroker1, subcnt)
        else if fld is TFMMemo then
          TFMMemoUpdate(TFMMemo(fld),dmMain.RPCBroker1, subcnt)
        else if fld is TFMRadioButton then
          TFMRadioButtonUpdate(TFMRadioButton(fld),dmMain.RPCBroker1, subcnt)
        else if fld is TFMRadioGroup then
          TFMRadioGroupUpdate(TFMRadioGroup(fld),dmMain.RPCBroker1, subcnt)
        else
          dec(subcnt);
        end; // // if fld <> nil
      end; // for index := 0 to (ChangedCtrlsList.Count - 1)
    for index := 0 to FDA.Count - 1 do begin
      inc(subcnt);
      dmMain.RPCBroker1.Param[1].Mult[IntToStr(subcnt)] := FDA[index];
      end;
      dmMain.RPCBroker1.Call;
    except
      on E:Exception do begin
        OnException(E);
        MAGBTMF1.InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^MAG Key VALIDATE',280,MAGBTMF1.sgLatestTasks);
        Complete := false;
        end;  // on E:
    end; // try...except
    until Complete;
    if dmMain.RPCBroker1.Results.Count > 1 then
      for i := 0 to dmMain.RPCBroker1.Results.Count-1 do
        if pos('BEGIN_diERRORS',dmMain.RPCBroker1.Results[i]) <> 0 then Error := true;
    if not Error then result := dmMain.RPCBroker1.Results[0]
    else Result :='-1^RPC Error: MAG Key Validate';
      dmMain.RPCBroker1.Param.Clear;
  end;

end.
