unit fmagDirectoryDialog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ShellCtrls, ExtCtrls, StdCtrls, Menus, Buttons, filectrl;
 // magpositions;

type
  TfrmDirectoryDialog = class(TForm)
    ShellChangeNotifier1: TShellChangeNotifier;
    Panel1: TPanel;
    ShellTreeView1: TShellTreeView;
    ShellComboBox1: TShellComboBox;
    Splitter1: TSplitter;
    pnlShellList: TPanel;
    ShellListView1: TShellListView;
    PopupMenu1: TPopupMenu;
    List1: TMenuItem;
    Icon1: TMenuItem;
    Report1: TMenuItem;
    SmallIcon1: TMenuItem;
    Panel2: TPanel;
    btnAdd: TBitBtn;
    BitBtn2: TBitBtn;
    Label1: TLabel;
    lbSelectedDir: TLabel;
    StatusBar1: TStatusBar;
    procedure FormCreate(Sender: TObject);
    procedure Icon1Click(Sender: TObject);
    procedure List1Click(Sender: TObject);
    procedure Report1Click(Sender: TObject);
    procedure SmallIcon1Click(Sender: TObject);
    procedure btnAddClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ShellTreeView1Change(Sender: TObject; Node: TTreeNode);
  private
    FdirList : string;{ Private declarations }
  public
    function Execute(var dir: string ): boolean;{ Public declarations }
  end;

var
  frmDirectoryDialog: TfrmDirectoryDialog;

implementation

{$R *.dfm}

procedure TfrmDirectoryDialog.FormCreate(Sender: TObject);
begin
pnlShellList.align := alclient;
//GetFormPosition(self as Tform);
end;

procedure TfrmDirectoryDialog.Icon1Click(Sender: TObject);
begin
ShellListView1.ViewStyle := vsIcon;
end;

procedure TfrmDirectoryDialog.List1Click(Sender: TObject);
begin
ShellListView1.ViewStyle := vsList;
end;

procedure TfrmDirectoryDialog.Report1Click(Sender: TObject);
begin
ShellListView1.ViewStyle := vsReport;
end;

procedure TfrmDirectoryDialog.SmallIcon1Click(Sender: TObject);
begin
ShellListView1.ViewStyle := vsSmallIcon;
end;

procedure TfrmDirectoryDialog.btnAddClick(Sender: TObject);
function ConvertToUNCPath
   (MappedDrive: string) : string;
var
   RemoteString : array[0..255] of char;
   lpRemote : PChar;
   StringLen : DWord;
begin
  lpRemote := @RemoteString;
  StringLen := 255;
  if WNetGetConnection
     (Pchar(ExtractFileDrive(MappedDrive)),lpRemote,
       StringLen)= NO_ERROR then
    Result := RemoteString
  else Result := '//';
end;


 var vDir : string;
begin
//ShellTreeView1.Path := vDir;
vDir := ConvertToUNCPath(ShellTreeView1.Path);
if pos('//',vDir) <> 0 then vDir := ShellTreeView1.Path + '\';
if directoryexists(vDir)
    then FdirList := vDir
    else messagebeep(2);
modalresult := mrOK;
(*
tnode := shelltreeview1.Selected;
s := tnode.Text + '\';
while tnode.Level <> 0 do
  begin
  tnode := tnode.Parent;
  s := tnode.Text + '\' + s;
  end;
FdirList.Add(s);
*)
end;
{ExpandUNCFileName returns a fully qualified path name using Universal
Naming Convention for network files. For files on local disks,
ExpandUNCFileName is equivalent to ExpandFileName.
In a UNC file name, the drive prefix is replaced with the name of the
network resource to which the drive is mapped. For example, if the
working directory is G:\SomeSharedFolder and drive G is mapped to
\\CompanyServer\AllSharedFolders ExpandUNCFileName('afile.ext') returns
"\\CompanyServer\AllSharedFolders\SomeSharedFolder\afile.ext".

example
ShowMessage(ExpandUNCFileName('afile.ext'));

//displays "\\CompanyServer\AllSharedFolders\SomeSharedFolder\afile.ext"
//if the working directory is G:\SomeSharedFolder
//and drive G is mapped to "\\CompanyServer\AllSharedFolders

}
function TfrmDirectoryDialog.Execute(var dir : string ): boolean;
begin
result := false;
application.CreateForm(TfrmDirectoryDialog, frmDirectoryDialog);
if pos('\\',dir) <> 0 then begin
  frmDirectoryDialog.ShellComboBox1.Root := 'rfNetwork';
  //frmDirectoryDialog.ShellTreeView1.Path := Dir;
  end
else frmDirectoryDialog.ShellTreeView1.Path := Dir;

frmDirectoryDialog.FdirList := dir;
result := frmDirectoryDialog.ShowModal = mrOK;
dir := frmDirectoryDialog.Fdirlist;
frmDirectoryDialog.Free;
end;

procedure TfrmDirectoryDialog.FormDestroy(Sender: TObject);
begin
//SaveFormPosition(self as Tform);
end;

procedure TfrmDirectoryDialog.ShellTreeView1Change(Sender: TObject;
  Node: TTreeNode);
begin
  if shelltreeview1.SelectionCount <> 0 then btnAdd.enabled := true;
  if directoryexists(shelltreeview1.Path)
    then lbSelectedDir.caption := shelltreeview1.Path
    else lbSelectedDir.caption := '';
end;

end.
