unit fmagLookUpDialog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls,  ExtCtrls, StdCtrls, Menus, Buttons, filectrl,
  Diaccess, Fmcmpnts, DiTypLib,RpcConf1,Trpcb;

type
  TfrmLookupDialog = class(TForm)
    Panel1: TPanel;
    PopupMenu1: TPopupMenu;
    Panel2: TPanel;
    btnOK: TBitBtn;
    BitExit: TBitBtn;
    StatusBar1: TStatusBar;
    lvLookup: TListView;
    BitNEW: TBitBtn;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    procedure FormCreate(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    function ListViewSearch(SearchList:TListView;SearchString:string;position:integer):integer;
    function GetLabels(Lister:TFMLister): TStringList;
    procedure ListViewUpdate(Clear,IEN,RowSelect,MultiSelect: Boolean;Lister:TFMLister;lv:TListView);
    procedure lvLookupSelectItem(Sender: TObject; Item: TListItem;
      Selected: Boolean);
    procedure lvColumnClick(Sender: TObject;
        Column: TListColumn);
    procedure lvCompare(Sender: TObject; Item1,Item2: TListItem;
        Data: Integer; var Compare: Integer);
    function lvSearch(SearchList:TListView;SearchString: string;ColumnIndex:integer):integer;
    procedure lvClear(Sender: TObject);
    procedure BitNEWClick(Sender: TObject);
  private
  public
    function Execute(NewButton: boolean;Lister: TFMLister;Title:string;var entry : string ): boolean;{ Public declarations }
  end;

var
  frmLookupDialog: TfrmLookupDialog;
  ColumnToSort: Integer;
  Order,Output: String;


implementation

{$R *.dfm}

procedure TfrmLookupDialog.FormCreate(Sender: TObject);
begin
  order := 'a';
  output := '';
//pnlShellList.align := alclient;
//GetFormPosition(self as Tform);
end;
function TfrmLookupDialog.ListViewSearch(SearchList:TListView;SearchString:string;position:integer):integer;
var index: integer;
    CheckString: string;
begin
  result := -1;
  for index := 0 to SearchList.Items.Count - 1 do begin
    if position = 0 then CheckString := SearchList.Items[index].Caption
    else CheckString := SearchList.Items[index].SubItems[position-1];
    if CheckString = SearchString then begin
      result := index;
      exit;
      end; //if piece
    end; // for index
end; //ListSearch
procedure TfrmLookupDialog.ListViewUpdate(Clear,IEN,RowSelect,MultiSelect: Boolean;Lister:TFMLister;lv:TListView);
var
  i,j,k,l: integer;
  Labels: TStringList;
  NewColumn: TListColumn;
  ListItem: TListItem;
begin
  if clear then begin
   lv.Items.Clear;
   lv.Columns.Clear;
   end;
  with Lister do begin
    GetList(nil);
    if Results.Count>0 then begin
      lv.ViewStyle := vsReport;
      lv.GridLines := true;
      lv.RowSelect := RowSelect;
      lv.MultiSelect := MultiSelect;
      Labels := GetLabels(Lister);
      GetLabels(Lister).Free;
      if Labels.Count>0 then begin{Create Column Labels}
        if IEN then begin
          NewColumn := lv.Columns.Add;
          NewColumn.Caption := 'IEN';
          NewColumn.Width := lv.Font.Size*4;
          end;
        for k := 0 to Labels.Count-1 do begin
          NewColumn := lv.Columns.Add;
          NewColumn.Caption := Labels[k];
          NewColumn.Width := lv.Font.Size*(Length(Labels[k])+2);
          end;
        end;
      for i := 0 to Results.Count -1 do begin   {Create ListItems}
        ListItem := lv.Items.Add;
        if IEN then ListItem.Caption := Lister.Results[i]
        else ListItem.Caption :=
          GetRecord(Results[i]).GetField(FieldNumbers.Strings[0]).FMDBExternal;
        if IEN then l := 0 else l := 1;
        for j := l to FieldNumbers.Count -1 do
          ListItem.SubItems.Add(GetRecord(Results[i]).GetField(FieldNumbers.Strings[j]).FMDBExternal);
        end; //for i
      for i := 0 to lv.Columns.Count -1 do begin
        lv.Columns[i].AutoSize := true;   {AutoSize Columns}
        lv.Columns[i].width := columnheaderwidth;  {Set ColumnWidth}
        end;
      end; //if results
    end; // with Lister
    Labels.Free;
end; //ListViewUpdate
function TfrmLookupDialog.GetLabels(Lister:TFMLister): TStringList;
  function GetLabel(FMFile,FMField:string): String;
    var
      ResultList :TStringList;
  begin
    ResultList := TStringList.create;
    with lister.RPCBroker do begin
     Param[0].VALUE := FMFile;
     Param[0].PTYPE := LITERAL;
     Param[1].VALUE := FMField;
     Param[1].PTYPE := LITERAL;
     Param[2].VALUE := '';
     Param[2].PTYPE := LITERAL;
     Param[3].VALUE := 'LABEL';
     Param[3].PTYPE := LITERAL;
     RemoteProcedure := 'MAG FLD ATT';
      try
        LSTCALL(ResultList);
      except
        On E: EBrokerError do begin
          Result := 'Broker Error: '+ E.ClassName+' '+
            E.Mnemonic+' '+E.Message+' '+E.Action;
          Exit;
          end;
      end;  //try
    end; //with RPCBroker1
    Result := ResultList[0] ;
    ResultList.Free;
  end;
  var i:integer;
begin
 Result := TStringList.Create;
 for i := 0 to Lister.FieldNumbers.Count-1 do
   result.Add(GetLabel(Lister.FileNumber,Lister.FieldNumbers[i]));
end;
procedure TfrmLookupDialog.btnOKClick(Sender: TObject);
begin
  output := frmLookupDialog.StaticText2.Caption ;
  modalresult := mrOK;
end;
function TfrmLookupDialog.Execute(NewButton: boolean;Lister: TFMLister;Title:string;var entry : string ): boolean;
begin
  result := false;
  application.CreateForm(TfrmLookupDialog, frmLookupDialog);
  if Title  <> '' then frmLookupDialog.Caption := Title +' - ' + frmLookupDialog.Caption;
  frmLookupDialog.BitNEW.Visible := NewButton;
  frmLookupDialog.btnOK.Enabled := false;
  frmLookupDialog.ListViewUpdate(True,True,True,False,Lister,frmLookupDialog.lvLookup);
  result := frmLookupDialog.ShowModal = mrOK;
  entry := output;
  frmLookupDialog.Free;
end;

procedure TfrmLookupDialog.FormDestroy(Sender: TObject);
begin
//SaveFormPosition(self as Tform);
end;


procedure TfrmLookupDialog.lvLookupSelectItem(Sender: TObject;
  Item: TListItem; Selected: Boolean);
begin
  frmLookupDialog.StaticText2.Caption := Item.Caption;
  frmLookupDialog.btnOK.Enabled := true;
end;

procedure TfrmLookupDialog.lvColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  ColumnToSort := Column.Index;
  (Sender as TCustomListView).AlphaSort;
  if order = 'a' then order := 'd'
  else order := 'a';
end;

procedure TfrmLookupDialog.lvCompare(Sender: TObject; Item1,
  Item2: TListItem; Data: Integer; var Compare: Integer);
function CompAll(Input1,Input2:string):integer;
var
  I1,I2,C1,C2: Integer;
begin
    Val(Input1,I1,C1);
    Val(Input2,I2,C2);
  if ((c1 = 0) and (c2 = 0)) then begin
    if I1 > I2 then result := I1 - I2;
    if I1 < I2 then result := -(I2 - I1);
    if I1 = I2 then result := 0;
    end
  else result := CompareText(Input1,Input2);
 if order = 'd' then result := -result;
end;
var IX: integer;
begin
  if ColumnToSort = 0 then
    Compare := CompAll(Item1.Caption,Item2.Caption)
  else begin
   ix := ColumnToSort - 1;
   Compare := CompAll(Item1.SubItems[ix],Item2.SubItems[ix]);
  end;
end;
function TfrmLookupDialog.lvSearch(SearchList:TListView;SearchString: string;ColumnIndex:integer):integer;
var i: integer;
  FoundItem : TListItem;
begin
  result := -1;
 if ColumnIndex = 0 then begin
   FoundItem := SearchList.FindCaption(0,SearchString,false,true,false);
   if FoundItem <> nil then Result := FoundItem.index
   else Result := -1;
   end
 else begin
   for i := 0 to SearchList.Items.Count - 1 do
     if pos(SearchString,SearchList.Items[i].SubItems[ColumnIndex-1]) <> 0 then begin
       result := i;
       exit;
       end;
     end;
end;
procedure TfrmLookupDialog.lvClear(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to frmLookupDialog.ComponentCount - 1 do
   if (frmLookupDialog.Components[I] is TListView) then
   with frmLookupDialog.Components[I] as TListView do begin
     items.clear;
     columns.clear;
     end;
end;

procedure TfrmLookupDialog.BitNEWClick(Sender: TObject);
begin
  output := 'new' ;
  modalresult := mrOK;
end;

end.
