unit frmBPProperties;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, Fmcntrls, Diaccess, Fmcmpnts;

type
  TfrmBPProperties = class(TForm)
    fmeBPNetLogArch: TFMEdit;
    bbtnDirectoryDialog: TBitBtn;
    FMFiler1: TFMFiler;
    bbtnOK: TBitBtn;
    bbtnCancel: TBitBtn;
    btnApply: TBitBtn;
    bbtnHelp: TBitBtn;
    FMGets1: TFMGets;
    FMHelp1: TFMHelp;
    FMValidator1: TFMValidator;
    fmlblBPClientVersion: TFMLabel;
    fmlblClientDistributionDate: TFMLabel;
    fmeWSLogSize: TFMEdit;
    fmlblWSOS: TFMLabel;
    fmlblLastExecutionDate: TFMLabel;
    stBPClientVersion: TStaticText;
    stClientDistributionDate: TStaticText;
    stWSOS: TStaticText;
    stLastExecutionDate: TStaticText;
    stLogfileSize: TStaticText;
    stNetworkLogfilelocation: TStaticText;
    procedure bbtnDirectoryDialogClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btnApplyClick(Sender: TObject);
    procedure fmeBPNetLogArchChange(Sender: TObject);
    procedure bbtnOKClick(Sender: TObject);
    procedure bbtnCancelClick(Sender: TObject);
    function BrowseDialog(const Title: string; const Flag: integer): string;
    function BrowseDialogCallBack(Wnd: HWND; uMsg: UINT; lParam, lpData: LPARAM):   integer stdcall;
    procedure FormActivate(Sender: TObject);
    procedure fmeWSLogSizeKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure fmeWSLogSizeKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure fmeBPNetLogArchKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure fmeBPNetLogArchKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure bbtnHelpClick(Sender: TObject);

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
 frmBPProperties1: TfrmBPProperties;
  IENS,Workstation: string;

implementation

{$R *.dfm}
uses fmagDirectoryDialog,MagSiteParameters,unitDM,ShellAPI, ShlObj,
  magWebHelp;
// http://delphi.about.com/od/windowsshellapi/l/aa070400a.htm

{BrowseInfo structure
Two of the main elements of BrowseInfo are the lpszTitle and ulFlags fields. The dialog box displays the contents of lpszTitle in a static text control above the treeview. The ulFlags element sets the value which determines what the dialog displays and allows the user to select.
We can specify zero or more of the flags in order to make the dialog box much more useful than just browsing for folders. Some of the flags that can be specified to enhance the Browse For Folders dialog box are:

Value Meaning
BIF_BROWSEFORCOMPUTER Only returns computers.
  If the user selects anything other than a computer, the OK button is grayed.
BIF_BROWSEFORPRINTER Only returns printers.
  If the user selects anything other than a printer, the OK button is grayed.
BIF_RETURNONLYFSDIRS Only returns file system directories.
  If the user selects folders that aren't part of the file system, the OK button is grayed.
BIF_BROWSEINCLUDEFILES The browse dialog will display files as well as folders
BIF_DONTGOBELOWDOMAIN	Does not include network folders below the domain level
   in the tree view control.  For example, to browse for both folders and files
   the ulFlags should be set to BIF_BROWSEINCLUDEFILES.

 }


function TfrmBPProperties.BrowseDialog(const Title: string; const Flag: integer): string;
var
  lpItemID : PItemIDList;
  BrowseInfo : TBrowseInfo;
  DisplayName : array[0..MAX_PATH] of char;
  TempPath : array[0..MAX_PATH] of char;
begin
  Result:='';
  FillChar(BrowseInfo, sizeof(TBrowseInfo), #0);
  with BrowseInfo do begin
    hwndOwner := Application.Handle;
    pszDisplayName := @DisplayName;
    lpszTitle := PChar(Title);
    ulFlags := Flag;
  //  lpfn := BrowseDialogCallback;
  end;
  lpItemID := SHBrowseForFolder(BrowseInfo);
  if lpItemId <> nil then begin
    SHGetPathFromIDList(lpItemID, TempPath);
    Result := TempPath;
    GlobalFreePtr(lpItemID);
  end;
end;
function TfrmBPProperties.BrowseDialogCallBack
  (Wnd: HWND; uMsg: UINT; lParam, lpData: LPARAM):
  integer stdcall;
var
  wa, rect : TRect;
  dialogPT : TPoint;
begin
  //center in work area
  if uMsg = BFFM_INITIALIZED then
  begin
    wa := Screen.WorkAreaRect;
    GetWindowRect(Wnd, Rect);
    dialogPT.X := ((wa.Right-wa.Left) div 2) -
                  ((rect.Right-rect.Left) div 2);
    dialogPT.Y := ((wa.Bottom-wa.Top) div 2) -
                  ((rect.Bottom-rect.Top) div 2);
    MoveWindow(Wnd,
               dialogPT.X,
               dialogPT.Y,
               Rect.Right - Rect.Left,
               Rect.Bottom - Rect.Top,
               True);
  end;
  Result := 0;
end; (*BrowseDialogCallBack*)



procedure TfrmBPProperties.bbtnDirectoryDialogClick(Sender: TObject);
var vDir: String;
    sTitle, sFolder: string;
    iFlag : integer;
begin
  vdir := fmeBPNetLogArch.Text;
  sTitle := 'Network Log Folder';
  iFlag :=  BIF_RETURNONLYFSDIRS;
  sFolder := BrowseDialog(sTitle, iFlag);
  if sFolder <> '' then vdir := sFolder;
  if pos(':',sFolder) <> 0 then
    vdir := expanduncfilename(sFolder);
  fmeBPNetLogArch.Text := vdir;
  FMFiler1.AddFDA(fmeBPNetLogArch.FMFile,fmeBPNetLogArch.IENS,fmeBPNetLogArch.FMField,fmeBPNetLogArch.text);
  frmBPProperties1.btnApply.Enabled := true;
end;

procedure TfrmBPProperties.FormCreate(Sender: TObject);
begin
  //frmBPProperties1.Caption := format('%s - %s',[ ' '+Server+' ', 'Network Log Share']);
  dmMain.FMComponentInit(self);
end;

procedure TfrmBPProperties.btnApplyClick(Sender: TObject);
begin
  if FMFiler1.AnythingToFile then begin
    if FMFiler1.DataProblemCheck then begin
      Windows.MessageBox(frmBPProperties1.Handle,PChar('Invalid data value!'),' ',MB_SYSTEMMODAL) ;
      end  //if FMFiler1.DataProblemCheck
    else if not FMFiler1.Update then
      Windows.MessageBox(frmBPProperties1.Handle,PChar('Invalid data value!'),' ',MB_SYSTEMMODAL)
      else frmBPProperties1.btnApply.Enabled := false;
    end //if FMFiler1.AnythingToFile
  else frmBPProperties1.btnApply.Enabled := false;
end;

procedure TfrmBPProperties.fmeBPNetLogArchChange(Sender: TObject);
begin
  with Sender as TFMEdit do
    if FMDBExternal <> Text then begin
        if pos(':',text) <> 0 then
          text := expanduncfilename(text);
        if Validate then begin
          FMFiler1.AddFDA(FMFile,IENS,FMField,text);
          frmBPProperties1.btnApply.Enabled := true;
          end //if Validate..
        else begin
          frmSiteParameters.SiteParametersDisplayHelp(Sender);
          text := FMDBExternal;
          end;  // else not validated
      end; //
end;

procedure TfrmBPProperties.bbtnOKClick(Sender: TObject);
begin
  if FMFiler1.AnythingToFile then begin
    if FMFiler1.DataProblemCheck then begin
      Windows.MessageBox(frmBPProperties1.Handle,PChar('Invalid data value!'),' ',MB_SYSTEMMODAL) ;
      end
    else if not FMFiler1.Update then
      Windows.MessageBox(frmBPProperties1.Handle,PChar('Invalid data value!'),' ',MB_SYSTEMMODAL) ;
    end
  else ;
  frmBPProperties1.close;
end;

procedure TfrmBPProperties.bbtnCancelClick(Sender: TObject);
begin
  frmBPProperties1.Close;
end;

procedure TfrmBPProperties.FormActivate(Sender: TObject);
begin
  {$ifdef Win32}
          SetForegroundWindow(frmBPProperties1.Handle);
  {$else}
          BringWindowToTop(frmBPProperties1.Handle);
  {$endif}
//  Application.NormalizeTopMosts;
//  SetWindowPos(frmBPProperties1.Handle, HWND_TOPMOST, 0,0,0,0,
//   SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
  bbtnOk.SetFocus;
  btnApply.Enabled := false;
end;

procedure TfrmBPProperties.fmeWSLogSizeKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if key = VK_Return then fmeBPNetLogArchChange(Sender);
end;

procedure TfrmBPProperties.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  frmBPProperties1.ModalResult := mrCancel;
  Action := caFree;
end;

procedure TfrmBPProperties.fmeWSLogSizeKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if key = VK_F1 then
     frmSiteParameters.F1KeyDown(Sender,Key,Shift);
end;

procedure TfrmBPProperties.fmeBPNetLogArchKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if key = VK_F1 then
     frmSiteParameters.F1KeyDown(Sender,Key,Shift);
end;

procedure TfrmBPProperties.fmeBPNetLogArchKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if key = VK_Return then fmeBPNetLogArchChange(Sender);
end;

procedure TfrmBPProperties.bbtnHelpClick(Sender: TObject);
begin
  Application.CreateForm(TfrmMagBPHelp,frmMagBPHelp);
  frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
 'help\MAG_BP_User_Manual.htm#_Toc258827246');
end;

end.
