unit magAssocInstVistaRadGroups1;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: BP Site Parameter sub form
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Fmcntrls, Menus, Fmcmpnts,Fmlookup,Diaccess,ComCtrls,
  Buttons,RpcConf1,Trpcb,DiTypLib, ExtCtrls, Spin, OleCtnrs,MFunstr;


type
  TMagAssocInstVistaRadGroup = class(TForm)
    fmlbAssocInstVistaRadGroups: TFMListBox;
    PopupVistRadGroup: TPopupMenu;
    popAIVTG: TPopupMenu;
    Add1: TMenuItem;
    Delete1: TMenuItem;
    Close1: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure Update(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Add1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure DeleteMember(var ListBox:TFMListBox; MainIEN:string);
    procedure popAIVTGPopup(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MagAssocInstVistaRadGroup: TMagAssocInstVistaRadGroup;

implementation

uses UnitDM,MagSiteParameters,Magbtm1;

{$R *.dfm}

procedure TMagAssocInstVistaRadGroup.FormCreate(Sender: TObject);
begin
 MagAssocInstVistaRadGroup.Caption :=
   format('%s - %s - %s',[Magbtm1.SiteName,frmSiteParameters.fmlbAssociatedInstitutions.Items[frmSiteParameters.fmlbAssociatedInstitutions.itemindex],'AI Edit']);
  dmMain.fmlAssocVistaRadGroup.IENS := ','+frmSiteParameters.fmlbAssociatedInstitutions.GetSelectedRecord.IEN+
        ','+IntToStr(magbtm1.place)+',';
  fmlbAssocInstVistaRadGroups.GetList;
end;
procedure TMagAssocInstVistaRadGroup.Update(Sender: TObject);
begin
  dmMain.fmlAssocVistaRadGroup.IENS := ','+frmSiteParameters.fmlbVistaRadGroup.GetSelectedRecord.IEN+
        ','+IntToStr(magbtm1.place)+',';
  fmlbAssocInstVistaRadGroups.GetList;
end;
procedure TMagAssocInstVistaRadGroup.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  MagAssocInstVistaRadGroup.ModalResult := mrCancel;
  Action := caFree;
end;

procedure TMagAssocInstVistaRadGroup.Add1Click(Sender: TObject);
var
  AddRecord : boolean;
  iens: string;
  RList: TStringList;
  Lister: TFMLister;
begin
  with dmMain do begin
    Lister :=TFMLister.Create(self);
    Lister.FileNumber := '40.8';
    Lister.FieldNumbers.Add('.01');
    Lister.FieldNumbers.Add('.07');
    Lister.DisplayFields.Add('.07');
    Lister.RPCBroker := dmMain.RPCBroker1;
    Lister.ListerFlags := [lfInternal] ;
    Lister.Screen :='I '+char(39)+'$D(^MAG(2006.1,'+fmgSiteParam.IENs+'"INSTS",'+
      frmSiteParameters.fmlbAssociatedInstitutions.GetSelectedRecord.IEN+',"201","B",$P($G(^(0)),U,7)))';
    frmSiteParameters.FMLookup1.FMLister := Lister;
    frmSiteParameters.FMLookup1.AllowNew := false;
    if frmSiteParameters.FMLookup1.Execute(AddRecord) then begin
      inc(AddCnt);
      iens := '+'+IntToStr(AddCnt)+',';
        RPCBroker1.RemoteProcedure := 'DDR GETS ENTRY DATA';
      try
        RList := TStringList.Create;
        with RPCBroker1.Param[0] do begin
          Value  := '.DDR';
          Ptype  := list;
          Mult['"FILE"']  := '40.8';
          Mult['"IENS"']  := frmSiteParameters.FMLookUp1.RecordNumber+',';
          Mult['"FIELDS"'] := '.01';
          Mult['"FLAGS"'] := 'E';
          end;
        RPCBroker1.LSTCALL(RList);
        if RList[0]='[Data]' then begin
          fmlbAssocInstVistaRadGroups.Items.Add(piece(RList[1],U,5));
          RList.Clear;
          with RPCBroker1.Param[0] do begin
            Value  := '.DDR';
            Ptype  := list;
            Mult['"FILE"']  := '40.8';
            Mult['"IENS"']  := frmSiteParameters.FMLookup1.RecordNumber+',';
            Mult['"FIELDS"'] := '.07';
            Mult['"FLAGS"'] := 'I';
            end;
          RPCBroker1.LSTCALL(RList);
          if RList[0]='[Data]' then begin
            frmSiteParameters.FMFilerMain.AddFDA('2006.12201',iens+frmSiteParameters.fmlbAssociatedInstitutions.GetSelectedRecord.IEN+
           ','+frmSiteParameters.fmgSiteParam.IENs,'.01',piece(RList[1],U,4));
            end;
          end;
        frmSiteParameters.btnApply.Enabled := true;
      finally
        RList.Free;
      end;
      end;
      Lister.Free;
    end;
end;
procedure TMagAssocInstVistaRadGroup.Delete1Click(Sender: TObject);
begin
  DeleteMember(fmlbAssocInstVistaRadGroups,IntToStr(magbtm1.place));
  frmSiteParameters.btnApply.Enabled := true;
end;
procedure TMagAssocInstVistaRadGroup.DeleteMember(var ListBox:TFMListBox; MainIEN:string);
var
  IENS,FileNum: string;
begin
    if (ListBox.GetSelectedRecord <> nil) then begin {delete}
      IENS:= ListBox.GetSelectedRecord.IEN+','+frmSiteParameters.fmlbVistaRadGroup.GetSelectedRecord.IEN+
        ','+IntToStr(magbtm1.place)+',';
      FileNum := ListBox.FMLister.FileNumber;
      frmSiteParameters.FMFilerMain.AddFDA(FileNum,IENS,'.01','@');
      ListBox.Items.Delete(ListBox.ItemIndex);
      end
    else
      Windows.MessageBox(MagAssocInstVistaRadGroup.Handle,PChar('You need to select a an item to delete.'),' ',MB_SYSTEMMODAL);
end;

procedure TMagAssocInstVistaRadGroup.popAIVTGPopup(Sender: TObject);
begin
 // if fmlbAssocInstVistaRadGroups.Items.Count > 0 then popAIVTGPopup.items[1].enabled := true
 // else popAIVTGPopup.item[1].enabled := false;
end;

procedure TMagAssocInstVistaRadGroup.FormActivate(Sender: TObject);
begin
    Application.NormalizeTopMosts;
    SetWindowPos(MagAssocInstVistaRadGroup.Handle, HWND_TOPMOST, 0,0,0,0,
      SWP_NOACTIVATE+SWP_NOMOVE+SWP_NOSIZE);
end;

end.
