unit Magbtm1;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: Main BP Queue Processor
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

interface

uses
 Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
 StdCtrls, MFunStr, Mask, Grids, Gauges, hash, ExtCtrls, FileCtrl,StrUtils,
 Trpcb, Fmcmpnts, Diaccess, Menus, ComCtrls,
 OleCtrls,SplVista, Buttons, RpcConf1, magbut,eftfut,{isp3,}
 telabout, { isp3,} AxCtrls, DbOleCtl,DiTypLib, MagExeWait,shellAPI,
 Fmlookup,  RpcSLogin,DateUtils,printers
 {cMagSecurity, cMagImport, cMagDBBroker, cMagDBMVista}

 {/p121 gek }
 , variants
 ;

type

TMagFileServer = RECORD
   Path : String[100];
   Size : TLargeInteger;
   Space      : TLargeInteger;
   Used : TLargeInteger;
  end;

  TMAGBTMF1 = class(TForm)
    Timer1: TTimer;
    pnlBP: TPanel;
    pnlblBP: TPanel;
    pnlSGlatestask: TPanel;
    sgLatestTasks: TStringGrid;
    mnuMainMenu: TMainMenu;
    mnuHelp: TMenuItem;
    mnuAbout: TMenuItem;
    mnuContents: TMenuItem;
    View1: TMenuItem;
    mnuServerSize: TMenuItem;
    mnuJHRPT: TMenuItem;
    mnuOpenLog: TMenuItem;
    mnuFile: TMenuItem;
    mnuEdit: TMenuItem;
    mnuBPServers: TMenuItem;
    mnuPurge: TMenuItem;
    mnuPurgeParameters: TMenuItem;
    OpenDialog1: TOpenDialog;
    mnuNetLocMan: TMenuItem;
    ImagingSiteParameters1: TMenuItem;
    mnuExit1: TMenuItem;
    FMGets1: TFMGets;
    FMFindOne1: TFMFindOne;
    Splitter4: TSplitter;
    pnlTop: TPanel;
    pnlResources: TPanel;
    pnllblResource: TPanel;
    pnlSG2: TPanel;
    sgServer: TStringGrid;
    Panel3: TPanel;
    pnlsbtn: TPanel;
    sbtnStart: TBitBtn;
    sbtnStop: TBitBtn;
    Timer2: TTimer;
    lvQueues: TListView;
    mnuQueueManager: TMenuItem;
    mnuMailMessages: TMenuItem;
    mnuMailGroups: TMenuItem;
    RPCBrokerTest: TRPCBroker;
    mnuImportQueue: TMenuItem;
    mnuRefreshQueueCounts: TMenuItem;
    mnuPurgeReQueuebytype: TMenuItem;
    mnu508mode: TMenuItem;
    PDF1: TMenuItem;
    stEventLog: TStaticText;
    stVistAStorage: TStaticText;
    mnuImportOCX: TMenuItem;
    function JukeBoxCacheSize(JBPath:string):boolean;
    function GetPlace(var SiteCode,SiteName: string):integer;
    procedure Reboot; //may wish to uncomment this out of formclose
    function GetFileSysName(Drive : Byte) : String;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ProcCycle;
    function GetQueue(var action, input: string): boolean;
    procedure ReQueue(qptr: string);
    function Abstra:boolean;
    function JBox:boolean;
    function Import:boolean;
    function JBTOHD(action: string):boolean;
    function FDELETE:boolean;
    function GCC(action: string): boolean;
    function QueueUpdate(qptr,Process,QueueStatus : string ): boolean;
    function GetQueueList:boolean;
    function MakeAbs(abspath,Sourcepath,qptr:string; var msg:string):boolean;
    procedure ReportGCCError(Error: string);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure InitSGLatestTasks;
    procedure InitSGServer;
    procedure sbtnStartClick(Sender: TObject);
    procedure sbtnStopClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure sgLatestTasksEnter(Sender: TObject);
    procedure sgLatestTasksExit(Sender: TObject);
    function ResetCurrentServer(notify: string): string;
    function DiskFree32(var FileServer: TMagFileServer): Boolean;
    procedure AltFileType(var AltFileTypeList:TStringList);
    procedure InvStrGrid(log: boolean; input: string; RMax: Integer; var Grid: TStringGrid);
    function CheckVolNameNT(volname,volpath: string): boolean;
    procedure mnuContentsClick(Sender: TObject);
    procedure mnuAboutClick(Sender: TObject);
    procedure mnuServerSizeClick(Sender: TObject);
    procedure JBSleep(path:string);
    procedure init;
    procedure ErrorLog(Proced,ErrorType,MessageS: String);
    procedure mnuJHRPTClick(Sender: TObject);
    procedure InitLogFile(filepath,title:string;AlwaysNew: Boolean;var FileSize: integer);
    procedure LogProc;
    procedure mnuBPServersClick(Sender: TObject);
    procedure mnuPurgeClick(Sender: TObject);
    procedure mnuLogClick(Sender: TObject);
    procedure mnuOpenLogClick(Sender: TObject);
    procedure mnuPurgeParametersClick(Sender: TObject);
    procedure mnuNetLocManClick(Sender: TObject);
    procedure mnuPurgeNullQueRecClick(Sender: TObject);
    procedure ImagingSiteParameters1Click(Sender: TObject);
    function PtrUpdate(RPC,Ptr,Ext,ien:string):boolean;
    //procedure mnuLogStatClick(Sender: TObject);
    procedure ServerSize(Group:string);
    function MagEnterpriseUpdate(Data,Send,Place, App: string): boolean;
//    function GetConPar(NetLoc: string;var UserName,PW:String;Conn :boolean):boolean;
    function TryCopy(qptr,source,destin,Action:string;QSN: integer;
       var Copied,NotCopied:TStringList): boolean;
    function ImageGroupNotify(Filename,SourceSze,JBSze:string): boolean;
    procedure mnuExit1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure AutoPurge(Sender: TObject;Shares:string);
    procedure ScheduledPurge(Sender: TObject;RequestDate,Shares:string);
    procedure AutoVerify(Sender: TObject; RequestDate:String);
    function VerifyVersion(Sender: TObject;AppsVersion: string;var kids: string): boolean;
    function AbstractOK(FileExt:string):boolean;
    function QueueJBTOHD(ImageType,ien:string):boolean;
    function QueueAbstract(ien:string):boolean;
    function QueueDelete(qptr:string):boolean;
    function FileCreationDate(FilePath:string):Tdate;
    function JBQueue(RecNo: string):string;
    procedure UpdateQueuePointer(QueueType,QueuePtr: string);
    procedure GetSystemTimeout(var TimeOut: string);
    procedure Timer2Timer(Sender: TObject);
    procedure mnuAllClick(Sender: TObject);
    procedure ExecNewProcess(ProgramName : String; Wait: Boolean);
    function LimitListSize(Percent,RecordSize:integer;Sender: TObject):string;
//    function GetValue(Filenumber,FieldNumber,IEN:string):string;
    procedure RaidVerify(Sender: TObject);
    procedure UpdateBPServerActivity(DistDate,AppVer,OSVer: string);
    function AssignLogPath(CompName,WSIEN:string):string;
    function LogSize(WSIEN:string):string;
    procedure ListViewUpdate(Clear,IEN: Boolean;Lister:TFMLister;lv:TListView);
    function GetLabels(FMDC:TObject): TStringList;
    procedure lvColumnClick(Sender: TObject;
      Column: TListColumn);
    procedure lvCompare(Sender: TObject; Item1,
      Item2: TListItem; Data: Integer; var Compare: Integer);
    function lvSearch(SearchList:TListView;SearchString:String; ColumnIndex:integer):integer;
    procedure lvClear(Sender: TObject);
    procedure lvAdd(Viewer:TListView;Column:integer;UpdateLabel:TLabel);
    procedure LVUpdate(Results: TStrings;lv:TListView;delim: string);
    procedure OnException(E:exception);
    function IncrQueuePtr(Queue: string):boolean ;
    procedure RefreshQueueCounts1Click(Sender: TObject);
    procedure mnuQueueManagerClick(Sender: TObject);
    procedure mnuMailMessagesClick(Sender: TObject);
    procedure mnuMailGroupsClick(Sender: TObject);
    function DateToFMInternal(ExDate:string):string;
    procedure CurrentRAIDShares(var RAIDShares: TStringList);
    function NumericSegment(Segment: string):integer;
    procedure MergeStrings(Dest, Source: TStrings) ;
    procedure Button1Click(Sender: TObject);
    procedure mnuImportQueueClick(Sender: TObject);
    procedure mnuPurgeRequeuebytype1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    function GetNetUser : Ansistring;
    procedure Button4Click(Sender: TObject);
    procedure mnu508modeClick(Sender: TObject);
    procedure PDF1Click(Sender: TObject);
    function MagExecuteFile(const FileName, Params, DefaultDir: string;  ShowCmd: Integer; oper : string = 'open'): THandle;
  public


  private

  end;
  var
    MAGBTMF1: TMAGBTMF1;
    JBCacheSize: LongInt;
    MagServerWriteCnt,Idle,Cycle,MAGTMInterval,place,logCNT: integer;
    Initial,PurgeActive,VerifierActive,LogOn,ErrorLogInit,Conn,ProcCycleActive,ProcCycleOn: boolean;
    WSIEN,WSID,JOBID,DistDate,AppVer,OSVer,CompName,LogFilePath,kids,SiteCode,SiteName: string;
    LastServerUpdate,ErrorLogDate,LogDate: TDATETime;
    Lister: TFMLister;
    Password,User,TempS, AppsVer, PlaceName,TimeOut,MyPurge,MyVerify ,Notify,SReserve,FreeSpace: string;
//121    MagDBBroker1 : TMagDBMVista;
    GearErrorL: TStringList;
    RaidAttempt,CycleCount,BPErrorLogSize,BackProcLogSize :integer;
    logSizeV: real;
    SilentAccess,SilentVerify,VServer,VPort,Division: string;


  const
    RaidPause = 5;
    RaidInterval = 6;
    FailIfExist = true;
    logMAX = 10000;
    EMessage = 'Vista Host is not responding' ;
    u ='^';
    rStringHeader = 'Date/Time^Event:_Queue_Ref^Message/Path';

implementation

uses MAGPURGE2,MAGJHRPT,MagViewLog,
  {MagNewBP,}MagNetLoc, MagSiteParameters, {MagLogStat,}
  UnitDM, MagShowLog,MagWebHelp, MagQueuePurgeByType,
  MAGNetLoc2,MAGMailGroups,MailGroupProperties,MagImportQueue1;

(* references: http://delphi.about.com/od/adptips2005/qt/nilselfapp.htm
  http://delphi.about.com/b/2006/07/29/multi-resolution-delphi-applications.htm
  http://delphi.about.com/od/formsdialogs/a/delphiformlife.htm
  *)

{$R *.DFM}
function TMAGBTMF1.GetNetUser : Ansistring;
var
  dwI : DWord;
begin
  dwI := MAX_PATH;   SetLength (Result, dwI + 1);   if WNetGetUser (Nil, PChar (Result), dwI) = NO_ERROR then    SetLength (Result, StrLen (PChar (Result)))   else     SetLength (Result, 0)
end;

procedure TMAGBTMF1.FormCreate(Sender: TObject);
begin

  sbtnStart.Enabled := True;
  sbtnStart.Default := True;
  sbtnStop.Enabled := False;
  ProcCycleOn := false;
  AppsVer := GetAppVer(Application.ExeName);
  if not VerifyVersion(self,AppsVer,kids) then begin
    Windows.MessageBox(MAGBTMF1.Handle,PChar('The Background Processor client software is version ' + AppsVer+
      ' .  VistA Imaging Host system has version '+kids+' installed.  Please update to compatible'+
      ' client and host software.  Shutting down the Background Processor...'),' ',MB_SYSTEMMODAL);
    application.Terminate;
    end;
  place := GetPlace(SiteCode,SiteName);
  if place < 1 then begin
    Windows.MessageBox(MAGBTMF1.Handle,PChar('The Site parameter context could not be determined.  The application will terminate.'),' ',MB_SYSTEMMODAL);
    application.Terminate;
    end;
  {DONE : -c121  change to user OCX.}
  //121/  if pos(UpperCase(dmMain.GetFieldValue('2006.1','25',IntToStr(place)+',','E',true)),'OFF') <> 0 then MagImport1.MagSecurity.SecurityOn := false
  //121/  else MagImport1.MagSecurity.SecurityOn := true;
  {this is ImportX code.}
  if pos(UpperCase(dmMain.GetFieldValue('2006.1','25',IntToStr(place)+',','E',true)),'OFF') <> 0 then MagImportX1.NetSecurity := false
  else MagImportX1.NetSecurity := true;

  Application.Title := ' '+SiteName+' '+ 'BP Queue Processor ';
  Caption := Application.Title;
  PurgeActive := false;
  VerifierActive := false;
  Application.ShowHint := True;
  Application.HintColor := clAqua;
  Application.HintPause := 100;
  Application.HintHidePause := 5000;
  cycle:= 0 ;
  initial := true;
  LogOn := false;
  ErrorLogInit := false;
  mnuServerSize.Checked:=false;
// *** Moved to Init which executes in FormActivate ***
//  LogDate := FileCreationDate(ExtractFilePath(Application.ExeName)+
//    'log\BackProc\BackProc.LOG');
//  MAGBTMF1.BringToFront;
  VServer := dmMain.RPCBroker1.Server;
  VPort := IntToStr(dmMain.RPCBroker1.ListenerPort);
  SilentAccess:= dmMain.GetVariable('$S($D(^MAG(2006.1,"'+IntToStr(magbtm1.place)+'","GW"))'+
    ':$P($G(^MAG(2006.1,"'+IntToStr(magbtm1.place)+'","GW")),U,1),1:0)');
  SilentVerify:= dmMain.GetVariable('$S($D(^MAG(2006.1,"'+IntToStr(magbtm1.place)+'","GW"))'+
    ':$P($G(^MAG(2006.1,"'+IntToStr(magbtm1.place)+'","GW")),U,2),1:0)');
  SilentAccess := hash.Decrypt(SilentAccess);
  SilentVerify := hash.Decrypt(SilentVerify);
  Division := dmMain.RPCBroker1.LogIn.Division;
//  Division := dmMain.GetFieldValue('2006.1','.01',IntToStr(magbtm1.place)+',','I',true);
  // background for printDialog issue: https://forums.codegear.com/thread.jspa?threadID=17410

{/p121 gek   create the Import OCX}
(*   NOT here.  this form isn't created first.
  MagImportX1 := TMagImportX.Create(Self);
  MagImportX1.Visible := false;
  *)
  dmMain.OCXVistaInit;
end; //FormCreate




procedure TMAGBTMF1.Timer1Timer(Sender: TObject);
{ProcCycleActive controls Single instantiation of the ProcCycle}
begin
  Timer1.Interval := 1000;
  Caption := Format('%s - %s - %s - %s', [Application.Title ,TimeToStr(Now),' BP Server ID: '
      +WSID,'   JOB ID: '+JOBID]);
   if not ProcCycleActive and ProcCycleOn then begin
     ProcCycleActive := True;
     ProcCycle;
     application.ProcessMessages;
     if LogDate <> date then begin
       try
         LogProc;
       except
         InvStrGrid(True,DateTimeToStr(Now)+'^Initialization Failure^Log Files at:'+LogFilePath+' '+
           SysErrorMessage(GetLastError),280,sgLatestTasks);
         exit;
         end; // try...except
       InitLogFile('log\BackProc\BPError.LOG','BP_Error_Log',true,BPErrorLogSize);
       ErrorLogDate := FileCreationDate(ExtractFilePath(Application.ExeName)+'log\BackProc\BPError.LOG');
       ErrorLogInit := true;
       end;
     ProcCycleActive := False;
   end;
end;

// Timer1Timer

procedure TMAGBTMF1.ProcCycle;
function findproc(lbProcList:TListbox; procname:string;var index:integer):boolean;
var i:integer;
  begin
    result := false;
    i := 0;
    index := -1;
    if lbProcList.Items.Count = 0 then exit;
    repeat
      if pos(procname,lbProcList.Items[i])<> 0 then
        begin
          result := true;
          index:=i;
        end;
      inc(i);
    until (i=lbProcList.Items.count)or(result);
  end;
var index:integer;

begin
//  inc(CycleCount);
  if not GetQueueList then exit;
  if (Now > AddSec(LastServerUpdate,60*20)) or (MagServerWriteCnt > 100) or
    (DateToStr(LastServerUpdate) <> DateToStr(Date)) then begin
       RaidVerify(self);
       UpdateBPServerActivity(DistDate,AppVer,OSVer);
       end;
    if lvQueues.Items.Count > 0 then begin
      index := lvSearch(lvQueues,'JBTOHD',0);
      if index > -1 then begin
         lvQueues.Items[index].Selected := true;
        lvQueues.Update;
        if JBTOHD('JBTOHD') then exit;
        end;
      index := lvSearch(lvQueues,'PREFET',0);
      if index > -1 then begin
        lvQueues.Items[index].Selected := true;
        lvQueues.Update;
        if JBTOHD('PREFET') then exit;
        end;
      index := lvSearch(lvQueues,'ABSTRACT',0);
      if index > -1 then begin
        lvQueues.Items[index].Selected := true;
        lvQueues.Update;
        if ABSTRA then exit;
        end;
      index := lvSearch(lvQueues,'IMPORT',0);
      if index > -1 then begin
        lvQueues.Items[index].Selected := true;
        lvQueues.Update;
        if Import then exit;
        end;
      index := lvSearch(lvQueues,'JUKEBOX',0);
      if index > -1 then begin
        lvQueues.Items[index].Selected := true;
        lvQueues.Update;
        if JBOX then exit;
        end;
      index := lvSearch(lvQueues,'DELETE',0);
      if index > -1 then begin
        lvQueues.Items[index].Selected := true;
        lvQueues.Update;
        if FDELETE then exit;
        end;
      index := lvSearch(lvQueues,'GCC',0);
      if index > -1 then begin
        lvQueues.Items[index].Selected := true;
        lvQueues.Update;
        if GCC('GCC') then exit;
        end;
      end;  // if items.count
end; //ProcCycle
procedure TMAGBTMF1.UpdateBPServerActivity(DistDate,AppVer,OSVer: string);
var
  FMFiler1: TFMFiler;
  Complete: boolean;
begin
  repeat
    Complete := true;
    FMFiler1 := TFMFiler.Create(self);
    FMFiler1.RPCBroker := dmMain.RPCBroker1;
    FMFiler1.AddFDA('2006.8',WSIEN+',','51',AppVer);
    FMFiler1.AddFDA('2006.8',WSIEN+',','52',DistDate);
    FMFiler1.AddFDA('2006.8',WSIEN+',','53',OSVer);
    FMFiler1.AddFDA('2006.8',WSIEN+',','55',DateToFMInternal(DateToStr(Now)));
    try
      FMFiler1.Update;
    except
      on E:Exception do begin
        OnException(E);
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^UpdateBPServerActivity',280,sgLatestTasks);
        complete := false;
        FMFiler1.Free;
        end;
      end; //try...except
  until Complete;
  FMFiler1.Free;
end; //UpdateBPServerActivity
procedure TMAGBTMF1.RaidVerify(Sender: TObject);
var Reset: string;
    LocalPause: integer;
  begin
    RaidAttempt := 0;
    Notify := '0';
    Reset := '';
    LocalPause := RaidPause*1000;
    InvStrGrid(True,DateTimeToStr(Now)+'^'+'Raid Verify'+
         '^Checking File Server Space',280,sgLatestTasks);
    repeat
      inc(RaidAttempt);
      if RaidAttempt > 1 then begin
         Sleep(LocalPause);
         end;
      ServerSize('ALL');
      if (RaidAttempt >= RaidInterval) then begin
        notify := '1';
        InvStrGrid(True,DateTimeToStr(Now)+'^ResetCurrentServer'+
            '^Not enough File Server Space',280,sgLatestTasks);
        inc(RaidAttempt);
        end;
      Reset := ResetCurrentServer(notify);
      if (Reset = '0'){ and (RaidAttempt = 1)} then
              InvStrGrid(True,DateTimeToStr(Now)+'^ResetCurrentServer'+
            '^Not enough File Server Space',280,sgLatestTasks);
    until (Reset <> '0') or (notify = '1');
    if Reset = '2' then
        InvStrGrid(True,DateTimeToStr(Now)+'^ResetCurrentServer'+
            '^Not enough File Server Space',280,sgLatestTasks);
    InvStrGrid(True,DateTimeToStr(Now)+'^'+' % Server Reserve'+U+
      format('%s %s %s %s',['Low Water Mark: ',SReserve+'%' , '   Free Space: ', FreeSpace+'%']),280,sgLatestTasks);
    if (Reset = '-1'){ and (RaidAttempt = 1)} then begin
       InvStrGrid(True,DateTimeToStr(Now)+'^ResetCurrentServer'+
       '^RAID groups not properly configured',280,sgLatestTasks);
        InvStrGrid(True,DateTimeToStr(Now)+'^ResetCurrentServer'+
       '^Use the Network Location Manager to reset your RAID groups',280,sgLatestTasks);
       sbtnStopClick(nil);
       end;
  end; // RaidVerify

function TMAGBTMF1.IncrQueuePtr(Queue: string):boolean ;
 var CurrentQPtr,PrevQPtr,NxtQPtr: string;
 begin
    CurrentQPtr := dmMain.GetVariable('$S($D(^MAGQUEUE(2006.031,"C","'+IntToStr(magbtm1.place)+'","'+
      Queue+'")):$O(^MAGQUEUE(2006.031,"C","'+IntToStr(magbtm1.place)+'","'+Queue+'","")),1:0)');
    PrevQPtr := dmMain.GetFieldValue('2006.031','1',CurrentQPtr+',','I',true);
    NxtQPtr := dmMain.GetVariable('$S($O(^MAGQUEUE(2006.03,"C","'+IntToStr(magbtm1.place)+'","'+
      Queue+'","'+PrevQPtr+'")):$O(^MAGQUEUE(2006.03,"C","'+IntToStr(magbtm1.place)+'","'+Queue+'","'+PrevQPtr+'")),1:0)');
    if dmMain.FMUpdate1('2006.031','1',CurrentQPtr,NxtQPtr) then begin
      InvStrGrid(True,DateTimeToStr(Now)+'^Increment '+Queue+' Ptr^Succeeded',280,sgLatestTasks);
      Result:= true;
      frmSiteParameters.ReSetQueueCnt(Queue);
      end
    else begin
      InvStrGrid(True,DateTimeToStr(Now)+'^Increment '+Queue+' Ptr^Failed',280,sgLatestTasks);
      result := false;
      end;
 end; // IncrQueuePtr

function TMAGBTMF1.GetQueue(var action, input: string):boolean ;
var complete: boolean;
begin
  repeat
    complete := true;
    result := false;
    dmMain.RPCBroker1.Param[0].VALUE := action;
    dmMain.RPCBroker1.Param[0].PTYPE := LITERAL ;
    dmMain.RPCBroker1.RemoteProcedure := 'MAGQ GET';
    try
      input := dmMain.RPCBroker1.strCall;       //call
    except
      on E:Exception do begin
        OnException(E);
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^GetQueue',280,sgLatestTasks);
        complete := false;
        end;
      end; //try...except
  until complete;
  dmMain.RPCBroker1.ClearResults:= true; //CleanupInstance;
  dmMain.RPCBroker1.ClearParameters := true;
//    if input = '0' then begin //Advance the Queue if the last GetQueueProcess failed
//      IncrQueuePtr(Action);
//      exit;
//      end;
  if StrToInt(piece(input,'^',1)) < 0 then begin
    //consider cache sleep &/or mail message here for CWL problems (same as Critical low)
    if StrToInt(piece(input,'^',1))= -15 then begin
      InvStrGrid(true,DateTimeToStr(Now)+u+action+' : '+piece(input,'^',2)+u+
        piece(input,'^',3),280,sgLatestTasks);
      if StrToInt(piece(input,'^',7))<2 then ReQueue(piece(input,'^',2));
      end //if StrToInt(piece(input,'^',1))= -15
    else begin
      QueueUpdate(piece(input,U,2),action,piece(input,U,1)+'^'+' '+piece(input,'^',3)+u);
      // Propose requeuing IMPORT if QSN < 2 - here
      UpdateQueuePointer(action,piece(input,U,2));
      end; // else
    end;  // if StrToInt(piece(input,'^',1)) < 0
  if StrToInt(piece(input,'^',1)) > 0 then result := true ;
end; //GetQueue

function TMAGBTMF1.GetQueueList;
var
  ProcList : Tstringlist;
  Complete: boolean;
begin
  repeat
    Complete := true;
    result := false;
    ProcList := TStringList.Create;
    dmMain.RPCBroker1.Param[0].VALUE :=CompName+'^'+AppVer+'^'+
      DistDate+'^'+OSVer ;
    dmMain.RPCBroker1.Param[0].PTYPE := LITERAL ;
    dmMain.RPCBroker1.Param[1].VALUE := 'B-PROC';
    dmMain.RPCBroker1.Param[1].PTYPE := LITERAL ;
    dmMain.RPCBroker1.RemoteProcedure := 'MAGQ ABP';
    try
      dmMain.RPCBroker1.LSTCALL(ProcList);
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^GetQueueList',280,sgLatestTasks);
        OnException(E);
        ProcList.Free;
        Complete := false;
        application.ProcessMessages;
        end;
    end; //try...except
  until complete;
    dmMain.RPCBroker1.ClearResults:= true; //CleanupInstance;
    dmMain.RPCBroker1.ClearParameters := true;
   //proclist ROWS become a 2 attribute record (procname^count)
  if ProcList.Count < 2 then begin
    Windows.MessageBox(MAGBTMF1.Handle,PChar('This server is not yet configured for BP queue task processing!'),' ',MB_SYSTEMMODAL);
    ProcList.Free;
    sbtnStopClick(nil);
    exit;
    end;
  if (piece(ProcList[0],'^',1)='-1')or(StrToInt(piece(ProcList[0],'^',1)) > 1) then begin
    InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^GMAGQ ABP '+piece(ProcList[0],'^',2),280,sgLatestTasks);
    ProcList.Free;
    exit;
    end;
  result:=true;
  WSID := piece(ProcList[0],'^',4)+' - '+piece(ProcList[0],'^',5);
  JOBID := piece(ProcList[0],'^',3);
  ProcList[0] := 'Queue^Active^Failed' ;
  LVUpdate(ProcList,lvQueues,'^');
  ProcList.free;
end; //GetQueueList

procedure TMAGBTMF1.ReQueue(qptr: string);
var
 RequeueN : string;
 Complete: boolean;
begin
  repeat
    Complete := true;
    InvStrGrid(true,DateTimeToStr(Now)+u+'Requeuing: '+qptr+u,280,sgLatestTasks);
    dmMain.RPCBroker1.Param[0].VALUE := qptr;
    dmMain.RPCBroker1.Param[0].PTYPE := LITERAL ;
    dmMain.RPCBroker1.RemoteProcedure := 'MAGQ REQ';
    try
      RequeueN := dmMain.RPCBroker1.strCall;
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^ReQueue',280,sgLatestTasks);
        OnException(E);
        Complete := false;
        end; // on E:Exception
     end; //try...except
   until complete;
 InvStrGrid(true,DateTimeToStr(Now)+u+'Requeue result:^ '+RequeueN,280,sgLatestTasks);
 if StrToInt(RequeueN)< 1 then
   ErrorLog('ReQueue','Brokercall: MAGQ REQ','Requeue Failure trying to Requeue: '+QPTR);
end;
function TMAGBTMF1.Import:Boolean;
var
  input,qptr,TrackingID,action,ImageIEN,SCRE,Source,Filename,share,shareien,path : string;
  QSN,i: integer;
  SearchRec:TSearchRec;
  ImportDispo: TStrings;
  ImportStat : boolean;
  StatusCB,QueueRecordCB,temp,WSIen : string;
  {/p121 variable types the TLB will like.}
  pStat : wordbool;
  pQnum : String;
  pVarlist : olevariant;
  pCB : widestring;

begin
   try try
     ImportDispo := TStringlist.create;
     action := 'IMPORT';
     result := false;
     if getqueue(action,input) then begin
       inc(MagServerWriteCnt);
       result := true;
       qptr :=  piece(input,'^',1);
       TrackingID := piece(input,'^',2);
       if Length(Trim(TrackingID)) < 2 then begin
         //if QSN < 2 then ReQueue(qptr); commented out p39 t24
         QueueUpdate(qptr,action,'-1^'+'No Tracking ID '+action+' failed^');
         exit;
         end;
       QSN := StrToInt(piece(input,'^',8));
       QueueRecordCB := piece(input,'^',3)+'^'+piece(input,'^',4);
       InvStrGrid(True,DateTimeToStr(Now) + '^'+action+': ' + qptr + '^' + 'Tracking ID: ' + TrackingID,280,sgLatestTasks);
// *************    121  Start ************
  {TODO : -c121  change to user OCX.}
//       MagImport1.ImportQueue(ImportStat,piece(input,'^',5),ImportDispo, StatusCB);

       pQnum := piece(input,'^',5);
       pVarlist := vararraycreate([0, 1], varolestr);
       pCB := '';
      { pstat => importStat
        pQnum
        pVarList, convert to Tstrings after call.}
       MagImportX1.ImportQueue (pStat,pQnum,pVarList,pCB);
       ImportStat := pstat;
       StatusCB := pCB;
      for i := vararraylowbound(pVarlist, 1) to vararrayhighbound(pVarlist, 1) do
      begin
        // ImportDispo   is BP variable for the Result TStringlist (aka 'reslist')
        ImportDispo.add(pvarlist[i]);
      end;
// *************  121 End  ************


       if not ImportStat then begin
         QueueUpdate(qptr,action,'-1^'+Piece(ImportDispo[0],'^',2)+u);
         for i := 3 to ImportDispo.Count-1 do begin
          temp := Piece(ImportDispo[i],'^',2);
          if length(temp)= 0 then continue;
          while pos('^',temp) <> 0 do
            temp := copy(temp,1,pos('^',temp)-1)+ '~'+copy(temp,pos('^',temp)+1,999);
          QueueUpdate(qptr,action,'-1^'+temp+u);
          end; // for i := 3 ...
          if QSN < 2 then ReQueue(qptr);
          end // if not ImportStat
       else begin // ImportStat
           ImageIen := dmMain.GetVariable('$S($D(^MAG(2005,"ATRKID","'+TrackingID+'"))'+
           ':$O(^MAG(2005,"ATRKID","'+TrackingID+'","A"),-1),1:0)');
           if ImageIen = '0' then begin
             QueueUpdate(qptr,action,'-1^No Image file entry was created!^');
             exit;
             end; // ImageIen = '0'
             Filename := trim(dmMain.GetFieldValue('2005','1',ImageIen+',','E',true));
             //Check for RAID reference
             ShareIEN := dmMain.GetVariable('$S($D(^MAG(2005,'+ImageIen+',0)):+$P($G(^MAG(2005,'+ImageIen+',0)),U,3),1:0)');
             if ShareIEN = '0' then begin
               QueueUpdate(qptr,action,'-1^'+'No valid RAID share found^');
               exit;
               end;
             ShareIEN := dmMain.GetVariable('$S($$SLINE^MAGQBJB('+ShareIEN+')=1:'+ShareIEN+',1:0)');
             if ShareIEN = '0' then begin
               QueueUpdate(qptr,action,'-1^'+'The RAID share is not on-line^');
               exit;
               end;
             share := trim(dmMain.GetFieldValue('2005.2','1',shareIEN+',','E',true));
             path := dmMain.GetVariable('$S(1:$$DIRHASH^MAGFILEB("'+Filename+'",'+ShareIEN+'))');
           Source := share+path+Filename;
           if FileExists(source) then begin // SourceExists
              FindFirst(source,faAnyFile,SearchRec);
             if SearchRec.Size = 0 then QueueUpdate(qptr,action,'-1^File copied was of size zero: '+Source+'^')
             else QueueUpdate(qptr,action,'1^'+'Tracking ID: ' + TrackingID +' '+action+' complete: '+Source+'^');
             end // if FileExists
           else QueueUpdate(qptr,action,'-1^File was not found at:'+source+'^');
         end; // ImportStat
         // RPC CALL HERE
       //  if StatusCB = '' then StatusCB := QueueRecordCB;  //added - sf  7/10/02 removed P39
        // gek P8T32, P15 ? ? What was QueueRecordCB used for
        // gek P8T32, P15  import API now calls the RPMag4StatusCallback
        // MagDBBroker1.RPMag4StatusCallback(ImportDispo,StatusCB); //gek P8T32, P15
       end;  // if getqueue(action,input)
  except
    on E:Exception do begin
      InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^Import',280,sgLatestTasks);
      OnException(E);
      QueueUpdate(qptr,action,'-1^'+'RPC Exception^');
      //      if QSN < 2 then ReQueue(qptr);
      end; // on E:Exception
  end; //try...except
  finally
    ImportDispo.free;
  end; //try...finally
end;

function TMAGBTMF1.JBTOHD(action: string): boolean;
// RESULT=STATUS^MAGIFN^FROMPATH^TOPATH^FILETYPE^QPTR^VWP^QSN
procedure Alt(FileType: TStringList;qptr,sourcepath,destpath: string);
var i: integer;
begin
  if FileType.count > 0 then
    if not DirectoryExists(ExtractFilePath(destpath))
      then SysUtils.ForceDirectories(ExtractFilePath(destpath));
  for i := 0 to FileType.count - 1 do
    begin
      InvStrGrid(True,DateTimeToStr(Now)+'^'+action+': '+qptr+'^'+
        ChangeFileExt(sourcepath,'.'+FileType[i])+'  '+
        ChangeFileExt(destpath,'.'+FileType[i])
        ,280,sgLatestTasks);
      if not FileExists(pchar(ChangeFileExt(destpath,'.'+ FileType[i]))) then
        begin
          if CopyFile(pchar(ChangeFileExt(sourcepath,'.'+
            FileType[i])), pchar(ChangeFileExt(destpath,'.'+
            FileType[i])),FailIfExist) then
              InvStrGrid(True,DateTimeToStr(Now)+'^'+action+': '+qptr+'^'+
                ChangeFileExt(ExtractFileName(sourcepath),'.'+ FileType[i])+
                 ' '+action+' copy complete.',280,sgLatestTasks)
          else begin
            if not DirectoryExists(ExtractFileDrive(sourcepath)) then
              InvStrGrid(True,DateTimeToStr(Now)+'^JBTOHD:ALT'^'+ ExtractFileDrive(sourcepath) +
                ' Jukebox is currently offline. ',280,sgLatestTasks);
            InvStrGrid(True,DateTimeToStr(Now)+'^'+action+': '+qptr+'^'+
            ChangeFileExt(sourcepath,'.'+FileType[i])+'  '+
            'NOT Copied',280,sgLatestTasks);
            end;
        end
      else
        InvStrGrid(True,DateTimeToStr(Now)+'^'+action+': '+qptr+'^'+
         ChangeFileExt(destpath,'.'+FileType[i])+'  '+
          'Already on Server',280,sgLatestTasks);
    end;
end;
var
  input,destpath,sourcepath,qptr,filename,vwp,filetype : string;
  QSN: integer;
  AltFileTypeList: TStringList;
begin
  result := false;
  if getqueue(action ,input) then begin // substitiuted if for while
    inc(MagServerWriteCnt);
    result := true;
    qptr :=  piece(input,'^',6);
    vwp :=  piece(input,'^',7);
    QSN := StrToInt(piece(input,'^',8));
    filetype := piece(input,'^',5);
    destpath := piece(input,'^',4);
    sourcepath := piece(input,'^',3);
    filename:= ExtractFileName(sourcepath);
    AltFileType(AltFileTypeList);
    if (lowercase(filetype) = 'full') or (lowercase(filetype) = 'big') or
      (pos('.tif',lowercase(ExtractFileExt(filename))) <> 0) then
        Alt(AltFileTypeList,qptr,sourcepath,destpath);
    AltFileTypeList.free;
    InvStrGrid(True,DateTimeToStr(Now) + '^'+action+': ' + qptr + '^' +
      SourcePath + '  ' + DestPath,280,sgLatestTasks);
    if not DirectoryExists(ExtractFilePath(destpath)) then SysUtils.ForceDirectories(ExtractFilePath(destpath));
    if FileExists(destpath) then begin
      QueueUpdate(qptr,action,'2^'+Piece(ExtractFileExt(filename),'.',2)+' '+action+
        ' FileServer copy not overwritten^'+vwp);
      exit;
      end;
    if FileExists(sourcepath) then begin
      if not CopyFile(pchar(sourcepath),pchar(destpath),FailIfExist) then begin
        destpath := piece(input,'^',9);
        if (piece(input,'^',1)='2') and (destpath<>'') then begin
          if FileExists(destpath) then begin
            QueueUpdate(qptr,action,'2^'+piece(ExtractFileExt(filename),'.',2) +' '+action+
              ' FileServer copy not overwritten^'+vwp);
            exit;
            end;
          if CopyFile(pchar(sourcepath),pchar(destpath),FailIfExist) then begin
            vwp := piece(input,'^',10);
            QueueUpdate(qptr,action,'1^'+piece(ExtractFileExt(filename),'.',2)+' '+action+
              ' copy complete^'+vwp);
            exit;
            end;
          end;
        QueueUpdate(qptr,action,'-1^'+piece(ExtractFileExt(filename),'.',2) +
          ' Unable to copy to the current fileServer: '+
        IntToStr(GetLastError)+ ': '+SysErrorMessage(GetLastError)+'^');
        if QSN < 2 then Requeue(qptr);
        end
      else begin
        QueueUpdate(qptr,action,'1^'+piece(ExtractFileExt(filename),'.',2)+' '+action+' copy complete^'+vwp);
        end;
      end  //FileExists
    else begin
      if pos('abstract',lowercase(filetype)) <> 0 then begin
        QueueAbstract(piece(input,'^',2));
        QueueUpdate(qptr,action,'-1^'+'No Jukebox sourcefile available / Attempting Abstract Queue^');
        QueueDelete(qptr);
        exit;
        end;
      QueueUpdate(qptr,action,'-1^'+'Jukebox sourcefile unavailable^');
      if not DirectoryExists(ExtractFileDrive(sourcepath)) then
        InvStrGrid(True,DateTimeToStr(Now)+'^JBTOHD'^'+ ExtractFileDrive(sourcepath) +
                ' Jukebox is currently offline. ',280,sgLatestTasks);
      if QSN < 2 then ReQueue(qptr);
      exit;
      end;
  end ; //if getqueue
end; //JBTOHD
//***** Abstract Processes**************************************************************

function TMAGBTMF1.Abstra: boolean;
// RESULT=STATUS^IMAGE PTR^FROM FILEPATH^ABSTRACT FILEPATH^QPTR^VWP^QSN^JBPATH

var
  action,input,abspath,sourcepath,jbpath,qptr,vwp,msg : string;
  QSN: integer;
begin
  result := false;
  action := 'ABSTRACT' ;
  if getqueue(action ,input) then begin
    inc(MagServerWriteCnt);
    GearErrorL := TStringList.Create;
    result := true;
    vwp := piece(input,'^',6); //Vista Write Pointer
    QSN := StrToInt(piece(input,'^',7)); //queue sequence number
    qptr :=  piece(input,'^',5);
    abspath := piece(input,'^',4);
    sourcepath := piece(input,'^',3);
    jbpath := piece(input,'^',8);
    if length(jbpath) <> 0 then
      if FileExists(jbpath+ExtractFileName(abspath)) then begin
        msg := 'An Abstract for this file is on the Jukebox, a JBTOHD is being queued';
        QueueUpdate(qptr,action,'-1^'+msg+'^');
        QueueJBTOHD('A',piece(input,'^',2));
        exit;
      end;
    if not AbstractOK(Piece(ExtractFileExt(sourcepath),'.',2)) then begin
      msg := 'Make AbstractError / Image File type: '+Piece(ExtractFileExt(sourcepath),'.',2)+
        ' is an Unsupported Format';
      QueueUpdate(qptr,action,'-1^'+msg+'^');
      exit;
      end;
    InvStrGrid(True,DateTimeToStr(Now) + '^' + action + ': ' + qptr + '^' +
      SourcePath + ' ' + abspath,280,sgLatestTasks);
    if FileExists(SourcePath) then begin
      if FileExists(abspath) then begin
        QueueUpdate(qptr,action,'2^Make AbstractError / abs is already present^'+ vwp);
        end
      else begin
        if not DirectoryExists(ExtractFilePath(abspath))
          then SysUtils.ForceDirectories(ExtractFilePath(abspath));
        if makeabs(abspath,sourcepath,qptr,msg) then
          QueueUpdate(qptr,action,'1^'+msg+'^'+vwp)
        else begin //not makeabs
          QueueUpdate(qptr,action,'-1^'+msg+'^'+vwp);
          if QSN < 2 then Requeue(qptr);
          end;
        end
      end
    else begin // not FileExists
      QueueUpdate(qptr,action,'-1^Make AbstractError / Source File not available^');
      if QSN < 2 then Requeue(qptr);
      end;
   GearErrorL.Free; // was commented out
    end; //getqueue
end; //Abstra
function TMAGBTMF1.MakeAbs(abspath,sourcepath,qptr:string;var msg:string): boolean;
var
  Format: String;
  JPG_CQ,IWL,ErrorFile,text,params :string;
  logfile: textfile;
  ExeProcessInfo: TProcessInformation;
  FileRec:TSearchRec;
begin
    iwl := 'HISTO'; //Image Window Level
    ErrorFile := ExtractFilePath(Application.ExeName)+'MagAbsError.txt';
    Format := 'JPG';
    JPG_CQ := '100';
    params := sourcepath+ ' '+ abspath +' '+ Format + ' '+ JPG_CQ+ ' '+IWL+' '+char(34)+ErrorFile+char(34);
    WinExecAndWait32('Mag_MakeAbs.exe '+params,0,ExeProcessInfo);
      //Check AbsError.txt
   if fileExists(ErrorFile) then begin
     AssignFile(logfile,ErrorFile);
     Reset(logfile);
     Readln(logfile,text);
     msg := piece(text,'^',2);
     if pos('0',piece(text,'^',1)) <> 0 then begin
       msg := ExtractFileName(abspath)+' '+ piece(text,'^',2);
       result := true;
       end
     else begin
       result := false;
       msg :='Make AbstractError / '+ piece(text,'^',2);
       end;
     CloseFile(logfile);
     end;
   if FindFirst(abspath,(faAnyFile),FileRec) = 0 then begin
     result := true;
     if FileRec.Size = 0 then begin
       DeleteFile(abspath);
       msg := 'File of size zero created then deleted';
       result := false;
       end;
     end
   else result := false;
   FindClose(FileRec);
end;  //MakeABS
//***** End Abstract Processes**************************************************************
function TMAGBTMF1.JukeBoxCacheSize(JBPath:string):boolean;
var
  JBCache: TMagFileServer;
  JBPTR: string;
begin
  result := false;
  if JBPath = '' then begin
    JBPTR := dmMain.GetVariable('$S($$JBPTR^MAGBAPI($$PLACE^MAGBAPI(+$G(DUZ(2))))>0:$$JBPTR^MAGBAPI($$PLACE^MAGBAPI(+$G(DUZ(2)))),1:0)');
    JBCache.Path := dmMain.GetVariable('$S($D(^MAG(2005.2,"'+JBPTR+'",0)):$P($G(^MAG(2005.2,"'+JBPTR+'",0)),U,2),1:0)');
    end
  else JBCache.Path := JBPath;
  if DiskFree32(JBCache) then begin
    if ((JBCache.Space/JBCache.Size)*100) > 5 then
      begin
        result := true;
        InvStrGrid(True,DateTimeToStr(Now)+'^JukeBoxCacheSize^'+' JBCache Percent Space Available: '+
        piece(FloatToStr(((JBCache.Space/JBCache.Size)*100)),'.',1)
        ,280,sgLatestTasks);
      end;
    JBCacheSize := (JBCache.Space div JBCache.Size)*100;
    end;
end;

function TMAGBTMF1.JBox: boolean;
   // RESULT=STATUS^IMAGE PTR^fullsourcepath^destpath^VOLUME NAME^
   // JUKEBOX DEVICE^QUEUE PTR^QueueSequenceNumber(QSN)^JukeBox Pointer^abspath^bigpath
   // checkroom-diskfree else makeroom
   // check destpath - donot overwrite
   // copyfile sourcepath and abs sourcepath
   // QueueStatus and/or Requeue

function Alt(FileType: TStringList;qptr,sourcepath,destpath:string;
                var Copied,NotCopied: TStringList):boolean;
var i: integer;
begin
  result := false;
  if FileType.count > 0 then
    for i := 0 to FileType.count - 1 do begin
      InvStrGrid(True,DateTimeToStr(Now) + '^JUKEBOX: '+ qptr + '^' +
        ChangeFileExt(sourcepath,'.'+FileType[i]) + ' ' +
        ChangeFileExt(destpath,'.'+FileType[i]),280,sgLatestTasks);
      if CopyFile(pchar(ChangeFileExt(sourcepath,'.'+FileType[i])),
        pchar(ChangeFileExt(destpath,'.'+FileType[i])),FailIfExist) then begin
          Copied.Add(FileType[i]);
          Result := true;
          end  // if CopyFile
      else InvStrGrid(True,DateTimeToStr(Now) + '^JUKEBOX: '+ qptr + '^' +
        FileType[i] + ' Not copied.',280,sgLatestTasks);
      end; //for
end;
procedure REQ(qptr,action: string; QSN:integer;var requeued:boolean);
begin
  if QSN < 2 then
    if not Requeued then
     begin
       ReQueue(qptr);
       Requeued := true;
      end;
end;
procedure VolSleep(volname,path:string);
  var
    interval: integer;
  begin
    interval := 0;
    InvStrGrid(True,DateTimeToStr(Now)+'^JBVolSleep^'+ path +
      ' Jukebox is currently offline. ',280,sgLatestTasks);
    while not DirectoryExists(path) do begin
      inc(interval);
      InvStrGrid(True,DateTimeToStr(Now)+'^JBVolSleep:'+IntToStr(interval)+'^'+ path +
        ' Jukebox is currently offline. ',280,sgLatestTasks);
      if interval mod 10000 = 0 then interval := 0;
      case interval of
        0..10: pause(30*(interval mod 10));
        else pause (300);
        end;
      end;
  end;

var // JBox function
  action,input,destpath,volname,jbdev,qptr,
      SFilename,CopyStatus,JBP,IMGPTR : string;
  AltDone,Requeued: boolean;
  AltFileTypeList,Copied,NotCopied: TStringlist;
  QSN,i: integer;
  full,big,abs,stat: string;
begin
  result := false;
  action := 'JUKEBOX' ;
  if getqueue(action ,input) then begin// sub if for while
    result := true;
    AltDone := false;
    Requeued := false;
    qptr := piece(input,'^',6);
    JBP := piece(input,'^',7);
//    if piece(input,'^',1)='2' then begin
//      QueueUpdate(qptr,action,'2^'+
//        piece(ExtractFileExt(piece(input,'^',3)),'.',2)+'^'+JBP);
//      exit;
//      end;
    IMGPTR := piece(input,'^',2);
    AltFileType(AltFileTypeList);
    CopyStatus := '';
    QSN := StrToInt(piece(input,'^',8));
    full := piece(input,'^',3);
    SFilename := ExtractFileName(piece(input,'^',4));
    destpath := ExtractFilePath(piece(input,'^',4));
    jbdev := piece(input,'^',5);
    big := piece(input,'^',10);
    abs := piece(input,'^',9);
    stat := '1'; //save queue record for further processing on success
    if not DirectoryExists(ExtractFilePath(destpath))
      then SysUtils.ForceDirectories(ExtractFilePath(destpath));
    if not (JBCacheSize > 5) then
      if not JukeBoxCacheSize(ExtractFileDrive(destpath)+'\') then begin
        result := false;
        if pos('Unable to copy to the Jukebox: Not enough write cache available',
          sgLatestTasks.Cells[2,1]) = 0 then
          InvStrGrid(True,DateTimeToStr(Now)+'^'+action+': '+qptr+'^'+'Unable to copy to the Jukebox: '+
          'Not enough write cache available',280,sgLatestTasks); //don't repeat display
        if QSN < 2 then ReQueue(qptr);
        exit;
        end; // if not JukeBoxCacheSize
    if DirectoryExists(ExtractFileDrive(destpath)+'\') then begin
      Copied := TStringList.Create;
      NotCopied := TStringList.Create;
      if full <> '' then
        if TryCopy(qptr,full,destpath+ExtractFileName(full),'Jukebox',QSN,Copied,NotCopied) then begin
          AltDone := Alt(AltFileTypeList,qptr,full,destpath+SFilename,Copied,NotCopied);
          PtrUpdate('MAGQ JPUD',JBP,piece(ExtractFileExt(full),'.',2),IMGPTR);
          end;
      if abs <> '' then
        if TryCopy(qptr,abs,destpath + ExtractFileName(ABS),
          'Jukebox',QSN,Copied,NotCopied) then PtrUpdate('MAGQ JPUD',JBP,'ABS',IMGPTR);
      if big <> '' then
        if TryCopy(qptr,big,destpath+ExtractFileName(big),'Jukebox',QSN,Copied,NotCopied)
          then begin
            if not AltDone then Alt(AltFileTypeList,qptr,big,destpath,Copied,NotCopied);
            PtrUpdate('MAGQ JPUD',JBP,'BIG',IMGPTR);
            end;
      if Copied.Count > 0 then begin
         for i := 0 to Copied.Count -1 do CopyStatus:=CopyStatus+Copied[i]+' ';
         CopyStatus := CopyStatus + 'copied.';
         end;
      if NotCopied.Count > 0 then begin
         for i := 0 to NotCopied.Count -1 do CopyStatus:=CopyStatus+NotCopied[i]+' ';
         CopyStatus := CopyStatus + 'NOT Copied.';
         Stat := '-1';
         end;
      QueueUpdate(qptr,'JUKEBOX',Stat+'^'+CopyStatus+u+JBP);
      if stat='-1' then REQ(qptr,action,QSN,Requeued);
      Copied.Free;
      NotCopied.Free;
      end
    else begin // Directory does not exist
      InvStrGrid(True,DateTimeToStr(Now)+'^'+action+': '+qptr+'^'+' Unable to copy to the Jukebox: '+
        IntToStr(GetLastError)+' '+SysErrorMessage(GetLastError),280,sgLatestTasks);
      QueueUpdate(qptr,action,'-1^'+CopyStatus+' Jukebox is not available: '+
      ExtractFileDrive(destpath)+' '+volname+' ^');
      VolSleep('',ExtractFileDrive(destpath)+'\');
      if QSN < 2 then ReQueue(qptr);
      end;
    AltFileTypeList.free;
  end; // if getqueue
end; //JBox

function TMAGBTMF1.PtrUpdate(RPC,Ptr,Ext,ien:string):boolean;
  var Complete: boolean;
  begin
    repeat
      Complete := true;
      result := false;
      dmMain.RPCBroker1.Param[0].VALUE := Ptr;
      dmMain.RPCBroker1.Param[0].PTYPE := LITERAL;
      dmMain.RPCBroker1.Param[1].VALUE := Ext;
      dmMain.RPCBroker1.Param[1].PTYPE := LITERAL;
      dmMain.RPCBroker1.Param[2].VALUE := IEN;
      dmMain.RPCBroker1.Param[2].PTYPE := LITERAL;
      dmMain.RPCBroker1.RemoteProcedure := RPC;
      try
        dmMain.RPCBroker1.Call;
      except
        on E:Exception do begin
          InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^PtrUpdate: '+RPC,280,sgLatestTasks);
          OnException(E);
          Complete:= false;
          end; // on E:Exception
      end; //try...except
    until Complete;
    result := (pos('1',dmMain.RPCBroker1.Results[0]) <> 0);
end;  // PtrUpdate(Ptr,Ext,ien:string):boolean;
function TMAGBTMF1.QueueJBTOHD(ImageType,ien:string):boolean;
  var Complete: boolean;
  begin
    repeat
      Complete := true;
      result := false;
      dmMain.RPCBroker1.Param[0].VALUE := ImageType;
      dmMain.RPCBroker1.Param[0].PTYPE := LITERAL;
      dmMain.RPCBroker1.Param[1].VALUE := IEN;
      dmMain.RPCBroker1.Param[1].PTYPE := LITERAL;
      dmMain.RPCBroker1.RemoteProcedure := 'MAGG QUE IMAGE';
      try
        dmMain.RPCBroker1.Call;
      except
        on E:Exception do begin
          InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^MAGG QUE IMAGE',280,sgLatestTasks);
          OnException(E);
          Complete := false;
          end; // on E:Exception
        end; //try...except
    until Complete;
    result := (pos('1',dmMain.RPCBroker1.Results[0]) <> 0);
end;  // QueueJBTOHD(ImageType,ien:string):boolean;

function TMAGBTMF1.QueueAbstract(ien:string):boolean;
  var Complete: boolean;
  begin
    repeat
      Complete := true;
      result := false;
      dmMain.RPCBroker1.Param[0].VALUE := IEN+'^';
      dmMain.RPCBroker1.Param[0].PTYPE := LITERAL;
      dmMain.RPCBroker1.RemoteProcedure := 'MAG ABSJB';
      try
        dmMain.RPCBroker1.Call;
      except
        on E:Exception do begin
          InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^MAG ABSJB',280,sgLatestTasks);
          OnException(E);
          Complete:= false;
          end; // on E:Exception
      end; //try...except
      until complete;
      result := (pos('1',dmMain.RPCBroker1.Results[0]) <> 0);
end;  // QueueAbstract(ien:string):boolean;


function TMAGBTMF1.FDELETE: boolean;
// RESULT=STATUS^FILE^QPTR^QueueSequenceNumber^JukeBoxPath^Image IEN^Jukebox Ptr
var
  action,input,deletepath,JukeBoxPath,CurrentJukeBox,CJBPath,qptr : string;
  QSN,Attrs: integer;
  Copied,NotCopied: TStringlist;
  LastErrorMessage, EMessage: String;
  LastError: integer;
  //  FailIfExist: boolean;
begin
  action := 'DELETE' ;
  result := false;
  if not getqueue(action ,input) then exit
  else begin
    result := true;
    qptr :=  piece(input,'^',3);
    QSN := StrToInt(piece(input,'^',4));
    deletepath := piece(input,'^',2);
    JukeBoxPath := piece(input,'^',5)+ExtractFileName(piece(input,'^',2));
    CurrentJukeBox := piece(input,'^',8);
    CJBPath := piece(input,'^',9)+ExtractFileName(piece(input,'^',2));
    if not FileExists(deletepath) then begin
      Emessage := 'The Vista cache file: '+deletepath+' not found';
      result := false;
      QueueUpdate(qptr,action,'1^'+EMessage+'^');
      exit;
      end;
    if not FileExists(JukeboxPath) then begin
      InvStrGrid(True,DateTimeToStr(Now)+'^'+Action+': '+qptr+'^The jukebox copy: '+
               JukeboxPath+ ' does not exist -- attempting a copy...',280,sgLatestTasks);
      if not DirectoryExists(ExtractFilePath(CJBPath))
        then if not SysUtils.ForceDirectories(ExtractFilePath(CJBPath)) then begin
            LastError:= GetLastError;
            LastErrorMessage := SysErrorMessage(LastError);
            EMessage := 'ForceDirectories failed: ' +IntToStr(LastError)+': '+ LastErrorMessage;
            QueueUpdate(qptr,action,'-1^'+EMessage+'^');
            result := false;
            if QSN < 2 then ReQueue(qptr);
            exit;
            end;
      InvStrGrid(True,DateTimeToStr(Now) + '^' + action+': '+qptr + '^' +
        deletepath +' is being copied to: '+ CJBPath,280,sgLatestTasks);
      Copied := TStringList.Create;
      NotCopied := TStringList.Create;
      if not TryCopy(qptr,deletepath,CJBPath,action,QSN,Copied,NotCopied) then begin
        Copied.Free;
        NotCopied.Free;
        QueueUpdate(qptr,action,'-1^Could not complete/Requeued^');
        result := false;
        if QSN < 2 then ReQueue(qptr);
        exit;
        end;
      PtrUpdate('MAGQ JPUD',CurrentJukeBox,piece(ExtractFileExt(deletepath),'.',2),piece(input,'^',6));
      InvStrGrid(True,DateTimeToStr(Now) + '^' + action+': '+qptr + '^' +
      ExtractFileName(CJBPath)+' copied to archived successfully.',280,sgLatestTasks);
      Copied.Free;
      NotCopied.Free;
      end; // if not FileExists(JukeboxPath)
    InvStrGrid(True,DateTimeToStr(Now) + '^' + action+': '+qptr + '^' +
      deletepath,280,sgLatestTasks);
    if DeleteFile(pchar(deletepath)) then QueueUpdate(qptr,action,'1^Delete complete^')
    else begin
      Attrs := FileGetAttr(deletepath);
      if Attrs and faReadOnly <> 0 then begin
        FileSetAttr(deletepath, Attrs - faReadOnly);
        if not DeleteFile(pchar(deletepath)) then begin
          result:= false;
          QueueUpdate(qptr,action,'-1^Could not complete^');
          if QSN < 2 then ReQueue(qptr);
          exit;
          end  // if not DeleteFile(pchar(deletepath))
        else QueueUpdate(qptr,action,'1^Delete complete/override ReadOnly^');
        end // if Attrs and faReadOnly <> 0
      else begin
        QueueUpdate(qptr,action,'-1^Could not complete '+
          IntToStr(GetLastError)+ ': '+SysErrorMessage(GetLastError)+'^');
        result:= false;
        if QSN < 2 then ReQueue(qptr);
        end;
     end;
  end;
end; //FDelete

function TMAGBTMF1.QueueUpdate(qptr,Process,QueueStatus : string ): boolean;
var complete: boolean;
begin
  repeat
    complete := true;
    result:= false;
    dmMain.RPCBroker1.Param[0].VALUE := qptr;
    dmMain.RPCBroker1.Param[0].PTYPE := LITERAL ;
    dmMain.RPCBroker1.Param[1].VALUE := QueueStatus;
    dmMain.RPCBroker1.Param[1].PTYPE := LITERAL ;
    dmMain.RPCBroker1.RemoteProcedure := 'MAGQ QUD';
    InvStrGrid(True,DateTimeToStr(Now) + '^'+Process+':' + qptr + '^' +
      piece(QueueStatus,'^',2),280,sgLatestTasks);
    try
      dmMain.RPCBroker1.Call;
     except
       on E:Exception do begin
         InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^QueueUpdate',280,sgLatestTasks);
         OnException(E);
         Complete := false;
         end; // on E:Exception
     end; //try...except
  until complete;
  result:= true;
end; // QueueUpdate

procedure TMAGBTMF1.FormClose(Sender: TObject; var Action: TCloseAction);
///XXX.free; free any memory resident resources
var
  I: Integer;
  F: TForm;
begin
  //Reboot;
  for I := 0 to Application.ComponentCount - 1 do
  begin
    if Application.Components[I] is TForm then
    begin
      F := TForm(Application.Components[I]);
      if (F <> Self) and (F.Visible) then F.Close;
    end;
  end;
end;//FormClose
procedure TMAGBTMF1.Reboot;
var
 Flags : Integer;
begin
 If MessageDlg('Reboot: Are you sure?',mtInformation, mbOkCancel, 0) = mrOk
 Then
 Begin
  Flags := EWX_FORCE OR EWX_REBOOT;
  ExitWindowsEx(Flags, 0);
 End;
end;

function TMAGBTMF1.GetFileSysName(Drive : Byte) : String;
var
 DriveLetter  : Char;
 NoMatter     : DWord;
 FileSysName  : Array[0..MAX_PATH] of Char;
begin
 DriveLetter  := Char(Drive + $41);
 GetVolumeInformation(PChar(DriveLetter + ':\'), Nil,
                      0,nil,NoMatter, NoMatter, FileSysName,
                      SizeOf(FileSysName));
 Result := FileSysName;
end;
procedure TMAGBTMF1.ServerSize(Group:string);
function Getlist(Group:string;var ServerList:TStringList): Boolean;
var Complete: boolean;
begin
  repeat
    Complete := true;
    result := false;
    dmMain.RPCBroker1.RemoteProcedure := 'MAGQ ALL SERVER';
    dmMain.RPCBroker1.Param[0].VALUE :=Group;
    dmMain.RPCBroker1.Param[0].PTYPE := LITERAL ;
    try
      dmMain.RPCBroker1.LSTCALL(ServerList);
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^ MAGQ ALL SERVER',280,sgLatestTasks);
        OnException(E);
        Complete := false;
        end; // on E:Exception
      end; //try...except
  until Complete;
  if ServerList.count > 0 then result:= true
  else result:= false;
end; //ServerSize.Getlist

procedure RAIDGroupSpace(ien:string;var FreeSpace,TotalSpace:string);
function ExtractInt(Segment:string):integer;
var
  code: integer;
begin
  Val(Segment,Result,Code);
  if (code <> 0) then result := 0;
end;

var i: integer;
    FreeS,TotalS: Integer;
    RGLister: TFMLister ;
    Complete: boolean;
begin
  repeat
    Complete := true;
    FreeS:=0;
    TotalS:=0;
    RGLister := TFMLister.Create(application);
    RGLister.RPCBroker := dmMain.RPCBroker1;
    RGLister.FileNumber := '2005.22';
    RGLister.ListerFlags := [lfInternal];
    RGLister.Screen :='I $P($G(^MAG(2005.2,$P(^(0),U,1),0)),U,6,7)="1^MAG"'; //Only count if on-line
    RGLister.iens :=','+ien+',';
    try
      RGLister.GetList(nil);
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^RGLister',280,sgLatestTasks);
        OnException(E);
        Complete := false;
        RGLister.Free;
        end; // on E:Exception
    end; // try...except
  until Complete;
  for i := 0 to RGLister.Results.Count - 1 do begin
      FreeS := FreeS + ExtractInt(dmMain.GetFieldValue('2005.2','4',dmMain.GetFieldValue('2005.22','.01',RGLister.Results[i]+','+ien+',','I',true)+',','E',true));
      TotalS := TotalS + ExtractInt(dmMain.GetFieldValue('2005.2','2',dmMain.GetFieldValue('2005.22','.01',RGLister.Results[i]+','+ien+',','I',true)+',','E',true));
      end; // for i := 0
  FreeSpace := IntToStr(FreeS);
  TotalSpace := IntToStr(TotalS);
  // Update Group
  dmMain.FMUpdate('2005.2','4',ien+',',FreeSpace);
  dmMain.FMUpdate('2005.2','2',ien+',',TotalSpace);
  RGLister.Free;
end;
function FileServerUpdate(ServerList: TStringList):boolean;
  var
    i: integer;
    Complete: boolean;
  begin
      FileServerUpdate:= false;
      for i := 0 to ServerList.count - 1 do begin
        repeat
          Complete := true;
          dmMain.RPCBroker1.Param[0].VALUE := piece(ServerList.strings[i],'^',2);
          dmMain.RPCBroker1.Param[0].PTYPE := LITERAL ;
          dmMain.RPCBroker1.Param[1].VALUE := piece(ServerList.strings[i],'^',3);
          dmMain.RPCBroker1.Param[1].PTYPE := LITERAL ;
          dmMain.RPCBroker1.Param[2].VALUE := piece(ServerList.strings[i],'^',4);
          dmMain.RPCBroker1.Param[2].PTYPE := LITERAL ;
          dmMain.RPCBroker1.RemoteProcedure := 'MAGQ FS UPDATE';
        try
          dmMain.RPCBroker1.Call;
        except
          on E:Exception do begin
            InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^MAGQ FS UPDATE',280,sgLatestTasks);
            OnException(E);
            Complete := false;
            end; // on E:Exception
        end; //try...except
      until Complete;
    end; // for i := 0 to ServerList.count - 1
  FileServerUpdate:= true;
end; //ServerSize.FileServerUpdate
// ServerSize
//  This method gets a list of Vista Imaging active RAID shares.
//  The size and space available is then checked.
//  The Vista Imaging Network Location File (#2005.2) is then updated.
// This function graphically displays the current Vista Imaging storage resources
// The output of this method is displayed in both the Vista Storage table (sgServer: TStringGrid)
// and the Vista Storage graphic (frmMagPurge2: Charts 1, 2, 3)

var
  ServerList: TStringList;
  Server: TMagFileServer;
  h,i: integer;
  temp,FSpace,TSpace: string;
  Complete : boolean;
begin  // ServerSize
  JukeBoxCacheSize('');
  MagServerWriteCnt := 1;
  LastServerUpdate:= Now;
  ServerList := TStringList.Create;
  GetList(Group,ServerList);   // rpc: 'MAGQ ALL SERVER'
//Server List : PHYSICAL REFERENCE^CWL or ien^TOTAL SPACE^FREE SPACE^NAME^GROUP^TYPE
  if ServerList.count > 0 then begin
    pnllblresource.Caption := 'Server Resources:  ' + piece(ServerList.strings[0],'^',1);
    for h := sgServer.RowCount -1 downto 1 do
      sgServer.Rows[h].Clear;
    end;
  for h := 0 to ServerList.count - 1 do begin  //get Size and space for all shares and update sgServer
    Server.Path := piece(ServerList.strings[h],'^',1);
    if Server.Path[length(Server.Path)] <> '\' then
      Server.Path := Server.Path +'\';
    if Diskfree32(Server) then begin
      ServerList.strings[h] := piece(ServerList.strings[h],'^',1)+'^'+
        piece(ServerList.strings[h],'^',2)+'^'+IntToStr(Server.Size)+
        '^'+IntToStr(Server.Space)+'^'+piece(ServerList.strings[h],'^',5)+'^'+
         piece(ServerList.strings[h],'^',6)+'^'+piece(ServerList.strings[h],'^',7);
      end
    else ServerList.strings[h] := piece(ServerList.strings[h],'^',1)+'^'+piece(ServerList.strings[h],'^',2)+
         '^^'+piece(ServerList.strings[h],'^',4)+'^'+piece(ServerList.strings[h],'^',5)+'^'+
          piece(ServerList.strings[h],'^',6)+'^'+piece(ServerList.strings[h],'^',7);
    InvStrGrid(False,piece(ServerList.strings[h],'^',5)+ '^'+piece(ServerList.strings[h],'^',7)+ '^'+
      piece(ServerList.strings[h],'^',2)+ '^'+piece(ServerList.strings[h],'^',4)+ '^'+piece(ServerList.strings[h],'^',3)+ '^'+
      piece(ServerList.strings[h],'^',1)+ '^'+piece(ServerList.strings[h],'^',6),25,sgServer);
    end; // get Size and space for all shares and update sgServer
  FileServerUpdate(ServerList); //update Network Location file with size and space rpc: 'MAGQ FS UPDATE'
  //next...the graphing of RAID
  if mnuServerSize.checked then
    if ServerList.count > 0 then frmMagPurge2.GraphDisplay(ServerList,3,frmMagPurge2.chtRAIDShares);
  // now...get list, size and space for Jukebox cache
    ServerList.Clear;
   repeat
     Complete := true;
     dmMain.fmlNetLoc.Results.Clear;
     dmMain.fmlNetLoc.RPCBroker := dmMain.RPCBroker1;
     dmMain.fmlNetLoc.Screen := 'I ($P(^(0),U,7)["WORM"),$P(^(0),U,6)="1",$P(^(0),U,10)=' +IntToStr(magbtm1.place);
     try
       dmMain.fmlNetLoc.GetList(nil);
     except
       on E:Exception do begin
          InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^fmlNetLoc.GetList',280,sgLatestTasks);
          OnException(E);
          Complete := false;
          end; // on E:Exception
     end; //try...except
   until Complete;
   for i := 0 to dmMain.fmlNetLoc.Results.Count - 1 do begin
      temp :='';
      Server.Path := dmMain.GetFieldValue('2005.2','1',dmMain.fmlNetLoc.Results[i]+',','E',true);
      if Server.Path[length(Server.Path)] <> '\' then Server.Path := Server.Path +'\';
      temp := Server.Path;
      temp := temp +'^'+ dmMain.fmlNetLoc.Results[i];
      if Diskfree32(Server) then temp := temp+'^'+IntToStr(Server.Size)+'^'+IntToStr(Server.Space)
      else temp := temp+'^0^0';
      temp := temp +'^'+ dmMain.GetFieldValue('2005.2','.01',dmMain.fmlNetLoc.Results[i]+',','E',true);
      temp := temp +'^^'+ dmMain.GetFieldValue('2005.2','6',dmMain.fmlNetLoc.Results[i]+',','I',true);
      ServerList.Add(temp);
    InvStrGrid(False,piece(temp,'^',5)+ '^'+piece(temp,'^',7)+ '^'+
      piece(temp,'^',2)+ '^'+piece(temp,'^',4)+ '^'+piece(temp,'^',3)+ '^'+
      piece(temp,'^',1)+ '^'+piece(temp,'^',6),25,sgServer);
    FileServerUpdate(ServerList);  // update 2005.2
    end;
  // now...the graphing of the Jukebox cache
    if mnuServerSize.checked then
      if ServerList.count > 0 then frmMagPurge2.GraphDisplay(ServerList,3,frmMagPurge2.chtJukeboxShares);
    // now...get list, size and space for RAID groups then graph
    ServerList.Clear;
    repeat
      Complete := true;
      dmMain.fmlNetLoc.Results.Clear;
      dmMain.fmlNetLoc.RPCBroker := dmMain.RPCBroker1;
      dmMain.fmlNetLoc.Screen := 'I ($P(^(0),U,7)["GRP"),$P($G(^(1)),U,6)'+char(39)+'="1",$P(^(0),U,10)=' +IntToStr(magbtm1.place);
      try
        dmMain.fmlNetLoc.GetList(nil);
      except
        on E:Exception do begin
          InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^fmlNetLoc.GetList',280,sgLatestTasks);
          OnException(E);
          Complete := false;
          end; // on E:Exception
      end; //try...except
    until Complete;
// this method requires A GROUP UPDATE - HERE - LOOP THROUGH THE GROUP MEMBERS MULTIPLE AND add THE MEMBER SPACE
    for i := 0 to dmMain.fmlNetLoc.Results.Count - 1 do begin
      temp :='';
      temp := 'N/A';//dmMain.GetFieldValue('2005.2','1',dmMain.fmlNetLoc.Results[i]+',','E',true);
      temp := temp +'^'+ dmMain.fmlNetLoc.Results[i];
      RAIDGroupSpace(dmMain.fmlNetLoc.Results[i],TSpace,FSpace);
      temp := temp +'^'+ FSpace;
      temp := temp +'^'+ TSpace;
      temp := temp +'^'+ dmMain.GetFieldValue('2005.2','.01',dmMain.fmlNetLoc.Results[i]+',','E',true);
      temp := temp +'^'; // There are no Worm groups at this time
      temp := temp +'^'+ dmMain.GetFieldValue('2005.2','6',dmMain.fmlNetLoc.Results[i]+',','I',true);
      ServerList.Add(temp);
      end; // for i...
      for h := 0 to ServerList.count - 1 do begin
      InvStrGrid(False,piece(ServerList.strings[h],'^',5)+ '^'+
        piece(ServerList.strings[h],'^',7)+ '^'+piece(ServerList.strings[h],'^',2)+ '^'+
        piece(ServerList.strings[h],'^',4)+ '^'+piece(ServerList.strings[h],'^',3)+ '^'+
        piece(ServerList.strings[h],'^',1)+ '^'+piece(ServerList.strings[h],'^',6),25,sgServer);
        end; // for h...
    if mnuServerSize.checked then
      if ServerList.count > 0 then frmMagPurge2.GraphDisplay(ServerList,3,frmMagPurge2.chtRAIDGroups);
    ServerList.free;

  application.processmessages;
end; //ServerSize

procedure TMAGBTMF1.InitSGLatestTasks;
begin
  with sgLatestTasks do
    begin
      ColCount := 3;
      ColWidths[0]:= sgLatestTasks.Width div 6;
      ColWidths[1]:= sgLatestTasks.Width div 6;
      ColWidths[2]:= (sgLatestTasks.Width div 6)*4;
      cells[0,0]:='Event Time';
      cells[1,0]:='Process: Queue IEN';
      cells[2,0]:='Process Status';
    end;
end; //InitSGLatestTasks

procedure TMAGBTMF1.InitSGServer;
  begin
    with sgServer do
      begin
        colcount := 7;
        ColWidths[0]:= (sgServer.width div 40)*8;
        ColWidths[1]:= (sgServer.width div 40)*8;
        ColWidths[2]:= (sgServer.width div 40)*5;  //SgServer.colcount;
        ColWidths[3]:= (sgServer.width div 40)*5;
        ColWidths[4]:= (sgServer.width div 40)*4;
        ColWidths[5]:= (sgServer.width div 40)*14;  // SgServer.colcount;
        ColWidths[6]:= (sgServer.width div 40)*8;
        cells[0,0]:='Network Location Name';
        cells[1,0]:='Storage Type';
        cells[2,0]:='IEN';
        cells[3,0]:='Free Space';
        cells[4,0]:='Disk Size';
        cells[5,0]:='Share Path';
        cells[6,0]:='RAID Group';
        Update;
     end;
 end;

procedure TMAGBTMF1.sbtnStartClick(Sender: TObject);
begin
  try
    LogProc;
  except
    InvStrGrid(True,DateTimeToStr(Now)+'^Initialization Failure^Log Files at:'+LogFilePath+' '+
      SysErrorMessage(GetLastError),280,sgLatestTasks);
    exit;
    end; // try...except
  InitLogFile('log\BackProc\BPError.LOG','BP_Error_Log',true,BPErrorLogSize);
  ErrorLogDate := FileCreationDate(ExtractFilePath(Application.ExeName)+'log\BackProc\BPError.LOG');
  ErrorLogInit := true;
  ProcCycleOn := true;
  sbtnStop.Enabled := true;
  sbtnStart.Enabled := false;
  sbtnStart.Default := false;
  sbtnStop.Default := true;
  mnuFile.Enabled := false;
  mnuEdit.Enabled := False;
  mnuJHRPT.Enabled := False;
  mnuHelp.Enabled := False;
  RaidVerify(self);
  UpdateBPServerActivity(DistDate,AppVer,OSVer);
  Application.ProcessMessages;
  JBCacheSize := 0;
end; //sbtnStartClick

procedure TMAGBTMF1.sbtnStopClick(Sender: TObject);
begin
  ProcCycleOn := false;
  sbtnStop.Enabled := false;
  sbtnStop.Default := false;
  sbtnStart.Enabled := true;
  sbtnStart.Default := true;
  mnuFile.Enabled := true;
  mnuEdit.Enabled := true;
  mnuJHRPT.Enabled := true;
  mnuHelp.Enabled := true;
  InvStrGrid(True,DateTimeToStr(Now)+'^STOPPED^'+
   ' Background Processor stop button depressed.',280,sgLatestTasks);
  Application.ProcessMessages;
end;

procedure TMAGBTMF1.FormKeyPress(Sender: TObject; var Key: Char);
var
  GridRowIndex,GridColIndex: integer;
begin
  if Key = #13 then
    if not (ActiveControl is TStringGrid) then
      begin
        SelectNext(ActiveControl,True,True);
        Key := #0;
      end
    else
      with (Sender as TStringGrid ) do
        begin
          GridColIndex := Col;
          GridRowIndex := Row;
          if GridColIndex = ColCount - 1 then
            begin
              if GridRowIndex < RowCount - 1 then
                begin
                  inc(GridRowIndex);
                  Row := GridRowIndex;
                  Col := FixedCols;
                end;
            end
          else
             begin
               inc(GridColIndex);
               Col := GridColIndex;
             end;
        end;
end;

procedure TMAGBTMF1.sgLatestTasksEnter(Sender: TObject);
begin
  with (Sender as TWinControl) do
    if (Parent is TPanel) then
      with (Parent as TPanel) do
        begin
          Color := clAqua;
          BevelOuter := bvLowered;
        end;
end;

procedure TMAGBTMF1.sgLatestTasksExit(Sender: TObject);
begin
  with (Sender as TWinControl) do

      with (Parent as TPanel) do
        begin
          Color := clBtnFace;
          BevelOuter := bvRaised;
        end;
end;
function TMAGBTMF1.ResetCurrentServer(notify: string): string;
var
  i : Integer;
  RAIDShares: TStringList;
  ResultString: string;
  Complete: boolean;
begin
  repeat
    Complete:= true;
    result:= '0';
    FreeSpace := '0.00' ;
    SReserve := dmMain.GetFieldValue('2006.1','11',IntToStr(place)+',','E',false);
    dmMain.RPCBroker1.RemoteProcedure:= 'MAGQ FS CHNGE';
    dmMain.RPCBroker1.Param[0].VALUE := notify ;
    dmMain.RPCBroker1.Param[0].PTYPE := LITERAL ;
    dmMain.RPCBroker1.Param[1].VALUE := OSVer ;
    dmMain.RPCBroker1.Param[1].PTYPE := LITERAL ;
    dmMain.RPCBroker1.Param[2].VALUE := CompName;
    dmMain.RPCBroker1.Param[2].PTYPE := LITERAL ;
    try
      dmMain.RPCBroker1.Call;
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^ResetCurrentServer',280,sgLatestTasks);
        OnException(E);
        Complete := false;
        end; // on E:Exception
    end; //try...except
  until Complete;
    // ; RESULT VALUES:0=BELOW RESERVE,1=ABOVE RESERVE*PURGE FACTOR,2=BETWEEN RESERVE AND RESERVE*PURGE FACTOR
// ; ^CWL-PHYSICAL REFERENCE^CWL-TOTAL SPACE^PURGE^%RESERVE^PURGE_GROUP_IEN^VERIFY
  ResultString := UpperCase(dmMain.RPCBroker1.Results[0]);
  InvStrGrid(True,DateTimeToStr(Now)+'^ResetCurrentServer^'+StringReplace(ResultString,'^',' ',[rfReplaceAll]),
    280,sgLatestTasks);
  result := piece(ResultString,'^',1);
  FreeSpace := piece(ResultString,'^',5);
 // The following is the method of internally managing Automated Verifier activity
 // 62.1 and 62.5 (Last Verifier BP Server) are updated at the start of the Verifier Process
 // 62.3 is updated at the end of the automated BP Verifier run
// 62.1 (DATE OF LAST VERIFY) <> 62.3 (DATE OF SCHEDULED VERIFIER)
  if VerifierActive then //No other Verifier Active update
   if (NumericSegment(dmMain.GetFieldValue('2006.1','62.1',IntToStr(magbtm1.place)+',','I',true)) <>
      NumericSegment(dmMain.GetFieldValue('2006.1','62.3',IntToStr(magbtm1.place)+',','I',true)))
       then VerifierActive := false;
  if PurgeActive then //No other Purge Active update
   if (NumericSegment(dmMain.GetFieldValue('2006.1','61.1',IntToStr(magbtm1.place)+',','I',true)) <>
      NumericSegment(dmMain.GetFieldValue('2006.1','61.3',IntToStr(magbtm1.place)+',','I',true)))
       then PurgeActive := false;
  if pos('AUTO_PURGE',piece(ResultString,'^',4)) <> 0 then
    AutoPurge(self,piece(ResultString,'^',6));
  if pos('SCHEDULED_PURGE',piece(ResultString,'^',4)) <> 0 then
    ScheduledPurge(self,piece(piece(ResultString,'^',4),'~',2),piece(ResultString,'^',6));
  if pos('VERIFY',piece(ResultString,'^',7)) <> 0 then begin
    AutoVerify(self,piece(piece(ResultString,'^',7),'~',2));
    end;
  if pos('RGADVANCE',piece(ResultString,'^',8)) <> 0 then begin
    if pos('SCHEDULED',piece(ResultString,'^',8)) <> 0 then
      InvStrGrid(True,DateTimeToStr(Now)+'^RGADVANCE^The BP Queue executed a scheduled RAID Group Advance',280,sgLatestTasks);
    if pos('AUTOMATIC',piece(ResultString,'^',8)) <> 0 then
      InvStrGrid(True,DateTimeToStr(Now)+'^RGADVANCE^The BP Queue executed an automatic RAID Group Advance',280,sgLatestTasks);
    RaidShares := TStringList.Create;
    CurrentRAIDShares(RAIDShares);
    if RAIDShares.Count > 0 then
      for i := 0 to RAIDShares.Count - 1 do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RGADVANCE^'+RAIDShares[i],280,sgLatestTasks);
        end;
    RaidShares.Free;
    end; // if pos('RGADVANCE'
end;
procedure TMAGBTMF1.CurrentRAIDShares(var RAIDShares: TStringList);
var
  CRSLister: TFMLister;
  Group: string;
  Complete: boolean;
begin
  Group := dmMain.GetFieldValue('2006.1','.031',IntToStr(magbtm1.place)+',','I',true);
  if Length(group)=0 then begin
    InvStrGrid(True,DateTimeToStr(Now)+'^Current RAID Shares^Exception: No RAID group Assigned',280,sgLatestTasks);
    sbtnStopClick(nil);
    exit;
  end;
  repeat
    Complete := true;
    CRSLister := TFMLister.Create(application);
    CRSLister.RPCBroker := dmMain.RPCBroker1;
    CRSLister.FileNumber := '2005.2';
    CRSLister.ListerFlags := [lfInternal];
    CRSLister.Screen :='I ($P($G(^MAG(2005.2,Y,0)),U,6,7)="1^MAG"),'+
     '$P($G(^MAG(2005.2,Y,0)),U,10)='+IntToStr(magbtm1.place)+',$P($G(^MAG(2005.2,Y,1)),U,8)='+Group ;
    try
      CRSLister.GetList(RAIDShares);
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^CurrentRAIDShares',280,sgLatestTasks);
        OnException(E);
        Complete := false;
        end; // on E:Exception
    end; //try...except
  until Complete;
end; // CurrentRAIDShares
function TMAGBTMF1.DiskFree32(var FileServer: TMagFileServer): Boolean;
function spcopy(input:string): LPSTR;
var size:integer;
begin
  size:=length(input);
  result:=stralloc(size+1);
  strpcopy(result,input);
end;//DiskFree.spcopy

var
  GetDiskfreeSpaceEx: Function(lpDirectoryName: string;
                    var lpFreeBytesAvailableToCaller,
                      lpTotalNumberOfBytes,
                      lpTotalNumberOfFreeBytes: Int64): Bool; STDCALL;
//                    lpTotalNumberOfFreeBytes: TLargeInteger): Bool; STDCALL;
  ServerPath:string;
  hlib: THandle;
 // FreeBAU,TotNumBytes,TotNumFree: TLargeInteger;
   FreeBAU,TotNumBytes,TotNumFree: Int64;
const megabyte = 1000000;
begin
  hlib := GetModuleHandle('kernel32');
  if hlib <> 0 then
    begin
      GetDiskFreeSpaceEx := GetProcAddress(hlib, 'GetDiskFreeSpaceExA');
      ServerPath := FileServer.Path;
      result := GetDiskFreeSpaceEx(ServerPath,FreeBAU,TotNumBytes,TotNumFree);
      with FileServer do begin
        size := TotNumBytes div megabyte;
        space := TotNumFree div megabyte;
        used :=  (TotNumBytes - TotNumFree) div megabyte;
        end;
    end
  else result:= false;
//  GetDiskFreeSpaceEx := nil;
  if not FreeLibrary(hlib) then
    Windows.MessageBox(MAGBTMF1.Handle,PChar('not FreeLibrary:'+IntToStr(GetLastError)),' ',MB_SYSTEMMODAL);
end;

procedure TMAGBTMF1.AltFileType(var AltFileTypeList:TStringList);
var Complete: boolean;
begin
  repeat
    Complete:= true;
    AltFileTypeList := TStringList.Create;
    dmMain.RPCBroker1.RemoteProcedure := 'MAGQ FTYPE';
    try
      dmMain.RPCBroker1.LSTCALL(AltFileTypeList);
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^MAGQ FTYPE',280,sgLatestTasks);
        OnException(E);
        Complete:= false;
        AltFileTypeList.Free;
      end; // on E:Exception
    end; //try...except
  until Complete;
end;

function TMAGBTMF1.CheckVolNameNT(volname,volpath: string): boolean;
function GetVolumeName(path :string ) : String;
var
  NoMatter     : DWord;
  VolumeName   : Array[0..MAX_PATH] of Char;
begin
  if GetVolumeInformation(PChar(path), VolumeName,
   SizeOf(VolumeName),nil,NoMatter, NoMatter, Nil,0)
   then Result := VolumeName
  else  Result :='';
end;
begin
  if LowerCase(volname)= LowerCase(GetVolumeName(volpath)) then result := true
  else result := false;
end;

procedure TMAGBTMF1.InvStrGrid(Log:boolean; input: string; RMax: Integer; var Grid: TStringGrid);
var
i,k :integer;
logfile: textfile;
const delimit: string = '^';

begin
  with Grid do begin
    ColCount := LastPiecePos(input,delimit); //truncate last column
    if RowCount < Rmax + 1 then RowCount := RowCount + 1;
    for i :=  RowCount downto FixedRows + 1 do
      for k := ColCount downto FixedCols do cells[k,i] := cells[k,i-1];
      for i := ColCount - 1 downto FixedCols do
        cells[i,FixedRows] := piece(input,delimit,((i+1)-FixedCols));
      Update;
    end;
    if (Log and Logon) then begin
      logCnt := logCnt + 1;
      AssignFile(logfile,ExtractFilePath(Application.ExeName)+'log\BackProc\BackProc.LOG');
      Append(logfile);
      Writeln(logfile,input);
      Flush(logfile);
      CloseFile(logfile);
      BackProcLogSize := BackProcLogSize + Length(input);
      if BackProcLogSize > logSizeV then begin
        // if BPErrorLogSize = 0 then write to the log file that there are no Errors to this time HERE!
        try
          logproc;
        except
           InvStrGrid(True,DateTimeToStr(Now)+'^Initialization Failure^Log Files at:'+LogFilePath+' '+
             SysErrorMessage(GetLastError),280,sgLatestTasks);
           exit;
           end; //try...except
        end;  //if BackProcLogSize > logSizeV
      end; // if (Log and Logon)
end; // InvStrGrid


procedure TMAGBTMF1.mnuContentsClick(Sender: TObject);
begin
  Application.CreateForm(TfrmMagBPHelp,frmMagBPHelp);
  frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+
    'help\MAG_BP_User_Manual.htm#_Toc315344900');

end;


procedure TMAGBTMF1.mnuAboutClick(Sender: TObject);
var about : TTelaboutf  ;
begin
  about := TTelaboutf.create(self);
  try
    about.showmodal;
  finally
    about.free;
    sbtnStart.SetFocus;
  end;
end;

procedure TMAGBTMF1.mnuServerSizeClick(Sender: TObject);
  begin
    if mnuServerSize.Checked then begin
      frmMagPurge2.Close;
      mnuServerSize.checked := false;
      end
    else begin
      mnuServerSize.checked := true;
      Application.CreateForm(TfrmMagPurge2,frmMagPurge2);
      end;
  end;

procedure TMAGBTMF1.JBSleep(path:string);
  var
    interval: integer;
  begin
    interval := 0;
    InvStrGrid(True,DateTimeToStr(Now)+'^JBSleep^'+ path +
      ' Jukebox is currently offline. ',280,sgLatestTasks);
    while not DirectoryExists(ExtractFileDrive(path)) do begin
      inc(interval);
      InvStrGrid(True,DateTimeToStr(Now)+'^JBSleep: '+IntToStr(interval)+'^'+ path +
          ' Jukebox is currently offline. ',280,sgLatestTasks);
      if interval mod 10000 = 0 then interval := 0;
      case interval of
        0..10: sleep((30*(interval mod 10))*1000);
        else sleep (300000);
        end; {case}
      end; {while not}
  end; {JBSleep}

procedure TMAGBTMF1.init;

function FileLastWriteDate(FileRec: TSearchRec):TDate;
var
  SystemTime: TSystemTime;
begin
 FileTimeToSystemTime(FileRec.FindData.ftLastWriteTime,
   SystemTime);
 with SystemTime do
   FileLastWriteDate:= EncodeDate(wyear,wmonth,wday);
end; // FileLastWriteDate

var
ProcList: TStringList;
FileRec: TSearchRec;
Complete: boolean;

begin
  if FindFirst(Application.ExeName,(faAnyFile),FileRec) = 0 then
  DistDate :=  DateToFMInternal(DateTimeToStr(FileLastWriteDate(FileRec)))
  else DistDate := '';
  FindClose(FileRec);
  AppVer := GetAppVer(Application.ExeName);
  OSVer := GetOSVersion(self);
  CompName := UpperCase(GetCompName(self));
  WSIEN:=dmMain.GetVariable('$S($D(^MAG(2006.8,"C","'+IntToStr(magbtm1.place)+'","'+CompName+'"))'+
    ':$O(^MAG(2006.8,"C","'+IntToStr(magbtm1.place)+'","'+CompName+'","0")),1:0)');
  LogFilePath := AssignLogPath(CompName,WSIEN);
  LogSizeV := StrToFloat(LogSize(WSIEN));
  LogDate := FileCreationDate(ExtractFilePath(Application.ExeName)+'log\BackProc\BackProc.LOG');
  FindClose(FileRec);
  repeat
    Complete := true;
    ProcList := TStringList.Create;
    dmMain.RPCBroker1.Param[0].VALUE :=CompName+'^'+AppVer+'^'+DistDate+'^'+OSVer ;
    dmMain.RPCBroker1.Param[0].PTYPE := LITERAL ;
    dmMain.RPCBroker1.Param[1].VALUE := 'B-PROC';
    dmMain.RPCBroker1.Param[1].PTYPE := LITERAL ;
    dmMain.RPCBroker1.RemoteProcedure := 'MAGQ ABP';
    try
      dmMain.RPCBroker1.LSTCALL(ProcList);
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^Init',280,sgLatestTasks);
        OnException(E);
        Complete := false;
        end; // on E:Exception
    end; //try...except
  until Complete;
   if piece(ProcList[0],'^',6) <> '1' then begin
     Windows.MessageBox(MAGBTMF1.Handle,PChar('You must be assigned the "MAG SYSTEM" key to operate the Background Processor'),' ',MB_SYSTEMMODAL);
     application.Terminate;
     end;
   if ProcList.Count > 1 then begin  //<>0
     if StrToInt(piece(ProcList[0],'^',1)) > 1 then
       InvStrGrid(true,DateTimeToStr(Now)+u+'INIT'+u+'Init: '+
         piece(ProcList[0],'^',2),280,sgLatestTasks)
     else begin
       WSID := piece(ProcList[0],'^',4)+' - '+piece(ProcList[0],'^',5);
       JOBID := piece(ProcList[0],'^',3);
      end;
     end
   else ;//'This Server is not yet configured !'
  ProcList.Free;
//  CycleCount := 0;
end;
procedure TMAGBTMF1.ErrorLog(Proced,ErrorType,MessageS: String);
var
  logfile: Textfile;
  input: string;
  const u = '^';
begin
  //ErrorValue := GetLastError;
  If not ErrorLogInit then begin
    InitLogFile('log\BackProc\BPError.Log','BP_Error_Log',true,BPErrorLogSize);
    ErrorLogInit := true;
    end;
  input := DateTimeToStr(Now)+u+Proced+u+ErrorType+u+MessageS;
  AssignFile(logfile,ExtractFilePath(Application.ExeName)+'log\BackProc\BPError.log');
  Append(logfile);
  Writeln(logfile,input);
  Flush(logfile);
  CloseFile(logfile);
  BPErrorLogSize := BPErrorLogSize + Length(input);
  if BPErrorLogSize > logSizeV then
     InitLogFile('log\BackProc\BPError.LOG','BP_Error_Log',true,BPErrorLogSize);
  end; //  ErrorLog
function TMAGBTMF1.NumericSegment(Segment: string):integer;
    var
     code: integer;
    begin
     Val(Segment,Result,Code);
     if (code <> 0) then result := 0;
    end;

procedure TMAGBTMF1.InitLogFile(filepath,title:string;AlwaysNew: Boolean;var FileSize: integer);
  function FSize(filepath:string): longint;
    var ftext: textfile;
    begin
      AssignFile(ftext, filepath);
      Reset(ftext);
      try
        FSize := system.FileSize(ftext);
      finally
        CloseFile(ftext);
      end;// try..finally
  end;
  function CreationDate(FileRec: TSearchRec):TDate;
  var
    SystemTime: TSystemTime;
  begin
    FileTimeToSystemTime(FileRec.finddata.ftCreationTime,
     SystemTime);
    with SystemTime do
      CreationDate:= EncodeDate(wyear,wmonth,wday);
  end;
  procedure NewCreationDate(Path: string);
    var
      NewfileTime : TFileTime;
      TempFileHandle: Integer;
      CurrentSystemTime: TSystemTime;
    begin
      GetLocalTime(CurrentSystemTime);
      if SystemTimeToFileTime(CurrentSystemTime,NewfileTime) then begin
        TempFileHandle := FileOpen(path,fmOpenWrite);
        if TempFileHandle < 0 then begin
          InvStrGrid(True,DateTimeToStr(Now)+'^NewCreationDate^SetTime Handle - Destin: '+path+'   '  + SysErrorMessage(GetLastError),280,sgLatestTasks);
          exit;
          end;
        if not SetFileTime(TempFileHandle,@NewFileTime,nil,nil) then
            InvStrGrid(True,DateTimeToStr(Now)+'^InitLogFile: procedure NewCreationDate^SetFileTime Failed '+
              IntToStr(GetLastError)+ ': '+ SysErrorMessage(GetLastError)+' Handle: '+
              IntToStr(TempFileHandle),280,sgLatestTasks);
        FileClose(TempFileHandle);
        end; // if SystemTimeToFileTime(
    end; //procedure NewCreationDate
  function FileInUse(FileName: string): Boolean;
    var hFileRes: HFILE;
    begin
      Result := False;
      if not FileExists(FileName) then exit;
      hFileRes := CreateFile(PChar(FileName),GENERIC_READ or GENERIC_WRITE,0,
                              nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
      Result := (hFileRes = INVALID_HANDLE_VALUE);
      if not Result then CloseHandle(hFileRes);
    end; //function FileInUse
 function DateStringF(Value:Tdate):string;
     var
       DayStr,MonthStr: string;
       Year,Month,Day:word;
     begin
       DecodeDate(value,Year,Month,Day);
       DayStr := RightStr(StringOfChar('0',2) + IntToStr(Day),2);
       MonthStr := RightStr(StringOfChar('0',2) + IntToStr(Month),2);
       result := IntToStr(Year)+ '_'+MonthStr + '_' + DayStr ;
     end;

  function ArchName(DriveDir,FName,FExt: string; OldRec:TSearchRec):string;
   var
     DateString,SeqNumber,TempRec: string;
     Year,Month,Day:word;
     cnt: integer;
     rec: TSearchRec;
   begin
  //  RightStr(StringOfChar(pad,length) + value, length );
     DateString := DateStringF(CreationDate(OldRec));
     TempRec:='';
     SeqNumber :='';
     if FindFirst(DriveDir+FName+DateString+'*',(faDirectory),Rec) = 0 then begin
       TempRec:= Rec.Name;
       while FindNext(Rec) = 0 do begin
         TempRec := Rec.Name;
         end; //while FindNext(Rec)
       FindClose(Rec);
       end; // if FindFirst
       SeqNumber := piece(piece(TempRec,FName+DateString,2),'.',1);
       cnt := NumericSegment(piece(SeqNumber,'_',2));
       inc(cnt);
       SeqNumber := '_'+RightStr(StringOfChar('0',4) + IntToStr(cnt),4);
     Result := DriveDir+FName+DateString+SeqNumber+FExt;
   end; //function ArchName
procedure ArchiveFile(ArchPath,WSDriveDir,Filepath,FName,FExt: string;AlwaysNew: boolean);
 var
   FileRec:TSearchRec;
   ExeProcessInfo: TProcessInformation;
   NewName,EMessage,params: string;
   LastError: integer;

begin
    if FindFirst(WSDriveDir+FName+'*',(faDirectory),FileRec) = 0 then begin //Archive
      if ((CreationDate(FileRec) <> Date) or AlwaysNew) then begin
        NewName := ArchName(ArchPath,FName,FExt,FileRec);
        FindClose(FileRec);
        if not RenameFile(WSDriveDir+ FName+FExt,NewName) then begin
          EMessage :=DateTimeToStr(Now)+U+'InitLogFile ^Problem renaming log file: '+WSDriveDir+ filepath+' -> '+NewName;
          //InvStrGrid(True,Emessage,280,sgLatestTasks);
          LastError:= GetLastError;
          EMessage :=DateTimeToStr(Now)+U+'Last Error'+U+IntToStr(LastError)+': '+SysErrorMessage(LastError);
          InvStrGrid(True,Emessage,280,sgLatestTasks);
          end
        else begin  // Successful rename - Archive step
          params := char(34)+newname+char(34)+ ' '+ char(34)+Archpath+piece(ExtractFileName(newname),'.',1)+'.html'+ char(34)+' '+ rStringHeader + ' '+'none' + ' '+'^'+' '+title;
          ExecNewProcess('MagHTMLArchive.exe '+params,true);
          application.ProcessMessages;
          DeleteFile(newname);
          application.ProcessMessages;
          end;
        end;
      end
    else FindClose(FileRec);
end; // procedure ArchiveFile
function CheckFilepath(var filepath,ArchPath:string):Boolean;
// Initializes directory for the designated Share path for archival Log files (html)
// Inititalizes the Archival path and the log path if one does not exist.
// defaults to local server especially when the network destination fills
 var logfile: textfile;
     driveLetter : char;
     driveNumber : byte;
     directory : string;
     DirName : string;
     EMessage : string;
   begin // CheckFilepath
     result := true;
     Archpath := LogFilePath+filepath;
     //Update local creation date
     if not fileExists(ExtractFilePath(Application.ExeName)+filepath) then begin
        AssignFile(logfile,ExtractFilePath(Application.ExeName)+filepath);
        Rewrite(logfile);
        CloseFile(logfile);
        EMessage :=DateTimeToStr(Now)+U+'InitLogFile ^A new logfile is created: '+ExtractFilePath(Application.ExeName)+filepath;
        InvStrGrid(True,Emessage,280,sgLatestTasks);
        end;
     NewCreationDate(ExtractFilePath(Application.ExeName)+filepath);
     //test remote read/write access
     try
      if not DirectoryExists(ExtractFilePath(LogFilePath+filepath))
        then if not SysUtils.ForceDirectories(ExtractFilePath(LogFilePath+filepath)) then begin
           EMessage :=DateTimeToStr(Now)+U+'CheckFilePath^GetLastError: '+IntToStr(GetLastError)+' '+
             SysErrorMessage(GetLastError)+' '+ExtractFilePath(LogFilepath+filepath);
           InvStrGrid(True,Emessage,280,sgLatestTasks);
          end;
      if fileExists(LogFilepath+filepath) then begin
        {$I-}
        AssignFile(logfile,LogFilepath+filepath);
        FileMode := 2;  {Set file access to Read/Write }
        Reset(logfile);
        CloseFile(logfile);
       {$I+} // if one exists then leave it alone this is only a test
       CheckFilepath := (IOResult = 0) and (LogFilepath+filepath <> '');
        end
      else begin
        AssignFile(logfile,LogFilePath+filepath);
        Rewrite(logfile);
        CloseFile(logfile);
        DeleteFile(LogFilePath+filepath); // post test cleanup
        end;
     except
       Archpath := ExtractFilePath(Application.ExeName)+filepath;
       EMessage :=DateTimeToStr(Now)+U+'InitLogFile Error^GetLastError: '+IntToStr(GetLastError)+
         SysErrorMessage(GetLastError)+LogFilePath+filepath;
       InvStrGrid(True,Emessage,280,sgLatestTasks);
       result := false;
       end; // try...except
   if fileinuse(ExtractFilePath(Application.ExeName)+filepath) then
     ErrorLog('CheckFilePath','File in use:',ExtractFilePath(LogFilepath+filepath));
   end; // CheckFilepath
 var
   FName,FExt,ArchPath,WSFilePath: string;
   logfile: textfile;
  begin  //InitLogFile
    // log files on local machine and archive on designated remote
    // "ArchPath" is the archival (html) designated path
    // "WS" is the local log path
    WSFilePath := ExtractFilePath(Application.ExeName)+ filepath;
    FExt := ExtractFileExt(WSFilePath);
    FName := piece(ExtractFileName(WSFilePath),ExtractFileExt(WSFilePath),1);
    if not DirectoryExists(ExtractFilePath(WSFilePath))
      then SysUtils.ForceDirectories(ExtractFilePath(WSFilePath));
    Checkfilepath(filepath,ArchPath);
    //DriveDir := ExtractFilePath(ArchPath); // local if network out
    //Archive Process
    if FileExists(WSFilePath) then
      if FSize(WSFilePath) <> 0 then
      ArchiveFile(ExtractFilePath(ArchPath),ExtractFilePath(WSFilePath),Filepath,FName,FExt,AlwaysNew);
    //ArchiveFile(ArchPath,WSDriveDir,Filepath,FName,FExt: string;AlwaysNew: boolean)
    if not fileExists(ExtractFilePath(Application.ExeName)+ filepath) then begin
      AssignFile(logfile,ExtractFilePath(Application.ExeName)+ filepath);
      Rewrite(logfile);
      CloseFile(logfile);
      NewCreationDate(ExtractFilePath(Application.ExeName)+ filepath);
      end;
  end;


procedure TMAGBTMF1.mnuJHRPTClick(Sender: TObject);
begin
  if mnuJHRPT.Checked then begin
    frmMagJHRPT1.Close;
    mnuJHRPT.checked := false;
    end
  else begin
    mnuJHRPT.checked := true;
    //frmMagJHRPT1.Show;
    Application.CreateForm(TfrmMagJHRPT1,frmMagJHRPT1);
    try
      frmMagJHRPT1.ShowModal;
    finally
      frmMagJHRPT1.Free;
      sbtnStart.SetFocus;
    end;
    end;
end;
function TMAGBTMF1.FileCreationDate(FilePath:string):Tdate;
  var
    FileRec: TSearchRec;
    SystemTime: TSystemTime;
  begin
    if FindFirst(FilePath,(faDirectory),FileRec) = 0 then begin
      FileTimeToSystemTime(FileRec.finddata.ftCreationTime,SystemTime);
      with SystemTime do
        FileCreationDate:= EncodeDate(wyear,wmonth,wday);
      end
    else FileCreationDate := date;
  end;
procedure TMAGBTMF1.LogProc;
  begin
    BackProcLogSize:= 0;
    InitLogFile('log\BackProc\BackProc.LOG','BackProc_Log',true,BackProcLogSize);
    Logon := true;
    InvStrGrid(True,DateTimeToStr(Now)+'^BP Version^'+
      AppVer,280,sgLatestTasks);
    InvStrGrid(True,DateTimeToStr(Now)+'^BP OS^'+
      OSVer,280,sgLatestTasks);
    InvStrGrid(True,DateTimeToStr(Now)+'^Work Station^'+
      CompName,280,sgLatestTasks);
    InvStrGrid(True,DateTimeToStr(Now)+'^Vista Imaging Install^'+
      kids,280,sgLatestTasks);
    InvStrGrid(True,DateTimeToStr(Now)+'^Vista BrokerServer^'+
      dmMain.RPCBroker1.Server,280,sgLatestTasks);
    LogDate := FileCreationDate(ExtractFilePath(Application.ExeName)+
      'log\BackProc\BackProc.LOG');
 // The BPError Init is now executed at the Same time as LOGProc But only inititally
//    InitLogFile('log\BackProc\BPError.LOG','BP_Error_Log',true,BPErrorLogSize);
//    ErrorLogDate := FileCreationDate(ExtractFilePath(Application.ExeName)+'log\BackProc\BPError.LOG');
//    ErrorLogInit := true;
    stEventLog.Caption := 'BP Event Log - '+
      ExtractFilePath(Application.ExeName)+'LOG\BackProc\BackProc.LOG capture ON';
    stEventLog.Update;
  end;

procedure TMAGBTMF1.mnuPurgeClick(Sender: TObject);
begin
    MyPurge := ExtractFilePath(Application.ExeName)+ 'MagPurge.exe';
    StartProgSLogin(MyPurge, dmMain.RPCBroker1);
end;

procedure TMAGBTMF1.mnuLogClick(Sender: TObject);
begin

end;  //mnuLogClick

procedure TMAGBTMF1.mnuOpenLogClick(Sender: TObject);
begin
  ShowLog.OpenLogFile(logFilePath,Self);
end;

procedure TMAGBTMF1.mnuPurgeParametersClick(Sender: TObject);
begin
  if mnuPurgeParameters.Checked then begin
    frmSiteParameters.Free;
    mnuPurgeParameters.checked := false;
    end
  else begin
    mnuPurgeParameters.checked := true;
    try
      Application.CreateForm(TfrmSiteParameters,frmSiteParameters);
      frmSiteParameters.Top := MAGBTMF1.Top;
      frmSiteParameters.Left :=  MAGBTMF1.Left;
      frmSiteParameters.pcSiteParameters.ActivePageIndex := 3;
      frmSiteParameters.pcSiteParametersChange(frmSiteParameters.pcSiteParameters);
      frmSiteParameters.ShowModal;
    finally
      frmSiteParameters.Free;
      mnuPurgeParameters.checked := false;
      sbtnStart.SetFocus;
    end; //try...finally
    end; // else
end;

procedure TMAGBTMF1.mnuBPServersClick(Sender: TObject);
begin
  if mnuBPServers.Checked then begin
    frmSiteParameters.Close;
    mnuBPServers.checked := false;
    end
  else begin
    mnuBPServers.checked := true;
    try
      Application.CreateForm(TfrmSiteParameters,frmSiteParameters);
      frmSiteParameters.Top := MAGBTMF1.Top;
      frmSiteParameters.Left :=  MAGBTMF1.Left;
      frmSiteParameters.pcSiteParameters.ActivePageIndex := 4;
      frmSiteParameters.pcSiteParametersChange(frmSiteParameters.pcSiteParameters);
      frmSiteParameters.ShowModal;
    finally
      frmSiteParameters.Free;
      mnuBPServers.checked := false;
      sbtnStart.SetFocus;
      end; //try...finally
    end; // else
end;

procedure TMAGBTMF1.mnuNetLocManClick(Sender: TObject);
begin
  mnuNetLocMan.checked := not mnuNetLocMan.checked;
  if mnuNetLocMan.checked then begin
    Application.CreateForm(TfrmNetworkLoc,frmNetworkLoc);
    try
      frmNetworkLoc.ShowModal;
    finally
      frmNetworkLoc.Free;
      mnuNetLocMan.checked := false;
      sbtnStart.SetFocus;
      end; // try...finally
     end;
end;

procedure TMAGBTMF1.mnuPurgeNullQueRecClick(Sender: TObject);
begin
  with dmMain.RPCBroker1 do begin
    RemoteProcedure := 'MAGQB PURNUL';
    CALL;
    end;
end;

procedure TMAGBTMF1.ImagingSiteParameters1Click(Sender: TObject);
//var f: TfrmSiteParameters;
begin
   if ImagingSiteParameters1.Checked then begin
    frmSiteParameters.Free;
    ImagingSiteParameters1.checked := false;
    end
  else begin
    ImagingSiteParameters1.checked := true;
    try
      Application.CreateForm(TfrmSiteParameters,frmSiteParameters);
      frmSiteParameters.Top := MAGBTMF1.Top;
      frmSiteParameters.Left :=  MAGBTMF1.Left;
      frmSiteParameters.pcSiteParameters.ActivePageIndex := 0;
      frmSiteParameters.pcSiteParametersChange(frmSiteParameters.pcSiteParameters);
      frmSiteParameters.ShowModal;
    finally
      frmSiteParameters.Free;
      Application.ProcessMessages;
      ImagingSiteParameters1.checked := false;
      sbtnStart.SetFocus;
    end; //try...finally
    end; // else
end;

function TMAGBTMF1.ImageGroupNotify(Filename,SourceSze,JBSze:string): boolean;
var Complete: boolean;
begin
  repeat
    Complete := true;
    dmMain.RPCBroker1.Param[0].VALUE := FileName;
    dmMain.RPCBroker1.Param[0].PTYPE := LITERAL;
    dmMain.RPCBroker1.Param[1].VALUE := SourceSze;
    dmMain.RPCBroker1.Param[1].PTYPE := LITERAL;
    dmMain.RPCBroker1.Param[2].VALUE := JBSze;
    dmMain.RPCBroker1.Param[2].PTYPE := LITERAL;
    dmMain.RPCBroker1.RemoteProcedure := 'MAGQ ISN';
    try
      dmMain.RPCBroker1.Call;
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^ImageGroupNotify',280,sgLatestTasks);
        OnException(E);
        Complete := false;
        end; // on E:Exception
    end; //try...except
  until Complete;
  result := (pos('1',dmMain.RPCBroker1.Results[0]) <> 0);
end;   //ImageGroupNotify
function TMAGBTMF1.TryCopy(qptr,source,destin,Action:string;QSN: integer; var Copied,NotCopied:TStringList): boolean;
var
  SFilename: string;
  LastErrorMessage: String;
  LastError: integer;
  SearchRec: TSearchRec;
  LAfileTime : TFileTime;
  TempFileHandle: Integer;
  SourceSize,JBSize:Integer;
begin
  result := true;
  SFilename:=ExtractFileName(source);
  InvStrGrid(True,DateTimeToStr(Now) + '^'+Action+': '+ qptr + '^' +
    source + ' ' + destin,280,sgLatestTasks);
  if FileExists(source) then begin // SourceExists
    FindFirst(source,faAnyFile,SearchRec);  //get original Last Access Time Stamp
//    LAfileTime := SearchRec.finddata.ftLastAccessTime;
    SourceSize := SearchRec.Size;
    if SourceSize = 0 then begin
        NotCopied.Add(piece(ExtractFileExt(SFilename),'.',2));
        InvStrGrid(True,DateTimeToStr(Now)+'^'+Action+': '+qptr+'^'+
          piece(ExtractFileExt(SFilename),'.',2)+ ' : NOT Copied. ' +
           'The source file is of size zero.',280,sgLatestTasks);
        result := false;
        exit;
        end;
    FindClose(SearchRec);
    if not FileExists(destin) then
      if not CopyFile(pchar(source),pchar(destin),FailIfExist) then begin  //NotCopy
        LastError:= GetLastError;
        LastErrorMessage := SysErrorMessage(LastError);
        NotCopied.Add(piece(ExtractFileExt(SFilename),'.',2));
        InvStrGrid(True,DateTimeToStr(Now)+'^'+Action+': '+qptr+'^'+
           piece(ExtractFileExt(SFilename),'.',2)+ ' : NOT Copied. ' +
           IntToStr(LastError)+': '+ LastErrorMessage,280,sgLatestTasks);
        result:= false;
        end // NotCopy
      else begin // Copied
        FindFirst(destin,faAnyFile,SearchRec);  //get original Last Access Time Stamp
        JBSize := SearchRec.Size;
        FindClose(SearchRec);
        if SourceSize <> JBSize then begin
          NotCopied.Add(piece(ExtractFileExt(SFilename),'.',2));
            InvStrGrid(True,DateTimeToStr(Now)+'^'+Action+': '+qptr+'^'+
          piece(ExtractFileExt(SFilename),'.',2)+ ' : NOT Copied. ' +
           IntToStr(LastError)+': '+ LastErrorMessage,280,sgLatestTasks);
          ImageGroupNotify('False Positive Copy' +ExtractFileName(Source),IntToStr(SourceSize),IntToStr(JBSize));
          result := false;
          exit;
          end;
        Copied.Add(piece(ExtractFileExt(SFilename),'.',2));
//        TempFileHandle := FileOpen(destin,fmOpenWrite);
//        if TempFileHandle < 0 then begin
//            InvStrGrid(True,DateTimeToStr(Now)+'^'+Action+' : '+qptr+'^SetTime Handle - Destin: '+destin+'   '  + SysErrorMessage(GetLastError),280,sgLatestTasks);
//            exit;
//          end;
//        if not SetFileTime(TempFileHandle,nil,@LAFileTime,nil) then
//          InvStrGrid(True,DateTimeToStr(Now)+'^'+Action+': '+qptr+'^SetFileTime Failed '+
//            IntToStr(GetLastError)+ ': '+ SysErrorMessage(GetLastError)+' Handle: '+
//             IntToStr(TempFileHandle),280,sgLatestTasks);
//        FileClose(TempFileHandle);
//        TempFileHandle := FileOpen(source,fmOpenWrite);
//        if TempFileHandle < 0 then begin
//            InvStrGrid(True,DateTimeToStr(Now)+'^'+Action+': '+qptr+'^SetTime Handle - Source: '+source+'   '  + SysErrorMessage(GetLastError),280,sgLatestTasks);
//            exit;
//          end;
//        if not SetFileTime(TempFileHandle,nil,@LAFileTime,nil) then
//          InvStrGrid(True,DateTimeToStr(Now)+'^'+Action+': '+qptr+'^SetFileTime Failed '+
//            IntToStr(GetLastError)+ ': '+ SysErrorMessage(GetLastError)+' Handle: '+
//             IntToStr(TempFileHandle),280,sgLatestTasks);
        end
    else begin  //destination file already exists
      FindFirst(destin,faAnyFile,SearchRec);
      JBSize := SearchRec.Size;
      FindClose(SearchRec);
      if (SourceSize = JBSize) then begin
        //Copied.Add(piece(ExtractFileExt(SFilename),'.',2));
        InvStrGrid(True,DateTimeToStr(Now)+'^'+Action+': '+qptr+'^'+Action+' copy not overwritten.'
          ,280,sgLatestTasks);
        Exit;
        end;
      if (SourceSize > 0) and (JBSize = 0) then
        if CopyFile(pchar(source),pchar(destin),False) then begin
          //Copied.Add(piece(ExtractFileExt(SFilename),'.',2));
          InvStrGrid(True,DateTimeToStr(Now)+'^'+Action+': '+qptr+'^Zero size '+Action+' copy overwritten.'
            ,280,sgLatestTasks);
          end
        else begin
          if QSN = 2 then ImageGroupNotify(ExtractFileName(Source),IntToStr(SourceSize),IntToStr(JBSize));
          NotCopied.Add(piece(ExtractFileExt(SFilename),'.',2));
          InvStrGrid(True,DateTimeToStr(Now)+'^'+Action+': '+qptr+'^Zero size '+Action+' copy NOT overwritten.'
            ,280,sgLatestTasks);
          result := false;
          end;
       if (SourceSize <> JBSize) and (JBSize <> 0) then begin
         if QSN = 2 then ImageGroupNotify(ExtractFileName(Source),IntToStr(SourceSize),IntToStr(JBSize));
         NotCopied.Add(piece(ExtractFileExt(SFilename),'.',2));
         InvStrGrid(True,DateTimeToStr(Now)+'^'+Action+': '+qptr+'^Size Mismatch '+Action+' copy not overwritten.'
           ,280,sgLatestTasks);
         result := false;
         end;
      end; // destination file already exists
    end  // SourceExists
  else begin // SourceDoesNotExist
    result := false;
    InvStrGrid(True,DateTimeToStr(Now)+'^'+Action+': '+qptr+'^'+
      piece(ExtractFileExt(SFilename),'.',2)+' Source file does not exist.'
      ,280,sgLatestTasks);
    NotCopied.Add(piece(ExtractFileExt(SFilename),'.',2));
    end;
end; //TMAGBTMF1.TryCopy


function TMAGBTMF1.GCC(action: string): boolean;
// RESULT=STATUS^MAGIFN^FROMPATH^TOPATH^QPTR^VWP^QSN^Ext
//RESULT=STATUS^IMAGE PTR^FROM FILE^TO FILE^QUEUE PTR^REMOTELOC PTR^QSN^REMOTE FILE NAME
function NetCon(Dest,vwp: string; var Conn:boolean): boolean;
var
  NR: TNetResource;
  Password,User: String;
  Complete: Boolean;
begin
  // get Network Location Credentials
  repeat
    Complete := true;
    result := false;
    FMGets1.ClearCtrlData ;
    FMGets1.FileNumber := '2005.2';
    FMGets1.IENS := vwp;
    FMGets1.FieldNumbers.Clear;
    FMGets1.FieldNumbers.Add('15');
    FMGets1.FieldNumbers.Add('16');
    FMGets1.FieldNumbers.Add('17');
    FMGets1.GetData;
    try
      Password := FMGets1.GetField('16').FMDBInternal;
      User := FMGets1.GetField('15').FMDBInternal;
      Conn := FMGets1.GetField('17').FMDBInternal = '1';
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^GCC/NetCon',280,sgLatestTasks);
        OnException(E);
        Complete := false;
        end; // on E:Exception
    end; //try...except
  Until Complete;
  // try Network Location Credentials
  FillChar(NR, SizeOf(NR), 0);
  NR.dwType := RESOURCETYPE_DISK;
  NR.lpLocalName := NIL;
  NR.lpRemoteName := pchar(ExtractFileDrive(Dest));
  if length(Password) > 0 then begin
    Password := hash.decrypt(Password);
    if WNetAddConnection2( NR,pchar(Password),pChar(User),0) <> 0 then
       ErrorLog('GCC connection','NetConError','Using Network Location entry credentials '+'User: '+User+' Password Length: '+IntToStr(Length(Password))+' Win32 Error:'+IntToStr(GetLastError)+ ' | ' +SysErrorMessage(GetLastError))
    else begin
      result := true;
      exit;
      end;  //Network Location Connection successful
    end // had a Network Location password
  else ErrorLog('GCC connection','NetConError','There is no password associated with this Network Location:'+ExtractFileDrive(Dest));
  // try Service Account credentials
  NR.dwType := RESOURCETYPE_DISK;
  NR.lpLocalName := NIL;
  NR.lpRemoteName := pchar(ExtractFileDrive(Dest));
  User := dmMain.GetFieldValue('2006.1','50',IntToStr(place)+',','I',true);
  Password := dmMain.GetFieldValue('2006.1','51',IntToStr(place)+',','I',true);
  if length(Password) > 0 then begin
    Password := hash.decrypt(Password);
    if WNetAddConnection2( NR,pchar(Password),pChar(User),0) <> 0 then
       ErrorLog('GCC connection','NetConError','Using Service Account (IA) credentials '+'User: '+User+' Password Length: '+IntToStr(Length(Password))+' Win32 Error:'+IntToStr(GetLastError)+ ' | ' +SysErrorMessage(GetLastError))
    else begin
      result:= true;
      exit;
      end;  // had a Service Account password
    end  
  else ErrorLog('GCC connection','NetConError','There is no password associated with this Service Account:'+ExtractFileDrive(Dest));
    // Try user credentials
    NR.dwType := RESOURCETYPE_DISK;
    NR.lpLocalName := NIL;
    NR.lpRemoteName := pchar(ExtractFileDrive(Dest));
    if WNetAddConnection2( NR,NIL,NIL,0) <> 0 then
      ErrorLog('GCC connection','NetConError','Using User credentials '+' Win32 Error:'+IntToStr(GetLastError)+ ' | ' +SysErrorMessage(GetLastError))
    else result := true;
  Result := not DirectoryExists(ExtractFileDrive(Dest));
end;  //function NetCon

var
  input,destpath,sourcepath,qptr,filename,vwp,NewName{ext} : string;
  QSN: integer;
  Copied,NotCopied{,ExtList}: TStringList;
  {KeepConn : boolean;}
begin
  result := false;
  if getqueue(action ,input) then begin // substituted if for while
    result := false;
    qptr :=  piece(input,'^',5);
    vwp :=  piece(input,'^',6);
    NewName :=  piece(input,'^',8);
    QSN := StrToInt(piece(input,'^',7));
    destpath := piece(input,'^',4);
    sourcepath := piece(input,'^',3);
    filename := ExtractFileName(sourcepath);
      // is the Destination path and the vwp in-synch ??
    if pos(dmMain.GetFieldValue('2005.2','1',vwp+',','E',true),
      ExtractFilePath(destpath)) = 0 then begin
      ReportGCCError('Export Share mismatch: '+dmMain.GetFieldValue('2005.2','1',vwp+',','E',true)+' / '+ ExtractFilePath(destpath));
      exit;
      end;
    if not DirectoryExists(ExtractFileDrive(Destpath)) then
      if not NetCon(destpath,vwp,Conn) then begin
        QueueUpdate(qptr,action,'-1^'+
          ' Cannot Connect to the Export Share^'+vwp);
        WNetCancelConnection2(pchar(ExtractFileDrive(Destpath)),0, False);
        if QSN < 2 then Requeue(qptr)
        else ReportGCCError(ExtractFileDrive(Destpath)+': Cannot connect to the Export Share.');
        exit;
        end;
    if not DirectoryExists(ExtractFilePath(destpath))
      then SysUtils.ForceDirectories(ExtractFilePath(destpath));
      Copied := TStringList.Create;
      NotCopied:= TStringList.create;
      if not TryCopy(qptr,sourcepath,destpath,Action,QSN,Copied,NotCopied) then begin
        QueueUpdate(qptr,action,'-1^'+piece(ExtractFileName(SourcePath),'.',2) +
          ' Unable to copy to the current fileServer:'+destpath+'^');
        if QSN < 2 then Requeue(qptr)
        else
          ReportGCCError('The "'+sourcepath+'" to "'+ destpath+'" copy failed.');
        exit;
        end
      else begin
        QueueUpdate(qptr,action,'1^'+piece(ExtractFileName(SourcePath),
        '.',2) +' '+action+' copy complete^'+vwp);
        end;
    WNetCancelConnection2(pchar(ExtractFileDrive(Destpath)),0, False);
    end ; //if getqueue
  Copied.Free;
  NotCopied.Free;
end; //GCC
procedure TMAGBTMF1.ReportGCCError(Error: string);
 begin
  MagEnterpriseUpdate('"The GCC queue processor is having difficulty copying files to the ','',IntToStr(place),'GCC Queue Error');
  MagEnterpriseUpdate('network location. The last copy attempt failed 3 times with an error status of : ','',IntToStr(place),'GCC Queue Error');
  MagEnterpriseUpdate(Error,'',IntToStr(place),'GCC Queue Error');
  MagEnterpriseUpdate('GCC Copy Error','1',IntToStr(place),'GCC Queue Error');
end;  // ReportGCCError
procedure TMAGBTMF1.mnuExit1Click(Sender: TObject);
begin
MAGBTMF1.sbtnStopClick(self);
magbtmf1.close;
end;
function TMAGBTMF1.MagEnterpriseUpdate(Data,Send,Place, App: string): boolean;
  var Complete: boolean;
begin
  repeat
    Complete := true;
    result := true;
    dmMain.RPCBroker1.ClearParameters := true;
    dmMain.RPCBroker1.Param[0].VALUE := Data;
    dmMain.RPCBroker1.Param[0].PTYPE := LITERAL;
    dmMain.RPCBroker1.Param[1].VALUE := Send;
    dmMain.RPCBroker1.Param[1].PTYPE := LITERAL;
    dmMain.RPCBroker1.Param[2].VALUE := Place;
    dmMain.RPCBroker1.Param[2].PTYPE := LITERAL;
    dmMain.RPCBroker1.Param[3].VALUE := App;
    dmMain.RPCBroker1.Param[3].PTYPE := LITERAL;
    dmMain.RPCBroker1.RemoteProcedure := 'MAGQ DFNIQ';
    try
      dmMain.RPCBroker1.Call;       //call
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^MagEnterpriseUpdate',280,sgLatestTasks);
        OnException(E);
        Complete:= false;
        end; // on E:Exception
    end; //try...except
  until Complete;
end; // MagEnterpriseUpdate
// function TMAGBTMF1.GetConPar(NetLoc: string;var UserName,PW:String;Conn :boolean):boolean;
// var
//   i: integer;
// begin
//  GetConPar := false;
//  if Lister = nil then begin
//    Lister := TFMLister.Create(application);
//    Lister.RPCBroker := dmMain.RPCBroker1;
//    Lister.FileNumber := '2005.2';
//    Lister.ListerFlags := [lfInternal];
//    Lister.FieldNumbers.Clear;
//    Lister.FieldNumbers.Add('1');
//    Lister.FieldNumbers.Add('6');
//    Lister.FieldNumbers.Add('15');
//    Lister.FieldNumbers.Add('16');
//    Lister.FieldNumbers.Add('17');
//    Lister.Screen :='I $P(^(0),U,6,7)="1^GCC"';
//    Lister.GetList(nil);
//    end;
//  with Lister do
//    for i := 0 to Results.Count -1 do
//      if NetLoc = GetRecord(Lister.Results[i]).GetField('1').FMDBINternal then begin
//        UserName := GetRecord(Lister.Results[i]).GetField('15').FMDBInternal;
//        PW := GetRecord(Lister.Results[i]).GetField('16').FMDBInternal;
//        Conn := (GetRecord(Lister.Results[i]).GetField('17').FMDBInternal='1');
//        GetConPar := true;
//        exit;
//        end;
// end;

{procedure TMAGBTMF1.mnuLogStatClick(Sender: TObject);
begin
  if mnuLogStat.Checked then begin
    frmMagLogStat.Close;
    mnuLogStat.checked := false;
    end
  else begin
    mnuLogStat.checked := true;
    Application.CreateForm(TfrmMagLogStat,frmMagLogStat);
    end;
end;
 }
procedure TMAGBTMF1.FormActivate(Sender: TObject);
begin
  {$ifdef Win32}
          SetForegroundWindow(MAGBTMF1.Handle);
  {$else}
          BringWindowToTop(MAGBTMF1.Handle);
  {$endif}
{DONE : -c121  ... do we need this for using ActiveX ?. No.}
//  MagDBBroker1 := TMagDBmvista.create;   //121 out NA
{DONE : -c121  change to user OCX.}
//  MagImport1.MagBroker := dmMain.RPCBroker1;  //121 out NA
{DONE : -c121  change to user OCX.}
//  MagImport1.MagDBBroker := MagDBBroker1;       //121 out NA
//  MagDBBroker1.SetBroker(dmMain.RPCBroker1);    //121 out NA
  InitSGLatestTasks;
  InitSGServer;
  Init;
  MagServerWriteCnt := 0;
  magbtmf1.update;
  Timer1.Enabled := true;
  Timer2.Enabled := True;
  sbtnStart.SetFocus;
end;

procedure TMAGBTMF1.AutoPurge(Sender: TObject;Shares:string);
begin
 if not PurgeActive then begin
  InvStrGrid(True,DateTimeToStr(Now)+'^AUTOPURGE^The BP Queue is about to launch AUTOPURGE',280,sgLatestTasks);
  PurgeActive := true;
  MyPurge := ExtractFilePath(Application.ExeName)+ 'MagPurge.exe xval=AutoPurge '+Shares;
  StartProgSLogin(MyPurge, dmMain.RPCBroker1);
  end;
end;
procedure TMAGBTMF1.ScheduledPurge(Sender: TObject;RequestDate,Shares:string);
begin
 if not PurgeActive then begin
  InvStrGrid(True,DateTimeToStr(Now)+'^Scheduled PURGE^The BP Queue is about to launch Scheduled PURGE',280,sgLatestTasks);
  PurgeActive := true;
  MyPurge := ExtractFilePath(Application.ExeName)+ 'MagPurge.exe xval=SchedPurge '+Shares+' '+RequestDate;
  StartProgSLogin(MyPurge, dmMain.RPCBroker1);
  end;
end;

procedure TMAGBTMF1.AutoVerify(Sender: TObject; RequestDate: string);
begin
 if not VerifierActive then begin
  InvStrGrid(True,DateTimeToStr(Now)+'^SCHEDVERIFY^The BP Queue Processor is about to launch a scheduled VERIFY',280,sgLatestTasks);
  VerifierActive := true;
  MyVerify := ExtractFilePath(Application.ExeName)+ 'MagVerifier.exe xval=AutoVerify '+RequestDate;
  StartProgSLogin(MyVerify, dmMain.RPCBroker1);
  end;
end;
function TMAGBTMF1.VerifyVersion(Sender: TObject;AppsVersion: string;var kids: string): boolean;
var
  VERS,Data: string;
  complete: boolean;
begin
  repeat
    result := false;
    Complete := true;
    dmMain.RPCBroker1.RemoteProcedure := 'XWB IS RPC AVAILABLE';
    dmMain.RPCBroker1.Param[0].Value :='MAGQ VOK';
    dmMain.RPCBroker1.Param[0].PType := literal;
    dmMain.RPCBroker1.Param[1].Value := 'R';
    dmMain.RPCBroker1.Param[1].PType := literal;
    try
      dmMain.RPCBroker1.Call;       //call
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^VerifyVersionII',280,sgLatestTasks);
        OnException(E);
        Complete := false;
        end; // on E:Exception
    end; //try...except
  until complete;
  if dmMain.RPCBroker1.Results[0]='0' then begin
    Windows.MessageBox(MAGBTMF1.Handle,PChar('The Patch 39 KIDS install on the Vista host system is required for this Version of the: '+ Application.title),' ',MB_SYSTEMMODAL);
    Application.Terminate;
    exit;
    end;
  repeat
    Data := '';
    VERS := piece(AppsVersion,'.',1) + '.' + piece(AppsVersion,'.',2)+ 'P'+ piece(AppsVersion,'.',3);
    dmMain.RPCBroker1.RemoteProcedure := 'MAGQ VOK';
    dmMain.RPCBroker1.Param[0].Value := VERS;
    dmMain.RPCBroker1.Param[0].PType := LITERAL;
    try
      dmMain.RPCBroker1.Call;       //call
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^VerifyVersionII',280,sgLatestTasks);
        OnException(E);
        Complete := false;
        end; // on E:Exception
    end; //try...except
   until complete;
   if dmMain.RPCBroker1.Results.Count < 1 then begin
     Windows.MessageBox(MAGBTMF1.Handle,PChar('BrokerError'),' ',MB_SYSTEMMODAL);
     result := false;
     end
   else begin
     Data := dmMain.RPCBroker1.Results[0];
     if pos('1^',data) <> 0 then result := true
     else result := false;
     kids := piece(data,'^',2);
     end;
  end;  // VerifyVersion
function TMAGBTMF1.AbstractOK(FileExt:string):boolean;
  var
    temp: string;
    complete: boolean;
begin
  repeat
    Complete := true;
    result := false;
    FMFindOne1.Value :=UpperCase(FileExt);
    FMFindOne1.FileNumber:='2005.021';
    try
      temp := FMFindOne1.GetIEN;
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^AbstractOk',280,sgLatestTasks);
        OnException(E);
        Complete := false;
        end; // on E:Exception
    end; //try...except
  until Complete;
  if pos('-1',temp) = 0 then
    result := (pos('YES',dmMain.GetFieldValue('2005.021','4',temp+',','E',true)) <> 0);
  end;
function TMAGBTMF1.QueueDelete(qptr:string):boolean;
var
  complete: boolean;
begin
  repeat
    complete := true;
    dmMain.RPCBroker1.Param[0].VALUE := qptr;
    dmMain.RPCBroker1.Param[0].PTYPE := LITERAL;
    dmMain.RPCBroker1.RemoteProcedure := 'MAGQB QUEDEL';
    try
      dmMain.RPCBroker1.Call;       //call
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^MAGQB QUEDEL',280,sgLatestTasks);
        OnException(E);
        Complete := false;
        end; // on E:Exception
    end; // try...except
  until Complete;
end; // QueueDelete(qptr:string):boolean;

function TMAGBTMF1.GetPlace(var SiteCode,SiteName: string):integer;
var
  FMGetsPN : TFMGets;
  Complete: boolean;
begin
  repeat
    Complete := true;
    Lister := TFMLister.Create(application);
    Lister.RPCBroker := dmMain.RPCBroker1;
    Lister.FileNumber := '2006.1';
    Lister.ListerFlags := [lfInternal];
    Lister.FMIndex := '#';
    Lister.FieldNumbers.Clear;
    Lister.FieldNumbers.Add('.01');
    Lister.Screen :='I $D(^MAG(2006.1,"B",+$G(DUZ(2)),Y))';
    try
      Lister.GetList(nil);
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^GetPlace',280,sgLatestTasks);
        OnException(E);
        Complete := false;
        Lister.Free;
        end; // on E:Exception
    end; // try...except
  until Complete;
  with Lister do begin
     if results.count = 1 then begin
       GetPlace := StrToInt(Results[0]);
       place := StrToInt(Results[0]);
       end
    else GetPlace := 0;
    end;
  repeat
    Complete:= true;
    FMGetsPN := TFMGets.Create(self);
    FMGetsPN.FileNumber := '2006.1';
    FMGetsPN.FieldNumbers.Clear;
    FMGetsPN.FieldNumbers.Add('.01') ;
    FMGetsPN.FieldNumbers.Add('.02') ;
    FMGetsPN.RPCBroker := dmMain.RPCBroker1;
    FMGetsPN.IENS := IntToStr(Place)+',';
    try
      FMGetsPN.GetData;
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^GetPlace',280,sgLatestTasks);
        OnException(E);
        Complete := false;
        FMGetsPN.Free;
        end; // on E:Exception
    end; // try...except
  until Complete;
    SiteName := FMGetsPN.GetField('.01').FMDBExternal;
    SiteCode := FMGetsPN.GetField('.02').FMDBExternal;
    FMGetsPN.Free;
end;   // GetPlace
procedure TMAGBTMF1.UpdateQueuePointer(QueueType,QueuePtr: string);
var
  FMFiler1 : TFMFiler;
  Complete: boolean;
begin
  repeat
    Complete := true;
    Lister := TFMLister.Create(application);
    Lister.RPCBroker := dmMain.RPCBroker1;
    Lister.FileNumber := '2006.031';
    Lister.ListerFlags := [lfInternal];
    Lister.FieldNumbers.Clear;
    Lister.FieldNumbers.Add('.01');
    Lister.Screen :='I (($P(^(0),U,1)="'+QueueType+'")&($P(^(0),U,4)='+IntToStr(Place)+'))';
    try
      Lister.GetList(nil);
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^UpdateQueuePointer',280,sgLatestTasks);
        OnException(E);
        Complete := false;
        Lister.Free;
        end; // on E:Exception
    end; //try...except
  until Complete;
  repeat
    FMFiler1 := TFMFiler.Create(self);
    FMFiler1.RPCBroker := dmMain.RPCBroker1;
    FMFiler1.AddFDA('2006.031',Lister.Results[0],'1',QueuePtr);
    try
      FMFiler1.Update;
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^UpdateQueuePointer',280,sgLatestTasks);
        OnException(E);
        Complete := false;
        FMFiler1.free;
        end; // on E:Exception
    end; //try...except
  until Complete;
  FMFiler1.Free;
  Lister.free;
end;  // UpdateQueuePointer



function TMAGBTMF1.JBQueue(RecNo: string):string;
var Complete: boolean;
begin
  //inc(JBQCount);
  repeat
    Complete:= true;
    dmMain.RPCBroker1.Param[0].VALUE := RecNo;
    dmMain.RPCBroker1.Param[0].PTYPE := LITERAL;
    dmMain.RPCBroker1.RemoteProcedure := 'MAGQ JBQUE';
    try
      dmMain.RPCBroker1.Call;       //call
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^MAGQ JBQUE',280,sgLatestTasks);
        OnException(E);
        Complete := false;
        end; // on E:Exception
    end; //try...except
  until Complete;
  JBQueue := dmMain.RPCBroker1.Results[0];
end; // JBQueue


procedure TMAGBTMF1.GetSystemTimeout(var TimeOut: string);
var
  FMGetsTO: TFMGets;
  tmp: string;
begin
  tmp := IntToStr(Timer2.Interval div 900);
  FMGetsTO := TFMGets.Create(self);
  FMGetsTO.FileNumber := '8989.3';
  FMGetsTO.FieldNumbers.Clear;
  FMGetsTO.FieldNumbers.Add('230') ;
  FMGetsTO.RPCBroker := dmMain.RPCBroker1;
  FMGetsTO.IENS := '1,';
  try
    FMGetsTO.GetData;
    TimeOut := FMGetsTO.GetField('230').FMDBInternal;
  except
    on E:Exception do begin
      InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^GetSystemTimeout',280,sgLatestTasks);
      TimeOut := tmp;
      OnException(E);
      end; // on E:Exception
  end; //try...except
  FMGetsTO.Free;
end; // GetSystemTimeout


procedure TMAGBTMF1.Timer2Timer(Sender: TObject);
begin
  GetSystemTimeOut(TimeOut);
  if StrToInt(TimeOut)< 30 then TimeOut := '30';
  Timer2.Interval := (StrToInt(Timeout)*900);
end;
procedure TMAGBTMF1.mnuAllClick(Sender: TObject);
begin
  Application.CreateForm(TfrmQPurgeByType,frmQPurgeByType);
  try
    frmQPurgeByType.ShowModal;
  finally
    frmQPurgeByType.Free;
    sbtnStart.SetFocus;
  end; // try...finally
end;
function TMAGBTMF1.MagExecuteFile(const FileName, Params, DefaultDir: string;  ShowCmd: Integer; oper : string = 'open'): THandle;
var
  zOper, zFileName, zParams, zDir: array[0..279] of Char;

begin
 //                              HWND                lpOperation
  Result := ShellExecute(Application.MainForm.Handle,strPcopy(zOper,oper),
  //      lpFile                      lpParameters
  StrPCopy(zFileName, FileName), StrPCopy(zParams, Params),
  //      lpDirectory          nShowCmd
   StrPCopy(zDir, DefaultDir), ShowCmd);
end;

procedure TMAGBTMF1.ExecNewProcess(ProgramName : String; Wait: Boolean);
var
  StartInfo : TStartupInfo;
  ProcInfo : TProcessInformation;
  CreateOK : Boolean;
  Emessage: string;
begin
    { fill with known state }
  FillChar(StartInfo,SizeOf(TStartupInfo),#0);
  FillChar(ProcInfo,SizeOf(TProcessInformation),#0);
  StartInfo.cb := SizeOf(TStartupInfo);
  CreateOK := CreateProcess(nil, PChar(ProgramName), nil, nil,False,
              CREATE_NEW_PROCESS_GROUP+NORMAL_PRIORITY_CLASS,
              nil, nil, StartInfo, ProcInfo);
    { check to see if successful }
  if CreateOK then
    begin
        //may or may not be needed. Usually wait for child processes
      if Wait then
        WaitForSingleObject(ProcInfo.hProcess, INFINITE);
    end
  else
    begin
      EMessage :=DateTimeToStr(Now)+U+'Create Process failed'+ProgramName;
      InvStrGrid(True,DateTimeToStr(Now)+'^Error Message^'+Emessage,280,sgLatestTasks);
      ErrorLog('ExecNewProcess','Create Process failed',ProgramName);
     end;
  CloseHandle(ProcInfo.hProcess);
  CloseHandle(ProcInfo.hThread);
end;

function TMAGBTMF1.LimitListSize(Percent,RecordSize:integer;Sender: TObject):string;
var
  MS: TMemoryStatus;
begin
  MS.dwLength := SizeOf(TMemoryStatus);
  GlobalMemoryStatus(MS);
  result :=  IntToStr((MS.dwAvailVirtual div Percent)div RecordSize);
end;

function TMAGBTMF1.AssignLogPath(CompName,WSIEN:string):string;
// Look at the Win32 API GetFileSecurity() function.
// also GetNamedSecurityInfo to check for network write permissions before returnning the network result.
// Log and return local default
//http://groups.google.com/group/borland.public.delphi.language.delphi.win32/browse_thread/thread/40ecfe40371d89bd
{ Results of GetDriveType
Value	Meaning
0	The drive type cannot be determined.
1	The root directory does not exist.
DRIVE_REMOVABLE	The drive can be removed from the drive.
DRIVE_FIXED	The disk cannot be removed from the drive.
DRIVE_REMOTE	The drive is a remote (network) drive.
DRIVE_CDROM	The drive is a CD-ROM drive.
DRIVE_RAMDISK	The drive is a RAM disk.
}
begin
  if StrToInt(WSIEN) > 0 then begin
    result := dmMain.GetFieldValue('2006.8','49',WSIEN+',','E',true);
    if (pos('-1',piece(result,'^',1)) <> 0) or
    (result='') then result := ExtractFilePath(Application.ExeName)
    else if (GetDriveType(pchar(result)) = DRIVE_REMOTE) then result := result + CompName+'\'
         else if RightStr(result,1) <> '\' then result := result +'\';
    end // if StrToInt(WSIEN) > 0
  else result :=ExtractFilePath(Application.ExeName);
  if RightStr(result,1) <> '\' then result := result +'\';
end;
function TMAGBTMF1.LogSize(WSIEN:string):string;
var
  temp: string ;
begin
  if StrToInt(WSIEN) > 0 then begin
    temp := dmMain.GetFieldValue('2006.8','54',WSIEN+',','E',true);
//    temp := GetValue('2006.8','54',WSIEN);
    if temp = '' then temp := '0';
    if not (StrToFloat(temp) > 0) then temp := '1';
    result := FloatToStr(StrToFloat(temp)*1000000);
    end
  else result:='1000000';
end;

procedure TMAGBTMF1.lvCompare(Sender: TObject; Item1,
  Item2: TListItem; Data: Integer; var Compare: Integer);
function CompAll(Input1,Input2:string):integer;
var
  I1,I2,C1,C2: Integer;
begin
    Val(Input1,I1,C1);
    Val(Input2,I2,C2);
  if ((c1 = 0) and (c2 = 0)) then begin
    if I1 > I2 then result := I1 - I2;
    if I1 < I2 then result := -(I2 - I1);
    if I1 = I2 then result := 0;
    end
  else result := CompareText(Input1,Input2);
  if order = 'd' then result := -result;
end;
var IX: integer;
begin
  if ColumnToSort = 0 then
    Compare := CompAll(Item1.Caption,Item2.Caption)
  else begin
   ix := ColumnToSort - 1;
   Compare := CompAll(Item1.SubItems[ix],Item2.SubItems[ix]);
  end;
end;
function TMAGBTMF1.lvSearch(SearchList:TListView;SearchString: string;ColumnIndex:integer):integer;
var i: integer;
  FoundItem : TListItem;
begin
  result := -1;
 if ColumnIndex = 0 then begin
   FoundItem := SearchList.FindCaption(0,SearchString,false,true,false);
   if FoundItem <> nil then Result := FoundItem.index
   else Result := -1;
   end
 else begin
   for i := 0 to SearchList.Items.Count - 1 do
     if pos(SearchString,SearchList.Items[i].SubItems[ColumnIndex-1]) <> 0 then begin
       result := i;
       exit;
       end;
     end;
end;
procedure TMAGBTMF1.lvClear(Sender: TObject);
var
  I: Integer;
begin
  for I := 0 to MAGBTMF1.ComponentCount - 1 do
   if (MAGBTMF1.Components[I] is TListView) then
   with MAGBTMF1.Components[I] as TListView do begin
     items.clear;
     columns.clear;
     end;
end;

procedure TMAGBTMF1.lvAdd(Viewer:TListView;Column:integer;UpdateLabel:TLabel);
var
  I,sum,temp,code:integer;
  LI : TListItem;
begin
  UpdateLabel.Caption := '0';
  sum := 0;
  for I := 0 to Viewer.Items.count - 1 do begin
    val(Viewer.Items[I].subitems[column - 2],temp,code);
    if code=0 then sum := sum + temp;
    end;
  UpdateLabel.Caption := IntToStr(sum);
end;


procedure TMAGBTMF1.lvColumnClick(Sender: TObject;
  Column: TListColumn);
begin
  ColumnToSort := Column.Index;
  (Sender as TCustomListView).AlphaSort;
  if order = 'a' then order := 'd'
  else order := 'a';

end;
procedure TMAGBTMF1.ListViewUpdate(Clear,IEN: Boolean;Lister:TFMLister;lv:TListView);
var
  i,j,k,l: integer;
  Labels: TStringList;
  NewColumn: TListColumn;
  ListItem: TListItem;
begin
  if clear then begin
   lv.Items.Clear;
   lv.Columns.Clear;
   end;
  with Lister do begin
    GetList(nil);
    if Results.Count>0 then begin
      lv.ViewStyle := vsReport;
      lv.GridLines := true;
      Labels := GetLabels(Lister);
      if Labels.Count>0 then begin{Create Column Labels}
        if IEN then begin
          NewColumn := lv.Columns.Add;
          NewColumn.Caption := 'IEN';
          end;
        for k := 0 to Labels.Count - 1 do begin
          NewColumn := lv.Columns.Add;
          NewColumn.Caption := Labels[k];
          end;
        end;
      for i := 0 to Results.Count -1 do begin   {Create ListItems}
        ListItem := lv.Items.Add;
        if IEN then ListItem.Caption := Lister.Results[i]
        else ListItem.Caption :=
          GetRecord(Results[i]).GetField(FieldNumbers.Strings[0]).FMDBExternal;
        if IEN then l := 0 else l := 1;
        for j := l to FieldNumbers.Count - 1 do
          ListItem.SubItems.Add(GetRecord(Results[i]).GetField(FieldNumbers.Strings[j]).FMDBExternal);
        end; //for i
      for i := 0 to lv.Columns.Count -1 do begin
        lv.Columns[i].AutoSize := true;   {AutoSize Columns}
        lv.Columns[i].width := columnheaderwidth;  {Set ColumnWidth}
        end;
      end; //if results
    end; // with Lister
end; //ListViewUpdate
function TMAGBTMF1.GetLabels(FMDC:TObject): TStringList;
  function GetLabel(FMFile,FMField:string): String;
    var
      ResultList :TStringList;
      Complete: boolean;
  begin
    repeat
      Complete := true;
      ResultList := TStringList.create;
      dmMain.RPCBroker1.Param[0].VALUE := FMFile;
      dmMain.RPCBroker1.Param[0].PTYPE := LITERAL;
      dmMain.RPCBroker1.Param[1].VALUE := FMField;
      dmMain.RPCBroker1.Param[1].PTYPE := LITERAL;
      dmMain.RPCBroker1.Param[2].VALUE := '';
      dmMain.RPCBroker1.Param[2].PTYPE := LITERAL;
      dmMain.RPCBroker1.Param[3].VALUE := 'LABEL';
      dmMain.RPCBroker1.Param[3].PTYPE := LITERAL;
      dmMain.RPCBroker1.RemoteProcedure := 'MAG FLD ATT';
      try
        dmMain.RPCBroker1.LSTCALL(ResultList);
      except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^MAG FLD ATT',280,sgLatestTasks);
        OnException(E);
        Complete:= false;
        ResultList.Free;
        end; // on E:Exception
      end; //try...except
    until Complete;
    ResultList.Free;
    Result := ResultList[0] ;
  end;  // function GetLabel(
  var i:integer;
begin
 Result := TStringList.Create;
 if FMDC.ClassType = TFMLister then with FMDC as TFMLister do
   for i := 0 to FieldNumbers.Count - 1 do
     result.Add(GetLabel(FileNumber,FieldNumbers[i]));
 if FMDC.ClassType = TFMGets then with FMDC as TFMGets do
   for i := 0 to FieldNumbers.Count - 1 do
     result.Add(GetLabel(FileNumber,FieldNumbers[i]));
end; // function GetLabels
procedure TMAGBTMF1.LVUpdate(Results: TStrings;lv:TListView;delim: string);
var
   i,j,k,ColCnt : integer;
  NewColumn: TListColumn;
  ListItem: TListItem;
begin
   lv.Items.Clear;
   lv.Columns.Clear;
    if Results.Count > 0 then begin
      lv.ViewStyle := vsReport;
      lv.GridLines := true;
      lv.RowSelect := true;
      lv.MultiSelect := true;
      ColCnt := LastPiecePos(Results[0],delim);
      if ColCnt > 0 then begin{Create Column Labels}
        for k := 1 to ColCnt do begin
          NewColumn := lv.Columns.Add;
          NewColumn.Caption := piece(Results[0],delim,k);
          end;
        end;
      for i := 1 to Results.Count - 1 do begin   {Create ListItems}
        ListItem := lv.Items.Add;
       ListItem.Caption := piece(Results[i],delim,1);
        for j := 2 to ColCnt do
          ListItem.SubItems.Add(piece(Results[i],delim,j));
       end; //for i
      for i := 0 to lv.Columns.Count -1 do begin
        lv.Columns[i].AutoSize := true;   {AutoSize Columns}
        lv.Columns[i].width := columnheaderwidth;  {Set ColumnWidth}
        end;
      end; //if results
end; //LVUpdate



procedure TMAGBTMF1.OnException(e:Exception);

begin
   MAGBTMF1.Timer1.Enabled := false;
   MAGBTMF1.Timer2.Enabled := false;
   if Assigned(dmMain.RPCBroker1) then begin
     dmMain.RPCBroker1.free;
     dmMain.RPCBroker1 := nil;
     end;
   dmMain.RPCBroker1 := TRPCBroker.Create(nil);
   if not dmMain.RPCBroker1.Connected then begin
     eftfut.pause(6);
     if not dmMain.AutoLogin(dmMain.RPCBroker1,SilentAccess,SilentVerify,VServer,VPort,'SILENT',Division, 5, SELF) then
       repeat
         InvStrGrid(True,DateTimeToStr(Now)+'^Login Message^Silent Login attempt failed!',280,sgLatestTasks);
         InvStrGrid(True,DateTimeToStr(Now)+'^Login Message^Pausing 3 minutes and will then retry',280,sgLatestTasks);
         pause(180);
         if Assigned(dmMain.RPCBroker1) then begin
           dmMain.RPCBroker1.free;
           dmMain.RPCBroker1 := nil;
           end;
         dmMain.RPCBroker1 := TRPCBroker.Create(nil);
       until dmMain.AutoLogin(dmMain.RPCBroker1,SilentAccess,SilentVerify,VServer,VPort,'SILENT',Division, 5, SELF);
       MAGBTMF1.Timer1.Enabled := true;
       MAGBTMF1.Timer2.Enabled := true;
       end // if not dmMain.RPCBroker1.Connected
     else begin
       InvStrGrid(True,DateTimeToStr(Now)+'^Error Message^Non-Connection related Broker error',280,sgLatestTasks);
       ErrorLog('Broker Relogin','Exception Handle',E.ClassName+' '+E.Message);
       end; // else
end;
procedure TMAGBTMF1.RefreshQueueCounts1Click(Sender: TObject);
var i: integer;
  DisplayList: TStringList;
  Complete: boolean;
  begin
    repeat
      Complete := true;
      DisplayList := TStringList.Create;
      dmMain.fmlQueuePointer.Screen :='I $P(^(0),U,4)="'+IntToStr(magbtm1.place)+'"';
      //  ListerFlags := [lfExternal];
      try
        dmMain.fmlQueuePointer.GetList(DisplayList);
      except
        on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^RefreshQueueCounts1Click',280,sgLatestTasks);
        Complete := false;
        OnException(E);
        end; // on E:Exception
      end; //try...except
    until Complete;
    if dmMain.fmlQueuePointer.errorlist.Count > 0 then begin
      dmMain.fmlQueuePointer.displayErrors;
      DisplayList.Free;
      exit;
      end;
   if not Magbtm1.LogOn then begin
     Magbtm1.BPErrorLogSize := 0;
     magbtmf1.InitLogFile('log\BackProc\BackProc.LOG','BackProc_Log',true,Magbtm1.BackProcLogSize);
     Magbtm1.LogOn := true;
     end;
    for i := 1 to DisplayList.Count - 1 do begin
      frmSiteParameters.ReSetQueueCnt(DisplayList[i]);
      InvStrGrid(True,DateTimeToStr(Now)+'^Refresh Queue Counts^The '+DisplayList[i]+' has been re-synched.',280,sgLatestTasks);
      end;
    DisplayList.Free;
end;

procedure TMAGBTMF1.mnuQueueManagerClick(Sender: TObject);
begin
  if mnuQueueManager.Checked then begin
    frmSiteParameters.Close;
    mnuQueueManager.checked := false;
    end
  else begin
    mnuQueueManager.checked := true;
    try
      Application.CreateForm(TfrmSiteParameters,frmSiteParameters);
      frmSiteParameters.Top := MAGBTMF1.Top;
      frmSiteParameters.Left :=  MAGBTMF1.Left;
      frmSiteParameters.pcSiteParameters.ActivePageIndex := 5;
      frmSiteParameters.pcSiteParametersChange(frmSiteParameters.pcSiteParameters);
      frmSiteParameters.ShowModal;
    finally
      frmSiteParameters.Free;
      mnuQueueManager.checked := false;
      sbtnStart.SetFocus;
    end; //try...finally
    end; // else
end;

procedure TMAGBTMF1.mnuMailMessagesClick(Sender: TObject);
begin
   if mnuMailMessages.Checked then begin
    frmSiteParameters.Close;
    mnuMailMessages.checked := false;
    end
  else begin
    mnuMailMessages.checked := true;
    try
      Application.CreateForm(TfrmSiteParameters,frmSiteParameters);
      frmSiteParameters.Top := MAGBTMF1.Top;
      frmSiteParameters.Left :=  MAGBTMF1.Left;
      frmSiteParameters.pcSiteParameters.ActivePageIndex := 1;
      frmSiteParameters.pcSiteParametersChange(frmSiteParameters.pcSiteParameters);
      frmSiteParameters.ShowModal;
    finally
      frmSiteParameters.Free;
      mnuMailMessages.checked := false;
      sbtnStart.SetFocus;
    end; //try...finally
    end; // else
end;

procedure TMAGBTMF1.mnuMailGroupsClick(Sender: TObject);
begin
   if mnuMailGroups.Checked then begin
    frmSiteParameters.free;
    mnuMailGroups.checked := false;
    end
  else begin
    mnuMailGroups.checked := true;
    try
      Application.CreateForm(TfrmSiteParameters,frmSiteParameters);
      frmSiteParameters.Top := MAGBTMF1.Top;
      frmSiteParameters.Left :=  MAGBTMF1.Left;
      frmSiteParameters.pcSiteParameters.ActivePageIndex := 2;
      frmSiteParameters.pcSiteParametersChange(frmSiteParameters.pcSiteParameters);
      frmSiteParameters.ShowModal;
    finally
      frmSiteParameters.Free;
      mnuMailGroups.checked := false;
      sbtnStart.SetFocus;
    end; //try...finally
    end; // else
end;
function TMAGBTMF1.DateToFMInternal(ExDate:string):string;
begin
  result := IntToStr(YearOf(StrToDate(ExDate))-1700)+
        RightStr('0'+IntToStr(MonthOf(StrToDate(ExDate))),2)+
        RightStr('0'+IntToStr(DayOf(StrToDate(Exdate))),2);
end;


procedure TMAGBTMF1.Button1Click(Sender: TObject);
VAR
nSilentAccess, nSilentVerify: STRING;
begin
  nSilentAccess:= dmMain.GetVariable('$S($D(^MAG(2006.1,"'+IntToStr(magbtm1.place)+'","GW"))'+
    ':$P($G(^MAG(2006.1,"'+IntToStr(magbtm1.place)+'","GW")),U,1),1:0)');
  nSilentVerify:= dmMain.GetVariable('$S($D(^MAG(2006.1,"'+IntToStr(magbtm1.place)+'","GW"))'+
    ':$P($G(^MAG(2006.1,"'+IntToStr(magbtm1.place)+'","GW")),U,2),1:0)');
  nSilentAccess := hash.Decrypt(nSilentAccess);
  nSilentVerify := hash.Decrypt(nSilentVerify);
  Windows.MessageBox(MAGBTMF1.Handle,PChar('SilentAccess: '+nSilentAccess),' ',MB_SYSTEMMODAL);
  Windows.MessageBox(MAGBTMF1.Handle,PChar('SilentVerify: '+nSilentVerify),' ',MB_SYSTEMMODAL);
end;

procedure TMAGBTMF1.MergeStrings(Dest, Source: TStrings) ;
var j : integer;
begin
   for j := 0 to -1 + Source.Count do
     if Dest.IndexOf(Source[j]) = -1 then
       Dest.Add(Source[j]) ;
end;

procedure TMAGBTMF1.mnuImportQueueClick(Sender: TObject);
begin
  if mnuImportQueue.Checked then begin
    frmMagImportQueue.Close;
    mnuImportQueue.checked := false;
    end
  else begin
    mnuImportQueue.checked := true;
    Application.CreateForm(TfrmMagImportQueue, frmMagImportQueue);
    frmMagImportQueue.ShowModal;
    frmMagImportQueue.Free;
    mnuImportQueue.checked := false;
    end;
end;

procedure TMAGBTMF1.mnuPurgeRequeuebytype1Click(Sender: TObject);
begin
 Application.CreateForm(TfrmQPurgeByType,frmQPurgeByType);
 frmQPurgeByType.ShowModal;
 frmQPurgeByType.Free;
end;

procedure TMAGBTMF1.Button2Click(Sender: TObject);
var
  Filename,ShareIEN,share,path,source,ImageIen: string;

begin
  ImageIen :='3';
  Filename := trim(dmMain.GetFieldValue('2005','1',ImageIen+',','E',true));
  ShareIEN := dmMain.GetVariable('$S($D(^MAG(2005,'+ImageIen+',0)):+$P($G(^MAG(2005,'+ImageIen+',0)),U,3),1:0)');
  if ShareIEN = '0' then begin
    Windows.MessageBox(MAGBTMF1.Handle,PChar('No valid RAID share found^'),' ',MB_SYSTEMMODAL);
    exit;
    end;
  ShareIEN := dmMain.GetVariable('$S($$SLINE^MAGQBJB('+ShareIEN+')=1:'+ShareIEN+',1:0)');
  if ShareIEN = '0' then begin
    Windows.MessageBox(MAGBTMF1.Handle,PChar('The referenced RAID share is not on-line^'),' ',MB_SYSTEMMODAL);
    exit;
    end;
  share := trim(dmMain.GetFieldValue('2005.2','1',shareIEN+',','E',true));

 path := dmMain.GetVariable('$S(1:$$DIRHASH^MAGFILEB("'+Filename+'",'+ShareIEN+'))');
 Source := share+path+Filename;
 Windows.MessageBox(MAGBTMF1.Handle,PChar(source),' ',MB_SYSTEMMODAL);
end;

procedure TMAGBTMF1.Button4Click(Sender: TObject);
begin
  JukeBoxCacheSize('');
end;

procedure TMAGBTMF1.mnu508modeClick(Sender: TObject);
begin
  {toggle 508 Mode}
  if mnu508mode.Checked then mnu508mode.Checked := false
  else mnu508mode.Checked := true;
end;

procedure TMAGBTMF1.PDF1Click(Sender: TObject);
var MyFile : string;
begin
  MyFile := ExtractFilePath(Application.ExeName)+'help\MAG_BP_User_Manual.pdf';
  if fileexists(MyFile) then
    begin
      MagExecuteFile(MyFile, '', '', SW_SHOW);
      end;
end;

end.



