unit magbut;

interface
  uses
  Windows, SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, hash ,StdCtrls, Grids, ExtCtrls, MFunStr, filectrl,
  ComCtrls,Registry;

 function FSize(FilePath: string): integer;
 procedure InvStrGrid(input: string; RMax: Integer; var Grid: TStringGrid);
 function GetFileLastAccessTime(sFileName : string ) : TDateTime;
 function GetVolumeName(Drive : Byte) : String;
 function NextAvailDriveLetter(start: char): string;
 function CreateProcessSimple(sExecutableFilePath : string ): boolean;
 function GetAppVer(FilePath: string): string;
 function GetOSVersion(Sender: TObject): string;
 function GetCompName(Sender :TObject):string;
 function CreationDate(FileRec: TSearchRec):TDate;
 procedure PurgeFile(fname,ext: string;cnt: integer);
 function ArchName(OldRec:TSearchRec):string;
 procedure NewCreationDate(Path: string);
 function LastPiecePos(SubStr:String;Delim: String): integer;
 procedure lvUpdate(Clear:Boolean;List:TStringlist;lv:TListView);
implementation
Function LastPiecePos(SubStr:String;Delim: String): integer;
Var
Count: integer;
begin
count := 0;
while pos(Delim,SubStr) <> 0 do
 begin
   inc(count);{count := count + pos(Delim,SubStr);}
   SubStr := Copy(SubStr,pos(Delim,SubStr)+1,9999);
 end;
 if count > 0 then inc(count);
 LastPiecePos := count;
end;

procedure NewCreationDate(Path: string);
  var
    NewfileTime : TFileTime;
    TempFileHandle: Integer;
    CurrentSystemTime: TSystemTime;
  begin
    GetLocalTime(CurrentSystemTime);
    if SystemTimeToFileTime(CurrentSystemTime,NewfileTime) then begin
      TempFileHandle := FileOpen(path,fmOpenWrite);
      if not SetFileTime(TempFileHandle,@NewFileTime,nil,nil) then
        ShowMessage('CreationDate: SetFileTime Failed '+IntToStr(GetLastError)+ ': '
        + SysErrorMessage(GetLastError));
      FileClose(TempFileHandle);
      end;
  end;


 function ArchName(OldRec:TSearchRec):string;
 var
   DateString,DayStr,MonthStr: string;
   Year,Month,Day:word;
 begin
   DecodeDate(CreationDate(OldRec),Year,Month,Day);
   DayStr := IntToStr(Day);
   if Length(dayStr) < 2 then DayStr := '0' + DayStr;
   MonthStr := IntToStr(Month);
   if Length(MonthStr) < 2 then MonthStr := '0' + MonthStr;
   DateString := IntToStr(Year)+ '_'+MonthStr + '_' + DayStr ;
   Result := ExtractFilePath(Application.ExeName)+
   piece(OldRec.name,ExtractFileExt(OldRec.name),1)+DateString+
     ExtractFileExt(OldRec.name);
 end;

  procedure PurgeFile(fname,ext: string;cnt: integer);
  var
    rec: TSearchRec;
      i: integer;
    pfpath: string;
    fileList: TStringList;
  begin
    pfpath := ExtractFilePath(Application.ExeName)+ fname+ '*';
    if FindFirst(pfPath,(faDirectory),Rec) = 0 then begin
      fileList := TStringList.Create;
      if fname+ext <> rec.name then fileList.Add(Rec.Name);
      while FindNext(Rec) = 0 do if fname+ext<>rec.name then fileList.Add(Rec.Name);
      if fileList.Count > cnt then begin
        filelist.Sorted := true;
        for i := 0 to (filelist.Count-cnt)-1 do
          SysUtils.DeleteFile(ExtractFilePath(Application.ExeName)+FileList.Strings[i]);
        end;
      fileList.Free;
      end;
    SysUtils.FindClose(Rec);
  end;

  function CreationDate(FileRec: TSearchRec):TDate;
  var
    SystemTime: TSystemTime;
  begin
    FileTimeToSystemTime(FileRec.finddata.ftCreationTime,
     SystemTime);
    with SystemTime do
      CreationDate:= EncodeDate(wyear,wmonth,wday);
  end;

function GetCompName(Sender :TObject):string;
var
  lpBuffer: pchar;
 nSize: dWord;
 // k: integer;
begin
 result :='';
 //lpBuffer := stralloc(100);
 GetMem(lpBuffer,100);
 nSize := 100;
 try
   if GetComputerName(lpBuffer,nSize) then
     result := strpas(lpbuffer) ;
 except
   on exception do showmessage('GetCompName Error: '+inttoStr(GetLastError));
 end;
 //StrDispose(lpBuffer);
 FreeMem(lpBuffer);
end;

function GetAppVer(FilePath: string): string;
var
  lpData  : PChar;
  xword, lpdwHandle,dwlen : Dword;
  lp,lpfilename: pointer;
  begin
    xword:=0;
    result:='';
  try
    lpFilename := pchar(FilePath);     // test code
    dwlen := GetFileVersionInfoSize(lpFilename,lpdwHandle);
    GetMem(lpdata,dwlen+1);
  if GetFileVersionInfo(lpFilename,xword,dwlen,lpdata) then begin
    VerQueryValue(lpdata,'\\StringFileInfo\\040904e4\\FileVersion',lp,dwlen);
    result := pchar(lp);
    end;
  finally
   FreeMem(lpdata);
   end;
end;
function GetOSVersion(sender:TObject): string;
var
   VersionInfo: TOSVersionInfo;
   Platform: string;
begin
  VersionInfo.dwOSVersionInfoSize := SizeOf(VersionInfo);
  GetVersionEx(VersionInfo);
  with VersionInfo do begin
    case dwPlatformId of
      VER_PLATFORM_WIN32s       {0} : Platform := 'Win32s';
      VER_PLATFORM_WIN32_WINDOWS{1} :
        case dwMinorVersion of
          0  : Platform := 'Win 95';
          10 : Platform := 'Win 98';
          90 : Platform := 'Win Me';
          end; //  case dwMinorVersion of
      VER_PLATFORM_WIN32_NT     {2} :
        case dwMajorVersion of
          4 : Platform := 'Win NT' ;
          5 : begin
            if dwMinorVersion = 0 then
                Platform := 'Win Server 2000';
            if dwMinorVersion = 1 then
                Platform := 'Win XP';
            if dwMinorVersion = 2 then
                Platform := 'Win Server';
              end; // Case of 5
          6 : begin
            if dwMinorVersion = 0 then
                Platform := 'Win Server 2008';
            if dwMinorVersion = 1 then
                Platform := 'Win Server 2008 R2';
           end; // Case of 5
          end; //  case dwMajorVersion
     end; //case dwPlatformId
    result := platform+ '.'+inttostr(dwMajorVersion)+'.'+inttostr(dwMinorVersion)+'.'+
    inttostr(dwBuildNumber);
    end;
end;


function FSize(FilePath: string): integer;
var
  FileRec:TSearchRec;
begin
  result:= FindFirst(FilePath,faAnyFile,FileRec);
  if result = 0 then result := FileRec.Size;
  FindClose(FileRec.FindHandle);
end;

procedure InvStrGrid(input: string; RMax: Integer; var Grid: TStringGrid);
var
i,k :integer;
const delimit: string = '^';
begin
  with Grid do
    begin
      ColCount := LastPiecePos(input,delimit);
//  DefaultColWidth :=Width div Grid.ColCount;
      if RowCount < Rmax + 1 then RowCount := RowCount + 1;
      for i :=  RowCount downto FixedRows + 1 do
      for k := ColCount downto FixedCols do
        begin
          cells[k,i] := cells[k,i-1];
        end;
      for i := ColCount - 1 downto FixedCols do
        cells[i,FixedRows] := piece(input,delimit,((i+1)-FixedCols));
      Update;
    end;
end;


function GetFileLastAccessTime(sFileName : string ) : TDateTime;
  //"GetFileLastAccessTime()" will simply return the file's last access time as a
  //Delphi's TDateTime type which you can convert to a string by using the
  //"DateTimeToStr()" function.
var
  ffd : TWin32FindData;
  dft : DWord;
  lft : TFileTime;
  h   : THandle;
begin
  h := Windows.FindFirstFile(PChar(sFileName), ffd);
  if(INVALID_HANDLE_VALUE <> h) then
    begin
      // we're looking for just one file, so close our "find"
      Windows.FindClose( h );
      // convert the FILETIME to local FILETIME
      FileTimeToLocalFileTime(ffd.ftLastAccessTime, lft );
      // convert FILETIME to DOS time
      FileTimeToDosDateTime(lft,LongRec(dft).Hi, LongRec(dft).Lo);
      // finally, convert DOS time to TDateTime for use in Delphi's
      // native date/time functions
      Result := FileDateToDateTime(dft);
      //ffd.free;
      if pos('97',DateTimeToStr(result))=0 then
        showmessage(DateTimeToStr(result));
    end
  else
    begin
      Result := -1;
      showmessage('invalid file handle '+sfilename);
    end;
end;



function GetVolumeName(Drive : Byte) : String;
var
 DriveLetter  : Char;
 NoMatter     : DWord;
 VolumeName   : Array[0..MAX_PATH] of Char;
begin
 DriveLetter  := Char(Drive + $41);
 GetVolumeInformation(PChar(DriveLetter + ':\'), VolumeName,
   SizeOf(VolumeName),nil,NoMatter, NoMatter, Nil,0);
 Result := VolumeName;
end;

function NextAvailDriveLetter(start:char):string; //TMAGBTMF1.
var
   DriveLetter:char;
   index:integer;
   done: boolean;
begin
index :=(ord(start)-$41) ;{start at f}
done:=false;
repeat
  inc(index);
  Driveletter:= chr(index+$40);
  if GetDriveType(pchar(DriveLetter+':\'))=1 then done:=true;
until (index=26) or (done);
if done then result := DriveLetter+':'
else result :='0';
end;

function CreateProcessSimple(sExecutableFilePath : string ): boolean;
  var
    pi: TProcessInformation;
    si: TStartupInfo;
    CreateOK: boolean;
  begin
    FillMemory( @si, sizeof( si ), 0 );
    si.cb := sizeof( si );
    CreateOK := CreateProcess(Nil,PChar( sExecutableFilePath ),
      Nil, Nil, False, NORMAL_PRIORITY_CLASS, Nil, Nil,si, pi );
    // "after calling code" such as the code to wait until the
    // process is done should go here
    if CreateOK then //may or may not be needed. Usually wait for child processes
      WaitForSingleObject(PI.hProcess, INFINITE);
      CloseHandle( pi.hProcess );
      CloseHandle( pi.hThread );
      result := true;
  end;
procedure lvUpdate(Clear:Boolean;List:TStringlist;lv:TListView);
var
  i,j,k: integer;
  NewColumn: TListColumn;
  ListItem: TListItem;
begin
  if clear then begin
    lv.Items.Clear;
    lv.Columns.Clear;
    end;
  if list.Count>0 then begin
    lv.ViewStyle := vsReport;
    lv.GridLines := true;
    for k := 1 to LastPiecePos(list.Strings[0],'^') do begin
      NewColumn := lv.Columns.Add;
      NewColumn.Caption := piece(list.Strings[0],'^',k);
      end;
    for i := 1 to list.Count -1 do begin   {Create ListItems}
      ListItem := lv.Items.Add;
      ListItem.Caption :=piece(list.strings[i],'^',1 );
      for j := 2 to LastPiecePos(list.Strings[i],'^') do
          ListItem.SubItems.Add(piece(list.strings[i],'^',j));
      end; //for i
    for i := 0 to lv.Columns.Count -1 do begin
      lv.Columns[i].AutoSize := true;   {AutoSize Columns}
      lv.Columns[i].width := columnheaderwidth;  {Set ColumnWidth}
      end;
    end; //if results
  lv.Items[lv.Items.Count-1].Selected := true;
end; //lvUpdate



end.


