unit magpurge3;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Trpcb, MFunstr,StdCtrls,FileCtrl, OleCtrls, graphsv3, ExtCtrls, magbut,
  splVista,eftfut, Menus, isp3;


type
  TMagSitePurgeParam = RECORD
    FilePrefix: string;
    MinAbs: integer;
    MinFull: integer;
    MinBig: integer;
    abs_KeepDays: integer;
    pacsabs_KeepDays: integer;
    full_KeepDays: integer;
    pacs_KeepDays: integer;
    big_KeepDays: integer;
    bigpacs_KeepDays: integer;
    radholds: boolean;
  end;
  TMagFileServer = RECORD
    ServerName : String[100];
    ServerSize : integer;
    Space      : integer;
  end;
  TMagPurgeCount = RECORD
    abs: integer;
    pacsabs: integer;
    full: integer;
    pacs: integer;
    big: integer;
    bigpacs: integer;
    text: integer;
  end;
  TMagPurge = class(TForm)
    splButton: TSplitter;
    pnlGraphs: TPanel;
    pnlDeleteCount: TPanel;
    grphCachePurge: TGraph;
    pnlStartServer: TPanel;
    grphOriginalServers: TGraph;
    pnlProcGroup: TPanel;
    btnPurge: TButton;
    gbActivities: TGroupBox;
    lblStartTime: TLabel;
    lblRunTime: TLabel;
    lblFileCnt: TLabel;
    lblDelCnt: TLabel;
    lblSTData: TLabel;
    lblRTData: TLabel;
    lblTFPData: TLabel;
    lblPCData: TLabel;
    gbShares: TGroupBox;
    lbServers: TListBox;
    gbPurgeFiles: TGroupBox;
    lbPaths: TListBox;
    TCP1: TTCP;
    lblJBques: TLabel;
    lblJBqueData: TLabel;
    function Purge(FilePath: string): boolean;
    function Getlist(var ServerList:TStringList): Boolean;
    function PurgeParam:boolean;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    function DeleteCriteria(var Criteria: string;
       FPath: string; FileRec: TSearchRec): boolean;
    procedure LogFile(filepath,DataItem:string);
    function JBQueue(RecNo: string):string;
    procedure btnPurgeClick(Sender: TObject);
    procedure CacheUpdate(filepath,fname,ien: string);
    procedure init;
    function TxtLastFile(FilePath:string):boolean;
    function LastAccessDate(FileRec: TSearchRec):TDate;
    procedure mWait(AMsec:Word);
    procedure GraphicUpdate(CacheCount,PurgeCount:TMagPurgeCount);
    procedure TBUpdate;
    procedure Summary;
    procedure Elog;
    procedure InitLogFile(filepath:string; cnt: integer);
    function MagUpdate(FileName,ext,ien, device: string): Boolean;
    procedure InitVariables;
    procedure Button1Click(Sender: TObject);
    function ImageDel(IEN:string):boolean;
    function FileSizeZero(Path:string): boolean;
    //DEVELOPMENT TEST METHODS
//    function DirListNext(fpath: string): boolean;

  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  MagPurge: TMagPurge;
  SitePurgeParam: TMagSitePurgeParam;
  PurgeCount: TMagPurgeCount;
  CacheCount: TMagPurgeCount;
  CurrentShare: string[100];
  LogOn: boolean;
  WSID,JOBID: string;
  FileCount,DeleteCount,JBQCount: integer;
  StartTime: TTime;
  yBroker : TRPCBroker;
  intSaveRPCTimeLimit: integer;

const
  AbsType  = '^.abs^.tif^.jpg^';
  TimeLimit = 90;
implementation

  uses  MagPerResults, Magbtm1;

{$R *.DFM}
function TMagPurge.Purge(FilePath: string): boolean;
function DirCheck(SearchRec: TSearchRec):boolean;
begin
  result := false;
  if (SearchRec.FindData.dwFileAttributes mod 32) div 16 = 1 then
    result := true;
end;
function ImageFile(FileName:string):boolean;
var
  prefix: string;
  i,code: integer;
begin
Result:= false;
prefix := SitePurgeParam.FilePrefix;
if pos(prefix,FileName)= 1 then
  begin           {test prefixless filename for integer value}
    val(piece(piece(Filename,ExtractFileExt(Filename),1),prefix,2),i,code);
    if code = 0 then result:= true;
    if i<>0 then;
  end;
end;
var
  FileRec:TSearchRec;
  Criteria: string;
begin  //Purge
 result := true;
 if FindFirst(FilePath,(faDirectory),FileRec) = 0 then
    repeat
      if Length(ExtractFilePath(FileRec.name)) > 0 then ShowMessage(FileRec.name);
      if DirCheck(FileRec) then begin
        if ((FileRec.name<>'.') and (FileRec.name<>'..')) then {not self/parent}
            Purge(ExtractFilePath(FilePath)+FileRec.Name+'\*.*');
        end
      else begin // process as image file;
        inc(FileCount);
        if FileCount mod 1000 = 0 then GraphicUpdate(CacheCount,PurgeCount);
        // purge txt when last of image filename
        if (LowerCase(ExtractFileExt(FileRec.Name))='.txt') and
          (ImageFile(FileRec.Name)) then begin
          inc(CacheCount.text);
          if TxtLastFile(ExtractFilePath(FilePath)+FileRec.Name) then begin
            DeleteFile(ExtractFilePath(FilePath)+FileRec.Name);
            inc(PurgeCount.text);
            inc(DeleteCount);
            if lbPaths.Items.Count > 50 then lbPaths.clear;
            lbPaths.Items.Add(format('%s - %s',[piece(ExtractFilePath(FilePath),
              ExtractFileDrive(FilePath),2)+FileRec.Name,
              DateTimeToStr(LastAccessDate(FileRec))]));
            lbPaths.Update;
            if LogOn then LogFile('Purge.Log','TxtLastFile'+ '^'+
              ExtractFilePath(FilePath)+FileRec.Name+
              DateTimeToStr(LastAccessDate(FileRec)));
            end; //If TextLastFile
            continue;
          end; //If LowerCaseExt
      if DeleteCriteria(Criteria,FilePath,FileRec) then begin
        if DeleteFile(ExtractFilePath(FilePath)+FileRec.Name) then begin
          if not MagUpdate(FileRec.Name,piece(ExtractFileExt(FileRec.Name),'.',2),
            piece(Criteria,'^',6),'NET') then ShowMessage('Should have been updated: '+
            ExtractFilePath(FilePath)+FileRec.Name+'^'
            +DateTimeToStr(LastAccessDate(FileRec)))
          else if (pos('6',piece(criteria,'^',1))<>0) and
                (pos('13',piece(criteria,'^',3))<>0) then
            ImageDel(piece(criteria,'^',6));
          if lbPaths.Items.Count > 50 then lbPaths.clear;
          lbPaths.Items.Add(format('%s - %s',[piece(ExtractFilePath(FilePath),
            ExtractFileDrive(FilePath),2)+ FileRec.Name,
            DateTimeToStr(LastAccessDate(FileRec))]));
          lbPaths.Update;
          if LogOn then
            LogFile('Purge.Log',criteria+'^'+ExtractFilePath(FilePath)+FileRec.Name+'^'
            +DateTimeToStr(LastAccessDate(FileRec)));
          end   //IF DeleteFile
        else ShowMessage('Should have been purged: '+ExtractFilePath(FilePath)+FileRec.Name+'^'
          +DateTimeToStr(LastAccessDate(FileRec)));
      end; // Delete Criteria
    {LogFile('Purge.Log',criteria+'^NOT PURGED'+ExtractFilePath(FilePath)+FileRec.Name+'^'
          +DateTimeToStr(LastAccessDate(FileRec)));}
     end; //else image file
    Application.ProcessMessages;
    mWait(5);
  if FileCount mod 10 = 0 then TBUpdate;
  until FindNext(FileRec) <> 0
 else showmessage('Findfirst failed: '+ FilePath+' '+ FileRec.Name);// empty directory
  FindClose(FileRec);
end;// Purge
function TMagPurge.DeleteCriteria(var Criteria: string;
             FPath: string; FileRec: TSearchRec): boolean;
function TimeDifference(days: integer): boolean;  //if #days + DateLastAccessed
  var                                             //<today then true
    SystemTime: TSystemTime;
    FileTA: TDate;
  begin
    result:= false;
    FileTimeToSystemTime(FileRec.finddata.ftLastAccessTime,SystemTime);
    with SystemTime do
      FileTA:= EncodeDate(wyear,wmonth,wday);
    if FileTA + days < date then result := true;
  end;
function Age(ReturnStr: string; FileType:integer): boolean;
begin
  case FileType of
   0: if piece(ReturnStr,'^',2) = '1' then //PACS ABS
           result := TimeDifference(SitePurgeParam.pacsabs_KeepDays)
      else result := TimeDifference(SitePurgeParam.abs_KeepDays);
   1: if piece(ReturnStr,'^',2) = '1' then
        result := TimeDifference(SitePurgeParam.bigpacs_KeepDays)
      else result := TimeDifference(SitePurgeParam.big_KeepDays);
   2: if piece(ReturnStr,'^',2) = '1' then //PACS
        result := TimeDifference(SitePurgeParam.PACS_KeepDays)
      else result := TimeDifference(SitePurgeParam.FULL_KeepDays);
   else result := false;
  end;  // case
end; //age
function MinimumAge(Extension:string;
  SitePurgeParam:TMagSitePurgeParam; ftype: integer): boolean;
begin
  case ftype of
   0: result:=TimeDifference(SitePurgeParam.MinAbs);
   1: result:=TimeDifference(SitePurgeParam.MinBig);
   2: result:=TimeDifference(SitePurgeParam.MinFull);
   else result := false;
  end; {case}
end;
function ftype(ext:string): integer;
begin
   if pos('^'+ext+'^',AbsType) <> 0 then begin
     ftype := 0;
     exit;
     end;
   if ext ='.big' then begin
     ftype := 1;
     exit;
     end;
   ftype := 2;
end;
procedure DelCnt(fileType: integer;pacs: string);
begin
  inc(DeleteCount);
  case fileType of
    0: if pacs = '1' then inc(PurgeCount.pacsabs)
       else inc(PurgeCount.abs);
    1: if pacs = '1' then inc(PurgeCount.bigpacs)
       else inc(PurgeCount.big) ;
    2: if pacs = '1' then inc(PurgeCount.pacs)
       else inc(PurgeCount.full);
  end;
end;

var
  ReturnStr,Extension: string;
  Action,filetype: integer;
begin  // DeleteCriteria
  result := false;
  Extension := LowerCase(ExtractFileExt(FileRec.Name));
  filetype := ftype(Extension);
  if not MinimumAge(Extension,SitePurgeParam,filetype) then begin
    case filetype of //This code optimizes the purge & desensitizes PACS differentiation
      0: inc(CacheCount.abs);
      1: inc(CacheCount.big);
      2: inc(CacheCount.full);
      end; //case
    exit;
    end;
  with yBroker do begin
    Param[0].VALUE := ExtractFilePath(FPath);
    Param[0].PTYPE := LITERAL;
    Param[1].VALUE := FileRec.Name;
    Param[1].PTYPE := LITERAL;
    Param[2].VALUE := piece(Extension,'.',2);
    Param[2].PTYPE := LITERAL;
    Param[3].VALUE := CurrentShare;
    Param[3].PTYPE := LITERAL;
    if SitePurgeParam.RadHolds then Param[4].VALUE := '1'
    else Param[4].VALUE := '0';
    Param[4].PTYPE := LITERAL;
    RemoteProcedure := 'MAGQBP FREF';
    intSaveRPCTimeLimit := RPCTimeLimit;  {save off current time limit}
    RPCTimeLimit := TimeLimit;   {can take up to a minute to complete}
    try
      Call;       //call
      RPCTimeLimit := intSaveRPCTimeLimit;
    except
      On E: EBrokerError do begin
        RPCTimeLimit := intSaveRPCTimeLimit;
        LogFile('PurgeError.Log','Delete Criteria^'+ E.ClassName+'^'+E.Mnemonic+'^'+E.Message+'^'+E.Action);
        application.Terminate;
        end;
     end;
   ReturnStr := Results[0];
  end;  // with yBroker
 CRITERIA := ReturnStr;
 case filetype of
    0: if piece(ReturnStr,'^',2) = '1' then inc(CacheCount.pacsabs)
       else inc(CacheCount.abs);
    1: if piece(ReturnStr,'^',2) = '1' then inc(CacheCount.bigpacs)
       else inc(CacheCount.big);
    2: if piece(ReturnStr,'^',2) = '1' then inc(CacheCount.pacs)
       else inc(CacheCount.full);
    end; //case
  if piece(ReturnStr,'^',2) = '1' then inc(CacheCount.pacs);
  Action := StrToInt(piece(ReturnStr,'^',1));
  case Action of
   -1,-3 : result := false ;
   -2 : begin result := false; inc(JBQCount); end;
   0 : result := true;
   2 :
     if FileExists(ExtractFilePath(FPath)+'\'+ChangeFileExt(FileRec.Name,'.TGA')) and
       not FileSizeZero(ExtractFilePath(FPath)+'\'+ChangeFileExt(FileRec.Name,'.TGA')) then
       result:= TimeDifference(SitePurgeParam.BIGPACS_KeepDays);
   1 :
     if (not FileExists(piece(ReturnStr,'^',5))) or (FileSizeZero(piece(ReturnStr,'^',5))) then begin
       //MagUpdate(FileRec.Name,piece(ExtractFileExt(FPath),'.',2),piece(ReturnStr,'^',6),'JB');
       ReturnStr := ReturnStr + '^'+ JBQueue(piece(ReturnStr,'^',6));
       end
     else result := Age(ReturnStr,filetype);
   3 :
     begin
       if FileExists(piece(ReturnStr,'^',4)) and (not FileSizeZero(piece(ReturnStr,'^',4))) then
         result := true // FILE EXISTS AT ALTERNATE SITE
       else
         begin
           result := Age(ReturnStr,filetype);
           if not result and (not FileSizeZero(piece(ReturnStr,'^',6))) then // IF NOT PURGING AT LEAST FIX POINTERS
             CacheUpdate(ExtractFilePath(FPath),FileRec.Name,piece(ReturnStr,'^',6));
         end;
     end;
   5 :
     begin
       if FileExists(piece(ReturnStr,'^',4)) and FileSizeZero(piece(ReturnStr,'^',4)) then
         result := true;  // good copy at alternate site (pointed to site)
       if not FileExists(piece(ReturnStr,'^',5)) or FileSizeZero(piece(ReturnStr,'^',5)) then begin
         //MagUpdate(FileRec.Name,piece(ExtractFileExt(FPath),'.',2),piece(ReturnStr,'^',6),'JB');
         if not result then CacheUpdate(ExtractFilePath(FPath),FileRec.Name,piece(ReturnStr,'^',6));
         ReturnStr := ReturnStr + '^'+ JBQueue(piece(ReturnStr,'^',6));
         end;
     end;
   6 :   result := Age(ReturnStr,filetype);
  end; // Case of Action
  if result then DelCnt(filetype,piece(ReturnStr,'^',2));
end; //TMagPurge.DeleteCriteria
procedure TMagPurge.CacheUpdate(filepath,fname,ien: string);
begin
  with yBroker do begin
    Param[0].VALUE := filepath;
    Param[0].PTYPE := LITERAL;
    Param[1].VALUE := fname;
    Param[1].PTYPE := LITERAL;
    Param[2].VALUE := piece(ExtractFileExt(fname),'.',2);
    Param[2].PTYPE := LITERAL;
    Param[3].VALUE := ien;
    Param[3].PTYPE := LITERAL;
    RemoteProcedure := 'MAGQ CUPDTE';
    intSaveRPCTimeLimit := RPCTimeLimit;  {save off current time limit}
    RPCTimeLimit := TimeLimit;   {can take up to a minute to complete}
    try
      Call;       //call
      RPCTimeLimit := intSaveRPCTimeLimit;
    except
      On E: EBrokerError do begin
        RPCTimeLimit := intSaveRPCTimeLimit;
        LogFile('PurgeError.Log','Cache Update^'+E.ClassName+'^'+E.Mnemonic+'^'+E.Message+'^'+E.Action);
        exit;
        end;
     end; //try
  end; // with yBroker
end; // CacheUpdate

function TMagPurge.FileSizeZero(Path:string): boolean;
var
  SearchRec: TSearchRec;
begin
  FindFirst(Path,faAnyFile,SearchRec);  //get original Last Access Time Stamp
  Result := not (SearchRec.Size>0) ;
  FindClose(SearchRec);
end;

function TMagPurge.Getlist(var ServerList:TStringList): Boolean;
begin
  yBroker.RemoteProcedure := 'MAGQBP ALL SHARES';
  intSaveRPCTimeLimit := yBroker.RPCTimeLimit;  {save off current time limit}
  yBroker.RPCTimeLimit := TimeLimit;   {can take up to a minute to complete}
  try
    yBroker.LSTCALL(ServerList);
    yBroker.RPCTimeLimit := intSaveRPCTimeLimit;
  except
    On E: EBrokerError do begin
      LogFile('PurgeError.Log','GetList'+'^'+E.ClassName+'^'+E.Mnemonic+'^'+E.Message+'^'+E.Action);
      Application.terminate;
      end;
  end; // try
  if ServerList.count > 0 then result:= true
  else result:= false;
end; //Getlist

function TMagPurge.MagUpdate(FileName,ext,ien,device: string): Boolean;
begin
  with yBroker do
    begin
      Param[0].VALUE := FileName;
      Param[0].PTYPE := LITERAL;
      Param[1].VALUE := ext;
      Param[1].PTYPE := LITERAL;
      Param[2].VALUE := ien;
      Param[2].PTYPE := LITERAL;
      Param[3].VALUE := device;
      Param[3].PTYPE := LITERAL;
      RemoteProcedure := 'MAGQBP UPDATE';
      intSaveRPCTimeLimit := RPCTimeLimit;  {save off current time limit}
      RPCTimeLimit := TimeLimit;   {can take up to a minute to complete}
      try
        Call;       //call
        RPCTimeLimit := intSaveRPCTimeLimit;
      except
        On E: EBrokerError do begin
          RPCTimeLimit := intSaveRPCTimeLimit;
          LogFile('Purge.Log','PurgeUpdate'+'^'+E.ClassName+'^'+E.Mnemonic+'^'+E.Message+'^'+E.Action);
          Application.terminate;
          end;
      end; // try
      if piece(Results[0],'^',1) = '1' then result := true
      else result := false;
    end;
end;

function TMagPurge.PurgeParam:boolean;
//;; MinAbs^MinFull^MinBig^ABS^PACABS^FULL^PACS^BIG^RADHOLDS
//  yBroker.Param[0].VALUE := proc + '^' + input;
//  yBroker.Param[0].PTYPE := LITERAL ;
 begin
  with yBroker do begin
    RemoteProcedure := 'MAGQBP PARM';
    intSaveRPCTimeLimit := RPCTimeLimit;  {save off current time limit}
    RPCTimeLimit := TimeLimit;   {can take up to a minute to complete}
    try
      Call;       //call
      RPCTimeLimit := intSaveRPCTimeLimit;
    except
      On E: EBrokerError do begin
        LogFile('PurgeError.Log','GetQueue'+'^'+E.ClassName+'^'+E.Mnemonic+'^'+E.Message+'^'+E.Action);
        Application.terminate;
        end;
    end; // try
    if StrToInt(piece(Results[0],'^',1)) = 1 then begin
      result := true;
      SitePurgeParam.MinAbs := StrToInt(piece(Results[0],'^',2));
      SitePurgeParam.MinFull := StrToInt(piece(Results[0],'^',3));
      SitePurgeParam.MinBig := StrToInt(piece(Results[0],'^',4));
      SitePurgeParam.abs_KeepDays := StrToInt(piece(Results[0],'^',5));
      SitePurgeParam.pacsabs_KeepDays := StrToInt(piece(Results[0],'^',6));
      SitePurgeParam.full_KeepDays := StrToInt(piece(Results[0],'^',7));
      SitePurgeParam.pacs_KeepDays := StrToInt(piece(Results[0],'^',8));
      SitePurgeParam.big_KeepDays := StrToInt(piece(Results[0],'^',9));
      SitePurgeParam.bigpacs_KeepDays := StrToInt(piece(Results[0],'^',10));
      if piece(Results[0],'^',11)= '1' then SitePurgeParam.radholds := true
      else SitePurgeParam.radholds := false;
      SitePurgeParam.FilePrefix := piece(Results[0],'^',12);
      //result := VerifyParam(SitePurgeParam);
      end
    else result := false;
  end; // with RPCBroker1
end;
procedure TMagPurge.LogFile(filepath,DataItem:string);
var
logfile: textfile;
  begin
    if not FileExists(ExtractFilePath(Application.ExeName) + filepath) then
      FileClose(FileCreate(ExtractFilePath(Application.ExeName) + filepath));
    AssignFile(logfile,ExtractFilePath(Application.ExeName)+filepath);
    Append(logfile);
    Writeln(logfile,DataItem);
    Flush(logfile);
    CloseFile(logfile);
  end;// LogFile
procedure TMagPurge.FormCreate(Sender: TObject);
procedure FormSave(Sender: TObject);
var
  FormImage: TBitmap;
begin
  FormImage := GetFormImage;
try
  FormImage.SaveToFile(ExtractFilePath(Application.ExeName)+'BP_Purge.bmp');finally
  FormImage.Free;
end; //try...finally
end;// FormSave
begin
{  Application.HelpFile :='EFTFUT.HLP';}
  Application.ShowHint := True;
  application.HintPause :=1000;
  application.HintHidePause := 8000;
  Application.HintColor := clAqua;
  logon:= true;
 // mnuImageVer.Enabled := false;
//  mnuPurgeResults.Enabled := false;
  MAGBTMF1.security2(yBroker);
  init;
   Caption := Format('%s - %s %s %s',
    [Application.Title ,TimeToStr(Now),'         WS ID: '
      +WSID,'     JOB ID: '+JOBID]);
   MagPurge.Update;
 //  FormSave(self);
end;  //FormCreate
procedure TMagPurge.init;
var
ProcList: TStringList;
begin
  ProcList := TStringList.Create;
  with yBroker do
    begin
        Param[0].VALUE := CompName; //tcp1.LocalHostName;
        Param[0].PTYPE := LITERAL ;
        Param[1].VALUE := 'Purge';
        Param[1].PTYPE := LITERAL ;
        RemoteProcedure := 'MAGQ ABP';
        intSaveRPCTimeLimit := RPCTimeLimit;  {save off current time limit}
        RPCTimeLimit := TimeLimit;   {can take up to a minute to complete}
        try
          LSTCALL(ProcList);
          RPCTimeLimit := intSaveRPCTimeLimit;
        except
          On E: EBrokerError do begin
          LogFile('Purge.Log','GetQueue^'+E.ClassName+'^'+E.Mnemonic+'^'+E.Message+'^'+E.Action);
          ProcList.free;
          Application.Terminate;
          end;
      end;  //try
   end; //with RPCBroker1
  WSID := piece(ProcList[0],'^',4)+' - '+piece(ProcList[0],'^',5);
  JOBID := piece(ProcList[0],'^',3);
  ProcList.Free;
end;
procedure TMagPurge.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  MAGBTMF1.mnuPurge.checked := false;
  MAGBTMF1.Show;
end;//FormClose
function TMagPurge.ImageDel(IEN:string):boolean;
var
  Value : TStringList;
begin
  Result := false;
  Value := TStringList.Create;
  with yBroker do
    begin
        Param[0].VALUE :=IEN;
        Param[0].PTYPE := LITERAL ;
        Param[1].VALUE := '0';
        Param[1].PTYPE := LITERAL ;
        RemoteProcedure := 'MAGQ DIK';
        intSaveRPCTimeLimit := RPCTimeLimit;  {save off current time limit}
        RPCTimeLimit := TimeLimit;   {can take up to a minute to complete}
        try
          LSTCALL(Value);
          RPCTimeLimit := intSaveRPCTimeLimit;
        except
          On E: EBrokerError do begin
          LogFile('Purge.Log','ImageDel^'+E.ClassName+'^'+E.Mnemonic+'^'+E.Message+'^'+E.Action);
          Value.free;
          Application.Terminate;
          end;
      end;  //try
   end; //with RPCBroker1
  Value.free;
  Result := true;
end; // ImageDel
function TMagPurge.JBQueue(RecNo: string):string;
begin
  inc(JBQCount);
  with yBroker do
    begin
      Param[0].VALUE := RecNo;
      Param[0].PTYPE := LITERAL;
      RemoteProcedure := 'MAGQ JBQUE';
      intSaveRPCTimeLimit := RPCTimeLimit;  {save off current time limit}
      RPCTimeLimit := TimeLimit;   {can take up to a minute to complete}
      try
        Call;       //call
        RPCTimeLimit := intSaveRPCTimeLimit;
      except
        On E: EBrokerError do begin
          LogFile('PurgeError.Log','JBQueue^'+E.ClassName+'^'+E.Mnemonic+'^'+E.Message+'^'+E.Action);
          Application.terminate;
          end;
      end; // try
      JBQueue := Results[0];
    end;
end;
procedure TMagPurge.btnPurgeClick(Sender: TObject);
var
  ServerIndex: integer;
  ServerList: TStringlist;
begin
  InitLogFile('Purge.Log',5);
  InitLogFile('PurgeError.Log',5);
  InitVariables;
  Application.CreateForm(TfrmPurgeResults,frmPurgeResults);
  frmPurgeResults.Visible := false;
  frmPurgeResults.lbResults.Clear;
 // mnuPurgeResults.Enabled := false;
  ServerList := TStringList.Create;
  lbServers.Clear;
  lbServers.Update;
  StartTime := Time;
  lblSTData.Caption := TimeToStr(StartTime);
  MagPurge.Update;
  if PurgeParam and GetList(ServerList) then
    for ServerIndex := 0 to ServerList.Count-1 do begin
      lbServers.items.Add(ServerList[ServerIndex]);
      lbServers.ItemIndex := ServerIndex;
      lbServers.Update;
      lbpaths.clear;
      lbpaths.update;
      CurrentShare := ServerList[ServerIndex];
      Purge(CurrentShare+'\*.*');
      lbServers.items.strings[ServerIndex] :=
        format('%s - %s',[lbServers.items.strings[ServerIndex],' Purged']);
      lbServers.Update;
      GraphicUpdate(CacheCount,PurgeCount);
        //init;
      end;
  ServerList.Free;
  Summary;
  Elog;
end;
procedure TMagPurge.Summary;
var
  ResultSummary: TStringList;
  i: integer;
begin
  ResultSummary := TStringList.Create;
  ResultSummary.Add('[Purge Run Summary]');
  ResultSummary.Add('  Start Time: '+ TimeToStr(StartTime));
  ResultSummary.Add('  Run Time: '+ lblRTData.Caption);
  ResultSummary.Add('  JB Queues: '+ lblJBQueData.Caption);
  with SitePurgeParam do begin
    ResultSummary.Add('[Purge Site Parameters]');
    ResultSummary.Add('  Site File Prefix: '+FilePrefix);
    ResultSummary.Add('  Minimum Abstracts: ' + IntToStr(MinAbs));
    ResultSummary.Add('  Minimum Full: ' + IntToStr(MinFull));
    ResultSummary.Add('  MinimumBig: ' + IntToStr(MinBig));
    ResultSummary.Add('  Abstract keep days: ' + IntToStr(abs_KeepDays));
    ResultSummary.Add('  Pacs Abstracts keep days: '+IntToStr(pacsabs_KeepDays));
    ResultSummary.Add('  Full keep days: ' + IntToStr(full_KeepDays));
    ResultSummary.Add('  Pacs keep days: ' + IntToStr(pacs_KeepDays));
    ResultSummary.Add('  Big keep days: ' + IntToStr(big_KeepDays));
    ResultSummary.Add('  Big Pacs keep days: ' + IntToStr(bigpacs_KeepDays));
    case Radholds of
      true: ResultSummary.Add('  Rad Holds: True');
      false: ResultSummary.Add('  Rad Holds: False');
      end; // case Radholds
    end; //with SitePurgeParam
  ResultSummary.Add('[Server Cache Count]');
  ResultSummary.Add('  Total Server Files: '+ IntToStr(FileCount));
  with CacheCount do begin
    ResultSummary.Add('  Total Abstracts: '+ IntToStr(abs));
    ResultSummary.Add('  Total Pacs Abstracts: '+IntToStr(pacsabs));
    ResultSummary.Add('  Total Full: '+IntToStr(full));
    ResultSummary.Add('  Total Pacs: '+IntToStr(pacs));
    ResultSummary.Add('  Total Big: '+IntToStr(big));
    ResultSummary.Add('  Total Big Pacs: '+IntToStr(Bigpacs));
    ResultSummary.Add('  Total Text: '+IntToStr(text));
    end; // with CacheCount
  ResultSummary.Add('[Purge File Count]');
  ResultSummary.Add('  Total Server Files Deleted: ' + IntToStr(DeleteCount));
  with PurgeCount do begin
    ResultSummary.Add('  Purged Abstracts: '+IntToStr(abs));
    ResultSummary.Add('  Purged Pacs Abstracts: '+IntToStr(pacsabs));
    ResultSummary.Add('  Purged Full: '+IntToStr(full));
    ResultSummary.Add('  Purged Pacs: '+IntToStr(pacs));
    ResultSummary.Add('  Purged Big: '+IntToStr(big));
    ResultSummary.Add('  Total Big Pacs: '+IntToStr(Bigpacs));
    ResultSummary.Add('  Purged Text: '+IntToStr(text));
    end; // with PurgeCount
  for i := 0 to ResultSummary.count-1 do begin
    Logfile('Purge.Log',ResultSummary[i]);
    frmPurgeResults.lbResults.Items.Add(ResultSummary[i]);
    end;
  ResultSummary.Free;
  frmPurgeResults.Visible := true;
 // mnuPurgeResults.Enabled := true;
end; //procedure Summary
procedure TMagPurge.Elog;
var
  ProcList: TStringList;
  I: integer;
begin
  ProcList := TStringList.Create;
  with yBroker do begin
    RemoteProcedure := 'MAGQ ELOGR';
    intSaveRPCTimeLimit := RPCTimeLimit;  {save off current time limit}
    RPCTimeLimit := TimeLimit;   {can take up to a minute to complete}
    try
      LSTCALL(ProcList);
      RPCTimeLimit := intSaveRPCTimeLimit;
    except
      On E: EBrokerError do begin
        RPCTimeLimit := intSaveRPCTimeLimit;
        ProcList.free;
        Exit;
        end;
      end;  //try
   end; //with RPCBroker1
   if ProcList.Count > 0 then begin
    //InitLogFile('PrgError.Log',5);
    for i := 1 to ProcList.Count - 1 do
      LogFile('PurgeError.Log',ProcList.Strings[i]);
    end;
   ProcList.free;
end;

function TMagPurge.TxtLastFile(FilePath:string): boolean;
var
  SearchRec: TSearchRec;
  WildCard: string;
begin
  Wildcard:=piece(LowerCase(FilePath),LowerCase(ExtractFileExt(FilePath)),1)+'.*';
  case FindFirst(WildCard, faAnyFile, SearchRec) of
   0 : if (LowerCase(ExtractFileExt(SearchRec.Name)) <> '.txt') or
           (FindNext(SearchRec) = 0) then result := false
       else result := true;
  else result := true;
  end;
  FindClose(SearchRec);
end;
function TMagPurge.LastAccessDate(FileRec: TSearchRec):TDate;
var
  SystemTime: TSystemTime;
begin
 FileTimeToSystemTime(FileRec.finddata.ftLastAccessTime,
   SystemTime);
 with SystemTime do
   LastAccessDate:= EncodeDate(wyear,wmonth,wday);
end;
procedure TMagPurge.mWait(Amsec:Word);//Millisec Wait
function AddMilSec(ChngeTime:TDateTime; AmSec: word):TDateTime;
var
  hour,min,sec,msec,Asec: word;
  NewTime: TDateTime;
const
  HalfDaySec : word = 43200;
  HourSec : word = 3600;
  MinSec: word = 60;
begin
  NewTime := ChngeTime;
  Asec := AmSec div 1000;
  hour := ASec div HourSec;
  Min := (ASec mod HourSec) div MinSec;
  sec := ((ASec mod HourSec) mod MinSec);
  msec := AmSec mod 1000;
  AddMilSec := NewTime + EncodeTime(hour,min,sec,msec);
end;
var
EndPause: TDateTime;
begin
  EndPause := Now;
  EndPause := AddMilSec(EndPause,AmSec);
  While EndPause > Now do
    {Application.ProcessMessages};
end;
procedure TMagPurge.TBUpdate;
var
 hours,min,sec,msec:word;
begin
 Caption := Format('%s - %s %s %s',
    [Application.Title ,TimeToStr(Now),'         WS ID: '
      +WSID,'     JOB ID: '+JOBID]);
 DecodeTime(Time - StartTime,hours,min,sec,msec);
 lblRTData.Caption := IntToStr(hours)+':'+IntToStr(Min)+':'+IntToStr(sec);
 lblTFPData.Caption := IntToStr(FileCount);
 lblPCData.Caption := IntToStr(DeleteCount);
 lblJBQueData.Caption := IntToStr(JBQCount);
 MagPurge.Update;
end;
procedure TMagPurge.GraphicUpdate(CacheCount,PurgeCount:TMagPurgeCount);
   begin
     with grphOriginalServers do
       begin
         NumPoints := 8;
         AutoInc:=0;
         ThisPoint := 1 ;
         GraphData := FileCount;
         color[1] := 15;
         label_[1] := 'FileTotal';
         ThisPoint := 2 ;
         GraphData := CacheCount.full;
         color[2] := 1;
         label_[2] := 'Full Image';
         ThisPoint := 3 ;
         GraphData := CacheCount.abs;
         color[3] := 14;
         label_[3] := 'Abstract';
         ThisPoint := 4 ;
         GraphData := CacheCount.big;
         color[4] := 9;
         label_[4] := 'Big';
         ThisPoint := 5 ;
         GraphData := CacheCount.pacs;
         color[5] := 5;
         label_[5] := 'Pacs';
         ThisPoint := 6 ;
         GraphData := CacheCount.bigpacs;
         color[6] := 11;
         label_[6] := 'BigPacs';
         ThisPoint := 7 ;
         GraphData := CacheCount.text;
         color[7] := 12;
         label_[7] := 'Text';
         ThisPoint := 8 ;
         GraphData := CacheCount.pacsabs;
         color[8] := 13;
         label_[8] := 'PacsAbs';
         DrawMode:=2;
       end;
      with grphCachePurge do
       begin
         NumPoints := 8;
         AutoInc:=0;
         ThisPoint := 1 ;
         GraphData := DeleteCount;
         color[1] := 15;
         label_[1] := 'Total Purges';
         ThisPoint := 2 ;
         GraphData := PurgeCount.full;
         color[2] := 1;
         label_[2] := 'Full';
         ThisPoint := 3 ;
         GraphData := PurgeCount.abs;
         color[3] := 14;
         label_[3] := 'Abstract';
         ThisPoint := 4 ;
         GraphData := PurgeCount.big;
         color[4] := 9;
         label_[4] := 'Big';
         ThisPoint := 5 ;
         GraphData := PurgeCount.pacs;
         color[5] := 5;
         label_[5] := 'Pacs';
         ThisPoint := 6 ;
         GraphData := PurgeCount.bigpacs;
         color[6] := 11;
         label_[6] := 'BigPacs';
         ThisPoint := 7 ;
         GraphData := PurgeCount.text;
         color[7] := 12;
         label_[7] := 'Text';
         ThisPoint := 8 ;
         GraphData := PurgeCount.pacsabs;
         color[8] := 13;
         label_[8] := 'PacsAbs';
         DrawMode:=2;
       end;
   end;
procedure TMagPurge.InitVariables;
  begin
    with PurgeCount do begin
      abs:=0;
      pacsabs:=0;
      full:= 0;
      pacs:=0;
      big:=0;
      bigpacs:=0;
      text:=0;
      end;
    with CacheCount do begin
      abs:=0;
      pacsabs:=0;
      full:= 0;
      pacs:=0;
      big:=0;
      bigpacs:=0;
      text:=0;
      end;
    FileCount :=0;
    DeleteCount :=0;
    JBQCount :=0;
    lblSTData.Caption:='       ';
    lblRTData.Caption:='       ';
    lblTFPData.Caption:='       ';
    lblPCData.Caption:='       ';
    Application.ProcessMessages;
  end;
procedure TMagPurge.InitLogFile(filepath:string; cnt: integer);
  function CreationDate(FileRec: TSearchRec):TDate;
  var
    SystemTime: TSystemTime;
  begin
    FileTimeToSystemTime(FileRec.finddata.ftCreationTime,
     SystemTime);
    with SystemTime do
      CreationDate:= EncodeDate(wyear,wmonth,wday);
  end;
  procedure NewCreationDate(Path: string);
  var
    NewfileTime : TFileTime;
    TempFileHandle: Integer;
    CurrentSystemTime: TSystemTime;
  begin
    GetLocalTime(CurrentSystemTime);
    if SystemTimeToFileTime(CurrentSystemTime,NewfileTime) then begin
      TempFileHandle := FileOpen(path,fmOpenWrite);
      if not SetFileTime(TempFileHandle,@NewFileTime,nil,nil) then
        ShowMessage(DateTimeToStr(Now)+'InitLogFile '+ 'SetFileTime Failed '+
          IntToStr(GetLastError)+ ': '+ NetConMessage(GetLastError));
      FileClose(TempFileHandle);
      end;
  end;

  procedure PurgeFile(fname,ext: string;cnt: integer);
  var
    rec: TSearchRec;
      i: integer;
    pfpath: string;
    fileList: TStringList;
  begin
    pfpath := ExtractFilePath(Application.ExeName)+ fname+ '*';
    if FindFirst(pfPath,(faDirectory),Rec) = 0 then begin
      fileList := TStringList.Create;
      if fname+ext <> Rec.Name then fileList.Add(Rec.Name);
      while FindNext(Rec) = 0 do if fname+ext <> Rec.Name then fileList.Add(Rec.Name);
      if fileList.Count > cnt then begin
        filelist.Sorted := true;
        for i := filelist.Count downto cnt do
          DeleteFile(ExtractFilePath(Application.ExeName)+ fileList.Strings[i-1]);
        end; // fileList.Count > cnt
      fileList.Free;
      end; // FindFirst(pfPath,(faDirectory),Rec) = 0
    FindClose(Rec);
  end;
 function ArchName(OldRec:TSearchRec):string;
 var
    DateString,DayStr,MonthStr: string;
   Year,Month,Day:word;
 begin
   DecodeDate(CreationDate(OldRec),Year,Month,Day);
   DayStr := IntToStr(Day);
   if Length(dayStr) < 2 then DayStr := '0' + DayStr;
   MonthStr := IntToStr(Month);
   if Length(MonthStr) < 2 then MonthStr := '0' + MonthStr;
   DateString := IntToStr(Year)+ '_'+MonthStr + '_' + DayStr ;
   Result := ExtractFilePath(Application.ExeName)+
   piece(OldRec.name,ExtractFileExt(OldRec.name),1)+DateString+
     ExtractFileExt(OldRec.name);
 end;
 var
   FileRec:TSearchRec;
   fpath,NewName: string;
   name: string;
   logfile: textfile;
 begin
    name := piece(ExtractFileName(filepath),ExtractFileExt(filepath),1);
    fpath := ExtractFilePath(Application.ExeName) + filepath;
    PurgeFile(name,ExtractFileExt(filepath),cnt);
    if FindFirst(fPath,(faDirectory),FileRec) = 0 then begin
      if CreationDate(FileRec) <> date then begin
        NewName := ArchName(FileRec);
        if not RenameFile(fpath,NewName) then begin
          ShowMessage('Log File Rename Failed: '+
            IntToStr(GetLastError)+ ': '+NetConMessage(GetLastError));
          if RenameFile(fpath,ChangeFileExt(NewName,'.lo1')) then
             ShowMessage(DateTimeToStr(Now)+' Rename to: '+
               ChangeFileExt(NewName,'.LG1')+' Successful!');
          end; //  not Rename
        end;  // if CreationDate
      end; // if FindFirst
    FindClose(FileRec);//
    if not fileExists(ExtractFilePath(Application.ExeName) + filepath) then begin
      Showmessage('Creating a New Log File');
      AssignFile(logfile,ExtractFilePath(Application.ExeName)+filepath);
      Rewrite(logfile);   //Rewrite creates a new external file with the name assigned to F.
      //Flush(logfile);
      CloseFile(logfile);
      NewCreationDate(ExtractFilePath(Application.ExeName) + filepath);
      end;
  end; //InitLogFile

procedure TMagPurge.Button1Click(Sender: TObject);
begin
//if not FileSizeZero('AutoExec.000') then button1.caption := 'nonZero'
// else  button1.caption := 'Zero';
end;

end.
