unit JBScanResults;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: BP Verifier Report
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls,Printers;

type
  TmagJBSResults = class(TForm)
    lbReport: TListBox;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    SaveDialog1: TSaveDialog;
    OpenDialog1: TOpenDialog;
    mnuOpen1: TMenuItem;
    mnuSave1: TMenuItem;
    mnuClose1: TMenuItem;
    PrinterSetupDialog1: TPrinterSetupDialog;
    procedure mnuOpen1Click(Sender: TObject);
    procedure mnuSave1Click(Sender: TObject);
    procedure mnuPrint1Click(Sender: TObject);
    procedure mnuClose1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  magJBSResults: TmagJBSResults;

implementation

{$R *.DFM}

procedure TmagJBSResults.mnuOpen1Click(Sender: TObject);
begin
 OpenDialog1.Title :='Jukebox Scan Report';
 OpenDialog1.Filter := 'Text files (*.txt)|*.TXT';
 OpenDialog1.Options := [ofReadOnly, ofFileMustExist]	;
 if OpenDialog1.Execute then begin
   lbReport.Items.Clear;
   lbReport.Items.LoadFromFile(OpenDialog1.FileName);
   lbReport.Update;
   mnuClose1.Enabled := true;
   end;
end;

procedure TmagJBSResults.mnuSave1Click(Sender: TObject);
begin
 SaveDialog1.Title :='Save Jukebox Scan Report';
 SaveDialog1.Filter := 'Text files (*.txt)|*.TXT';
 SaveDialog1.Options := [ofOverwritePrompt]	;
 if SaveDialog1.Execute then lbReport.Items.SaveToFile(SaveDialog1.FileName);

end;

procedure TmagJBSResults.mnuPrint1Click(Sender: TObject);
var
  PageNum: string;
  i,Ctr,x,PHeight,LineSpace: integer;
begin
  PrinterSetUpDialog1.Execute;
  Printer.BeginDoc;
  PHeight := Printer.PageHeight;
  LineSpace := PHeight DIV 60;
  Ctr := 1;
  x := 1;
  PageNum := IntToStr(Printer.PageNumber);
  for i := 0 to lbReport.items.Count -1 do begin
    Printer.Canvas.TextOut(0,x,lbReport.items[i]);
    x := x + LineSpace;
    ctr := ctr + 1;
    If ctr > 59 then begin
      Printer.NewPage;
      x := 0;
      Ctr := 0;
      PageNum := IntToStr(Printer.PageNumber);
      end;
    end;
  Printer.EndDoc;

end;

procedure TmagJBSResults.mnuClose1Click(Sender: TObject);
begin
  magJBSResults.Close;
//  lbReport.items.Clear;
//  magJBSResults.Visible := false;
//  magJBSResults.CleanupInstance;
end;

procedure TmagJBSResults.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 magJBSResults.ModalResult := mrCancel;
  Action := caFree;
end;

end.
