unit MagQBut2;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: BP Utility
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

interface

  uses  ComCtrls,MagExeWait,Windows, Messages, SysUtils, Classes,OleCtrls,
    Graphics, Controls, Forms, Dialogs,StdCtrls, Mask, ExtCtrls, FileCtrl,
 AxCtrls, DbOleCtl, MFunStr, Trpcb;



procedure InitLogFile(filepath,StringHeader:string; cnt: integer;AlwaysNew: Boolean);


implementation
procedure InitLogFile(filepath, Stringheader:string; cnt: integer;AlwaysNew: Boolean);
  function CreationDate(FileRec: TSearchRec):TDate;
  var
    SystemTime: TSystemTime;
  begin
    FileTimeToSystemTime(FileRec.finddata.ftCreationTime,
     SystemTime);
    with SystemTime do
      CreationDate:= EncodeDate(wyear,wmonth,wday);
  end;
  function LikeFiles(DriveDir,FName,FExt:string;var List:TStringList): boolean;
    var
      rec1: TSearchRec;
      ffName: string;
    begin
      result := false;
      ffName := DriveDir+FName+'*';
      if FindFirst(ffName,(faDirectory),Rec1) = 0 then begin
        List.Add(Rec1.Name);
        while FindNext(Rec1) = 0 do if FName+FExt<>rec1.name then List.Add(Rec1.Name);
        end;
      FindClose(Rec1);
      if List.count > 0 then result := true;
    end;
  function NumericSegment(Segment: string):integer;
    var
     code: integer;
    begin
     Val(Segment,Result,Code);
     if (code <> 0) then result := 0;
    end;
  procedure PurgeFile(DriveDir,Fname,Fext:string;cnt: integer);
  var
      i: integer;
    fileList: TStringList;
  begin
    fileList := TStringList.Create;
    if LikeFiles(DriveDir,FName,FExt,filelist) then begin
      filelist.Sorted := true;
      for i := 1 to (filelist.Count-cnt)do
        DeleteFile(DriveDir+FileList.Strings[i]);
      end;
    fileList.Free;
    end;
 function ArchName(DriveDir,FName,FExt: string; OldRec:TSearchRec):string;
 var
   DateString,DayStr,MonthStr,SeqNumber,TempRec: string;
   Year,Month,Day:word;
   FileList: TStringList;
   cnt,i: integer;
   rec: TSearchRec;
 begin
   DecodeDate(CreationDate(OldRec),Year,Month,Day);
   DayStr := IntToStr(Day);
   if Length(DayStr) < 2 then DayStr := '0' + DayStr;
   MonthStr := IntToStr(Month);
   if Length(MonthStr) < 2 then MonthStr := '0' + MonthStr;
   DateString := IntToStr(Year)+ '_'+MonthStr + '_' + DayStr ;
   TempRec:='';
   SeqNumber :='';
   if FindFirst(DriveDir+FName+DateString+'*',(faDirectory),Rec) = 0 then begin
     TempRec:= Rec.Name;
     while FindNext(Rec) = 0 do TempRec := Rec.Name;
     SeqNumber := piece(piece(TempRec,FName+DateString,2),'.',1);
     cnt := NumericSegment(piece(SeqNumber,'_',2));
     inc(cnt);
     SeqNumber := IntToStr(cnt);
     if Length(SeqNumber) < 2 then SeqNumber := '0' + SeqNumber;
     SeqNumber := '_'+SeqNumber;
     end;
   FindClose(Rec);
   Result := DriveDir+FName+DateString+SeqNumber+FExt;
 end;
procedure NewCreationDate(Path: string);
  var
    NewfileTime : TFileTime;
    TempFileHandle: Integer;
    CurrentSystemTime: TSystemTime;
  begin
    GetLocalTime(CurrentSystemTime);
    if SystemTimeToFileTime(CurrentSystemTime,NewfileTime) then begin
      TempFileHandle := FileOpen(path,fmOpenWrite);
      if not SetFileTime(TempFileHandle,@NewFileTime,nil,nil) then
        ShowMessage('InitLogFile: SetFileTime Failed '+IntToStr(GetLastError)+ ': '
        + SysErrorMessage(GetLastError));
      FileClose(TempFileHandle);
      end;
 end;
 var
   FileRec:TSearchRec;
   DriveDir,fpath,NewName,FName,FExt,emessage,params: string;
   logfile: textfile;
    ExeProcessInfo: TProcessInformation;
  begin
    filepath := ExtractFilePath(Application.ExeName)+ filepath;
    if not DirectoryExists(ExtractFilePath(filepath))
      then ForceDirectories(ExtractFilePath(filepath));
    FName := piece(ExtractFileName(filepath),ExtractFileExt(filepath),1);
    DriveDir := ExtractFilePath(filepath);
    if DriveDir = '' then DriveDir := ExtractFilePath(Application.ExeName);
    FExt := ExtractFileExt(filepath);
    //PurgeFile(DriveDir,FName,FExt,cnt);
    if FindFirst(DriveDir+FName+'*',(faDirectory),FileRec) = 0 then
      if ((CreationDate(FileRec) <> Date) or AlwaysNew) then begin
        NewName := ArchName(DriveDir,FName,FExt,FileRec);
        if not RenameFile(DriveDir + FName + FExt,NewName) then begin
        	EMessage :=DateTimeToStr(Now)+U+'LogFile Init Error^ Problem rename log file.^^^^^^^^^^^';
          end
        else begin
          params := char(34)+newname+char(34)+ ' '+ char(34)+DriveDir+piece(ExtractFileName(newname),'.',1)+'.html'+ char(34)+' '+ StringHeader + ' '+'../../linked.css' + ' '+'^';
          WinExecAndWait32('MagHTMLArchive.exe '+params,0,ExeProcessInfo);
          DeleteFile(newname);
          end
        end;
    FindClose(FileRec);//
    if not fileExists(DriveDir + FName + FExt) then begin
      AssignFile(logfile,DriveDir + FName + FExt);
      Rewrite(logfile);
      CloseFile(logfile);
      NewCreationDate(DriveDir + FName + FExt);
      end;
  end;

end.
