unit MagOfflineWrn;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: BP Verifier - Warning Message
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Fmcmpnts, StdCtrls, Fmcntrls, ExtCtrls, OleCtrls, Trpcb,
  Fmlookup, Diaccess,MFunStr,FileCtrl, Buttons,eftfut, TeeProcs, TeEngine,
  Chart, Series, ComCtrls;

type
  TfrmMagOffline = class(TForm)
    bbtnOK: TBitBtn;
    bbtnCancel: TBitBtn;
    lvOffline: TListView;
    mmoInitWarning: TMemo;
    lblContinue: TLabel;

    procedure FormCreate(Sender: TObject);
    procedure bbtnOKClick(Sender: TObject);
    procedure bbtnCancelClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMagOffline: TfrmMagOffline;
  AddRecord: boolean;
implementation
uses magjbscan1;
{$R *.DFM}

procedure TfrmMagOffline.FormCreate(Sender: TObject);
begin
  Lister := TFMLister.Create(self);
  Lister.RPCBroker := magjbscan.RPCBroker1;
  if MAGJBSCAN1.kids = '3.0P13' then
    Lister.Screen :='I $P(^(0),U,6)["0",$P(^(0),U,7)'+char(39)+'["DGM",$P(^(0),U,7)'+char(39)+'["EKG"'
  else
    Lister.Screen :='I $P(^(0),U,6)["0",$P(^(0),U,7)'+char(39)+'["DGM",$P(^(0),U,10)='+MAGJBSCAN1.Place+',$P(^(0),U,7)'+char(39)+'["EKG"';
  Lister.FileNumber := '2005.2';
  Lister.FieldNumbers.Add('1');
  Lister.FieldNumbers.Add('5');
  Lister.DisplayFields.Add('1');
  Lister.DisplayFields.Add('5');
  magjbscan.ListViewUpdate(True,True,Lister,lvOffLine);
end;

procedure TfrmMagOffline.bbtnOKClick(Sender: TObject);
begin
    Lister.Free;
    frmMagOffline.Visible := false;
    frmMagOffline.ModalResult := mrCancel;
    application.ProcessMessages;
end;

procedure TfrmMagOffline.bbtnCancelClick(Sender: TObject);
begin
    Lister.Free;
    MessageDlg('Exiting the BP Verifier.', mtInformation,
      [mbOk], 0);
    magjbscan1.term := true;
    frmMagOffline.Visible := false;
    frmMagOffline.ModalResult := mrCancel;
    application.ProcessMessages;

end;

end.

