unit magjbscan1;
   {                                         
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Richard Price
   Description: Main BP Verifier
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Trpcb, RpcConf1, MFunstr, StdCtrls, FileCtrl, OleCtrls, {graphsv3,} Menus,
  Mask, ExtCtrls, Grids, hash, splVista,Magbut,isp3, MagExeWait,StrUtils,
  Diaccess, Fmcmpnts, telabout, AxCtrls, DiTypLib,
  ComCtrls,eftfut,DateUtils,ACTIVEX,fmxutils,MEMCheck,rpcSLogin;


type
  TMagSiteSecurity = RECORD
    UserName  : String[20];
    Password  : String[20];
  end;
  TMagJBScan = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    mnuSiteIntegrity: TMenuItem;
    FMFiler1: TFMFiler;
    FMGets1: TFMGets;
    Help1: TMenuItem;
    mnuBPHelp: TMenuItem;
    mnuDFNhelp: TMenuItem;
    mnuAboutBPVerifier: TMenuItem;
    FMValidator1: TFMValidator;
    OpenLog1: TMenuItem;
    pnlMain: TPanel;
    pnlServers: TPanel;
    pnlLeft: TPanel;
    pnlCauche: TPanel;
    gpCacheShare: TGroupBox;
    lbCacheShare: TListBox;
    sgActivity: TStringGrid;
    mnuExit: TMenuItem;
    OpenDialog1: TOpenDialog;
    FMFindOne1: TFMFindOne;
    FMGets2: TFMGets;
    lvCacheShare: TListView;
    splLeft: TSplitter;
    Splitter4: TSplitter;
    pnlDialog: TPanel;
    rgText: TRadioGroup;
    rgSelectIEN: TRadioGroup;
    gbRange: TGroupBox;
    lblStart: TLabel;
    lblStop: TLabel;
    ebStop: TMaskEdit;
    ebStart: TMaskEdit;
    gbShares: TGroupBox;
    lbServers: TListBox;
    lvServers: TListView;
    Panel3: TPanel;
    btnPurge: TButton;
    pnlProcGroup: TPanel;
    gbActivities: TGroupBox;
    lblStartTime: TLabel;
    lblSTData: TLabel;
    lblRunTime: TLabel;
    lblRTData: TLabel;
    lblFileCnt: TLabel;
    lblTFPData: TLabel;
    lblNoRefCnt: TLabel;
    lblNoRefData: TLabel;
    lblBadVCCnt: TLabel;
    lblBadVCData: TLabel;
    lblJBBad: TLabel;
    lblJBBadData: TLabel;
    llbJBAltRef: TLabel;
    lblJBAltData: TLabel;
    lblSizeZeros: TLabel;
    lblSizeZeroData: TLabel;
    lblSizeZeroDel: TLabel;
    lblSizeZeroDelData: TLabel;
    rgCriteria: TRadioGroup;
    splRight: TSplitter;
    sbVerifier: TStatusBar;
    pnlIEN: TPanel;
    Timer1: TTimer;
    lblDuplicates: TLabel;
    lblDuplicateData: TLabel;
    RPCBroker1: TRPCBroker;
    btnStop: TButton;
    // initialization methods
    function NumericSegment(Segment: string):integer;
    procedure FormCreate(Sender: TObject);
    function init(Sender: TObject):boolean;
    procedure FormActivate(Sender: TObject);
    procedure InitLogs;
    procedure InitLogFile(filepath,stringHeader,title:string; ArchiveOnly: boolean;var FileSize: integer);
    function VerifyVersion(Sender: TObject;AppsVersion: string;var kids: string): boolean;
    function GetWorkStation(kids: string;Sender: TObject):integer;
    function AssignLogPath(WSIEN,CompName:string):string;
    // Application utilities
    function JBQueue(RecNo: string):string;
    procedure LogFile(filepath,DataItem:string;var LogSize:integer);
    procedure Elog;
    procedure TBUpdate;
    function CheckVolNameNT(volname,volpath: string): boolean;
    function MagHash(filename:string; Ptr: Integer):string;
    procedure InvStrGrid(Log:boolean; input: string; RMax: Integer; var Grid: TStringGrid);
    procedure mWait(Amsec:Word);
    procedure SetPiece(SubString: string;var TargetString:string ;delimiter:string;piece1:integer);
    function LocCopy(FileName,Source,Target: string): boolean;
    function ExtractPtr(Segment:string):integer;
    function Aggregate(JBType:string;var JBString: string;ExtList: TStringList):boolean;
    function AggregateList(ListString,CJBString: string):TStringList;
    function PathMaker(Location,Name: string):  string;
    function LocPiecePos(text,value,delim:string):integer;
    Function MPieceSub(SuperString,Delimiter:string;LowerRange,UpperRange:integer):String;
    Function PatInfo(DFN:String):string;
    function MagEnterpriseUpdate(Data,Send,Place,Application: string): boolean;
    procedure DFNFormat(DataString: string;var wiped:string);
    //  Database/Fileman utilities
    function MagUpdate(FileName,ext,ien: string): Boolean;
    function PtrUpdate(RPC,Ptr,Ext,ien:string):boolean;
    function Find1(FNum,IENS,Flag,FndValue,XREF,Screen:string;silent:boolean): string;
    function GetFieldValue(FNum,FldNum,IENS,Flag:string;silent:boolean): string;
    function FMUpdate(FNum,FldNum,IENS,Value:string):boolean;
    function GetFMData(Broker: TRPCBroker;FileS,FieldS,FlagS,IENs:string):string;
    function FindFMData(Broker: TRPCBroker;FileS,IENs,FlagS,ValueS,IndexS,ScreenS:string):string;
    function GetVariable(GetLogic:string):string;
    function DateToFMInternal(ExDate:string):string;

    //  Main Application Processes
    function Scan(ien:integer): boolean;
    procedure btnPurgeClick(Sender: TObject);
    function TextCheck():boolean;
    function MakeAbs(abspath,sourcepath:string;var msg:string): boolean;
    function DupCheck(ServerList: TStrings;Position: integer): boolean;
    function Certified(ien: string): boolean;
    procedure DFNCheck(ien:string);

    // Post Application processes
    procedure PostScan(NewDate: String);
    procedure Summary;
    procedure DFNReport;
    procedure DFNSum(DataString: String);
    procedure DFNSummary(ScanCount:integer);
    procedure SendScanErrors(LogName:string);
    procedure SiteIntegrityReport(Sender: TObject;FilePath: string);
    function DFNLogFormat(ien,DFNData:String):String;

    // Application Menu methods
    procedure rgSelectIENClick(Sender: TObject);
    procedure rgCriteriaClick(Sender: TObject);
    procedure mnuSiteIntegrityClick(Sender: TObject);
    procedure mnuAboutBPVerifierClick(Sender: TObject);
    procedure mnuBPHelpClick(Sender: TObject);
    procedure mnuDFNhelpClick(Sender: TObject);
    procedure OpenLog1Click(Sender: TObject);
    procedure mnuExitClick(Sender: TObject);

    // Display methods
    procedure ListViewUpdate(Clear,IEN: Boolean;Lister:TFMLister;lv:TListView);
    function GetLabels(Lister:TFMLister): TStringList;
    function lvDupCheck(ServerList: TListView; Position:integer): boolean;
    function ListSearch(SearchList:TStrings;SearchString,Delimiter:String;
               position:integer):integer;
    function ListViewSearch(SearchList:TListView;SearchString:String;position:integer):integer;
    function IsStrANumber(const S: string): Boolean;

    // System Utilities
    function GetPlace(Sender: TObject):integer;
    procedure GetSystemTimeout(var TimeOut: string);
    procedure Timer1Timer(Sender: TObject);
    procedure ExecNewProcess(ProgramName : String; Wait: Boolean);
    function AvailVirtualSize(Sender: TObject):int64;
    function GetAbstractOkList(Sender: TObject):TStringList;
    function LogSize(WSIEN,CompName:string):String;
    function AutoLogin(Broker: TRPCBroker;SilentAccess,SilentVerify,VServer,VPort,Division:string; Pause: Integer;Sender:TObject): boolean;
    procedure FMComponentInit(Sender: TObject);
    function MakeBrokerCall(Sender: TObject):boolean;
    function MakeBrokerLSTCall(Sender: TObject;List: TStrings):boolean;
    procedure OnException(E:exception);
    function FileInUse(FileName: string): Boolean;
    procedure UpdateBPServerActivity(DistDate,AppVer,OSVer: string);
    function FSize(filepath:string): longint;
    procedure btnStopClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
//  E:Exception;
  MagJBScan: TMagJBScan;
  CurrentShare: string[100];
  MAGSiteSecurity: TMagSiteSecurity;
  duz: string[100];
  DFNEC: array[0..100] of integer;
  DFNEType,ExtList,Abstractable:  TStringList;
  LogOn,AggregateEnabled : boolean;
  WSID,JOBID,FileID,CompName,AppVer,DistDate,OSVer,WSIEN,kids,TimeOut,SiteCode, Place,rString: string;
  StartTime: TDateTime;
  JBQCount,ShareIndex,JBBadcnt,JBAltCnt,FileCount,splL,splR,ABSRecoveryCnt,JBFullRecoveryCnt,
  VCBadCnt,NoRefCnt,ZSizeCnt,ZSizeDeleted,Dupes, TxtUpdates: integer;
  Lister: TFMLister;
  term,ScanActive,RunOnce,StopScan : boolean;
  EMessage,CJBString,LogFilePath,AUTO:String;
  logSizeV: real;
  MEMCount,MEMTot,MEMS: Int64;
  ScanErrorLogSize,NoArchiveLogSize,CertedLogSize,DFNErrorLogSize,ScanLogSize: integer;
  SilentAccess,SilentVerify,VServer,VPort,Division: string;
  BigFileType,DateRequested, StartIen,EndIEN: string;
  StartDate: Tdatetime;
const
 // logSize = 10000;
//  TimeLimit = 3600;
  AbsType  = '^.abs^.tif^.jpg^';
  FailIfExist = true;
  U ='^';
  rStringHeader =
  'Date/Time^Message^IMAGE_PTR^FILE_NAME^FULL_JB_PTR^BIG_JB_PTR^FULL_VC_PTR^ABS_VC_PTR^BIG_VC_PTR^Current_Write_PTR^JB_ALT_1^JB_ALT_2^JB_ALT_3';
  dfnHeader =
  'Image_IEN^Patient_Name_1^DFN_1^SSN_1^Patient_Name_2^DFN_2^SSN_2^Package^Package_IEN^Image_Class^Error_level^Memo';
implementation

uses JBScanResults, needdata,MagShowLog, magWebHelp, MagOfflineWrn, MAGQBUT2;

 // uses Magbtm1;

{$R *.DFM}
function TMagJBScan.MakeBrokerLSTCall(Sender:TObject;List: TStrings):boolean;
  var Brokercall: string;
  begin
    result := true;

  try
    BrokerCall := RPCBroker1.RemoteProcedure;
    RPCBroker1.lstCall(List);
  except
    on E: Exception do begin
      InvStrGrid(True,DateTimeToStr(Now)+'^RPC Error: '+Brokercall+' ^^^^^^^^^^^^',280,sgActivity);
      OnException(E);
      result := false;
      end;
    end; //try...except
  end;

function TMagJBScan.MakeBrokerCall(Sender:TObject):boolean;
  var Brokercall: string;
  begin
    result := true;
  try
    BrokerCall := RPCBroker1.RemoteProcedure;
    RPCBroker1.Call;
  except
    on E:Exception do begin
      InvStrGrid(True,DateTimeToStr(Now)+'^RPC Error: '+Brokercall+' ^^^^^^^^^^^^',280,sgActivity);
      OnException(E);
      result := false;
      end;
    end; //try...except
  end;
function TMagJBScan.Scan(ien:integer): boolean;
function JBPath(path:string; RIndex:integer; var Extents: string): boolean;
procedure Zero(ZPath,ZExt,ZIEN: String; RIndex: integer);
  var MessageS: string;
  begin
    MessageS:= 'Copy of: '+path+ZExt+' is of size zero';
    case RIndex of   // Vista Cache reference - Latest DE not reliable for JB size
       5..7: begin
         MessageS := MessageS + '...purging';
         Inc(ZSizeDeleted);
         DeleteFile(ZPath + ZExt);
         if lowercase(ZExt) <> 'txt' then repeat until PtrUpdate('MAGQ VCUD','0',ZExt,ZIEN);
         end;
    else MessageS := MessageS +'.';
    end;  // case index
    MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+U+MessageS+U+MPieceSub(rString,U,1,11),ScanErrorLogSize);
  end;
  var
    FileRec:TSearchRec;
    ext,ExtentionList: string;
    index,ExtNum: integer;
  begin
    Application.ProcessMessages;
    result := false;
    ext :=  PIECE(UpperCase(ExtractFileExt(piece(rString,U,2))),'.',2);
    ExtentionList := 'ABS^TXT^'+BigFileType;
    if pos(ext,ExtentionList) = 0 then ExtentionList := ExtentionList +U+ ext;
    ExtNum := LastPiecePos(ExtentionList,U) ;
    Extents := '';
    for index := 1 to ExtNum do begin
      try
      if FindFirst(path+piece(ExtentionList,U,index),(faAnyFile),FileRec) = 0 then
        if FileRec.Size = 0 then begin
          Zero(path,piece(ExtentionList,U,index),IntToStr(ien),RIndex);
          Inc(ZSizeCnt);
          end
        else Extents := Extents + ExtractFileExt(FileRec.Name);
      finally
         FindClose(FileRec);
      end;
      end;
    Extents := UpperCase(Extents);
    if pos('.',Extents) <> 0 then result := true;
    Application.ProcessMessages;
  end; //JBPath

function CheckNet():boolean;
{NEED TO UPDATE THE CACHESHARE RPC!!!!}
var
  path,Filename,extents: string;
  index,ShareIndex,Ptr: integer;
begin
  result := false;
  FileName := piece(piece(rString,U,2),'.',1);
  for index := 5 to 7 do begin
    Ptr := ExtractPtr(piece(rString,U,index));
    extents := '';
    if Ptr < 1 then continue; //not an integer
   ShareIndex :=  ListViewSearch(lvCacheShare,IntToStr(Ptr),0);
   if (ShareIndex <> -1) and (pos('OFFLINE',UpperCase(lvCacheShare.Items[ShareIndex].SubItems[2])) = 0) then begin
     path := lvCacheShare.items[ShareIndex].SubItems[1];
     if path[length(path)] <> '\' then path := path + '\';
      path := path+MagHash(FileName,ExtractPtr(lvCacheShare.items[ShareIndex].Caption))+ Filename+'.';
     if JBPath(path,index,extents) then begin
       SetPiece(piece(rString,U,index)+extents,rString,U,index);
       result:= true;
       end // if JBPath
     else inc(VCBadCnt);
     end // if ShareIndex <> -1
   else begin
     inc(VCBadCnt);
     SetPiece(piece(rString,U,index)+'-Offline',rString,U,index);
     end;
   end;
end;
function JBCheck():boolean;
  var
    index,ServerIndex,Ptr,AltCnt,i: integer;
    path,FileName,Extents,EXT: string;
  begin
    result:= false;
    ext := ExtractFileExt(piece(rString,U,2));
    FileName := piece(piece(rString,U,2),'.',1);
   //CHECK FULL & BIG  JBATHS
    for index := 3 to 4 do begin
      Ptr := ExtractPtr(piece(rString,U,index));
      if Ptr < 1 then continue; //not an integer
      ServerIndex := ListViewSearch(lvServers,IntToStr(Ptr),0);
      if ServerIndex = -1 then begin
        SetPiece(piece(rString,U,index)+'-Offline',rString,U,index);
        inc(JBBadCnt);
        continue;
        end;
      if (pos('OFFLINE',UpperCase(lvServers.items[ServerIndex].SubItems[4])) <> 0) or
           (pos('OFFLINE',UpperCase(lvServers.Items[ServerIndex].SubItems[2])) <> 0) then begin
        SetPiece(piece(rString,U,index)+'-Offline',rString,U,index);
        continue;
        end;
      path := lvServers.items[ServerIndex].SubItems[1];
      if path[length(path)] <> '\' then path := path + '\';
      path := path+MagHash(FileName,ExtractPtr(lvServers.items[ServerIndex].Caption))+ Filename+'.';
      if JBPath(path,index,Extents) then begin
        SetPiece(piece(rString,U,index)+ Extents,rString,U,index);
        case index of
          3: if pos(lowercase(EXT),lowercase(Extents)) = 0 then inc(JBBadCnt);
          4: if pos('.'+lowercase(BigFileType),lowercase(Extents))= 0 then inc(JBBadCnt);
          end;
        result := true;
        end // if JBPath
      else begin
         inc(JBBadCnt);
         i := 0;
         while (not DirectoryExists(ExtractFileDrive(path))) and (not Term) do begin
           Eftfut.pause(30);
           inc(i);
           if i > 2  then begin
           MagEnterpriseUpdate(DateTimeToStr(Now),'',Place,'Site_Verification_Issue');
           EMessage :='The Jukebox share: '+ExtractFileDrive(path)+
               ' is not available!'  ;
           MagEnterpriseUpdate(Emessage,'',Place,'Site_Verification_Issue');
           EMessage := 'All Vista Imaging Jukebox servers should be fully operational';
           MagEnterpriseUpdate(Emessage,'',Place,'Site_Verification_Issue');
           EMessage := 'when operating the BP Verifier!';
           MagEnterpriseUpdate(Emessage,'',Place,'Site_Verification_Issue');
           MagEnterpriseUpdate(MPieceSub(rString,U,1,11),'',Place,'Site_Verification_Issue');
           MagEnterpriseUpdate(Emessage,'',Place,'Site_Verification_Issue');
           MagEnterpriseUpdate('Imaging_Site_Verification_Issue','1',Place,'Site_Verification_Issue');
           MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+U+'JBCheck^The Jukebox share: '+ExtractFileDrive(path)+
               ' is not available!^^^^^^^^^^',ScanErrorLogSize);
           if FileExists(ExtractFilePath(Application.ExeName)+'log\verifier\ScanError.Log') then
             if FSize(ExtractFilePath(Application.ExeName)+'log\verifier\ScanError.Log') <> 0 then
               SendScanErrors(ExtractFilePath(Application.ExeName)+'log\verifier\ScanError.Log');
           term := true;
           MessageDlg('A Jukebox Share is OFFLINE: '+ExtractFileDrive(path)+' Exiting the BP Verifier.', mtInformation,
            [mbOk], 0);
           end; //   if i > 2
         end;  //   while not DirectoryExists(ExtractFileDrive(path))
         if term then exit ; //Might as well since the WSAEConnect has been broken
         JBPath(path,index,Extents); // falls through to here if jb comes back within 1 minute
         end; //else begin
      end; // for index
    //Check Alternate JukeBox Locations
    AltCnt := 0;
    for index := lvServers.Items.Count-1 downto 0 do begin
      if ((pos(lvServers.items[Index].Caption,piece(RString,U,3))=1) or
        (pos(lvServers.items[Index].Caption,piece(RString,U,4))=1))
        and (UpperCase(lvservers.Items[Index].SubItems[2])<> 'OFFLINE') then
         continue;
      if pos('OFFLINE',UpperCase(lvServers.items[Index].SubItems[4])) <> 0 then continue;
      path := lvServers.items[Index].SubItems[1];
      if path[length(path)]<>'\' then path := path +'\';
      path :=path+ MagHash(FileName,ExtractPtr(lvServers.items[Index].Caption))+ Filename+'.';
      if JBPath(path,8+AltCnt,Extents) then begin
        inc(AltCnt);
        inc(JBAltCnt);
        SetPiece(lvServers.Items[Index].Caption + Extents,Rstring,U,8+AltCnt);
        result := true;
        end; // if JBPath
      end; //  for index
    //Check the Current Jukebox Write Location
    CJBString := GetFMData(RPCBroker1,'2006.1','2.01','"I"',IntToStr(GetPlace(self)));
    if JBPath(PathMaker(CJBString+'.',Filename+'.'),0,Extents) then CJBString := UpperCase(CJBString + Extents);
  end; // JBCheck
begin // Scan
  result := false;
  term := false;
  if CheckNet() then result := true;
  if JBCheck() then result := true;
  if term then exit;
//  if result then inc(DupCount);
end; // scan
procedure TMagJBScan.btnPurgeClick(Sender: TObject);
function VerifyIEN(var start,stop:integer):boolean ;
  var code: integer;
  begin
    result := true ;
    Code := ExtractPtr(ebStart.Text);
    if Code < 1 then begin
      MessageDlg('Error in Starting value: ' + IntToStr(Code), mtWarning, [mbOk], 0);
      result := false;
      end
    else Start := StrToInt(ebStart.Text);
    Code := ExtractPtr(ebStop.Text);
    if Code < 1 then begin
      MessageDlg('Error in Ending value: ' + IntToStr(Code), mtWarning, [mbOk], 0);
      result := false;
      end
    else Stop := StrToInt(ebStop.Text);
  end;

function GetNext(var entry:integer;start,stop,Criteria:string):boolean;
begin
  result := true;
    repeat
      RPCBroker1.ClearParameters := true;
      RPCBroker1.Param[0].VALUE := IntToStr(entry);
      RPCBroker1.Param[0].PTYPE := LITERAL;
      RPCBroker1.Param[1].VALUE := start;
      RPCBroker1.Param[1].PTYPE := LITERAL;
      RPCBroker1.Param[2].VALUE := stop;
      RPCBroker1.Param[2].PTYPE := LITERAL;
      RPCBroker1.Param[3].VALUE := Criteria;
      RPCBroker1.Param[3].PTYPE := LITERAL;
      RPCBroker1.RemoteProcedure := 'MAGQ JBSCN';
      until MakeBrokerCall(Self);
    rString := RPCBroker1.Results[0];
    if piece(rstring,u,23) = '-1' then begin
        emessage := DateTimeToStr(Now)+'^No Acquisition Site in Image file^'+MPieceSub(rString,U,1,11);
        MagJBScan.LogFile('log\verifier\ScanError.Log',emessage,ScanErrorLogSize);
        end;
    Entry := ExtractPtr(piece(rString,U,1));
    if Entry < 1 then result := false;
end; // GetNext
function SetBigFileType(rstring:string):string;
  var value:string;
  begin
    result := '';
    if pos('[',piece(rstring,'^',4)) <> 0 then
      result := piece(piece(piece(rstring,'^',4),'[',2),']',1);
    if pos('[',piece(rstring,'^',7)) <> 0 then
      result := piece(piece(piece(rstring,'^',7),'[',2),']',1);
    if result= '' then result :='BIG';
  end;

function Eval(): boolean;
var
  index,ptr,lv:integer;
  tm: Int64;
begin    // find at least one Network reference
  result := false;
  for index := 3 to 9 do begin
    ptr := ExtractPtr(piece(rString,U,index));
    if ptr < 1 then continue //not an integer
    else begin
      result := true;
      exit;
      end;
    end;
end;

var
  ien,ShareIndex,h,i: integer;
  NewDate: string;
begin
  application.ProcessMessages;
  if not init(self) then begin
    application.Terminate;
    close;
    application.ProcessMessages;
    exit;
    end;
  if (pos(rgSelectIEN.Items[rgSelectIEN.ItemIndex],'Range') <> 0) and
   (not VerifyIEN(h,i)) then begin
     MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+'Invalid input range'+
          '^^^^^^^^^^^',ScanLogSize);
     exit;
     end;
  if (pos(rgSelectIEN.Items[rgSelectIEN.ItemIndex],'Auto') = 0) then
    if ((ListViewSearch(lvServers,'Offline',3)<> -1) or
      (ListViewSearch(lvCacheShare,'Offline',3)<> -1)) then begin
         Application.CreateForm(TfrmMagOffline,frmMagOffline);
         frmMagOffline.ShowModal;
         if term then begin
           application.Terminate;
           close;
           application.ProcessMessages;
           exit;
           end;
         end;
  UpdateBPServerActivity(DistDate,AppVer,OSVer);
  ScanActive := true;
  StopScan := false;
  mnuExit.Enabled := false;
  btnPurge.Enabled := false;
  for ShareIndex := lvServers.items.count-1 downto 0 do begin
    CurrentShare := lvServers.Items[ShareIndex].SubItems[1];
    if CurrentShare[length(CurrentShare)] <> '\' then CurrentShare := CurrentShare + '\';
    if not DirectoryExists(ExtractFilePath(CurrentShare)) then //if not CheckVolNameNT('DEX',CurrentShare) then
      lvServers.Items[ShareIndex].SubItems.Add('Offline')
    else lvServers.Items[ShareIndex].SubItems.Add('Online');
    end;
  DFNEType := TStringList.Create;
  // Main processing loop
  ien:=0;
 { pnlDialog.Width := pnlDialog.Constraints.MinWidth ;
  splLeft.Left :=   pnlDialog.Left-10;
  pnlleft.Width := ((pnlMain.Width )- panel3.Width )div 2;}
  sbVerifier.Panels[0].text :=  rgSelectIEN.Caption +' : ' + rgSelectIEN.Items[rgSelectIEN.ItemIndex];
  sbVerifier.Panels[0].Width := MagJBScan.Width div 3;
  sbVerifier.Panels[1].text := rgText.Caption + ' : ' + rgText.Items[rgText.ItemIndex];
  sbVerifier.Panels[1].Width := MagJBScan.Width div 3;
  if pos(rgSelectIEN.Items[rgSelectIEN.ItemIndex],'ALL') <> 0 then
    sbVerifier.Panels[2].text := gbRange.Caption + ' : ' + 'ALL';
  if pos(rgSelectIEN.Items[rgSelectIEN.ItemIndex],'Range') <> 0 then
    sbVerifier.Panels[2].text := gbRange.Caption + ' : ' + ebStart.Text + ' - ' + ebStop.Text ;
  if pos(rgSelectIEN.Items[rgSelectIEN.ItemIndex],'Auto') <> 0 then
    sbVerifier.Panels[2].text := gbRange.Caption + ' : ' + 'Auto' ;
  sbVerifier.Panels[2].Width := MagJBScan.Width div 3;
  application.ProcessMessages;
  if not GetNext(ien,trim(ebStart.text),trim(ebStop.text),AUTO) then begin
    MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+'About to exit without processing: '+IntToStr(ien)+'^^^^^^^^^^^',ScanLogSize);
    btnPurge.Enabled := true;
    PostScan(NewDate);
    exit;
    end;
  MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+'Starting IEN: '+IntToStr(ien)+'^^^^^^^^^^^',ScanLogSize);
  StartIEN := IntToStr(ien);
  repeat
    EndIEN := IntToStr(ien);
    MagJBScan.Repaint;
    BigFileType := UpperCase(SetBigFileType(rstring));
    if piece(rstring,u,23) = '-1' then continue;
    if (FileCount > 0 ) and (FileCount mod 100 = 0) then begin
      if FileCount = 100 then MEMS := (AvailVirtualSize(self) div 1000);
      MEMTot := MEMTot + (AvailVirtualSize(self) div 1000);
      Inc(MEMCount);
      end;
    if (FileCount > 0)and (FileCount mod 5000 = 0) then
      MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+'Progress: '+IntToStr(ien)+'^^^^^^^^^^^',ScanLogSize);
    pnlIEN.Caption := 'Progress: '+IntToStr(ien);
    Application.ProcessMessages;
    if pos('GP',piece(rString,U,17)) <> 0 then begin
      if piece(rString,U,16) <> '1' then
          DFNCheck(Piece(rstring,U,1));
      inc(FileCount);
      if FileCount mod 20 = 0 then TBUpdate;
      end
    else begin
      inc(FileCount);
      if FileCount mod 20 = 0 then TBUpdate;
      if not Eval() then begin
        inc(NoRefCnt);
        if pos('ARCH',piece(rstring,u,21)) <> 0 then
          InvStrGrid(True,DateTimeToStr(Now)+'^No NetWork References: Archived Image^'+MPieceSub(rString,U,1,11),280,sgActivity);
        if pos('DUPE',piece(rstring,u,21)) <> 0 then begin
          inc(Dupes);
          emessage := DateTimeToStr(Now)+'^Duplicate image entry in Image file and in the Image Archive file^'+MPieceSub(rString,U,1,11);
          InvStrGrid(True,emessage,280,sgActivity);
          MagJBScan.LogFile('log\verifier\ScanError.Log',emessage,ScanErrorLogSize);
          end;
        if (pos('ARCH',piece(rstring,u,21)) = 0) and (pos('DUPE',piece(rstring,u,21)) = 0) then
          InvStrGrid(True,DateTimeToStr(Now)+'^No Network References^'+MPieceSub(rString,U,1,11),280,sgActivity);
        if length(piece(rString,U,2))>6 then begin
          if pos('ARCH',piece(rstring,u,21)) <> 0 then
            MagJBScan.LogFile('log\verifier\NoArchive.Log',piece(rString,U,2)+'^2005.1',NoArchiveLogSize)
          else LogFile('log\verifier\NoArchive.Log',piece(rString,U,2)+'^',NoArchiveLogSize);
          end;
        end
      else begin //Eval
        scan(ien);
        if term then break;
        if not Certified(IntToStr(ien)) then begin
         emessage := DateTimeToStr(Now)+U+'Not Certed'+U+MPieceSub(rString,U,1,11);
         InvStrGrid(True,emessage,280,sgActivity);
         if (pos('OFFLINE',UpperCase(MPieceSub(rString,U,1,11))) = 0) then
           MagJBScan.LogFile('log\verifier\ScanError.Log',emessage,ScanErrorLogSize);
         end;
         Application.ProcessMessages;
        end;
     end; //else begin
  until (not GetNext(ien,trim(ebStart.text),trim(ebStop.text),AUTO)
    or (StopScan));
  MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+'Ending IEN: '+EndIEN+'^^^^^^^^^^^',ScanLogSize);
  PostScan(NewDate);
  end; // btnPurgeClick

procedure TMagJBScan.PostScan(NewDate: String);
var frequency: string;
begin
  DFNSummary(FileCount);
  // Schedule next Auto Verifier
  if pos('1',AUTO) <> 0 then begin
    Frequency := GetFieldValue('2006.1','62.2',place+',','E',true);
    if not IsStrANumber(Frequency) then begin
      MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+U+'The Scheduled Verifier Frequency is null.The next Scheduled Verifier is NOT scheduled'+U+MPieceSub(rString,U,1,11),ScanErrorLogSize);
      NewDate := '';
      end
    else NewDate := GetVariable('$S(1:$$FMADD^XLFDT('+DateRequested+','+Frequency+',"",""))');
    FMUpdate('2006.1','62.3',Place+',',NewDate);
    term := true;
    end;
  TBUpdate;
  application.ProcessMessages;
  if FileExists(ExtractFilePath(Application.ExeName)+'log\verifier\ScanError.Log') then
    if FSize(ExtractFilePath(Application.ExeName)+'log\verifier\ScanError.Log') <> 0 then
      SendScanErrors(ExtractFilePath(Application.ExeName)+'log\verifier\ScanError.Log');
  btnPurge.Enabled := true;
  mnuExit.Checked := false;
  ScanActive := false;
  mnuExit.Enabled := true;
  splLeft.Left := splL;
  splLeft.Refresh;
  splRight.Left := splR;
  splRight.Refresh;
  //magJBScan.Resizing(restore);
  application.ProcessMessages;
  Summary;
  InitLogFile('log\verifier\Scan.Log',rStringHeader,'Scan_Log',true,ScanLogSize);
  InitLogFile('log\verifier\DFNError.Log',dfnHeader,'DFN_Error_Log',true,DFNErrorLogSize);
  InitLogFile('log\verifier\ScanError.Log',rstringHeader,'Scan_Error_Log',true,ScanErrorLogSize);
  InitLogFile('log\verifier\NoArchive.Log','Filename^2005.1^','NoArchive_Log',true, NoArchiveLogSize);
  if term then application.Terminate;
end; // PostScan

function TMagJBScan.MagHash(filename:string; Ptr: Integer): string;
  begin
      repeat
        RPCBroker1.ClearParameters := true;
        RPCBroker1.Param[0].VALUE := FileName;
        RPCBroker1.Param[0].PTYPE := LITERAL;
        RPCBroker1.Param[1].VALUE := IntToStr(Ptr);
        RPCBroker1.Param[1].PTYPE := LITERAL;
        RPCBroker1.RemoteProcedure := 'MAG DIRHASH';
      until MakeBrokerCall(Self);
        result := piece(RPCBroker1.Results[0],U,1);
    end;
function TMagJBScan.MagUpdate(FileName,ext,ien: string): Boolean;
//    need to handle exception
begin
    repeat
      RPCBroker1.ClearParameters := true;
      RPCBroker1.Param[0].VALUE := FileName;
      RPCBroker1.Param[0].PTYPE := LITERAL;
      RPCBroker1.Param[1].VALUE := ext;
      RPCBroker1.Param[1].PTYPE := LITERAL;
      RPCBroker1.Param[2].VALUE := ien;
      RPCBroker1.Param[2].PTYPE := LITERAL;
      RPCBroker1.RemoteProcedure := 'MAGQBP UPDATE';
    until MakeBrokerCall(Self);
    if piece(RPCBroker1.Results[0],U,1) = '1' then result := true
    else result := false;
end; // MagUpdate

procedure TMagJBScan.LogFile(filepath,DataItem:string;var LogSize:integer);
var
  logfile: textfile;
  fpath: string;
  begin
    fpath := ExtractFilePath(Application.ExeName)+ filepath;
    if not DirectoryExists(ExtractFilePath(fpath))
      then ForceDirectories(ExtractFilePath(fpath));
    if not FileExists(fpath) then
      FileClose(FileCreate(fpath));
    AssignFile(logfile,fpath);
    Append(logfile);
    Writeln(logfile,DataItem);
    Flush(logfile);
    CloseFile(logfile);
    LogSize := LogSize + Length(DataItem);
    if LogSize > LogSizeV then begin
      if pos('DFNERROR.LOG',UpperCase(filepath)) <> 0 then begin
        DFNSummary(FileCount);
        InitLogFile('log\verifier\DFNError.Log',dfnHeader,'DFN_Error_Log',false,LogSize);
        end;
      if pos('SCAN.LOG',UpperCase(filepath)) <> 0 then begin
        SendScanErrors(ExtractFilePath(Application.ExeName)+'log\verifier\ScanError.Log');
        InitLogFile('log\verifier\Scan.Log',rStringHeader,'Scan_Log',false,LogSize);
        end;
      if pos('SCANERROR.LOG',UpperCase(filepath)) <> 0 then
        InitLogFile('log\verifier\ScanError.Log',rstringHeader,'Scan_Error_Log',false,LogSize);
      if pos('NOARCHIVE.LOG',UpperCase(filepath)) <> 0 then
        InitLogFile('log\verifier\NoArchive.Log','Filename^2005.1^','NoArchive_Log',false, LogSize);
      LogSize := 0;
      end;
  end;

function TMagJBScan.FSize(filepath:string): longint;
    var ftext: textfile;
    begin
    AssignFile(ftext, filepath);
      Reset(ftext);
      try
        FSize := system.FileSize(ftext);
      finally
        CloseFile(ftext);
      end;// try..finally
  end;
function TMagJBScan.NumericSegment(Segment: string):integer;
     var
       code: integer;
     begin
       Val(Segment,Result,Code);
       if (code <> 0) then result := 0;
     end;


procedure TMagJBScan.InitLogFile(filepath,stringHeader,title:string;ArchiveOnly: Boolean;var FileSize: integer);
  function CreationDate(FileRec: TSearchRec):TDate;
  var
    SystemTime: TSystemTime;
  begin
    FileTimeToSystemTime(FileRec.finddata.ftCreationTime,
     SystemTime);
    with SystemTime do
      CreationDate:= EncodeDate(wyear,wmonth,wday);
  end; // function CreationDate
  procedure NewCreationDate(Path: string);
    var
      NewfileTime : TFileTime;
      TempFileHandle: Integer;
      CurrentSystemTime: TSystemTime;
    begin
      GetLocalTime(CurrentSystemTime);
      if SystemTimeToFileTime(CurrentSystemTime,NewfileTime) then begin
        TempFileHandle := FileOpen(path,fmOpenWrite);
        application.ProcessMessages;
        if not SetFileTime(TempFileHandle,@NewFileTime,nil,nil) then ; // can't log error
          if not fileinuse(ExtractFilePath(Application.ExeName)+'log\verifier\ScanError.Log') then
            if GetLastError > 0 then
            MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+'NewCreationDate: SetFileTime Failed '+
             Path+' '+ IntToStr(GetLastError)+ ': '+ SysErrorMessage(GetLastError)+'^^^^^^^^^^^',ScanLogSize);
        FileClose(TempFileHandle);
        end; // if SystemTimeToFileTime
   end; // procedure NewCreationDate
    function DateStringF(Value:Tdate):string;
     var
       DayStr,MonthStr: string;
       Year,Month,Day:word;
     begin
       DecodeDate(value,Year,Month,Day);
       DayStr := RightStr(StringOfChar('0',2) + IntToStr(Day),2);
       MonthStr := RightStr(StringOfChar('0',2) + IntToStr(Month),2);
       result := IntToStr(Year)+ '_'+MonthStr + '_' + DayStr ;
     end;
   function ArchName(DriveDir,FName,FExt: string; OldRec:TSearchRec):string;
     var
       DateString,SeqNumber,TempRec: string;
       FileList: TStringList;
       cnt,i: integer;
       rec: TSearchRec;
     begin
   //  RightStr(StringOfChar(pad,length) + value, length );
       DateString := DateStringF(CreationDate(OldRec));
       TempRec:='';
       SeqNumber :='';
       if FindFirst(DriveDir+FName+DateString+'*',(faDirectory),Rec) = 0 then begin
         TempRec:= Rec.Name;
         while FindNext(Rec) = 0 do TempRec := Rec.Name;
         FindClose(Rec);
         end; // if FindFirst
       SeqNumber := piece(piece(TempRec,FName+DateString,2),'.',1);
       cnt := NumericSegment(piece(SeqNumber,'_',2));
       if cnt > 9998 then begin
         cnt:= 0;
         DateString := DateStringF(Today);
         end;
       inc(cnt);
       SeqNumber := '_'+RightStr(StringOfChar('0',4) + IntToStr(cnt),4);
       Result := DriveDir+FName+DateString+SeqNumber+FExt;
       end; // function ArchName
procedure ArchiveFile(ArchPath,WSDriveDir,Filepath,FName,FExt,stringHeader: string;AlwaysNew: boolean);
 var
   FileRec:TSearchRec;
   ExeProcessInfo: TProcessInformation;
   NewName,EMessage,params: string;
   LastError: integer;
begin
    if FindFirst(WSDriveDir+FName+'*',(faDirectory),FileRec) = 0 then begin //Archive
      if ((CreationDate(FileRec) <> Date) or AlwaysNew) then begin
        NewName := ArchName(ArchPath,FName,FExt,FileRec);
        FindClose(FileRec);
        if not RenameFile(WSDriveDir+ FName+FExt,NewName) then begin
          EMessage :=DateTimeToStr(Now)+U+'InitLogFile ^Problem renaming log file: '+WSDriveDir+ filepath+' -> '+NewName;
          MagJBScan.LogFile('log\verifier\Scan.Log',EMessage,ScanLogSize);
          LastError:= GetLastError;
          EMessage :=DateTimeToStr(Now)+U+'Archive Rename Error'+U+WSDriveDir+ FName+FExt
            +IntToStr(LastError)+': '+SysErrorMessage(LastError);
          MagJBScan.LogFile('log\verifier\Scan.Log',EMessage,ScanLogSize);
          end
        else begin  // Successful rename - Archive step
          params := char(34)+newname+char(34)+ ' '+ char(34)+Archpath+piece(ExtractFileName(newname),'.',1)+'.html'+ char(34)+' '+ StringHeader + ' '+'none' + ' '+'^'+' '+title;
          ExecNewProcess('MagHTMLArchive.exe '+params,true);
          application.ProcessMessages;
          DeleteFile(newname);
          application.ProcessMessages;
          end;
        end;
      end
    else FindClose(FileRec);
end; // procedure ArchiveFile
function CheckFilepath(var filepath,ArchPath:string):Boolean;
// Initializes directory for the designated Share path for archival Log files (html)
// Inititalizes the Archival path and the log path if one does not exist.
// defaults to local workstation especially when the network destination filas
 var logfile: textfile;
      EMessage : string;
   begin // CheckFilepath
     result := true;
     Archpath := LogFilePath+filepath;
     //Update local creation date
     if not fileExists(ExtractFilePath(Application.ExeName)+filepath) then begin
        AssignFile(logfile,ExtractFilePath(Application.ExeName)+filepath);
        Rewrite(logfile);
        CloseFile(logfile);
        EMessage :=DateTimeToStr(Now)+'^InitLogFile ^A new logfile is created: '+ExtractFilePath(Application.ExeName)+filepath+'^^^^^^^^^^';
        InvStrGrid(True,EMessage,280,sgActivity);
        end;
     Application.ProcessMessages;
     NewCreationDate(ExtractFilePath(Application.ExeName)+filepath);
     //test remote read/write access
     try
      if not DirectoryExists(ExtractFilePath(LogFilePath+filepath))
        then if not ForceDirectories(ExtractFilePath(LogFilePath+filepath)) then begin
           EMessage :=DateTimeToStr(Now)+'^CheckFilePath^GetLastError: '+IntToStr(GetLastError)+' '+
             SysErrorMessage(GetLastError)+' '+ExtractFilePath(LogFilepath+filepath+'^^^^^^^^^^');
           InvStrGrid(True,Emessage,280,sgActivity);
          end;
      if fileExists(LogFilepath+filepath) then begin
        {$I-}
        AssignFile(logfile,LogFilepath+filepath);
        FileMode := 2;  {Set file access to Read/Write }
        Reset(logfile);
        CloseFile(logfile);
       {$I+} // if one exists then leave it alone this is only a test
       CheckFilepath := (IOResult = 0) and (LogFilepath+filepath <> '');
        end
      else begin
        AssignFile(logfile,LogFilePath+filepath);
        Rewrite(logfile);
        CloseFile(logfile);
        DeleteFile(LogFilePath+filepath); // post test cleanup
        end;
     except
       Archpath := ExtractFilePath(Application.ExeName)+filepath;
       EMessage := DateTimeToStr(Now)+'^CheckFilePath^Log File Archival reset to: '+
         Archpath + 'instead of: '+ExtractFilePath(LogFilepath+filepath);
       MagJBScan.LogFile('log\verifier\Scan.Log',EMessage,ScanLogSize);
       result := false;
       end; // try...except
     if fileinuse(ExtractFilePath(Application.ExeName)+filepath) then begin
       EMessage :=DateTimeToStr(Now)+U+'CheckFilePath^File in use: '+ExtractFilePath(LogFilepath+filepath);
       MagJBScan.LogFile('log\verifier\Scan.Log',EMessage,ScanLogSize);
       end; // if fileinuse(
   end; // CheckFilepath
 var
   WSFilePath,FName,FExt,emessage,Archpath: string;
   logfile: textfile;
  begin  // procedure InitLogFile
     // log files on local machine and archive on designated remote
    // "ArchPath" is the archival (html) designated path
    // "WS" is the local log path
    WSFilePath := ExtractFilePath(Application.ExeName)+ filepath;
    FExt := ExtractFileExt(WSFilePath);
    FName := piece(ExtractFileName(WSFilePath),ExtractFileExt(WSFilePath),1);
    if not DirectoryExists(ExtractFilePath(WSFilePath))
      then ForceDirectories(ExtractFilePath(WSFilePath));
    Archpath := LogFilePath+filepath;
    if FileExists(WSFilePath) then
      if FSize(WSFilePath) <> 0 then
        ArchiveFile(ExtractFilePath(ArchPath),ExtractFilePath(WSFilePath),Filepath,FName,FExt,stringHeader,true)
      else DeleteFile(WSFilePath);
    Checkfilepath(filepath,ArchPath);
    if not ArchiveOnly then
      if not fileExists(ExtractFilePath(Application.ExeName)+ filepath) then begin
        AssignFile(logfile,ExtractFilePath(Application.ExeName)+ filepath);
        Rewrite(logfile);
        CloseFile(logfile);
        NewCreationDate(ExtractFilePath(Application.ExeName)+ filepath);
        FileSize := 0;
        end;
    Application.ProcessMessages;
  end; //procedure InitLogFile

procedure TMagJBScan.FormCreate(Sender: TObject);
function FileLastWriteDate(FileRec: TSearchRec):TDate;
  var
    SystemTime: TSystemTime;
  begin
    FileTimeToSystemTime(FileRec.FindData.ftLastWriteTime,SystemTime);
    with SystemTime do FileLastWriteDate:= EncodeDate(wyear,wmonth,wday);
  end;
var
  FileRec: TSearchRec;
  TMP: string;
begin
   if not CheckCmdLine(RPCBroker1) then
     if GetServerInfo(VServer, VPort) <> mrCancel then begin
       RPCBroker1.Server := VServer;
       RPCBroker1.ListenerPort := StrToInt(VPort);
       Caption := 'Vista Imaging BP Verifier - Started by normal sign-on';
      end
     else halt;
     try
        RPCBroker1.Connected := true;
        if RPCBroker1.Connected then
          if not RPCBroker1.createcontext('MAG WINDOWS') then begin
            Windows.MessageBox(MagJBScan.Handle,PChar('CC:createcontext("MAG WINDOWS") not be established!'),'',MB_SYSTEMMODAL);
             halt;
             exit;
             end ;
      except
        on E:Exception do begin
           InvStrGrid(True,DateTimeToStr(Now)+'^RPC Error: formCreate ^^^^^^^^^^^^',280,sgActivity);
           halt;
           exit;
           if Assigned(RPCBroker1) then begin
             RPCBroker1.free;
             RPCBroker1 := nil;
             end;
           end;
          end; //try...except
  Application.ProcessMessages;
  if not Assigned(RPCBroker1) then Application.Terminate;
  Application.BringToFront;
  Application.ProcessMessages;
  Application.HelpFile :=ExtractFilePath(Application.ExeName)+'help\BackProc.HLP';
  Application.ShowHint := True;
  Application.HintColor := clAqua;
  Application.HintPause := 2000;
  rgSelectIEN.ItemIndex := rgSelectIEN.Items.IndexOf('ALL');
  rgSelectIENClick(Self);
  splL := splLeft.Left;
  splR := splRight.Left;
  AppVer := GetAppVer(Application.ExeName);
  OSVer := GetOSVersion(self);
  if FindFirst(Application.ExeName,(faAnyFile),FileRec) = 0 then
    DistDate :=  DateToFMInternal(DateTimeToStr(FileLastWriteDate(FileRec)))
  else DistDate := '';
  FindClose(FileRec);
  if not VerifyVersion(self,AppVer,kids) then begin
    MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+'The Background Processor client software is version ' + AppVer+
      ' .  VistA Imaging Host system has version '+kids+' installed.  Please update to compatible'+
      ' client and host software.  Shutting down the '+Application.Title+' ...'+
          '^^^^^^^^^^^',ScanLogSize);
    Windows.MessageBox(MagJBScan.Handle,PChar('The Background Processor client software is version ' + AppVer+
      ' .  VistA Imaging Host system has version '+kids+' installed.  Please update to compatible'+
      ' client and host software.  Shutting down the '+Application.Title+' ...'),'',MB_SYSTEMMODAL);
    application.Terminate;
    end;
 Place := IntToStr(GetPlace(Self));
 CompName := GetCompName(self);
 WSIEN:=GetVariable('$S($D(^MAG(2006.8,"C","'+Place+'","'+CompName+'"))'+
  ':$O(^MAG(2006.8,"C","'+Place+'","'+CompName+'","0")),1:0)');
 LogFilePath := AssignLogPath(WSIEN,CompName);
 LogSizeV := StrToFloat(LogSize(WSIEN,CompName));
 Caption := Format('%s - %s - %s %s %s',
  [SiteCode,Application.Title ,TimeToStr(Now),'         WS ID: '
    +WSID,'     JOB ID: '+JOBID]);
  AUTO :='';
  RunOnce := false;
  Term := false;
  application.ProcessMessages;
//  Get Auto-reloggin variables
  VServer := RPCBroker1.Server;
  VPort := IntToStr(RPCBroker1.ListenerPort);
  try
  SilentAccess:= GetVariable('$S($D(^MAG(2006.1,"'+place+'","GW"))'+
    ':$P($G(^MAG(2006.1,"'+place+'","GW")),U,1),1:0)');
  SilentVerify:= GetVariable('$S($D(^MAG(2006.1,"'+place+'","GW"))'+
    ':$P($G(^MAG(2006.1,"'+place+'","GW")),U,2),1:0)');
  Division := RPCBroker1.LogIn.Division;

//  Division := GetFieldValue('2006.1','.01',place+',','I',true);
  tmp :=GetVariable('$S($G(DUZ):$G(DUZ)_U_$G(DUZ(2)),1:0)');
  MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+'DUZ: '+tmp+U+MPieceSub(rString,U,1,10),ScanLogSize);
  TMP:= GetVariable('$S($D(^MAG(2006.1,"'+place+'","GW"))'+
    ':$P($G(^MAG(2006.1,"'+place+'","GW")),U,1),1:0)');
  MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+'GW ACCESS: '+tmp+U+MPieceSub(rString,U,1,10),ScanLogSize);
  TMP := GetVariable('$S($D(^MAG(2006.1,"'+place+'","GW"))'+
    ':$P($G(^MAG(2006.1,"'+place+'","GW")),U,2),1:0)');
  MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+'GW VERIFY: '+tmp+U+MPieceSub(rString,U,1,10),ScanLogSize);
  except
    MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+'SilentAccess: '+SilentAccess+U+MPieceSub(rString,U,1,10),ScanLogSize);
    MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+'SilentVerify: '+SilentVerify+U+MPieceSub(rString,U,1,10),ScanLogSize);
    MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+'Division: '+Division+U+MPieceSub(rString,U,1,10),ScanLogSize);
  end;
  SilentAccess := hash.Decrypt(SilentAccess);
  SilentVerify := hash.Decrypt(SilentVerify);
end;  //FormCreate
procedure TMagJBScan.FormActivate(Sender: TObject);
begin
  Timer1.Enabled := True;
  {$ifdef Win32}
          SetForegroundWindow(MagJBScan.Handle);
  {$else}
          BringWindowToTop(MagJBScan.Handle);
  {$endif}
  btnPurge.SetFocus;
 if not RunOnce then
   if pos('AutoVerify',ParamStr(1)) <> 0 then begin
      Application.BringToFront;
      Application.ProcessMessages;
      RunOnce := true;
      AUTO := '1';
      rgSelectIEN.ItemIndex := rgSelectIEN.Items.IndexOf('Auto');
      rgSelectIENClick(Self);
      btnPurgeClick(Self);
      Application.ProcessMessages;
      end
   else if rgSelectIEN.Items.IndexOf('Auto') <> -1 then
           rgSelectIEN.Items.Delete(rgSelectIEN.Items.IndexOf('Auto'));

end;

function TMagJBScan.VerifyVersion(Sender: TObject;AppsVersion: string;var kids: string): boolean;
var
  VERS,Data,eMessage: string;
  begin
      repeat
        RPCBroker1.ClearParameters := true;
        RPCBroker1.RemoteProcedure := 'XWB IS RPC AVAILABLE';
        RPCBroker1.Param[0].Value :='MAGQ VOK';
        RPCBroker1.Param[0].PType := literal;
        RPCBroker1.Param[1].Value := 'R';
        RPCBroker1.Param[1].PType := literal;
      {no version number passed in this example as XWB GET VARIABLE VALUE has only one version}
      until MakeBrokerCall(Self);
      if RPCBroker1.Results[0]='0' then begin
        eMessage := 'The Patch '+Piece(GetAppVer(Application.ExeName),'.',3)+' KIDS install on the Vista host system is required for this Version of the: '+Application.title;
        MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+eMessage+U+MPieceSub(rString,U,1,11),ScanLogSize);
        Application.Terminate;
        exit;
        end; // if Results[0]='0'
    result := false;
    Data := '';
    VERS := piece(AppsVersion,'.',1) + '.' + piece(AppsVersion,'.',2)+ 'P'+ piece(AppsVersion,'.',3);
    repeat
      RPCBroker1.ClearParameters := true;
      RPCBroker1.RemoteProcedure := 'MAGQ VOK';
      RPCBroker1.Param[0].Value := VERS;
      RPCBroker1.Param[0].PType := LITERAL;
    until MakeBrokerCall(Self);
    if RPCBroker1.Results.Count < 1 then begin
      MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+'BrokerError'+U+MPieceSub(rString,U,1,11),ScanLogSize);
      result := false;
      end
    else begin
      Data := RPCBroker1.Results[0];
      if pos('1^',data) <> 0 then result := true
      else result := false;
      kids := piece(data,'^',2);
      end;
  end;

function TMagJBScan.init(Sender: TObject): boolean;
  var version,loghead,WSVersion: string;
    FMGetsWS: TFMGets;
    FMFindWS: TFMFindOne;
    i: integer;
    NewColumn: TListColumn;
    TempList: TStringList;
begin
  Abstractable := GetAbstractOKList(self);
  Place := IntToStr(GetPlace(Self));
  result := false;
  TxtUpdates := 0;
  ABSRecoveryCnt := 0;
  JBFullRecoveryCnt := 0;
  NoRefCnt := 0;
  JBBadCnt := 0;
  VCBadCnt := 0;
  FileCount := 0;
  JBAltCnt := 0;
  ZSizeCnt := 0;
  ZSizeDeleted := 0;
  Dupes := 0;
  MEMCount := 1 ;
  MEMTot := (AvailVirtualSize(self) div 1000);
  MEMS := (AvailVirtualSize(self) div 1000);
  WSVersion := IntToStr(GetWorkStation(kids,self));
  if StrToInt(WSVersion) < 1 then begin
    Windows.MessageBox(MagJBScan.Handle,PChar('This server is not currently setup as a BackGround Processor.'),'',MB_SYSTEMMODAL);
    MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+
      'This BP Server is not currently setup as a BackGround Processor.'+U+MPieceSub(rString,U,1,11),ScanLogSize);
    exit;
    end;
  Lister := TFMLister.Create(self);
  Lister.RPCBroker := RPCBroker1;
  Lister.Screen :='I $P(^(0),U,7)["WORM",$P(^(0),U,10)='+Place;
  Lister.FileNumber := '2005.2';
  Lister.FieldNumbers.Add('1');
  Lister.FieldNumbers.Add('5');
  Lister.FieldNumbers.Add('7');
  Lister.DisplayFields.Add('1');
  Lister.DisplayFields.Add('5');
  Lister.DisplayFields.Add('7');
  ListViewUpdate(True,True,Lister,lvServers);
  NewColumn := lvServers.Columns.Add;
  NewColumn.Caption := 'Share Availability';
  Lister.GetList(lbServers.Items); //Broker call
//  if Lister.ErrorList.Count > 0 then for i := 0 to Lister.ErrorList.Count -1 do
//    MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+U+'Error Listing the Jukebox attributes^'+Lister.ErrorList[i]+'^^^^^^^^^^^',ScanErrorLogSize);
  Lister.Screen := 'I $P(^(0),U,7)["MAG",$P(^(0),U,10)='+Place+',$E($P(^(0),U,2),1,2)="\\"';
  ListViewUpdate(True,True,Lister,lvCacheShare);
  application.ProcessMessages;
  if lvServers.items.Count < 1 then begin
    lbServers.items.Clear;
    MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+'Jukebox shares are not setup: '+ RPCBroker1.RemoteProcedure+U+MPieceSub(rString,U,1,11),ScanLogSize);
    exit;
    end;
  repeat
    RPCBroker1.ClearParameters := true;
    RPCBroker1.RemoteProcedure := 'MAGQ SHARES';
    until MakeBrokerLSTCall(Self,lbCacheShare.items);
  if lvCacheShare.items.Count < 1 then begin
    MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+'Vista Cache shares are not setup: '+ RPCBroker1.RemoteProcedure+U+MPieceSub(rString,U,1,11),ScanLogSize);
    exit;
    end;
  TempList := TStringList.Create;
  repeat
    RPCBroker1.ClearParameters := true;
    RPCBroker1.Param[0].Value := CompName;
    RPCBroker1.Param[0].PType := LITERAL;
    RPCBroker1.Param[1].Value := 'JBScan';
    RPCBroker1.Param[1].PType := LITERAL;
    RPCBroker1.RemoteProcedure := 'MAGQ JBS';
    until MakeBrokerLSTCall(Self,TempList);
  WSID := piece(TempList[0],U,4)+' - '+CompName;
  JOBID := piece(TempList[0],U,3);
  FileID :=piece(TempList[0],U,6);
  TempList.Free;
  Caption := Format('%s - %s %s %s',
    [Application.Title ,TimeToStr(Now),'         WS ID: '
      +WSID,'     JOB ID: '+JOBID]);
  lbServers.Items.Delete(0);
  lbServers.Update;
  InitLogs;
  sgActivity.Cells[0,0]:= 'Time';
  sgActivity.ColWidths[0] := 70;
  sgActivity.Cells[1,0] := 'Activity';
  sgActivity.ColWidths[1] := 90;
  sgActivity.Cells[2,0] := 'IEN';
  sgActivity.ColWidths[3] := 90;
  sgActivity.Cells[3,0] := 'File';
  sgActivity.Cells[4,0] := 'JB Full';
  sgActivity.Cells[5,0] := 'JB Big';
  sgActivity.Cells[6,0] := 'VC Full';
  sgActivity.Cells[7,0] := 'VC Abstract';
  sgActivity.Cells[8,0] := 'VC Big';
  sgActivity.Cells[9,0] := 'CWL';
  sgActivity.Cells[10,0] := 'JB Path 1';
  sgActivity.Cells[11,0]:= 'JB Path 2';
  sgActivity.update;
  StartTime := Now;
  lblSTData.Caption := DateTimeToStr(StartTime);
  MagJBScan.Update;
  result := true;
  {if lvDupCheck(lvServers,2) then begin
    showmessage('You have multiple, online Jukebox shares with the same physical reference.');
    result := false;
    term := true;
    exit;
    end;}
  AggregateEnabled := true; //not lvDupCheck(lvServers,2);
  If AggregateEnabled then InvStrGrid(True,DateTimeToStr(Now)+'^Aggregate Function - Enabled^^^^^^^^^^^',280,sgActivity)
  else InvStrGrid(True,DateTimeToStr(Now)+'^Aggregate Function - Disabled^^^^^^^^^^^',280,sgActivity);
  // To manage Scheduled Verifier activity...
  if pos(rgSelectIEN.Items[rgSelectIEN.ItemIndex],'Auto') <> 0 then begin
    //Set StartDate to enable next-scheduling to occur regularly
     DateRequested := ParamStr(2);
   //Set Last Verifier date (scheduled)
    FMUpdate('2006.1','62.1',Place+',',DateRequested
    );
    end; // if Scheduled
   //Set Last BP Verifier WS
  FMUpdate('2006.1','62.5',Place+',',GetVariable('$O(^MAG(2006.8,"C","'+IntToStr(GetPlace(Self))+'","'+GetCompName(Self)+'",""))'));
end;


function TMagJBScan.MagEnterpriseUpdate(Data,Send,place,Application: string): boolean;
begin
  result := true;
    repeat
      RPCBroker1.ClearParameters := true;
      RPCBroker1.Param[0].VALUE := Data;
      RPCBroker1.Param[0].PTYPE := LITERAL;
      RPCBroker1.Param[1].VALUE := Send;
      RPCBroker1.Param[1].PTYPE := LITERAL;
      RPCBroker1.Param[2].VALUE := Place;
      RPCBroker1.Param[2].PTYPE := LITERAL;
      RPCBroker1.Param[3].VALUE := Application;
      RPCBroker1.Param[3].PTYPE := LITERAL;
      RPCBroker1.RemoteProcedure := 'MAGQ DFNIQ';
    until MakeBrokerCall(Self);
end; //MagEnterpriseUpdate

function TMAgJBScan.PathMaker(Location,Name: string): string;
var
  Ptr,ServerIndex: integer;
begin
  Result := '';
  Ptr := ExtractPtr(piece(Location,'.',1));
  if Ptr < 1 then exit
  else begin
    ServerIndex := ListViewSearch(lvServers,IntToStr(Ptr),0);
    if ServerIndex < 0 then begin
      ServerIndex := ListViewSearch(lvCacheShare,IntToStr(Ptr),0);
      if ServerIndex < 0 then exit;
      Result := lvCacheShare.items[ServerIndex].SubItems[1];
      if Result[length(Result)] <> '\' then Result := Result + '\';
      Result := Result+MagHash(Name,StrToInt(lvCacheShare.items[ServerIndex].Caption));
      end
    else begin
      Result := lvServers.items[ServerIndex].SubItems[1];
      if Result[length(Result)] <> '\' then Result := Result + '\';
      Result := result+MagHash(Name,StrToInt(lvServers.items[ServerIndex].Caption));
      end;
    Result := Result + name;
    end;
end;

function TMAgJBScan.LocCopy(FileName,Source,Target: string): boolean;
var
  SourcePath,TargetPath: string;
begin
  result := false;
  SourcePath := PathMaker(Source,FileName);
  TargetPath := PathMaker(Target,FileName);
  if not DirectoryExists(ExtractFilePath(TargetPath))
    then try ForceDirectories(ExtractFilePath(TargetPath));
      except
        on E: Exception do begin
          EMessage :=DateTimeToStr(Now)+U+SysErrorMessage(GetLastError)+': '+Target+
            ' ~LC.FD^'+MPieceSub(rString,U,1,11);
          MagJBScan.LogFile('log\verifier\Scan.Log',Emessage,ScanLogSize);
         OnException(E);
        end;
     end; //try
  result := CopyFile(pchar(SourcePath), pchar(TargetPath),FailIfExist);
end;

//******************************************************************************
procedure TMagJBScan.DFNReport;
function SendMessage(outData,send,place,Application:string):boolean;
begin
    repeat
    RPCBroker1.ClearParameters := true;
    RPCBroker1.Param[0].VALUE :=outData;//
    RPCBroker1.Param[0].PTYPE := LITERAL ;
    RPCBroker1.Param[1].VALUE := send;
    RPCBroker1.Param[1].PTYPE := LITERAL ;
    RPCBroker1.Param[2].VALUE := place;
    RPCBroker1.Param[2].PTYPE := LITERAL ;
    RPCBroker1.Param[3].VALUE := Application;
    RPCBroker1.Param[3].PTYPE := LITERAL ;
    RPCBroker1.RemoteProcedure := 'MAGQ DFNIQ';
    until MakeBrokerCall(Self);
end;

var
   inputFile: TextFile;
   inputLine,outLine: string;
  // use rpc "MAGG PAT INFO" TO RETRIEVE ssn & pATIENT nAME INFO

begin

 AssignFile(inputFile, ExtractFilePath(Application.ExeName)+'DFNError.log');   { File selected in dialog box }
 Reset(inputFile);
 outline := format('%-10s %-10s %-10s %-10s %-10s %-10s %-10s',
      ['Image IEN','Case/A #','App','App DFN','Image DFN','Txt DFN','App Mult']) ;
 SendMessage(outLine,'',Place,'DFN_Report');
 while not eof(inputFile) do begin
   Readln(inputFile, inputLine);                          { Read the first line out of the file }
   outLine := format('%-10s',[piece(inputLine,U,1)]);
   outLine := outline + ' '+  format('%-10s',[piece(inputLine,U,12)]);
   outLine := outline + ' '+  format('%-10s',[piece(inputLine,U,13)]);
   outLine := outline + ' '+  format('%-10s',[piece(inputLine,U,14)]);
   outLine := outline + ' '+  format('%-10s',[piece(inputLine,U,15)]);
   outLine := outline + ' '+  format('%-10s',[piece(inputLine,U,16)]);
   outLine := outline + ' '+  format('%-10s',[piece(inputLine,U,17)]);
   SendMessage(outLine,'',Place,'DFN_Report');//send message content
   end;
   SendMessage('','',Place,'DFN_Report');
   SendMessage('Imaging DFN Report','1',Place,'DFN_Report'); //   send message
   CloseFile(inputFile);
   end;
procedure TMagJBScan.Summary;
var
  index: integer;
  SMessage: string;
begin
   Application.CreateForm(TmagJBSResults,magJBSResults);
   with magJBSResults.lbReport do begin
     Clear;
     Items.Add('$$Summary');
     Items.Add('      Jukebox Duplicate Scan Report');
     Items.Add('  Jukebox Shares');
     Items.Add('2005.2 IEN--'+
       'File Share Root--'+ 'Hashed--'+'Online Status--'+ 'Number of Duplicates');
     for index := 0 to lvServers.items.count - 1 do
       Items.Add(lvServers.Items[index].Caption+ '--'+
          lvServers.Items[index].SubItems[0]+'--'+
          lvServers.Items[index].SubItems[1]+'--'+
          lvServers.Items[index].SubItems[2]+'--'+
          lvServers.Items[index].SubItems[3]+'--'+
          lvServers.Items[index].SubItems[4]);
     Items.Add(' ');
     Items.Add(' Image Shares');
     Items.Add('2005.2 IEN--'+'Share Root--'+ 'Hashed--'+'Online Status');
     for index := 0 to lvCacheShare.items.count - 1 do
       Items.Add(lvCacheShare.Items[index].Caption+'--'+
       lvCacheShare.Items[index].SubItems[0]+'--'+
       lvCacheShare.Items[index].SubItems[1]+'--'+
       lvCacheShare.Items[index].SubItems[2]+'--'+
       lvCacheShare.Items[index].SubItems[3]);
     Items.Add('  ');
     Items.Add('Starting IEN: '+StartIEN);
     Items.Add('Ending IEN: '+EndIEN);
     Items.Add('      Totals:');
     Items.Add('Start Time: '+DateTimeToStr(StartTime));
     Items.Add('Run Time (Hrs:Min:Sec): '+lblRTData.Caption);
     Items.Add('Total IENs: '+IntToStr(FileCount));
     Items.Add('NO Refs: '+IntToStr(NoRefCnt));
     Items.Add('Bad VC Refs: '+IntToStr(VCBadCnt));
     Items.Add('Bad JB Refs: '+ IntToStr(JBBadCnt));
     Items.Add('Alt JB Refs: '+IntToStr(JBAltCnt));
     Items.Add('Size Zeros: '+IntToStr(ZSizeCnt));
     Items.Add('Size Zero deleted: '+IntToStr(ZSizeDeleted));
     Items.Add('Duplicates: '+IntToStr(Dupes));
     Items.Add('Full files recovered: '+IntToStr(JBFullRecoveryCnt));
     Items.Add('Abstracts recovered: '+IntToStr(ABSRecoveryCnt));
     Items.Add('Initial Free Memory Allocation: '+IntToStr(MEMS)+ 'Kb');
     Items.Add('Average Free Memory Allocation: '+IntToStr(MEMTot Div MEMCount)+ 'Kb');
     Items.Add('Terminal Free Memory Allocation: '+IntToStr(AvailVirtualSize(Self) div 1000)+ 'Kb');
     if TxtUpdates > 0 then Items.Add('Text File Updates: '+ IntToStr(TxtUpdates));
     for index := 0 to Items.Count - 1 do begin
       SMessage := DateTimeToStr(Now)+U+'Summary ^'+Items[Index];
       MagJBScan.LogFile('log\verifier\Scan.Log',SMessage+'^^^^^^^^^^',ScanLogSize);
       end;  // with magJBSResults.
     end;
    if not term then magJBSResults.ShowModal
    else magJBSResults.Release;
end;
procedure TMagJBScan.DFNSummary(ScanCount: integer);

var i :integer;
begin
  MagJBScan.LogFile('log\verifier\DFNError.Log', IntToStr(ScanCount)+' entries scanned.^^^^^^^^^^^',DFNErrorLogSize);
  MagEnterpriseUpdate(IntToStr(ScanCount)+' entries scanned.','',Place,'DFN_Summary');
  MagEnterpriseUpdate('Summary: ','',Place,'DFN_Summary');
  MagJBScan.LogFile('log\verifier\DFNError.Log','Summary: ^^^^^^^^^^^',DFNErrorLogSize);
  for i := 0 to DFNEType.Count -1 do begin
    MagJBScan.LogFile('log\verifier\DFNError.Log', IntToStr(DFNEC[i])+ ' occurrences of : '+DFNEType[i]+' type errors.^^^^^^^^^^^',DFNErrorLogSize);
    MagEnterpriseUpdate(IntToStr(DFNEC[i])+ ' occurrences of : '+DFNEType[i]+' type errors.' ,'',Place,'DFN_Summary');
    end;
  MagJBScan.LogFile('log\verifier\DFNError.Log','Database scan took '+lblRTData.Caption +'^^^^^^^^^^^',DFNErrorLogSize);
  MagEnterpriseUpdate('Database scan took '+lblRTData.Caption,'',Place,'DFN_Summary');
  MagEnterpriseUpdate('Imaging_Integrity_Check','1',Place,'DFN_Summary');
  DFNEType.Free;
end;

procedure TMagJBScan.SendScanErrors(LogName:string);
var
  i: integer;
  temp: string;
  logfile: TextFile;
begin
  try
    AssignFile(logfile,LogName);
    Reset(logfile);
    while not SeekEof(logfile) do begin
      Readln(logfile,temp);
      MagEnterpriseUpdate(temp,'',Place,'Scan_Errors');
      end;
  finally
    CloseFile(logfile);
    MagEnterpriseUpdate('Verifier_Scan_Error_log','1',Place,'Scan_Errors');
  end;
end;


procedure TMagJBScan.TBUpdate;
var
  hours,min,sec,remain,SecsB: Int64;

begin
 Caption := Format('%s - %s %s %s',
    [Application.Title ,TimeToStr(Now),'         WS ID: '
      +WSID,'     JOB ID: '+JOBID]);
  SecsB := SecondsBetween(StartTime,Now);
  hours := SecsB div 3600;
  remain := SecsB mod 3600;
  min := remain div 60;
  sec := remain mod 60;
 lblRTData.Caption :=IntToStr(hours)+':'+IntToStr(Min)+':'+IntToStr(sec);
 lblTFPData.Caption := IntToStr(FileCount);
 lblNoRefData.Caption := IntToStr(NoRefCnt);
 lblBadVCData.Caption := IntToStr(VCBadCnt);
 lblJBBadData.Caption := IntToStr(JBBadCnt);
 lblJBAltData.Caption := IntToStr(JBAltCnt);
 lblSizeZeroData.Caption := IntToStr(ZSizeCnt);
 lblSizeZeroDelData.Caption := IntToStr(ZSizeDeleted);
 lblDuplicateData.Caption := IntToStr(Dupes);
 Application.ProcessMessages;
end;
function TMagJBScan.CheckVolNameNT(volname,volpath: string): boolean;
  function GetVolumeName(path :string ) : String;
    var
      NoMatter     : dword;
      VolumeName   : Array[0..MAX_PATH] of Char;
    begin
      if GetVolumeInformation(PChar(path), VolumeName,
        SizeOf(VolumeName),nil,NoMatter, NoMatter, Nil,0)
      then Result := VolumeName
      else  Result :='';
    end;  // GetVolumeName
begin
  if LowerCase(volname)= LowerCase(GetVolumeName(volpath)) then result := true
  else result := false;
end;
procedure TMagJBScan.InvStrGrid(Log:boolean; input: string; RMax: Integer; var Grid: TStringGrid);
var
i,k :integer;
logfile: textfile;
const delimit: string = U;
begin
  with Grid do begin
    ColCount := LastPiecePos(input,delimit); //truncate last column
    if RowCount < Rmax + 1 then RowCount := RowCount + 1;
    for i :=  RowCount downto FixedRows + 1 do
      for k := ColCount downto FixedCols do cells[k,i] := cells[k,i-1];
    for i := ColCount - 1 downto FixedCols do begin
        cells[i,FixedRows] := piece(input,delimit,((i+1)-FixedCols));
//        ColWidths[i] := Canvas.TextWidth(Cells[i,0]) + 5;
        end;
      Update;
    end;
    if Log then begin
      magjbscan.LogFile('log\verifier\Scan.LOG',input,ScanLogSize);
      end;
 Application.ProcessMessages;
end; // InvStrGrid
procedure TMagJBScan.Elog;
var
  ProcList: TStringList;
  I: integer;
begin
  ProcList := TStringList.Create;
  repeat
    RPCBroker1.ClearParameters := true;
    RPCBroker1.RemoteProcedure := 'MAGQ ELOGR';
    until MakeBrokerLSTCall(Self,ProcList);
  if ProcList.Count > 0 then begin
    MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+U+'Start Time: '+ TimeToStr(StartTime)+'^^^^^^^^^^^',ScanErrorLogSize);
    MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+U+'Run Time: '+ lblRTData.Caption+'^^^^^^^^^^^',ScanErrorLogSize);
    for i := 1 to ProcList.Count - 1 do
      MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+U+'ProcList: '+ProcList.Strings[i]+'^^^^^^^^^^^',ScanErrorLogSize);
    end;
  ProcList.free;
end;
procedure TMagJBScan.mWait(Amsec:Word);//Millisec Wait
function AddMilSec(ChngeTime:TDateTime; AmSec: word):TDateTime;
var
  hour,min,sec,msec,Asec: word;
  NewTime: TDateTime;
const
  HalfDaySec : word = 43200;
  HourSec : word = 3600;
  MinSec: word = 60;
begin
  NewTime := ChngeTime;
  Asec := AmSec div 1000;
  hour := ASec div HourSec;
  Min := (ASec mod HourSec) div MinSec;
  sec := ((ASec mod HourSec) mod MinSec);
  msec := AmSec mod 1000;
  AddMilSec := NewTime + EncodeTime(hour,min,sec,msec);
end;
var
EndPause: TDateTime;
begin
  EndPause := Now;
  EndPause := AddMilSec(EndPause,AmSec);
  While EndPause > Now do
    {Application.ProcessMessages};
end; // mWait


procedure TMagJBScan.rgSelectIENClick(Sender: TObject);
var
  check: string;
begin
case rgSelectIEN.ItemIndex of
  0: begin // Range
       rgCriteria.Enabled := true;
       ebStart.Enabled := true;
       ebStop.Enabled := true;
       rgCriteriaClick(Self);
       ebStart.Color := clWindow ;
       ebStop.Color := clWindow ;
       lblStart.Font.Color := clWindowText;
       lblStop.Font.Color := clWindowText;
       AUTO := '';
     end;
  1: begin  // ALL
       rgCriteria.Enabled := false;
       ebStart.EditMask := '';
       ebStart.Enabled := false;
       ebStop.EditMask := '';
       ebStart.Clear;
       ebStop.Clear;
       ebStop.Enabled := false;
       ebStart.Color := clScrollBar;
       ebStop.Color := clScrollBar;
       lblStart.Font.Color := clGrayText;
       lblStop.Font.Color := clGrayText;
       AUTO := '';
     end;
  2: begin // Auto
       rgCriteria.Enabled := false;
       ebStart.EditMask := '';
       ebStart.Enabled := false;
       ebStop.EditMask := '';
       ebStart.Clear;
       ebStop.Clear;
       ebStop.Enabled := false;
       ebStart.Color := clScrollBar;
       ebStop.Color := clScrollBar;
       lblStart.Font.Color := clGrayText;
       lblStop.Font.Color := clGrayText;
       //Check Site Parameters for Scheduled Verifier Check Text setting;
       check := GetFMData(RPCBroker1,'2006.1','62.6','"I"',IntToStr(GetPlace(self)));
       if piece(check,'^',1) = '-1' then rgText.ItemIndex := rgText.Items.IndexOf('Don'+#39+'t Check')
       else begin
         if numericSegment(check) = 1 then rgText.ItemIndex := rgText.Items.IndexOf('Check')
         else rgText.ItemIndex := rgText.Items.IndexOf('Don'+#39+'t Check');
         end;
       rgText.Update;
       AUTO := '1';
     end;
  end;
end;
function TMagJBScan.JBQueue(RecNo: string):string;
begin
  inc(JBQCount);
  repeat
    RPCBroker1.ClearParameters := true;
    RPCBroker1.Param[0].VALUE := RecNo;
    RPCBroker1.Param[0].PTYPE := LITERAL;
    RPCBroker1.RemoteProcedure := 'MAGQ JBQUE';
  until MakeBrokerCall(Self);
  JBQueue := RPCBroker1.Results[0];
end;

procedure TMagJBScan.SetPiece(SubString: string;var TargetString:string;delimiter:string;piece1:integer);
var
  index: integer;
  temp,temp1: string;
begin
  temp := TargetString;
  TargetString :='';
  temp1 := piece(temp,delimiter,piece1);
  for index := 1 to piece1 -1 do TargetString := TargetString + piece(Temp,delimiter,index)+ delimiter;
  TargetString := TargetString + Substring + copy(temp,(length(TargetString)+length(Temp1))+1,9999);
end;

function TMagJBScan.ListSearch(SearchList:TStrings;SearchString,Delimiter:String;position:integer):integer;
var index: integer;
begin
  result := -1;
  for index := 0 to SearchList.Count -1 do begin
    if piece(SearchList.Strings[index],Delimiter,position)=SearchString then begin
      result := index;
      exit;
      end; //if piece
    end; // for index
end; //ListSearch

function TMagJBScan.ListViewSearch(SearchList:TListView;SearchString:string;position:integer):integer;
var index: integer;
    CheckString: string;
begin
  result := -1;
  for index := 0 to SearchList.Items.Count - 1 do begin
    if position = 0 then CheckString := SearchList.Items[index].Caption
    else CheckString := SearchList.Items[index].SubItems[position-1];
    if CheckString = SearchString then begin
      result := index;
      exit;
      end; //if piece
    end; // for index
end; //ListSearch


function TMagJBScan.locpiecepos(text,value,delim:string):integer;
var i: integer;
begin
result := 0;
for i := 1 to LastPiecePos(text,delim) do
  if pos(value,piece(text,delim,i)) <> 0 then result := i;
end;


function TMagJBScan.PtrUpdate(RPC,Ptr,Ext,ien:string):boolean;
var emesage: string;
  begin
    result := false;
      repeat
        RPCBroker1.ClearParameters := true;
        RPCBroker1.Param[0].VALUE := Ptr;
        RPCBroker1.Param[0].PTYPE := LITERAL;
        RPCBroker1.Param[1].VALUE := Ext;
        RPCBroker1.Param[1].PTYPE := LITERAL;
        RPCBroker1.Param[2].VALUE := IEN;
        RPCBroker1.Param[2].PTYPE := LITERAL;
        RPCBroker1.RemoteProcedure := RPC;
      until MakeBrokerCall(Self);
      if pos('^1^','^'+trim(RPCBroker1.Results[0])+'^') = 0 then begin
        emessage :='';
        if pos('-1',RPCBroker1.Results[0]) <> 0 then emessage := Ext+ ' Ptr Update: Record not found';
        if pos('-2',RPCBroker1.Results[0]) <> 0 then emessage := Ext+  ' Ptr Update: Image is archived on an Offline platter';
        InvStrGrid(True,DateTimeToStr(Now)+U+emessage+'^'+MPieceSub(rString,U,1,11),280,sgActivity);
        end;
      result := (pos('1',RPCBroker1.Results[0]) <> 0);
end;  // PtrUpdate(Ptr,Ext,ien:string):boolean;

function TMagJBScan.ExtractPtr(Segment:string):integer;
var
  code: integer;
  delim,subsegment: string;
begin
  if pos('-',segment) <> 0 then delim := '-' else delim := '.';
  if pos(']',Segment) <> 0 then Subsegment := piece(Segment,']',2)
  else subSegment := segment;
  Val(piece(subSegment,delim,1),Result,Code);
  if (code <> 0) then result := 0;
end;
function TMagJBScan.AggregateList(ListString,CJBString: string):TStringList;
var
 i: integer;
 LocString,TmpString: string;
begin
  Result := TStringList.Create;
  Result.Sorted := true;
  Result.Duplicates := dupIgnore;
  TmpString := CJBString;
  for i := 3 to 11 do begin   // build list of available file extentions
    LocString := UpperCase(piece(ListString,U,i));
    while pos('.',LocString) <> 0 do begin
      if Result.IndexOf(piece(LocString,'.',2))= -1 then Result.Add('.' + piece(LocString,'.',2));
      LocString := copy(LocString,pos('.',LocString)+1,999)
      end; // while
    end; // for i
    while pos('.',TmpString) <> 0 do begin
      if Result.IndexOf(piece(TmpString,'.',2)) = -1 then Result.Add('.' + piece(TmpString,'.',2));
      TmpString := copy(TmpString,pos('.',TmpString)+1,999)
      end; // while
end;

function TMagJBScan.Aggregate(JBType:string;var JBString: string;ExtList: TStringList):boolean;
var
 i: integer;
begin
  result := true;
  for i := 0 to ExtList.Count -1 do // aggregate the files into the Current JukeBox Write Location
    if pos(ExtList.Strings[i],JBString) = 0 then begin
      if LocCopy(ChangeFileExt(Piece(rString,U,2),ExtList.Strings[i]),
        IntToStr(ExtractPtr(piece(rString,U,LocPiecePos(rString,ExtList.Strings[i],U)))),IntToStr(ExtractPtr(JBString))) then
        JBString := JBString + ExtList.Strings[i]
      else begin
      	EMessage :=DateTimeToStr(Now)+U+'Aggregate JB Copy Error: '+ChangeFileExt(Piece(rString,U,2),ExtList.Strings[i]);
        MagJBScan.LogFile('log\verifier\ScanError.Log',EMessage+U+MPieceSub(rString,U,1,11),ScanErrorLogSize);
        result := false;
        end;
      end;
  if result then begin
      // Update JBString to complete the Aggregate
    for i := 0 to ExtList.Count - 1 do begin // update the JBPtrs
      if (pos(ExtractFileExt(piece(rString,U,2)),ExtList.Strings[i]) <> 0) or
        (pos('.'+BigFileType,ExtList.Strings[i]) <> 0) then begin
        repeat until PtrUpdate('MAGQ JPUD',IntToStr(ExtractPtr(JBString)),
          piece(ExtList.Strings[i],'.',2),piece(rString,U,1));
        continue;
        end;
      end; // for i := 0 to ExtList.Count -1
    if JBType='F' then SetPiece(JBString,rString,U,3);
    if JBType='B' then SetPiece('['+BigFileType+']'+JBString,rString,U,4);  // Consider preserving the BIG Type
    end //  if result
  else MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+U+'Aggregation Failure Error'+U+MPieceSub(rString,U,1,11),ScanErrorLogSize);
  InvStrGrid(True,DateTimeToStr(Now)+U+'Aggregate: '+CJBString+U+MPieceSub(rString,U,1,11),280,sgActivity);
end;
function TMagJBScan.TextCheck():boolean;
  function TxtType(TextList: TStringList):integer;
    var i : integer;
    begin
      result := 3; // default to 3 ~ defined as a text file typing error
      for i := 0 to TextList.count-1 do begin
        if pos(UpperCase('Consult Information:'),
            UpperCase(TextList.Strings[i])) <> 0 then begin
          result := 0;
          exit;
          end;
        if pos('$$BEGIN DATA1',UpperCase(TextList.Strings[i])) <> 0 then begin
          result := 1;
          exit;
          end;
        if pos('$$BEGIN IMAGE DATA',UpperCase(TextList.Strings[i])) <> 0 then begin
          result := 2;
          exit;
          end;
      end;
    end;
  function SSNUM(SSNValue: string):string;
    var i,j: integer;
      dl: string;
    begin
      if Length(SSNValue)=0 then begin
        result :='';
        exit;
        end;
      val(SSNValue[4],i,j);
      if j <> 0 then begin
        dl := SSNValue[4];
        result := StringReplace(SSNValue,dl,'',[rfReplaceAll]);
        end
      else result := SSNValue;
    end;
  function GetID(FName,PTR, rString: string): String;
    var TextFileList: TStringList;
           LSSN,SSN,ChangedID,SOPUID,StudyUID,UID,path: string;
           i: integer;
           f: textfile;
    begin
      FName := Piece(FName,'.',1)+'.txt';
      result := '^^' ;
      SSN :='';
      LSSN := '';
      ChangedID := '';
      path := PathMaker(PTR+'.',FName) ;
      TextFileList := TStringList.create;
      with TextFileList do begin
        try
          TextFileList.LoadFromFile(path);
          if (TextFileList.Count < 1) then begin
            EMessage :=DateTimeToStr(Now)+U+'Text File Corruption Error Type 1: '+ path;
            MagJBScan.LogFile('log\verifier\ScanError.Log',EMessage+MPieceSub(rString,U,1,11),ScanErrorLogSize);
            TextFileList.Free;
            exit;
            end;
        except
          On E: Exception do begin
            EMessage :=DateTimeToStr(Now)+U+'Text File Corruption Error Type 2: '+path ;
            MagJBScan.LogFile('log\verifier\ScanError.Log',EMessage+MPieceSub(rString,U,1,11),ScanErrorLogSize);
            TextFileList.Free;
            exit;
            end;
        end;  //try
      case TxtType(TextFileList) of
        0: begin
            i := 0;
             repeat
               if pos('Pt ID:',strings[i]) = 1 then
                 SSN := trim(piece(Strings[i],'Pt ID:',2));
               inc(i);
             until ((SSN <> '') or (i = count-1));
              SSN := SSNum(SSN);
             end;
        1: begin //PACS
             i := 0;
             SOPUID :='';
             StudyUID := '';
             repeat
               if pos('PATIENTS_ID',strings[i]) <> 0 then
                 SSN := trim(piece(Strings[i],'PATIENTS_ID=',2));
               if pos('0010,0020|',strings[i]) <> 0 then
                 LSSN := trim(piece(Strings[i],'|',4));
               if pos('0008,0018|',strings[i]) <> 0 then // '|SOP Instance UID'
                 SOPUID := trim(piece(Strings[i],'|',4));
               if pos('0020,000D|',Strings[i]) <> 0 then  // '|Study Instance UID'
                   StudyUID := trim(piece(Strings[i],'|',4));
               inc(i);
             until (((SSN <> '')and(LSSN<>'')and(StudyUID<>'')and(SOPUID<>''))or (i = count-1));
             SSN := SSNum(SSN);
             LSSN := SSNum(LSSN);
             if pos(SSN,LSSN) = 0 then ChangedID := '1';
             if ((SOPUID='') or (StudyUID='')) then
               SetPiece('Text/Image UID Mismatch: '+path,result,U,3)
             else if ((SOPUID='') or (StudyUID='')) then
               SetPiece('GP ptr Missing: '+path,result,U,3)
               else begin
               SetPiece(SOPUID,result,U,4);
               SetPiece(StudyUID,result,U,5);
               UID := GetFMData(RPCBroker1,'2005','60','"E"',IntToStr(NumericSegment(piece(rString,U,1))));
               if piece(UID,'^',1) = '-1' then UID :='';
               if trim(SOPUID) <> trim(UID) then
                 SetPiece('Text/Image SOP/UID Mismatch: '+path,result,U,3);
               UID := GetFMData(RPCBroker1,'2005','60','"E"',IntToStr(NumericSegment(piece(piece(rString,U,17),'~',2))));
               if piece(UID,'^',1) = '-1' then UID :='';
               if trim(StudyUID) <> trim(UID) then
                 SetPiece('Text/Image Study/UID Mismatch: '+path,result,U,3);
               end; //has SOPUID & StudyUID
             if piece(Result,'^',3) <> '' then begin
                MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+U+piece(Result,'^',3)+U+
                  MPieceSub(rString,U,1,11),ScanErrorLogSize);
                InvStrGrid(True,DateTimeToStr(Now)+U+piece(Result,'^',3)+U+MPieceSub(rString,U,1,11),280,sgActivity);
                end;
             end; // CASE PACS
          2: begin
               i := 0;
               repeat
                 if pos('PATIENTS_ID=',strings[i]) = 1 then
                   SSN := trim(piece(Strings[i],'PATIENTS_ID=',2));
                 inc(i);
                until ((SSN <> '') or (i = count-1));
                SSN := SSNum(SSN);
             end;
          3: MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+'^Cannot determine Text file type: '+path+U+
              MPieceSub(rString,U,1,11),ScanErrorLogSize);
           end; // case
      end; //  with TextFileList
      TextFileList.Free;
      if SSN ='' then begin
        SetPiece('No SSN Found: '+path,Result,U,3);
        exit;
        end;
        repeat
          RPCBroker1.ClearParameters := true;
          RPCBroker1.Param[0].VALUE := '10^'+SSN;
          RPCBroker1.Param[0].PTYPE := LITERAL;
          RPCBroker1.RemoteProcedure := 'MAGG PAT FIND';
        until MakeBrokerCall(Self);
        if pos('Found 1',RPCBroker1.Results[0]) <> 0 then begin
          SetPiece(trim(piece(RPCBroker1.Results[1],U,2)),result,U,1);
          if pos('1',trim(ChangedID)) <> 0 then begin
            inc(TxtUpdates);
            InvStrGrid(True,DateTimeToStr(Now)+'^Updated Text file: '+path+U+MPieceSub(rString,U,1,11),280,sgActivity)
            end;
          end
        else SetPiece(trim(RPCBroker1.Results[0]),result,U,2);
    end; // GetID
var i,j,k,l: integer;
 ExtList,UniqueID,VCLoc:TStringList;
 EMessage: string;
begin
  result := true;
  if pos('TXT',UpperCase(rString)) <> 0 then begin
    ExtList := TStringList.Create;
    UniqueID := TStringList.Create;
    VCLoc := TStringList.Create;
    for i := 5 to 7 do begin  // was 3 to 11
      if pos('TXT',UpperCase(piece(rString,U,i))) <> 0 then
        if VCLoc.IndexOf(IntToStr(ExtractPtr(piece(rString,U,i)))) = -1 then begin
          ExtList.Add(IntToStr(ExtractPtr(piece(rString,U,i)+'.'))+U+
            GetID(piece(rString,U,2),IntToStr(ExtractPtr(piece(rString,U,i)+'.')),rString));
          VCLoc.Add(IntToStr(ExtractPtr(piece(rString,U,i))));
          end;
        end;
    for i := ExtList.Count - 1 downto 0 do begin
      if piece(ExtList[i],U,4) <> '' then result := false;
      //Compare TXT file Pat DFN to Image file (#2005) Pat DFN
      if piece(ExtList[i],U,2) <> '' then begin
        if (UniqueID.IndexOf(piece(ExtList[i],U,2)) = 0) then
          UniqueId.Add(piece(ExtList[i],U,2));
        if trim(piece(ExtList[i],U,2)) <> trim(piece(rString,U,15)) then begin
          SetPiece(piece(ExtList[i],U,2),rString,U,14);
          SetPiece('Text/Image DFN Mismatch',rString,U,20);
          InvStrGrid(True,DateTimeToStr(Now)+'^Text/Image DFN Mismatch: '+
            PathMaker(IntToStr(ExtractPtr(piece(ExtList[i],U,1)))+'.',ChangeFileExt(piece(rstring,u,2),'.TXT'))
             +U+MPieceSub(rString,U,1,11),280,sgActivity);
          EMessage := DateTimeToStr(Now)+U+ 'Text/Image DFN Mismatch'+U;
          MagJBScan.LogFile('log\verifier\ScanError.Log',EMessage+MPieceSub(rString,U,1,11),ScanErrorLogSize);
          result := false;
          end; //trim(piece(ExtList[i],U,2)) <> trim(piece(rString,U,15))
        end // piece(ExtList[i],U,2) <> ''
      else begin
        InvStrGrid(True,DateTimeToStr(Now)+'^Text file Patient ID not in Vista^'+MPieceSub(rString,U,1,11),280,sgActivity);
        EMessage := DateTimeToStr(Now)+U+ 'Text GetID Error: '+piece(ExtList[i],U,3)+U;
        MagJBScan.LogFile('log\verifier\ScanError.Log',EMessage+MPieceSub(rString,U,1,11),ScanErrorLogSize);
        result := false;
        end;
      end;  //  for i := ExtList.Count - 1 downto 0 do begin
    if UniqueID.Count > 1 then begin
      SetPiece('Mult DFN in Text Files ',rString,U,20);
      result := false;
      end;
    if ExtList.Count = 1 then begin
      SetPiece(piece(ExtList[0],U,2),rString,U,18);
      if piece(ExtList[0],U,3) <> '' then SetPiece(piece(ExtList[0],U,3),rString,U,20);
      end;
    ExtList.Free;
    UniqueID.Free;
    VCLoc.Free;
    end
    else result := true;
end; //TextCheck

procedure TMagJBScan.rgCriteriaClick(Sender: TObject);
begin
    with rgCriteria do begin
      case ItemIndex of
        0 : begin
              ebStart.EditMask := '9999999999;0;_';
              ebStop.EditMask := '9999999999;0;_';
            end;
        1: begin
              ebStart.EditMask := '!00/00/0000;1;_';
              ebStop.EditMask := '!00/00/0000;1;_';
           end;
       end; //case
      end; //with rgCriteria
end;

procedure TMagJBScan.mnuSiteIntegrityClick(Sender: TObject);
var
  OpenDialog: TOpenDialog;
begin
  if mnuSiteIntegrity.Checked then begin
    frmNeedData.Close;
    mnuSiteIntegrity.checked := false;
    end
  else begin
    OpenDialog := TOpenDialog.Create(Self);
    with OpenDialog do begin
      if logFilePath <> '' then InitialDir := logFilePath
      else InitialDir := ExtractFilePath(Application.ExeName)+'log\';
//      InitialDir := ExtractFilePath(Application.ExeName);
      DefaultExt := 'html';
      Filter := 'DFNError files (DFNError*.html)|DFNError*.html|';
      //FilterIndex := 0; { start the dialog showing all files }
      Options := [ofFileMustExist,ofPathMustExist,ofEnableSizing];
      if NOT Execute then exit
      else // SiteIntegrityReport(self,FileName);
        if pos('HTML',UpperCase(FileName)) <> 0 then begin
          Application.CreateForm(TfrmMagBPHelp,frmMagBPHelp);
          frmMagBPHelp.WB.Navigate(FileName);
          end
         else WinExec(pchar('NOTEPAD.exe '+FileName),SW_SHOW);
      end; //with OpenDialog
    mnuSiteIntegrity.checked := false;
    end; //else begin
end;
function TMagJBScan.MPieceSub(SuperString,Delimiter:string;LowerRange,UpperRange:integer):String;
var i: integer;
begin
  result := '';
  for i := LowerRange to UpperRange do begin
    if i <> LowerRange then result := result+Delimiter;
    result := result+piece(SuperString,Delimiter,i);
    end;
end;
Function TMagJBScan.PatInfo(DFN:String):string;
begin
  result := '';
   repeat
      RPCBroker1.ClearParameters := true;
      RPCBroker1.Param[0].VALUE := DFN;
      RPCBroker1.Param[0].PTYPE := LITERAL ;
      RPCBroker1.RemoteProcedure := 'MAGG PAT INFO';
    until MakeBrokerCall(Self);
      result := RPCBroker1.results[0];
end;
procedure TMagJBScan.DFNFormat(DataString: string;var wiped:string);
var
  Output,TempPatInfo: string;
       i: integer;
begin
  DFNSum(DataString);
  for i := 1 to 12 do
    case i of
      1 : Output := piece(DataString,U,1);
      2 :  SetPiece(piece(DataString,U,15),Output,U,i);
      3 :  if piece(DataString,U,15)<> '' then begin
             TempPatInfo := PatInfo(piece(DataString,U,15));
             SetPiece(piece(TempPatInfo,U,3),Output,U,3);
             SetPiece(piece(TempPatInfo,U,6),Output,U,4);
             end;
      5 :  if ((piece(DataString,U,14)<>'') and
             (piece(DataString,U,14)<>piece(DataString,U,15))) then
             SetPiece(piece(DataString,U,14),Output,U,i);
      6 :  if ((piece(DataString,U,14)<> '') and
            (piece(DataString,U,14)<>piece(DataString,U,15))) then begin
             TempPatInfo := PatInfo(piece(DataString,U,14));
             SetPiece(piece(TempPatInfo,U,3),Output,U,6);
             SetPiece(piece(TempPatInfo,U,6),Output,U,7);
             end;
      8 :  SetPiece(piece(piece(DataString,U,13),'~',1),Output,U,i);
      9 : SetPiece(piece(piece(DataString,U,13),'~',2),Output,U,i);
     10 : SetPiece(piece(piece(DataString,U,17),'~',1),Output,U,i);
     11 : if (piece(piece(DataString,U,16),'~',2)='') then MagJBScan.SetPiece('1',Output,U,i) //default to Primary
           else MagJBScan.SetPiece(piece(piece(DataString,U,16),'~',2),Output,U,11);
     12 : if piece(DataString,U,16) <> '' then
            MagJBScan.SetPiece(piece(piece(DataString,U,16),'~',1),Output,U,i)
            else MagJBScan.SetPiece(piece(piece(DataString,U,20),'~',1),Output,U,i);
    end; //case
   Wiped := Output;
   SetPiece('',Wiped,U,3);
   SetPiece('',Wiped,U,4);
   SetPiece('',Wiped,U,6);
   SetPiece('',Wiped,U,7);
end;
procedure TMagJBScan.DFNSum(DataString: String);
var EString: string;
begin
  if piece(DataString,U,16) <> '' then EString := trim(piece(DataString,U,16))
  else EString := trim(piece(DataString,U,20));
   if EString <> '' then begin
  if DFNEType.IndexOf(EString) <> -1 then
    inc(DFNEC[DFNEType.IndexOf(EString)])
  else begin
    DFNEType.Add(EString);
    DFNEC[DFNEType.IndexOf(EString)]:= 1;
    end;
    end;
end;

procedure TMagJBScan.mnuAboutBPVerifierClick(Sender: TObject);
var about : TTelaboutf  ;
begin
  try
    about := TTelaboutf.create(self);
    about.showmodal;
  finally
    about.free;
  end;
end;

procedure TMagJBScan.mnuBPHelpClick(Sender: TObject);
begin
  Application.CreateForm(TfrmMagBPHelp,frmMagBPHelp);
  frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+'help\MAG_BP_User_Manual.htm#_Toc315345021');
end;

function TMagJBScan.MakeAbs(abspath,sourcepath:string;var msg:string): boolean;
var
  NewWidth, NewHeight,i: integer;
  Factor1 : real;
  Format: String;
  JPG_CQ,IWL,ErrorFile,text,params :string;
  logfile: textfile;
  ExeProcessInfo: TProcessInformation;
  FileRec:TSearchRec;
begin
  if not DirectoryExists(ExtractFilePath(absPath))
    then try ForceDirectories(ExtractFilePath(absPath));
      except
        on E: Exception do begin
          result := false;
          msg := SysErrorMessage(GetLastError)+ ': Make AbstractError / ForceDirectories';
          exit;
        end;
     end; //try
    iwl := 'HISTO'; //Image Window Level
    ErrorFile :=ExtractFilePath(Application.ExeName)+'MagAbsError.txt';
    Format := 'JPEG';
    JPG_CQ := '100';
    params := sourcepath+ ' '+ abspath +' '+ Format + ' '+ JPG_CQ+ ' '+IWL+' '+char(34)+ErrorFile+char(34);
    WinExecAndWait32('Mag_MakeAbs.exe '+params,0,ExeProcessInfo);
      //Check AbsError.txt
   if fileExists(ErrorFile) then begin
     AssignFile(logfile,ErrorFile);
     Reset(logfile);
     Readln(logfile,text);
     msg := piece(text,'^',2);
     if pos('0',piece(text,'^',1)) <> 0 then begin
       msg := ExtractFileName(abspath)+' '+ piece(text,'^',2);
       result := true;
       end
     else begin
       result := false;
       msg :='Make AbstractError / '+ piece(text,'^',2);
       end;
     CloseFile(logfile);
     end;
   if FindFirst(abspath,(faAnyFile),FileRec) = 0 then begin
     result := true;
     if FileRec.Size = 0 then begin
       DeleteFile(abspath);
       msg := 'File of size zero created then deleted';
       result := false;
       end;
     end
   else result := false;
   FindClose(FileRec);
   Application.ProcessMessages;
end;  //MakeABS

procedure TMagJBScan.mnuDFNhelpClick(Sender: TObject);
begin
  Application.CreateForm(TfrmMagBPHelp,frmMagBPHelp);
  frmMagBPHelp.WB.Navigate(ExtractFilePath(Application.ExeName)+'help\MAG_BP_User_Manual.htm#_Toc315345028');
end;

function TMagJBScan.DupCheck(ServerList: TStrings; Position:integer): boolean;
var
  i: integer;
  Temp: string;
  TempList: TStrings;
  begin
    result := false;
    TempList := TStringList.Create;
    for i := 0 to ServerList.Count - 1 do begin
      Temp := ServerList.Strings[i];
      if ListSearch(TempList,piece(Temp,U,Position),U,Position) > 0 then begin
        result:= true;
        exit;
        end;
      TempList.Add(Temp);
      end;
    TempList.Free;
  end;
function TMagJBScan.lvDupCheck(ServerList: TListView; Position:integer): boolean;
var
  i: integer;
  Temp: string;
  TempList: TStrings;
  begin
    result := false;
    try
      TempList := TStringList.Create;
      for i := 0 to ServerList.Items.Count - 1 do begin
        if position = 0 then Temp := ServerList.Items[i].Caption
        else Temp := ServerList.Items[i].SubItems[position-1];
        if (pos('Offline',ServerList.Items[i].SubItems[2]) <> 0) then continue;
        if TempList.IndexOf(Temp) <> -1 then begin
          result:= true;
          break;
          end;
        TempList.Add(Temp);
        end;
    finally
      TempList.Free;
    end;
  end;


function TMagJBScan.Certified(ien: string): boolean;
procedure JBFullRecovery(CWL:integer;FileName,FExt: string);
  var NewPtr: integer;
begin  //no jukebox ptr
  InvStrGrid(True,DateTimeToStr(Now)+U+'No FULL JB Files^'+MPieceSub(rString,U,1,11),280,sgActivity);
  if pos('.'+BigFileType,MPieceSub(RString,U,3,11)) <> 0 then begin
    if Abstractable.IndexOf('BIG') <> -1 then begin
      NewPtr := ExtractPtr(piece(MPieceSub(RString,U,3,11),U,
        LocPiecePos(MPieceSub(RString,U,3,11),'.BIG',U)));
      if MakeAbs(PathMaker(IntToStr(CWL),ChangeFileExt(Filename,'.TGA')),
        PathMaker(IntToStr(NewPtr),ChangeFileExt(Filename,'.'+BigFileType)),EMessage) then begin
        SetPiece(IntToStr(CWL)+'.TGA',rString,U,8);
        if LocCopy(ChangeFileExt(FileName,'.TGA'),IntToStr(CWL),IntToStr(ExtractPtr(CJBString))) then begin
          CJBString := CJBString+'.TGA';
          InvStrGrid(True,DateTimeToStr(Now)+'^BigToTGA^'+MPieceSub(rString,U,1,11),280,sgActivity);
          repeat until PtrUpdate('MAGQ JPUD',IntToStr(ExtractPtr(CJBString)),'TGA',IEN);
          InvStrGrid(True,DateTimeToStr(Now)+'^TGA to JB: '+CJBString+U+MPieceSub(rString,U,1,11),280,sgActivity);
          dec(VCBadCnt);
          Inc(JBFullRecoveryCnt);
          end; // if LocCopy(
        repeat until PtrUpdate('MAGQ VCUD',IntToStr(CWL),'TGA',IEN);
        end; // if MakeAbs
     end // if Abstractable.IndexOf('BIG') <> -1
     else MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+'^MakeAbs Failure: Cannot make a TGA from this BIG file: '+
       piece(rString,U,1)+U+MPieceSub(rString,U,1,11),ScanErrorLogSize);
   end; // if BIG
end; // JBFullRecovery

procedure AbsRecovery(CWL: integer;FExt,FileName: string);
var NewPtr: integer;
begin  // recover JB ABS PTR
  InvStrGrid(True,DateTimeToStr(Now)+U+'No ABS JB Files^'+MPieceSub(rString,U,1,11),280,sgActivity);
     //first try recover ABS from Imaging Network
  NewPtr := ExtractPtr(piece(MPieceSub(RString,U,3,11),U,LocPiecePos(MPieceSub(RString,U,3,11),FExt,U)));
  EMessage:='';
  if Abstractable.IndexOf(piece(FExt,'.',2)) <> -1 then begin
    if MakeAbs(PathMaker(IntToStr(CWL),ChangeFileExt(Filename,'.ABS')),
      PathMaker(IntToStr(NewPtr),Filename),EMessage) then begin
      SetPiece(IntToStr(CWL)+'.ABS',rString,U,6);
      InvStrGrid(True,DateTimeToStr(Now)+U+'New Abs to CWL^'+MPieceSub(rString,U,1,11),280,sgActivity);
      repeat until PtrUpdate('MAGQ VCUD',IntToStr(CWL),'ABS',IEN);
      if LocCopy(ChangeFileExt(FileName,'.ABS'),IntToStr(CWL),IntToStr(ExtractPtr(CJBString))) then begin
        CJBString := CJBString+'.ABS';
        repeat until PtrUpdate('MAGQ JPUD',IntToStr(ExtractPtr(CJBString)),'ABS',IEN);
        InvStrGrid(True,DateTimeToStr(Now)+U+'Abs to JB: '+CJBString+U+MPieceSub(rString,U,1,11),280,sgActivity);
        dec(VCBadCnt);
        inc(AbsRecoveryCnt);
        end; //if LocCopy
      end // if MakeAbs
    else begin
      inc(JBBadCnt);
      MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+U+'MakeAbs failed'+U+MPieceSub(rString,U,1,11),ScanErrorLogSize);
      result := false;
      end;
      end; //     if Abstractable.IndexOf(piece(FExt,'.',2)) <> -1
end;  //ABSRecovery

procedure VerifyVCAbs;
 begin
   if pos('OFFLINE',UpperCase(piece(rstring,'^',6))) = 0 then begin
     repeat until PtrUpdate('MAGQ VCUD','0','ABS',IEN);
     SetPiece('',rString,U,6);
     EMessage :='No ABS file VC Ptr Cleared^';
     end
   else EMessage :='No ABS file VC Share Offline^';
   MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+U+EMessage+MPieceSub(rString,U,1,11),ScanErrorLogSize);
   InvStrGrid(True,DateTimeToStr(Now)+U+EMessage+MPieceSub(rString,U,1,11),280,sgActivity);
   end;

procedure VerifyVCBig(FileName,Temp: string);
 begin
     if (pos('.'+BigFileType,Temp) = 0) and (pos('OFFLINE',UpperCase(Temp)) = 0) then begin
       InvStrGrid(True,DateTimeToStr(Now)+U+'No VC Big Files^'+MPieceSub(rString,U,1,11),280,sgActivity);
       MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+U+'No VC Big Files^'+MPieceSub(rString,U,1,11),ScanErrorLogSize);
       repeat until PtrUpdate('MAGQ VCUD','0','BIG',IEN);
       SetPiece('',rString,U,7);
       end
     else if pos('.TXT',Temp) = 0 then
       if pos('.TXT',MPieceSub(RString,U,3,11)) <> 0 then
          if LocCopy(ChangeFileExt(FileName,'.TXT'),
            IntToStr(ExtractPtr(piece(rString,U,LocPiecePos(rString,'.TXT',U)))),
              IntToStr(ExtractPtr(piece(rString,U,7)))) then begin
            SetPiece(piece(rString,U,7)+'.TXT',rString,U,7);
            InvStrGrid(True,DateTimeToStr(Now)+U+'TXT to BIG VC^'+MPieceSub(rString,U,1,11),280,sgActivity);
            end;
     end; // VerifyVCBig

procedure VerifyVCFull(FExt,FileName,Temp: string);
   begin
     if (pos(FExt,Temp) = 0) and (pos('OFFLINE',UpperCase(Temp)) = 0) then begin
       InvStrGrid(True,DateTimeToStr(Now)+U+'No Full VC Files^'+MPieceSub(rString,U,1,11),280,sgActivity);
       MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+U+'No Full VC Files^'+MPieceSub(rString,U,1,11),ScanErrorLogSize);
       repeat until PtrUpdate('MAGQ VCUD','0',piece(FExt,'.',2),IEN);
       SetPiece('',rString,U,5);
       end
     else if pos('.TXT',Temp)= 0 then
       if pos('.TXT',MPieceSub(RString,U,3,11)) <> 0 then
          if LocCopy(ChangeFileExt(FileName,'.TXT'),
            IntToStr(ExtractPtr(piece(rString,U,LocPiecePos(rString,'.TXT',U)))),
              IntToStr(ExtractPtr(piece(rString,U,5)))) then begin
                SetPiece(piece(rString,U,5)+'.TXT',rString,U,5);
                InvStrGrid(True,DateTimeToStr(Now)+U+'TXT to Full VC^'+MPieceSub(rString,U,1,11),280,sgActivity);
                end;
     end; // VerifyVCFull
function BIGBelongs(TempString: string):boolean;
  begin
    if ((ExtractPtr(piece(TempString,U,4)) > 0) or
          (ExtractPtr(piece(TempString,U,7)) > 0) or
            ((pos('EMPTY_FBIG',piece(rstring,u,22)) <> 0) and
              (pos(UpperCase(piece(piece(TempString,'^',2),'.',2)),'JPG^TIF^PDF') = 0)) or
            (pos('.'+BigFileType,TempString) <> 0)) then result := true
    else result:= false;
end;
function NeedAggregate(TempString:string;ExtList: TStringList):boolean;
  var i: integer;
begin
  result := false;
  for i := 0 to ExtList.Count -1 do begin
    if (pos(ExtList.Strings[i],TempString) = 0) and
      (pos(ExtList.Strings[i],MPieceSub(rString,U,1,11)) <> 0) then result := true;
    end;
end;
var
  FullPtr,CWL,i,j:integer;
  filename,FExt,BigString,Temp,VString,EMessage: string;
  AltAggregated: boolean;
begin
    // Initialize & Filter JBPTR
  result := true;
  AltAggregated := false;
  rString := UpperCase(rString);
  if rgText.ItemIndex = 0 then result := TextCheck();
  Filename := piece(rString,U,2);
  FExt := UpperCase(ExtractFileExt(FileName));
  IEN := piece(rString,U,1);
  CWL := ExtractPtr(piece(rString,U,8));
  if pos('OFFLINE',piece(rString,U,3)) <> 0 then begin
    EMessage :=DateTimeToStr(Now)+U+'Images JB share is OFFLINE:'+
      ExtractFileDrive(PathMaker(IntToStr(ExtractPtr(piece(rString,U,3))),filename))+U+MPieceSub(rString,U,1,11);
    InvStrGrid(True,EMessage,280,sgActivity);
    inc(JBBadCnt);
    MagJBScan.LogFile('log\verifier\ScanError.Log',EMessage,ScanErrorLogSize);
    result := false;
    exit;
    end;
  FullPtr := ExtractPtr(piece(rString,U,3));
  if (pos(FExt,piece(rString,U,3)) = 0) and (pos(FExt,MPieceSub(rString,U,3,11)) = 0) then
    JBFullRecovery(CWL,FileName,FExt);
  if Abstractable.IndexOf(piece(FExt,'.',2)) <> -1 then begin
    if (((pos('ABS',piece(rString,U,3)) = 0) and (pos('ABS',MPieceSub(rString,U,3,11)) = 0) and
    (pos(FExt,MPieceSub(rString,U,3,11)) <> 0))) then AbsRecovery(CWL,FExt,FileName);
     end;
  temp := piece(rString,U,5);  //Verify VC Full
  if (ExtractPtr(temp) > 0) then VerifyVCFull(FExt,FileName,temp);
  temp := piece(rString,U,6);  //Verify VC ABS
  if (ExtractPtr(temp) > 0) and (pos('.ABS',Temp) = 0) then VerifyVCAbs;
  temp := piece(rString,U,7);  //Verify VC BIG
  if (ExtractPtr(temp) > 0) then VerifyVCBIG(FileName,temp);
  ExtList := AggregateList(rString,CJBString);
  try
  if ExtList.Indexof('.'+BigFileType)<> -1 then
    ExtList.Delete(ExtList.IndexOf('.'+BigFileType));
  for i := 9 to 11 do begin
    if not NeedAggregate(piece(rString,U,i),ExtList) and (ExtList.Count > 0) and
        (NeedAggregate(piece(rString,U,3),ExtList)) then begin
      SetPiece(piece(rString,U,3)+IntToStr(ExtractPtr(piece(rString,U,i))),rString,U,3);
      for j := 0 to ExtList.Count -1 do begin
        repeat until PtrUpdate('MAGQ JPUD',IntToStr(ExtractPtr(piece(rString,U,i))),piece(ExtList[j],'.',2),IEN);
        SetPiece(piece(rString,U,3)+ExtList[j],rString,U,3);
        end;
      AltAggregated := true;
      EMessage :=DateTimeToStr(Now)+U+'Alt Jukebox Aggregate'+U+MPieceSub(rString,U,1,11);
      InvStrGrid(True,EMessage,280,sgActivity);
      break;
      end;
    end;
  if AggregateEnabled and NeedAggregate(piece(rString,U,3),ExtList) and not AltAggregated then begin
    if not Aggregate('F',CJBString,Extlist) then begin
      EMessage :=DateTimeToStr(Now)+U+'Full Aggregate Failed'+U+MPieceSub(rString,U,1,11);
      InvStrGrid(True,EMessage,280,sgActivity);
      MagJBScan.LogFile('log\verifier\ScanError.Log',EMessage,ScanErrorLogSize);
      end
    else // SetPiece(CJBString,rString,U,3);
    end;
  finally ExtList.Free;
  end;
  if BigBelongs(MPieceSub(rString,U,1,11)) and (pos('.'+BigFileType,MPieceSub(rString,U,1,11))<>0) then begin
    ExtList :=TStringList.Create();
    AltAggregated := false;
    try
      ExtList.Add('.'+BigFileType);
      ExtList.Add('.TXT');
    for i := 9 to 11 do begin
      if not NeedAggregate(piece(rString,U,i),ExtList) and (ExtList.Count > 0) and
          (NeedAggregate(piece(rString,U,4),ExtList)) then begin
        SetPiece(piece(rString,U,4)+IntToStr(ExtractPtr(piece(rString,U,i))),rString,U,4);
        for j := 0 to ExtList.Count -1 do begin
          repeat until PtrUpdate('MAGQ JPUD',IntToStr(ExtractPtr(piece(rString,U,i))),piece(ExtList[j],'.',2),IEN);
          SetPiece(piece(rString,U,4)+ExtList[j],rString,U,4);
          end;
        AltAggregated := true;
        EMessage :=DateTimeToStr(Now)+U+'BIG Alt Jukebox Aggregate'+U+MPieceSub(rString,U,1,11);
        InvStrGrid(True,EMessage,280,sgActivity);
        break;
        end;
      end;
    if AggregateEnabled and NeedAggregate(piece(rString,U,4),ExtList) and not AltAggregated then
      if not Aggregate('B',CJBString,Extlist) then begin
        EMessage :=DateTimeToStr(Now)+U+'Big Aggregate Failed'+U+MPieceSub(rString,U,1,11);
        InvStrGrid(True,EMessage,280,sgActivity);
        MagJBScan.LogFile('log\verifier\ScanError.Log',EMessage,ScanErrorLogSize);
        Result := false;
        end
      else SetPiece(CJBString,rString,U,4);
     finally ExtList.Free;
     end;//try
     end; //if BigBelongs
  if BigBelongs(MPieceSub(rString,U,1,11)) then begin
    if (pos('.'+BigFileType,MPieceSub(rString,U,1,4))=0) then begin
      if pos('EMPTY_FBIG',piece(rstring,u,22)) <> 0 then
        InvStrGrid(True,DateTimeToStr(Now)+U+'Empty FBIG node'+U+MPieceSub(rString,U,1,11),280,sgActivity);
      if pos('ARCH',piece(rstring,u,21)) <> 0 then
        MagJBScan.LogFile('log\verifier\NoArchive.Log',ChangeFileExt(Filename,'.'+BigFileType)+'^2005.1',NoArchiveLogSize)
      else MagJBScan.LogFile('log\verifier\NoArchive.Log',ChangeFileExt(Filename,'.'+BigFileType)+'^',NoArchiveLogSize);
      InvStrGrid(True,DateTimeToStr(Now)+U+'No Jukebox Big Files^'+MPieceSub(rString,U,1,11),280,sgActivity);
      MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+U+'No Jukebox Big Files^'+MPieceSub(rString,U,1,11),ScanErrorLogSize);
      repeat until PtrUpdate('MAGQ JPUD','0','BIG',IEN);
      SetPiece('',rString,U,4);
      Result := false;
      end;
    end;
  if (pos(FExt,piece(rString,U,3)) = 0) then begin
    Result := false;
    if pos('ARCH',piece(rstring,u,21)) <> 0 then
      MagJBScan.LogFile('log\verifier\NoArchive.Log',Filename+'^2005.1',NoArchiveLogSize)
    else LogFile('log\verifier\NoArchive.Log',Filename+'^',NoArchiveLogSize);
    InvStrGrid(True,DateTimeToStr(Now)+U+'No Jukebox Full Files^'+MPieceSub(rString,U,1,11),280,sgActivity);
    MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+U+'No Jukebox Full Files^'+MPieceSub(rString,U,1,11),ScanErrorLogSize);
    repeat until PtrUpdate('MAGQ JPUD','0',piece(FExt,'.',2),IEN);
    SetPiece('',rString,U,3);
    end;
  if (Abstractable.IndexOf(FExt) <> -1) and (pos('.ABS',piece(rString,U,3)) = 0) then begin
      if pos('ARCH',piece(rstring,u,21)) <> 0 then
        MagJBScan.LogFile('log\verifier\NoArchive.Log',ChangeFileExt(Filename,'.ABS')+'^2005.1',NoArchiveLogSize)
      else LogFile('log\verifier\NoArchive.Log',ChangeFileExt(Filename,'.ABS')+'^',NoArchiveLogSize);
      end;
  if (pos('.TXT',piece(rString,U,3)) = 0) then begin
    if pos('ARCH',piece(rstring,u,21)) <> 0 then
      MagJBScan.LogFile('log\verifier\NoArchive.Log',ChangeFileExt(Filename,'.TXT')+'^2005.1',NoArchiveLogSize)
    else MagJBScan.LogFile('log\verifier\NoArchive.Log',ChangeFileExt(Filename,'.TXT')+'^',NoArchiveLogSize);
    end;
  if pos('ARCH',piece(rstring,u,21))=0 then DFNCheck(ien);
end; // Certified
procedure TMagJBScan.DFNCheck(ien:string);
function SetQA(ien,QAValue: string): boolean;
var
  i,j:integer;
  ErrorText: string;
begin
  SetQA := true ;
    repeat
      RPCBroker1.ClearParameters := true;
      RPCBroker1.RemoteProcedure := 'DDR FILER';
      RPCBroker1.Param[0].Value := 'EDIT';
      RPCBroker1.Param[0].PType := Literal;
      RPCBroker1.Param[1].Mult['1'] := '2005^13^'+ien+U+QAValue;
      RPCBroker1.Param[1].PType := List;
    until MakeBrokerCall(Self);
    if RPCBroker1.Results.Count > 1 then begin
      ErrorText := 'FM SetQA Error: ';
      j :=1;
      for i:= 1 to RPCBroker1.Results.Count-1 do begin
        if pos('BEGIN_diERRORS',RPCBroker1.Results[i]) <> 0 then begin
          SetQA := false;
          while pos('END_diERRORS',RPCBroker1.Results[i+j]) <> 0 do begin
            ErrorText := ErrorText + RPCBroker1.Results[i+j];
            inc(j);
            end;  // while pos('END_diERRORS',
          MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+U+ErrorText+U+MPieceSub(rString,U,1,11),ScanErrorLogSize);
          end;  // if pos('BEGIN_diERRORS'
        end; // for i:= 1 to RPCBroker1.Results.Count-1
      end; // RPCBroker1.Results.Count > 1
end;
var  LogOut,Wiped :string;
  begin
     if (piece(rString,U,16) <> '') then begin
       DFNFormat(rString,Wiped);
       LogOut := DFNLogFormat(ien,MPieceSub(rString,U,12,20));
       MagJBScan.LogFile('log\verifier\DFNError.Log',LogOut,DFNErrorLogSize);
       MagEnterpriseUpdate(Wiped,'',Place,'DFN_errors');
       SetQA(ien,'1');
       exit;
       end;
     if pos('~',piece(rString,U,14)) <> 0 then
        if pos(piece(piece(rString,U,14),'~',1),
          piece(piece(rString,U,14),'~',2)) <> 1 then begin
          DFNFormat(rString,Wiped);
          LogOut := DFNLogFormat(ien,MPieceSub(rString,U,12,20));
          MagJBScan.LogFile('log\verifier\DFNError.Log',LogOut,DFNErrorLogSize);
          MagEnterpriseUpdate(Wiped,'',Place,'DFN_Errors');
          SetQA(ien,'1');
          exit;
          end;
     if ((pos('~',piece(rString,U,14)) = 0) and (piece(rstring,U,14)<>''))then
        if (trim(piece(piece(rString,U,14),'~',1)) <> trim(piece(rString,U,15))) then begin
        DFNFormat(rString,Wiped);
        LogOut := DFNLogFormat(ien,MPieceSub(rString,U,12,20));
        MagJBScan.LogFile('log\verifier\DFNError.Log',LogOut,DFNErrorLogSize);
        MagEnterpriseUpdate(Wiped,'',Place,'DFN_Errors');
        exit;
        end;
     if (rgText.ItemIndex = 0) and (piece(rString,U,20) <> '') then begin
       DFNFormat(rString,Wiped);
       LogOut := DFNLogFormat(ien,MPieceSub(rString,U,12,20));
       MagJBScan.LogFile('log\verifier\DFNError.Log',LogOut,DFNErrorLogSize);
       MagEnterpriseUpdate(Wiped,'',Place,'DFN_Errors');
       exit;
       end;
     SetQA(ien,'0'); //else clear
     end;
function TMagJBScan.DFNLogFormat(ien,DFNData:String):String;
var
  output,TempPatInfo : string;
  i,h,code: integer;
begin
  output := ien+u;
    for i := 2 to 5 do
      case i of
       2: begin
           MagJBScan.SetPiece(piece(piece(DFNData,'^',i),'~',1),output,'^',8);
           MagJBScan.SetPiece(piece(piece(DFNData,'^',i),'~',2),output,'^',9);
           end;
       3:  if pos(('^'+piece(piece(DFNData,'^',i),'~',1)),
              ('^'+piece(DFNData,'^',5)+'^')) = 0 then begin
             MagJBScan.SetPiece(piece(piece(DFNData,'^',i),'~',1),output,'^',6);
             Val(piece(piece(DFNData,'^',i),'~',1), h, Code);
             if Code = 0 then begin   { nil or Error during conversion to integer? }
               //add pat name(5) and ssn(7) here
               TempPatInfo := MagJBScan.PatInfo(IntToStr(h));
               MagJBScan.SetPiece(piece(TempPatInfo,'^',3),output,'^',5);
               MagJBScan.SetPiece(piece(TempPatInfo,'^',6),output,'^',7);
               end;
             end;
       4: begin
           MagJBScan.SetPiece(piece(DFNData,'^',i),output,'^',3) ;
           Val(piece(DFNData,'^',i), h, Code);
           if Code = 0 then begin; { nil or Error during conversion to integer? }
             //  add pat name(2) and ssn(4) here
             TempPatInfo := MagJBScan.PatInfo(IntToStr(h));
             MagJBScan.SetPiece(piece(TempPatInfo,'^',3),output,'^',2);
             MagJBScan.SetPiece(piece(TempPatInfo,'^',6),output,'^',4);
             end;
           end;
       5: begin
           MagJBScan.SetPiece(piece(piece(DFNData,'^',6),'~',1),output,'^',10);
           if (piece(piece(DFNData,'^',i),'~',2)='') then MagJBScan.SetPiece('1',output,'^',11) //default to Primary
           else MagJBScan.SetPiece(piece(piece(DFNData,'^',i),'~',2),output,'^',11);
           if piece(DFNData,'^',i)='' then MagJBScan.SetPiece(piece(piece(DFNData,'^',10),'~',1),output,'^',12)
           else MagJBScan.SetPiece(piece(piece(DFNData,'^',i),'~',1),output,'^',12);
           end;
       end; // case
       for i := 1 to 12 do
       case I of
         1: MagJBScan.SetPiece(copy(piece(output,'^',i),1,9),output,'^',i);
         2: MagJBScan.SetPiece(copy(piece(output,'^',i),1,14),output,'^',i);
         3: MagJBScan.SetPiece(copy(piece(output,'^',i),1,7),output,'^',i);
         4: MagJBScan.SetPiece(copy(piece(output,'^',i),1,12),output,'^',i);
         5: MagJBScan.SetPiece(copy(piece(output,'^',i),1,14),output,'^',i);
         6: MagJBScan.SetPiece(copy(piece(output,'^',i),1,7),output,'^',i);
         7: MagJBScan.SetPiece(copy(piece(output,'^',i),1,12),output,'^',i);
         8: MagJBScan.SetPiece(copy(piece(output,'^',i),1,5),output,'^',i);
         9: MagJBScan.SetPiece(copy(piece(output,'^',i),1,8),output,'^',i);
         10: MagJBScan.SetPiece(copy(piece(output,'^',i),1,2),output,'^',i);
         11: MagJBScan.SetPiece(copy(piece(output,'^',i),1,2),output,'^',i);
         12: MagJBScan.SetPiece(copy(piece(output,'^',i),1,45),output,'^',i);
         end;
     result := output;
end;

procedure TMagJBScan.OpenLog1Click(Sender: TObject);
begin
  ShowLog.OpenLogFile(logFilePath,Self);
end;

procedure TMagJBScan.mnuExitClick(Sender: TObject);
begin
   mnuExit.Checked := false;
   if not ScanActive then Application.Terminate;
end;
procedure TMagJBScan.SiteIntegrityReport(Sender: TObject;FilePath: string);
begin
  try
    Windowstate := wsMinimized;
    frmNeedData:= TfrmNeedData.Create(Self);
    frmNeedData.ProcessReport(self,Filepath);
    frmNeedData.QuickRep1.Preview;
  finally
    Windowstate := wsNormal;
    frmNeedData.Free;
  end; // try
end;
procedure TMagJBScan.ListViewUpdate(Clear,IEN: Boolean;Lister:TFMLister;lv:TListView);
var
  i,j,k,l: integer;
  Labels: TStringList;
  NewColumn: TListColumn;
  ListItem: TListItem;
begin
  if clear then begin
   lv.Items.Clear;
   lv.Columns.Clear;
   end;
  with Lister do begin
    GetList(nil);
    if Results.Count>0 then begin
      lv.ViewStyle := vsReport;
      lv.GridLines := true;
      Labels := GetLabels(Lister);
      GetLabels(Lister).Free;
      if Labels.Count>0 then begin{Create Column Labels}
        if IEN then begin
          NewColumn := lv.Columns.Add;
          NewColumn.Caption := 'IEN';
          NewColumn.Width := lv.Font.Size*4;
          end;
        for k := 0 to Labels.Count-1 do begin
          NewColumn := lv.Columns.Add;
          NewColumn.Caption := Labels[k];
          NewColumn.Width := lv.Font.Size*(Length(Labels[k])+2);
          end;
        end;
      for i := 0 to Results.Count -1 do begin   {Create ListItems}
        ListItem := lv.Items.Add;
        if IEN then ListItem.Caption := Lister.Results[i]
        else ListItem.Caption :=
          GetRecord(Results[i]).GetField(FieldNumbers.Strings[0]).FMDBExternal;
        if IEN then l := 0 else l := 1;
        for j := l to FieldNumbers.Count -1 do
          ListItem.SubItems.Add(GetRecord(Results[i]).GetField(FieldNumbers.Strings[j]).FMDBExternal);
        end; //for i
      for i := 0 to lv.Columns.Count -1 do begin
        lv.Columns[i].AutoSize := true;   {AutoSize Columns}
        lv.Columns[i].width := columnheaderwidth;  {Set ColumnWidth}
        end;
      end; //if results
    end; // with Lister
    Labels.Free;
end; //ListViewUpdate
function TMagJBScan.GetLabels(Lister:TFMLister): TStringList;
  function GetLabel(FMFile,FMField:string): String;
    var
      ResultList :TStringList;
  begin
    ResultList := TStringList.create;
    repeat
      RPCBroker1.ClearParameters := true;
      RPCBroker1.Param[0].VALUE := FMFile;
      RPCBroker1.Param[0].PTYPE := LITERAL;
      RPCBroker1.Param[1].VALUE := FMField;
      RPCBroker1.Param[1].PTYPE := LITERAL;
      RPCBroker1.Param[2].VALUE := '';
      RPCBroker1.Param[2].PTYPE := LITERAL;
      RPCBroker1.Param[3].VALUE := 'LABEL';
      RPCBroker1.Param[3].PTYPE := LITERAL;
      RPCBroker1.RemoteProcedure := 'MAG FLD ATT';
    until MakeBrokerLSTCall(Self,ResultList);
    Result := ResultList[0] ;
    ResultList.Free;
  end;
  var i:integer;
begin
 Result := TStringList.Create;
 for i := 0 to Lister.FieldNumbers.Count-1 do
   result.Add(GetLabel(Lister.FileNumber,Lister.FieldNumbers[i]));
end;

function TMagJBScan.GetPlace(Sender: TObject):integer;
var Data,GPLACE: string;
begin
  GPlace :=GetVariable('$S($$PLACE^MAGBAPI(+$G(DUZ(2))):$$PLACE^MAGBAPI(+$G(DUZ(2))),1:0)');
  SiteCode:=GetVariable('$S($L($P($G(^MAG(2006.1,'+GPlace+',0)),U,9)):$P($G(^MAG(2006.1,'+GPlace+',0)),U,9),1:"")');
  GetPlace := StrToInt(GPlace);                                                                     
end;
function TMagJBScan.GetWorkStation(kids: string;Sender: TObject):integer;
var Data: string;
begin
 //  if kids = '3.0P13' then GetWorkStation := StrToInt(FindFMData(RPCBroker1,'2006.8','','','"'+CompName+'"','"C"',''))
  if kids = '3.0P13' then GetWorkStation := StrToInt(Find1('2006.8','','',CompName,'C','',false))
  else GetWorkStation := StrToInt(GetVariable('$O(^MAG(2006.8,"C","'+IntToStr(GetPlace(Self))+'","'+GetCompName(Self)+'",""))'));
end;

function TMagJBScan.GetFMData(Broker: TRPCBroker;FileS,FieldS,FlagS,IENs:string):string;
var
  Data: string;
begin
  if StrToInt(IENs) <= 0 then begin
    MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+U+'There is no lookup entry number for: '+FileS+' '+FieldS+U,ScanErrorLogSize);
    exit;
    end;
    repeat
      Broker.ClearParameters := true;
      Broker.RemoteProcedure := 'XWB GET VARIABLE VALUE';
      Broker.Param[0].Value := '$S($L($$GET1^DIQ('+ FileS +','+IENs+','+FieldS+','+ FlagS+
      ',"TA","ERR")):$$GET1^DIQ('+FileS +','+IENs+','+FieldS+','+
      FlagS+',"TA","ERR"),$D(ERR("DIERR",1,"TEXT",1)):"-1^"_ERR("DIERR",1,"TEXT",1)'+
       ',1:"-1^No value")';
      Broker.Param[0].PType := reference;
    until MakeBrokerCall(Self);
      if pos('-1^No value',RPCBroker1.Results[0]) <> 0 then Data :='-1^'
      else Data := RPCBroker1.Results[0];
      GetFMData := Data;
end;

function TMagJBScan.FindFMData(Broker: TRPCBroker;FileS,IENs,FlagS,ValueS,IndexS,ScreenS:string):string;
var
  Data : string;
  //example ienstring := FindFMData(RPCBroker1,'2006.8','""','"B"','+CompName+','""','"I $D(^MAG(2006.1,"C","'+CompName+'",Y))"');
begin
  repeat
    Broker.ClearParameters := true;
    Broker.RemoteProcedure := 'XWB GET VARIABLE VALUE';
    Broker.Param[0].Value := '$S($L($$FIND1^DIC('+ FileS +','+IENs+','+FlagS+','+
      ValueS+','+IndexS+','+ ScreenS+',"ROOT")):$$FIND1^DIC('+ FileS +','+IENs+','+FlagS+','+
      ValueS+','+IndexS+','+ ScreenS+',"ROOT"),1:"-1^"_ERR("DIERR",1,"TEXT",1))';
    Broker.Param[0].PType := reference;
  until MakeBrokerCall(Self);
    if Broker.Results.Count > 0 then Data := Broker.Results[0]
    else Data :='-1^';
    FindFMData := Data;
end;
procedure TMagJBScan.GetSystemTimeout(var TimeOut: string);
var  tmp: string;
begin
  tmp := IntToStr(Timer1.Interval div 900);
  try
    TimeOut := GetFMData(RPCBroker1,'8989.3','230','"I"','1');
  except
    on E:Exception do begin
      InvStrGrid(True,DateTimeToStr(Now)+'^RPC Exception^GetSystemTimeout'+'^^^^^^^^^^^',280,sgActivity);
      TimeOut := tmp;
      OnException(E);
      end; // on E:Exception
  end; //try...except
end;


procedure TMagJBScan.ExecNewProcess(ProgramName : String; Wait: Boolean);
var
  StartInfo : TStartupInfo;
  ProcInfo : TProcessInformation;
  CreateOK : Boolean;
  Emessage: string;
begin
    { fill with known state }
  FillChar(StartInfo,SizeOf(TStartupInfo),#0);
  FillChar(ProcInfo,SizeOf(TProcessInformation),#0);
  StartInfo.cb := SizeOf(TStartupInfo);
  CreateOK := CreateProcess(nil, PChar(ProgramName), nil, nil,False,
              CREATE_NEW_PROCESS_GROUP+NORMAL_PRIORITY_CLASS,
              nil, nil, StartInfo, ProcInfo);
    { check to see if successful }
  if CreateOK then
    begin
        //may or may not be needed. Usually wait for child processes
      if Wait then
        WaitForSingleObject(ProcInfo.hProcess, INFINITE);
    end
  else
    begin
      EMessage :=DateTimeToStr(Now)+U+'Create Process failed'+ProgramName;
      MagJBScan.LogFile('log\verifier\ScanError.Log',EMessage+'^^^^^^^^^^^',ScanErrorLogSize);
     end;
  CloseHandle(ProcInfo.hProcess);
  CloseHandle(ProcInfo.hThread);
end;
procedure TMagJBScan.Timer1Timer(Sender: TObject);
begin
if rpcbroker1.Connected then begin
  GetSystemTimeOut(TimeOut);
  if StrToInt(TimeOut)< 30 then TimeOut := '30';
  if piece(timeout,'^') <> '-1' then
    Timer1.Interval := (StrToInt(Timeout)*900);
  end;
end;
procedure TMagJBScan.InitLogs;
  var BldDate,range : string;
begin
  if pos(rgSelectIEN.Items[rgSelectIEN.ItemIndex],'ALL') <> 0 then
    range := gbRange.Caption + ' : ' + 'ALL';
  if pos(rgSelectIEN.Items[rgSelectIEN.ItemIndex],'Range') <> 0 then
    range := gbRange.Caption + ' : ' + ebStart.Text + ' - ' + ebStop.Text ;
  if pos(rgSelectIEN.Items[rgSelectIEN.ItemIndex],'Auto') <> 0 then
    range := gbRange.Caption + ' : ' + 'Auto';
  InitLogFile('log\verifier\DFNError.Log',dfnHeader,'DFN_Error_Log',false,DFNErrorLogSize);
  InitLogFile('log\verifier\ScanError.Log',rstringHeader,'Scan_Error_Log',false,ScanErrorLogSize);
  InitLogFile('log\verifier\NoArchive.Log','Filename^2005.1^','NoArchive_Log',false,NoArchiveLogSize);
  InitLogFile('log\verifier\Scan.Log',rStringHeader,'Scan_Log',false,ScanLogSize);
  MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+'^'+Range+'^^^^^^^^^^^',ScanLogSize);
  MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+'^Application EXE: '+Application.ExeName+' Application Version: '+
    GetAppVer(Application.ExeName)+'^^^^^^^^^^^',ScanLogSize);
  BldDate := formatdatetime('mm/dd/yy  h:nn  am/pm',filedatetime(Application.exename));
  MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+'^Application build date: '+BldDate+'^^^^^^^^^^^',ScanLogSize);
  MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+'^WS ID: '+WSID+' JOB ID: '+JOBID+' KIDS: '+kids+'^^^^^^^^^^^',ScanLogSize);
end;
function TMagJBScan.AvailVirtualSize(Sender: TObject):Int64;
var
  MS: TMemoryStatus;
begin
  MS.dwLength := SizeOf(TMemoryStatus);
  GlobalMemoryStatus(MS);
  result :=  MS.dwAvailVirtual;
end;

function TMagJBScan.GetAbstractOkList(Sender: TObject):TStringList;
var
 i: integer;
 key,ien,data,FMFile,FMField,TA,ERR: string;
begin
  Result := TStringList.Create;
  FMFile := '2005.021';
  FMField := '4';
  TA := '"TA"';
  ERR :='"ERR"';
  key :='';
  repeat
   ien := '';
   data := '';
   key := GetVariable('$O(^MAG(2005.021,"B","' + key+'"))');
   if key = '0' then key := '';
   if key <> '' then begin
     ien := GetVariable('$O(^MAG(2005.021,"B","' + key+'",""))');
     if ien <> '' then
       data := GetVariable('$S($L($$GET1^DIQ('+ FMFile +','+ien+','+FMField+
          ',"Z",'+TA+','+ERR+')):$$GET1^DIQ('+ FMFile +','+ien+','+FMField+
          ',"Z",'+TA+','+ERR+'),1:"-1^"_ERR("DIERR",1,"TEXT",1))');
     if Data = 'YES' then result.Add(key);
     end;
  until key='';
end;
function TMagJBScan.AssignLogPath(WSIEN,CompName:string):string;
// Look at the Win32 API GetFileSecurity() function.
// also GetNamedSecurityInfo to check for network write permissions before returnning the network result.
// Log and return local default
//http://groups.google.com/group/borland.public.delphi.language.delphi.win32/browse_thread/thread/40ecfe40371d89bd
begin
  result :='';
  if NumericSegment(WSIEN) > 0 then begin
    result := GetFMData(RPCBroker1,'2006.8','49','"E"',WSIEN);
    if (pos('-1',piece(result,'^',1)) <> 0) or (Length(Result) < 2) then
      result := ExtractFilePath(Application.ExeName);
    if (GetDriveType(pchar(result)) = DRIVE_REMOTE) then result := result + CompName+'\'
    else if RightStr(result,1) <> '\' then result := result +'\';
    end; // if NumericSegment(WSIEN)
end;
function TMagJBScan.GetVariable(GetLogic:string):string;
  var
  data: string;
begin
  result := '';
  repeat
    RPCBroker1.ClearParameters := true;
    RPCBroker1.RemoteProcedure := 'XWB GET VARIABLE VALUE';
    RPCBroker1.Param[0].Value := GetLogic;
    RPCBroker1.Param[0].PType := reference;
  until MakeBrokerCall(Self);
  if RPCBroker1.Results.Count > 0 then Data := RPCBroker1.Results[0]
  else Data :='0';
  result := Data;
end;// function
function TMagJBScan.LogSize(WSIEN,CompName:string):string;
var
  temp: string ;
begin
  if StrToInt(WSIEN) > 0 then begin
    temp :=  GetFMData(RPCBroker1,'2006.8','54','"E"',WSIEN);
    if temp = '' then temp := '0';
    if pos('-1',temp) <> 0 then temp := '0';
    if not (StrToFloat(temp) > 0) then temp := '1000000';
    result := FloatToStr(StrToFloat(temp)*1000000);
    end
  else result:='1000000';
end;
procedure TMagJBScan.FMComponentInit(Sender: TObject);
var i: integer;
begin
  for i := 0 to (Sender as TComponent).ComponentCount - 1 do begin
    if (pos('TFM',(Sender as TComponent).Components[i].ClassName)= 1) then begin
      if ((Sender as TComponent).Components[i] is TFMLister) then
        ((Sender as TComponent).Components[i] as TFMLister).RPCBroker := RPCBroker1;
      if ((Sender as TComponent).Components[i] is TFMGets) then
        ((Sender as TComponent).Components[i] as TFMGets).RPCBroker := RPCBroker1;
      if ((Sender as TComponent).Components[i] is TFMValidator) then
        ((Sender as TComponent).Components[i] as TFMValidator).RPCBroker := RPCBroker1;
      if ((Sender as TComponent).Components[i] is TFMFiler) then
        ((Sender as TComponent).Components[i] as TFMFiler).RPCBroker := RPCBroker1;
      if ((Sender as TComponent).Components[i] is TFMFindOne) then
        ((Sender as TComponent).Components[i] as TFMFindOne).RPCBroker := RPCBroker1;
      if ((Sender as TComponent).Components[i] is TFMFinder) then
        ((Sender as TComponent).Components[i] as TFMFinder).RPCBroker := RPCBroker1;
      if ((Sender as TComponent).Components[i] is TFMHelp) then
        ((Sender as TComponent).Components[i] as TFMHelp).RPCBroker := RPCBroker1;
      end;
    end;
end;

function TMagJBScan.AutoLogin(Broker: TRPCBroker;SilentAccess,SilentVerify,VServer,VPort,Division:string; Pause: Integer;Sender:TObject): boolean;
var tmp: string;
begin
  result := false;
  Application.ProcessMessages;
  with Broker do begin
    AccessVerifyCodes := SilentAccess + ';' + SilentVerify;
    server := VServer;
    listenerPort := strtoint(VPort);
    Broker.LogIn.Division := Division;
    try try
      connected := true;
      RPCBroker1.createcontext('MAG WINDOWS');
    except
       on E:Exception do
         InvStrGrid(True,DateTimeToStr(Now)+'^Login Message: '+
           StringReplace(E.Message,'^','~',[rfReplaceAll])+'^^^^^^^^^^^',280,sgActivity);
       end; //try...exception
    finally
      InvStrGrid(True,DateTimeToStr(Now)+'^Login Message: Silent Login attempt'+'^^^^^^^^^^^',280,sgActivity);
      if not connected then begin
        InvStrGrid(True,DateTimeToStr(Now)+'^Login Message: Broker Reconnection failed^^^^^^^^^^^',280,sgActivity);
        end // if not connected
      else begin
        InvStrGrid(True,DateTimeToStr(Now)+'^Login Message:Broker Reconnection Successful^^^^^^^^^^^',280,sgActivity);
        FMComponentInit(sender);
        FMComponentInit(self);
        application.ProcessMessages;
        result := true;
        end;
    end; //try...finally
    end; // With Broker
end;
procedure TMagJBScan.OnException(E:Exception);
begin
   timer1.Enabled := false;
   InvStrGrid(True,DateTimeToStr(Now)+'^Error on RPCBrokercall: '+
     StringReplace(E.Message,'^','~',[rfReplaceAll])+'^^^^^^^^^^^',280,sgActivity);
   if Assigned(RPCBroker1) then begin
     InvStrGrid(True,DateTimeToStr(Now)+'^Pre Auto Login RPCBroker1.Socket: '+IntToStr(RPCBROKER1.Socket)+'^^^^^^^^^^^',280,sgActivity);
     RPCBroker1.free;
     RPCBroker1 := nil;
     end;
   RPCBroker1 := TRPCBroker.Create(nil);
   if not RPCBroker1.Connected then begin
     eftfut.pause(6);
     if not AutoLogin(RPCBroker1,SilentAccess,SilentVerify,VServer,VPort,Division, 5, SELF) then
       repeat
         InvStrGrid(True,DateTimeToStr(Now)+'^Login Message: Silent Login attempt failed!'+'^^^^^^^^^^^',280,sgActivity);
         InvStrGrid(True,DateTimeToStr(Now)+'^Login Message: Pausing 3 minutes and will then retry'+'^^^^^^^^^^^',280,sgActivity);
         eftfut.pause(180);
         if Assigned(RPCBroker1) then begin
           RPCBroker1.free;
           RPCBroker1 := nil;
           end;
         RPCBroker1 := TRPCBroker.Create(nil);
       until AutoLogin(RPCBroker1,SilentAccess,SilentVerify,VServer,VPort, Division, 5, SELF);
       timer1.Enabled := true;
       end // if not dmMain.RPCBroker1.Connected
     else begin
          MagJBScan.LogFile('log\verifier\ScanError.Log',DateTimeToStr(Now)+'^Error Message^Non-Connection related Broker error^'+MPieceSub(rString,U,1,10),ScanErrorLogSize);
       end; // else
end;
function TMagJBScan.Find1(FNum,IENS,Flag,FndValue,XREF,Screen:string;silent:boolean): string;
    var
        RList: tstringlist;
        i : integer;
        float        : Extended;
        errorPos     : Integer;
        complete: boolean;
  begin
   complete := true;
   repeat
     RPCBroker1.RemoteProcedure := 'DDR FIND1';
     RList := TStringList.Create;
     RPCBroker1.Param.Clear;
     with RPCBroker1.Param[0] do begin
       Value  := '.DDR';
       Ptype  := list;
       Mult['"FILE"']  := FNum;
       Mult['"IENS"']  := IENS;
       Mult['"FLAGS"'] := Flag;
       Mult['"VALUE"'] := FndValue;
       Mult['"XREF"'] := XREF;
       Mult['"SCREEN"'] := Screen;
       end; // with RPCBroker1.Param[0]
    try
      RPCBroker1.LSTCALL(rlist);
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Error: DDR FIND1 ^^^^^^^^^^^^',280,sgActivity);
        OnException(E);
        complete := false
        end;
      end; //try...except
      if not complete then continue;
      Val(Rlist[0], float, errorPos);
      if errorPos = 0 then Result := Rlist[0]
      else begin
        Result := '-1' ;
        for i := 0 to Rlist.Count -1 do begin
          if pos('BEGIN_diERRORS',rlist[i]) <> 0 then
            if not silent then if (i+6) <= (rlist.Count -1) then showmessage(rlist[i+6]);
          end;
        end;
     if StrToInt(result) = 0 then result := '-1';
     RList.Free;
     RPCBroker1.Param.Clear;
     until complete;
   end;
function TMagJBScan.GetFieldValue(FNum,FldNum,IENS,Flag:string;silent:boolean): string;
    var RList: tstringlist;
            i : integer;
      complete: boolean;
  begin
    complete := true;
    repeat
      RPCBroker1.RemoteProcedure := 'DDR GETS ENTRY DATA';
      RList := TStringList.Create;
      RPCBroker1.Param.Clear;
      with RPCBroker1.Param[0] do begin
        Value  := '.DDR';
        Ptype  := list;
        Mult['"FILE"']  := FNum;
        Mult['"IENS"']  := IENS;
        Mult['"FIELDS"'] := FldNum;
        Mult['"FLAGS"'] := Flag;
        end; // with RPCBroker1.Param[0]
    try
      RPCBroker1.LSTCALL(rlist);
    except
      on E:Exception do begin
        InvStrGrid(True,DateTimeToStr(Now)+'^RPC Error: DDR GETS ENTRY DATA ^^^^^^^^^^^^',280,sgActivity);
        OnException(E);
        complete := false;
        end;
      end; //try...except
    if not complete then continue;
    if RList[0]='[Data]' then begin
      if flag = 'I' then result := piece(RList[1],U,4)
      else result := piece(RList[1],U,5);
      end
    else Result := '';
     //end;
    if Result = '' then
      for i := 0 to Rlist.Count -1 do begin
        if pos('BEGIN_diERRORS',rlist[i]) <> 0 then
          if not silent then
            if (i+6) <= (rlist.Count -1) then showmessage(rlist[i+6]);
           end;
    RList.Free;
    RPCBroker1.Param.Clear;
  until complete;
  end;
procedure TMagJBScan.UpdateBPServerActivity(DistDate,AppVer,OSVer: string);
var
  FMFiler1: TFMFiler;
begin
  FMFiler1 := TFMFiler.Create(self);
  FMFiler1.RPCBroker := RPCBroker1;
  FMFiler1.AddFDA('2006.8',WSIEN+',','51',AppVer);
  FMFiler1.AddFDA('2006.8',WSIEN+',','52',DistDate);
  FMFiler1.AddFDA('2006.8',WSIEN+',','53',OSVer);
  FMFiler1.AddFDA('2006.8',WSIEN+',','55',DateToFMInternal(DateToStr(Now)));
  FMFiler1.Update;
  FMFiler1.Free;
end;
function TMagJBScan.FMUpdate(FNum,FldNum,IENS,Value:string):boolean;
var
  filer: TFMFiler;
begin
  result := true;
  filer := TFMFiler.Create(self);
  filer.RPCBroker := RPCBroker1;
  Filer.AddFDA(FNum,IENS,FldNum,Value);
  filer.Update;
  if filer.ErrorList.Count > 0 then begin
    filer.DisplayErrors;
    Result := false;
    end;
  filer.Free;
end;
function TMagJBScan.FileInUse(FileName: string): Boolean;
     var hFileRes: HFILE;
     begin
       Result := False;
       if not FileExists(FileName) then exit;
      hFileRes := CreateFile(PChar(FileName),GENERIC_READ or GENERIC_WRITE,0,
                               nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0);
      Result := (hFileRes = INVALID_HANDLE_VALUE);
      if not Result then CloseHandle(hFileRes);
     end; //  function FileInUse

function TMagJBScan.DateToFMInternal(ExDate:string):string;
begin
  result := IntToStr(YearOf(StrToDate(ExDate))-1700)+
        RightStr('0'+IntToStr(MonthOf(StrToDate(ExDate))),2)+
        RightStr('0'+IntToStr(DayOf(StrToDate(Exdate))),2);
end;


procedure TMagJBScan.btnStopClick(Sender: TObject);
begin
  StopScan := true;
  MagJBScan.LogFile('log\verifier\Scan.Log',DateTimeToStr(Now)+U+'Stop button Clicked^^^^^^^^^^^',ScanLogSize);
end;
function TMagJBScan.IsStrANumber(const S: string): Boolean;
  var
    P: PChar;
  begin
    P      := PChar(S);
    Result := False;
    if P^ = #0 then Exit; 
    while P^ <> #0 do
    begin
      if not (P^ in ['0'..'9']) then Exit;
      Inc(P);
    end;
    Result := True;
  end; // IsStrANumber


end.

