unit Maggut4;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Garrett Kirin
   [==     unit Maggut4;
   Description: Image utilities
          Some functions and methods are used by many Forms (windows) and components of
          the application.  Utility units are designed to be a repository of such
          utility functions used throughout the application.

          This utility methodsthat
          -  operate on Delphi forms.
          -  String function to Replace substring in a string
                                     ==]
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)


interface
uses SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls, Inifiles,
  Forms, Dialogs, StdCtrls, FmxUtils,
  ExtCtrls, Buttons, ComCtrls, cMagPat;

  {     Call here to check,  before creating an unwanted second copy of a form.}
function DoesFormExist(s: string): boolean;
  {     Replace all sfrom to sto in the entire TStringlist}
procedure magReplaceStrings(sfrom, sto: string; var t: tstringlist);
  {     Replace all sfrom to sto in the string str}
procedure magReplaceString(sfrom, sto: string; var st: string);
  {     Set focus to a specific form}
procedure SetFocusToForm(s: string);


implementation

procedure magReplaceString(sfrom, sto: string; var st: string);
var j, k: integer;
  s: string;
begin
  { this procedure will
    switching the string - sfrom to the string - sto  }
    { we use it here for the FakePatientName function, a user can display a real
      patient for a demo, but the FakePatientName will be displayed in all delphi
      windows and in all VistA and Imaging Reports }
  if (pos(sfrom, st) > 0) then
  begin
    j := pos(sfrom, st);
    s := st;
    k := length(sfrom);
    delete(s, j, k);
    insert(sto, s, j);
    st := s;
  end;
end;

procedure magReplaceStrings(sfrom, sto: string; var t: tstringlist);
var i: integer;
  s: string;
begin
  { this procedure will to through all lines of 't'
    switching the sting - sfrom to the string - sto  }
    { we use it here for the FakePatientName function, a user can display a real
      patient for a demo, but the FakePatientName will be displayed in all delphi
      windows and in all VistA and Imaging Reports }
  for i := 0 to t.count - 1 do
  begin
    if (pos(sfrom, t[i]) > 0) then
    begin
      // 7/17/00  New procedure to switch one string, we'll call that now
      s := t[i];
      magReplaceString(sfrom, sto, s);
      t[i] := s;
      (* j := pos(sfrom,t[i]);
       s := t[i];
       k := length(sfrom);
       delete(s,j,k);
       insert(sto,s,j);
       t[i] := s; *)
    end;
  end;
end;

function DoesFormExist(s: string): boolean;
{Called with the Tform.name value of a form, to see if it exists, if we have to create it or not}
var i: integer;
begin
  result := false;
  for I := screen.CustomFormCount - 1 downto 0 do
  begin
    if (Uppercase(screen.customforms[i].name) = uppercase(s)) then
    begin
      result := true;
      break;
    end;
  end;
end;


procedure SetFocusToForm(s: string);
var I: integer;
begin
  {Called with the Tform.name value of a form. }
  for I := screen.CustomFormCount - 1 downto 0 do
  begin
    if (Uppercase(screen.customforms[i].name) = uppercase(s)) then
    begin
      (screen.customforms[i] as Tform).setfocus;
      break;
    end;
  end;
end;



end.
