unit cMagBrowsePlay;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, stdctrls, comctrls,buttons,GEARLib_TLB  {, magrec_c}{, maggut_c}
//type listtypes = (image,listview,treeview);
 ,  umagdefinitions, umagclasses, cmagimagelist, menus;
type TBrowseListType = (magltImageList, magltListView, magltTreeView, magltMultiPage);
type
  TMagBrowsePlay = class(TCustomPanel)
  private
   //FlistType : listtypes;

   //oo1 flisttype : integer;   { 0 = imagelist  1= listview }
   flisttype : TBrowseListType;
   lbDesc : Tlabel;
   lbCount : Tlabel;
   lbProc : Tlabel;
   lbDate : Tlabel;
   lbInterval : Tlabel;
   ButtonPanel : TPanel;
   TrackPanel : TPanel;
   InfoPanel : TPanel;
   TrackImage : TTrackBar;
   TrackInterval : TTrackBar;
   Image : TGear;
   popupSelect : TPopupmenu;
   sbAbs : TSpeedButton;
   sbFull : TSpeedButton;
   sbPlay : TSpeedButton;
   Timer1 : TTimer;
   PIlistptr : Tmagimagelist;
   procedure TrackImageChange(Sender: TObject);
   procedure TrackImageKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
   procedure PlayImages(Sender: TObject);
   procedure Timer1Timer(Sender: TObject);
   procedure TrackIntervalChange(Sender: TObject);
   procedure TrackPanelResize(Sender : TObject);
   procedure BrowsePlayResize(Sender : TObject);
   function AbleToPlay: boolean;
     procedure RangeStart(Sender: TObject);
    procedure RangeEnd(Sender: TObject);
  protected
    { Protected declarations }
  public
    ptrListView : ^Tlistview;
    ptrTreeView : ^TTreeview;
    constructor create(AOwner : TComponent);override;
   Destructor destroy;override;
   procedure InitList;
   procedure LinkToImageList(maglist : TMagImageList);
//   procedure LinkToList(var xlist : Tlist);
   procedure LinkToTreeView(var TV : TTreeview);
   procedure LinkToListView(var LV : TListview);
   procedure StopPlay;{ Public declarations }

  published

    property align;
    property visible;
//    property ListType : ListTypes read Flisttype write Flisttype;
 //001 TBrowseListType
    property LinkListType : TBrowseListType read Flisttype write Flisttype;

    { Published declarations }
  end;

procedure Register;

implementation

constructor TMagBrowsePlay.create(AOwner : TComponent);
var mnuStart,mnuEnd : Tmenuitem;
begin
inherited create(AOwner);
mnustart := Tmenuitem.create(self);
mnustart.Name := 'mnuselstart';
mnustart.caption := 'Range Start';
mnuEnd := Tmenuitem.create(self);
mnuEnd.Name := 'mnuselend';
mnuEnd.caption := 'Range End';
popupselect := TPopupmenu.create(self);
popupselect.Items.Add(mnustart);
popupselect.Items.Add(mnuend);
mnustart.OnClick := RangeStart;
mnuend.OnClick := RangeEnd;

ButtonPanel := TPanel.create(self);
ButtonPanel.parent := self;
ButtonPanel.bevelouter := bvnone;
ButtonPanel.Caption := '';
ButtonPanel.align := altop;
ButtonPanel.height := 28;
ButtonPanel.show;

lbDesc := Tlabel.create(self);
lbDesc.parent := self;
lbDesc.caption := 'description';
lbdesc.top := 2;
lbDesc.Align := Altop;
lbDesc.AutoSize := false;
lbDesc.layout := tlCenter;
lbDesc.height :=  22;
lbDesc.width := 250;
lbDesc.show;

TrackPanel := TPanel.create(self);
TrackPanel.parent := self;
TrackPanel.bevelouter := bvnone;
TrackPanel.Caption := '';
TrackPanel.align := alleft;
TrackPanel.width := 45;
TrackPanel.OnResize := TrackPanelResize;
TrackPanel.show;

lbCount := Tlabel.create(self);
lbCount.parent := TrackPanel;
lbCount.caption := 'count';
lbCount.Align := Altop;
lbCount.show;


InfoPanel := TPanel.create(self);
InfoPanel.parent := self;
InfoPanel.Caption := '';
InfoPanel.bevelouter := bvnone;
InfoPanel.borderwidth := 3;
InfoPanel.align := alright;
InfoPanel.width := 60;
InfoPanel.show;


lbProc := Tlabel.create(self);
lbProc.parent := InfoPanel;
lbProc.caption := 'procedure';
lbProc.Align := Altop;
lbProc.AutoSize := false;
lbProc.layout := tlCenter;
lbProc.height :=  22;
lbProc.show;

lbDate := Tlabel.create(self);
lbDate.parent := InfoPanel;
lbDate.caption := 'date';
lbDate.Align := Altop;
lbDate.AutoSize := false;
lbDate.layout := tlCenter;
lbDate.height :=  22;
lbDate.show;

sbAbs := TSpeedButton.create(self);
sbAbs.parent := ButtonPanel;
sbAbs.caption := 'Abs';
sbAbs.groupindex := 1;
sbAbs.AllowAllUp := False;
sbAbs.down := true;
sbAbs.setbounds(1,1,25,25);
sbAbs.show;

sbFull := TSpeedButton.create(self);
sbFull.parent := ButtonPanel;
sbFull.caption := 'Full';
sbFull.groupindex := 1;
sbFull.AllowAllUp := False;
sbFull.down := true;
sbFull.setbounds(27,1,25,25);
sbFull.show;

sbPlay := TSpeedButton.create(self);
sbPlay.parent := ButtonPanel;
sbPlay.caption := 'Play';
sbPlay.groupindex := 2;
sbPlay.AllowAllUp := true;
sbPlay.OnClick := PlayImages;
sbPlay.setbounds(53,1,25,25);
sbPlay.show;


TrackInterval := TTrackBar.create(self);
TrackInterval.Parent := buttonPanel;
TrackInterval.Top := 1;
TrackInterval.left := 79;
TrackInterval.Width := 64;
TrackInterval.height := 25;
TrackInterval.Min := 1;
TrackInterval.Max := 30;
TrackInterval.position := 10;
TrackInterval.Pagesize := 2;
TrackInterval.OnChange := TrackIntervalChange;
TrackInterval.visible := false;
TrackInterval.PopupMenu := popupselect;


lbInterval := Tlabel.create(self);
lbInterval.parent := buttonPanel;
lbInterval.caption := '1.0 sec.';
lbInterval.Left :=  150;
lbInterval.top := 1;
lbInterval.width :=  50;
lbInterval.visible := false;


TrackImage := TTrackBar.create(self);
TrackImage.Parent := TrackPanel;
TrackImage.Top := 18;
TrackImage.left := 2;
TrackImage.Min := 0;
TrackImage.Max := 10;
TrackImage.Pagesize := 2;
Trackimage.orientation := trVertical;
TrackImage.OnChange := TrackImageChange;
TrackImage.OnKeyDown := TrackImageKeyDown;
TrackImage.Show;
TrackImage.tickstyle := tsAuto;



Image := TGear.create(self);
Image.parent := self;
Image.Align := alClient;
Image.show;
image.PopupMenu := popupselect;

Flisttype := magltImageList;
new(ptrListView);
ptrlistview^ := nil;
new(ptrTreeView);
ptrTreeView^ := nil;
//oot new(PIlistPtr);
//oot PIListptr^ := nil;
Timer1 := nil;
OnResize := BrowsePlayResize;
end;

destructor TMagBrowsePlay.destroy;
begin
dispose(ptrListView);
dispose(ptrTreeView);
//oot dispose(PIListptr);
if Timer1 <> nil then Timer1.destroy;
inherited destroy;
end;

procedure TMagBrowsePlay.TrackImageChange(Sender: TObject);
var tPI : TImageData;
TLI : TListitem;
begin
case Flisttype of
magltImageList  : begin
   if (PIlistptr = nil ) then exit;
   if (PIlistptr.Objlist.count = 0 ) then exit;
   if (TrackImage.max <> PIlistptr.objlist.count) then InitList;
   tPI := PIListptr.objlist[TrackImage.position -1 ];
   if sbAbs.down then Image.loadimage := tPI.Afile
                 else Image.loadimage := tPI.Ffile;
   lbCount.caption := inttostr(TrackImage.position)+' of '+inttostr(PIListptr.objlist.count);
   end;
magltListView : begin
   if ( ptrlistview^ = nil ) then exit;
   if (ptrlistview^.items.count = 0 ) then exit;
   if (TrackImage.max <> ptrListView^.items.count) then InitList;
   TLI := ptrlistview^.items[TrackImage.position -1 ];
   tPI := TLI.data ;
   ptrlistview^.selected := nil;
   TLI.selected := true;
   if sbAbs.down then Image.loadimage := tPI.Afile
                 else Image.loadimage := tPI.Ffile;
   lbCount.caption := inttostr(TrackImage.position)+' of '+inttostr(ptrListView^.items.count);
   end;
end ;{ case}



Image.tag := strtoint(tPI.Mag0);
lbDesc.caption :=   tPI.imgdes;
lbDate.caption :=   tPI.Date;
lbProc.caption :=   tPI.proc;
end;

procedure TMagBrowsePlay.TrackImageKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
IF ((SSRIGHT IN SHIFT) OR (NOT (SSSHIFT IN SHIFT) ))THEN
   BEGIN
   TrackImage.SELEND := 0;
   TrackImage.SELSTART := 0;
   EXIT;
   END;
WITH TrackImage DO
     BEGIN
     IF KEY = 40 THEN
     begin
     IF ((SELSTART = 0) and (selend =0 )) THEN
       begin
       SELSTART := POSITION;
       selend := position ;
       exit;
       end;
     IF SELSTART  > POSITION THEN SELSTART := POSITION
      ELSE SELEND := POSITION;
     end;
     END;
end;

procedure TMagBrowsePlay.InitList;
begin
case flisttype of
magltImageList :   begin
   if PIListptr.objlist.count = 0 then
     begin
     StopPlay;
     exit;
     end;
   if PIListptr.objlist.count > 0 then
   TrackImage.Max := PIListptr.objlist.count;
   end;
magltListView :
   begin
   if ptrListview^.items.count = 0 then
     begin
     StopPlay;
     exit;
     end;
   if ptrListview^.items.count > 0 then
   TrackImage.Max := ptrListview^.items.count;
   end;

magltTreeView :   begin
   if ptrTreeview^.items.count = 0 then
     begin
     StopPlay;
     exit;
     end;
   if ptrTreeView^.items.count > 0 then
   TrackImage.Max := ptrTreeView^.items.count;
   end;
end; { case }
TrackImage.Min := 1;
Image.aspectRatio := 2;
Image.fitmethod := 2;
Image.AutoRedraw := true;
TrackImage.position := 1;
TrackImagechange(self);
{BrowsePanel.width := 200;   }
end;


procedure TMagBrowsePlay.LinkToListView(var LV : Tlistview);
begin
ptrListView^ := LV;
flisttype := magltListView;
initlist;
end;

procedure TMagBrowsePlay.LinkToTreeView(var TV : TTreeview);
begin
ptrTreeView^ := TV;
flisttype := magltTreeView;
initlist;
end;

procedure TMagBrowsePlay.LinkToImageList(maglist : TMagImageList);
begin
flisttype := magltImageList;
PIListptr := maglist;
InitList;
end;


function TMagBrowsePlay.AbleToPlay;
begin
result := true;
case Flisttype of
 magltImageList : begin
   if (PIlistptr = nil ) then begin result := false; exit; end;
   if (PIlistptr.objlist.count = 0 ) then begin result := false; exit; end;
   end;
magltListView : begin
   if ( ptrlistview^ = nil ) then begin result := false; exit; end;
   if (ptrlistview^.items.count = 0 ) then begin result := false; exit; end;
   end;
{ 2 : begin          
  if (ptrTreeView^ = nil ) then exit;
  if (ptrTreeView^.count = 0) then exit;
  end;              }
  end; {case}

end;

procedure TMagBrowsePlay.PlayImages(Sender: TObject);
begin
if sbPlay.down then
               begin
               if not AbleToPlay then
                  begin
                  sbPlay.down := false;
                  exit;
                  end;
               Timer1 := TTimer.create(self);
               Timer1.OnTimer := Timer1Timer;
               TrackInterval.show;
               lbInterval.show;


               // create timer set its onTimer event
               // enable it.
               TrackIntervalChange(self);
               Timer1.enabled := true
               end
               else
               begin
               Timer1.enabled := false;
               Timer1.destroy;
               Timer1 := nil;
               TrackInterval.Hide;
               lbInterval.hide;
               // destroy timer
               end;
end;

procedure TMagBrowsePlay.Timer1Timer(Sender: TObject);
var i,j : integer;
incup : boolean;
begin
incup := true;
with TrackImage do
begin
if(( selstart <>  0 ) or (selend <> 0)) then
       begin
       i := selstart;
       j := selend;
       end
       else
       begin
       i := min;
       j := max;
       end;
if(( position >= j ) or ( position < i ))
   then position := i
   else Position := Position+1;
TrackImagechange(self);
end;
end;

procedure TMagBrowsePlay.TrackIntervalChange(Sender: TObject);
begin
Timer1.Interval := (100 * TrackInterval.position);
lbinterval.caption := floattostr(Timer1.interval / 1000) + ' sec.';
end;

procedure TMagBrowsePlay.TrackPanelResize(Sender: TObject);
begin
TrackImage.height := Trackpanel.height - 5 - TrackImage.top;
end;

procedure TMagBrowsePlay.BrowsePlayResize(Sender: TObject);
var i,j,k : integer;
begin
if (buttonpanel.width-(lbinterval.Left +lbinterval.Width)) >
   (60 + 60 +10) then
                      begin
                      lbdate.parent := buttonpanel;
                      lbdate.top := lbinterval.top;

                      lbdate.align := alnone;
                      lbdate.left := buttonpanel.width-65;
                      lbproc.parent := buttonpanel;
                      lbproc.top := lbinterval.top;
                      lbproc.align := alnone;
                      lbproc.left := buttonpanel.width-125;
                      lbproc.Width := 60;
                      infopanel.visible := false;
                      end
                      else
                      begin
                      infopanel.visible := true;
                      lbproc.parent := infopanel;
                      lbproc.align := altop;
                      lbdate.parent := infopanel;
                      lbdate.align := altop;
                      end;


end;

procedure TMagBrowsePlay.StopPlay;
begin
sbPlay.down := false;
if Timer1 <> nil then
   begin
   Timer1.enabled := false;
   Timer1.destroy;
   Timer1 := nil;
   TrackInterval.Hide;
   lbInterval.hide;
   end;
end;


procedure Register;
begin
  RegisterComponents('Imaging', [TMagBrowsePlay]);
end;

procedure TMagBrowsePlay.RangeStart(Sender: TObject);
begin
TrackImage.SelStart := trackimage.position;

end;


procedure TMagBrowsePlay.RangeEnd(Sender: TObject);
begin
TrackImage.SelEnd := trackimage.position;

end;


end.
