unit cMagDBDemo;
   {
   Package: MAG - VistA Imaging
 WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
 Date Created:
 Site Name: Silver Spring, OIFO
 Developers: Garrett Kirin
 [==  unit cMagDBDemo;
 Description:  Imaging Demo DataBase RPC Calls.
   Desecndant of Abstract Class TMagDBBroker
     This Class will surface (redeclare, override and implement) the Abstract
     methods and members of the ancestor abstract class to make Demo
     DataBase Calls.
   This design enables the application to function the same way
   regardless of which database is connected.  M, (Oracle), Demo TXT files
   ==]
 Note:
  }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Trpcb, hash, RPCconf1, uMagUtils, uMagDefinitions, umagclasses,
  maggmsgu, fmxutils, magfileversion, cmagdbbroker, cMagDBDemoUtils;

type
  TMagDBDemo = class(TMagDBBroker)
  private
  //demo
    FPatientList : Tstrings;
    FBroker: TRPCBroker;
    FDemoConnected : boolean;
    FDuz : string;
    FDemoUtils : TMagDemoUtils;
  protected
    { Protected declarations }
  public
    constructor create();
//gek    function GetSilentCodes(Vserver, Vport: string;  var SilentAccess: string; var SilentVerify: string): boolean; override;
    function CheckDBConnection(var xmsg: string): boolean; override;
    function IsConnected: boolean; override;
    procedure SetConnected(const Value: boolean); override;
    function GetListenerPort: integer; override;
    function GetServer: string; override;
    procedure SetListenerPort(const Value: integer); override;
    procedure SetServer(const Value: string); override;

    function GetBroker: TRPCBroker; override;
    procedure SetBroker(const Value: TRPCBroker); override;
    procedure CreateBroker; override;
    function RPFileManDate(var xmsg: string; dateinput: string; var dateoutput: string; NoFuture : boolean = false): boolean; override;
    procedure RPXMultiProcList(lit: TStrings; dfn: string);  override;

        //ADMINDOC
    procedure RPMagVersionCheck(T: Tstrings; version: string); override;
    //Clinical Procedures
    procedure RPUpdateConsult(consult, tiuien, cmpflag: string; var status: string); override;
    procedure RPGetClinProcReq(dfn: string; var t: Tstrings); override;
    procedure RPGetTIUDAfromClinProcReq(dfn, fConsIEN, vstring, Complete: string; var t: Tstrings); override;
    procedure RPGetVisitListForReq(dfn: string; var t: Tstrings); override;

    procedure RPMaggOffLineImageAccessed(IObj: TImageData); override;
    procedure RPMaggQueImage(IObj: TImageData); override;
    procedure RPMaggQueBigImage(IObj: TImageData); override;
    procedure RPMag3Logaction(actionstring: string); override;
    procedure RPMaggQuePatient(whichimages, DFN: string); override;
    procedure RPMaggQueImageGroup(whichimages, MAGIEN: string); override;
    procedure RPMaggGroupImages(IObj: TImageData; var t: tstringlist; noQAcheck: boolean = false); override;
//    procedure RPMaggPatImages(DFN: string; var t: tstringlist); override;
    procedure RPMaggPatEachImage(DFN, MAX: string; var t: tstringlist); override;
    procedure RPMaggLogOff; override;
    procedure RPMaggWrksUpdate(Apppath, DispAppName, CapAppName, Compname, Location, LastUpdate: string; startmode: integer); override;
    procedure RPMaggUserKeys(var t: Tstringlist); override;
    procedure RPMaggGetTimeout(app: string; var minutes: string); override;
    procedure RPGetNoteText(tiuda: string; t: tstrings); override;
    procedure RPGetNoteTitles(t, tint: tstringlist); override;
//  not creating  TIU Entries.
    function RPCreateRecord(var msg: string; DFN, notetitle, notedate: string; notetext: tstrings): boolean; override;
    function RPGetFileManDateTime(datestr: string; var DisDt, IntDT: string; NoFuture : boolean = false): boolean; override;
    function RPSignRecord(tiuda, hashesign: string; var MSG: string): boolean; override;
    procedure RPGetDischargeSummaries(dfn: string; var t: tstringlist); override;
    procedure RPGetNotesByContext(dfn: string; var t: tstringlist; context: integer; author, count: string; docclass: integer; seq: string; showadd: integer; incund: integer); override;
    function RPGetTIUData(tiuda: string; var TIUPTR: string): boolean; override;
    procedure RPGetCPRSTIUNotes(tiuda: string; t: tstringlist; var success: boolean; var RPmsg: string); override;
//    procedure RPMagCategories(t: tstrings); override;
    function RPMagEkgOnline: integer; override;
    procedure RPMagGetNetLoc(var success: boolean; var RPmsg: string; var Shares: TStringList; NetLocType: string); override;
    procedure RPMagLogErrorText(T: Tstrings; COUNT: INTEGER); override;

    function RPTIUCPClass: integer; override;
    function RPTIUConsultsClass: integer; override;
    procedure RPGetFileExtensions(var t: tstrings); override;


 /////////////////////////
    procedure RPFilterDelete(var rstat: boolean; var rmsg: string; fltien: string); override;
    procedure RPFilterSave(var rstat: boolean; var rmsg: string; t: Tstrings); override;
    procedure RPFilterListGet(var rstat: boolean; var rmsg: string; var tlist: tstrings; duz: string = ''; getall: boolean = false); override;
    procedure RPFilterDetailsGet(var rstat: boolean; var rmsg, filter: string; fltien: string; fltname: string = ''; duz: string = ''); override;
    procedure RPCTPresetsGet(var rstat: boolean; var rmsg: string; var value: string); override;
    procedure RPCTPresetsSave(var rstat: boolean; var rmsg: string; value: string); override;

    procedure RPMaggHS(var rstat: boolean; var rmsg: string; var tlist: tstringlist; value: string); override;
    procedure RPMaggHSList(var rstat: boolean; var rmsg: string; var tlist: tstringlist; value: string); override;
    procedure RPMaggRadReport(var rstat: boolean; var rmsg: string; var tlist: tstringlist; rarpt: string); override;
    procedure RPMaggRadImage(var rstat: boolean; var rmsg: string; var tlist: tstringlist; radstring: string); override;
    procedure RPMaggDGRPD(var rstat: boolean; var rmsg: string; var rlist: tstringlist; dfn: string); override;
    procedure RPMaggUser2(var rstat: boolean; var rmsg: string; var rlist: tstrings; wsid: string); override;
    procedure RPMaggCPRSRadExam(var rstat: boolean; var rmsg: string; var rlist: tstrings; cprsstring: string); override;
    procedure RPMaggRadExams(var rstat: boolean; var rmsg: string; var rlist: tstrings; DFN: string); override;
    procedure RPMaggImageInfo(var rstat: boolean; var rmsg: string; var rlist: tstrings; ien: string; noQAcheck : boolean = false); override;
    procedure RPMag4PatGetImages(var Fstat: boolean; var rpcmsg: string; DFN: string; var Flist: tstrings; filter: TImageFilter = nil); override;
    procedure RPMagGetUserPreferences(var Fstat: boolean; var rpcmsg: string; xlist: Tstringlist; code: string = ''); override;
    procedure RPMagSetUserPreferences(var Fstat: boolean; var rpcmsg: string; xlist: Tstrings); override;
//    procedure RPMagIndexType(var Fstat: boolean; var Flist: tstringlist; MagDFN: string); override;
    procedure RPMag4RemoteImport(var Fstat: boolean; var Flist: tstringlist; DataArray: Tstringlist); override;
    procedure RPMagPatInfo(var Fstat: boolean; var Fstring: string; MagDFN: string; isicn: boolean = false); override;
//    procedure RPMag4PostProcessing(var Fstat: boolean; var Flist: tstringlist; Magien: string); override;
    procedure RPMag4PostProcessActions(var Fstat: boolean; var Flist: tstringlist; Magien: string); override;
    procedure RPMag3LookupAny(var Fstat: boolean; var fmsg: string; var Flist: tstringlist; InputString: string); override;
    procedure RPMag4IAPIStats(var Fstat: boolean; var FList: tstrings; DtStart, DtEnd: string); override;
    procedure RPMaggImageDelete(var Fstat: boolean; var rmsg: string; var Flist: tstrings; IEN, ForceDel: string; reason: string = ''; GrpDelOK: boolean = false); override;
//    procedure RPMagGetImageReport(var Fstat: boolean; var Fmsg: string; Flist: tstrings; magien: string); override;
    procedure RPImageReport(var Fstat: boolean; var Fmsg: string; Flist: tstrings; IObj: TImageData; noQACheck : boolean= false); override;
    procedure RPMag3TIUImage(var Fstat: boolean; var Flist: tstringlist; MagIEN, TIUDA: string); override;
    procedure RPMag4DataFromImportQueue(var Fstat: boolean; var Flist: tstringlist; QueueNum: string); override;
    procedure RPMag4ValidateData(var Fstat: boolean; var Flist: tstringlist; t: tstringlist; rettype: string); override;
    procedure RPMag4AddImage(var Fstat: boolean; var Flist: tstringlist; t: tstringlist); override;
    procedure RPMagABSJB(var Fstat: boolean; var Flist: tstringlist; CreatAbsIEN, JBCopyIEN: string); override;

    function RPMag4GetFileFormatInfo(ext: string; var xmsg: string): boolean; override;
    function RPVerifyEsig(esig: string; var xmsg: string): boolean; override;
    procedure RPLogCopyAccess(s: string); override;
    procedure RPIndexGetType(lit: TStrings; cls: string; ignoreStatus: boolean = false); override;
    procedure RPIndexGetEvent(lit: TStrings; cls: string = ''; spec: string = ''; ignoreStatus: boolean = false); override;
    procedure RPIndexGetSpecSubSpec(lit: TStrings; cls: string = ''; proc: string = ''; ignoreStatus: boolean = false); override;
    procedure RPDGChkPatDivMeansTest(DFN: string; var code: INTEGER; var t: TSTRINGLIST); override;
    procedure RPDGSensitiveRecordBulletin(DFN: string); override;
    procedure RPDGSensitiveRecordAccess(DFN: string; var code: INTEGER; var t: TSTRINGLIST); override;
    function RPMaggPatBS5Chk(DFN: string; var t: tstringlist): boolean; override;
    function RPMagPatLookup(STR: string; t: tstrings; var xmsg: string): boolean; override;
    procedure RPMag4GetImageInfo(magien: string; var Flist: Tstrings); override;
    function RPMaggGetPhotoIDs(xdfn: string; t: tstringlist): BOOLEAN; override;
    procedure RPMag4StatusCallback(t: tstrings; cb: string; DoStatusCB: boolean = true); override;
    { TODO : Need to return a message, 'Why connection didn't work, User cancel, Error, etc. }
    { TODO : DBSelect needs : option of user sending the Server Port, and not being prompted for it . }
    function DBSelect(var vserver, vport: string; context: string = 'MAG WINDOWS'): boolean; override;
    function DBConnect(vserver, vport: string; context: string = 'MAG WINDOWS'; accesscode: string = ''; verifycode: string = ''): boolean; override;
//testdemo    function Connected: boolean;

  published
 //   property Broker: TRPCBroker read GetBroker write SetBroker;
//   property Connected : boolean read IsConnected write SetConnected;
//   property listenerport : integer read GetListenerPort write SetListenerPort;
//   property server : string read GetServer write SetServer;
  end;


implementation



procedure TMagDBDemo.RPDGChkPatDivMeansTest(DFN: string; var code: INTEGER; var t: TSTRINGLIST);
begin
//demo
code := 0;
exit;
  FBroker.PARAM[0].VALUE := DFN;
  FBroker.PARAM[0].PTYPE := LITERAL;
  FBroker.REMOTEPROCEDURE := 'DG CHK PAT/DIV MEANS TEST';
  {         Checks if means test required for patient and checks if means test display required for
             user's division.
             Returns 1 in 1st string if Both true :
             Otherwise 0
             If Both true, returns test in 2nd and 3rd string ( if any)
             }
  try
    FBroker.lstCALL(t);
    if t.count = 0 then
      begin
        code := -1;
        t[0] := 'The Attempt to determine Patient Means Test Status failed. Check VistA Error Log.';
        exit;
      end;

    code := strtoint(t[0]);
    t.delete(0);
  except
    on E: EXCEPTION do
      begin
        code := -1;
        t[0] := 'The Attempt to determine Patient sensitivity Failed. Check VistA Error Log.';
      end;
  end;

end;

procedure TMagDBDemo.RPDGSensitiveRecordBulletin(DFN: string);
begin
//demo
exit;
  {         DG SENSITIVITY RECORD BULLETIN
             Input parameter ACTION (send bulletin, set log, or both) will be made optional with 'both' being the default value
             Input parameter DG1 (inpatient/outpatient status) will be removed

  PARAMETERS ARE 3 ? ( MIGHT HAVE CHANGED )
     1 = DFN   2 = Option name^Menu text (Optional)  3 =  Action (Optional)
               ACTION CODE 1  SET LOG
                           2  SEND BULLETIN
                           3  BOTH  ( DEFAULT )      }

  FBroker.PARAM[0].VALUE := DFN;
  FBroker.PARAM[0].PTYPE := LITERAL;
  FBroker.REMOTEPROCEDURE := 'DG SENSITIVE RECORD BULLETIN';
  FBroker.STRCALL;
  {
  EXCEPT
  ON E: EXCEPTION DO
     begin
     result := false;
     IF (POS('<SUBSCRIPT>',E.MESSAGE) > 0 ) THEN xmsg := 'The Remote Procedure Call '+xbrokerx.remoteprocedure+' doesn''t exist on VISTA.  Please Call IRM'
                                           else xmsg := E.message;
     end;
  end;
  }

end;

{ TODO : This needs changed to style of Broker Calls in magDBBroker. }

procedure TMagDBDemo.RPDGSensitiveRecordAccess(DFN: string; var code: INTEGER; var t: TSTRINGLIST);
begin
//demo
code := 0;
exit;
  FBroker.PARAM[0].VALUE := DFN;
  FBroker.PARAM[0].PTYPE := LITERAL;
  FBroker.REMOTEPROCEDURE := 'DG SENSITIVE RECORD ACCESS';
  {
             DG SENSITIVE RECORD ACCESS
             Output value line 1 of RESULT will be made less granular
             -1 = RPC/API failed
             0 = No display or action required
             1 = Display warning message
             2 = Display warning message - require OK to continue
             3 = Display warning message - do not continue
             If the output value is 1 (display warning message) entry in DG SECURITY LOG file is automatically made; GUI application does not need to take action to log access

             DG SENSITIVITY RECORD BULLETIN
             Input parameter ACTION (send bulletin, set log, or both) will be made optional with 'both' being the default value
             Input parameter DG1 (inpatient/outpatient status) will be removed
  }
  try
    FBroker.lstCALL(t);
    if t.count = 0 then
      begin
        code := -1;
        t[0] := 'The Attempt to determine Patient sensitivity Failed. Check VistA Error Log.';
        exit;
      end;

    code := strtoint(t[0]);
    t.delete(0);
  except
    on E: EXCEPTION do
      begin
        code := -1;
        t[0] := 'The Attempt to determine Patient sensitivity Failed. Check VistA Error Log.';
      end;
  end;
end;

{ TODO : This needs changed to style of Broker Calls in magDBBroker. }

function TMagDBDemo.RPMaggPatBS5Chk(DFN: string; var t: tstringlist): boolean;
begin
//demo
result := true;
exit;
  FBroker.PARAM[0].VALUE := DFN;
  FBroker.PARAM[0].PTYPE := LITERAL;
  FBroker.REMOTEPROCEDURE := 'MAGG PAT BS5 CHECK';
  {         Checks if More than one patient has Same Last Name and Last 4 of SSN
             It calls the Patient API  GUIBS5A^DPTLK6 to figure it out.
             Returns 1 in 1st string if more than 1 exist
             Otherwise 0
             }
  try
    FBroker.lstCALL(t);
    if t.count = 0 then
      begin
        result := true;
        exit;
      end;

    if t[0] = '0' then
      begin
        result := true;
        exit;
      end;

    t.delete(0);
    result := false;
  except
    on E: EXCEPTION do result := true
  end; ;

end;

{ TODO : This needs changed to style of Broker Calls in magDBBroker. }

function TMagDBDemo.RPMagPatLookup(STR: string; t: tstrings; var xmsg: string): boolean;
var I : integer;
begin
 {'M' t[1] = SAHO,F 10/10/1920 123456789   NON-VETERAN(OTHER)^959}
 {Demo,Patient^c:\Program Files\vista\imaging\image\patient1^Various types of Images.}
 FPatientlist.LoadFromFile(ExtractFilePath(application.exename)+'image\MagDemoPatients.TXT');

 for i := 0 to FPatientlist.count-1 do
        begin
        t.add(magpiece(FPatientlist[i],'^',1)+'^' + magpiece(FPatientlist[i],'^',2));
        end;
 result := true;
//demo
end;

// New Patch 8 call to return patient images based on filters of
//   package, Class, date range.

procedure TMagDBDemo.RPMag4PatGetImages(var Fstat: boolean; var rpcmsg: string; DFN: string; var Flist: tstrings; filter: TImageFilter = nil);
var cls, pkg, types, spec, event: string;
  FrDt: string;
  ToDt: string;
  MthRange: integer;
  origin: string;
  oldRpcTimeLimit: integer;
  demolist : Tstrings;
  patdir : string;
begin
demolist := tstringlist.create;
try
fstat := true; //fstat := false;
rpcmsg := 'List of demo images' ; //'No images for filter Demo.'  ;
(*
'2^02/12/2002^CP HOLTER^11^HOLTER^^^IMAGE^^^|
     1966^\\ISW-IMGQADB\IMAGE1$\QA\00\19\QA001967.ASC^.\BMP\magtext.bmp^HOLTER^3020212^11^
       CP HOLTER^02/12/2002^107^^A^^^11^^^^^1023^GREEN,DEAN^^^^^'

'2^09/10/2003^CLIN^1^CONSENT^NONE^CLIN^CONSENT^ALLERGY & IMMUNOLOGY^DISCHARGE SUMMARY^|
     3044^C:\IMAGE\GK00\00\00\00\30\GK000000003044.TIF^C:\IMAGE\GK00\00\00\00\30\GK000000003044.ABS^
        CONSENT^3030910.1229^15^CLIN^09/10/2003^^M^A^^^1^^^^^1068^KIRIN,NEW^CLIN^^^^'
*)
patdir := magpiece(fpatientlist[strtoint(dfn)-1],'^',3);
//demolist.LoadFromFile(demodir+'\magdemoimagelist.txt');
demolist.LoadFromFile(extractfilepath(application.exename)+patdir+'\magdemoimagelist.txt');

if filter <> nil then FDemoUtils.FilterTheList(filter,demolist);
Flist.Assign(demolist);
finally
demolist.free;
end;
exit;
//demo
 {TODO: needs activated for demo}

  cls := '';
  pkg := '';
  types := '';
  spec := '';
  event := '';
  FrDt := '';
  ToDt := '';
 // MthRange := 0;
  origin := '';
  if filter <> nil then
    begin
      cls := ClassesToString(filter.classes);
      pkg := PackagesToString(filter.packages);
      types := filter.Types;
      spec := filter.SpecSubSpec;
      event := filter.ProcEvent;
      FrDt := filter.FromDate;
      ToDt := filter.ToDate;
      MthRange := filter.MonthRange;
      if MthRange < 0 then
        begin
          frdt := formatdatetime('mm/dd/yyyy', incMonth(date, mthrange));
          todt := '';
        end;
      origin := filter.origin;
    end;
exit;
//for Filters to work in Demo.
(* we have a complete image list for demo patients. MagDemoImageList (in each patients demo dir)
   and we load it above (Flist)
loop through all properties of filter. if not null
see if appropriate '^' piece of Image entry is contained in property.
i.e. pkg = 'MED,RAD'   substr := $p(6)  if ((substr <> '') and (pos(substr,pkg)> 0))
                                            then okay
                                            else delete this item.


*)
//demo

  with FBroker do
    begin
      oldRpcTimeLimit := RPCtimelimit;
      maggmsgf.magmsg('s', 'Increasing RPCTimeLimit to ' + inttostr(oldRPCTimelimit * 2));
      RPCTimeLimit := oldRPCTimeLimit * 2;
      param[0].Value := DFN;
      param[0].PType := literal;
      param[1].value := pkg;
      param[1].ptype := literal;
      param[2].value := cls;
      param[2].ptype := literal;
      param[3].value := types;
      param[3].ptype := literal;
      param[4].value := event;
      param[4].ptype := literal;
      param[5].value := spec;
      param[5].ptype := literal;
      Param[6].Value := FrDt;
      Param[6].ptype := literal;
      Param[7].Value := ToDt;
      Param[7].ptype := literal;
      Param[8].Value := origin;
      Param[8].PType := literal;
      remoteprocedure := 'MAG4 PAT GET IMAGES';
    end;
  try
    maggmsgf.MagMsg('s', 'DFN:' + DFN + ' Start RPC MAG4 PAT GET IMAGES' + formatdatetime('mm/mm@hh:nn:ss.zzz', now));
    Fbroker.lstCall(Flist);
    maggmsgf.MagMsg('s', 'DFN:' + DFN + ' Done RPC MAG4 PAT GET IMAGES' + formatdatetime('mm/mm@hh:nn:ss.zzz', now));
    if (magpiece(Flist[0], '^', 1) = '0') then
      begin
        Fstat := false;
        rpcmsg := magpiece(Flist[0], '^', 2);
        exit;
      end;
    Fstat := true;
    rpcmsg := magpiece(Flist[0], '^', 2);
    Flist.delete(0);
  except
    on E: EXCEPTION do
      begin
        Flist.insert(0, '0^ERROR Accessing Patient Image list.');
        Fstat := false;
        rpcmsg := 'ERROR Accessing Patient Image list: ' + e.Message;
        Flist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;
  maggmsgf.magmsg('s', 'Restoring RPCTimeLimit to ' + inttostr(oldRPCTimelimit));
  Fbroker.RPCTimeLimit := oldRPCTimeLimit;
end;

function TMagDBDemo.RPMaggGetPhotoIDs(xdfn: string; t: tstringlist): BOOLEAN;
var flist : Tstrings;
patdir : string;
i : integer;
photoi : integer;
begin
photoi := -1;
flist := Tstringlist.create;

patdir := magpiece(fpatientlist[strtoint(xdfn)-1],'^',3);
flist.LoadFromFile(extractfilepath(application.exename)+patdir+'\magdemoimagelist.txt');


for i := 0 to flist.count-1 do
  begin
   if magpiece(magpiece(flist[i],'|',2),'^',6)='18' then
     begin
      photoi := i;
      break;
      end;

  end;
if photoi > -1 then
  begin
  result := true;
  t.add(magpiece(flist[photoi],'|',2));
  end
  else result := false;
exit;
//demo
  try
    with FBroker do
      begin
        param[0].Value := XDFN;
        param[0].PType := literal;
        remoteprocedure := 'MAGG PAT PHOTOS';
        lstCall(t);
      end;
    if (t.count < 2) then result := false
    else
      begin
        result := true;
        t.delete(0);
      end;
  except
    result := false;
  end;
  //if (magpiece(t[0],'^',1) = 0 ) then result := false;
  //if (magpiece(t[0],'^',2) = 0 ) then result := false;
end;

(*function TMagDBDemo.Connected : boolean;
begin
  if assigned(Fbroker) then
    result := Fbroker.Connected
  else result := false;
end; *)

function TMagDBDemo.DBConnect(vserver, vport: string; context: string = 'MAG WINDOWS'; accesscode: string = ''; verifycode: string = ''): boolean;
var SilentAccess, SilentVerify: string;
begin
//demo
FDemoConnected := true;
result := true;
exit;
  if not assigned(FBroker) then
    begin
      result := false;
      exit;
    end;

  if ((accesscode <> '') and (Verifycode <> '')) then
    begin
      Fbroker.AccessVerifyCodes := Accesscode + ';' + Verifycode;
    end ;
 (*gek else if GetSilentCodes(Vserver, Vport, SilentAccess, SilentVerify) then
    begin
      Fbroker.AccessVerifyCodes := SilentAccess + ';' + SilentVerify;
    end; *)

  Fbroker.server := VServer;
  Fbroker.listenerPort := strtoint(VPort);
  try
    FBroker.connected := true;
    Result := FBroker.connected;

    if result then
      begin
        Fbroker.CreateContext(context);
      end;
  except
    on e: exception do
      begin
        result := false;
      end;
  end;
end;


function TMagDBDemo.DBSelect(var vserver, vport: string; context: string = 'MAG WINDOWS'): boolean;
var SilentAccess, SilentVerify: string;
begin
result := true;
FDemoConnected := true;
exit;
//demo
  if not assigned(FBroker) then
    begin
      result := false;
      exit;
    end;
  if (GetServerInfo(VServer, VPort) = mrOK) then
    begin
     (* gek if GetSilentCodes(Vserver, Vport, SilentAccess, SilentVerify) then
        begin
          Fbroker.AccessVerifyCodes := SilentAccess + ';' + SilentVerify;
        end;  *)
      Fbroker.server := VServer;
      Fbroker.listenerPort := strtoint(VPort);
      FBroker.connected := true;
      Result := FBroker.connected;
    end
  else
    result := false;
  if result then
    begin
      try
        Fbroker.CreateContext(context);
      except
        on e: exception do
          begin
            result := false;
          end;
      end;
    end;
end;

procedure TMagDBDemo.RPMaggImageDelete(var Fstat: boolean; var rmsg: string; var Flist: tstrings; IEN, ForceDel: string; reason: string = ''; GrpDelOK: boolean = false);
begin
Fstat := true;
messagedlg('Demo Image NOT deleted',mtconfirmation,[mbok],0);
exit;
  Fstat := false;
  rmsg := '';
  Flist.clear;
  FBroker.Param[0].Value := ien + '^' + ForceDel; { if ForceDel = '^1', then force delete, don't test for MAG DELETE KEY }
  FBroker.Param[0].PType := literal;
  FBroker.Param[1].Value := magbooltostr(GrpDelOK);
  FBroker.Param[1].PType := literal;
  Fbroker.param[2].VAlue := reason;
  Fbroker.param[2].Ptype := literal;
  FBroker.remoteprocedure := 'MAGG IMAGE DELETE';
  try
    FBroker.lstCall(Flist);

    if ((Flist[0] = '') or (Flist.count = 0)) then
      begin
        rmsg := 'Attempt to Delete Image Entry Failed. Broker Error on Vista System';
        Flist.insert(0, '0^' + rmsg);
        exit;
      end;
    if (magpiece(Flist[0], '^', 1) = '0') then
      begin
        rmsg := 'Attempt to Delete Image Entry Failed.';
        Flist.insert(0, '0^' + rmsg);
        exit;
      end;
    rmsg := 'Image Entry deleted: ' + ien;
    Flist.insert(0, '1^VistA Image Entry deleted: ' + ien);
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
        rmsg := magpiece(e.message, #$A, 2);
        Flist.Insert(0, '0^' + magpiece(e.message, #$A, 2));
      end;
  end; // try

end;

procedure TMagDBDemo.RPMag3TIUImage(var Fstat: boolean; var Flist: tstringlist; MagIEN, TIUDA: string);
begin
showmessage('  RPMag3TIUImage needs activated for demo'); exit;
  Flist.clear;
  Fstat := false;
  FBroker.RemoteProcedure := 'MAG3 TIU IMAGE';
  FBroker.Param[0].Value := magien;
  FBroker.Param[0].PType := literal;
  FBroker.Param[1].Value := TIUDA;
  FBroker.Param[1].PType := literal;
  try
    FBroker.Call;

    Flist.assign(FBroker.Results);
    if ((magpiece(Flist[0], '^', 1) = '') or (magpiece(Flist[0], '^', 1) = '0'))
      then
      begin
        Flist.insert(0, '0^ERROR linking Image to TIU: ');
        exit;
      end;
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
        Flist.insert(0, '0^ERROR linking Image to TIU:');
        Flist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;

end;

procedure TMagDBDemo.RPMag4DataFromImportQueue(var Fstat: boolean; var Flist: tstringlist; QueueNum: string);
begin
// not needed for demo
exit;
  Flist.clear;
  FStat := false;
  Fbroker.Param[0].PType := literal;
  Fbroker.Param[0].Value := QueueNum;
  Fbroker.remoteprocedure := 'MAG4 DATA FROM IMPORT QUEUE';
  // GETARR^MAGGSIUI
  try
    Fbroker.lstcall(Flist);
    if (magpiece(Flist[0], '^', 1) = '0') then exit;
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Flist.insert(0, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;
end;

procedure TMagDBDemo.RPMag4RemoteImport(var Fstat: boolean; var Flist: tstringlist; DataArray: Tstringlist);
var I: integer;
begin
  Fstat := false;
  Fbroker.Param[0].PType := list;
  Fbroker.Param[0].Value := '.x';
  for I := 0 to DataArray.count - 1 do Fbroker.Param[0].Mult['' + inttostr(i) + ''] := DataArray[i];
  Fbroker.RemoteProcedure := 'MAG4 REMOTE IMPORT';
  try
    Fbroker.lstCall(Flist);
    if (magpiece(Flist[0], '^', 1) = '0') then exit;
    Fstat := true;

  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Flist.insert(0, '0^' + magpiece(e.message, #$A, 2));
        exit;
      end;
  end;

end;

procedure TMagDBDemo.RPMag4ValidateData(var Fstat: boolean;
  var Flist: tstringlist; t: tstringlist; rettype: string);
var I: integer;
begin
//not needed for demo
exit;
  Fstat := false;
  Fbroker.Param[0].PType := list;
  Fbroker.Param[0].Value := '.x';
  for I := 0 to t.count - 1 do Fbroker.Param[0].Mult['' + inttostr(i) + ''] := t[i];
  Fbroker.Param[1].Ptype := literal;
  Fbroker.Param[1].value := rettype;
  Fbroker.RemoteProcedure := 'MAG4 VALIDATE DATA';
  try
    Fbroker.lstCall(Flist);
    if (magpiece(Flist[0], '^', 1) = '0') then exit;
    Fstat := true;

  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Flist.insert(0, '0^' + magpiece(e.message, #$A, 2));
        exit;
      end;
  end;

end;

procedure TMagDBDemo.RPMag4StatusCallback(t: tstrings; cb: string; DoStatusCB: boolean = true);
var I: integer;
begin
//not needed for demo
exit;
  if (cb = '') then exit;
  FBroker.Param[0].PType := list;
  FBroker.Param[0].Value := '.X';
  //FLoglist.insert(0,xmsg);
  //FLogList.insert(1,FTrkNum);
  //FLogList.insert(2,Qnum);
  for I := 0 to t.count - 1 do FBroker.Param[0].Mult['' + inttostr(i) + ''] := t[i];
  FBroker.param[1].Ptype := literal;
  FBroker.param[1].Value := cb;
  FBroker.RemoteProcedure := 'MAG4 STATUS CALLBACK';
  //MAG4 STATUS CALLBACK          STATUSCB^MAGGSIUI
  //STATUSCB(MAGRY,STATARR,TAGRTN)
  //        D @(TAGRTN_"(.STATARR)")
  try
    FBroker.Call;
  except
    //
  end;
end;

procedure TMagDBDemo.RPMag4AddImage(var Fstat: boolean; var Flist: tstringlist; t: tstringlist);
var I: integer;
begin
// not needed for demo
exit;
  Flist.clear;
  Fstat := false;
  Fbroker.Param[0].PType := list;
  Fbroker.Param[0].Value := '.x';
  for I := 0 to t.count - 1 do Fbroker.Param[0].Mult['' + inttostr(i) + ''] := t[i];
  //Fbroker.Param[1].Ptype := literal;
  //Fbroker.Param[1].value := '1';
  Fbroker.RemoteProcedure := 'MAG4 ADD IMAGE';
  try
    Fbroker.lstCall(Flist);
    if (magpiece(Flist[0], '^', 1) = '0') then exit;
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
        Flist.Insert(0, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;
end;

procedure TMagDBDemo.RPMagABSJB(var Fstat: boolean; var Flist: tstringlist; CreatAbsIEN, JBCopyIEN: string);
begin
//not needed for demo
exit;
  FBroker.Param[0].Value := CreatAbsIEN + '^' + JBCopyIEN;
  FBroker.Param[0].PType := literal;
  FBroker.RemoteProcedure := 'MAG ABSJB';
  try
    FBroker.Call;
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
        Flist.add('0^' + magpiece(e.message, #$A, 2));
        FStat := false;
      end;
  end;
end;


function TMagDBDemo.GetBroker: TRPCBroker;
begin
//showmessage('  function GetBroker needs activated for demo'); exit;
  Result := FBroker;
end;

procedure TMagDBDemo.SetBroker(const Value: TRPCBroker);
begin
showmessage('  procedure SetBroker needs activated for demo'); exit;
  FBroker := Value;
end;

(*gek function TMagDBDemo.GetSilentCodes(Vserver, Vport: string; var SilentAccess: string; var SilentVerify: string): boolean;
var t: tstrings;
var I: INTEGER;
begin
// not needed for Demo
Result := true;
exit;
  result := false;
  if not fileexists('c:\winnt\system32\MySAVC.mag') then exit;
  t := Tstringlist.create;
  try
    t.LoadFromFile('c:\winnt\system32\MySAVC.mag');
    for I := 0 to t.count - 1 do
      begin
        if (pos(Vserver + ',' + Vport, t[i]) > 0) then
          begin
            silentaccess := magpiece(t[i], '^', 2);
            silentverify := magpiece(t[i], '^', 3);
            result := true;
          end;
      end;
  finally
    t.free;
  end;
end;
*)
procedure TMagDBDemo.RPMag4IAPIStats(var Fstat: boolean;
  var FList: tstrings; DtStart, DtEnd: string);
begin
//not needed for Demo
exit;
  Fstat := false;
  Fbroker.Param[0].PType := literal;
  Fbroker.Param[0].Value := DtStart;
  Fbroker.Param[1].PType := literal;
  Fbroker.Param[1].Value := DtEnd;
  //Fbroker.Param[2].Ptype := literal;
  //Fbroker.Param[2].value := rettype;
  Fbroker.RemoteProcedure := 'MAG4 IAPI STATS';
  try
    Fbroker.lstCall(Flist);
    if (magpiece(Flist[0], '^', 1) = '0') then exit;
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Flist.insert(0, '0^' + magpiece(e.message, #$A, 2));
        exit;
      end;
  end;

end;

(*procedure TMagDBDemo.RPMag4PostProcessing(var Fstat: boolean;
  var Flist: tstringlist; Magien: string);
begin
//not needed for demo
exit;
  Fstat := false;
  Fbroker.Param[0].PType := literal;
  Fbroker.Param[0].Value := Magien;
  Fbroker.RemoteProcedure := 'MAG4 POST PROCESSING';
  try
    Fbroker.lstCall(Flist);
    if (magpiece(Flist[0], '^', 1) = '0') then exit;
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Flist.insert(0, '0^' + magpiece(e.message, #$A, 2));
        exit;
      end;
  end;

end;   *)

procedure TMagDBDemo.RPMag3LookupAny(var Fstat: boolean; var fmsg: string; var Flist: tstringlist; InputString: string);
begin
showmessage(' ? ? is this called by demo');
exit;
  Fstat := false;
  Fbroker.Param[0].PType := literal;
  Fbroker.Param[0].Value := inputstring;
  Fbroker.RemoteProcedure := 'MAG3 LOOKUP ANY';
  try
    Fbroker.lstCall(Flist);
    if (magpiece(Flist[0], '^', 1) = '0') then
      begin
        fmsg := magpiece(flist[0], '^', 2);
        exit;
      end;
    Fstat := true;
  //  flist.delete(0);
  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Flist.insert(0, e.message);
        fmsg := e.message;
        exit;
      end;
  end;

end;

procedure TMagDBDemo.RPMag4PostProcessActions(var Fstat: boolean;
  var Flist: tstringlist; Magien: string);
begin
//not needed for demo
exit;
  Fstat := false;
  Fbroker.Param[0].PType := literal;
  Fbroker.Param[0].Value := Magien;
  Fbroker.RemoteProcedure := 'MAG4 POST PROCESS ACTIONS';
  try
    Fbroker.lstCall(Flist);
    if (magpiece(Flist[0], '^', 1) = '0') then exit;
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Flist.insert(0, e.message);
        exit;
      end;
  end;

end;

procedure TMagDBDemo.RPMagPatInfo(var Fstat: boolean; var Fstring: string; MagDFN: string; isicn: boolean = false);
var info: string;
begin
//showmessage(' RPMagPatInfo   '+magdfn+'   needs activated for demo'); exit;
{info =  '1^959^SAHO,F^MALE^00/00/20^821283241^^NON-VETERAN (OTHER)^^0^'}
fstat := true;
fstring := magpiece(Fpatientlist[strtoint(magdfn)-1],'|',2);
exit;


//demo
  Fstat := false;
  Fbroker.Param[0].PType := literal;
  Fbroker.Param[0].Value := MagDFN;
  Fbroker.RemoteProcedure := 'MAGG PAT INFO';
  try
    info := Fbroker.strCall;
    if (magpiece(info, '^', 1) = '0') then exit;
    Fstring := info;
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Fstring := '0^' + magpiece(e.message, #$A, 2);
        exit;
      end;
  end;

end;

(*procedure TMagDBDemo.RPMagIndexType(var Fstat: boolean; var Flist: tstringlist; MagDFN: string);
begin
showmessage(' RPMagIndexType   needs activated for demo'); exit;
  Fstat := false;
  Fbroker.Param[0].PType := literal;
  Fbroker.Param[0].Value := MagDFN;
  Fbroker.RemoteProcedure := 'MAG4 INDEX GET TYPE';
  try
    Fbroker.lstCall(Flist);
    if (magpiece(Flist[0], '^', 1) = '0') then exit;
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Flist.insert(0, '0^' + magpiece(e.message, #$A, 2));
        exit;
      end;
  end;

end;
  *)
procedure TMagDBDemo.RPIndexGetSpecSubSpec(lit: TStrings; cls: string = ''; proc: string = ''; ignoreStatus: boolean = false);
var t: tstrings;
  ign: string;
begin
lit.loadfromFile(ExtractFilepath(application.exename)+ '\image\MagDemoIndexSpec.txt');
lit.Delete(0);
 exit;
 //demo
  if ignorestatus then ign := '1'
  else ign := '';
  lit.clear;
  t := tstringlist.create;
  // We changed the value of the Constants magiclAdmin, and magiclClin
  // so this isn't needed. (we'll see)
  //if cls = magiclAdmin then cls :="ADMIN,ADMIN/CLIN";
  //if cls = magiclClin then cls :="CLIN,CLIN/ADMIN";
  FBroker.remoteprocedure := 'MAG4 INDEX GET SPECIALTY';
  FBroker.Param[0].PType := literal;
  FBroker.Param[0].Value := cls;
  FBroker.Param[1].PType := literal;
  FBroker.Param[1].Value := proc;
  FBroker.Param[2].PType := literal;
  FBroker.Param[2].Value := ign;

  try
    FBroker.lstcall(t);
    if (t.count = 0) then
      begin
        lit.add('<Error loading ''Specialty'' list>');
      //oot 6/18/02 maggmsgf.magmsg('', 'Error loading Index Specialty', nullpanel);
        exit;
      end;

  except
    on e: exception do
      begin
        lit.add('<Exception loading ''Specialty'' list>');
      //oot 6/18/02      maggmsgf.magmsg('', 'Exception loading Index Specialty', nullpanel);
        exit;
      end;
  end;
  t.delete(0);
  lit.AddStrings(t);
  t.free;
end;

procedure TMagDBDemo.RPIndexGetEvent(lit: TStrings; cls: string = ''; spec: string = ''; ignoreStatus: boolean = false);
var t: tstrings;
  ign: string;
begin
lit.loadfromFile(ExtractFilepath(application.exename)+ '\image\MagDemoIndexEvent.txt');
lit.Delete(0);
 exit;
 //demo
  if ignorestatus then ign := '1'
  else ign := '';
  lit.clear;
  t := tstringlist.create;
  // We changed the value of the Constants magiclAdmin, and magiclClin
  // so this isn't needed. (we'll see)
  //if cls = magiclAdmin then cls :="ADMIN,ADMIN/CLIN";
  //if cls = magiclClin then cls :="CLIN,CLIN/ADMIN";

  FBroker.remoteprocedure := 'MAG4 INDEX GET EVENT';

  FBroker.Param[0].PType := literal;
  FBroker.Param[0].Value := cls;
  FBroker.Param[1].PType := literal;
  FBroker.Param[1].Value := spec;
  FBroker.Param[2].PType := literal;
  FBroker.Param[2].Value := ign;

  try
    FBroker.lstcall(t);
    if (t.count = 0) then
      begin
        lit.add('<Error loading ''Events'' list>');
      //oot 6/18/02    maggmsgf.magmsg('', 'Error loading Index Events', nullpanel);
        exit;
      end;

  except
    on e: exception do
      begin
        lit.add('<Exception loading ''Events'' list>');
      //oot 6/18/02 maggmsgf.magmsg('', 'Exception loading Index Events', nullpanel);
        exit;
      end;
  end;
  t.delete(0);
  lit.AddStrings(t);
  t.free;
end;

procedure TMagDBDemo.RPIndexGetType(lit: TStrings; cls: string; ignoreStatus: boolean = false);
var t: tstrings;
  xmsg: string;
  ign: string;
begin
lit.loadfromFile(ExtractFilepath(application.exename)+ '\image\MagDemoIndexType'+magpiece(cls,',',1)+'.txt');
lit.Delete(0);
 exit;
 //demo
  if ignorestatus then ign := '1'
  else ign := '';
  if not CheckDBConnection(xmsg) then raise Exception.Create(xmsg);
  lit.clear;
  t := tstringlist.create;
  // We changed the value of the Constants magiclAdmin, and magiclClin
  // so this isn't needed. (we'll see)
  //if cls = magiclAdmin then cls :="ADMIN,ADMIN/CLIN";
  //if cls = magiclClin then cls :="CLIN,CLIN/ADMIN";
  FBroker.remoteprocedure := 'MAG4 INDEX GET TYPE';
  FBroker.Param[0].PType := literal;
  FBroker.Param[0].Value := Uppercase(cls);
  FBroker.Param[1].PType := literal;
  FBroker.Param[1].Value := ign;

  try
    FBroker.lstcall(t);
    if (t.count = 0) then
      begin
        lit.add('<Error loading ''Type'' list>');
      //oot 6/18/02       maggmsgf.magmsg('', 'Error loading Index Types', nullpanel);
        exit;
      end;

  except
    on e: exception do
      begin
        lit.add('<Exception loading ''Type'' list>');
      //oot 6/18/02       maggmsgf.magmsg('', 'Exception loading Index Types', nullpanel);
        exit;
      end;
  end;
  t.delete(0);
  lit.AddStrings(t);
  t.free;
end;

procedure TMagDBDemo.RPLogCopyAccess(s: string);
var ret: string;
begin
//not needed for demo
exit;
  FBroker.param[0].ptype := literal;
  FBroker.param[0].value := s;
  FBroker.remoteprocedure := 'MAGGACTION LOG';
  ret := FBroker.STRCALL;
  { TODO : This and other functions have to be able to log messages. }
   // if copy(ret, 1, 1) <> '1' then MaggMsgf.magmsg('', 'Error logging action ' + magpiece(st, '^', 2), nilpanel);

end;
// 01/21/03   msg => changed to xmsg  (msg is a function)

function TMagDBDemo.RPVerifyEsig(esig: string; var xmsg: string): boolean;
var s: string;
begin
//demo.
result := true;
xmsg := 'Demo - any signature is okay';
exit;

  esig := encrypt(esig);
  FBroker.param[0].ptype := literal;
  FBroker.param[0].value := esig;
  FBroker.remoteprocedure := 'MAGG VERIFY ESIG';
  s := FBroker.strcall;
  xmsg := magpiece(s, '^', 2);
  result := (copy(s, 1, 1) <> '0');
end;

procedure TMagDBDemo.RPMagGetUserPreferences(var Fstat: boolean;
  var rpcmsg: string; xlist: Tstringlist; code: string = '');
begin
//showmessage(' RPMagGetUserPreferences   needs activated for demo');
fstat := true;
xlist.LoadFromFile(extractfilepath(application.exename)+'\image\MagDemoPref'+code+'.txt');
xlist.Delete(0);
exit;
//demo
  Fstat := true;
  FBroker.remoteprocedure := 'MAGGUPREFGET';
  //WinMsg('', 'Applying View preferences...');
  if code <> '' then
    begin
      FBroker.Param[0].PType := literal;
      FBroker.Param[0].Value := code;
    end;
  try
    FBroker.lstcall(xlist);
    if xlist.count < 2 then
      begin
        fstat := false;
        rpcmsg := 'Can''t Access User Preferences. Using defaults.';
      //WinMsg('', 'Can''t Access View Preferences, using System defaults.');
      //messagebeep(0);
        exit;
      end;
    xlist.DELETE(0);
  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        rpcmsg := e.message;
        Fstat := false;
      end;
  end;
end;

procedure TMagDBDemo.RPMagSetUserPreferences(var Fstat: boolean; var rpcmsg: string; xlist : Tstrings);
var i : integer;
fld : string;
data: string;
begin
fstat := true;
rpcmsg := 'Not saved for Demo';
exit;
//demo
  Fstat := true;
  if not FBroker.CONNECTED then
    begin

      rpcmsg := 'Save User preferences canceled.  No connection to VistA.';
      messagebeep(0);
      exit;
    end;
  //LOGACTIONS('MAIN', 'SAVESETTINGS', DUZ);
  for I := 0 to xlist.Count-1 do
    begin
    fld := magpiece(xlist[i],'|',1);
    data := magpiece(xlist[i],'|',2);
    Fbroker.Param[0].Mult['' +fld+ ''] := data;
    end;
  FBroker.remoteprocedure := 'MAGGUPREFSAVE';
  FBroker.Param[0].Value := '.X';
  FBroker.Param[0].PType := list;

  try
    FBroker.call;
    if FBroker.Results[0] = '' then
      begin
        Fstat := false;
        rpcmsg := 'The Attempt to save User Preferences Failed. Check VistA Error Log.';

        exit;
      end;
    rpcmsg := magpiece(Fbroker.Results[0], '^', 2);
  except
    on E: EBrokerError do showmessage('Error Communicating with VistA : ' + e.message);
    on E: Exception do showmessage('An Error occured while connecting to VistA' + #13 + 'Setting were not saved.' + #13 + E.Message);

  else
    showmessage('UnKnown Error while Saving Settings.');
  end;

end;

procedure TMagDBDemo.RPMag4GetImageInfo(magien: string;
  var Flist: Tstrings);
begin
//showmessage(' RPMag4GetImageInfo   needs activated for demo');
exit;
//demo
  FBroker.remoteprocedure := 'MAG4 GET IMAGE INFO';
  FBroker.param[0].ptype := literal;
  FBroker.param[0].value := magien;
  try
    FBroker.lstcall(flist);
    if Flist.count = 0 then
      begin
        Flist.Add('Error: Accessing Image Information');
        Flist.add('    for Image ID# ' + magien);
        exit;
      end;
  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Flist.Insert(0, e.message);
      end;
  end;
end;

procedure TMagDBDemo.RPImageReport(var Fstat: boolean; var Fmsg: string; Flist: tstrings; IObj: TImageData; noQACheck : boolean = false);
var rptfile : string;
begin
//showmessage(' RPMagGetImageReport   needs activated for demo');
rptFile := magpiece(Iobj.FFile,'.',1)+'.rpt';
if FileExists(rptFile) then
  begin
  Flist.LoadFromFile(rptfile);
  fstat := true;
  fmsg := Iobj.ImgDes;
  end
  else
  begin
  fstat := false;
  fmsg := 'Demo Image, report not available';
  Flist.add('0^Demo Image, report not available');
  end;

exit;
//demo


  Flist.clear;
  Fstat := false;
  FBroker.Param[0].Value := IObj.Mag0 + '^';
  FBroker.Param[0].PType := literal;
  FBroker.remoteprocedure := 'MAGGRPT';
  //maggmsgf.magmsg('', 'Building Image Report...', nilpanel);
  //FBroker.lstcall(t);

  //FBroker.RemoteProcedure := 'MAG3 TIU IMAGE';
  //FBroker.Param[0].Value := magien;
  //FBroker.Param[0].PType := literal;
  //FBroker.Param[1].Value := TIUDA;
  //FBroker.Param[1].PType := literal;
  try
    FBroker.Call;
    if FBroker.Results.count = 0 then
      begin
        fmsg := 'Report Failed for Image ID #: ' + IObj.Mag0;
        Flist.insert(0, '0^ERROR Building Image Report: ');
        Flist.add(' Report Failed for Image ID #: ' + IObj.Mag0);
        Flist.Add('Check VISTA Error Log.');
      //maggmsgf.magmsg('DE', ': The Attempt to build the Image report Failed. Check VISTA Error Log.', nilpanel);
      //maggmsgf.magmsg('s', ' Report Failed for Image IEN: '+ien,nilpanel);
      //maggmsgf.magmsg('', '', nilpanel);
        exit;
      end;

    Flist.assign(FBroker.Results);
    if (magpiece(Flist[0], '^', 1) = '')
      then
      begin
        fmsg := 'Report Failed for Image ID #: ' + IObj.Mag0;
        Flist.insert(0, '0^ERROR Building Image Report: ');
        exit;
      end;
    if (magpiece(Flist[0], '^', 1) = '0')
      then
      begin
        fmsg := magpiece(Flist[0], '^', 2);
        exit;
      end;
    fmsg := magpiece(Flist[0], '^', 2);
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
        Flist.insert(0, '0^EXCEPTION Building Image Report:');
        Flist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;

end;


(*procedure TMagDBDemo.RPMagGetImageReport(var Fstat: boolean; var Fmsg: string; Flist: tstrings; magien: string);
begin
//showmessage(' RPMagGetImageReport   needs activated for demo');
fstat := false;
fmsg := 'Demo Image, report not available "GetImageReport"';
Flist.add('0^Demo Image, report not available "GetImageReport"');
exit;
//demo


  Flist.clear;
  Fstat := false;
  FBroker.Param[0].Value := magien + '^';
  FBroker.Param[0].PType := literal;
  FBroker.remoteprocedure := 'MAGGRPT';
  //maggmsgf.magmsg('', 'Building Image Report...', nilpanel);
  //FBroker.lstcall(t);

  //FBroker.RemoteProcedure := 'MAG3 TIU IMAGE';
  //FBroker.Param[0].Value := magien;
  //FBroker.Param[0].PType := literal;
  //FBroker.Param[1].Value := TIUDA;
  //FBroker.Param[1].PType := literal;
  try
    FBroker.Call;
    if FBroker.Results.count = 0 then
      begin
        fmsg := 'Report Failed for Image ID #: ' + magien;
        Flist.insert(0, '0^ERROR Building Image Report: ');
        Flist.add(' Report Failed for Image ID #: ' + magien);
        Flist.Add('Check VISTA Error Log.');
      //maggmsgf.magmsg('DE', ': The Attempt to build the Image report Failed. Check VISTA Error Log.', nilpanel);
      //maggmsgf.magmsg('s', ' Report Failed for Image IEN: '+ien,nilpanel);
      //maggmsgf.magmsg('', '', nilpanel);
        exit;
      end;

    Flist.assign(FBroker.Results);
    if (magpiece(Flist[0], '^', 1) = '')
      then
      begin
        fmsg := 'Report Failed for Image ID #: ' + magien;
        Flist.insert(0, '0^ERROR Building Image Report: ');
        exit;
      end;
    if (magpiece(Flist[0], '^', 1) = '0')
      then
      begin
        fmsg := magpiece(Flist[0], '^', 2);
        exit;
      end;
    fmsg := magpiece(Flist[0], '^', 2);
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
        Flist.insert(0, '0^EXCEPTION Building Image Report:');
        Flist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;

end;  *)

function TMagDBDemo.CheckDBConnection(var xmsg: string): boolean;
begin
  result := true;
  if not assigned(FBroker)
    then
    begin
      xmsg := 'You must Login to VistA to procede.';
   // xmsg := 'DataBase Component isn''t assigned to a DataBase.'+#13+
   //            'An error in software has occured. Call IRM.';
      result := false;
    end;
  if (assigned(FBroker)) and (not FBroker.Connected)
    then
    begin
      xmsg := 'You must Login to VistA to procede.';
      result := false;
    end;
  if not result
    then
    messagedlg(xmsg, mtWarning, [mbok], 0);

end;

function TMagDBDemo.RPMag4GetFileFormatInfo(ext: string; var xmsg: string): boolean;
var t: tstrings;
begin
  t := tstringlist.create;
  FBroker.remoteprocedure := 'MAG4 GET FILE FORMAT INFO';
  FBroker.Param[0].PType := literal;
  FBroker.Param[0].Value := ext;


  try
    FBroker.lstcall(t);
    if (t.count = 0) then
      begin
        result := false;
        xmsg := 'Error Getting File Type info for ' + ext;
        exit;
      end;
    xmsg := t[1];
    result := true;
  except
    on e: exception do
      begin
        result := false;
        xmsg := 'Exception Getting File Type info for ' + ext;
      end;
  end;

end;
 ///////////// started converting remainder of calls in frmMain
 ////////////  that called xBrokerx, to call MagDBBroker.

procedure TMagDBDemo.RPMaggImageInfo(var rstat: boolean; var rmsg: string; var rlist: tstrings; ien: string; noQAcheck : boolean = false);
begin
  rstat := false;
  with FBroker do
    begin
      param[0].Value := ien;
      param[0].PType := literal;
      remoteprocedure := 'MAGG IMAGE INFO';
    end;
  try
    Fbroker.lstCall(rlist);
    if (magpiece(rlist[0], '^', 1) = '0') or (rlist.count = 0) then
      begin
        rstat := false;
        if rlist.count > 0 then rmsg := magpiece(rlist[0], '^', 2)
        else rmsg := 'ERROR in VistA operation canceled.';
        exit;
      end;
    rstat := true;
    rmsg := rlist[0];
    rlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        rlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        rlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;

end;

procedure TMagDBDemo.RPMaggRadExams(var rstat: boolean; var rmsg: string; var rlist: tstrings; DFN: string);
begin
{ TODO : Get a list of Rad Exams for one of the demo patients. }
//showmessage(' RPMaggRadExams   needs activated for demo');
rlist.add('0^No Radiology Exams for demo.');
rstat := false;
rmsg := ' RPMaggRadExams   needs activated for demo';
exit;
//demo
  rstat := false;
  with FBroker do
    begin
      param[0].Value := DFN + '^1';
      param[0].PType := literal;
      remoteprocedure := 'MAGGRADLIST';
    end;
  try
    Fbroker.lstCall(rlist);
    if (magpiece(rlist[0], '^', 1) = '0') or (rlist.count = 0) then
      begin
        if rlist.count > 0 then rmsg := magpiece(rlist[0], '^', 2)
        else rmsg := 'ERROR Compiling Rad Exam list.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(rlist[0], '^', 2);
   // rlist.delete(0);
    if strtoint(magpiece(rlist[0], '^', 1)) > 0 then rmsg := magpiece(rlist[0], '^', 1) + ' ' + rmsg;


  except
    on E: EXCEPTION do
      begin
        rlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        rlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;
end;


//RPMaggCPRSRadExam(rstat,rmsg,rlist,cprsstring);

procedure TMagDBDemo.RPMaggCPRSRadExam(var rstat: boolean; var rmsg: string; var rlist: tstrings; cprsstring: string);
begin
  rstat := false;
  with FBroker do
    begin
      param[0].Value := cprsstring;
      param[0].PType := literal;
      remoteprocedure := 'MAGG CPRS RAD EXAM';
    end;
  try
    Fbroker.lstCall(rlist);
    if (magpiece(rlist[0], '^', 1) = '0') or (rlist.count = 0) then
      begin
        rstat := false;
        if rlist.count > 0 then rmsg := magpiece(rlist[0], '^', 2)
        else rmsg := 'ERROR in VistA operation canceled.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(rlist[0], '^', 2);
    //rlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        rlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        rlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;

end;


//RPMaggUser2(rstat,rmsg,rlist,WSID);

procedure TMagDBDemo.RPMaggUser2(var rstat: boolean; var rmsg: string; var rlist: tstrings; wsid: string);
begin
rstat :=true;
rlist.LoadFromFile(ExtractFilepath(application.exename)+ '\image\MagDemoUser2.txt');
exit;
//demo;
  rstat := false;
  with FBroker do
    begin
      param[0].Value := wsid;
      param[0].PType := literal;
      remoteprocedure := 'MAGGUSER2';
    end;
  try
    Fbroker.lstCall(rlist);
    if (magpiece(rlist[0], '^', 1) = '0') or (rlist.count = 0) then
      begin
        rstat := false;
        if rlist.count > 0 then rmsg := magpiece(rlist[0], '^', 2)
        else rmsg := 'ERROR in VistA operation canceled.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(rlist[0], '^', 2);
    ////////rlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        rlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        rlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;

end;

    (*
    xBrokerx.param[0].ptype := literal;
    xBrokerx.param[0].value := WSID;
    //RPMaggUser2(var Fstat: boolean; var Flist: tstringlist; CompName: string; var vServer: string; tPort: string);

    xBrokerx.remoteprocedure := 'MAGGUSER2';
    xBrokerx.call;
    *)


procedure TMagDBDemo.RPMaggDGRPD(var rstat: boolean; var rmsg: string; var rlist: tstringlist; dfn: string);
begin
rmsg := ' RPMaggDGRPD  is activated for demo';

rstat := true;
rlist.loadfromfile(ExtractFilePath(application.exename)+'\image\MagDemoPatientProfile'+DFN+'.TXT');
rlist.delete(0);
exit;
//demo
  rstat := false;
  with FBroker do
    begin
      param[0].Value := dfn;
      param[0].PType := literal;
      remoteprocedure := 'MAGGDGRPD';
    end;
  try
    Fbroker.lstCall(rlist);
    if (magpiece(rlist[0], '^', 1) = '0') or (rlist.count = 0) then
      begin
        rstat := false;
        if rlist.count > 0 then rmsg := magpiece(rlist[0], '^', 2)
        else rmsg := 'ERROR in VistA operation canceled.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(rlist[0], '^', 2);
    rlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        rlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        rlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;

end;




//RPMaggRadImage(rstat,rmsg,t,radstring);

procedure TMagDBDemo.RPMaggRadImage(var rstat: boolean; var rmsg: string; var tlist: tstringlist; radstring: string);
begin
  rstat := false;
  with FBroker do
    begin
      param[0].Value := radstring;
      param[0].PType := literal;
      remoteprocedure := 'MAGGRADIMAGE';
    end;
  try
    Fbroker.lstCall(tlist);
    if (magpiece(tlist[0], '^', 1) = '0') or (tlist.count = 0) or
      (magpiece(tlist[0], '^', 1) = '-2') then
      begin
        rstat := false;
        if tlist.count > 0 then rmsg := magpiece(tlist[0], '^', 2)
        else rmsg := 'ERROR in VistA operation canceled.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(tlist[0], '^', 2);
   // tlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        tlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        tlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;




(*
    xBrokerx.param[0].value := radstring;
    xBrokerx.param[0].ptype := literal;
    xBrokerx.rem oteprocedure := 'MAGGRADIMAGE';
    xBrokerx.LSTCALL(t);
    if t.count = 0 then
    begin
      WinMsg('DE', ': The Attempt to access the Image list for selected exam Failed.' +
        '  Check VistA Error Log.');
      WinMsg('s', 'Rad Report info: ' + sysradstring);
      exit;
    end;
    if magpiece(t[0], '^', 1) = '0' then
    begin
      WinMsg('DE', magpiece(t[0], '^', 2));
      WinMsg('s', 'Rad Report info: ' + sysradstring);
      exit;
    end;
    if magpiece(t[0], '^', 1) = '-2' then //Patch 5
    begin
      WinMsg('DEQA', magpiece(t[0], '^', 2));
      WinMsg('s', 'Rad Report info: ' + sysradstring);
      exit;
    end;
*)

end;
//dmod.MagDBBroker1.RPMaggRadReport(rstat,rmsg,t,RARPT);

procedure TMagDBDemo.RPMaggRadReport(var rstat: boolean; var rmsg: string; var tlist: tstringlist; rarpt: string);
begin
  rstat := false;
  with FBroker do
    begin
      param[0].Value := rarpt;
      param[0].PType := literal;
      remoteprocedure := 'MAGGRADREPORT';
    end;
  try
    Fbroker.lstCall(tlist);
    if (magpiece(tlist[0], '^', 1) = '0') or (tlist.count = 0) or
      (magpiece(tlist[0], '^', 1) = '-2') then
      begin
        rstat := false;
        if tlist.count > 0 then rmsg := magpiece(tlist[0], '^', 2)
        else rmsg := 'ERROR in VistA operation canceled.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(tlist[0], '^', 2);
   // tlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        tlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        tlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;





(*    xBrokerx.Param[0].Value := RARPT;
    xBrokerx.Param[0].PType := literal;
    xBrokerx.remoteprocedure := 'MAGGRADREPORT';
    WinMsg('', 'Building Radiology Exam Report...');
    xBrokerx.lstcall(t);
    if t.count = 0 then
    begin
      WinMsg('DE', ': The Attempt to build Radiology Exam report Failed. Check VistA Error Log.');
      Winmsg('s', 'Failed RARPT : ' + RARPT);
      WinMsg('', '');
      exit;
    end;
    if (magpiece(t[0], '^', 1) = '-2') then //Patch 5
    begin
      WinMsg('DEQA', magpiece(t[0], '^', 2) + '   ' + daycase);
      Winmsg('s', 'Failed RARPT : ' + RARPT);
      exit;
    end;
    if (magpiece(t[0], '^', 1) = '0') then
    begin
      WinMsg('DE', magpiece(t[0], '^', 2) + '   ' + daycase);
      Winmsg('s', 'Failed RARPT : ' + RARPT);
      exit;
    end
    else
  *)


end;

procedure TMagDBDemo.RPMaggHSList(var rstat: boolean; var rmsg: string; var tlist: tstringlist; value: string);
begin
rmsg := ' RPMaggHSList  activated for demo';

rstat := true;
tlist.loadfromfile(ExtractFilePath(application.exename)+'\image\MagDemoHSList.TXT');
tlist.delete(0);
exit;
//demo
  rstat := false;
  with FBroker do
    begin
      param[0].Value := value;
      param[0].PType := literal;
      remoteprocedure := 'MAGGHSLIST';
    end;
  try
    Fbroker.lstCall(tlist);
    if (magpiece(tlist[0], '^', 1) = '0') or (tlist.count = 0) then
      begin
        rstat := false;
        if tlist.count > 0 then rmsg := magpiece(tlist[0], '^', 2)
        else rmsg := 'ERROR in VistA operation canceled.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(tlist[0], '^', 2);
    tlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        tlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        tlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;
  (*
  xBrokerx.param[0].value := 'hs';
  xBrokerx.param[0].ptype := literal;
  xBrokerx.remoteprocedure := 'MAGGHSLIST';
  xBrokerx.call;
  st := magpiece(xBrokerx.results[0], '^', 1);
  if (st = '0') then
  begin MaggMsgf.magmsg('', magpiece(xBrokerx.results[0], '^', 2), msg);
    exit;
  end;
  xBrokerx.results.delete(0);
  *)
end;


procedure TMagDBDemo.RPMaggHS(var rstat: boolean; var rmsg: string; var tlist: tstringlist; value: string);
begin
rstat := true;
rmsg := 'Demo HealthSummary Report';
tlist.LoadFromFile(ExtractFilePath(application.exename)+'image\MagDemoHSReport-'+magpiece(value,'^',2)+'.TXT');
tlist.delete(0);
//FPatientlist.LoadFromFile(ExtractFilePath(application.exename)+'image\MagDemoHSReport-'+magpiece(value,'^',2)+'.TXT');
exit;
//demo
  rstat := false;
  with FBroker do
    begin
      param[0].Value := value;
      param[0].PType := literal;
      remoteprocedure := 'MAGGHS';
    end;
  try
    Fbroker.lstCall(tlist);
    if (magpiece(tlist[0], '^', 1) = '0') or (tlist.count = 0) then
      begin
        rstat := false;
        if tlist.count > 0 then rmsg := magpiece(tlist[0], '^', 2)
        else rmsg := 'ERROR: Health Summary Failed. Check VISTA Error Log.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(tlist[0], '^', 2);
    tlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        tlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        tlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;
(*
  try
    xBrokerx.PARAM[0].VALUE := PATDFN.CAPTION + '^' + XST;
    xBrokerx.PARAM[0].PTYPE := LITERAL;
    xBrokerx.remoteprocedure := 'MAGGHS';
    xBrokerx.lstcall(t);
    if t.count = 0 then
    begin
      Maggmsgf.MagMsg('de', 'Failed to build Patient Health Summary. Check VISTA Error Log.', msg);
      MaggMsgf.magmsg('e', 'ERROR: Health Summary Failed. Check VISTA Error Log.', msg);
      exit;
    end;
    if magpiece(t[0], '^', 1) = '0' then Maggmsgf.MagMsg('', magpiece(t[0], '^', 2), msg);
    if magpiece(t[0], '^', 1) <> '0' then begin
      t.delete(0);
*)
end;

(*
procedure TMagDBDemo.RPMag...(var rstat: boolean; var rmsg: string; var rlist: tstrings; xxx : string);
var yyy : string;
begin
 rstat := false;
  with FBroker do
  begin
    Param[0].PType := list;
    Param[0].Value := '.x';

    param[0].Value := ;
    param[0].PType := ;
    param[1].value := ;
    param[1].ptype := ;

    remoteprocedure := 'MAG......';
  end;
  try
    Fbroker.lstCall(rlist);
    if (magpiece(rlist[0], '^', 1) = '0') or (rlist.count = 0) then
    begin
      rstat := false;
      if rlist.count > 0 then rmsg := magpiece(rlist[0], '^', 2)
                         else rmsg := 'ERROR in VistA operation canceled.';
      exit;
    end;
    rstat := true;
    rmsg := magpiece(rlist[0], '^', 2);
    rlist.delete(0);
  except
    on E: EXCEPTION do
    begin
      rlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
      rstat := false;
      rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
      rlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
    end;
  end;

end;
*)

procedure TMagDBDemo.RPGetFileExtensions(var t: tstrings);
begin
  FBroker.remoteprocedure := 'MAG4 GET SUPPORTED EXTENSIONS';
  try
    FBroker.lstcall(t);
  except
    on E: exception do
      begin
        t.insert(0, '0^Error: Getting supported Extensions.');
        maggmsgf.magmsg('de', 'VistA Error: ' + magpiece(e.message, #$A, 2));
      end;
  end;
end;

procedure TMagDBDemo.RPUpdateConsult(consult, tiuien, cmpflag: string; var status: string);
begin
  FBroker.remoteprocedure := 'MAG4 CP UPDATE CONSULT';
  FBroker.Param[0].ptype := literal;
  FBroker.Param[0].value := consult;

  FBroker.Param[1].ptype := literal;
  FBroker.Param[1].value := tiuien;
  FBroker.Param[2].ptype := literal;
  FBroker.Param[2].value := cmpflag;
  try
    status := FBroker.strcall;
  except
    on E: EXCEPTION do
      begin
        status := '0^VistA Error';
        maggmsgf.magmsg('de', 'VistA Error: ' + magpiece(e.message, #$A, 2));
      end;
  end;
end;

function TMagDBDemo.RPTIUCPClass: integer;
var s: string;
begin
result := 4;
showmessage(' RPTIUCPClass   needs activated for demo');
exit;
//demo
  FBroker.remoteprocedure := 'TIU IDENTIFY CLINPROC CLASS';
  try
    s := FBroker.strcall;
    result := strtoint(s);
  except
    on E: EXCEPTION do
      begin
        messagedlg('VistA Error: ' + magpiece(e.message, #$A, 2), mtconfirmation,
          [mbok], 0);
        result := 0;
      end;
  end;
end;

function TMagDBDemo.RPTIUConsultsClass: integer;
var s: string;
begin
result := 5;
showmessage(' RPTIUConsultsClass   needs activated for demo');
exit;
//demo

  FBroker.remoteprocedure := 'TIU IDENTIFY CONSULTS CLASS';
  try
    s := FBroker.strcall;
    result := strtoint(s);
  except
    on E: EXCEPTION do
      begin
        messagedlg('VistA Error: ' + magpiece(e.message, #$A, 2), mtconfirmation,
          [mbok], 0);
        result := 0;
      end;
  end;
end;

procedure TMagDBDemo.RPMagLogErrorText(T: Tstrings; COUNT: INTEGER);
var I, j: integer;

begin
  I := t.count;
  if (i < count) then count := i;
  FBroker.remoteprocedure := 'MAGG LOG ERROR TEXT';
  FBroker.Param[0].Value := '.X';
  FBroker.Param[0].PType := list;

  for j := 1 to count do
    begin
      dec(i);
    //xBrokerx.Param[3].Mult['"TEXT'+','+INTTOSTR(I+1)+',0"']:=NOTETEXT[I];
      FBroker.Param[0].Mult[('"TEXT' + COPY('000', 1, 3 - LENGTH(INTTOSTR(I))) + IntToStr(i) + '"')] := t[i];
    end;

  FBroker.call;

end;

procedure TMagDBDemo.RPMagGetNetLoc(var success: boolean; var RPmsg: string; var Shares: TStringList; NetLocType: string);
begin
success := true;
rpmsg := 'Demo DataBase';
exit;
//demo
  (* Get all network locations and their properties *)
  success := false;
  try
    FBroker.PARAM[0].VALUE := NetLocType;
    FBroker.PARAM[0].PTYPE := LITERAL;
    FBroker.Remoteprocedure := 'MAG GET NETLOC';
    FBroker.lstCall(Shares);
    if (magpiece(Shares[0], '^', 1) = '0') then
      begin
        maggmsgf.MagMsg('', magpiece(Shares[0], '^', 2));
        RPmsg := Shares[0];
        exit;
      end;
    if (Shares.count = 0) then
      begin
        maggmsgf.MagMsg('', 'Error accessing Network Locations');
        RPmsg := 'Error accessing Network Locations ';
        exit;
      end;
    success := true;
    RPmsg := Shares[0];
    Shares.delete(0);

  except
    on E: EXCEPTION do
      begin
        showmessage(e.message);
        Shares[0] := 'The Attempt to get network locations. Check VistA Error Log.';
      end;
  end;

end;

function TMagDBDemo.RPMagEkgOnline: integer;
begin
result := 0;
exit;
//demo
  (* get the status of the first EKG server 0=offline 1=online - if no server exists 0 is returned *)
  FBroker.remoteprocedure := 'MAG EKG ONLINE';
  result := StrToInt(FBroker.strcall);

end;

procedure TMagDBDemo.RPMaggOffLineImageAccessed(IObj: TImageData);
begin
  with FBroker do
    begin
      if not CONNECTED then EXIT;
      REMOTEPROCEDURE := 'MAGG OFFLINE IMAGE ACCESSED';
      PARAM[0].PTYPE := LITERAL;
      PARAM[0].VALUE := IObj.Ffile;
      PARAM[1].PTYPE := LITERAL;
      PARAM[1].VALUE := IObj.mag0;
      CALL;
    end;
end;

(*
procedure ___________(magrecord : MagRecordPtr) ;
begin
with xBrokerx do
     begin
     If NOT CONNECTED THEN EXIT;
     REMOTEPROCEDURE :=       ;
     PARAM[0].PTYPE :=   ----;
     PARAM[0].VALUE := -------;
     PARAM[1].PTYPE := -------;
     PARAM[1].VALUE := -----------  ;
     CALL;
     end;
END ;
*)

procedure TMagDBDemo.RPMag3Logaction(actionstring: string);
begin
//not needed for demo
exit;
  with FBroker do
    begin
      Param[0].VALUE := actionstring;
      param[0].ptype := literal;
      remoteprocedure := 'MAG3 LOGACTION';
      Call;
    end;
end;

procedure TMagDBDemo.RPMaggQueImage(IObj: TImageData);
begin
//not needed for demo
exit;

  with FBroker do
    begin
      Param[0].Value := 'AF';
      Param[0].PType := literal;
      Param[1].Value := IObj.mag0;
      Param[1].PType := literal;
      remoteprocedure := 'MAGG QUE IMAGE';
      maggmsgf.magmsg('s', '--RPC : MAGG QUE IMAGE ^AF^' + IObj.mag0);
      try
        call;
        maggmsgf.MagMsg('S', '--' + FBroker.RESULTS[0]);
      except
        messagedlg('Error attempting to set the Queue ' + #13 + 'to copy an Image from the Juke Box.'
          + #13 + 'Not Fatal, Process will continue.', mtwarning, [mbok], 0);
      end;
    end;
end;

procedure TMagDBDemo.RPMaggQueBigImage(IObj: TImageData);
begin
//not needed for demo
exit;
  with FBroker do
    begin
      Param[0].Value := 'B';
      Param[0].PType := literal;
      Param[1].Value := IObj.mag0;
      Param[1].PType := literal;
      remoteprocedure := 'MAGG QUE IMAGE';
      maggmsgf.magmsg('s', '--RPC : MAGG QUE IMAGE ^B^' + IObj.mag0);
      try
        call;
        maggmsgf.MagMsg('S', '--' + FBroker.RESULTS[0]);
      except
        messagedlg('Error attempting to set the Queue ' + #13 + 'to copy a BIG Image from the Juke Box.'
          + #13 + 'Not Fatal, Process will continue.', mtwarning, [mbok], 0);
      end;
    end;
end;
// Queue all images for a Patient to be copied from JukeBox to HD.

procedure TMagDBDemo.RPMaggQuePatient(whichimages, DFN: string);
var s: string;
begin
//not needed for demo
exit;
  { whichimages is a code of 'A' for abstract
                             'F' for Full }
  with FBroker do
    begin
      Param[0].VALUE := whichimages;
      param[0].ptype := literal;
      Param[1].VALUE := DFN;
      param[1].ptype := literal;
      remoteprocedure := 'MAGG QUE PATIENT';
      maggmsgf.magmsg('s', '--RPC : MAGG QUE PATIENT ^' + whichimages + '^' + dfn);
      S := strCall;
      maggmsgf.MagMsg('s', '--' + s);
    end;
end;
// Queue images to be Copied from JukeBox.
//  The RPC Call "M" code, determines if the iamges need to be queued.
//  and if true.  Makes the call to set the JBtoHD Queue.

procedure TMagDBDemo.RPMaggQueImageGroup(whichimages, MAGIEN: string);
var s: string;
begin
//not needed for demo
exit;
  { whichimages is a code of 'A' for abstract
                             'F' for Full }
  try
    with FBroker do
      begin
        Param[0].VALUE := whichimages;
        param[0].ptype := literal;
        Param[1].VALUE := MAGIEN;
        param[1].ptype := literal;
        remoteprocedure := 'MAGG QUE IMAGE GROUP';
        maggmsgf.magmsg('s', '--RPC : MAGG QUE IMAGE GROUP^' + whichimages + '^' + MAGIEN);
        S := strCall;
        maggmsgf.MagMsg('s', '--' + s);
      end;
  except
    //
  end;
end;
// Returns all images for an Image Group.

procedure TMagDBDemo.RPMaggGroupImages(IObj: TImageData; var t: tstringlist; noQAcheck: boolean = false);
begin
t.loadfromfile(ExtractFilePath(Iobj.FFile)+'\MagdemoImageList.txt');

exit;
//demo
  with FBroker do
    begin
      param[0].value := IObj.Mag0;
      param[0].ptype := literal;
      remoteprocedure := 'MAGG GROUP IMAGES'; //MAGOGLU';
      lstcall(t);
    end;
end;


// Gets all images for a patient.  Groups are returned as one item.
//   Single images are returned as one item.

(*procedure TMagDBDemo.RPMaggPatImages(DFN: string; var t: tstringlist);
begin
  with FBroker do
    begin
      param[0].Value := DFN;
      param[0].PType := literal;
      remoteprocedure := 'MAGG PAT IMAGES';
      lstCall(t);
    end;
end; *)
// This call returns all images, it returns the images of a group, instead
// of returning the Group.

procedure TMagDBDemo.RPMaggPatEachImage(DFN, MAX: string; var t: tstringlist);
begin
//not needed for demo
exit;
  with FBroker do
    begin
      param[0].Value := DFN;
      param[0].PType := literal;
      param[1].value := MAX;
      param[1].PType := literal;
      remoteprocedure := 'MAGG PAT EACH IMAGE';
      lstCall(t);
    end;
end;

procedure TMagDBDemo.CreateBroker;
begin
//not needed for demo
exit;
  if not assigned(FBroker) then
    begin
      FBroker := TRPCBroker.create(nil);
    end;
end;

procedure TMagDBDemo.RPMaggLogOff;
begin
FDemoConnected := false;
exit;
//demo
  if not FBroker.connected then exit;

  FBroker.remoteprocedure := 'MAGG LOGOFF';
  try
    FBroker.call;
  except
    on E: EBrokerError do maggmsgf.magmsg('de', 'Error Connecting to VISTA.' + #13 + #13 + E.MESSAGE + #13 + #13 + 'Shutdown will continue.');
    on E: Exception do maggmsgf.magmsg('de', 'Error During Log Off : ' + e.message);
  else
    maggmsgf.magmsg('de', 'Unknown Error during Log Off');
  end;
  FBroker.connected := false;
end;

procedure TMagDBDemo.RPMaggWrksUpdate(Apppath, DispAppName, CapAppName, Compname, Location, LastUpdate: string; startmode: integer);
var dtCapture, dtDisplay: string;
begin
//not needed for demo
exit;
  dtDisplay := '';
  dtCapture := '';

  if (CapAppName <> '') then
    begin
      try
        dtCapture := FORMATDATETIME('mm/dd/yy@hh:mm', FILEDATETIME(CapAppName));
      except
        dtCapture := '';
      end;
    end;
  if (DispAppName <> '') then
    begin
      try
        dtDisplay := FORMATDATETIME('mm/dd/yy@hh:mm', FILEDATETIME(DispAppName));
      except
        dtDisplay := '';
      end;
    end;

  FBroker.remoteprocedure := 'MAGG WRKS UPDATES';
  FBroker.param[0].ptype := literal;
  FBroker.param[0].value := Compname
    + '^' + dtCapture
    + '^' + dtDisplay
    + '^' + Location
    + '^' + LastUpdate
    + '^' + MagGetFileVersionInfo(DispAppName)
    + '^' + MagGetFileVersionInfo(CapAppName)
    + '^' + inttostr(startmode)
    + '^' + MagGetOSVersion
    + '^';
  FBroker.call;
  maggmsgf.magmsg('s', 'Workstation Information sent to VistA:');
  maggmsgf.magmsg('s', '  -> Result = ' + FBroker.results[0]);

end;

procedure TMagDBDemo.RPMaggUserKeys(var t: Tstringlist);
begin
  t.loadfromfile(extractfilepath(application.exename)+'image\magdemokeys.txt');
  exit;
  //demo
  FBroker.remoteprocedure := 'MAGGUSERKEYS';
  FBroker.lstcall(t);
  maggmsgf.MagMsgs('', t);
end;

procedure TMagDBDemo.RPMaggGetTimeout(app: string; var minutes: string);
begin
//not needed for demo
exit;
  FBroker.remoteprocedure := 'MAGG GET TIMEOUT';
  FBroker.Param[0].ptype := literal;
  FBroker.Param[0].value := app;
  minutes := FBroker.strcall;

end;

procedure TMagDBDemo.RPGetDischargeSummaries(dfn: string; var t: tstringlist);
begin
showmessage(' RPGetDischargeSummaries   needs activated for demo');
exit;
//demo

  FBroker.RemoteProcedure := 'TIU SUMMARIES';
  FBroker.Param[0].ptype := literal;
  FBroker.param[0].value := dfn;
  FBroker.lstcall(t);
end;

procedure TMagDBDemo.RPGetNoteText(tiuda: string; t: tstrings);
begin
  FBroker.RemoteProcedure := 'TIU GET RECORD TEXT';
  FBroker.Param[0].ptype := literal;
  FBroker.param[0].value := tiuda;
  FBroker.lstcall(t);
end;

procedure TMagDBDemo.RPGetNoteTitles(t, tint: tstringlist);
var i: integer;
begin
  t.sorted := false;
  tint.sorted := false;
  tint.clear;
  FBroker.RemoteProcedure := 'TIU GET PN TITLES';
  //xbrokerx.Param[0].ptype := literal;
  //xbrokerx.param[0].value := dfn  ;
  FBroker.lstcall(t);
  for I := 0 to t.count - 1 do
    begin
      tint.add('');
      tint[i] := copy(t[i], 2, pos('^', t[i]) - 2);
      t[i] := magpiece(t[i], '^', 2)
    end;
end;

//  Not Creating New TIU Records(*

function TMagDBDemo.RPCreateRecord(var msg: string; DFN, notetitle, notedate: string; notetext: tstrings): boolean;
var I: integer;
  S: string;
begin
//not needed for demo
result := true;
exit;
  if dfn = '' then
    begin
      result := false;
      msg := 'Need to Select a Patient';
      exit;
    end;
  FBroker.RemoteProcedure := 'TIU CREATE RECORD';
  FBroker.Param[0].ptype := literal;
  FBroker.param[0].value := DFN;
  FBroker.Param[1].ptype := literal;
  FBroker.param[1].value := notetitle;

  FBroker.Param[2].ptype := literal;
  FBroker.param[2].value := '';
  FBroker.Param[3].ptype := literal;
  FBroker.param[3].value := '';
  FBroker.Param[4].ptype := literal;
  FBroker.param[4].value := '';

  FBroker.Param[5].Value := '.X';
  FBroker.Param[5].PType := list;
  for i := 0 to NOTETEXT.COUNT do
    begin
    //xBrokerx.Param[3].Mult['"TEXT'+','+INTTOSTR(I+1)+',0"']:=NOTETEXT[I];
      FBroker.Param[5].Mult['"TEXT"' + ',' + INTTOSTR(I + 1) + ',0'] := NOTETEXT[I];
    end;

  s := FBroker.strcall;
  if magpiece(S, '^', 1) = '0'
    then
    begin
      RESULT := FALSE;
      MSG := MAGPIECE(S, '^', 2);
    end
  else
    begin
      RESULT := TRUE;
      MSG := S;
    end;

end;

// *)

function TMagDBDemo.RPGetFileManDateTime(datestr: string; var DisDt, IntDT: string; NoFuture : boolean = false): boolean;
var dt: string;
  { this returns 1 ^ Display Date ^ internal date
            or   0 ^ error msg     }
begin
//not needed for demo
result := true;
exit;
  FBroker.PARAM[0].PTYPE := literal;
  FBroker.PARAM[0].VALUE := datestr;
  IF NoFuture then
    begin
      FBroker.Param[1].ptype := literal;
      FBroker.Param[1].value := '1';
    end;
  FBroker.REMOTEPROCEDURE := 'MAGG DTTM';
  FBroker.CALL;
  dt := FBroker.RESULTS[0];
  if (dt = '') or (COPY(dt, 1, 1) = '0') then
    begin
      result := false;
      MESSAGEDLG(magpiece(dt, '^', 2), mtconfirmation, [mbok], 0);
      exit;
    end;
  DisDT := magpiece(dt, '^', 2);

  if maglength(DisDT, ':') > 2 then DisDT := magpiece(DisDT, ':', 1) + ':' + magpiece(DisDT, ':', 2);

  IntDT := magpiece(dt, '^', 3);
  result := true;
end;

function TMagDBDemo.RPSignRecord(tiuda, hashesign: string; var MSG: string): boolean;
var s: string;
begin
//not needed for demo
result := true;
exit;
  FBroker.PARAM[0].PTYPE := literal;
  FBroker.PARAM[0].VALUE := TIUDA;
  FBroker.PARAM[1].PTYPE := literal;
  FBroker.PARAM[1].VALUE := hashesign;
  FBroker.REMOTEPROCEDURE := 'TIU SIGN RECORD';
  S := FBroker.STRCALL;
  if (S = '0') then RESULT := TRUE
  else begin
      RESULT := FALSE;
      MSG := s;
    end;
end;

procedure TMagDBDemo.RPGetNotesByContext(dfn: string; var t: tstringlist; context: integer; author, count: string; docclass: integer; seq: string; showadd: integer; incund: integer);
begin
showmessage('  procedure RPGetNotesByContext needs activated for demo'); exit;
  (*
                  CLIP OF CODE FROM THE CALL TO 'TIU DOCUMENTS BY CONTEXT'
  CONTEXT(TIUY,CLASS,CONTEXT,DFN,EARLY,LATE,PERSON,OCCLIM,SEQUENCE,SHOWADD,INCUND)
   ; main
           ; --- Call with:  TIUY     - RETURN ARRAY pass by reference
          0 ;                 CLASS    - Pointer to TIU DOCUMENT DEFINITION #8925.1
          1 ;                 CONTEXT  - 1=All Signed (by PT),
           ;                          - 2="Unsigned (by PT&(AUTHOR!TANSCRIBER))
           ;                          - 3="Uncosigned (by PT&EXPECTED COSIGNER
           ;                          - 4="Signed notes (by PT&selected author)
           ;                          - 5="Signed notes (by PT&date range)
          2 ;                 DFN      - Pointer to Patient (#2)
          3 ;                [EARLY]   - FM date/time to begin search
          4 ;                [LATE]    - FM date/time to end search
          5 ;                [PERSON]  - Pointer to file 200 (DUZ if not passed)
          6 ;                [OCCLIM]  - Occurrence Limit (optional)
          7 ;                [SEQUENCE]- "A"=ascending (Regular date/time)
           ;                          - "D"=descending (Reverse date/time) (dflt)
          8 = SHOWADD(wasn't documented in 'M' routine
              SHOWADD 0/1  means Show Addenda
          9 ;                [INCUND]  - Boolean: include undictated & untranscribe

  *)
  FBroker.RemoteProcedure := 'TIU DOCUMENTS BY CONTEXT';
  FBroker.Param[0].ptype := literal;
  FBroker.param[0].value := inttostr(docclass); // CPMOD was just '3'
  FBroker.Param[1].ptype := literal;
  FBroker.param[1].value := inttostr(context);
  FBroker.Param[2].ptype := literal;
  FBroker.param[2].value := dfn;
  FBroker.Param[3].ptype := literal;
  FBroker.param[3].value := '';
  FBroker.Param[4].ptype := literal;
  FBroker.param[4].value := '';
  FBroker.Param[5].ptype := literal;
  FBroker.param[5].value := author;
  FBroker.Param[6].ptype := literal;
  FBroker.param[6].value := count;

  FBroker.Param[7].ptype := literal;
  FBroker.param[7].value := seq;
  FBroker.Param[8].ptype := literal;
  FBroker.param[8].value := inttostr(showadd);
  FBroker.Param[9].ptype := literal;
  FBroker.param[9].value := inttostr(incund);
  FBroker.lstcall(t);
end;

function TMagDBDemo.RPGetTIUData(tiuda: string; var TIUPTR: string): boolean;
var S: string;
begin
  FBroker.RemoteProcedure := 'MAG3 TIU DATA FROM DA';
  FBroker.Param[0].ptype := literal;
  FBroker.param[0].value := TIUDA;
  try
    S := FBroker.strCall;
    if ((s = '') or (magpiece(s, '^', 1) = '0')) then
      begin
        RESULT := FALSE;
        TIUPTR := '';
        exit;
      end;
    RESULT := TRUE;
    TIUPTR := s;
  except
    RESULT := FALSE;
    TIUPTR := '';
  end;
end;

procedure TMagDBDemo.RPGetCPRSTIUNotes(tiuda: string; t: tstringlist; var success: boolean; var RPmsg: string);
begin
  success := false;
  try
    FBroker.remoteprocedure := 'MAG3 CPRS TIU NOTE';
    FBroker.param[0].ptype := literal;
    FBroker.param[0].value := tiuda;
    FBroker.lstcall(t);
    if (magpiece(t[0], '^', 1) = '0') then
      begin
        maggmsgf.MagMsg('', magpiece(t[0], '^', 2));
        RPmsg := t[0];
        exit;
      end;
    if (t.count = 0) then
      begin
        maggmsgf.MagMsg('', 'Error accessing Images for TIU Note ');
        RPmsg := 'Error accessing Images for TIU Note ';
        exit;
      end;
    success := true;
    RPmsg := t[0];
    t.delete(0);
  except
    on E: Exception do
      begin
        maggmsgf.MagMsg('', 'Exception accessing Images for TIU Note ');
        RPmsg := 'Exception accessing Images for TIU Note ';
      end;
  end;
end;

//procedure RPMagCategories(var t, tien: tstrings);

(*procedure TMagDBDemo.RPMagCategories(t: tstrings);
begin
  //ADMINDOC
  try
    t.clear;
    //tien.clear;
    FBroker.remoteprocedure := 'MAGGDESCCAT';
    FBroker.lstcall(t);
    if (t.count = 0) then
      begin
        maggmsgf.magmsg('', 'Error loading Image Cagetories.');
        exit;
      end;
    if (t.count = 1) then maggmsgf.magmsg('de', magpiece(t[0], '^', 2));
    t.delete(0);

  except
    on e: exception do maggmsgf.magmsg('de', 'Exception ' + e.message);
  end;
end;
  *)
procedure TMagDBDemo.RPGetClinProcReq(dfn: string; var t: Tstrings);
begin
  //  success := false;
  try
    FBroker.remoteprocedure := 'MAG4 CP GET REQUESTS';
    FBroker.param[0].ptype := literal;
    FBroker.param[0].value := dfn;
    FBroker.lstcall(t);
    if (magpiece(t[0], '^', 1) = '0') then
      begin
        maggmsgf.MagMsg('', magpiece(t[0], '^', 2));
        exit;
      end;
    if (t.count = 0) then
      begin
        maggmsgf.MagMsg('', 'Error while listing CP Requests. ');
        t.add('0^Error while listing CP Requests. ');
        exit;
      end;
    //    success := true;
    t.delete(0);
  except
    on E: Exception do
      begin
        maggmsgf.MagMsg('', 'Exception while listing CP Requests. ');
        t.insert(0, '0^Exception while listing CP Requests. ');
      end;
  end;
end;

procedure TMagDBDemo.RPGetTIUDAfromClinProcReq(dfn, fConsIEN, vstring, Complete: string; var t: Tstrings);
begin
  //  success := false;
  try
    FBroker.remoteprocedure := 'MAG4 CP CONSULT TO TIUDA';
    FBroker.param[0].ptype := literal;
    FBroker.param[0].value := dfn;
    FBroker.param[1].ptype := literal;
    FBroker.param[1].value := fConsIEN;
    FBroker.param[3].ptype := literal;
    FBroker.param[3].value := complete;
    FBroker.param[2].ptype := literal;
    FBroker.param[2].value := vstring;
    FBroker.lstcall(t);
    if (magpiece(t[0], '^', 1) = '0') then
      begin
        maggmsgf.MagMsg('', magpiece(t[0], '^', 2));
        exit;
      end;
    if (t.count = 0) then
      begin
        maggmsgf.MagMsg('', 'Error (#34) in VistA');
        t.add('0^Error (#34) in VistA');
        exit;
      end;
    //    success := true;
    //     t.delete(0);
  except
    on E: Exception do
      begin
        maggmsgf.MagMsg('', 'Exception (#34) in VistA');
        t.insert(0, '0^Exception (#34) in VistA');
      end;
  end;

end;

procedure TMagDBDemo.RPGetVisitListForReq(dfn: string; var t: Tstrings);
begin
  //  success := false;
  try
    FBroker.remoteprocedure := 'MAG4 CP GET VISITS';
    FBroker.param[0].ptype := literal;
    FBroker.param[0].value := dfn;
    FBroker.lstcall(t);
    if (magpiece(t[0], '^', 1) = '0') then
      begin
        maggmsgf.MagMsg('', magpiece(t[0], '^', 2));
        exit;
      end;
    if (t.count = 0) then
      begin
        maggmsgf.MagMsg('', 'Error Listing Patient visits.');
        t.add('0^Error Listing Patient visits.');
        exit;
      end;
    //    success := true;

    t.delete(0);
  except
    on E: Exception do
      begin
        maggmsgf.MagMsg('', 'Exception Listing Patient visits.');
        t.insert(0, '0^Exception Listing Patient visits.');
      end;
  end;
end;

procedure TMagDBDemo.RPMagVersionCheck(T: Tstrings; version: string);
begin
t.add('1^Demo Version 1.1');
exit;
//demo;
  FBroker.remoteprocedure := 'MAG4 VERSION CHECK';
  FBroker.Param[0].PType := literal;
  FBroker.Param[0].Value := Version;

  try
    FBroker.lstcall(t);
    if (t.count = 0) then
      begin
        T.insert(0, '1^continue');
        maggmsgf.magmsg('', 'Error Checking Version on Server');
        exit;
      end;

  except
    on e: exception do
      begin
        t.insert(0, '1^continue');
        maggmsgf.magmsg('de', 'Exception ' + e.message);
      end;
  end;
end;

function TMagDBDemo.RPFileManDate(var xmsg: string; dateinput: string; var dateoutput: string; NoFuture : boolean = false): boolean;
var s: string;
var x2, x3: string;
begin
  result := false;
  if not FBroker.connected then
    begin
      xmsg := 'You must be connected to VistA to enable Date functions';
      exit;
    end;
  dateoutput := '';
  s := dateinput;
  if uppercase(s) = 'T' then s := 'N';
  with FBroker do
    begin
      PARAM[0].PTYPE := literal;
      PARAM[0].VALUE := S;
      IF NoFuture then
        begin
          Param[1].ptype := literal;
          Param[1].value := '1';
        end;
      REMOTEPROCEDURE := 'MAGG DTTM';
      CALL;
      S := RESULTS[0];
    end;
  if (S = '') then s := '0^Error converting input to Date/Time';
  if (COPY(S, 1, 1) = '0') then
    begin
      dateoutput := '';
      xmsg := magpiece(s, '^', 2);
      exit;
    end;
  // take out the seconds
  x2 := magpiece(s, '^', 2);
  x3 := magpiece(s, '^', 3);
  x2 := magpiece(x2, ':', 1) + ':' + magpiece(x2, ':', 2);
  x3 := copy(x3, 1, 12);

  dateoutput := x2 + '^' + x3;
  result := true;
end;

procedure TMagDBDemo.RPXMultiProcList(lit: TStrings; dfn: string); // proclist: Tstrings);
var t: tstrings;
begin
  lit.clear;
  t := tstringlist.create;
  FBroker.remoteprocedure := 'MAG4 MULTI PROCEDURE LIST';
  // for now we get all
  FBroker.Param[0].PType := list;
  FBroker.Param[0].Value := '.x';
  FBroker.Param[0].mult['1'] := 'MED^ALL';
  FBroker.Param[0].mult['2'] := 'LAB^ALL';
  FBroker.Param[0].mult['3'] := 'RAD^ALL';
  FBroker.Param[0].mult['4'] := 'SUR^ALL';
  FBroker.Param[0].mult['5'] := 'TIU^ALL';
  FBroker.Param[1].PType := literal;
  FBroker.Param[1].value := dfn;

  try
    FBroker.lstcall(t);
    if (t.count = 0) then
      begin
        lit.add('<Error loading ''Procedure'' list>');
        maggmsgf.magmsg('', 'Error loading Procedure listing.');
        exit;
      end;

  except
    on e: exception do
      begin
        lit.add('<Exception loading ''Procedure'' list>');
        maggmsgf.magmsg('', 'Exception loading Procedure listing');
        exit;
      end;
  end;
  t.delete(0);
  lit.AddStrings(t);
  t.free;
end;

procedure TMagDBDemo.RPCTPresetsGet(var rstat: boolean; var rmsg: string; var value: string);
var xmsg: string;
begin
rstat := false;
exit;
//demo
  rstat := false;
  with FBroker do
    begin
      remoteprocedure := 'MAG4 CT PRESETS GET';
    end;
  try
    xmsg := Fbroker.StrCall;
    if (magpiece(xmsg, '^', 1) = '0') or (xmsg = '') then
      begin
        rstat := false;
        if xmsg <> '' then rmsg := magpiece(xmsg, '^', 2)
        else rmsg := 'VistA ERROR: Operation canceled.';
        exit;
      end;
    rstat := true;
    rmsg := 'Success.';
    value := magpiece(xmsg, '^', 2);
  except
    on E: EXCEPTION do
      begin
        rmsg := '0^ERROR (EXCEPTION) in VistA function.' + magpiece(e.message, #$A, 2);
        rstat := false;
        maggmsgf.MagMsg('s', e.message);
      end;
  end;
end;

procedure TMagDBDemo.RPCTPresetsSave(var rstat: boolean; var rmsg: string; value: string);
var xmsg: string;
begin
rstat := false;
exit;
//demo
  rstat := false;
  with FBroker do
    begin
      Param[0].PType := literal;
      Param[0].Value := value;
      remoteprocedure := 'MAG4 CT PRESETS SAVE';
    end;
  try
    xmsg := Fbroker.StrCall;
    if (magpiece(xmsg, '^', 1) = '0') or (xmsg = '') then
      begin
        rstat := false;
        if xmsg <> '' then rmsg := magpiece(xmsg, '^', 2)
        else rmsg := 'VistA ERROR: Operation canceled.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(xmsg, '^', 2);
  except
    on E: EXCEPTION do
      begin
        rmsg := '0^ERROR (EXCEPTION) in VistA function.' + magpiece(e.message, #$A, 2);
        rstat := false;
        maggmsgf.MagMsg('s', e.message);
      end;
  end;

end;

procedure TMagDBDemo.RPFilterListGet(var rstat: boolean; var rmsg: string; var tlist: tstrings; duz: string = ''; getall: boolean = false);
begin
tlist.LoadfromFile(ExtractFilepath(application.exename)+ '\image\MagDemoFilterList'+duz+'-'+magbooltostrint(getall)+'.txt');
tlist.Delete(0);
rstat := true;
rmsg :='';
exit;
//demo
  rstat := false;
  with FBroker do
    begin
      param[0].Value := duz;
      param[0].PType := literal;
      param[1].Value := magbooltostrint(getall);
      param[1].PType := literal;
      remoteprocedure := 'MAG4 FILTER GET LIST';
    end;
  try
    Fbroker.lstCall(tlist);
    if (magpiece(tlist[0], '^', 1) = '0') or (tlist.count = 0) then
      begin
        rstat := false;
        if tlist.count > 0 then rmsg := magpiece(tlist[0], '^', 2)
        else rmsg := 'ERROR: Health Summary Failed. Check VISTA Error Log.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(tlist[0], '^', 2);
    tlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        tlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        tlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;
end;

procedure TMagDBDemo.RPFilterDetailsGet(var rstat: boolean; var rmsg, filter: string; fltien: string; fltname: string = ''; duz: string = '');
var vlist: tstrings;
fltlist : TStrings;
i : integer;
begin
vlist := tstringlist.create;
try
if fltien = '' then
  begin
    fltlist := Tstringlist.create;
    fltlist.loadfromfile(ExtractFilepath(application.exename)+ '\image\MagDemoFilterList'+Fduz+'-1.txt');
    fltlist.Delete(0);
    for I := 0 to fltlist.count -1 do
        if magpiece(fltlist[i],'^',2) = fltname then
           begin
             fltien := magpiece(fltlist[i],'^',1);
             break;
           end;
  end;
if fltien = '' then
  begin
  rmsg := 'Resolving Filter name failed.';
  rstat := false;
  exit;
  end;




vlist.LoadFromFile(ExtractFilepath(application.exename)+ '\image\MagDemoFilter'+fltien+'.txt');
filter := vlist[1];
rstat := true;
rmsg := '';
finally
vlist.free;
end;
exit;
//demo
  vlist := tstringlist.create;
  try
    rstat := false;
    with FBroker do
      begin
        param[0].Value := fltien;
        param[0].PType := literal;
        param[1].Value := fltname;
        param[1].PType := literal;
        param[2].Value := duz;
        param[2].PType := literal;
        remoteprocedure := 'MAG4 FILTER DETAILS';
      end;
    try
      Fbroker.lstCall(vlist);
      if (magpiece(vlist[0], '^', 1) = '0') or (vlist.count = 0) then
        begin
          rstat := false;
          if vlist.count > 0 then rmsg := magpiece(vlist[0], '^', 2)
          else rmsg := 'ERROR: Retrieving Filter Details Failed. Check VISTA Error Log.';
          exit;
        end;
      rstat := true;
      rmsg := magpiece(vlist[0], '^', 2);
      filter := vlist[1];
    //vlist.delete(0);
    except
      on E: EXCEPTION do
        begin
          rmsg := 'ERROR (EXCEPTION) in VistA function.';
          rstat := false;
          maggmsgf.MagMsg('s', 'ERROR (EXCEPTION) in VistA function:' + e.Message);
        end;
    end;
  finally
    vlist.free;
  end;
end;

procedure TMagDBDemo.RPFilterSave(var rstat: boolean; var rmsg: string; t: Tstrings);
var I: integer;
begin
rmsg := 'Saving Filters is disabled in Demo mode.' ;
showmessage(rmsg);
rstat := false;
exit;
//demo
  rstat := false;
  with FBroker do
    begin
      Param[0].PType := list;
      Param[0].Value := '.x';
      for I := 0 to t.count - 1 do Param[0].Mult['' + inttostr(i) + ''] := t[i];
      remoteprocedure := 'MAG4 FILTER SAVE';
    end;
  try
    rmsg := Fbroker.strCall;
    if (magpiece(rmsg, '^', 1) = '0') or (rmsg = '') then
      begin
        rstat := false;
        if (rmsg = '') then rmsg := 'ERROR: Retrieving Filter Details Failed. Check VISTA Error Log.';
        exit;
      end;
    rstat := true;
    //rmsg := magpiece(rmsg, '^', 2);
    //vlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        rmsg := 'ERROR (EXCEPTION) in VistA function.';
        rstat := false;
        maggmsgf.MagMsg('s', 'ERROR (EXCEPTION) in VistA function:' + e.Message);
      end;
  end;
end;

procedure TMagDBDemo.RPFilterDelete(var rstat: boolean; var rmsg: string; fltien: string);
begin
rmsg := 'Deleting Filters is disabled in Demo mode.'  ;
//showmessage(rmsg);
rstat := false;
exit;
//demo
//  if not CheckDBConnection(xmsg) then
  rstat := false;
  with FBroker do
    begin
      Param[0].PType := literal;
      Param[0].Value := fltien;
      remoteprocedure := 'MAG4 FILTER DELETE';
    end;
  try
    rmsg := Fbroker.strCall;
    if (magpiece(rmsg, '^', 1) = '0') or (rmsg = '') then
      begin
        rstat := false;
        if (rmsg <> '') then rmsg := magpiece(rmsg, '^', 2)
        else rmsg := 'ERROR: Deleting Image Filter. Check VISTA Error Log.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(rmsg, '^', 2);
    //vlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        rmsg := 'ERROR (EXCEPTION) in VistA function.';
        rstat := false;
        maggmsgf.MagMsg('s', 'ERROR (EXCEPTION) in VistA function:' + e.Message);
      end;
  end;
end;
function TMagDBDemo.IsConnected: boolean;
begin
result := FDemoConnected;
exit;
if assigned(FBroker)
  then result := FBroker.Connected
  else result := false;
end;

procedure TMagDBDemo.SetConnected(const Value: boolean);
begin
FDemoConnected := value;
exit;
//demo
if assigned(FBroker)
 then Fbroker.Connected := value;
end;

function TMagDBDemo.GetListenerPort: integer;
begin
if assigned(FBroker)
  then result := Fbroker.ListenerPort
  else result := 0;
end;

function TMagDBDemo.GetServer: string;
begin
result := 'Demo Images';
exit;
//demo
if assigned(FBroker)
  then result := FBroker.Server
  else result := '';
end;

procedure TMagDBDemo.SetListenerPort(const Value: integer);
begin
if assigned(FBroker)
  then FBroker.ListenerPort := value;
end;

procedure TMagDBDemo.SetServer(const Value: string);
begin
if assigned(FBroker)
  then FBroker.Server := value;
end;

constructor TMagDBDemo.create;
begin
 FPatientList := Tstringlist.create;
FDuz := '999';
end;

end.

