unit cMagDBDemoUtils;
{
 Package: MAG - VistA Imaging
 WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
 Date Created:
 Site Name: Silver Spring, OIFO
 Developers: Garrett Kirin
 [==   unit cMagDBDemoUtils;
 Description:   Imaging Demo Utilities.
   Imaging Demo Utilities. Used by TmagDBDemo Class.  To make the
   old demo files work with the new Abstract DB design ( TMagDBBroker is an
    Abstract Class, TMagDBMVista and TMagDBDemo redeclare and implement the
    abstracts class members) some Demo Specific coding is needed. This Util
    unit is specific to and only called from cMagDBDemo.
   (see cMagDBBroker description )
 ==]
 Note:
  }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)
interface
 uses uMagDefinitions, Classes, sysutils, forms, umagutils;

type TMagDemoUtils = Class
  private
    procedure ResolveIndexIENs(var values : string; rlist : Tstrings);
    procedure FilterOnProp(values: string; var rlist: Tstrings; itempiece: integer; inclusive : boolean = true);
    procedure FilterOnDate(frdt, todt: string; var flist: Tstrings);
  public
    procedure FilterTheList(filter : TImageFilter; var flist : TStrings);
  end;
implementation


procedure TMagDemoUtils.FilterTheList(filter : TImageFilter; var flist : TStrings);
var cls, pkg, types, spec, event: string;
  FrDt: string;
  ToDt: string;
  MthRange: integer;
  origin: string;
  demodir : string;
  indexlist : Tstrings;
  templist : Tstrings;
begin
indexlist := Tstringlist.create;
templist := TStringlist.create;
try
demodir := extractfilepath(application.exename) + 'image\';
(*
'2^09/10/2003^CLIN^1^CONSENT^NONE^CLIN^CONSENT^ALLERGY & IMMUNOLOGY^DISCHARGE SUMMARY^|
*)
  cls := '';
  pkg := '';
  types := '';
  spec := '';
  event := '';
  FrDt := '';
  ToDt := '';
 // MthRange := 0;
  origin := '';
  if filter <> nil then
    begin
      cls := ClassesToString(filter.classes);
      pkg := PackagesToString(filter.packages);
      types := filter.Types;
      spec := filter.SpecSubSpec;
      event := filter.ProcEvent;
      FrDt := filter.FromDate;
      ToDt := filter.ToDate;
      MthRange := filter.MonthRange;
      if MthRange < 0 then
        begin
          frdt := formatdatetime('mm/dd/yyyy', incMonth(date, mthrange));
          todt := '';
        end;
      origin := filter.origin;
    end;

//for Filters to work in Demo.
(* we have a complete image list for demo patients. MagDemoImageList (in each patients demo dir)
   and we load it above (Flist)
loop through all properties of filter. if not null
see if appropriate '^' piece of Image entry is contained in property.
i.e. pkg = 'MED,RAD'   substr := $p(6)  if ((substr <> '') and (pos(substr,pkg)> 0))
                                            then okay
                                            else delete this item.


*)
indexlist.Clear;
indexlist.LoadFromFile(demodir+'MagDemoIndexSpec.txt');
ResolveIndexIENs(spec,indexlist);
indexlist.Clear;
indexlist.LoadFromFile(demodir+'MagDemoIndexEvent.txt');
ResolveIndexIENs(event,indexlist);
indexlist.Clear;
indexlist.LoadFromFile(demodir+'MagDemoIndexTypeADMIN.txt');
templist.LoadFromFile(demodir+'MagDemoIndexTypeCLIN.txt');
indexlist.AddStrings(templist);
ResolveIndexIENs(types,indexlist);
{  cls := '';
  pkg := '';
  types := '';
  spec := '';
  event := '';
  FrDt := '';
  ToDt := '';
  MthRange := 0;
  origin := '';}
if cls <> '' then FilterOnProp(cls,flist,7);
if pkg <> '' then FilterOnProp(pkg,flist,6);
if types <> '' then FilterOnProp(types,flist,8);
if spec <> '' then FilterOnProp(spec,flist,9,false);
if event <> '' then FilterOnProp(event,flist,10,false);
if origin <> '' then FilterOnProp(origin,flist,11);
if ((FrDt <> '') or (ToDt <> '')) then FilterOnDate(frdt,todt,flist);

finally
indexlist.free;
templist.free;
end;
end;

procedure TMagDemoUtils.ResolveIndexIENs(var values : string; rlist : Tstrings);
var I : integer;
newvalues : string;
substr : string;
begin
newvalues := '';
values := ','+values+',';
for i := 0 to rlist.count-1  do
  begin
    if (magpiece(rlist[i],'|',2) = '') then continue;
    substr := ','+magpiece(rlist[i],'|',2)+',';
    if (pos(substr,values) > 0 ) then  newvalues := newvalues + magpiece(rlist[i],'^',1)+ ',';
  end;
if newvalues <> '' then newvalues := copy(newvalues,1,length(newvalues)-1);
values := newvalues;
end;

procedure TMagDemoUtils.FilterOnProp(values : string; var rlist : Tstrings; itempiece: integer; inclusive : boolean = true);
var I : integer;
substr : string;
begin
values := ','+values+',';
for i := rlist.count-1 downto 1 do
  begin
    if ((magpiece(rlist[i],'^',itempiece) = '') and inclusive) then continue;
    substr := ','+magpiece(rlist[i],'^',itempiece)+',';
    if (pos(substr,values) = 0 )
      then  rlist.Delete(i);
  end;
end;

procedure TMagDemoUtils.FilterOnDate(frdt,todt : string; var flist : Tstrings);
var I : integer;
cmpdt : string;
begin
if frdt <> '' then
  try
    frdt := formatdatetime('yyyymmddhhmmnn', strtodatetime(frdt));
  except
   frdt := '';
   end;
if todt <> '' then
  try
    todt := formatdatetime('yyyymmddhhmmnn', strtodatetime(todt + ' 11:59:59'));
  except
   todt := '';
   end;



for i := flist.count-1 downto 1 do
  begin
{formatdatetime('yyyymmddhhmmnn', strtodatetime(lic)}


{ a := formatdatetime('yyyymmddhhmmnn', strtodatetime(edit1.text));
  b := formatdatetime('yyyymmddhhmmnn', strtodatetime(edit2.text));
  x := CompareText(a,b);
  edit3.text := inttostr(x);}
  try
  cmpdt := magpiece(flist[i],'^',2);
  cmpdt := formatdatetime('yyyymmddhhmmnn', strtodatetime(cmpdt));
  except
  cmpdt := '';
  end;
  if cmpdt = '' then continue;
  // see if Image Date is > FromDate
  if frdt <> '' then
    if CompareText(frdt,cmpdt) > 0 then
      begin
        flist.delete(i);
        continue;
      end;
  // see if Image Data < ToDate
  if todt <> '' then
    if CompareText(cmpdt,todt) > 0 then
      begin
        flist.delete(i);
        continue;
      end;

  end;
end;

end.
