unit cMagDBMVista;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Garrett Kirin
   [==    unit cMagDBMVista;
   Description:
     Imaging M-Vista database calls. Desecndant of Abstract Class TMagDBBroker
     This Class will surface (redeclare, override and implement) the Abstract
     methods and members of the ancestor abstract class to make DataBase Calls.
     This design enables the application to function the same way
     regardless of which database is connected.  M, (Oracle), Demo TXT files
   ==]
   Note:
   }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Trpcb, hash, RPCconf1, uMagUtils, uMagDefinitions, umagclasses,
  maggmsgu, fmxutils, magfileversion, cMagDBBroker;

type
  TMagDBMVista = class(TMagDBBroker)
  private
    FBroker: TRPCBroker;

    function DoesFormExist(s: string): boolean;
    procedure CreateMessageHistory;
  protected
    { Protected declarations }
  public

//gek    function GetSilentCodes(Vserver, Vport: string; var SilentAccess: string; var SilentVerify: string): boolean; override;
    function CheckDBConnection(var xmsg: string): boolean; override;
    function IsConnected: boolean; override;
    procedure SetConnected(const Value: boolean); override;
    function GetListenerPort: integer; override;
    function GetServer: string; override;
    procedure SetListenerPort(const Value: integer); override;
    procedure SetServer(const Value: string); override;

    function GetBroker: TRPCBroker; override;
    procedure SetBroker(const Value: TRPCBroker); override;
    procedure CreateBroker; override;
    function RPFileManDate(var xmsg: string; dateinput: string; var dateoutput: string; NoFuture : boolean = false): boolean; override;
    procedure RPXMultiProcList(lit: TStrings; dfn: string); override;

    procedure RPMagVersionCheck(T: Tstrings; version: string); override;
       //Clinical Procedures
    procedure RPUpdateConsult(consult, tiuien, cmpflag: string; var status: string); override;
    procedure RPGetClinProcReq(dfn: string; var t: Tstrings); override;
    procedure RPGetTIUDAfromClinProcReq(dfn, fConsIEN, vstring, Complete: string; var t: Tstrings); override;
    procedure RPGetVisitListForReq(dfn: string; var t: Tstrings); override;

    procedure RPMaggOffLineImageAccessed(IObj: TImageData); override;
//Set Image Queues
    procedure RPMaggQueImage(IObj: TImageData); override;
    procedure RPMaggQueBigImage(IObj: TImageData); override;
    procedure RPMaggQuePatient(whichimages, DFN: string); override;
    procedure RPMaggQueImageGroup(whichimages, MAGIEN: string); override;

    procedure RPMag3Logaction(actionstring: string); override;
    procedure RPMaggGroupImages(IObj: TImageData; var t: tstringlist; noQAcheck: boolean = false); override;
//    procedure RPMaggPatImages(DFN: string; var t: tstringlist); override;
    procedure RPMaggPatEachImage(DFN, MAX: string; var t: tstringlist); override;
    procedure RPMaggLogOff; override;
    procedure RPMaggWrksUpdate(Apppath, DispAppName, CapAppName, Compname, Location, LastUpdate: string; startmode: integer); override;
    procedure RPMaggUserKeys(var t: Tstringlist); override;
    procedure RPMaggGetTimeout(app: string; var minutes: string); override;
    procedure RPGetNoteText(tiuda: string; t: tstrings); override;
    procedure RPGetNoteTitles(t, tint: tstringlist); override;
//  not creating  TIU Entries.
    function RPCreateRecord(var msg: string; DFN, notetitle, notedate: string; notetext: tstrings): boolean; override;
    function RPGetFileManDateTime(datestr: string; var DisDt, IntDT: string; NoFuture : boolean): boolean; override;
    function RPSignRecord(tiuda, hashesign: string; var MSG: string): boolean; override;
    procedure RPGetDischargeSummaries(dfn: string; var t: tstringlist); override;
    procedure RPGetNotesByContext(dfn: string; var t: tstringlist; context: integer; author, count: string; docclass: integer; seq: string; showadd: integer; incund: integer); override;
    function RPGetTIUData(tiuda: string; var TIUPTR: string): boolean; override;
    procedure RPGetCPRSTIUNotes(tiuda: string; t: tstringlist; var success: boolean; var RPmsg: string); override;
//    procedure RPMagCategories(t: tstrings); override;
    function RPMagEkgOnline: integer; override;
    procedure RPMagGetNetLoc(var success: boolean; var RPmsg: string; var Shares: TStringList; NetLocType: string); override;
    procedure RPMagLogErrorText(T: Tstrings; COUNT: INTEGER); override;

    function RPTIUCPClass: integer; override;
    function RPTIUConsultsClass: integer; override;
    procedure RPGetFileExtensions(var t: tstrings); override;


 /////////////////////////
    procedure RPFilterDelete(var rstat: boolean; var rmsg: string; fltien: string); override;
    procedure RPFilterSave(var rstat: boolean; var rmsg: string; t: Tstrings); override;
    procedure RPFilterListGet(var rstat: boolean; var rmsg: string; var tlist: tstrings; duz: string = ''; getall: boolean = false); override;
    procedure RPFilterDetailsGet(var rstat: boolean; var rmsg, filter: string; fltien: string; fltname: string = ''; duz: string = ''); override;
    procedure RPCTPresetsGet(var rstat: boolean; var rmsg: string; var value: string); override;
    procedure RPCTPresetsSave(var rstat: boolean; var rmsg: string; value: string); override;

    procedure RPMaggHS(var rstat: boolean; var rmsg: string; var tlist: tstringlist; value: string); override;
    procedure RPMaggHSList(var rstat: boolean; var rmsg: string; var tlist: tstringlist; value: string); override;
    procedure RPMaggRadReport(var rstat: boolean; var rmsg: string; var tlist: tstringlist; rarpt: string); override;
    procedure RPMaggRadImage(var rstat: boolean; var rmsg: string; var tlist: tstringlist; radstring: string); override;
    procedure RPMaggDGRPD(var rstat: boolean; var rmsg: string; var rlist: tstringlist; dfn: string); override;
    procedure RPMaggUser2(var rstat: boolean; var rmsg: string; var rlist: tstrings; wsid: string); override;
    procedure RPMaggCPRSRadExam(var rstat: boolean; var rmsg: string; var rlist: tstrings; cprsstring: string); override;
    procedure RPMaggRadExams(var rstat: boolean; var rmsg: string; var rlist: tstrings; DFN: string); override;
    procedure RPMaggImageInfo(var rstat: boolean; var rmsg: string; var rlist: tstrings; ien: string; noQAcheck : boolean = false); override;
    procedure RPMag4PatGetImages(var Fstat: boolean; var rpcmsg: string; DFN: string; var Flist: tstrings; filter: TImageFilter = nil); override;
    procedure RPMagGetUserPreferences(var Fstat: boolean; var rpcmsg: string; xlist: Tstringlist; code: string = ''); override;
    procedure RPMagSetUserPreferences(var Fstat: boolean; var rpcmsg: string; xlist: Tstrings); override;
//    procedure RPMagIndexType(var Fstat: boolean; var Flist: tstringlist; MagDFN: string); override;
    procedure RPMag4RemoteImport(var Fstat: boolean; var Flist: tstringlist; DataArray: Tstringlist); override;
    procedure RPMagPatInfo(var Fstat: boolean; var Fstring: string; MagDFN: string; isicn: boolean = false); override;
//    procedure RPMag4PostProcessing(var Fstat: boolean; var Flist: tstringlist; Magien: string); override;
    procedure RPMag4PostProcessActions(var Fstat: boolean; var Flist: tstringlist; Magien: string); override;
    procedure RPMag3LookupAny(var Fstat: boolean; var fmsg: string; var Flist: tstringlist; InputString: string); override;
    procedure RPMag4IAPIStats(var Fstat: boolean; var FList: tstrings; DtStart, DtEnd: string); override;
    procedure RPMaggImageDelete(var Fstat: boolean; var rmsg: string; var Flist: tstrings; IEN, ForceDel: string; reason: string = ''; GrpDelOK: boolean = false); override;
//    procedure RPMagGetImageReport(var Fstat: boolean; var Fmsg: string; Flist: tstrings; magien: string); override;
    procedure RPImageReport(var Fstat: boolean; var Fmsg: string; Flist: tstrings; IObj: TImageData; noQACheck : boolean = false); override;
    procedure RPMag3TIUImage(var Fstat: boolean; var Flist: tstringlist; MagIEN, TIUDA: string); override;
    procedure RPMag4DataFromImportQueue(var Fstat: boolean; var Flist: tstringlist; QueueNum: string); override;
    procedure RPMag4ValidateData(var Fstat: boolean; var Flist: tstringlist; t: tstringlist; rettype: string); override;
    procedure RPMag4AddImage(var Fstat: boolean; var Flist: tstringlist; t: tstringlist); override;
    procedure RPMagABSJB(var Fstat: boolean; var Flist: tstringlist; CreatAbsIEN, JBCopyIEN: string); override;
    procedure RPMaggInstall(var Fstat: boolean; var Flist: tstringlist); override;

    function RPMag4GetFileFormatInfo(ext: string; var xmsg: string): boolean; override;
    function RPVerifyEsig(esig: string; var xmsg: string): boolean; override;
    procedure RPLogCopyAccess(s: string); override;
    procedure RPIndexGetType(lit: TStrings; cls: string; ignoreStatus: boolean = false); override;
    procedure RPIndexGetEvent(lit: TStrings; cls: string = ''; spec: string = ''; ignoreStatus: boolean = false); override;
    procedure RPIndexGetSpecSubSpec(lit: TStrings; cls: string = ''; proc: string = ''; ignoreStatus: boolean = false); override;
    procedure RPDGChkPatDivMeansTest(DFN: string; var code: INTEGER; var t: TSTRINGLIST); override;
    procedure RPDGSensitiveRecordBulletin(DFN: string); override;
    procedure RPDGSensitiveRecordAccess(DFN: string; var code: INTEGER; var t: TSTRINGLIST); override;
    function RPMaggPatBS5Chk(DFN: string; var t: tstringlist): boolean; override;
    function RPMagPatLookup(STR: string; t: tstrings; var xmsg: string): boolean; override;
    procedure RPMag4GetImageInfo(magien: string; var Flist: Tstrings); override;
    function RPMaggGetPhotoIDs(xdfn: string; t: tstringlist): BOOLEAN; override;
    procedure RPMag4StatusCallback(t: tstrings; cb: string; DoStatusCB: boolean = true); override;
    { TODO : Need to return a message, 'Why connection didn't work, User cancel, Error, etc. }
    { TODO : DBSelect needs : option of user sending the Server Port, and not being prompted for it . }
    function DBSelect(var vserver, vport: string; context: string = 'MAG WINDOWS'): boolean; override;
    function DBConnect(vserver, vport: string; context: string = 'MAG WINDOWS'; accesscode: string = ''; verifycode: string = ''): boolean; override;


  published
 //   property Broker: TRPCBroker read GetBroker write SetBroker;
//   property Connected : boolean read IsConnected write SetConnected;
//   property listenerport : integer read GetListenerPort write SetListenerPort;
//   property server : string read GetServer write SetServer;
  end;


implementation
// uses umagclasses;

 { TODO : 
Need to get DoesFormExist function out of here and into a module (unit, class)
that doesn't 'use' forms. (task on this in my list) }

{Called with the Tform.name value of a form, to see if it exists, if we have to create it or not}
function TMagDBMVista.DoesFormExist(s: string): boolean;
var i: integer;
begin
  result := false;
  for I := screen.CustomFormCount - 1 downto 0 do
  begin
    if (Uppercase(screen.customforms[i].name) = uppercase(s)) then
    begin
      result := true;
      break;
    end;
  end;
end;

procedure TMagDBMVista.RPDGChkPatDivMeansTest(DFN: string; var code: INTEGER; var t: TSTRINGLIST);
begin
  FBroker.PARAM[0].VALUE := DFN;
  FBroker.PARAM[0].PTYPE := LITERAL;
  Fbroker.remoteprocedure := 'DG CHK PAT/DIV MEANS TEST';
  {         Checks if means test required for patient and checks if means test
             display required for
             user's division.
             Returns 1 in 1st string if Both true :
             Otherwise 0
             If Both true, returns test in 2nd and 3rd string ( if any)
             }
  try
    FBroker.lstCALL(t);
    if t.count = 0 then
      begin
        code := -1;
        t[0] := 'The Attempt to determine Patient Means Test Status failed. Check VistA Error Log.';
        exit;
      end;
    code := strtoint(t[0]);
    t.delete(0);
  except
    on E: EXCEPTION do
      begin
        code := -1;
        t[0] := 'The Attempt to determine Patient Means Test Status failed. Failed. Check VistA Error Log.';
      end;
  end;
end;

procedure TMagDBMVista.RPDGSensitiveRecordBulletin(DFN: string);
begin
  {         DG SENSITIVITY RECORD BULLETIN
             Input parameter ACTION (send bulletin, set log, or both) will be
                     made optional with 'both' being the default value
             Input parameter DG1 (inpatient/outpatient status) will be removed

  PARAMETERS ARE 3 ? ( MIGHT HAVE CHANGED )
     1 = DFN   2 = Option name^Menu text (Optional)  3 =  Action (Optional)
               ACTION CODE 1  SET LOG
                           2  SEND BULLETIN
                           3  BOTH  ( DEFAULT )      }

  FBroker.PARAM[0].VALUE := DFN;
  FBroker.PARAM[0].PTYPE := LITERAL;
  Fbroker.remoteprocedure := 'DG SENSITIVE RECORD BULLETIN';
  FBroker.STRCALL;
  {TODO: who do we notify, if the attempt to log the access fails ? }
  {
  EXCEPT
  ON E: EXCEPTION DO
     begin
     result := false;
     IF (POS('<SUBSCRIPT>',E.MESSAGE) > 0 ) THEN xmsg := 'The Remote Procedure Call '+xbrokerx.remoteprocedure+' doesn''t exist on VISTA.  Please Call IRM'
                                           else xmsg := E.message;
     end;
  end;
  }

end;

{ TODO: Changed style of Broker Calls to be similiar in paramters.
  stat, xmsg, list, etc.  It will make it easier to have a single method that
  makes the Broker call and handles exceptions.  This would be much preferred
  over the current way, that has each Procedure or Function having it's own
  exception handler (or having none) }

procedure TMagDBMVista.RPDGSensitiveRecordAccess(DFN: string; var code: INTEGER; var t: TSTRINGLIST);
begin
  FBroker.PARAM[0].VALUE := DFN;
  FBroker.PARAM[0].PTYPE := LITERAL;
  Fbroker.remoteprocedure := 'DG SENSITIVE RECORD ACCESS';
  {
             DG SENSITIVE RECORD ACCESS
             Output value line 1 of RESULT will be made less granular
             -1 = RPC/API failed
             0 = No display or action required
             1 = Display warning message
             2 = Display warning message - require OK to continue
             3 = Display warning message - do not continue
             If the output value is 1 (display warning message) entry in DG SECURITY LOG file is automatically made; GUI application does not need to take action to log access

             DG SENSITIVITY RECORD BULLETIN
             Input parameter ACTION (send bulletin, set log, or both) will be made optional with 'both' being the default value
             Input parameter DG1 (inpatient/outpatient status) will be removed
  }
  try
    FBroker.lstCALL(t);
    if t.count = 0 then
      begin
        code := -1;
        t[0] := 'The Attempt to determine Patient sensitivity Failed. Check VistA Error Log.';
        exit;
      end;

    code := strtoint(t[0]);
    t.delete(0);
  except
    on E: EXCEPTION do
      begin
        code := -1;
        t[0] := 'The Attempt to determine Patient sensitivity Failed. Check VistA Error Log.';
      end;
  end;
end;

{ TODO : This needs changed to style of Broker Calls in magDBBroker. }

function TMagDBMVista.RPMaggPatBS5Chk(DFN: string; var t: tstringlist): boolean;
begin
  FBroker.PARAM[0].VALUE := DFN;
  FBroker.PARAM[0].PTYPE := LITERAL;
  Fbroker.remoteprocedure := 'MAGG PAT BS5 CHECK';
  {         Checks if More than one patient has Same Last Name and Last 4 of SSN
             It calls the Patient API  GUIBS5A^DPTLK6 to figure it out.
             Returns 1 in 1st string if more than 1 exist
             Otherwise 0
             }
  try
    FBroker.lstCALL(t);
    if t.count = 0 then
      begin
        result := true;
        exit;
      end;

    if t[0] = '0' then
      begin
        result := true;
        exit;
      end;

    t.delete(0);
    result := false;
  except
    on E: EXCEPTION do result := true
  end; ;

end;

{ TODO : This needs changed to style of Broker Calls in magDBBroker. }

function TMagDBMVista.RPMagPatLookup(STR: string; t: tstrings; var xmsg: string): boolean;
begin
  result := false;

  FBroker.PARAM[0].VALUE := STR;
  FBroker.PARAM[0].PTYPE := LITERAL;
  Fbroker.remoteprocedure := 'MAGG PAT FIND';
  try
    FBroker.LSTCALL(t);
   {SAHO,F 10/10/1920 123456789   NON-VETERAN(OTHER)^959}
    //i:= t.count     ;
    case t.count of
      0: xmsg := 'ERROR: Searching for ''' + str + ''' No response from VISTA.';
      1: xMsg := t[0];
    else begin
        xMsg := t[0];
        t.delete(0);
        result := true;
      end;
    end;
  except
    on E: EXCEPTION do
      begin
        result := false;
        if (POS('<SUBSCRIPT>', E.MESSAGE) > 0) then xmsg := 'The Remote Procedure Call ' + FBroker.remoteprocedure + ' doesn''t exist on VISTA.  Please Call IRM'
        else xmsg := E.message;
      end;
  end;
end;


{== RPMag4PatGetImages
 New Patch 8 call to return patient images based on filter.
 Filter : TImageFilter  ==}

procedure TMagDBMVista.RPMag4PatGetImages(var Fstat: boolean; var rpcmsg: string; DFN: string; var Flist: tstrings; filter: TImageFilter = nil);
var cls, pkg, types, spec, event: string;
  FrDt: string;
  ToDt: string;
  MthRange: integer;
  origin: string;
begin
//showmessage('in cMagDBMVista DB');
  cls := '';
  pkg := '';
  types := '';
  spec := '';
  event := '';
  FrDt := '';
  ToDt := '';
 // MthRange := 0;
  origin := '';
  if filter <> nil then
    begin
      cls := ClassesToString(filter.classes);
      pkg := PackagesToString(filter.packages);
      types := filter.Types;
      spec := filter.SpecSubSpec;
      event := filter.ProcEvent;
      FrDt := filter.FromDate;
      ToDt := filter.ToDate;
      MthRange := filter.MonthRange;
      if MthRange < 0 then
        begin
          frdt := formatdatetime('mm/dd/yyyy', incMonth(date, mthrange));
          todt := '';
        end;
      origin := filter.origin;
    end;
  with FBroker do
    begin
      param[0].Value := DFN;
      param[0].PType := literal;
      param[1].value := pkg;
      param[1].ptype := literal;
      param[2].value := cls;
      param[2].ptype := literal;
      param[3].value := types;
      param[3].ptype := literal;
      param[4].value := event;
      param[4].ptype := literal;
      param[5].value := spec;
      param[5].ptype := literal;
      Param[6].Value := FrDt;
      Param[6].ptype := literal;
      Param[7].Value := ToDt;
      Param[7].ptype := literal;
      Param[8].Value := origin;
      Param[8].PType := literal;
      Fbroker.remoteprocedure := 'MAG4 PAT GET IMAGES';
    end;
  try
    maggmsgf.MagMsg('s', 'DFN:' + DFN + ' Start RPC MAG4 PAT GET IMAGES' + formatdatetime('mm/mm@hh:nn:ss.zzz', now));
    Fbroker.lstCall(Flist);
    //demo create
    //flist.savetofile(ExtractFilePath(application.exename)+'\image\xMagDemoImageList'+DFN+'.TXT');
    maggmsgf.MagMsg('s', 'DFN:' + DFN + ' Done RPC MAG4 PAT GET IMAGES' + formatdatetime('mm/mm@hh:nn:ss.zzz', now));
    if (magpiece(Flist[0], '^', 1) = '0') then
      begin
        Fstat := false;
        rpcmsg := magpiece(Flist[0], '^', 2);
        exit;
      end;
    Fstat := true;
    rpcmsg := magpiece(Flist[0], '^', 2);
    Flist.delete(0);
  except
    on E: EXCEPTION do
      begin
        Flist.insert(0, '0^ERROR Accessing Patient Image list.');
        Fstat := false;
        rpcmsg := 'ERROR Accessing Patient Image list: ' + e.Message;
        Flist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;

end;

function TMagDBMVista.RPMaggGetPhotoIDs(xdfn: string; t: tstringlist): BOOLEAN;
begin
  try
    with FBroker do
      begin
        param[0].Value := XDFN;
        param[0].PType := literal;
        Fbroker.remoteprocedure := 'MAGG PAT PHOTOS';
        lstCall(t);
      end;
    if (t.count < 2) then result := false
    else
      begin
        result := true;
        t.delete(0);
      end;
  except
    result := false;
  end;
  //if (magpiece(t[0],'^',1) = 0 ) then result := false;
  //if (magpiece(t[0],'^',2) = 0 ) then result := false;
end;
 {'B2^618^\\isw-imggold\image1$\DM\00\06\DM000618.JPG^\\isw-imggold\image1$\DM\00\06\DM000618.ABS^PHOTO ID Apr 06, 2000^
                                      3000406.1701^18^PHOTO ID^04/06/2000^^M^A^^^1^.04^Unk^^^1023^GREEN,DEAN^ADMIN/CLIN^^^^'}
(*function TMagDBMVista.Connected : boolean;
begin
  if assigned(Fbroker) then
    result := Fbroker.Connected
  else result := false;
end; *)

function TMagDBMVista.DBConnect(vserver, vport: string; context: string = 'MAG WINDOWS'; accesscode: string = ''; verifycode: string = ''): boolean;
var SilentAccess, SilentVerify: string;
begin
  if not assigned(FBroker) then
    begin
      result := false;
      exit;
    end;

  if ((accesscode <> '') and (Verifycode <> '')) then
    begin
      Fbroker.AccessVerifyCodes := Accesscode + ';' + Verifycode;
    end ;
 (*gek  else if GetSilentCodes(Vserver, Vport, SilentAccess, SilentVerify) then
    begin
      Fbroker.AccessVerifyCodes := SilentAccess + ';' + SilentVerify;
    end; *)

  Fbroker.server := VServer;
  Fbroker.listenerPort := strtoint(VPort);
  try
    FBroker.connected := true;
    Result := FBroker.connected;

    if result then
      begin
        Fbroker.CreateContext(context);
      end;
  except
    on e: exception do
      begin
        maggmsgf.MagMsg('', e.Message);
        result := false;
      end;
  end;
end;


procedure TMagDBMVista.CreateMessageHistory;
begin
maggmsgf := Tmaggmsgf.create(nil);
end;


function TMagDBMVista.DBSelect(var vserver, vport: string; context: string = 'MAG WINDOWS'): boolean;
var SilentAccess, SilentVerify: string;
begin
  if not assigned(FBroker) then
    begin
      result := false;
      exit;
    end;
  try
    if not doesformexist('MAGGMSGF') Then CreateMessageHistory;
    if (GetServerInfo(VServer, VPort) = mrOK) then
      begin
        (*gek if GetSilentCodes(Vserver, Vport, SilentAccess, SilentVerify) then
          begin
            Fbroker.AccessVerifyCodes := SilentAccess + ';' + SilentVerify;
          end; *)
        Fbroker.server := VServer;
        Fbroker.listenerPort := strtoint(VPort);
        FBroker.connected := true;
        Result := FBroker.connected;
      end
    else
      result := false;
    if result then
      begin
        Fbroker.CreateContext(context);
      end;

  except
    on e: exception do
      begin
        maggmsgf.MagMsg('', e.Message);
        result := false;
      end;
  end;
end;

procedure TMagDBMVista.RPMaggImageDelete(var Fstat: boolean; var rmsg: string; var Flist: tstrings; IEN, ForceDel: string; reason: string = ''; GrpDelOK: boolean = false);
begin
  Fstat := false;
  rmsg := '';
  Flist.clear;
  FBroker.Param[0].Value := ien + '^' + ForceDel; { if ForceDel = '^1', then force delete, don't test for MAG DELETE KEY }
  FBroker.Param[0].PType := literal;
  FBroker.Param[1].Value := magBoolToStrInt(GrpDelOK);
  FBroker.Param[1].PType := literal;
  Fbroker.param[2].VAlue := reason;
  Fbroker.param[2].Ptype := literal;
  Fbroker.remoteprocedure := 'MAGG IMAGE DELETE';
  try
    FBroker.lstCall(Flist);

    if ((Flist[0] = '') or (Flist.count = 0)) then
      begin
        rmsg := 'Attempt to Delete Image Entry Failed. Broker Error on Vista System';
        Flist.insert(0, '0^' + rmsg);
        exit;
      end;
    if (magpiece(Flist[0], '^', 1) = '0') then
      begin
        rmsg := 'Attempt to Delete Image Entry Failed.';
        Flist.insert(0, '0^' + rmsg);
        exit;
      end;
    rmsg := 'Image Entry deleted: ' + ien;
    Flist.insert(0, '1^VistA Image Entry deleted: ' + ien);
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
        rmsg := magpiece(e.message, #$A, 2);
        Flist.Insert(0, '0^' + magpiece(e.message, #$A, 2));
      end;
  end; // try

end;

procedure TMagDBMVista.RPMag3TIUImage(var Fstat: boolean; var Flist: tstringlist; MagIEN, TIUDA: string);
begin
  Flist.clear;
  Fstat := false;
  Fbroker.remoteprocedure := 'MAG3 TIU IMAGE';
  FBroker.Param[0].Value := magien;
  FBroker.Param[0].PType := literal;
  FBroker.Param[1].Value := TIUDA;
  FBroker.Param[1].PType := literal;
  try
    FBroker.Call;

    Flist.assign(FBroker.Results);
    if ((magpiece(Flist[0], '^', 1) = '') or (magpiece(Flist[0], '^', 1) = '0'))
      then
      begin
        Flist.insert(0, '0^ERROR linking Image to TIU: ');
        exit;
      end;
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
        Flist.insert(0, '0^ERROR linking Image to TIU:');
        Flist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;

end;

procedure TMagDBMVista.RPMag4DataFromImportQueue(var Fstat: boolean; var Flist: tstringlist; QueueNum: string);
begin
  Flist.clear;
  FStat := false;
  Fbroker.Param[0].PType := literal;
  Fbroker.Param[0].Value := QueueNum;
  Fbroker.remoteprocedure := 'MAG4 DATA FROM IMPORT QUEUE';
  // GETARR^MAGGSIUI
  try
    Fbroker.lstcall(Flist);
    if (magpiece(Flist[0], '^', 1) = '0') then exit;
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Flist.insert(0, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;
end;

procedure TMagDBMVista.RPMag4RemoteImport(var Fstat: boolean; var Flist: tstringlist; DataArray: Tstringlist);
var I: integer;
begin
  Fstat := false;
  Fbroker.Param[0].PType := list;
  Fbroker.Param[0].Value := '.x';
  for I := 0 to DataArray.count - 1 do Fbroker.Param[0].Mult['' + inttostr(i) + ''] := DataArray[i];
  Fbroker.remoteprocedure := 'MAG4 REMOTE IMPORT';
  try
    Fbroker.lstCall(Flist);
    if (magpiece(Flist[0], '^', 1) = '0') then exit;
    Fstat := true;

  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Flist.insert(0, '0^' + magpiece(e.message, #$A, 2));
        exit;
      end;
  end;

end;

procedure TMagDBMVista.RPMag4ValidateData(var Fstat: boolean;
  var Flist: tstringlist; t: tstringlist; rettype: string);
var I: integer;
begin
  Fstat := false;
  Fbroker.Param[0].PType := list;
  Fbroker.Param[0].Value := '.x';
  for I := 0 to t.count - 1 do Fbroker.Param[0].Mult['' + inttostr(i) + ''] := t[i];
  Fbroker.Param[1].Ptype := literal;
  Fbroker.Param[1].value := rettype;
  Fbroker.remoteprocedure := 'MAG4 VALIDATE DATA';
  try
    Fbroker.lstCall(Flist);
    if (magpiece(Flist[0], '^', 1) = '0') then exit;
    Fstat := true;

  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Flist.insert(0, '0^' + magpiece(e.message, #$A, 2));
        exit;
      end;
  end;

end;

procedure TMagDBMVista.RPMag4StatusCallback(t: tstrings; cb: string; DoStatusCB: boolean = true);
var I: integer;
begin
  if (cb = '') then exit;
  FBroker.Param[0].PType := list;
  FBroker.Param[0].Value := '.X';
  //FLoglist.insert(0,xmsg);
  //FLogList.insert(1,FTrkNum);
  //FLogList.insert(2,Qnum);
  for I := 0 to t.count - 1 do FBroker.Param[0].Mult['' + inttostr(i) + ''] := t[i];
  FBroker.param[1].Ptype := literal;
  FBroker.param[1].Value := cb;
  FBroker.Param[2].PType := literal;
  FBroker.param[2].Value := magbooltostrint(DoStatusCB);
  Fbroker.remoteprocedure := 'MAG4 STATUS CALLBACK';
  //MAG4 STATUS CALLBACK          STATUSCB^MAGGSIUI
  //STATUSCB(MAGRY,STATARR,TAGRTN)
  //        D @(TAGRTN_"(.STATARR)")
  try
    FBroker.Call;
  except
    //
  end;
end;

procedure TMagDBMVista.RPMag4AddImage(var Fstat: boolean; var Flist: tstringlist; t: tstringlist);
var I: integer;
begin
  Flist.clear;
  Fstat := false;
  Fbroker.Param[0].PType := list;
  Fbroker.Param[0].Value := '.x';
  for I := 0 to t.count - 1 do Fbroker.Param[0].Mult['' + inttostr(i) + ''] := t[i];
  //Fbroker.Param[1].Ptype := literal;
  //Fbroker.Param[1].value := '1';
  Fbroker.remoteprocedure := 'MAG4 ADD IMAGE';
  try
    Fbroker.lstCall(Flist);
    if (magpiece(Flist[0], '^', 1) = '0') then exit;
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
        Flist.Insert(0, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;
end;

procedure TMagDBMVista.RPMagABSJB(var Fstat: boolean; var Flist: tstringlist; CreatAbsIEN, JBCopyIEN: string);
begin
  FBroker.Param[0].Value := CreatAbsIEN + '^' + JBCopyIEN;
  FBroker.Param[0].PType := literal;
  Fbroker.remoteprocedure := 'MAG ABSJB';
  try
    FBroker.Call;
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
        Flist.add('0^' + magpiece(e.message, #$A, 2));
        FStat := false;
      end;
  end;
end;


function TMagDBMVista.GetBroker: TRPCBroker;
begin
  Result := FBroker;
end;

procedure TMagDBMVista.SetBroker(const Value: TRPCBroker);
begin
  FBroker := Value;
end;

(*gek function TMagDBMVista.GetSilentCodes(Vserver, Vport: string; var SilentAccess: string; var SilentVerify: string): boolean;
var t: tstrings;
var I: INTEGER;
begin
  result := false;
  if not fileexists('c:\winnt\system32\MySAVC.mag') then exit;
  t := Tstringlist.create;
  try
    t.LoadFromFile('c:\winnt\system32\MySAVC.mag');
    for I := 0 to t.count - 1 do
      begin
        if (pos(Vserver + ',' + Vport, t[i]) > 0) then
          begin
            silentaccess := magpiece(t[i], '^', 2);
            silentverify := magpiece(t[i], '^', 3);
            result := true;
          end;
      end;
  finally
    t.free;
  end;
end;  *)

procedure TMagDBMVista.RPMag4IAPIStats(var Fstat: boolean;
  var FList: tstrings; DtStart, DtEnd: string);
begin
  Fstat := false;
  Fbroker.Param[0].PType := literal;
  Fbroker.Param[0].Value := DtStart;
  Fbroker.Param[1].PType := literal;
  Fbroker.Param[1].Value := DtEnd;
  //Fbroker.Param[2].Ptype := literal;
  //Fbroker.Param[2].value := rettype;
  Fbroker.remoteprocedure := 'MAG4 IAPI STATS';
  try
    Fbroker.lstCall(Flist);
    if (magpiece(Flist[0], '^', 1) = '0') then exit;
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Flist.insert(0, '0^' + magpiece(e.message, #$A, 2));
        exit;
      end;
  end;

end;

(*procedure TMagDBMVista.RPMag4PostProcessing(var Fstat: boolean;
  var Flist: tstringlist; Magien: string);
begin
  Fstat := false;
  Fbroker.Param[0].PType := literal;
  Fbroker.Param[0].Value := Magien;
  Fbroker.remoteprocedure := 'MAG4 POST PROCESSING';
  try
    Fbroker.lstCall(Flist);
    if (magpiece(Flist[0], '^', 1) = '0') then exit;
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Flist.insert(0, '0^' + magpiece(e.message, #$A, 2));
        exit;
      end;
  end;

end;
  *)
procedure TMagDBMVista.RPMag3LookupAny(var Fstat: boolean; var fmsg: string; var Flist: tstringlist; InputString: string);
begin
  Fstat := false;
  Fbroker.Param[0].PType := literal;
  Fbroker.Param[0].Value := inputstring;
  Fbroker.remoteprocedure := 'MAG3 LOOKUP ANY';
  try
    Fbroker.lstCall(Flist);
    if (magpiece(Flist[0], '^', 1) = '0') then
      begin
        fmsg := magpiece(flist[0], '^', 2);
        exit;
      end;
    Fstat := true;
  //  flist.delete(0);
  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Flist.insert(0, e.message);
        fmsg := e.message;
        exit;
      end;
  end;

end;

procedure TMagDBMVista.RPMag4PostProcessActions(var Fstat: boolean;
  var Flist: tstringlist; Magien: string);
begin
  Fstat := false;
  Fbroker.Param[0].PType := literal;
  Fbroker.Param[0].Value := Magien;
  Fbroker.remoteprocedure := 'MAG4 POST PROCESS ACTIONS';
  try
    Fbroker.lstCall(Flist);
    if (magpiece(Flist[0], '^', 1) = '0') then exit;
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Flist.insert(0, e.message);
        exit;
      end;
  end;

end;

procedure TMagDBMVista.RPMagPatInfo(var Fstat: boolean; var Fstring: string; MagDFN: string; isicn: boolean = false);
begin
  Fstat := false;
  Fbroker.Param[0].PType := literal;
  Fbroker.Param[0].Value := MagDFN;
  (*
   enable this parameter in Version 41 CCOW
          FBroker.Param[1].Ptype := literal;
          FBroker.Param[1].Value := magbooltostrint(isicn);
  *)
  Fbroker.remoteprocedure := 'MAGG PAT INFO';
  try
    Fstring := Fbroker.strCall;
    if (magpiece(Fstring, '^', 1) = '0') then exit;
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Fstring := '0^' + magpiece(e.message, #$A, 2);
        exit;
      end;
  end;

end;

(*procedure TMagDBMVista.RPMagIndexType(var Fstat: boolean; var Flist: tstringlist; MagDFN: string);
begin
  Fstat := false;
  Fbroker.Param[0].PType := literal;
  Fbroker.Param[0].Value := MagDFN;
  Fbroker.remoteprocedure := 'MAG4 INDEX GET TYPE';
  try
    Fbroker.lstCall(Flist);
    if (magpiece(Flist[0], '^', 1) = '0') then exit;
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Flist.insert(0, '0^' + magpiece(e.message, #$A, 2));
        exit;
      end;
  end;

end;
  *)
procedure TMagDBMVista.RPIndexGetSpecSubSpec(lit: TStrings; cls: string = ''; proc: string = ''; ignoreStatus: boolean = false);
var t: tstrings;
  ign: string;
begin
  if ignorestatus then ign := '1'
  else ign := '';
  lit.clear;
  t := tstringlist.create;
  // We changed the value of the Constants magiclAdmin, and magiclClin
  // so this isn't needed. (we'll see)
  //if cls = magiclAdmin then cls :="ADMIN,ADMIN/CLIN";
  //if cls = magiclClin then cls :="CLIN,CLIN/ADMIN";
  Fbroker.remoteprocedure := 'MAG4 INDEX GET SPECIALTY';
  FBroker.Param[0].PType := literal;
  FBroker.Param[0].Value := cls;
  FBroker.Param[1].PType := literal;
  FBroker.Param[1].Value := proc;
  FBroker.Param[2].PType := literal;
  FBroker.Param[2].Value := ign;

  try
    FBroker.lstcall(t);
    //demo create    MagDemoIndexSpec
    //t.SaveToFile(ExtractFilepath(application.exename)+ '\image\MagDemoIndexSpec.txt');
    if (t.count = 0) then
      begin
        lit.add('<Error loading ''Specialty'' list>');
      //oot 6/18/02 maggmsgf.magmsg('', 'Error loading Index Specialty', nullpanel);
        exit;
      end;

  except
    on e: exception do
      begin
        lit.add('<Exception loading ''Specialty'' list>');
      //oot 6/18/02      maggmsgf.magmsg('', 'Exception loading Index Specialty', nullpanel);
        exit;
      end;
  end;
  t.delete(0);
  lit.AddStrings(t);
  t.free;
end;

procedure TMagDBMVista.RPIndexGetEvent(lit: TStrings; cls: string = ''; spec: string = ''; ignoreStatus: boolean = false);
var t: tstrings;
  ign: string;
begin
  if ignorestatus then ign := '1'
  else ign := '';
  lit.clear;
  t := tstringlist.create;
  // We changed the value of the Constants magiclAdmin, and magiclClin
  // so this isn't needed. (we'll see)
  //if cls = magiclAdmin then cls :="ADMIN,ADMIN/CLIN";
  //if cls = magiclClin then cls :="CLIN,CLIN/ADMIN";

  Fbroker.remoteprocedure := 'MAG4 INDEX GET EVENT';

  FBroker.Param[0].PType := literal;
  FBroker.Param[0].Value := cls;
  FBroker.Param[1].PType := literal;
  FBroker.Param[1].Value := spec;
  FBroker.Param[2].PType := literal;
  FBroker.Param[2].Value := ign;

  try
    FBroker.lstcall(t);
    //demo create    MagDemoIndexEvent
    //t.SaveToFile(ExtractFilepath(application.exename)+ '\image\MagDemoIndexEvent.txt');
    if (t.count = 0) then
      begin
        lit.add('<Error loading ''Events'' list>');
      //oot 6/18/02    maggmsgf.magmsg('', 'Error loading Index Events', nullpanel);
        exit;
      end;

  except
    on e: exception do
      begin
        lit.add('<Exception loading ''Events'' list>');
      //oot 6/18/02 maggmsgf.magmsg('', 'Exception loading Index Events', nullpanel);
        exit;
      end;
  end;
  t.delete(0);
  lit.AddStrings(t);
  t.free;
end;

procedure TMagDBMVista.RPIndexGetType(lit: TStrings; cls: string; ignoreStatus: boolean = false);
var t: tstrings;
  xmsg: string;
  ign: string;
begin
  if ignorestatus then ign := '1'
  else ign := '';
  if not CheckDBConnection(xmsg) then raise Exception.Create(xmsg);
  lit.clear;
  t := tstringlist.create;
  // We changed the value of the Constants magiclAdmin, and magiclClin
  // so this isn't needed. (we'll see)
  //if cls = magiclAdmin then cls :="ADMIN,ADMIN/CLIN";
  //if cls = magiclClin then cls :="CLIN,CLIN/ADMIN";
  Fbroker.remoteprocedure := 'MAG4 INDEX GET TYPE';
  FBroker.Param[0].PType := literal;
  FBroker.Param[0].Value := Uppercase(cls);
  FBroker.Param[1].PType := literal;
  FBroker.Param[1].Value := ign;

  try
    FBroker.lstcall(t);
    //demo create      MagDemoIndexType+(class)
    //t.SaveToFile(ExtractFilepath(application.exename)+ '\image\MagDemoIndexType'+magpiece(cls,',',1)+'.txt');
    if (t.count = 0) then
      begin
        lit.add('<Error loading ''Type'' list>');
      //oot 6/18/02       maggmsgf.magmsg('', 'Error loading Index Types', nullpanel);
        exit;
      end;

  except
    on e: exception do
      begin
        lit.add('<Exception loading ''Type'' list>');
      //oot 6/18/02       maggmsgf.magmsg('', 'Exception loading Index Types', nullpanel);
        exit;
      end;
  end;
  t.delete(0);
  lit.AddStrings(t);
  t.free;
end;

procedure TMagDBMVista.RPLogCopyAccess(s: string);
var ret: string;
begin

  FBroker.param[0].ptype := literal;
  FBroker.param[0].value := s;
  Fbroker.remoteprocedure := 'MAGGACTION LOG';
  ret := FBroker.STRCALL;
  { TODO : This and other functions have to be able to log messages. }
   // if copy(ret, 1, 1) <> '1' then MaggMsgf.magmsg('', 'Error logging action ' + magpiece(st, '^', 2), nilpanel);

end;
// 01/21/03   msg => changed to xmsg  (msg is a function)

function TMagDBMVista.RPVerifyEsig(esig: string; var xmsg: string): boolean;
var s: string;
begin
  esig := encrypt(esig);
  FBroker.param[0].ptype := literal;
  FBroker.param[0].value := esig;
  Fbroker.remoteprocedure := 'MAGG VERIFY ESIG';
  s := FBroker.strcall;
  xmsg := magpiece(s, '^', 2);
  result := (copy(s, 1, 1) <> '0');
end;

procedure TMagDBMVista.RPMagGetUserPreferences(var Fstat: boolean;
  var rpcmsg: string; xlist: Tstringlist; code: string = '');
begin
  Fstat := true;
  Fbroker.remoteprocedure := 'MAGGUPREFGET';
  //WinMsg('', 'Applying View preferences...');
  if code <> '' then
    begin
      FBroker.Param[0].PType := literal;
      FBroker.Param[0].Value := code;
    end;
  try
    FBroker.lstcall(xlist);
    //demo create    xMagDemoPref+(node)
    //xlist.SaveToFile(ExtractFilepath(application.exename)+ '\image\xMagDemoPref'+code+'.txt');
    if xlist.count < 2 then
      begin
        fstat := false;
        rpcmsg := 'Can''t Access User Preferences. Using defaults.';
      //WinMsg('', 'Can''t Access View Preferences, using System defaults.');
      //messagebeep(0);
        exit;
      end;
    xlist.DELETE(0);
  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        rpcmsg := e.message;
        Fstat := false;
      end;
  end;
end;

procedure TMagDBMVista.RPMagSetUserPreferences(var Fstat: boolean; var rpcmsg: string; xlist: Tstrings);
var i: integer;
  fld: string;
  data: string;
begin
  Fstat := true;
  if not FBroker.CONNECTED then
    begin

      rpcmsg := 'Save User preferences canceled.  No connection to VistA.';
      messagebeep(0);
      exit;
    end;
  //LOGACTIONS('MAIN', 'SAVESETTINGS', DUZ);
  for I := 0 to xlist.Count - 1 do
    begin
      fld := magpiece(xlist[i], '|', 1);
      data := magpiece(xlist[i], '|', 2);
      Fbroker.Param[0].Mult['' + fld + ''] := data;
    end;
  Fbroker.remoteprocedure := 'MAGGUPREFSAVE';
  FBroker.Param[0].Value := '.X';
  FBroker.Param[0].PType := list;

  try
    FBroker.call;
    if FBroker.Results[0] = '' then
      begin
        Fstat := false;
        rpcmsg := 'The Attempt to save User Preferences Failed. Check VistA Error Log.';

        exit;
      end;
    rpcmsg := magpiece(Fbroker.Results[0], '^', 2);
  except
    on E: EBrokerError do showmessage('Error Communicating with VistA : ' + e.message);
    on E: Exception do showmessage('An Error occured while connecting to VistA' + #13 + 'Setting were not saved.' + #13 + E.Message);

  else
    showmessage('UnKnown Error while Saving Settings.');
  end;

end;

procedure TMagDBMVista.RPMag4GetImageInfo(magien: string; var Flist: Tstrings);
begin
  Fbroker.remoteprocedure := 'MAG4 GET IMAGE INFO';
  FBroker.param[0].ptype := literal;
  FBroker.param[0].value := magien;
  try
    FBroker.lstcall(flist);
    if Flist.count = 0 then
      begin
        Flist.Add('Error: Accessing Image Information');
        Flist.add('    for Image ID# ' + magien);
        exit;
      end;
  except
    on E: EXCEPTION do
      begin
      // magpiece(E.message, #$A, 3)
        Flist.Insert(0, e.message);
      end;
  end;
end;

procedure TMagDBMVista.RPImageReport(var Fstat: boolean; var Fmsg: string; Flist: tstrings; IObj: TImageData; noQACheck : boolean = false);
begin
  Flist.clear;
  Fstat := false;
  FBroker.Param[0].Value := IObj.Mag0 + '^';
  FBroker.Param[0].PType := literal;
  FBroker.Param[1].Value := magBoolToStrInt(noQACheck);
  FBroker.Param[1].PType := literal;
  Fbroker.remoteprocedure := 'MAGGRPT';
  //maggmsgf.magmsg('', 'Building Image Report...', nilpanel);
  //FBroker.lstcall(t);

  //Fbroker.remoteprocedure := 'MAG3 TIU IMAGE';
  //FBroker.Param[0].Value := magien;
  //FBroker.Param[0].PType := literal;
  //FBroker.Param[1].Value := TIUDA;
  //FBroker.Param[1].PType := literal;
  try
    FBroker.Call;
    if FBroker.Results.count = 0 then
      begin
        fmsg := 'Report Failed for Image ID #: ' + IObj.Mag0;
        Flist.insert(0, '0^ERROR Building Image Report: ');
        Flist.add(' Report Failed for Image ID #: ' + IObj.Mag0);
        Flist.Add('Check VISTA Error Log.');
      //maggmsgf.magmsg('DE', ': The Attempt to build the Image report Failed. Check VISTA Error Log.', nilpanel);
      //maggmsgf.magmsg('s', ' Report Failed for Image IEN: '+ien,nilpanel);
      //maggmsgf.magmsg('', '', nilpanel);
        exit;
      end;

    Flist.assign(FBroker.Results);
    if (magpiece(Flist[0], '^', 1) = '')
      then
      begin
        fmsg := 'Report Failed for Image ID #: ' + IObj.Mag0;
        Flist.insert(0, '0^ERROR Building Image Report: ');
        exit;
      end;
    if (magpiece(Flist[0], '^', 1) = '0')
      then
      begin
        fmsg := magpiece(Flist[0], '^', 2);
        exit;
      end;
    fmsg := magpiece(Flist[0], '^', 2);
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
        Flist.insert(0, '0^EXCEPTION Building Image Report:');
        Flist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;

end;

(*procedure TMagDBMVista.RPMagGetImageReport(var Fstat: boolean; var Fmsg: string; Flist: tstrings; magien: string);
begin
  Flist.clear;
  Fstat := false;
  FBroker.Param[0].Value := magien + '^';
  FBroker.Param[0].PType := literal;
  Fbroker.remoteprocedure := 'MAGGRPT';
  //maggmsgf.magmsg('', 'Building Image Report...', nilpanel);
  //FBroker.lstcall(t);

  //Fbroker.remoteprocedure := 'MAG3 TIU IMAGE';
  //FBroker.Param[0].Value := magien;
  //FBroker.Param[0].PType := literal;
  //FBroker.Param[1].Value := TIUDA;
  //FBroker.Param[1].PType := literal;
  try
    FBroker.Call;
    if FBroker.Results.count = 0 then
      begin
        fmsg := 'Report Failed for Image ID #: ' + magien;
        Flist.insert(0, '0^ERROR Building Image Report: ');
        Flist.add(' Report Failed for Image ID #: ' + magien);
        Flist.Add('Check VISTA Error Log.');
      //maggmsgf.magmsg('DE', ': The Attempt to build the Image report Failed. Check VISTA Error Log.', nilpanel);
      //maggmsgf.magmsg('s', ' Report Failed for Image IEN: '+ien,nilpanel);
      //maggmsgf.magmsg('', '', nilpanel);
        exit;
      end;

    Flist.assign(FBroker.Results);
    if (magpiece(Flist[0], '^', 1) = '')
      then
      begin
        fmsg := 'Report Failed for Image ID #: ' + magien;
        Flist.insert(0, '0^ERROR Building Image Report: ');
        exit;
      end;
    if (magpiece(Flist[0], '^', 1) = '0')
      then
      begin
        fmsg := magpiece(Flist[0], '^', 2);
        exit;
      end;
    fmsg := magpiece(Flist[0], '^', 2);
    Fstat := true;
  except
    on E: EXCEPTION do
      begin
        Flist.insert(0, '0^EXCEPTION Building Image Report:');
        Flist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;

end;  *)

function TMagDBMVista.CheckDBConnection(var xmsg: string): boolean;
begin
  result := true;
  if not assigned(FBroker)
    then
    begin
      xmsg := 'You must Login to VistA to procede.';
   // xmsg := 'DataBase Component isn''t assigned to a DataBase.'+#13+
   //            'An error in software has occured. Call IRM.';
      result := false;
    end;
  if (assigned(FBroker)) and (not FBroker.Connected)
    then
    begin
      xmsg := 'You must Login to VistA to procede.';
      result := false;
    end;
  if not result
    then
    messagedlg(xmsg, mtWarning, [mbok], 0);

end;

function TMagDBMVista.RPMag4GetFileFormatInfo(ext: string; var xmsg: string): boolean;
var t: tstrings;
begin
  t := tstringlist.create;
  Fbroker.remoteprocedure := 'MAG4 GET FILE FORMAT INFO';
  FBroker.Param[0].PType := literal;
  FBroker.Param[0].Value := ext;


  try
    FBroker.lstcall(t);
    if (t.count = 0) then
      begin
        result := false;
        xmsg := 'Error Getting File Type info for ' + ext;
        exit;
      end;
    xmsg := t[1];
    result := true;
  except
    on e: exception do
      begin
        result := false;
        xmsg := 'Exception Getting File Type info for ' + ext;
      end;
  end;

end;
 ///////////// started converting remainder of calls in frmMain
 ////////////  that called xBrokerx, to call MagDBBroker.

procedure TMagDBMVista.RPMaggImageInfo(var rstat: boolean; var rmsg: string; var rlist: tstrings; ien: string; noQAcheck : boolean = false);
begin
  rstat := false;
  with FBroker do
    begin
      param[0].Value := ien;
      param[0].PType := literal;
      Param[1].Value := magBoolToStrInt(noQACheck);
      Param[1].PType := literal;
      Fbroker.remoteprocedure := 'MAGG IMAGE INFO';
    end;
  try
    Fbroker.lstCall(rlist);
    if (magpiece(rlist[0], '^', 1) = '0') or (rlist.count = 0) then
      begin
        rstat := false;
        if rlist.count > 0 then rmsg := magpiece(rlist[0], '^', 2)
        else rmsg := 'ERROR in VistA operation canceled.';
        exit;
      end;
    rstat := true;
    rmsg := rlist[0];
    rlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        rlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        rlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;

end;

procedure TMagDBMVista.RPMaggRadExams(var rstat: boolean; var rmsg: string; var rlist: tstrings; DFN: string);
begin
  rstat := false;
  with FBroker do
    begin
      param[0].Value := DFN + '^1';
      param[0].PType := literal;
      Fbroker.remoteprocedure := 'MAGGRADLIST';
    end;
  try
    Fbroker.lstCall(rlist);
    if (magpiece(rlist[0], '^', 1) = '0') or (rlist.count = 0) then
      begin
        if rlist.count > 0 then rmsg := magpiece(rlist[0], '^', 2)
        else rmsg := 'ERROR Compiling Rad Exam list.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(rlist[0], '^', 2);
   // rlist.delete(0);
    if strtoint(magpiece(rlist[0], '^', 1)) > 0 then rmsg := magpiece(rlist[0], '^', 1) + ' ' + rmsg;


  except
    on E: EXCEPTION do
      begin
        rlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        rlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;
end;


//RPMaggCPRSRadExam(rstat,rmsg,rlist,cprsstring);

procedure TMagDBMVista.RPMaggCPRSRadExam(var rstat: boolean; var rmsg: string; var rlist: tstrings; cprsstring: string);
begin
  rstat := false;
  with FBroker do
    begin
      param[0].Value := cprsstring;
      param[0].PType := literal;
      Fbroker.remoteprocedure := 'MAGG CPRS RAD EXAM';
    end;
  try
    Fbroker.lstCall(rlist);
    if (magpiece(rlist[0], '^', 1) = '0') or (rlist.count = 0) then
      begin
        rstat := false;
        if rlist.count > 0 then rmsg := magpiece(rlist[0], '^', 2)
        else rmsg := 'ERROR in VistA operation canceled.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(rlist[0], '^', 2);
    //rlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        rlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        rlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;

end;


//RPMaggUser2(rstat,rmsg,rlist,WSID);

procedure TMagDBMVista.RPMaggUser2(var rstat: boolean; var rmsg: string; var rlist: tstrings; wsid: string);
begin
  rstat := false;
  with FBroker do
    begin
      param[0].Value := wsid;
      param[0].PType := literal;
      Fbroker.remoteprocedure := 'MAGGUSER2';
    end;
  try
    Fbroker.lstCall(rlist);
    //demo create     xMagDemoUser2
    //rlist.SaveToFile(ExtractFilepath(application.exename)+ '\image\xMagDemoUser2.txt');

    if (magpiece(rlist[0], '^', 1) = '0') or (rlist.count = 0) then
      begin
        rstat := false;
        if rlist.count > 0 then rmsg := magpiece(rlist[0], '^', 2)
        else rmsg := 'ERROR in VistA operation canceled.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(rlist[0], '^', 2);
    ////////rlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        rlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        rlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;

end;

    (*
    xBrokerx.param[0].ptype := literal;
    xBrokerx.param[0].value := WSID;
    //RPMaggUser2(var Fstat: boolean; var Flist: tstringlist; CompName: string; var vServer: string; tPort: string);

    xBrokerx.remoteprocedure := 'MAGGUSER2';
    xBrokerx.call;
    *)


procedure TMagDBMVista.RPMaggDGRPD(var rstat: boolean; var rmsg: string; var rlist: tstringlist; dfn: string);
begin
  rstat := false;
  with FBroker do
    begin
      param[0].Value := dfn;
      param[0].PType := literal;
      Fbroker.remoteprocedure := 'MAGGDGRPD';
    end;
  try
    Fbroker.lstCall(rlist);
    //demo create
    //rlist.savetofile(ExtractFilePath(application.exename)+'\image\MagDemoPatientProfile'+DFN+'.TXT');

    if (magpiece(rlist[0], '^', 1) = '0') or (rlist.count = 0) then
      begin
        rstat := false;
        if rlist.count > 0 then rmsg := magpiece(rlist[0], '^', 2)
        else rmsg := 'ERROR in VistA operation canceled.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(rlist[0], '^', 2);
    rlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        rlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        rlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;

end;




//RPMaggRadImage(rstat,rmsg,t,radstring);

procedure TMagDBMVista.RPMaggRadImage(var rstat: boolean; var rmsg: string; var tlist: tstringlist; radstring: string);
begin
  rstat := false;
  with FBroker do
    begin
      param[0].Value := radstring;
      param[0].PType := literal;
      Fbroker.remoteprocedure := 'MAGGRADIMAGE';
    end;
  try
    Fbroker.lstCall(tlist);
    if (magpiece(tlist[0], '^', 1) = '0') or (tlist.count = 0) or
      (magpiece(tlist[0], '^', 1) = '-2') then
      begin
        rstat := false;
        if tlist.count > 0 then rmsg := magpiece(tlist[0], '^', 2)
        else rmsg := 'ERROR in VistA operation canceled.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(tlist[0], '^', 2);
   // tlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        tlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        tlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;




(*
    xBrokerx.param[0].value := radstring;
    xBrokerx.param[0].ptype := literal;
    xBrokerx.rem oteprocedure := 'MAGGRADIMAGE';
    xBrokerx.LSTCALL(t);
    if t.count = 0 then
    begin
      WinMsg('DE', ': The Attempt to access the Image list for selected exam Failed.' +
        '  Check VistA Error Log.');
      WinMsg('s', 'Rad Report info: ' + sysradstring);
      exit;
    end;
    if magpiece(t[0], '^', 1) = '0' then
    begin
      WinMsg('DE', magpiece(t[0], '^', 2));
      WinMsg('s', 'Rad Report info: ' + sysradstring);
      exit;
    end;
    if magpiece(t[0], '^', 1) = '-2' then //Patch 5
    begin
      WinMsg('DEQA', magpiece(t[0], '^', 2));
      WinMsg('s', 'Rad Report info: ' + sysradstring);
      exit;
    end;
*)

end;
//dmod.MagDBBroker1.RPMaggRadReport(rstat,rmsg,t,RARPT);

procedure TMagDBMVista.RPMaggRadReport(var rstat: boolean; var rmsg: string; var tlist: tstringlist; rarpt: string);
begin
  rstat := false;
  with FBroker do
    begin
      param[0].Value := rarpt;
      param[0].PType := literal;
      Fbroker.remoteprocedure := 'MAGGRADREPORT';
    end;
  try
    Fbroker.lstCall(tlist);
    if (magpiece(tlist[0], '^', 1) = '0') or (tlist.count = 0) or
      (magpiece(tlist[0], '^', 1) = '-2') then
      begin
        rstat := false;
        if tlist.count > 0 then rmsg := magpiece(tlist[0], '^', 2)
        else rmsg := 'ERROR in VistA. Operation canceled.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(tlist[0], '^', 2);
   // tlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        tlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        tlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;





(*    xBrokerx.Param[0].Value := RARPT;
    xBrokerx.Param[0].PType := literal;
    xBrokerx.remoteprocedure := 'MAGGRADREPORT';
    WinMsg('', 'Building Radiology Exam Report...');
    xBrokerx.lstcall(t);
    if t.count = 0 then
    begin
      WinMsg('DE', ': The Attempt to build Radiology Exam report Failed. Check VistA Error Log.');
      Winmsg('s', 'Failed RARPT : ' + RARPT);
      WinMsg('', '');
      exit;
    end;
    if (magpiece(t[0], '^', 1) = '-2') then //Patch 5
    begin
      WinMsg('DEQA', magpiece(t[0], '^', 2) + '   ' + daycase);
      Winmsg('s', 'Failed RARPT : ' + RARPT);
      exit;
    end;
    if (magpiece(t[0], '^', 1) = '0') then
    begin
      WinMsg('DE', magpiece(t[0], '^', 2) + '   ' + daycase);
      Winmsg('s', 'Failed RARPT : ' + RARPT);
      exit;
    end
    else
  *)


end;

procedure TMagDBMVista.RPMaggHSList(var rstat: boolean; var rmsg: string; var tlist: tstringlist; value: string);
begin
  rstat := false;
  with FBroker do
    begin
      param[0].Value := value;
      param[0].PType := literal;
      Fbroker.remoteprocedure := 'MAGGHSLIST';
    end;
  try
    Fbroker.lstCall(tlist);
    //demo create
    //Tlist.savetofile(ExtractFilePath(application.exename)+'\image\MagDemoHSList.TXT');

    if (magpiece(tlist[0], '^', 1) = '0') or (tlist.count = 0) then
      begin
        rstat := false;
        if tlist.count > 0 then rmsg := magpiece(tlist[0], '^', 2)
        else rmsg := 'ERROR in VistA operation canceled.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(tlist[0], '^', 2);
    tlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        tlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        tlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;
end;


procedure TMagDBMVista.RPMaggHS(var rstat: boolean; var rmsg: string; var tlist: tstringlist; value: string);
begin
  rstat := false;
  with FBroker do
    begin
      param[0].Value := value;
      param[0].PType := literal;
      Fbroker.remoteprocedure := 'MAGGHS';
    end;
  try
    Fbroker.lstCall(tlist);
    //demo create
    //tlist.savetofile(ExtractFilePath(application.exename)+'\image\MagDemoHSReport-'+magpiece(value,'^',2)+'.TXT');
    if (magpiece(tlist[0], '^', 1) = '0') or (tlist.count = 0) then
      begin
        rstat := false;
        if tlist.count > 0 then rmsg := magpiece(tlist[0], '^', 2)
        else rmsg := 'ERROR: Health Summary Failed. Check VISTA Error Log.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(tlist[0], '^', 2);
    tlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        tlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        tlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;
(*
  try
    xBrokerx.PARAM[0].VALUE := PATDFN.CAPTION + '^' + XST;
    xBrokerx.PARAM[0].PTYPE := LITERAL;
    xBrokerx.remoteprocedure := 'MAGGHS';
    xBrokerx.lstcall(t);
    if t.count = 0 then
    begin
      Maggmsgf.MagMsg('de', 'Failed to build Patient Health Summary. Check VISTA Error Log.', msg);
      MaggMsgf.magmsg('e', 'ERROR: Health Summary Failed. Check VISTA Error Log.', msg);
      exit;
    end;
    if magpiece(t[0], '^', 1) = '0' then Maggmsgf.MagMsg('', magpiece(t[0], '^', 2), msg);
    if magpiece(t[0], '^', 1) <> '0' then begin
      t.delete(0);
*)
end;

(*
procedure TMagDBMVista.RPMag...(var rstat: boolean; var rmsg: string; var rlist: tstrings; xxx : string);
var yyy : string;
begin
 rstat := false;
  with FBroker do
  begin
    Param[0].PType := list;
    Param[0].Value := '.x';

    param[0].Value := ;
    param[0].PType := ;
    param[1].value := ;
    param[1].ptype := ;

   Fbroker.remoteprocedure := 'MAG......';
  end;
  try
    Fbroker.lstCall(rlist);
    if (magpiece(rlist[0], '^', 1) = '0') or (rlist.count = 0) then
    begin
      rstat := false;
      if rlist.count > 0 then rmsg := magpiece(rlist[0], '^', 2)
                         else rmsg := 'ERROR in VistA operation canceled.';
      exit;
    end;
    rstat := true;
    rmsg := magpiece(rlist[0], '^', 2);
    rlist.delete(0);
  except
    on E: EXCEPTION do
    begin
      rlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
      rstat := false;
      rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
      rlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
    end;
  end;

end;
*)

procedure TMagDBMVista.RPGetFileExtensions(var t: tstrings);
begin
  Fbroker.remoteprocedure := 'MAG4 GET SUPPORTED EXTENSIONS';
  try
    FBroker.lstcall(t);
  except
    on E: exception do
      begin
        t.insert(0, '0^Error: Getting supported Extensions.');
        maggmsgf.magmsg('de', 'VistA Error: ' + magpiece(e.message, #$A, 2));
      end;
  end;
end;

procedure TMagDBMVista.RPUpdateConsult(consult, tiuien, cmpflag: string; var status: string);
begin
  Fbroker.remoteprocedure := 'MAG4 CP UPDATE CONSULT';
  FBroker.Param[0].ptype := literal;
  FBroker.Param[0].value := consult;

  FBroker.Param[1].ptype := literal;
  FBroker.Param[1].value := tiuien;
  FBroker.Param[2].ptype := literal;
  FBroker.Param[2].value := cmpflag;
  try
    status := FBroker.strcall;
  except
    on E: EXCEPTION do
      begin
        status := '0^VistA Error';
        maggmsgf.magmsg('de', 'VistA Error: ' + magpiece(e.message, #$A, 2));
      end;
  end;
end;

function TMagDBMVista.RPTIUCPClass: integer;
var s: string;
begin
  Fbroker.remoteprocedure := 'TIU IDENTIFY CLINPROC CLASS';
  try
    s := FBroker.strcall;
    result := strtoint(s);
  except
    on E: EXCEPTION do
      begin
        messagedlg('VistA Error: ' + magpiece(e.message, #$A, 2), mtconfirmation,
          [mbok], 0);
        result := 0;
      end;
  end;
end;

function TMagDBMVista.RPTIUConsultsClass: integer;
var s: string;
begin
  Fbroker.remoteprocedure := 'TIU IDENTIFY CONSULTS CLASS';
  try
    s := FBroker.strcall;
    result := strtoint(s);
  except
    on E: EXCEPTION do
      begin
        messagedlg('VistA Error: ' + magpiece(e.message, #$A, 2), mtconfirmation,
          [mbok], 0);
        result := 0;
      end;
  end;
end;

procedure TMagDBMVista.RPMagLogErrorText(T: Tstrings; COUNT: INTEGER);
var I, j: integer;

begin
  I := t.count;
  if (i < count) then count := i;
  Fbroker.remoteprocedure := 'MAGG LOG ERROR TEXT';
  FBroker.Param[0].Value := '.X';
  FBroker.Param[0].PType := list;

  for j := 1 to count do
    begin
      dec(i);
    //xBrokerx.Param[3].Mult['"TEXT'+','+INTTOSTR(I+1)+',0"']:=NOTETEXT[I];
      FBroker.Param[0].Mult[('"TEXT' + COPY('000', 1, 3 - LENGTH(INTTOSTR(I))) + IntToStr(i) + '"')] := t[i];
    end;

  FBroker.call;

end;

procedure TMagDBMVista.RPMagGetNetLoc(var success: boolean; var RPmsg: string; var Shares: TStringList; NetLocType: string);
begin
  (* Get all network locations and their properties *)
  success := false;
  try
    FBroker.PARAM[0].VALUE := NetLocType;
    FBroker.PARAM[0].PTYPE := LITERAL;
    Fbroker.remoteprocedure := 'MAG GET NETLOC';
    FBroker.lstCall(Shares);
    if (magpiece(Shares[0], '^', 1) = '0') then
      begin
        maggmsgf.MagMsg('', magpiece(Shares[0], '^', 2));
        RPmsg := Shares[0];
        exit;
      end;
    if (Shares.count = 0) then
      begin
        maggmsgf.MagMsg('', 'Error accessing Network Locations');
        RPmsg := 'Error accessing Network Locations ';
        exit;
      end;
    success := true;
    RPmsg := Shares[0];
    Shares.delete(0);

  except
    on E: EXCEPTION do
      begin
        showmessage(e.message);
        Shares[0] := 'The Attempt to get network locations. Check VistA Error Log.';
      end;
  end;

end;

function TMagDBMVista.RPMagEkgOnline: integer;
begin
  (* get the status of the first EKG server 0=offline 1=online - if no server exists 0 is returned *)
  Fbroker.remoteprocedure := 'MAG EKG ONLINE';
  result := StrToInt(FBroker.strcall);

end;

procedure TMagDBMVista.RPMaggOffLineImageAccessed(IObj: TImageData);
begin
  with FBroker do
    begin
      if not CONNECTED then EXIT;
      Fbroker.remoteprocedure := 'MAGG OFFLINE IMAGE ACCESSED';
      PARAM[0].PTYPE := LITERAL;
      PARAM[0].VALUE := IObj.Ffile;
      PARAM[1].PTYPE := LITERAL;
      PARAM[1].VALUE := IObj.mag0;
      CALL;
    end;
end;

(*
procedure ___________(magrecord : MagRecordPtr) ;
begin
with xBrokerx do
     begin
     If NOT CONNECTED THEN EXIT;
    Fbroker.remoteprocedure :=       ;
     PARAM[0].PTYPE :=   ----;
     PARAM[0].VALUE := -------;
     PARAM[1].PTYPE := -------;
     PARAM[1].VALUE := -----------  ;
     CALL;
     end;
END ;
*)

procedure TMagDBMVista.RPMag3Logaction(actionstring: string);
begin
  with FBroker do
    begin
      Param[0].VALUE := actionstring;
      param[0].ptype := literal;
      Fbroker.remoteprocedure := 'MAG3 LOGACTION';
      Call;
    end;
end;

procedure TMagDBMVista.RPMaggQueImage(IObj: TImageData);
begin
  with FBroker do
    begin
      Param[0].Value := 'AF';
      Param[0].PType := literal;
      Param[1].Value := IObj.mag0;
      Param[1].PType := literal;
      Fbroker.remoteprocedure := 'MAGG QUE IMAGE';
      maggmsgf.magmsg('s', '--RPC : MAGG QUE IMAGE ^AF^' + IObj.mag0);
      try
        call;
        maggmsgf.MagMsg('S', '--' + FBroker.RESULTS[0]);
      except
        messagedlg('Error attempting to set the Queue ' + #13 + 'to copy an Image from the Juke Box.'
          + #13 + 'Not Fatal, Process will continue.', mtwarning, [mbok], 0);
      end;
    end;
end;

procedure TMagDBMVista.RPMaggQueBigImage(IObj: TImageData);
begin
  with FBroker do
    begin
      Param[0].Value := 'B';
      Param[0].PType := literal;
      Param[1].Value := IObj.mag0;
      Param[1].PType := literal;
      Fbroker.remoteprocedure := 'MAGG QUE IMAGE';
      maggmsgf.magmsg('s', '--RPC : MAGG QUE IMAGE ^B^' + IObj.mag0);
      try
        call;
        maggmsgf.MagMsg('S', '--' + FBroker.RESULTS[0]);
      except
        messagedlg('Error attempting to set the Queue ' + #13 + 'to copy a BIG Image from the Juke Box.'
          + #13 + 'Not Fatal, Process will continue.', mtwarning, [mbok], 0);
      end;
    end;
end;
// Queue all images for a Patient to be copied from JukeBox to HD.

procedure TMagDBMVista.RPMaggQuePatient(whichimages, DFN: string);
var s: string;
begin
  { whichimages is a code of 'A' for abstract
                             'F' for Full }
  with FBroker do
    begin
      Param[0].VALUE := whichimages;
      param[0].ptype := literal;
      Param[1].VALUE := DFN;
      param[1].ptype := literal;
      Fbroker.remoteprocedure := 'MAGG QUE PATIENT';
      maggmsgf.magmsg('s', '--RPC : MAGG QUE PATIENT ^' + whichimages + '^' + dfn);
      S := strCall;
      maggmsgf.MagMsg('s', '--' + s);
    end;
end;
// Queue images to be Copied from JukeBox.
//  The RPC Call "M" code, determines if the iamges need to be queued.
//  and if true.  Makes the call to set the JBtoHD Queue.

procedure TMagDBMVista.RPMaggQueImageGroup(whichimages, MAGIEN: string);
var s: string;
begin
  { whichimages is a code of 'A' for abstract
                             'F' for Full }
  try
    with FBroker do
      begin
        Param[0].VALUE := whichimages;
        param[0].ptype := literal;
        Param[1].VALUE := MAGIEN;
        param[1].ptype := literal;
        Fbroker.remoteprocedure := 'MAGG QUE IMAGE GROUP';
        maggmsgf.magmsg('s', '--RPC : MAGG QUE IMAGE GROUP^' + whichimages + '^' + MAGIEN);
        S := strCall;
        maggmsgf.MagMsg('s', '--' + s);
      end;
  except
    //
  end;
end;
// Returns all images for an Image Group.

procedure TMagDBMVista.RPMaggGroupImages(IObj: TImageData; var t: tstringlist; noQAcheck: boolean = false);
begin
  with FBroker do
    begin
      param[0].value := IObj.Mag0;
      param[0].ptype := literal;
      param[1].Value := magBoolToStrInt(noQAcheck);
      param[1].PType := literal;
      Fbroker.remoteprocedure := 'MAGG GROUP IMAGES'; //MAGOGLU';
      lstcall(t);
    end;
end;


// Gets all images for a patient.  Groups are returned as one item.
//   Single images are returned as one item.
(*
procedure TMagDBMVista.RPMaggPatImages(DFN: string; var t: tstringlist);
begin
  with FBroker do
    begin
      param[0].Value := DFN;
      param[0].PType := literal;
      Fbroker.remoteprocedure := 'MAGG PAT IMAGES';
      lstCall(t);
    end;
end; *)

// This call returns all images, it returns the images of a group, instead
// of returning the Group.

procedure TMagDBMVista.RPMaggPatEachImage(DFN, MAX: string; var t: tstringlist);
begin
  with FBroker do
    begin
      param[0].Value := DFN;
      param[0].PType := literal;
      param[1].value := MAX;
      param[1].PType := literal;
      Fbroker.remoteprocedure := 'MAGG PAT EACH IMAGE';
      lstCall(t);
    end;
end;

procedure TMagDBMVista.CreateBroker;
begin
  if not assigned(FBroker) then
    begin
      FBroker := TRPCBroker.create(nil);
    end;
end;

procedure TMagDBMVista.RPMaggLogOff;
begin
  if not FBroker.connected then exit;

  Fbroker.remoteprocedure := 'MAGG LOGOFF';
  try
    FBroker.call;
  except
    on E: EBrokerError do maggmsgf.magmsg('de', 'Error Connecting to VISTA.' + #13 + #13 + E.MESSAGE + #13 + #13 + 'Shutdown will continue.');
    on E: Exception do maggmsgf.magmsg('de', 'Error During Log Off : ' + e.message);
  else
    maggmsgf.magmsg('de', 'Unknown Error during Log Off');
  end;
  FBroker.connected := false;
end;

procedure TMagDBMVista.RPMaggWrksUpdate(Apppath, DispAppName, CapAppName, Compname, Location, LastUpdate: string; startmode: integer);
var dtCapture, dtDisplay: string;
begin
  dtDisplay := '';
  dtCapture := '';

  if (CapAppName <> '') then
    begin
      try
        dtCapture := FORMATDATETIME('mm/dd/yy@hh:mm', FILEDATETIME(CapAppName));
      except
        dtCapture := '';
      end;
    end;
  if (DispAppName <> '') then
    begin
      try
        dtDisplay := FORMATDATETIME('mm/dd/yy@hh:mm', FILEDATETIME(DispAppName));
      except
        dtDisplay := '';
      end;
    end;

  Fbroker.remoteprocedure := 'MAGG WRKS UPDATES';
  FBroker.param[0].ptype := literal;
  FBroker.param[0].value := Compname
    + '^' + dtCapture
    + '^' + dtDisplay
    + '^' + Location
    + '^' + LastUpdate
    + '^' + MagGetFileVersionInfo(DispAppName)
    + '^' + MagGetFileVersionInfo(CapAppName)
    + '^' + inttostr(startmode)
    + '^' + MagGetOSVersion
    + '^';
  FBroker.call;
  maggmsgf.magmsg('s', 'Workstation Information sent to VistA:');
  maggmsgf.magmsg('s', '  -> Result = ' + FBroker.results[0]);

end;

procedure TMagDBMVista.RPMaggUserKeys(var t: Tstringlist);
begin
  Fbroker.remoteprocedure := 'MAGGUSERKEYS';
  FBroker.lstcall(t);
  maggmsgf.MagMsgs('', t);
end;

procedure TMagDBMVista.RPMaggGetTimeout(app: string; var minutes: string);
begin
  Fbroker.remoteprocedure := 'MAGG GET TIMEOUT';
  FBroker.Param[0].ptype := literal;
  FBroker.Param[0].value := app;
  minutes := FBroker.strcall;

end;

procedure TMagDBMVista.RPGetDischargeSummaries(dfn: string; var t: tstringlist);
begin
  Fbroker.remoteprocedure := 'TIU SUMMARIES';
  FBroker.Param[0].ptype := literal;
  FBroker.param[0].value := dfn;
  FBroker.lstcall(t);
end;

procedure TMagDBMVista.RPGetNoteText(tiuda: string; t: tstrings);
begin
  Fbroker.remoteprocedure := 'TIU GET RECORD TEXT';
  FBroker.Param[0].ptype := literal;
  FBroker.param[0].value := tiuda;
  FBroker.lstcall(t);
end;

procedure TMagDBMVista.RPGetNoteTitles(t, tint: tstringlist);
var i: integer;
begin
  t.sorted := false;
  tint.sorted := false;
  tint.clear;
  Fbroker.remoteprocedure := 'TIU GET PN TITLES';
  //xbrokerx.Param[0].ptype := literal;
  //xbrokerx.param[0].value := dfn  ;
  FBroker.lstcall(t);
  for I := 0 to t.count - 1 do
    begin
      tint.add('');
      tint[i] := copy(t[i], 2, pos('^', t[i]) - 2);
      t[i] := magpiece(t[i], '^', 2)
    end;
end;

//  Not Creating New TIU Records(*

function TMagDBMVista.RPCreateRecord(var msg: string; DFN, notetitle, notedate: string; notetext: tstrings): boolean;
var I: integer;
  S: string;
begin
  if dfn = '' then
    begin
      result := false;
      msg := 'You need to Select a Patient';
      exit;
    end;
  Fbroker.remoteprocedure := 'TIU CREATE RECORD';
  FBroker.Param[0].ptype := literal;
  FBroker.param[0].value := DFN;
  FBroker.Param[1].ptype := literal;
  FBroker.param[1].value := notetitle;

  FBroker.Param[2].ptype := literal;
  FBroker.param[2].value := '';
  FBroker.Param[3].ptype := literal;
  FBroker.param[3].value := '';
  FBroker.Param[4].ptype := literal;
  FBroker.param[4].value := '';

  FBroker.Param[5].Value := '.X';
  FBroker.Param[5].PType := list;
  for i := 0 to NOTETEXT.COUNT do
    begin
    //xBrokerx.Param[3].Mult['"TEXT'+','+INTTOSTR(I+1)+',0"']:=NOTETEXT[I];
      FBroker.Param[5].Mult['"TEXT"' + ',' + INTTOSTR(I + 1) + ',0'] := NOTETEXT[I];
    end;

  s := FBroker.strcall;
  if magpiece(S, '^', 1) = '0'
    then
    begin
      RESULT := FALSE;
      MSG := MAGPIECE(S, '^', 2);
    end
  else
    begin
      RESULT := TRUE;
      MSG := S;
    end;

end;

// *)

function TMagDBMVista.RPGetFileManDateTime(datestr: string; var DisDt, IntDT: string; NoFuture : boolean): boolean;
var dt: string;
  { this returns 1 ^ Display Date ^ internal date
            or   0 ^ error msg     }
begin
  FBroker.PARAM[0].PTYPE := literal;
  FBroker.PARAM[0].VALUE := datestr;
  IF NoFuture then
    begin
      FBroker.Param[1].ptype := literal;
      FBroker.Param[1].value := '1';
    end;
  Fbroker.remoteprocedure := 'MAGG DTTM';
  FBroker.CALL;
  dt := FBroker.RESULTS[0];
  if (dt = '') or (COPY(dt, 1, 1) = '0') then
    begin
      result := false;
      MESSAGEDLG(magpiece(dt, '^', 2), mtconfirmation, [mbok], 0);
      exit;
    end;
  DisDT := magpiece(dt, '^', 2);

  if maglength(DisDT, ':') > 2 then DisDT := magpiece(DisDT, ':', 1) + ':' + magpiece(DisDT, ':', 2);

  IntDT := magpiece(dt, '^', 3);
  result := true;
end;

function TMagDBMVista.RPSignRecord(tiuda, hashesign: string; var MSG: string): boolean;
var s: string;
begin
  FBroker.PARAM[0].PTYPE := literal;
  FBroker.PARAM[0].VALUE := TIUDA;
  FBroker.PARAM[1].PTYPE := literal;
  FBroker.PARAM[1].VALUE := hashesign;
  Fbroker.remoteprocedure := 'TIU SIGN RECORD';
  S := FBroker.STRCALL;
  if (S = '0') then RESULT := TRUE
  else begin
      RESULT := FALSE;
      MSG := s;
    end;
end;

procedure TMagDBMVista.RPGetNotesByContext(dfn: string; var t: tstringlist; context: integer; author, count: string; docclass: integer; seq: string; showadd: integer; incund: integer);
begin
  (*
                  CLIP OF CODE FROM THE CALL TO 'TIU DOCUMENTS BY CONTEXT'
  CONTEXT(TIUY,CLASS,CONTEXT,DFN,EARLY,LATE,PERSON,OCCLIM,SEQUENCE,SHOWADD,INCUND)
   ; main
           ; --- Call with:  TIUY     - RETURN ARRAY pass by reference
          0 ;                 CLASS    - Pointer to TIU DOCUMENT DEFINITION #8925.1
          1 ;                 CONTEXT  - 1=All Signed (by PT),
           ;                          - 2="Unsigned (by PT&(AUTHOR!TANSCRIBER))
           ;                          - 3="Uncosigned (by PT&EXPECTED COSIGNER
           ;                          - 4="Signed notes (by PT&selected author)
           ;                          - 5="Signed notes (by PT&date range)
          2 ;                 DFN      - Pointer to Patient (#2)
          3 ;                [EARLY]   - FM date/time to begin search
          4 ;                [LATE]    - FM date/time to end search
          5 ;                [PERSON]  - Pointer to file 200 (DUZ if not passed)
          6 ;                [OCCLIM]  - Occurrence Limit (optional)
          7 ;                [SEQUENCE]- "A"=ascending (Regular date/time)
           ;                          - "D"=descending (Reverse date/time) (dflt)
          8 = SHOWADD(wasn't documented in 'M' routine
              SHOWADD 0/1  means Show Addenda
          9 ;                [INCUND]  - Boolean: include undictated & untranscribe

  *)
  Fbroker.remoteprocedure := 'TIU DOCUMENTS BY CONTEXT';
  FBroker.Param[0].ptype := literal;
  FBroker.param[0].value := inttostr(docclass); // CPMOD was just '3'
  FBroker.Param[1].ptype := literal;
  FBroker.param[1].value := inttostr(context);
  FBroker.Param[2].ptype := literal;
  FBroker.param[2].value := dfn;
  FBroker.Param[3].ptype := literal;
  FBroker.param[3].value := '';
  FBroker.Param[4].ptype := literal;
  FBroker.param[4].value := '';
  FBroker.Param[5].ptype := literal;
  FBroker.param[5].value := author;
  FBroker.Param[6].ptype := literal;
  FBroker.param[6].value := count;

  FBroker.Param[7].ptype := literal;
  FBroker.param[7].value := seq;
  FBroker.Param[8].ptype := literal;
  FBroker.param[8].value := inttostr(showadd);
  FBroker.Param[9].ptype := literal;
  FBroker.param[9].value := inttostr(incund);
  FBroker.lstcall(t);
end;

function TMagDBMVista.RPGetTIUData(tiuda: string; var TIUPTR: string): boolean;
var S: string;
begin
  Fbroker.remoteprocedure := 'MAG3 TIU DATA FROM DA';
  FBroker.Param[0].ptype := literal;
  FBroker.param[0].value := TIUDA;
  try
    S := FBroker.strCall;
    if ((s = '') or (magpiece(s, '^', 1) = '0')) then
      begin
        RESULT := FALSE;
        TIUPTR := '';
        exit;
      end;
    RESULT := TRUE;
    TIUPTR := s;
  except
    RESULT := FALSE;
    TIUPTR := '';
  end;
end;

procedure TMagDBMVista.RPGetCPRSTIUNotes(tiuda: string; t: tstringlist; var success: boolean; var RPmsg: string);
begin
  success := false;
  try
    Fbroker.remoteprocedure := 'MAG3 CPRS TIU NOTE';
    FBroker.param[0].ptype := literal;
    FBroker.param[0].value := tiuda;
    FBroker.lstcall(t);
    if (magpiece(t[0], '^', 1) = '0') then
      begin
        maggmsgf.MagMsg('', magpiece(t[0], '^', 2));
        RPmsg := t[0];
        exit;
      end;
    if (t.count = 0) then
      begin
        maggmsgf.MagMsg('', 'Error accessing Images for TIU Note ');
        RPmsg := 'Error accessing Images for TIU Note ';
        exit;
      end;
    success := true;
    RPmsg := t[0];
    t.delete(0);
  except
    on E: Exception do
      begin
        maggmsgf.MagMsg('', 'Exception accessing Images for TIU Note ');
        RPmsg := 'Exception accessing Images for TIU Note ';
      end;
  end;
end;

//procedure RPMagCategories(var t, tien: tstrings);

(*procedure TMagDBMVista.RPMagCategories(t: tstrings);
begin
  //ADMINDOC
  try
    t.clear;
    //tien.clear;
    Fbroker.remoteprocedure := 'MAGGDESCCAT';
    FBroker.lstcall(t);
    if (t.count = 0) then
      begin
        maggmsgf.magmsg('', 'Error loading Image Cagetories.');
        exit;
      end;
    if (t.count = 1) then maggmsgf.magmsg('de', magpiece(t[0], '^', 2));
    t.delete(0);

  except
    on e: exception do maggmsgf.magmsg('de', 'Exception ' + e.message);
  end;
end;  *)

procedure TMagDBMVista.RPGetClinProcReq(dfn: string; var t: Tstrings);
begin
  //  success := false;
  try
    Fbroker.remoteprocedure := 'MAG4 CP GET REQUESTS';
    FBroker.param[0].ptype := literal;
    FBroker.param[0].value := dfn;
    FBroker.lstcall(t);
    if (magpiece(t[0], '^', 1) = '0') then
      begin
        maggmsgf.MagMsg('', magpiece(t[0], '^', 2));
        exit;
      end;
    if (t.count = 0) then
      begin
        maggmsgf.MagMsg('', 'Error while listing CP Requests. ');
        t.add('0^Error while listing CP Requests. ');
        exit;
      end;
    //    success := true;
    t.delete(0);
  except
    on E: Exception do
      begin
        maggmsgf.MagMsg('', 'Exception while listing CP Requests. ');
        t.insert(0, '0^Exception while listing CP Requests. ');
      end;
  end;
end;

procedure TMagDBMVista.RPGetTIUDAfromClinProcReq(dfn, fConsIEN, vstring, Complete: string; var t: Tstrings);
begin
  //  success := false;
  try
    Fbroker.remoteprocedure := 'MAG4 CP CONSULT TO TIUDA';
    FBroker.param[0].ptype := literal;
    FBroker.param[0].value := dfn;
    FBroker.param[1].ptype := literal;
    FBroker.param[1].value := fConsIEN;
    FBroker.param[3].ptype := literal;
    FBroker.param[3].value := complete;
    FBroker.param[2].ptype := literal;
    FBroker.param[2].value := vstring;
    FBroker.lstcall(t);
    if (magpiece(t[0], '^', 1) = '0') then
      begin
        maggmsgf.MagMsg('', magpiece(t[0], '^', 2));
        exit;
      end;
    if (t.count = 0) then
      begin
        maggmsgf.MagMsg('', 'Error (#34) in VistA');
        t.add('0^Error (#34) in VistA');
        exit;
      end;
    //    success := true;
    //     t.delete(0);
  except
    on E: Exception do
      begin
        maggmsgf.MagMsg('', 'Exception (#34) in VistA');
        t.insert(0, '0^Exception (#34) in VistA');
      end;
  end;

end;

procedure TMagDBMVista.RPGetVisitListForReq(dfn: string; var t: Tstrings);
begin
  //  success := false;
  try
    Fbroker.remoteprocedure := 'MAG4 CP GET VISITS';
    FBroker.param[0].ptype := literal;
    FBroker.param[0].value := dfn;
    FBroker.lstcall(t);
    if (magpiece(t[0], '^', 1) = '0') then
      begin
        maggmsgf.MagMsg('', magpiece(t[0], '^', 2));
        exit;
      end;
    if (t.count = 0) then
      begin
        maggmsgf.MagMsg('', 'Error Listing Patient visits.');
        t.add('0^Error Listing Patient visits.');
        exit;
      end;
    //    success := true;

    t.delete(0);
  except
    on E: Exception do
      begin
        maggmsgf.MagMsg('', 'Exception Listing Patient visits.');
        t.insert(0, '0^Exception Listing Patient visits.');
      end;
  end;
end;

procedure TMagDBMVista.RPMagVersionCheck(T: Tstrings; version: string);
begin
  Fbroker.remoteprocedure := 'MAG4 VERSION CHECK';
  FBroker.Param[0].PType := literal;
  FBroker.Param[0].Value := Version;

  try
    FBroker.lstcall(t);
    if (t.count = 0) then
      begin
        T.insert(0, '1^continue');
        maggmsgf.magmsg('', 'Error Checking Version on Server');
        exit;
      end;

  except
    on e: exception do
      begin
        t.insert(0, '1^continue');
        maggmsgf.magmsg('de', 'Exception ' + e.message);
      end;
  end;
end;

function TMagDBMVista.RPFileManDate(var xmsg: string; dateinput: string; var dateoutput: string; NoFuture : boolean = false): boolean;
var s: string;
var x2, x3: string;
begin
  result := false;
  if not FBroker.connected then
    begin
      xmsg := 'You must be connected to VistA to enable Date functions';
      exit;
    end;
  dateoutput := '';
  s := dateinput;
  if uppercase(s) = 'T' then s := 'N';
  with FBroker do
    begin
      PARAM[0].PTYPE := literal;
      PARAM[0].VALUE := S;
      IF NoFuture then
        begin
          Param[1].ptype := literal;
          Param[1].value := '1';
        end;
      Fbroker.remoteprocedure := 'MAGG DTTM';
      CALL;
      S := RESULTS[0];
    end;
  if (S = '') then s := '0^Error converting input to Date/Time';
  if (COPY(S, 1, 1) = '0') then
    begin
      dateoutput := '';
      xmsg := magpiece(s, '^', 2);
      exit;
    end;
  // take out the seconds
  x2 := magpiece(s, '^', 2);
  x3 := magpiece(s, '^', 3);
  x2 := magpiece(x2, ':', 1) + ':' + magpiece(x2, ':', 2);
  x3 := copy(x3, 1, 12);

  dateoutput := x2 + '^' + x3;
  result := true;
end;

procedure TMagDBMVista.RPXMultiProcList(lit: TStrings; dfn: string); // proclist: Tstrings);
var t: tstrings;
begin
  lit.clear;
  t := tstringlist.create;
  Fbroker.remoteprocedure := 'MAG4 MULTI PROCEDURE LIST';
  // for now we get all
  FBroker.Param[0].PType := list;
  FBroker.Param[0].Value := '.x';
  FBroker.Param[0].mult['1'] := 'MED^ALL';
  FBroker.Param[0].mult['2'] := 'LAB^ALL';
  FBroker.Param[0].mult['3'] := 'RAD^ALL';
  FBroker.Param[0].mult['4'] := 'SUR^ALL';
  FBroker.Param[0].mult['5'] := 'TIU^ALL';
  FBroker.Param[1].PType := literal;
  FBroker.Param[1].value := dfn;

  try
    FBroker.lstcall(t);
    if (t.count = 0) then
      begin
        lit.add('<Error loading ''Procedure'' list>');
        maggmsgf.magmsg('', 'Error loading Procedure listing.');
        exit;
      end;

  except
    on e: exception do
      begin
        lit.add('<Exception loading ''Procedure'' list>');
        maggmsgf.magmsg('', 'Exception loading Procedure listing');
        exit;
      end;
  end;
  t.delete(0);
  lit.AddStrings(t);
  t.free;
end;

procedure TMagDBMVista.RPCTPresetsGet(var rstat: boolean; var rmsg: string; var value: string);
var xmsg: string;
begin
  rstat := false;
  with FBroker do
    begin
      Fbroker.remoteprocedure := 'MAG4 CT PRESETS GET';
    end;
  try
    xmsg := Fbroker.StrCall;
    if (magpiece(xmsg, '^', 1) = '0') or (xmsg = '') then
      begin
        rstat := false;
        if xmsg <> '' then rmsg := magpiece(xmsg, '^', 2)
        else rmsg := 'VistA ERROR: Operation canceled.';
        exit;
      end;
    rstat := true;
    rmsg := 'Success.';
    value := magpiece(xmsg, '^', 2);
  except
    on E: EXCEPTION do
      begin
        rmsg := '0^ERROR (EXCEPTION) in VistA function.' + magpiece(e.message, #$A, 2);
        rstat := false;
        maggmsgf.MagMsg('s', e.message);
      end;
  end;
end;

procedure TMagDBMVista.RPCTPresetsSave(var rstat: boolean; var rmsg: string; value: string);
var xmsg: string;
begin
  rstat := false;
  with FBroker do
    begin
      Param[0].PType := literal;
      Param[0].Value := value;
      Fbroker.remoteprocedure := 'MAG4 CT PRESETS SAVE';
    end;
  try
    xmsg := Fbroker.StrCall;
    if (magpiece(xmsg, '^', 1) = '0') or (xmsg = '') then
      begin
        rstat := false;
        if xmsg <> '' then rmsg := magpiece(xmsg, '^', 2)
        else rmsg := 'VistA ERROR: Operation canceled.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(xmsg, '^', 2);
  except
    on E: EXCEPTION do
      begin
        rmsg := '0^ERROR (EXCEPTION) in VistA function.' + magpiece(e.message, #$A, 2);
        rstat := false;
        maggmsgf.MagMsg('s', e.message);
      end;
  end;

end;

procedure TMagDBMVista.RPFilterListGet(var rstat: boolean; var rmsg: string; var tlist: tstrings; duz: string = ''; getall: boolean = false);
begin
  rstat := false;
  with FBroker do
    begin
      param[0].Value := duz;
      param[0].PType := literal;
      param[1].Value := magbooltostrint(getall);
      param[1].PType := literal;
      Fbroker.remoteprocedure := 'MAG4 FILTER GET LIST';
    end;
  try
    Fbroker.lstCall(tlist);
      //demo create    MagDemoFilterList+ [(duz)|null-public]
      //tlist.SaveToFile(ExtractFilepath(application.exename)+ '\image\MagDemoFilterList'+duz+'-'+magbooltostrint(getall)+'.txt');
    if (magpiece(tlist[0], '^', 1) = '0') or (tlist.count = 0) then
      begin
        rstat := false;
        if tlist.count > 0 then rmsg := magpiece(tlist[0], '^', 2)
        else rmsg := 'ERROR: Health Summary Failed. Check VISTA Error Log.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(tlist[0], '^', 2);
    //tlist.delete(0); now the default filter is returned in 0 node.
  except
    on E: EXCEPTION do
      begin
        tlist.insert(0, '0^ERROR (EXCEPTION) in VistA function.');
        rstat := false;
        rmsg := 'ERROR (EXCEPTION) in VistA function:' + e.Message;
        tlist.insert(1, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;
end;

procedure TMagDBMVista.RPFilterDetailsGet(var rstat: boolean; var rmsg, filter: string; fltien: string; fltname: string = ''; duz: string = '');
var vlist: tstrings;
begin
  vlist := tstringlist.create;
  try
    rstat := false;
    with FBroker do
      begin
        param[0].Value := fltien;
        param[0].PType := literal;
        param[1].Value := fltname;
        param[1].PType := literal;
        param[2].Value := duz;
        param[2].PType := literal;
        Fbroker.remoteprocedure := 'MAG4 FILTER DETAILS';
      end;
    try
      Fbroker.lstCall(vlist);
      //demo create        MagDemoFilter+ (fltien)
      //vlist.SaveToFile(ExtractFilepath(application.exename)+ '\image\MagDemoFilter'+fltien+'.txt');

      if (vlist.count = 0) or (magpiece(vlist[0], '^', 1) = '0') then
        begin
          rstat := false;
          if vlist.count > 0 then rmsg := magpiece(vlist[0], '^', 2)
          else rmsg := 'ERROR: Retrieving Filter Details Failed. Check VISTA Error Log.';
          exit;
        end;
      rstat := true;
      rmsg := magpiece(vlist[0], '^', 2);
      filter := vlist[1];
    //vlist.delete(0);
    except
      on E: EXCEPTION do
        begin
          rmsg := 'ERROR (EXCEPTION) in VistA function.';
          rstat := false;
          maggmsgf.MagMsg('s', 'ERROR (EXCEPTION) in VistA function:' + e.Message);
        end;
    end;
  finally
    vlist.free;
  end;
end;

procedure TMagDBMVista.RPFilterSave(var rstat: boolean; var rmsg: string; t: Tstrings);
var I: integer;
begin
  rstat := false;
  with FBroker do
    begin
      Param[0].PType := list;
      Param[0].Value := '.x';
      for I := 0 to t.count - 1 do Param[0].Mult['' + inttostr(i) + ''] := t[i];
      Fbroker.remoteprocedure := 'MAG4 FILTER SAVE';
    end;
  try
    rmsg := Fbroker.strCall;
    if (magpiece(rmsg, '^', 1) = '0') or (rmsg = '') then
      begin
        rstat := false;
        if (rmsg = '') then rmsg := 'ERROR: Retrieving Filter Details Failed. Check VISTA Error Log.';
        exit;
      end;
    rstat := true;
    //rmsg := magpiece(rmsg, '^', 2);
    //vlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        rmsg := 'ERROR (EXCEPTION) in VistA function.';
        rstat := false;
        maggmsgf.MagMsg('s', 'ERROR (EXCEPTION) in VistA function:' + e.Message);
      end;
  end;
end;

procedure TMagDBMVista.RPFilterDelete(var rstat: boolean; var rmsg: string; fltien: string);
begin
//  if not CheckDBConnection(xmsg) then
  rstat := false;
  with FBroker do
    begin
      Param[0].PType := literal;
      Param[0].Value := fltien;
      Fbroker.remoteprocedure := 'MAG4 FILTER DELETE';
    end;
  try
    rmsg := Fbroker.strCall;
    if (magpiece(rmsg, '^', 1) = '0') or (rmsg = '') then
      begin
        rstat := false;
        if (rmsg <> '') then rmsg := magpiece(rmsg, '^', 2)
        else rmsg := 'ERROR: Deleting Image Filter. Check VISTA Error Log.';
        exit;
      end;
    rstat := true;
    rmsg := magpiece(rmsg, '^', 2);
    //vlist.delete(0);
  except
    on E: EXCEPTION do
      begin
        rmsg := 'ERROR (EXCEPTION) in VistA function.';
        rstat := false;
        maggmsgf.MagMsg('s', 'ERROR (EXCEPTION) in VistA function:' + e.Message);
      end;
  end;
end;

function TMagDBMVista.IsConnected: boolean;
begin
  if assigned(FBroker)
    then result := FBroker.Connected
  else result := false;
end;

procedure TMagDBMVista.SetConnected(const Value: boolean);
begin
  if assigned(FBroker)
    then Fbroker.Connected := value;
end;

function TMagDBMVista.GetListenerPort: integer;
begin
  if assigned(FBroker)
    then result := Fbroker.ListenerPort
  else result := 0;
end;

function TMagDBMVista.GetServer: string;
begin
  if assigned(FBroker)
    then result := FBroker.Server
  else result := '';
end;

procedure TMagDBMVista.SetListenerPort(const Value: integer);
begin
  if assigned(FBroker)
    then FBroker.ListenerPort := value;
end;

procedure TMagDBMVista.SetServer(const Value: string);
begin
  if assigned(FBroker)
    then FBroker.Server := value;
end;

procedure TMagDBMVista.RPMaggInstall(var Fstat: boolean; var Flist: tstringlist);
 var I: integer;
begin
if (FBroker = nil) or (not Fbroker.Connected) then
 begin
 Flist.add('0^No connection to the Server');
 exit;
 end;
  Flist.clear;
  Fstat := false;
  Fbroker.remoteprocedure := 'MAGG INSTALL';
  try
    Fbroker.lstCall(Flist);
    if (Flist.Count = 0) or (magpiece(Flist[0], '^', 1) = '0') then exit;
    Fstat := true;
    if maglength(Flist[0],'~') = 1 then  // This is old M code, not returning '~' codes for columns;
       Flist[0] := 'Server Versions  ^Install Date     ~S1'; // this sort code 'S1' says that this column is Dates.
  except
    on E: EXCEPTION do
      begin
        Flist.Insert(0, '0^' + magpiece(e.message, #$A, 2));
      end;
  end;
end;

end.

