unit cMagViewerTB;
  {
   Package: MAG - VistA Imaging
 WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
 Date Created:
 Site Name: Silver Spring, OIFO
 Developers: Garrett Kirin
[== unit cMagViewerTB;
 Description: Image Viewer ToolBar.
 The Viewer toolbar is designed as a standalone component rather than be encomposed
 in the Viewer itself.  It has a property MagViewer: TMag4Viewer that connects the
 Viewer Toolbar to an Image Viewer.  The Viewer Toolbar can control multiple
 viewers by changing the MagViewer property, and querrying the Viewer for current
 state.
 The original design of TMag4Viewer and TMagViewerTB was to have multiple toolbar
 components, each specific to an image Type. When Images are loaded into a viewer,
 certain Toolbars would be enabled/disabled or made visible/nonVisible depending on
 what types of Images were being viewed.
 That design isn't implemented.  The Viewer Toolbar component has controls that
 execute functions for document and color images.  i.e. Non - Dicom.
 The RadWindow has all functionality to handle Dicom Images.

 The Toolbuttons execute methods of the Viewer.  The Viewer is responsible for
 applying the methods to the appropriate images.  

==]

 Note:
  }
(*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ToolWin, ImgList,
  cmag4viewer, cmag4vGear, Menus, ExtCtrls, cMagVUtils, Buttons, umagdefinitions
  ;

type
    {Print command to be executed by parent window, not ToolBar to Viewer}
  TMagPrintClickEvent = procedure(sender: TObject; Viewer: TMag4Viewer) of object;
  TMagCopyClickEvent = procedure(sender: TObject; Viewer: TMag4Viewer) of object;


  TmagViewerTB = class(TFrame)
    tbarViewer: TToolBar;
    tbpagecontrols: TToolButton;
    tbsliders: TToolButton;
    tbApplyToAll: TToolButton;
    tbReset: TToolButton;
    tbFitWin: TToolButton;
    tbFitHeight: TToolButton;
    tbFitWidth: TToolButton;
    tbReverse: TToolButton;
    tb270: TToolButton;
    tb90: TToolButton;
    tbMousePan: TToolButton;
    tbPanWindow1: TToolButton;
    tbMouseZoomRect: TToolButton;
    tbMouseMagnify: TToolButton;
    tbReport: TToolButton;
    tbNew: TToolButton;
    tbTile: TToolButton;
    ImageList3: TImageList;
    tbFit1to1: TToolButton;
    tbFlipVert: TToolButton;
    tbFlipHoriz: TToolButton;
    tbViewerSettings: TToolButton;
    popupViewerStyles: TPopupMenu;
    StaticPages1: TMenuItem;
    Virtual1: TMenuItem;
    Dynamiccustom1: TMenuItem;
    tbClearViewer: TToolButton;
    tbRemoveImage: TToolButton;
    popupRowCol: TPopupMenu;
    mnuLockSize: TMenuItem;
    mnuReAlign: TMenuItem;
    mnuToggleSelected: TMenuItem;
    mnuRemoveImages: TMenuItem;
    N1: TMenuItem;
    mnuNewViewerX: TMenuItem;
    mnuShowAllX: TMenuItem;
    mnuClearbeforeAddImage: TMenuItem;
    ToolButton4: TToolButton;
    picContrast: TPanel;
    Label8: TLabel;
    licContrast: TLabel;
    tbicContrast: TTrackBar;
    ToolButton5: TToolButton;
    picBrightness: TPanel;
    Label6: TLabel;
    licBrightness: TLabel;
    tbicBrightness: TTrackBar;
    picZoom: TPanel;
    Label10: TLabel;
    licZoom: TLabel;
    tbicZoom: TTrackBar;
    tbPrintImage: TToolButton;
    tbCopyImage: TToolButton;
    pnlPage: TPanel;
    tblbPageCount: TLabel;
    tbepage: TEdit;
    tbtnPagePrev: TToolButton;
    tbtnPageLast: TToolButton;
    tbtnPageNext: TToolButton;
    btnPageFirst: TToolButton;
    ToolButton14: TToolButton;
    tbMaximize: TToolButton;
    ToolButton10: TToolButton;
    N1x1: TMenuItem;
    N2x1: TMenuItem;
    N3x1: TMenuItem;
    N4x1: TMenuItem;
    N1x2: TMenuItem;
    N2x2: TMenuItem;
    N3x2: TMenuItem;
    N4x2: TMenuItem;
    N1x3: TMenuItem;
    N2x3: TMenuItem;
    N3x3: TMenuItem;
    N4x3: TMenuItem;
    N1x4: TMenuItem;
    N2x4: TMenuItem;
    N3x4: TMenuItem;
    N4x4: TMenuItem;
    tbRefresh: TToolButton;
    ToolButton1: TToolButton;
    tbMousePointer: TToolButton;
    tbtnImageFirst: TToolButton;
    tbtnImagePrev: TToolButton;
    tbtnImageNext: TToolButton;
    tbtnImageLast: TToolButton;
    Panel2: TPanel;
    tblbImageCount: TLabel;
    tbBrightMore: TToolButton;
    tbBrightLess: TToolButton;
    tbContrastMore: TToolButton;
    tbContrastLess: TToolButton;
    trbZoomIn: TToolButton;
    tbZoomOut: TToolButton;
    ToolButton9: TToolButton;
    ToolButton16: TToolButton;
    ToolBar1: TToolBar;
    PanelProtytype: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    tbicWin: TTrackBar;
    tbicLev: TTrackBar;
    Panel1: TPanel;
    ComboBox1: TComboBox;
    procedure tbApplyToAllClick(Sender: TObject);
    procedure tbFitHeightClick(Sender: TObject);
    procedure tbReverseClick(Sender: TObject);
    procedure tbFitWidthClick(Sender: TObject);
    procedure tb270Click(Sender: TObject);
    procedure tb90Click(Sender: TObject);
    procedure tbMousePanClick(Sender: TObject);
    procedure tbPanWindow1Click(Sender: TObject);
    procedure tbMouseZoomRectClick(Sender: TObject);
    procedure tbMouseMagnifyClick(Sender: TObject);
    procedure tbTileClick(Sender: TObject);
    procedure tbarViewerResize(Sender: TObject);
    procedure tbFitWinClick(Sender: TObject);
    procedure tbFit1to1Click(Sender: TObject);
    procedure tbFlipVertClick(Sender: TObject);
    procedure tbFlipHorizClick(Sender: TObject);
    procedure StaticPages1Click(Sender: TObject);
    procedure Virtual1Click(Sender: TObject);
    procedure Dynamiccustom1Click(Sender: TObject);
    procedure tbViewerSettingsClick(Sender: TObject);
    procedure tbRemoveImageClick(Sender: TObject);
    procedure tbClearViewerClick(Sender: TObject);
    procedure popupRowColPopup(Sender: TObject);
    procedure mnuLockSizeClick(Sender: TObject);
    procedure mnuToggleSelectedClick(Sender: TObject);
    procedure mnuRemoveImagesClick(Sender: TObject);
    procedure mnuClearbeforeAddImageClick(Sender: TObject);
    procedure tbicZoomChange(Sender: TObject);
    procedure tbicBrightnessChange(Sender: TObject);
    procedure tbicContrastChange(Sender: TObject);
    procedure tbPrintImageClick(Sender: TObject);
    procedure tbCopyImageClick(Sender: TObject);
    procedure tbReportClick(Sender: TObject);
    procedure btnPageFirstClick(Sender: TObject);
    procedure tbtnPagePrevClick(Sender: TObject);
    procedure tbtnPageNextClick(Sender: TObject);
    procedure tbtnPageLastClick(Sender: TObject);
    procedure tbepageClick(Sender: TObject);
    procedure tbepageEnter(Sender: TObject);
    procedure tbepageKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure tbepageKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure tbResetClick(Sender: TObject);
    procedure tbMaximizeClick(Sender: TObject);
    procedure N1x1Click(Sender: TObject);
    procedure N2x1Click(Sender: TObject);
    procedure N3x1Click(Sender: TObject);
    procedure N4x1Click(Sender: TObject);
    procedure N1x2Click(Sender: TObject);
    procedure N2x2Click(Sender: TObject);
    procedure N3x2Click(Sender: TObject);
    procedure N4x2Click(Sender: TObject);
    procedure N1x3Click(Sender: TObject);
    procedure N2x3Click(Sender: TObject);
    procedure N3x3Click(Sender: TObject);
    procedure N4x3Click(Sender: TObject);
    procedure N1x4Click(Sender: TObject);
    procedure N2x4Click(Sender: TObject);
    procedure N3x4Click(Sender: TObject);
    procedure N4x4Click(Sender: TObject);
    procedure mnuReAlignClick(Sender: TObject);
    procedure tbRefreshClick(Sender: TObject);
    procedure tbMousePointerClick(Sender: TObject);
    procedure tbicWinChange(Sender: TObject);
    procedure tbicLevChange(Sender: TObject);
    procedure tbBrightMoreClick(Sender: TObject);
    procedure tbBrightLessClick(Sender: TObject);
    procedure tbContrastMoreClick(Sender: TObject);
    procedure tbContrastLessClick(Sender: TObject);
    procedure trbZoomInClick(Sender: TObject);
    procedure tbZoomOutClick(Sender: TObject);
    procedure tbtnImageFirstClick(Sender: TObject);
    procedure tbtnImagePrevClick(Sender: TObject);
    procedure tbtnImageNextClick(Sender: TObject);
    procedure tbtnImageLastClick(Sender: TObject);
  private
    FImagePageCount: integer;
    FCurViewer: TMag4Viewer; { Private declarations }
//    FMagVUtils: TMagVUtils;
    FPrintClickEvent : TMagPrintClickEvent;
    FCopyClickEvent : TMagCopyClickEvent;
    procedure GoToNextPage;
    procedure GoToPage(pg: integer);
    procedure GoToPrevPage;
    procedure SetRowCol(row, col: integer);
    procedure ApplyImageState(vGear: Tmag4Vgear); // 01/21/03  was imagestate  : Timagestate
    procedure DisablePageControls(imagestate: TMagImageState);
    procedure ApplyViewerState(viewer: Tmag4Viewer);

  public
    constructor create(Aowner: Tcomponent); override;
    destructor destroy; override;

    {Called by associated form, or component :
    Viewer Toolbar will querry the Viewer then update it's controls,
    (brightness, Zoom value, page count etc) according to the state
    of the selected image }
    procedure UpdateImageState;
  published
    {Connect this Viewer Toolbar to a Viewer.}
    property MagViewer: TMag4Viewer read FCurViewer write FCurViewer;
    property OnPrintClick: TMagPrintClickEvent read FPrintClickEvent write FPrintClickEvent;
    property OnCopyClick: TMagCopyClickEvent read FCopyClickEvent write FCopyClickEvent;

  end;

procedure Register;

implementation


{$R *.DFM}

procedure Register;
begin
  RegisterComponents('Imaging', [TmagViewerTB]);
end;
{ TODO :
Enable Disable Buttons, based on if Fcurviewer is NIL.
and later, based on Selected Images in Fcurviewer. }

procedure TmagViewerTB.tbApplyToAllClick(Sender: TObject);
begin
  if Fcurviewer <> nil then Fcurviewer.Applytoall := tbApplyToAll.Down; ;
end;

procedure TmagViewerTB.tbFitHeightClick(Sender: TObject);
begin
  if FcurViewer <> nil then FcurViewer.FitToHeight;
  application.processmessages;
  if FcurViewer <> nil then FcurViewer.MousePan;

end;

procedure TmagViewerTB.tbReverseClick(Sender: TObject);
begin
  if FcurViewer <> nil then FcurViewer.Inverse;
end;

procedure TmagViewerTB.tbFitWidthClick(Sender: TObject);
begin
  if FcurViewer <> nil then FcurViewer.FitToWidth;
  application.processmessages;
  if FcurViewer <> nil then FcurViewer.MousePan;
end;

procedure TmagViewerTB.tb270Click(Sender: TObject);
begin
  if FcurViewer <> nil then FcurViewer.Rotate(270);

end;

procedure TmagViewerTB.tb90Click(Sender: TObject);
begin
  if FcurViewer <> nil then FcurViewer.Rotate(90);
end;

procedure TmagViewerTB.tbMousePanClick(Sender: TObject);
begin
  if FcurViewer <> nil then FcurViewer.MousePan;
  (*  // If we want to lock button down depending on Cursor Action
      //    also have to group buttons, and call them CheckButtons.
    if FcurViewer <> nil then
  if tbMousePan.down
    then FcurViewer.MousePan
    else FCurViewer.MouseReset;*)
end;

procedure TmagViewerTB.tbMouseMagnifyClick(Sender: TObject);
begin
  if FcurViewer <> nil then FcurViewer.MouseMagnify;
  (*  // If we want to lock button down depending on Cursor Action
      //    also have to group buttons, and call them CheckButtons.
  if FcurViewer <> nil then
  if tbMouseMagnify.down
    then FcurViewer.MouseMagnify
    else FCurViewer.MouseReset;  *)
end;

procedure TmagViewerTB.tbMouseZoomRectClick(Sender: TObject);
begin
  if FcurViewer <> nil then FcurViewer.MouseZoomRect;
  (*  // If we want to lock button down depending on Cursor Action
      //    also have to group buttons, and call them CheckButtons.
  if FcurViewer <> nil then
  if tbMouseZoomRect.down
    then FcurViewer.MouseZoomRect
    else FCurViewer.MouseReset;*)
end;

procedure TmagViewerTB.tbPanWindow1Click(Sender: TObject);
begin
  if FcurViewer <> nil then FcurViewer.PanWindow := tbPanWindow1.Down;
end;

procedure TmagViewerTB.tbTileClick(Sender: TObject);
begin
  if FCurviewer <> nil then FCurViewer.TileAll;
end;

constructor TmagViewerTB.create(Aowner: Tcomponent);
begin
  inherited;
  autosize := true;
end;

destructor TmagViewerTB.destroy;
begin
  FCurViewer := nil;
  inherited;

end;

procedure TmagViewerTB.tbarViewerResize(Sender: TObject);
begin
  if (align = altop) then height := tbarviewer.Height + 2;
  if (width < TbarViewer.width) then
    if (align = alleft) then width := tbarviewer.width + 2;

end;

procedure TmagViewerTB.tbFitWinClick(Sender: TObject);
begin
  if FcurViewer <> nil then FcurViewer.FitToWindow;
end;

procedure TmagViewerTB.tbFit1to1Click(Sender: TObject);
begin
  if FcurViewer <> nil then
    begin
      FcurViewer.Fit1to1;
      application.processmessages;
      FcurViewer.MousePan;
    end;
end;

procedure TmagViewerTB.tbFlipVertClick(Sender: TObject);
begin
  if FcurViewer <> nil then FcurViewer.FlipVert;
end;

procedure TmagViewerTB.tbFlipHorizClick(Sender: TObject);
begin
  if FcurViewer <> nil then FcurViewer.FlipHoriz;
end;

procedure TmagViewerTB.StaticPages1Click(Sender: TObject);
begin
  if FcurViewer <> nil then Fcurviewer.ViewerStyle := magvsStaticPage;
end;

procedure TmagViewerTB.Virtual1Click(Sender: TObject);
begin
  if FcurViewer <> nil then Fcurviewer.ViewerStyle := magvsVirtual;
end;

procedure TmagViewerTB.Dynamiccustom1Click(Sender: TObject);
begin
  if FcurViewer <> nil then Fcurviewer.ViewerStyle := magvsDynamic;
end;

{ Open the Viewer Settings dialog window.}
procedure TmagViewerTB.tbViewerSettingsClick(Sender: TObject);
begin
  if Fcurviewer <> nil then
    begin
      //RowColSize.execute(FCurViewer);
        FCurViewer.EditViewerSettings;
    end;
end;

procedure TmagViewerTB.tbRemoveImageClick(Sender: TObject);
begin
  if FcurViewer <> nil then FCurViewer.RemoveFromList;
end;

procedure TmagViewerTB.tbClearViewerClick(Sender: TObject);
begin
  if FcurViewer <> nil then FCurViewer.ClearViewer;
end;

procedure TmagViewerTB.popupRowColPopup(Sender: TObject);
begin
  if FCurviewer <> nil then mnulocksize.Checked := Fcurviewer.LockSize
  else mnulocksize.checked := false;
end;

procedure TmagViewerTB.mnuLockSizeClick(Sender: TObject);
begin
  if Fcurviewer <> nil then
    begin
      mnulocksize.checked := not mnulocksize.checked;
      Fcurviewer.LockSize := mnulocksize.checked;
    end;
end;

procedure TmagViewerTB.mnuToggleSelectedClick(Sender: TObject);
begin
  if FCurviewer <> nil then FCurViewer.ToggleSelected;
end;

procedure TmagViewerTB.mnuRemoveImagesClick(Sender: TObject);
begin
  if FCurviewer <> nil then FCurViewer.RemoveFromList;
end;

procedure TmagViewerTB.mnuClearbeforeAddImageClick(Sender: TObject);
begin
  if Fcurviewer <> nil then
    begin
      mnuClearbeforeAddImage.checked := not mnuClearbeforeAddImage.checked;
      Fcurviewer.ClearBeforeAddDrop := mnuClearbeforeAddImage.checked;
    end;
end;

procedure TmagViewerTB.tbicZoomChange(Sender: TObject);
begin
  licZoom.caption := inttostr(tbicZoom.position);
  licZoom.update;
  if FcurViewer <> nil then
    begin
      FcurViewer.ZoomValue(tbicZoom.Position);
      FcurViewer.MousePan;
    end;

end;

procedure TmagViewerTB.tbicBrightnessChange(Sender: TObject);
begin
  licBrightness.caption := inttostr(trunc(tbicBrightness.position / 10) + 90);
  licBrightness.update;
  if FcurViewer <> nil then FcurViewer.BrightnessValue(tbicBrightness.position); //(trunc(tbicBrightness.Position / 10));
end;

procedure TmagViewerTB.tbicContrastChange(Sender: TObject);
begin
  liccontrast.caption := inttostr(tbicContrast.Position);
  liccontrast.update;
  if FcurViewer <> nil then FcurViewer.ContrastValue(tbicContrast.Position); //(tbicContrast.Position / 100);
end;

procedure TmagViewerTB.tbPrintImageClick(Sender: TObject);
begin
if (FCurViewer <> nil) then
  begin
    if assigned(OnPrintClick)
      then self.OnPrintClick(self,fCurViewer)
      else FCurViewer.ImagePrint;
  end;
end;


procedure TmagViewerTB.tbCopyImageClick(Sender: TObject);
begin
  if (FCurViewer <> nil) then
    begin
      if assigned(OnCopyClick)
        then self.OnCopyClick(self,fCurViewer)
        else FCurViewer.ImageCopy;
    end;
end;

procedure TmagViewerTB.tbReportClick(Sender: TObject);
begin
  if (FCurViewer <> nil) then FCurViewer.ImageReport;

end;



procedure TmagViewerTB.ApplyViewerState(viewer: Tmag4Viewer);
begin
  tbApplyToAll.Down := Viewer.ApplyToAll;
  tbPanWindow1.Down := Viewer.PanWindow;
  {TODO: these calls worked,  but we still need buttons for Group Images.}
  { Multipage documents            Buttons  yes
    MultiPage of the Viewer.       Buttons  YES (below, not enabled)
    MultiPage images in a Group    Buttons NO    }
  //  tbtnImageFirst.Enabled := not Viewer.ViewerScrollAtStart;
//  tbtnImagePrev.Enabled := not Viewer.ViewerScrollAtStart;
//  tbtnImageNext.Enabled := not Viewer.ViewerScrollAtEnd;
//  tbtnImageLast.Enabled := not Viewer.ViewerScrollAtEnd;


end;
 // 01/21/03  was (imagestate : Timagestate);

procedure TMagViewerTB.ApplyImageState(vGear: Tmag4Vgear);
var imagestate: TMagImageState;
begin
  if vGear = nil then imagestate := nil
  else imagestate := vGear.GetState;
  disablePagecontrols(imagestate);
  if imagestate = nil then exit;
  FImagePageCount := imagestate.PageCount;
  tbepage.text := inttostr(imagestate.page);
  tblbPageCount.caption := 'of ' + inttostr(imagestate.PageCount);
  tbicBrightness.Position := (imagestate.brightnessvalue);
  tbicContrast.Position := imagestate.contrastvalue;
  tbicZoom.Position := imagestate.zoomvalue;

  tbicWin.Min := imagestate.WinMinValue;
  tbicWin.Max := imagestate.WinMaxValue;
  tbicWin.Position := imagestate.WinValue;
  tbicLev.Min := imagestate.LevMinValue;
  tbicLev.Max := imagestate.LevMaxValue;
  tbicLev.Position := imagestate.LevValue;
  tblbImageCount.Caption := inttostr(imagestate.ImageNumber)+'/'+inttostr(imagestate.ImageCount);

  (*  // future If we want to lock button down depending on Cursor Action
      //    also have to group buttons, and call them CheckButtons.

  case imagestate.MouseAction of
   mactPan:
     begin
     if not tbMousePan.Down then tbMousePan.down := true;
     end;
   mactDrag:
   begin
    // if not tbDrag.Down then tbDrag.down := true;
    end;
   mactMagnify:
   begin
     if not tbMouseMagnify.Down then tbMouseMagnify.down := true;
    end;
   mactZoomRect:
     begin
     if not tbMouseZoomRect.Down then tbMouseZoomRect.down := true;
      end;
   mactSelect:
   begin
    // if not tbSelect.Down then tbSelect.down := true;
    end;
   mactPointer:
     begin
     if not tbMousePointer.Down then tbMousePointer.down := true;
     end;
   end;
   *)
end;

procedure TmagViewerTB.UpdateImageState;
begin
  if (FCurViewer <> nil)
    then
    begin
      ApplyImageState(FCurViewer.GetCurrentImage);
      ApplyViewerState(FcurViewer);
    end;

end;

procedure TmagViewerTB.DisablePageControls(imagestate: TMagImageState);
begin
  if imagestate = nil then // 01/21/03
    begin
      tbepage.enabled := false;
      btnPageFirst.enabled := false;
      tbtnPagePrev.enabled := false;
      tbtnPageNext.enabled := false;
      tbtnPageLast.enabled := false;

      tbtnImageFirst.enabled := false;
      tbtnImagePrev.enabled := false;
      tbtnImageNext.enabled := false;
      tbtnImageLast.enabled := false;
      tblbImageCount.caption := '0/0';
    end
  else
    begin
      tbepage.enabled := not (imagestate.PageCount = 1);
      btnPageFirst.enabled := (imagestate.Page <> 1);
      tbtnPagePrev.enabled := (imagestate.Page <> 1);
      tbtnPageNext.enabled := (imagestate.Page <> imagestate.PageCount);
      tbtnPageLast.enabled := (imagestate.Page <> imagestate.PageCount);

      tbtnImageFirst.enabled := (imagestate.ImageNumber <> 1);
      tbtnImagePrev.enabled := (imagestate.ImageNumber <> 1);
      tbtnImageNext.enabled := (imagestate.ImageNumber <> imagestate.ImageCount);
      tbtnImageLast.enabled := (imagestate.ImageNumber <> imagestate.ImageCount);
    end;
end;

procedure TMagViewerTB.GoToPage(pg: integer);
begin
  if (FCurViewer <> nil) then FCurViewer.ImagePage := pg;
end;

procedure TMagViewerTB.GoToPrevPage;
begin
  if (FCurViewer <> nil) then FCurViewer.Imagepage := FCurViewer.IMagepage - 1;
end;

procedure TMagViewerTB.GoToNextPage;
begin
  if (FCurViewer <> nil) then FCurViewer.IMagepage := FCurViewer.Imagepage + 1;
end;


procedure TmagViewerTB.btnPageFirstClick(Sender: TObject);
begin
  if FCurviewer <> nil then FCurViewer.PageFirstImage;
//  GoToPage(1);
  UpdateImageState;
end;

procedure TmagViewerTB.tbtnPagePrevClick(Sender: TObject);
begin
  if FCurviewer <> nil then FCurViewer.PagePrevImage;
//  GoToPrevPage;
  UpdateImageState;
end;

procedure TmagViewerTB.tbtnPageNextClick(Sender: TObject);
begin
  if FCurviewer <> nil then FCurViewer.PageNextImage;
//  GoToNextPage;
  UpdateImageState;
end;

procedure TmagViewerTB.tbtnPageLastClick(Sender: TObject);
begin
  if FCurviewer <> nil then FCurViewer.PageLastImage;
//  GoToPage(9999999);
  UpdateImageState;
end;

procedure TmagViewerTB.tbepageClick(Sender: TObject);
begin
  tbepage.selstart := 0;
  tbepage.sellength := 9;
end;

procedure TmagViewerTB.tbepageEnter(Sender: TObject);
begin
  tbepage.selstart := 0;
  tbepage.sellength := 9;
end;

procedure TmagViewerTB.tbepageKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  { 33 is Page UP,   34 is Page Down }
  case key of
    33: if ssCtrl in Shift then GotoPage(1)
      else GoToprevpage;
    34: if ssCtrl in Shift then GotoPage(999999999)
      else GoTonextpage;
  end;
end;

procedure TmagViewerTB.tbepageKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var pg: integer;
begin
  { 33 is Page UP,   34 is Page Down }
  if ((key = 33) or (key = 34)) then exit;
  try
    if (strtoint(tbepage.text + '0') > FImagePageCount) then
      begin
        GoToPage(strtoint(tbepage.text));
        exit;
      end;

    if (length(tbepage.text)) > (length(inttostr(FImagePageCount)))
      then
      begin
      //InvalidPage;

        exit;
      end;
    if (length(tbepage.text)) = (length(inttostr(FImagePageCount)))
      then
      begin
        pg := strtoint(tbepage.text);
        if pg > FImagePageCount then
          begin
        //old InvalidPage;
            pg := FImagePageCount;
            tbePage.Text := inttostr(FImagePageCount);
           // exit;
          end;
        GoToPage(pg);
        tbepage.SelStart := 0;
        tbepage.sellength := length(tbepage.text);
      end;
  except
    //InvalidPage;
  end; { try}
end;


procedure TmagViewerTB.tbResetClick(Sender: TObject);
begin
  if FcurViewer <> nil then
    begin
      FcurViewer.ResetImages;
    // Changing the next 3 controls, on this reset, is
    //  actually changing the property again.
    { TODO : Not Show Stopper, have to get way to stop the double processing. }
      tbicBrightness.Position := 100;
      tbicContrast.Position := 100;
      tbicZoom.Position := 100;
    end;
end;

procedure TmagViewerTB.tbMaximizeClick(Sender: TObject);
begin
  if FcurViewer <> nil then FCurViewer.MaximizeImage := true;
end;


procedure TmagViewerTB.SetRowCol(row, col: integer);
begin
  if FcurViewer <> nil then
    begin
      if FcurViewer.MaxCount < (row * col)
        then FcurViewer.MaxCount := (row * col);
      application.processmessages;
      FcurViewer.SetRowColcount(row, col);
    end;
end;

procedure TmagViewerTB.N1x1Click(Sender: TObject);
begin
  SetRowCol(1, 1);
end;

procedure TmagViewerTB.N2x1Click(Sender: TObject);
begin
  SetRowCol(2, 1);
end;

procedure TmagViewerTB.N3x1Click(Sender: TObject);
begin
  SetRowCol(3, 1);
end;

procedure TmagViewerTB.N4x1Click(Sender: TObject);
begin
  SetRowCol(4, 1);
end;

procedure TmagViewerTB.N1x2Click(Sender: TObject);
begin
  SetRowCol(1, 2);
end;

procedure TmagViewerTB.N2x2Click(Sender: TObject);
begin
  SetRowCol(2, 2);
end;

procedure TmagViewerTB.N3x2Click(Sender: TObject);
begin
  SetRowCol(3, 2);
end;

procedure TmagViewerTB.N4x2Click(Sender: TObject);
begin
  SetRowCol(4, 2);
end;

procedure TmagViewerTB.N1x3Click(Sender: TObject);
begin
  SetRowCol(1, 3);
end;

procedure TmagViewerTB.N2x3Click(Sender: TObject);
begin
  SetRowCol(2, 3);
end;

procedure TmagViewerTB.N3x3Click(Sender: TObject);
begin
  SetRowCol(3, 3);
end;

procedure TmagViewerTB.N4x3Click(Sender: TObject);
begin
  SetRowCol(4, 3);
end;

procedure TmagViewerTB.N1x4Click(Sender: TObject);
begin
  SetRowCol(1, 4);
end;

procedure TmagViewerTB.N2x4Click(Sender: TObject);
begin
  SetRowCol(2, 4);
end;

procedure TmagViewerTB.N3x4Click(Sender: TObject);
begin
  SetRowCol(3, 4);
end;

procedure TmagViewerTB.N4x4Click(Sender: TObject);
begin
  SetRowCol(4, 4);
end;

procedure TmagViewerTB.mnuReAlignClick(Sender: TObject);
begin
  if FCurviewer <> nil then FCurViewer.ReAlignImages(true);
end;

procedure TmagViewerTB.tbRefreshClick(Sender: TObject);
begin
  if FCurviewer <> nil then FCurViewer.ReFreshImages;
end;

procedure TmagViewerTB.tbMousePointerClick(Sender: TObject);
begin
  if FcurViewer <> nil then FCurViewer.MouseReset;
end;

procedure TmagViewerTB.tbicWinChange(Sender: TObject);
begin
  if FcurViewer <> nil then FCurViewer.WinLevValue(tbicWin.position,tbicLev.position);
end;

procedure TmagViewerTB.tbicLevChange(Sender: TObject);
begin
  if FcurViewer <> nil then FCurViewer.WinLevValue(tbicWin.position,tbicLev.position);
end;

procedure TmagViewerTB.tbBrightMoreClick(Sender: TObject);
begin
tbicBrightness.position := tbicBrightness.position +10;
  if FcurViewer <> nil then FcurViewer.BrightnessValue(tbicBrightness.position);
end;

procedure TmagViewerTB.tbBrightLessClick(Sender: TObject);
begin
tbicBrightness.position := tbicBrightness.position - 10;
  if FcurViewer <> nil then FcurViewer.BrightnessValue(tbicBrightness.position);
end;

procedure TmagViewerTB.tbContrastMoreClick(Sender: TObject);
begin
tbicContrast.position := tbicContrast.position +10;
  if FcurViewer <> nil then FcurViewer.BrightnessValue(tbicContrast.position);
end;

procedure TmagViewerTB.tbContrastLessClick(Sender: TObject);
begin
tbicContrast.position := tbicContrast.position - 10;
  if FcurViewer <> nil then FcurViewer.BrightnessValue(tbicContrast.position);
end;

procedure TmagViewerTB.trbZoomInClick(Sender: TObject);
begin
  tbicZoom.Position := trunc(tbicZoom.Position * 1.1);

  if FcurViewer <> nil then FcurViewer.ZoomValue(tbicZoom.Position);
end;

procedure TmagViewerTB.tbZoomOutClick(Sender: TObject);
begin
  tbicZoom.Position := trunc(tbicZoom.Position * 0.9);

  if FcurViewer <> nil then FcurViewer.ZoomValue(tbicZoom.Position);
end;

procedure TmagViewerTB.tbtnImageFirstClick(Sender: TObject);
begin
   if FcurViewer <> nil then FcurViewer.PageFirstViewer;
     UpdateImageState;
end;

procedure TmagViewerTB.tbtnImagePrevClick(Sender: TObject);
begin
   if FcurViewer <> nil then FcurViewer.PagePrevViewer;
     UpdateImageState;
end;

procedure TmagViewerTB.tbtnImageNextClick(Sender: TObject);
begin
   if FcurViewer <> nil then FcurViewer.PageNextViewer;
     UpdateImageState;
end;

procedure TmagViewerTB.tbtnImageLastClick(Sender: TObject);
begin
   if FcurViewer <> nil then FcurViewer.PageLastViewer;
     UpdateImageState;
end;

end.

