unit fmagColumnSelect;
   {
   Package: MAG - VistA Imaging
 WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
 Date Created: Version 3.0.8
 Site Name: Silver Spring, OIFO
 Developers: Garrett Kirin
[==    unit fmagColumnSelect;
 Description: Imaging List View utility form (Select Visible Columns).
 - Created by TMagListView object to display the list of that object's columns
   and allow user to check/uncheck the visible status.
   Then modify's the columns width in the TmagListView object, setting the
   width to 0 for the columns that the user wants invisible.
==]
 Note:
  }
 (*
   ;; +---------------------------------------------------------------------------------------------------+
   ;; Property of the US Government.
   ;; No permission to copy or redistribute this software is given.
   ;; Use of unreleased versions of this software requires the user
   ;;  to execute a written test agreement with the VistA Imaging
   ;;  Development Office of the Department of Veterans Affairs,
   ;;  telephone (301) 734-0100.
   ;;
   ;; The Food and Drug Administration classifies this software as
   ;; a medical device.  As such, it may not be changed
   ;; in any way.  Modifications to this software may result in an
   ;; adulterated medical device under 21CFR820, the use of which
   ;; is considered to be a violation of US Federal Statutes.
   ;; +---------------------------------------------------------------------------------------------------+
*)
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, CheckLst, Buttons, ExtCtrls, ComCtrls,cmaglistview;

type
  TfrmColumnSelect = class(TForm)
    chlistColumns: TCheckListBox;
    Label1: TLabel;
    Panel1: TPanel;
    btnApply: TBitBtn;
    btnClose: TBitBtn;
    btnOK: TBitBtn;
    btnAll: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure btnApplyClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure btnAllClick(Sender: TObject);
  private
   FLV : TMaglistview;
   procedure SetVisibleColumns;
    { Private declarations }
  public
    procedure DisplayColumns(LV : TMagListView);
  end;

var
  frmColumnSelect: TfrmColumnSelect;

implementation

{$R *.DFM}

procedure TfrmColumnSelect.FormCreate(Sender: TObject);
begin
  chlistColumns.Align := alclient;
end;

procedure TfrmColumnSelect.btnApplyClick(Sender: TObject);
begin
  SetVisibleColumns;
end;


procedure TfrmColumnSelect.SetVisibleColumns;
var i : integer;
begin
  FLV.visible := false;
  try
for i := 0 to chlistcolumns.items.count-1 do
begin
  if not chlistcolumns.checked[i] then
    begin
      FLV.Columns[i].Width := 0;
      FLV.FColVisible[i] := false;
    end
       else
       begin
       FLV.FColVisible[i] := true;
       if (FLV.columns[i].width = 0) then FLV.columns[i].width := FLV.FColWidth[i] + 10;
       end;
end;
finally
  FLV.visible := true;
  end;
end;

procedure TfrmColumnSelect.DisplayColumns(LV: TMaglistview);
var I : integer;
begin
FLV := LV;
chlistcolumns.items.Clear;
for i := 0 to Flv.Columns.Count -1  do
    begin
     chlistcolumns.Items.Add(Flv.columns[I].Caption);
     chlistcolumns.Checked[i] := (Flv.columns[I].width > 0);
    end;
end;

procedure TfrmColumnSelect.btnCloseClick(Sender: TObject);
begin
close;
end;

procedure TfrmColumnSelect.btnOKClick(Sender: TObject);
begin
SetVisibleColumns;
end;

procedure TfrmColumnSelect.btnAllClick(Sender: TObject);
var I : integer;
begin
for i := 0 to chlistcolumns.items.Count -1  do
    begin
     chlistcolumns.Checked[i] := true;
    end;
SetVisibleColumns;
end;

end.
