unit fMagCopyAgreement;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:
   Site Name: Silver Spring, OIFO
   Developers: Garrett Kirin
  [==  unit fMagCopyAgreement;
   Description: Utiltity form.  Prompts User
     to select a reason for Copying or Printing an Image
     and enter an Electronic signature.

   ==]
   Note:
   }
(*
        ;; +---------------------------------------------------------------------------------------------------+
        ;; Property of the US Government.
        ;; No permission to copy or redistribute this software is given.
        ;; Use of unreleased versions of this software requires the user
        ;;  to execute a written test agreement with the VistA Imaging
        ;;  Development Office of the Department of Veterans Affairs,
        ;;  telephone (301) 734-0100.
        ;;
        ;; The Food and Drug Administration classifies this software as
        ;; a Class II medical device.  As such, it may not be changed
        ;; in any way.  Modifications to this software may result in an
        ;; adulterated medical device under 21CFR820, the use of which
        ;; is considered to be a violation of US Federal Statutes.
        ;; +---------------------------------------------------------------------------------------------------+

*)

interface

uses WinTypes, WinProcs, Classes, Graphics, Forms, Controls, Buttons,
  StdCtrls, ExtCtrls, TabNotBk, ComCtrls, dialogs, maggut4;

type
  TfrmCopyAgreement = class(TForm)
    lbalign: TLabel;
    pnlAgree: TPanel;
    btnOKAgree: TBitBtn;
    memAgreement: TMemo;
    lbAgree: TLabel;
    BitBtn1: TBitBtn;
    Panel1: TPanel;
    rbtnChoices: TRadioGroup;
    lbHeader: TLabel;
    pnlesig: TPanel;
    pnlesig2: TPanel;
    btnOK: TBitBtn;
    btnCancel: TBitBtn;
    btnHelp: TBitBtn;
    Button1: TButton;
    procedure rbtnChoicesClick(Sender: TObject);
    procedure btnOKClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnOKAgreeClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    FAlreadyView : boolean;


    procedure getEsigReason(var reason: string);
    { Private declarations }
  public
        {  if result is True, esig and esigreason will be defined.}
    function Execute(var esigreason: string): boolean;
  end;

var
  frmCopyAgreement: TfrmCopyAgreement;

implementation
 uses cMagUtilsDB ;
{$R *.DFM}

function TfrmCopyAgreement.Execute(var esigreason : string): boolean;
begin
result := false;
if not doesformexist('frmCopyAgreement') then
  begin
    application.CreateForm(TfrmCopyAgreement,frmCopyAgreement);
    frmCopyAgreement.rbtnChoices.ItemIndex := -1;
  end ;
with frmcopyAgreement do
  begin
    try
    showmodal;
    if modalresult = mrcancel then exit;
    getEsigReason(esigreason);
    result := true;
    finally
    ;
    end;
  end;

end;

procedure TfrmCopyAgreement.rbtnChoicesClick(Sender: TObject);
begin
btnOK.enabled := (rbtnChoices.ItemIndex <> -1);
end;

procedure TfrmCopyAgreement.btnOKClick(Sender: TObject);
begin
  modalresult := mrok;
end;

procedure TfrmCopyAgreement.getEsigReason(var reason: string);
begin
  case rbtnChoices.itemindex of
    0: reason := 'A';
    1: reason := 'B';
    2: reason := 'C';
    3: reason := 'D';
    4: reason := 'E';
    5: reason := 'R';
  else reason := '?';
  end;
end;

procedure TfrmCopyAgreement.FormShow(Sender: TObject);
begin
if not FAlreadyView then
  begin
  pnlAgree.visible := true;
  pnlAgree.bringtofront;
  FAlreadyView := true;
  exit;
  end;
if rbtnchoices.ItemIndex = -1
  then rbtnchoices.SetFocus
  else btnok.SetFocus;
end;

procedure TfrmCopyAgreement.btnOKAgreeClick(Sender: TObject);
begin
pnlAgree.Visible := false;
end;

procedure TfrmCopyAgreement.Button1Click(Sender: TObject);
begin
pnlAgree.Visible := true;
end;

end.

