unit fmagGetEsigDialog;
   {
   Package: MAG - VistA Imaging
   WARNING: Per VHA Directive 10-93-142 this unit should not be modified.
   Date Created:  12/2004
   Site Name: Silver Spring, OIFO
   Developers: Garrett Kirin
   [==    unit fmagGetEsigDialog;
   Description: frmGetEsigDialog is a Utility form used by
   Print and Copy functions to get the text of the User's Electronic Signature
   The text is then verified (outside of this form).
   ==]
   Note:
   }
(*
        ;; +---------------------------------------------------------------------------------------------------+
        ;; Property of the US Government.
        ;; No permission to copy or redistribute this software is given.
        ;; Use of unreleased versions of this software requires the user
        ;;  to execute a written test agreement with the VistA Imaging
        ;;  Development Office of the Department of Veterans Affairs,
        ;;  telephone (301) 734-0100.
        ;;
        ;; The Food and Drug Administration classifies this software as
        ;; a Class II medical device.  As such, it may not be changed
        ;; in any way.  Modifications to this software may result in an
        ;; adulterated medical device under 21CFR820, the use of which
        ;; is considered to be a violation of US Federal Statutes.
        ;; +---------------------------------------------------------------------------------------------------+

*)

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  TfrmGetEsigDialog = class(TForm)
    edtEsig: TEdit;
    Label1: TLabel;
    okbtn: TBitBtn;
    btnCancel: TBitBtn;
    lbesigdesc: TLabel;
    procedure edtEsigKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    { Private declarations }
  public
    function Execute(var esig : string) : boolean;{ Public declarations }
  end;

var
  frmGetEsigDialog: TfrmGetEsigDialog;

implementation

{$R *.DFM}

procedure TfrmGetEsigDialog.edtEsigKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
if (not okbtn.enabled) and (length(edtesig.text) > 0) then OKbtn.Enabled := true;
end;

function TfrmGetEsigDialog.Execute(var esig: string): boolean;
begin
application.CreateForm(TfrmGetEsigDialog,frmGetEsigDialog);
frmGetEsigDialog.showmodal;
result := (frmGetEsigDialog.modalresult = mrok) ;
if result then esig := frmGetEsigDialog.edtEsig.Text;
frmGetEsigDialog.release;
end;

end.
