unit uMagGearTrans;
(*
        ;; +---------------------------------------------------------------------------------------------------+
        ;; Property of the US Government.
        ;; No permission to copy or redistribute this software is given.
        ;; Use of unreleased versions of this software requires the user
        ;;  to execute a written test agreement with the VistA Imaging
        ;;  Development Office of the Department of Veterans Affairs,
        ;;  telephone (301) 734-0100.
        ;;
        ;; The Food and Drug Administration classifies this software as
        ;; a Class II medical device.  As such, it may not be changed
        ;; in any way.  Modifications to this software may result in an
        ;; adulterated medical device under 21CFR820, the use of which
        ;; is considered to be a violation of US Federal Statutes.
        ;; +---------------------------------------------------------------------------------------------------+

*)

interface

uses
Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
OleCtrls, geardef, geardef7, GEARLib_TLB, StdCtrls, MEDXLib_TLB;

function TransClearImage(gearcontrol: TGear; value: boolean): integer;
function TransVisible(gearcontrol: TGear; value: boolean): integer;
function TransLoadImage(gearcontrol: TGear; NameOfFile: widestring): integer;
function TransImageBitsPerPixel(gearcontrol: TGear): integer;
function TransRedraw(gearcontrol: TGear; value: boolean): integer;
function TransAutoRedraw(gearcontrol: TGear; value: boolean): integer;
function TrZoomLevel(gearcontrol: TGear; value: integer): integer;
function TrGetZoomLevel(gearcontrol: TGear): integer;
function TrPageCount(Gearcontrol: TGear): integer;
function TrSetPage(Gearcontrol: TGear; value: integer): integer;
function TrGetPage(Gearcontrol: TGear): integer;
function TrFitMethod(Gearcontrol: TGear; value: integer): integer;
function TrInvert(Gearcontrol: TGear; value: boolean): integer;
//function TrGetOrientation(gearcontrol: TGear): integer;
function TrSetOrientation(gearcontrol: TGear; value: integer): integer;
function TrRotateany(gearcontrol: TGear; value: integer): integer;
function TrDelimage(gearcontrol: TGear; value: boolean): integer;
function TrAspectRatio(gearcontrol: TGear; value: integer): integer;
function TrDisplayBrightness(gearcontrol: TGear; value: real): integer;
function TrDisplayContrast(gearcontrol: TGear; value: real): integer;
function TrLoadRawFile(gearcontrol: TGear; NameOfFile: string; offset, xdim, ydim, pixel: longint; filldirection: integer; compression: integer): integer;
function TrSelectEvent(gearcontrol: TGear; value: integer): integer;
function TrGUIWindow(gearcontrol: TGear; value: integer): integer;
function TrGetGUIWindow(gearcontrol: TGear): longint;
function TrGuixpos(gearcontrol: TGear; value: integer): integer;
function TrGuiypos(gearcontrol: TGear; value: integer): integer;
function TrGuiwidth(gearcontrol: TGear; value: integer): integer;
function TrGUIheight(gearcontrol: TGear; value: integer): integer;
function TrMagnifyWindow(gearcontrol: TGear; value: integer): integer;
function TrGetMagnifyWindow(gearcontrol: TGear): integer;
function TrSetScrollPos(gearcontrol: TGear; value1, value2, value3: smallint): integer;
function TrGetScrollPos(gearcontrol: TGear; value: integer): integer;
function TrHiGear(gearcontrol: TGear): Integer;
function TrHandPanning(gearcontrol: TGear; value: boolean): integer;
function TrHeight(gearcontrol: TGear; value: integer): integer;
function TrWidth(gearcontrol: TGear; value: integer): integer;
function TrTop(gearcontrol: TGear; value: integer): integer;
function TrLeft(gearcontrol: TGear; value: integer): integer;
function TrResizeWidth(gearcontrol: TGear; value: integer): integer;
function TrResizeHeight(gearcontrol: TGear; value: integer): integer;
function TrResizeImage(gearcontrol: TGear; value: integer): integer;
function TrGetHeight(gearcontrol: TGear): integer;
function TrGetWidth(gearcontrol: TGear): integer;
function TrGetTop(gearcontrol: TGear): integer;
function TrGetLeft(gearcontrol: TGear): integer;
function TrGetImageWidth(gearcontrol: TGear): integer;
function TrGetImageHeight(gearcontrol: TGear): integer;
function TrImageRectLeft(gearcontrol: TGear; value: integer): Integer;
function TrImageRectTop(gearcontrol: TGear; value: integer): Integer;
function TrImageRectRight(gearcontrol: TGear; value: integer): Integer;
function TrImageRectBottom(gearcontrol: TGear; value: integer): Integer;
function TrExtFile(gearcontrol: Tgear; StrValue: string): integer;
function TrExtCode(gearcontrol: Tgear; StrValue: string): integer;
function TrExtPass(gearcontrol: Tgear; StrValue: string): integer;
function TrControlInterface(gearcontrol: TGear): IDispatch;
function TrUpdate(gearcontrol: TGear): integer;
function TrSetPixelPosx(gearcontrol: Tgear; value: integer): integer;
function TrSetPixelPosy(gearcontrol: Tgear; value: integer): integer;
function TrPixelGet(gearcontrol: Tgear; value: boolean): integer;
function TrPixelSet(gearcontrol: Tgear; value: boolean): integer;
function TrIsSigned(gearcontrol: Tgear): boolean;
function TrGetVGreen(gearcontrol: Tgear): integer;
function TrGetVRed(gearcontrol: Tgear): integer;
function TrGetVBlue(gearcontrol: Tgear): integer;  {may not be used}
function TrVGreen(gearcontrol: TGear; value: integer): integer;
function TrVRed(gearcontrol: TGear; value: integer): integer;
function TrVBlue(gearcontrol: TGear; value: integer): integer; {may not be used}
function TrHint(gearcontrol: TGear; strvalue: string): integer;
function TrFlip(gearcontrol: TGear; value: integer): integer;
function TrPrintImage(gearcontrol: Tgear; value: THandle): integer;
function TrPrintSize(Gearcontrol: Tgear; value: integer): integer;
function TrBackcolor(gearcontrol: Tgear; value: integer): integer;
function TrClipBoardCopy(gearcontrol: Tgear; value: boolean): integer;

implementation

//uses
{medtest1;}

function TransClearImage(gearcontrol: TGear; value: boolean): integer;
begin
gearcontrol.clearimage := value;
result := 1;
end;

function TransVisible(gearcontrol: TGear; value: boolean): integer;
  begin
  gearcontrol.visible := value;
  result := 1;
  end;

function TransLoadImage(gearcontrol: TGear; NameOfFile: widestring): integer;
  begin
  gearcontrol.loadimage := NameOfFile;
  end;

function TransImageBitsPerPixel(gearcontrol: TGear): integer;
  begin
  result := gearcontrol.ImageBitsPerPixel;
  end;

function TransRedraw(gearcontrol: TGear; value: boolean): integer;
begin
gearcontrol.Redraw := value;
end;

function TransAutoRedraw(gearcontrol: TGear; value: boolean): integer;
begin
gearcontrol.AutoRedraw := value;
end;

function TrZoomLevel(gearcontrol: TGear; value: integer): integer;
{SEts zoomlevel}
begin
gearcontrol.ZoomLevel := value;
end;

function TrGetZoomLevel(gearcontrol: TGear): integer;
begin
result := gearcontrol.zoomlevel;
end;

function TrPageCount(Gearcontrol: TGear): integer;
begin
result := gearcontrol.pagecount;
end;

function TrSetPage(Gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.Page := value;
end;

function TrGetPage(Gearcontrol: TGear): integer;
begin
result := gearcontrol.Page;
end;

function TrFitMethod(Gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.FitMethod := value;
end;

function TrInvert(Gearcontrol: TGear; value: boolean): integer;
begin
gearcontrol.invert := value;
end;

function TrSetOrientation(gearcontrol: TGear; value: integer): integer;
begin
Gearcontrol.ImageOrientation := value;
end;

function TrRotateany(gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.Rotateany := value;
end;


function TrDelimage(gearcontrol: TGear; value: boolean): integer;
begin
gearcontrol.DelImage := value;
end;


function TrAspectRatio(gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.AspectRatio:=value;
end;

function TrDisplayBrightness(gearcontrol: TGear; value: real): integer;
begin
gearcontrol.displaybrightness := value;
end;

function TrDisplayContrast(gearcontrol: TGear; value: real): integer;
begin
gearcontrol.displaycontrast := value;
end;

function TrLoadRawFile(gearcontrol: TGear; NameOfFile: string; offset, xdim, ydim, pixel: longint; filldirection: integer; compression: integer): integer;
begin
result := gearcontrol.LoadRawFile(NameOfFile, offset, xdim, ydim, pixel, filldirection, compression);
end;

function TrSelectEvent(gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.selectevent := value;
end;

function TrGUIWindow(gearcontrol: TGear; value: integer): integer;
{GUIPAN (Pan)
GUIMAG  (Magnify)
GUIPAL  (Palette)
GUITHM  (Thumbnail)}
begin
gearcontrol.GUIWindow := value;
end;

function TrGetGUIWindow(gearcontrol: TGear): longint;
var
x: integer;
begin
x := gearcontrol.GUIWindow;  // stackoverflow stops code here
result := x;
//showmessage('x=' + inttostr(x));
end;

function TrGuixpos(gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.Guixpos := value;
end;

function TrGuiypos(gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.Guiypos := value;
end;

function TrGuiwidth(gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.Guiwidth := value;
end;

function TrGUIheight(gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.GuiHeight := value;
end;

function TrMagnifyWindow(gearcontrol: TGear; value: integer): integer;
begin
//Settings:	0 - Turn off Magnify Window 1 - Pop-up 2 - Floating Window
gearcontrol.MagnifyWindow := value;
end;

function TrGetMagnifyWindow(gearcontrol: TGear): integer;
begin
result := gearcontrol.magnifywindow;
{0 = turned off
1= pop up
2 = floating}
{TrGetMagnifyWindow(gearcontrol); }
end;

function TrSetScrollPos(gearcontrol: TGear; value1, value2, value3: smallint): integer;
(*
value1 = SB_HORZ (0) or SB_VERT (1)
value2 = SB_THUMBPOSITION= 4
value3 = provides information about the value for changing the scrollbar
*)
begin
gearcontrol.setscrollpos(value1, value2, value3);
end;

function TrGetScrollPos(gearcontrol: TGear; value: integer): integer;
begin
value := gearcontrol.getscrollpos(value);
end;

function TrHiGear(gearcontrol: TGear): Integer;
begin
result := gearcontrol.higear;
end;

function TrHandPanning(gearcontrol: TGear; value: boolean): integer;
begin
gearcontrol.handpanning := value;
end;

function TrHeight(gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.Height := value;
end;

function TrWidth(gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.Width := value;
end;

function TrTop(gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.Top := value;
end;

function TrLeft(gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.Left := value;
end;

function TrResizeWidth(gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.ResizeWidth := value;
end;

function TrResizeHeight(gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.ResizeHeight := value;
end;

function TrResizeImage(gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.ResizeImage := value;
end;


function TrGetHeight(gearcontrol: TGear): integer;
begin
result := gearcontrol.Height;
end;

function TrGetWidth(gearcontrol: TGear): integer;
begin
result := gearcontrol.Width;
end;

function TrGetTop(gearcontrol: TGear): integer;
begin
result := gearcontrol.Top;
end;

function TrGetLeft(gearcontrol: TGear): integer;
begin
result := gearcontrol.Left
end;

function TrGetImageWidth(gearcontrol: TGear): integer;
begin
result := gearcontrol.ImageWidth;
end;

function TrGetImageHeight(gearcontrol: TGear): integer;
begin
result := gearcontrol.ImageHeight;
end;

function TrImageRectLeft(gearcontrol: TGear; value: integer): Integer;
begin
gearcontrol.ImageRectLeft := value;
end;

function TrImageRectTop(gearcontrol: TGear; value: integer): Integer;
begin
gearcontrol.ImageRectTop := value;
end;

function TrImageRectRight(gearcontrol: TGear; value: integer): Integer;
begin
gearcontrol.ImageRectRight := value;
end;

function TrImageRectBottom(gearcontrol: TGear; value: integer): Integer;
begin
gearcontrol.ImageRectBottom := value;
end;

function TrExtFile(gearcontrol: Tgear; StrValue: string): integer;
begin
gearcontrol.extfile := strvalue;
end;

function TrExtCode(gearcontrol: Tgear; StrValue: string): integer;
begin
gearcontrol.extcode := strvalue;
end;

function TrExtPass(gearcontrol: Tgear; StrValue: string): integer;
begin
gearcontrol.extpass := strvalue;
end;

function TrControlInterface(gearcontrol: TGear): IDispatch;
begin
gearcontrol.controlinterface;
end;

function TrUpdate(gearcontrol: TGear): integer;
begin
gearcontrol.update;
end;

function TrSetPixelPosx(gearcontrol: Tgear; value: integer): integer;
begin
gearcontrol.PixelPosx := value;
end;

function TrSetPixelPosy(gearcontrol: Tgear; value: integer): integer;
begin
gearcontrol.PixelPosy := value;
end;

function TrPixelGet(gearcontrol: Tgear; value: boolean): integer;
begin
gearcontrol.PixelGet := value;
end;

function TrPixelSet(gearcontrol: Tgear; value: boolean): integer;
begin
gearcontrol.PixelSet := value;
end;

function TrIsSigned(gearcontrol: Tgear): boolean;
begin
result := gearcontrol.IsSigned;
end;

function TrGetVGreen(gearcontrol: Tgear): integer;
begin
result := gearcontrol.VGreen;
end;

function TrGetVRed(gearcontrol: Tgear): integer;
begin
result := gearcontrol.VRed;
end;

function TrGetVBlue(gearcontrol: Tgear): integer;  {may not be used}
begin
result := gearcontrol.VBlue;
end;

function TrVGreen(gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.VGreen := value;
end;

function TrVRed(gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.VRed := value;
end;

function TrVBlue(gearcontrol: TGear; value: integer): integer; {may not be used}
begin
gearcontrol.VBlue := value;
end;

function TrHint(gearcontrol: TGear; strvalue: string): integer;
begin
gearcontrol.Hint := strvalue;
end;

function TrFlip(gearcontrol: TGear; value: integer): integer;
begin
gearcontrol.Flip := value;
end;

function TrPrintImage(gearcontrol: Tgear; Value: THandle): integer;
begin
gearcontrol.PrintImage := value;
end;

function TrPrintSize(Gearcontrol: Tgear; value: integer): integer;
begin
gearcontrol.PrintSize := value;
end;

function TrBackcolor(gearcontrol: Tgear; value: integer): integer;
begin
gearcontrol.Backcolor := value;
end;

function TrClipBoardCopy(gearcontrol: Tgear; value: boolean): integer;
begin
gearcontrol.clipboardcopy := value;
end;

end.
